Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:37 2012
FILE NAME: arakawa_schubert_L1982.f90
PROGRAM NAME: arakawa_schubert_l1982
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   178  vec  (   1): Vectorized loop.
   190  vec  (   1): Vectorized loop.
   190  vec  (   1): Vectorized loop.
   192  opt  (1592): Outer loop unrolled inside inner loop.
   202  vec  (   3): Unvectorized loop.
   202  vec  (  13): Overhead of loop division is too large.
   203  opt  (1592): Outer loop unrolled inside inner loop.
   203  vec  (   4): Vectorized array expression.
   203  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:37 2012
FILE NAME: arakawa_schubert_L1982.f90
PROGRAM NAME: arakawa_schubert_l1982
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Arakawa-Schubert scheme by Lord et al. (1982)
     2  !
     3  != Arakawa-Schubert scheme by Lord et al. (1982)
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: arakawa_schubert_L1982.f90,v 1.1 2011-07-14 06:17:16 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module arakawa_schubert_L1982
    13    !
    14    != Arakawa-Schubert scheme by Lord et al. (1982)
    15    !
    16    != Arakawa-Schubert scheme by Lord et al. (1982)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! Lord et al. (1982) ˤ Arakawa-Schubert scheme μ.
    21    !
    22    ! Implementation of Arakawa-Schubert scheme by Lord et al. (1982).
    23    !
    24    !
    25    !== References
    26    !
    27    !  Lord, S. J., W. C. Chao, and A. Arakawa,
    28    !    Interaction of a cumulus cloud ensemble with the large-scale environment.
    29    !    Part IV: The discrete model,
    30    !    J. Atmos. Sci., 39, 104-113, 1982.
    31    !
    32    !== Procedures List
    33    !
    34    ! ArakawaSchubertL1982CalcCWFCrtl ::
    35    ! ------------------------------- :: ------------
    36    ! ArakawaSchubertL1982CalcCWFCrtl :: Set critical value of cloud work function
    37    !                                    presented by Lord et al. (1982)
    38    !
    39    !== NAMELIST
    40    !
    41    ! NAMELIST#moist_conv_adjust_nml
    42    !
    43  
    44    ! ⥸塼 ; USE statements
    45    !
    46  
    47    ! ʻ
    48    ! Grid points settings
    49    !
    50    use gridset, only: imax, & ! ٳʻ.
    51                               ! Number of grid points in longitude
    52      &                jmax, & ! ٳʻ.
    53                               ! Number of grid points in latitude
    54      &                kmax    ! ľؿ.
    55                               ! Number of vertical level
    56  
    57    ! ̷ѥ᥿
    58    ! Kind type parameter
    59    !
    60    use dc_types, only: DP, &      ! ټ¿. Double precision.
    61      &                 STRING     ! ʸ.       Strings.
    62  
    63  
    64    ! å
    65    ! Message output
    66    !
    67    use dc_message, only: MessageNotify
    68  
    69    ! ʸ ; Declaration statements
    70    !
    71    implicit none
    72    private
    73  
    74  
    75    ! ³
    76    ! Public procedure
    77    !
    78    public :: ArakawaSchubertL1982CalcCWFCrtl
    79    public :: ArakawaSchubertL1982Init
    80  
    81    ! ѿ
    82    ! Public variables
    83    !
    84  
    85    ! ѿ
    86    ! Private variables
    87    !
    88    logical, save :: arakawa_schubert_L1982_inited = .false.
    89                                ! ե饰.
    90                                ! Initialization flag
    91  
    92    ! Values in Table 1 in Lord et al. (1982)
    93    !
    94    integer , parameter :: nTbl1 = 15
    95    real(DP), save      :: a_Tbl1Press( nTbl1 )  ! Pressure (Pa)
    96    real(DP), save      :: a_Tbl1CWF  ( nTbl1 )  ! Cloud work function (J kg-1 Pa-1)
    97  
    98    data a_Tbl1Press &
    99      & / 150.0d2  , 200.0d2  , 250.0d2  , 300.0d2  , 350.0d2  , 400.0d2  , 450.0d2  , &
   100      &   500.0d2  , 550.0d2  , 600.0d2  , 650.0d2  , 700.0d2  , 750.0d2  , 800.0d2  , &
   101      &   850.0d2   /
   102  
   103    data a_Tbl1CWF   &
   104      & / 1.6851d-2, 1.1686d-2, 0.7663d-2, 0.5255d-2, 0.4100d-2, 0.3677d-2, 0.3151d-2, &
   105      &   0.2216d-2, 0.1521d-2, 0.1082d-2, 0.0750d-2, 0.0664d-2, 0.0553d-2, 0.0445d-2, &
   106      &   0.0633d-2 /
   107  
   108  
   109    character(*), parameter:: module_name = 'arakawa_schubert_L1982'
   110                                ! ⥸塼̾.
   111                                ! Module name
   112    character(*), parameter:: version = &
   113      & '$Name: dcpam5-20120921 $' // &
   114      & '$Id: arakawa_schubert_L1982.f90,v 1.1 2011-07-14 06:17:16 yot Exp $'
   115                                ! ⥸塼ΥС
   116                                ! Module version
   117  
   118  contains
   119  
   120    subroutine ArakawaSchubertL1982CalcCWFCrtl( &
   121      & xy_PressCldBase, xyz_PressCldTop,  &  ! (in)
   122      & xyz_CWFCrtl                        &  ! (out)
   123      & )
   124      !
   125      !
   126      !
   127      ! Calculate critical cloud work function by using interpolation of Table 1
   128      ! by Lord et al. (1982)
   129      !
   130  
   131      ! ⥸塼 ; USE statements
   132      !
   133  
   134  
   135  
   136      ! ʸ ; Declaration statements
   137      !
   138      implicit none
   139  
   140      real(DP), intent(in ) :: xy_PressCldBase (0:imax-1, 1:jmax)
   141                                ! pressure at cloud base
   142      real(DP), intent(in ) :: xyz_PressCldTop (0:imax-1, 1:jmax, 1:kmax)
   143                                ! pressure at cloud top
   144      real(DP), intent(out) :: xyz_CWFCrtl     (0:imax-1, 1:jmax, 1:kmax)
   145                                ! critical cloud work function
   146  
   147      ! ѿ
   148      ! Work variables
   149      !
   150      integer  :: xyz_Index     (0:imax-1, 1:jmax, 1:kmax)
   151      real(DP) :: xyz_CWFIntpled(0:imax-1, 1:jmax, 1:kmax)
   152  
   153      integer :: i               ! ˲ DO 롼Ѻѿ
   154                                 ! Work variables for DO loop in longitude
   155      integer :: j               ! ˲ DO 롼Ѻѿ
   156                                 ! Work variables for DO loop in latitude
   157      integer :: k               ! ľ˲ DO 롼Ѻѿ
   158                                 ! Work variables for DO loop in vertical direction
   159      integer :: l
   160  
   161  
   162      ! ¹ʸ ; Executable statement
   163      !
   164  
   165      ! ǧ
   166      ! Initialization check
   167      !
   168      if ( .not. arakawa_schubert_L1982_inited ) then
   169        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   170      end if
   171  
   172  
   173      do k = 1, kmax
   174        do j = 1, jmax
   175          do i = 0, imax-1
   176  
   177            xyz_Index(i,j,k) = 1
   178            loop_search : do l = 2, nTbl1-1
   179              if ( a_Tbl1Press(l) < xyz_PressCldTop(i,j,k) ) then
   180                xyz_Index(i,j,k) = l
   181              end if
   182            end do loop_search
     .        xyz_index1 = xyz_index(i,j,k)                                     
     .  !CDIR NODEP                                                             
     .        do l = 1, 13                                                      
     .           if (a_tbl1press(1+l) .lt. xyz_presscldtop(i,j,k)) then         
     .              xyz_index1 = 1 + l                                          
     .           endif                                                          
     .        end do                                                            
     .        xyz_index(i,j,k) = xyz_index1                                     
   183  
   184          end do
   185        end do
   186      end do
   187  
   188      do k = 1, kmax
   189        do j = 1, jmax
   190          do i = 0, imax-1
   191  
   192            xyz_CWFIntpled(i,j,k) =                                                   &
   193              &   ( a_Tbl1CWF  (xyz_Index(i,j,k)+1) - a_Tbl1CWF  (xyz_Index(i,j,k)) ) &
   194              & / ( a_Tbl1Press(xyz_Index(i,j,k)+1) - a_Tbl1Press(xyz_Index(i,j,k)) ) &
   195              & * ( xyz_PressCldTop(i,j,k)          - a_Tbl1Press(xyz_Index(i,j,k)) ) &
   196              & + a_Tbl1CWF(xyz_Index(i,j,k))
   197  
   198          end do
   199        end do
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .           do j = 1, J3                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xyz_cwfintpled(i-1,j,k) = (a_tbl1cwf(xyz_index(i-1,j,k)+1
     .       1            )-(a_tbl1cwf(xyz_index(i-1,j,k))))/(a_tbl1press(      
     .       2            xyz_index(i-1,j,k)+1)-(a_tbl1press(xyz_index(i-1,j,k))
     .       3            ))*(xyz_presscldtop(i-1,j,k)-(a_tbl1press(xyz_index(i-
     .       4            1,j,k)))) + (a_tbl1cwf(xyz_index(i-1,j,k)))           
     .              end do                                                      
     .           end do                                                         
     .           do j = J3 + 1, jmax, 4                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xyz_cwfintpled(i-1,j,k) = (a_tbl1cwf(xyz_index(i-1,j,k)+1
     .       1            )-(a_tbl1cwf(xyz_index(i-1,j,k))))/(a_tbl1press(      
     .       2            xyz_index(i-1,j,k)+1)-(a_tbl1press(xyz_index(i-1,j,k))
     .       3            ))*(xyz_presscldtop(i-1,j,k)-(a_tbl1press(xyz_index(i-
     .       4            1,j,k)))) + (a_tbl1cwf(xyz_index(i-1,j,k)))           
     .                 xyz_cwfintpled(i-1,j+1,k) = (a_tbl1cwf(xyz_index(i-1,j+1,
     .       1            k)+1)-(a_tbl1cwf(xyz_index(i-1,j+1,k))))/(a_tbl1press(
     .       2            xyz_index(i-1,j+1,k)+1)-(a_tbl1press(xyz_index(i-1,j+1
     .       3            ,k))))*(xyz_presscldtop(i-1,j+1,k)-(a_tbl1press(      
     .       4            xyz_index(i-1,j+1,k)))) + (a_tbl1cwf(xyz_index(i-1,j+1
     .       5            ,k)))                                                 
     .                 xyz_cwfintpled(i-1,j+2,k) = (a_tbl1cwf(xyz_index(i-1,j+2,
     .       1            k)+1)-(a_tbl1cwf(xyz_index(i-1,j+2,k))))/(a_tbl1press(
     .       2            xyz_index(i-1,j+2,k)+1)-(a_tbl1press(xyz_index(i-1,j+2
     .       3            ,k))))*(xyz_presscldtop(i-1,j+2,k)-(a_tbl1press(      
     .       4            xyz_index(i-1,j+2,k)))) + (a_tbl1cwf(xyz_index(i-1,j+2
     .       5            ,k)))                                                 
     .                 xyz_cwfintpled(i-1,j+3,k) = (a_tbl1cwf(xyz_index(i-1,j+3,
     .       1            k)+1)-(a_tbl1cwf(xyz_index(i-1,j+3,k))))/(a_tbl1press(
     .       2            xyz_index(i-1,j+3,k)+1)-(a_tbl1press(xyz_index(i-1,j+3
     .       3            ,k))))*(xyz_presscldtop(i-1,j+3,k)-(a_tbl1press(      
     .       4            xyz_index(i-1,j+3,k)))) + (a_tbl1cwf(xyz_index(i-1,j+3
     .       5            ,k)))                                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   200      end do
   201  
   202      do k = 1, kmax
   203        xyz_CWFCrtl(:,:,k) = &
     .        if (xyz_cwfintpled.DSC.U2 .gt. 0) then                            
     .           J4 = and(xyz_cwfintpled.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t225 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t227 = 1, xyz_cwfintpled.DSC.U1 + 1                      
     .                 xyz_cwfcrtl(t227-1,t225,k) = xyz_cwfintpled(t227-1,t225,k
     .       1            )*(xy_presscldbase(t227-1,t225)-xyz_presscldtop(t227-1
     .       2            ,t225,k))                                             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t225 = J4 + 1, xyz_cwfintpled.DSC.U2, 4                     
     .  !CDIR       NODEP                                                       
     .              do t227 = 1, xyz_cwfintpled.DSC.U1 + 1                      
     .                 xyz_cwfcrtl(t227-1,t225,k) = xyz_cwfintpled(t227-1,t225,k
     .       1            )*(xy_presscldbase(t227-1,t225)-xyz_presscldtop(t227-1
     .       2            ,t225,k))                                             
     .                 xyz_cwfcrtl(t227-1,t225+1,k) = xyz_cwfintpled(t227-1,t225
     .       1            +1,k)*(xy_presscldbase(t227-1,t225+1)-xyz_presscldtop(
     .       2            t227-1,t225+1,k))                                     
     .                 xyz_cwfcrtl(t227-1,t225+2,k) = xyz_cwfintpled(t227-1,t225
     .       1            +2,k)*(xy_presscldbase(t227-1,t225+2)-xyz_presscldtop(
     .       2            t227-1,t225+2,k))                                     
     .                 xyz_cwfcrtl(t227-1,t225+3,k) = xyz_cwfintpled(t227-1,t225
     .       1            +3,k)*(xy_presscldbase(t227-1,t225+3)-xyz_presscldtop(
     .       2            t227-1,t225+3,k))                                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   204          & xyz_CWFIntpled(:,:,k) * ( xy_PressCldBase - xyz_PressCldTop(:,:,k) )
   205      end do
   206  
   207  
   208    end subroutine ArakawaSchubertL1982CalcCWFCrtl
   209  
   210    !-------------------------------------------------------------------
   211  
   212    subroutine ArakawaSchubertL1982Init
   213      !
   214      ! arakawa_schubert_L1982 ⥸塼νԤޤ.
   215      ! NAMELIST#arakawa_schubert_L1982_nml ɤ߹ߤϤμ³ǹԤޤ.
   216      !
   217      ! "arakawa_schubert_L1982" module is initialized.
   218      ! "NAMELIST#arakawa_schubert_L1982_nml" is loaded in this procedure.
   219      !
   220  
   221      ! ⥸塼 ; USE statements
   222      !
   223  
   224      ! NAMELIST եϤ˴ؤ桼ƥƥ
   225      ! Utilities for NAMELIST file input
   226      !
   227      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   228  
   229      ! ե
   230      ! File I/O support
   231      !
   232      use dc_iounit, only: FileOpen
   233  
   234  
   235      ! ʸ ; Declaration statements
   236      !
   237      implicit none
   238  
   239  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   240  !!$                              ! Unit number for NAMELIST file open
   241  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   242  !!$                              ! IOSTAT of NAMELIST read
   243  
   244      ! NAMELIST ѿ
   245      ! NAMELIST group name
   246      !
   247  !!$    namelist /arakawa_schubert_L1982_nml/ &
   248  !!$      &
   249  
   250            ! ǥեͤˤĤƤϽ³ "arakawa_schubert_L1982#CumAdjInit"
   251            ! Υɤ򻲾ȤΤ.
   252            !
   253            ! Refer to source codes in the initialization procedure
   254            ! "arakawa_schubert_L1982#ArakawaSchubertL1982Init" for the default values.
   255            !
   256  
   257      ! ¹ʸ ; Executable statement
   258      !
   259  
   260      if ( arakawa_schubert_L1982_inited ) return
   261  
   262      ! ǥեͤ
   263      ! Default values settings
   264      !
   265  
   266      ! NAMELIST ɤ߹
   267      ! NAMELIST is input
   268      !
   269  !!$    if ( trim(namelist_filename) /= '' ) then
   270  !!$      call FileOpen( unit_nml, &          ! (out)
   271  !!$        & namelist_filename, mode = 'r' ) ! (in)
   272  !!$
   273  !!$      rewind( unit_nml )
   274  !!$      read( unit_nml,                  &  ! (in)
   275  !!$        & nml = moist_conv_adjust_nml, &  ! (out)
   276  !!$        & iostat = iostat_nml )           ! (out)
   277  !!$      close( unit_nml )
   278  !!$
   279  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   280  !!$    end if
   281  
   282  
   283  
   284      !  ; Print
   285      !
   286      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   287      call MessageNotify( 'M', module_name, '' )
   288      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   289  
   290      arakawa_schubert_L1982_inited = .true.
   291  
   292    end subroutine ArakawaSchubertL1982Init
   293  
   294    !-------------------------------------------------------------------
   295  
   296  end module arakawa_schubert_L1982
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:37 2012
FILE NAME: arakawa_schubert_L1982.f90
PROGRAM NAME: arakawa_schubert_l1982
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Arakawa-Schubert scheme by Lord et al. (1982)
     2:            !
     3:            != Arakawa-Schubert scheme by Lord et al. (1982)
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: arakawa_schubert_L1982.f90,v 1.1 2011-07-14 06:17:16 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module arakawa_schubert_L1982
    13:              !
    14:              != Arakawa-Schubert scheme by Lord et al. (1982)
    15:              !
    16:              != Arakawa-Schubert scheme by Lord et al. (1982)
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! Lord et al. (1982) ˤ Arakawa-Schubert scheme μ.
    21:              !
    22:              ! Implementation of Arakawa-Schubert scheme by Lord et al. (1982).
    23:              !
    24:              !
    25:              !== References
    26:              !
    27:              !  Lord, S. J., W. C. Chao, and A. Arakawa,
    28:              !    Interaction of a cumulus cloud ensemble with the large-scale environment.
    29:              !    Part IV: The discrete model, 
    30:              !    J. Atmos. Sci., 39, 104-113, 1982.
    31:              !
    32:              !== Procedures List
    33:              !
    34:              ! ArakawaSchubertL1982CalcCWFCrtl :: 
    35:              ! ------------------------------- :: ------------
    36:              ! ArakawaSchubertL1982CalcCWFCrtl :: Set critical value of cloud work function 
    37:              !                                    presented by Lord et al. (1982)
    38:              !
    39:              !== NAMELIST
    40:              !
    41:              ! NAMELIST#moist_conv_adjust_nml
    42:              !
    43:            
    44:              ! ⥸塼 ; USE statements
    45:              !
    46:            
    47:              ! ʻ
    48:              ! Grid points settings
    49:              !
    50:              use gridset, only: imax, & ! ٳʻ. 
    51:                                         ! Number of grid points in longitude
    52:                &                jmax, & ! ٳʻ. 
    53:                                         ! Number of grid points in latitude
    54:                &                kmax    ! ľؿ. 
    55:                                         ! Number of vertical level
    56:            
    57:              ! ̷ѥ᥿
    58:              ! Kind type parameter
    59:              !
    60:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    61:                &                 STRING     ! ʸ.       Strings. 
    62:            
    63:            
    64:              ! å
    65:              ! Message output
    66:              !
    67:              use dc_message, only: MessageNotify
    68:            
    69:              ! ʸ ; Declaration statements
    70:              !
    71:              implicit none
    72:              private
    73:            
    74:            
    75:              ! ³
    76:              ! Public procedure
    77:              !
    78:              public :: ArakawaSchubertL1982CalcCWFCrtl
    79:              public :: ArakawaSchubertL1982Init
    80:            
    81:              ! ѿ
    82:              ! Public variables
    83:              !
    84:            
    85:              ! ѿ
    86:              ! Private variables
    87:              !
    88:              logical, save :: arakawa_schubert_L1982_inited = .false.
    89:                                          ! ե饰. 
    90:                                          ! Initialization flag
    91:            
    92:              ! Values in Table 1 in Lord et al. (1982)
    93:              !
    94:              integer , parameter :: nTbl1 = 15
    95:              real(DP), save      :: a_Tbl1Press( nTbl1 )  ! Pressure (Pa)
    96:              real(DP), save      :: a_Tbl1CWF  ( nTbl1 )  ! Cloud work function (J kg-1 Pa-1)
    97:            
    98:              data a_Tbl1Press &
    99:                & / 150.0d2  , 200.0d2  , 250.0d2  , 300.0d2  , 350.0d2  , 400.0d2  , 450.0d2  , &
   100:                &   500.0d2  , 550.0d2  , 600.0d2  , 650.0d2  , 700.0d2  , 750.0d2  , 800.0d2  , &
   101:                &   850.0d2   /
   102:            
   103:              data a_Tbl1CWF   &
   104:                & / 1.6851d-2, 1.1686d-2, 0.7663d-2, 0.5255d-2, 0.4100d-2, 0.3677d-2, 0.3151d-2, &
   105:                &   0.2216d-2, 0.1521d-2, 0.1082d-2, 0.0750d-2, 0.0664d-2, 0.0553d-2, 0.0445d-2, &
   106:                &   0.0633d-2 /
   107:            
   108:            
   109:              character(*), parameter:: module_name = 'arakawa_schubert_L1982'
   110:                                          ! ⥸塼̾. 
   111:                                          ! Module name
   112:              character(*), parameter:: version = &
   113:                & '$Name: dcpam5-20120921 $' // &
   114:                & '$Id: arakawa_schubert_L1982.f90,v 1.1 2011-07-14 06:17:16 yot Exp $'
   115:                                          ! ⥸塼ΥС
   116:                                          ! Module version
   117:            
   118:            contains
   119:            
   120:              subroutine ArakawaSchubertL1982CalcCWFCrtl( &
   121:                & xy_PressCldBase, xyz_PressCldTop,  &  ! (in)
   122:                & xyz_CWFCrtl                        &  ! (out)
   123:                & )
   124:                !
   125:                ! 
   126:                !
   127:                ! Calculate critical cloud work function by using interpolation of Table 1 
   128:                ! by Lord et al. (1982)
   129:                !
   130:            
   131:                ! ⥸塼 ; USE statements
   132:                !
   133:            
   134:            
   135:            
   136:                ! ʸ ; Declaration statements
   137:                !
   138:                implicit none
   139:            
   140:                real(DP), intent(in ) :: xy_PressCldBase (0:imax-1, 1:jmax)
   141:                                          ! pressure at cloud base
   142:                real(DP), intent(in ) :: xyz_PressCldTop (0:imax-1, 1:jmax, 1:kmax)
   143:                                          ! pressure at cloud top
   144:                real(DP), intent(out) :: xyz_CWFCrtl     (0:imax-1, 1:jmax, 1:kmax)
   145:                                          ! critical cloud work function
   146:            
   147:                ! ѿ
   148:                ! Work variables
   149:                !
   150:                integer  :: xyz_Index     (0:imax-1, 1:jmax, 1:kmax)
   151:                real(DP) :: xyz_CWFIntpled(0:imax-1, 1:jmax, 1:kmax)
   152:            
   153:                integer :: i               ! ˲ DO 롼Ѻѿ
   154:                                           ! Work variables for DO loop in longitude
   155:                integer :: j               ! ˲ DO 롼Ѻѿ
   156:                                           ! Work variables for DO loop in latitude
   157:                integer :: k               ! ľ˲ DO 롼Ѻѿ
   158:                                           ! Work variables for DO loop in vertical direction
   159:                integer :: l
   160:            
   161:            
   162:                ! ¹ʸ ; Executable statement
   163:                !
   164:            
   165:                ! ǧ
   166:                ! Initialization check
   167:                !
   168:                if ( .not. arakawa_schubert_L1982_inited ) then
   169:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   170:                end if
   171:            
   172:            
   173: +------>       do k = 1, kmax
   174: |+----->         do j = 1, jmax
   175: ||+---->           do i = 0, imax-1
   176: |||        
   177: |||                  xyz_Index(i,j,k) = 1
   178: |||V--->             loop_search : do l = 2, nTbl1-1
   179: ||||                   if ( a_Tbl1Press(l) < xyz_PressCldTop(i,j,k) ) then
   180: ||||                     xyz_Index(i,j,k) = l
   181: ||||                   end if
   182: |||V---              end do loop_search
   183: |||        
   184: ||+----            end do
   185: |+-----          end do
   186: +------        end do
   187:            
   188: +------>       do k = 1, kmax
   189: |+----->         do j = 1, jmax
   190: ||V---->           do i = 0, imax-1
   191: |||        
   192: |||                  xyz_CWFIntpled(i,j,k) =                                                   &
   193: |||                    &   ( a_Tbl1CWF  (xyz_Index(i,j,k)+1) - a_Tbl1CWF  (xyz_Index(i,j,k)) ) &
   194: |||                    & / ( a_Tbl1Press(xyz_Index(i,j,k)+1) - a_Tbl1Press(xyz_Index(i,j,k)) ) &
   195: |||                    & * ( xyz_PressCldTop(i,j,k)          - a_Tbl1Press(xyz_Index(i,j,k)) ) &
   196: |||                    & + a_Tbl1CWF(xyz_Index(i,j,k))
   197: |||        
   198: ||V----            end do
   199: |+-----          end do
   200: +------        end do
   201:            
   202: +------>       do k = 1, kmax
   203: |+V====          xyz_CWFCrtl(:,:,k) = &
   204: |                  & xyz_CWFIntpled(:,:,k) * ( xy_PressCldBase - xyz_PressCldTop(:,:,k) )
   205: +------        end do
   206:            
   207:            
   208:              end subroutine ArakawaSchubertL1982CalcCWFCrtl
   209:            
   210:              !-------------------------------------------------------------------
   211:            
   212:              subroutine ArakawaSchubertL1982Init
   213:                !
   214:                ! arakawa_schubert_L1982 ⥸塼νԤޤ. 
   215:                ! NAMELIST#arakawa_schubert_L1982_nml ɤ߹ߤϤμ³ǹԤޤ. 
   216:                !
   217:                ! "arakawa_schubert_L1982" module is initialized. 
   218:                ! "NAMELIST#arakawa_schubert_L1982_nml" is loaded in this procedure. 
   219:                !
   220:            
   221:                ! ⥸塼 ; USE statements
   222:                !
   223:            
   224:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   225:                ! Utilities for NAMELIST file input
   226:                !
   227:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   228:            
   229:                ! ե
   230:                ! File I/O support
   231:                !
   232:                use dc_iounit, only: FileOpen
   233:            
   234:            
   235:                ! ʸ ; Declaration statements
   236:                !
   237:                implicit none
   238:            
   239:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   240:            !!$                              ! Unit number for NAMELIST file open
   241:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   242:            !!$                              ! IOSTAT of NAMELIST read
   243:            
   244:                ! NAMELIST ѿ
   245:                ! NAMELIST group name
   246:                !
   247:            !!$    namelist /arakawa_schubert_L1982_nml/ &
   248:            !!$      & 
   249:            
   250:                      ! ǥեͤˤĤƤϽ³ "arakawa_schubert_L1982#CumAdjInit" 
   251:                      ! Υɤ򻲾ȤΤ. 
   252:                      !
   253:                      ! Refer to source codes in the initialization procedure
   254:                      ! "arakawa_schubert_L1982#ArakawaSchubertL1982Init" for the default values. 
   255:                      !
   256:            
   257:                ! ¹ʸ ; Executable statement
   258:                !
   259:            
   260:                if ( arakawa_schubert_L1982_inited ) return
   261:            
   262:                ! ǥեͤ
   263:                ! Default values settings
   264:                !
   265:            
   266:                ! NAMELIST ɤ߹
   267:                ! NAMELIST is input
   268:                !
   269:            !!$    if ( trim(namelist_filename) /= '' ) then
   270:            !!$      call FileOpen( unit_nml, &          ! (out)
   271:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   272:            !!$
   273:            !!$      rewind( unit_nml )
   274:            !!$      read( unit_nml,                  &  ! (in)
   275:            !!$        & nml = moist_conv_adjust_nml, &  ! (out)
   276:            !!$        & iostat = iostat_nml )           ! (out)
   277:            !!$      close( unit_nml )
   278:            !!$
   279:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   280:            !!$    end if
   281:            
   282:            
   283:            
   284:                !  ; Print
   285:                !
   286:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   287:                call MessageNotify( 'M', module_name, '' )
   288:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   289:            
   290:                arakawa_schubert_L1982_inited = .true.
   291:            
   292:              end subroutine ArakawaSchubertL1982Init
   293:            
   294:              !-------------------------------------------------------------------
   295:            
   296:            end module arakawa_schubert_L1982
