Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:14 2012
FILE NAME: dry_conv_adjust.f90
PROGRAM NAME: dry_conv_adjust
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   243  opt  (1592): Outer loop unrolled inside inner loop.
   243  vec  (   4): Vectorized array expression.
   243  vec  (   4): Vectorized array expression.
   248  vec  (   3): Unvectorized loop.
   248  vec  (  13): Overhead of loop division is too large.
   249  opt  (1592): Outer loop unrolled inside inner loop.
   249  vec  (   4): Vectorized array expression.
   249  vec  (   4): Vectorized array expression.
   256  opt  (1592): Outer loop unrolled inside inner loop.
   256  vec  (   4): Vectorized array expression.
   256  vec  (   4): Vectorized array expression.
   258  vec  (   3): Unvectorized loop.
   258  vec  (  13): Overhead of loop division is too large.
   259  opt  (1592): Outer loop unrolled inside inner loop.
   259  vec  (   4): Vectorized array expression.
   259  vec  (   4): Vectorized array expression.
   266  opt  (1592): Outer loop unrolled inside inner loop.
   266  vec  (   4): Vectorized array expression.
   266  vec  (   4): Vectorized array expression.
   272  opt  (1592): Outer loop unrolled inside inner loop.
   272  vec  (   4): Vectorized array expression.
   272  vec  (   4): Vectorized array expression.
   278  opt  (1592): Outer loop unrolled inside inner loop.
   278  vec  (   4): Vectorized array expression.
   278  vec  (   4): Vectorized array expression.
   282  vec  (   1): Vectorized loop.
   360  opt  (1059): Unable to determine last value of scalar temporary.
   371  vec  (   3): Unvectorized loop.
   371  vec  (  13): Overhead of loop division is too large.
   373  opt  (1019): Feedback of scalar value from one loop pass to another.
   373  opt  (1019): Feedback of scalar value from one loop pass to another.
   373  vec  (  21): Unvectorizable dependency.
   384  opt  (1592): Outer loop unrolled inside inner loop.
   384  vec  (   4): Vectorized array expression.
   384  vec  (   4): Vectorized array expression.
   398  warn (  82): Name "tempupplevbefadj" is not used.
   398  warn (  82): Name "templowlevbefadj" is not used.
   479  vec  (   4): Vectorized array expression.
   519  vec  (   4): Vectorized array expression.
   519  vec  (  24): Iteration count is assumed. Iteration count=256
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:14 2012
FILE NAME: dry_conv_adjust.f90
PROGRAM NAME: dry_conv_adjust
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ήĴ
     2  !
     3  != Dry convective adjustment
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6  ! Version::   $Id: dry_conv_adjust.f90,v 1.6 2012-09-08 15:18:50 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module dry_conv_adjust
    13    !
    14    != ήĴ᥹
    15    !
    16    != Dry convective adjustment
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !== Procedures List
    21    !
    22    ! DryConvAdjust :: ήĴ
    23    ! ------------  :: ------------
    24    ! DryConvAdjust :: Dry convective adjustment
    25    !
    26    !== NAMELIST
    27    !
    28    ! NAMELIST#dry_conv_adjust_nml
    29    !
    30  
    31    ! ⥸塼 ; USE statements
    32    !
    33  
    34    ! ʻ
    35    ! Grid points settings
    36    !
    37    use gridset, only: imax, & ! ٳʻ.
    38                               ! Number of grid points in longitude
    39      &                jmax, & ! ٳʻ.
    40                               ! Number of grid points in latitude
    41      &                kmax    ! ľؿ.
    42                               ! Number of vertical level
    43  
    44    ! ̷ѥ᥿
    45    ! Kind type parameter
    46    !
    47    use dc_types, only: DP, &      ! ټ¿. Double precision.
    48      &                 STRING     ! ʸ.       Strings.
    49  
    50    ! NAMELIST եϤ˴ؤ桼ƥƥ
    51    ! Utilities for NAMELIST file input
    52    !
    53    use namelist_util, only: MaxNmlArySize
    54                                ! NAMELIST ɤ߹κ祵.
    55                                ! Maximum size of arrays loaded from NAMELIST
    56  
    57    ! å
    58    ! Message output
    59    !
    60    use dc_message, only: MessageNotify
    61  
    62    ! ʸ ; Declaration statements
    63    !
    64    implicit none
    65    private
    66  
    67  
    68    ! ³
    69    ! Public procedure
    70    !
    71    public:: DryConvAdjust
    72    public:: DryConvAdjustInit
    73  
    74    ! ѿ
    75    ! Public variables
    76    !
    77    logical, save :: dry_conv_adjust_inited = .false.
    78                                ! ե饰.
    79                                ! Initialization flag
    80  
    81    ! ѿ
    82    ! Private variables
    83    !
    84    real(DP), save:: CrtlRH
    85                                ! ׳м.
    86                                ! Critical relative humidity
    87    integer, save:: ItrtMax
    88                                ! ƥ졼.
    89                                ! Number of iteration
    90  
    91    real(DP), save:: AdjustCriterion(1:MaxNmlArySize)
    92                                ! ĴԤ (Ūͥ륮κβٴ)
    93                                ! Criterion of adjustment (temperature difference
    94                                ! equivalent to difference of dry static energy)
    95  
    96    character(*), parameter:: module_name = 'dry_conv_adjust'
    97                                ! ⥸塼̾.
    98                                ! Module name
    99    character(*), parameter:: version = &
   100      & '$Name: dcpam5-20120921 $' // &
   101      & '$Id: dry_conv_adjust.f90,v 1.6 2012-09-08 15:18:50 yot Exp $'
   102                                ! ⥸塼ΥС
   103                                ! Module version
   104  
   105  contains
   106  
   107    !--------------------------------------------------------------------------------------
   108  
   109    subroutine DryConvAdjust( &
   110      & xyz_Temp,             &  ! (inout)
   111      & xyz_Press, xyr_Press  &  ! (in)
   112      & )
   113      !
   114      ! ήĴ᥹ˤ, ٤Ĵ.
   115      !
   116      ! Adjust temperature by dry convective adjustment
   117      !
   118  
   119      ! ⥸塼 ; USE statements
   120      !
   121  
   122      ! ʪ
   123      ! Physical and mathematical constants settings
   124      !
   125      use constants0, only: &
   126        & GasRUniv
   127                                ! $ R^{*} $ [J K-1 mol-1].
   128                                ! ׵.  Universal gas constant
   129  
   130      ! ʪ
   131      ! Physical constants settings
   132      !
   133      use constants, only: &
   134        & Grav, &
   135                                ! $ g $ [m s-2].
   136                                ! ϲ®.
   137                                ! Gravitational acceleration
   138        & GasRDry, &
   139                                ! $ R $ [J kg-1 K-1].
   140                                ! 絤ε.
   141                                ! Gas constant of air
   142        & CpDry
   143                                ! $ C_p $ [J kg-1 K-1].
   144                                ! 絤갵Ǯ.
   145                                ! Specific heat of air at constant pressure
   146  
   147      ! 
   148      ! Time control
   149      !
   150      use timeset, only: &
   151        & DelTime, &            ! $ \Delta t $
   152        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   153        & TimesetClockStart, TimesetClockStop
   154  
   155      ! ҥȥǡ
   156      ! History data output
   157      !
   158      use gtool_historyauto, only: HistoryAutoPut
   159  
   160  
   161      ! ʸ ; Declaration statements
   162      !
   163      implicit none
   164  
   165      real(DP), intent(inout):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   166                                ! $ T $ .     . Temperature
   167      real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   168                                ! $ p $ .  (٥).
   169                                ! Air pressure (full level)
   170      real(DP), intent(in   ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   171                                ! $ \hat{p} $ .  (Ⱦ٥).
   172                                ! Air pressure (half level)
   173  
   174      ! ѿ
   175      ! Work variables
   176      !
   177      real(DP):: xyz_DTempDt(0:imax-1, 1:jmax, 1:kmax)
   178                                ! ѲΨ.
   179                                ! Temperature tendency
   180      real(DP):: xyz_TempB (0:imax-1, 1:jmax, 1:kmax)
   181                                ! Ĵβ.
   182                                ! Temperature before adjustment
   183      logical:: xy_Adjust (0:imax-1, 1:jmax)
   184                                ! Ĵᤵ줿ݤ?.
   185                                ! Whether it was adjusted this time or not?
   186      logical:: xy_AdjustB (0:imax-1, 1:jmax)
   187                                ! Ĵᤵ줿ݤ?.
   188                                ! Whether it was adjusted last time or not?
   189      real(DP):: xyz_DelPress(0:imax-1, 1:jmax, 1:kmax)
   190                                ! $ \Delta p $
   191                                !
   192      real(DP):: xyr_ConvAdjustFactor(0:imax-1, 1:jmax, 0:kmax)
   193                                ! $ \frac{1}{2} \frac{ R }{Cp}
   194                                !   \frac{ p_{k} - p_{k+1} }{ p_{k+1/2} } $
   195  
   196      real(DP):: TempEquivToExcEne
   197                                ! Temperature equivalent to the excess dry static energy
   198                                ! (Dry static energy difference devided by specific heat)
   199  
   200      real(DP):: DelTempUppLev
   201                                ! k+1 ܤؤˤĴˤ벹٤Ѳ.
   202                                ! Temperature variation by adjustment at k+1 level
   203      real(DP):: DelTempLowLev
   204                                ! k ܤؤˤĴˤ벹٤Ѳ.
   205                                ! Temperature variation by adjustment at k level
   206      logical:: Adjust
   207                                ! ΰˤư٤ǤĴᤵ줿ݤ?.
   208                                ! Whether it was adjusted even once in global
   209                                ! this time or not?
   210  
   211      real(DP):: TempLowLevBefAdj ! Variables for check routine
   212      real(DP):: TempUppLevBefAdj
   213  
   214      integer:: i               ! ˲ DO 롼Ѻѿ
   215                                ! Work variables for DO loop in longitude
   216      integer:: j               ! ˲ DO 롼Ѻѿ
   217                                ! Work variables for DO loop in latitude
   218      integer:: k               ! ľ˲ DO 롼Ѻѿ
   219                                ! Work variables for DO loop in vertical direction
   220      integer:: itr             ! ƥ졼˲ DO 롼Ѻѿ
   221                                ! Work variables for DO loop in iteration direction
   222  
   223  
   224      ! ¹ʸ ; Executable statement
   225      !
   226  
   227      ! ǧ
   228      ! Initialization check
   229      !
   230      if ( .not. dry_conv_adjust_inited ) then
   231        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   232      end if
   233  
   234  
   235      ! ׻ַ¬
   236      ! Start measurement of computation time
   237      !
   238      call TimesetClockStart( module_name )
   239  
   240      ! Ĵ "Temp" ¸
   241      ! Store "Temp" before adjustment
   242      !
   243      xyz_TempB = xyz_Temp
     .        if (xyz_tempb.DSC.U2 .gt. 0) then                                 
     .           J1 = and(xyz_tempb.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t380 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t382 = 1, xyz_tempb.DSC.U1 + 1                           
     .                 xyz_tempb(t382-1,t380,t378+1) = xyz_temp(t382-1,t380,t378
     .       1            +1)                                                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t380 = J1 + 1, xyz_tempb.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t382 = 1, xyz_tempb.DSC.U1 + 1                           
     .                 xyz_tempb(t382-1,t380,t378+1) = xyz_temp(t382-1,t380,t378
     .       1            +1)                                                   
     .                 xyz_tempb(t382-1,t380+1,t378+1) = xyz_temp(t382-1,t380+1,
     .       1            t378+1)                                               
     .                 xyz_tempb(t382-1,t380+2,t378+1) = xyz_temp(t382-1,t380+2,
     .       1            t378+1)                                               
     .                 xyz_tempb(t382-1,t380+3,t378+1) = xyz_temp(t382-1,t380+3,
     .       1            t378+1)                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   244  
   245      ! Calculate some values used for dry convective adjustment
   246      !
   247  
   248      do k = 1, kmax
   249        xyz_DelPress(:,:,k) = xyr_Press(:,:,k-1) - xyr_Press(:,:,k)
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t390 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t392 = 1, imax                                           
     .                 xyz_delpress(t392-1,t390,k) = xyr_press(t392-1,t390,k-1) 
     .       1             - xyr_press(t392-1,t390,k)                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t390 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t392 = 1, imax                                           
     .                 xyz_delpress(t392-1,t390,k) = xyr_press(t392-1,t390,k-1) 
     .       1             - xyr_press(t392-1,t390,k)                           
     .                 xyz_delpress(t392-1,t390+1,k) = xyr_press(t392-1,t390+1,k
     .       1            -1) - xyr_press(t392-1,t390+1,k)                      
     .                 xyz_delpress(t392-1,t390+2,k) = xyr_press(t392-1,t390+2,k
     .       1            -1) - xyr_press(t392-1,t390+2,k)                      
     .                 xyz_delpress(t392-1,t390+3,k) = xyr_press(t392-1,t390+3,k
     .       1            -1) - xyr_press(t392-1,t390+3,k)                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   250      end do
   251  
   252      ! \frac{1}{2} \frac{ R }{Cp} \frac{ p_{k} - p_{k+1} }{ p_{k+1/2} }
   253      !
   254      !   The value at k = 0 is not used.
   255      k = 0
   256      xyr_ConvAdjustFactor(:,:,k) = 0.0d0
     .        if (xyr_convadjustfactor.DSC.U2 .gt. 0) then                      
     .           J3 = and(xyr_convadjustfactor.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t400 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t402 = 1, xyr_convadjustfactor.DSC.U1 + 1                
     .                 xyr_convadjustfactor(t402-1,t400,0) =                    
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t400 = J3 + 1, xyr_convadjustfactor.DSC.U2, 4               
     .  !CDIR       NODEP                                                       
     .              do t402 = 1, xyr_convadjustfactor.DSC.U1 + 1                
     .                 xyr_convadjustfactor(t402-1,t400,0) =                    
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t402-1,t400+1,0) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t402-1,t400+2,0) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t402-1,t400+3,0) =                  
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   257      !
   258      do k = 1, kmax-1
   259        xyr_ConvAdjustFactor(:,:,k) =                     &
     .        if (jmax .gt. 0) then                                             
     .           J4 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t406 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t408 = 1, imax                                           
     .                 xyr_convadjustfactor(t408-1,t406,k) = gasrdry/cpdry*(    
     .       1            xyz_press(t408-1,t406,k)-xyz_press(t408-1,t406,k+1))/(
     .       2            xyr_press(t408-1,t406,k)*2.00000000000000e+000)       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t406 = J4 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t408 = 1, imax                                           
     .                 xyr_convadjustfactor(t408-1,t406,k) = (gasrdry/cpdry)*(  
     .       1            xyz_press(t408-1,t406,k)-xyz_press(t408-1,t406,k+1))/(
     .       2            xyr_press(t408-1,t406,k)*2.00000000000000e+000)       
     .                 xyr_convadjustfactor(t408-1,t406+1,k) = (gasrdry/cpdry)*(
     .       1            xyz_press(t408-1,t406+1,k)-xyz_press(t408-1,t406+1,k+1
     .       2            ))/(xyr_press(t408-1,t406+1,k)*2.00000000000000e+000) 
     .                 xyr_convadjustfactor(t408-1,t406+2,k) = (gasrdry/cpdry)*(
     .       1            xyz_press(t408-1,t406+2,k)-xyz_press(t408-1,t406+2,k+1
     .       2            ))/(xyr_press(t408-1,t406+2,k)*2.00000000000000e+000) 
     .                 xyr_convadjustfactor(t408-1,t406+3,k) = (gasrdry/cpdry)*(
     .       1            xyz_press(t408-1,t406+3,k)-xyz_press(t408-1,t406+3,k+1
     .       2            ))/(xyr_press(t408-1,t406+3,k)*2.00000000000000e+000) 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   260          & GasRDry / CpDry                               &
   261          &   * ( xyz_Press(:,:,k) - xyz_Press(:,:,k+1) ) &
   262          &   / xyr_Press(:,:,k) / 2.0_DP
   263      end do
   264      !   The value at k = kmax is not used.
   265      k = kmax
   266      xyr_ConvAdjustFactor(:,:,k) = 0.0d0
     .        if (xyr_convadjustfactor.DSC.U2 .gt. 0) then                      
     .           J5 = and(xyr_convadjustfactor.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t418 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t420 = 1, xyr_convadjustfactor.DSC.U1 + 1                
     .                 xyr_convadjustfactor(t420-1,t418,k) =                    
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t418 = J5 + 1, xyr_convadjustfactor.DSC.U2, 4               
     .  !CDIR       NODEP                                                       
     .              do t420 = 1, xyr_convadjustfactor.DSC.U1 + 1                
     .                 xyr_convadjustfactor(t420-1,t418,k) =                    
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t420-1,t418+1,k) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t420-1,t418+2,k) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyr_convadjustfactor(t420-1,t418+3,k) =                  
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   267  
   268  
   269      ! Ĵ
   270      ! Adjustment
   271      !
   272      xy_AdjustB = .true.
     .        if (xy_adjustb.DSC.U2 .gt. 0) then                                
     .           J6 = and(xy_adjustb.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t424 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t426 = 1, xy_adjustb.DSC.U1 + 1                          
     .                 xy_adjustb(t426-1,t424) = 1                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t424 = J6 + 1, xy_adjustb.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t426 = 1, xy_adjustb.DSC.U1 + 1                          
     .                 xy_adjustb(t426-1,t424) = 1                              
     .                 xy_adjustb(t426-1,t424+1) = 1                            
     .                 xy_adjustb(t426-1,t424+2) = 1                            
     .                 xy_adjustb(t426-1,t424+3) = 1                            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   273  
   274      ! ֤
   275      ! Iteration
   276      !
   277      do itr = 1, ItrtMax
   278        xy_Adjust = .false.
     .        if (xy_adjust.DSC.U2 .gt. 0) then                                 
     .           J7 = and(xy_adjust.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t430 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t432 = 1, xy_adjust.DSC.U1 + 1                           
     .                 xy_adjust(t432-1,t430) = 0                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t430 = J7 + 1, xy_adjust.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t432 = 1, xy_adjust.DSC.U1 + 1                           
     .                 xy_adjust(t432-1,t430) = 0                               
     .                 xy_adjust(t432-1,t430+1) = 0                             
     .                 xy_adjust(t432-1,t430+2) = 0                             
     .                 xy_adjust(t432-1,t430+3) = 0                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   279  
   280        do k = 1, kmax-1
   281          do j = 1, jmax
   282            do i = 0, imax-1
   283              if ( xy_AdjustB(i,j) ) then
   284  
   285                ! Temperature equivalent to the excess dry static energy
   286                ! (Dry static energy difference devided by specific heat)
   287                !
   288                TempEquivToExcEne = &
   289                  &   xyz_Temp(i,j,k) - xyz_Temp(i,j,k+1)                                &
   290                  & - xyr_ConvAdjustFactor(i,j,k) * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) )
   291  
   292                ! Check vertical gradient of dry static energy
   293                !
   294                if ( TempEquivToExcEne > AdjustCriterion(itr) ) then
   295  
   296                  DelTempUppLev =                                                       &
   297                    &   xyz_DelPress(i,j,k) * TempEquivToExcEne                         &
   298                    & / ( xyr_ConvAdjustFactor(i,j,k)                                   &
   299                    &       * ( xyz_DelPress(i,j,k  )                                   &
   300                    &         - xyz_DelPress(i,j,k+1) )                                 &
   301                    &     + xyz_DelPress(i,j,k) + xyz_DelPress(i,j,k+1) )
   302  
   303                  DelTempLowLev =                                                       &
   304                    & - xyz_DelPress(i,j,k+1) * DelTempUppLev                           &
   305                    & / xyz_DelPress(i,j,k)
   306  
   307  
   308                  !=========
   309                  ! check routine
   310                  !---------
   311  !!$                TempLowLevBefAdj = xyz_Temp(i,j,k  )
   312  !!$                TempUppLevBefAdj = xyz_Temp(i,j,k+1)
   313                  !=========
   314  
   315  
   316                  ! ٤Ĵ
   317                  ! Adjust temperature
   318                  !
   319                  xyz_Temp(i,j,k  ) = xyz_Temp(i,j,k  ) + DelTempLowLev
   320                  xyz_Temp(i,j,k+1) = xyz_Temp(i,j,k+1) + DelTempUppLev
   321  
   322  
   323                  !=========
   324                  ! check routine
   325                  !---------
   326  !!$                write( 6, * ) '====='
   327  !!$                write( 6, * ) 'Energy difference before and after adjustment and each energy'
   328  !!$                write( 6, * )                                                        &
   329  !!$                  &   ( CpDry * TempLowLevBefAdj  )                                  &
   330  !!$                  &     * xyz_DelPress(i,j,k  ) / Grav                               &
   331  !!$                  & + ( CpDry * TempUppLevBefAdj  )                                  &
   332  !!$                  &     * xyz_DelPress(i,j,k+1) / Grav                               &
   333  !!$                  & - ( CpDry * xyz_Temp(i,j,k  ) )                                  &
   334  !!$                  &     * xyz_DelPress(i,j,k  ) / Grav                               &
   335  !!$                  & - ( CpDry * xyz_Temp(i,j,k+1) )                                  &
   336  !!$                  &     * xyz_DelPress(i,j,k+1) / Grav,                              &
   337  !!$                  &   ( CpDry * TempLowLevBefAdj  )                                  &
   338  !!$                  &     * xyz_DelPress(i,j,k  ) / Grav,                              &
   339  !!$                  &   ( CpDry * TempUppLevBefAdj  )                                  &
   340  !!$                  &     * xyz_DelPress(i,j,k+1) / Grav,                              &
   341  !!$                  &   ( CpDry * xyz_Temp(i,j,k  ) )                                  &
   342  !!$                  &     * xyz_DelPress(i,j,k  ) / Grav,                              &
   343  !!$                  &   ( CpDry * xyz_Temp(i,j,k+1) )                                  &
   344  !!$                  &     * xyz_DelPress(i,j,k+1) / Grav
   345  !!$                write( 6, * ) 'Difference of dry static energy after adjustment'
   346  !!$                write( 6, * )                                                         &
   347  !!$                  &   ( CpDry * xyz_Temp(i,j,k  ) )                                   &
   348  !!$                  & - ( CpDry * xyz_Temp(i,j,k+1) )                                   &
   349  !!$                  & - CpDry * xyr_ConvAdjustFactor(i,j,k)                             &
   350  !!$                  &   * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) ),                      &
   351  !!$                  &   ( CpDry * xyz_Temp(i,j,k  ) ),                                  &
   352  !!$                  &   ( CpDry * xyz_Temp(i,j,k+1) ),                                  &
   353  !!$                  & - CpDry * xyr_ConvAdjustFactor(i,j,k)                             &
   354  !!$                  &   * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) )
   355                  !=========
   356  
   357                  ! Ĵᤷݤ?
   358                  ! Whether it was adjusted or not?
   359                  !
   360                  xy_Adjust(i,j) = .true.
   361                end if
   362  
   363              end if
   364  
   365            end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           if (xy_adjustb(i-1,j) .ne. 0) then                             
     .              tempequivtoexcene = xyz_temp(i-1,j,k) - xyz_temp(i-1,j,k+1) 
     .       1          - xyr_convadjustfactor(i-1,j,k)*(xyz_temp(i-1,j,k)+     
     .       2         xyz_temp(i-1,j,k+1))                                     
     .              if (tempequivtoexcene .gt. adjustcriterion(itr)) then       
     .                 deltempupplev = xyz_delpress(i-1,j,k)*tempequivtoexcene/(
     .       1            xyr_convadjustfactor(i-1,j,k)*(xyz_delpress(i-1,j,k)- 
     .       2            xyz_delpress(i-1,j,k+1))+xyz_delpress(i-1,j,k)+       
     .       3            xyz_delpress(i-1,j,k+1))                              
     .                 xyz_temp(i-1,j,k) = xyz_temp(i-1,j,k) + (-xyz_delpress(i-
     .       1            1,j,k+1)*deltempupplev/xyz_delpress(i-1,j,k))         
     .                 xyz_temp(i-1,j,k+1) = xyz_temp(i-1,j,k+1) + deltempupplev
     .                 xy_adjust(i-1,j) = 1                                     
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   366          end do
   367        end do
   368  
   369        Adjust = .false.
   370        do i = 0, imax-1
   371          do j = 1, jmax
   372            xy_AdjustB(i,j) = xy_Adjust(i,j)
   373            Adjust          = Adjust .or. xy_Adjust(i,j)
   374          end do
   375        end do
   376  
   377        if ( .not. Adjust ) exit
   378  
   379      end do
   380  
   381      ! ѲΨ
   382      ! Calculate temperature tendency
   383      !
   384      xyz_DTempDt = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
     .        if (jmax .gt. 0) then                                             
     .           J8 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t438 = 1, J8                                                
     .              D1 = 1.D0/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t440 = 1, imax                                           
     .                 xyz_dtempdt(t440-1,t438,t436+1) = (xyz_temp(t440-1,t438, 
     .       1            t436+1)-xyz_tempb(t440-1,t438,t436+1))*D1             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t438 = J8 + 1, jmax, 4                                      
     .              D2 = 1.D0/(2.00000000000000e+000*deltime)                   
     .              D3 = 1.D0/(2.00000000000000e+000*deltime)                   
     .              D4 = 1.D0/(2.00000000000000e+000*deltime)                   
     .              D5 = 1.D0/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t440 = 1, imax                                           
     .                 xyz_dtempdt(t440-1,t438,t436+1) = (xyz_temp(t440-1,t438, 
     .       1            t436+1)-xyz_tempb(t440-1,t438,t436+1))*D2             
     .                 xyz_dtempdt(t440-1,t438+1,t436+1) = (xyz_temp(t440-1,t438
     .       1            +1,t436+1)-xyz_tempb(t440-1,t438+1,t436+1))*D3        
     .                 xyz_dtempdt(t440-1,t438+2,t436+1) = (xyz_temp(t440-1,t438
     .       1            +2,t436+1)-xyz_tempb(t440-1,t438+2,t436+1))*D4        
     .                 xyz_dtempdt(t440-1,t438+3,t436+1) = (xyz_temp(t440-1,t438
     .       1            +3,t436+1)-xyz_tempb(t440-1,t438+3,t436+1))*D5        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   385  
   386  
   387      ! ҥȥǡ
   388      ! History data output
   389      !
   390      call HistoryAutoPut( TimeN, 'DTempDtDryConv', xyz_DTempDt )
   391  
   392  
   393      ! ׻ַ¬
   394      ! Pause measurement of computation time
   395      !
   396      call TimesetClockStop( module_name )
   397  
   398    end subroutine DryConvAdjust
   399  
   400    !--------------------------------------------------------------------------------------
   401  
   402    subroutine DryConvAdjustInit
   403      !
   404      ! dry_conv_adjust ⥸塼νԤޤ.
   405      ! NAMELIST#dry_conv_adjust_nml ɤ߹ߤϤμ³ǹԤޤ.
   406      !
   407      ! "dyr_conv_adjust" module is initialized.
   408      ! "NAMELIST#dry_conv_adjust_nml" is loaded in this procedure.
   409      !
   410  
   411      ! ⥸塼 ; USE statements
   412      !
   413  
   414      ! NAMELIST եϤ˴ؤ桼ƥƥ
   415      ! Utilities for NAMELIST file input
   416      !
   417      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   418  
   419      ! ե
   420      ! File I/O support
   421      !
   422      use dc_iounit, only: FileOpen
   423  
   424      ! ̷ѥ᥿
   425      ! Kind type parameter
   426      !
   427      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   428  
   429      ! ʸ
   430      ! Character handling
   431      !
   432      use dc_string, only: StoA
   433  
   434      ! ҥȥǡ
   435      ! History data output
   436      !
   437      use gtool_historyauto, only: HistoryAutoAddVariable
   438  
   439      ! ʸ ; Declaration statements
   440      !
   441      implicit none
   442  
   443      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   444                                ! Unit number for NAMELIST file open
   445      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   446                                ! IOSTAT of NAMELIST read
   447  
   448      ! NAMELIST ѿ
   449      ! NAMELIST group name
   450      !
   451      namelist /dry_conv_adjust_nml/ &
   452        & CrtlRH, ItrtMax, AdjustCriterion
   453  
   454            ! ǥեͤˤĤƤϽ³ "dry_conv_adjust#DryConvAdjustInit"
   455            ! Υɤ򻲾ȤΤ.
   456            !
   457            ! Refer to source codes in the initialization procedure
   458            ! "dry_conv_adjust#DryConvAdjustInit" for the default values.
   459            !
   460  
   461      ! ¹ʸ ; Executable statement
   462      !
   463  
   464      if ( dry_conv_adjust_inited ) return
   465  
   466  
   467      ! ǥեͤ
   468      ! Default values settings
   469      !
   470      ! default values used in AGCM5
   471  !!$    CrtlRH  = 0.990_DP
   472  !!$    ItrtMax = 10
   473  !!$    AdjustCriterion(1:ItrtMax) = &
   474  !!$      & (/ 0.01_DP, 0.02_DP, 0.02_DP, 0.05_DP, 0.05_DP, &
   475  !!$      &    0.10_DP, 0.10_DP, 0.20_DP, 0.20_DP, 0.40_DP  /)
   476      !
   477      CrtlRH  = 1.0d0
   478      ItrtMax = 10
   479      AdjustCriterion(1:ItrtMax) = 0.0d0
   480  
   481  
   482      ! NAMELIST ɤ߹
   483      ! NAMELIST is input
   484      !
   485      if ( trim(namelist_filename) /= '' ) then
   486        call FileOpen( unit_nml, &          ! (out)
   487          & namelist_filename, mode = 'r' ) ! (in)
   488  
   489        rewind( unit_nml )
   490        read( unit_nml,                &  ! (in)
   491          & nml = dry_conv_adjust_nml, &  ! (out)
   492          & iostat = iostat_nml )         ! (out)
   493        close( unit_nml )
   494  
   495        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   496  !!$      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
   497      end if
   498  
   499      ! ƥ졼, ԰εƸΥå
   500      ! Check number of iteration, admissible error of unstability
   501      !
   502      call NmlutilAryValid( module_name, & ! (in)
   503        & AdjustCriterion, 'AdjustCriterion', &      ! (in)
   504        & ItrtMax,    'ItrtMax' )          ! (in)
   505  
   506  
   507      ! ҥȥǡϤΤΤؤѿϿ
   508      ! Register of variables for history data output
   509      !
   510      call HistoryAutoAddVariable( 'DTempDtDryConv', &
   511        & (/ 'lon ', 'lat ', 'sig ', 'time' /),      &
   512        & 'dry convective adjustment heating', 'K s-1' )
   513  
   514      !  ; Print
   515      !
   516      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   517      call MessageNotify( 'M', module_name, '  CrtlRH               = %f', d = (/ CrtlRH /) )
   518      call MessageNotify( 'M', module_name, '  ItrtMax              = %d', i = (/ ItrtMax /) )
   519      call MessageNotify( 'M', module_name, '  AdjustCriterion      = (/ %*r /)', &
   520        & r = real( AdjustCriterion(1:ItrtMax) ), n = (/ ItrtMax /) )
   521      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   522  
   523      dry_conv_adjust_inited = .true.
   524  
   525    end subroutine DryConvAdjustInit
   526  
   527    !--------------------------------------------------------------------------------------
   528  
   529  end module dry_conv_adjust
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:14 2012
FILE NAME: dry_conv_adjust.f90
PROGRAM NAME: dry_conv_adjust
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ήĴ
     2:            !
     3:            != Dry convective adjustment
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6:            ! Version::   $Id: dry_conv_adjust.f90,v 1.6 2012-09-08 15:18:50 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module dry_conv_adjust
    13:              !
    14:              != ήĴ᥹
    15:              !
    16:              != Dry convective adjustment
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !== Procedures List
    21:              ! 
    22:              ! DryConvAdjust :: ήĴ
    23:              ! ------------  :: ------------
    24:              ! DryConvAdjust :: Dry convective adjustment
    25:              !
    26:              !== NAMELIST
    27:              !
    28:              ! NAMELIST#dry_conv_adjust_nml
    29:              !
    30:            
    31:              ! ⥸塼 ; USE statements
    32:              !
    33:            
    34:              ! ʻ
    35:              ! Grid points settings
    36:              !
    37:              use gridset, only: imax, & ! ٳʻ. 
    38:                                         ! Number of grid points in longitude
    39:                &                jmax, & ! ٳʻ. 
    40:                                         ! Number of grid points in latitude
    41:                &                kmax    ! ľؿ. 
    42:                                         ! Number of vertical level
    43:            
    44:              ! ̷ѥ᥿
    45:              ! Kind type parameter
    46:              !
    47:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    48:                &                 STRING     ! ʸ.       Strings. 
    49:            
    50:              ! NAMELIST եϤ˴ؤ桼ƥƥ
    51:              ! Utilities for NAMELIST file input
    52:              !
    53:              use namelist_util, only: MaxNmlArySize
    54:                                          ! NAMELIST ɤ߹κ祵. 
    55:                                          ! Maximum size of arrays loaded from NAMELIST
    56:            
    57:              ! å
    58:              ! Message output
    59:              !
    60:              use dc_message, only: MessageNotify
    61:            
    62:              ! ʸ ; Declaration statements
    63:              !
    64:              implicit none
    65:              private
    66:            
    67:            
    68:              ! ³
    69:              ! Public procedure
    70:              !
    71:              public:: DryConvAdjust
    72:              public:: DryConvAdjustInit
    73:            
    74:              ! ѿ
    75:              ! Public variables
    76:              !
    77:              logical, save :: dry_conv_adjust_inited = .false.
    78:                                          ! ե饰. 
    79:                                          ! Initialization flag
    80:            
    81:              ! ѿ
    82:              ! Private variables
    83:              !
    84:              real(DP), save:: CrtlRH
    85:                                          ! ׳м. 
    86:                                          ! Critical relative humidity
    87:              integer, save:: ItrtMax
    88:                                          ! ƥ졼. 
    89:                                          ! Number of iteration
    90:            
    91:              real(DP), save:: AdjustCriterion(1:MaxNmlArySize)
    92:                                          ! ĴԤ (Ūͥ륮κβٴ)
    93:                                          ! Criterion of adjustment (temperature difference 
    94:                                          ! equivalent to difference of dry static energy)
    95:            
    96:              character(*), parameter:: module_name = 'dry_conv_adjust'
    97:                                          ! ⥸塼̾. 
    98:                                          ! Module name
    99:              character(*), parameter:: version = &
   100:                & '$Name: dcpam5-20120921 $' // &
   101:                & '$Id: dry_conv_adjust.f90,v 1.6 2012-09-08 15:18:50 yot Exp $'
   102:                                          ! ⥸塼ΥС
   103:                                          ! Module version
   104:            
   105:            contains
   106:            
   107:              !--------------------------------------------------------------------------------------
   108:            
   109:              subroutine DryConvAdjust( &
   110:                & xyz_Temp,             &  ! (inout)
   111:                & xyz_Press, xyr_Press  &  ! (in)
   112:                & )
   113:                !
   114:                ! ήĴ᥹ˤ, ٤Ĵ. 
   115:                !
   116:                ! Adjust temperature by dry convective adjustment
   117:                !
   118:            
   119:                ! ⥸塼 ; USE statements
   120:                !
   121:            
   122:                ! ʪ
   123:                ! Physical and mathematical constants settings
   124:                !
   125:                use constants0, only: &
   126:                  & GasRUniv
   127:                                          ! $ R^{*} $ [J K-1 mol-1]. 
   128:                                          ! ׵.  Universal gas constant
   129:            
   130:                ! ʪ
   131:                ! Physical constants settings
   132:                !
   133:                use constants, only: &
   134:                  & Grav, & 
   135:                                          ! $ g $ [m s-2]. 
   136:                                          ! ϲ®. 
   137:                                          ! Gravitational acceleration
   138:                  & GasRDry, &
   139:                                          ! $ R $ [J kg-1 K-1]. 
   140:                                          ! 絤ε. 
   141:                                          ! Gas constant of air
   142:                  & CpDry
   143:                                          ! $ C_p $ [J kg-1 K-1]. 
   144:                                          ! 絤갵Ǯ. 
   145:                                          ! Specific heat of air at constant pressure
   146:            
   147:                ! 
   148:                ! Time control
   149:                !
   150:                use timeset, only: &
   151:                  & DelTime, &            ! $ \Delta t $
   152:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   153:                  & TimesetClockStart, TimesetClockStop
   154:            
   155:                ! ҥȥǡ
   156:                ! History data output
   157:                !
   158:                use gtool_historyauto, only: HistoryAutoPut
   159:            
   160:            
   161:                ! ʸ ; Declaration statements
   162:                !
   163:                implicit none
   164:            
   165:                real(DP), intent(inout):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   166:                                          ! $ T $ .     . Temperature
   167:                real(DP), intent(in   ):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   168:                                          ! $ p $ .  (٥). 
   169:                                          ! Air pressure (full level)
   170:                real(DP), intent(in   ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   171:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   172:                                          ! Air pressure (half level)
   173:            
   174:                ! ѿ
   175:                ! Work variables
   176:                !
   177:                real(DP):: xyz_DTempDt(0:imax-1, 1:jmax, 1:kmax)
   178:                                          ! ѲΨ. 
   179:                                          ! Temperature tendency
   180:                real(DP):: xyz_TempB (0:imax-1, 1:jmax, 1:kmax)
   181:                                          ! Ĵβ. 
   182:                                          ! Temperature before adjustment
   183:                logical:: xy_Adjust (0:imax-1, 1:jmax)
   184:                                          ! Ĵᤵ줿ݤ?. 
   185:                                          ! Whether it was adjusted this time or not?
   186:                logical:: xy_AdjustB (0:imax-1, 1:jmax)
   187:                                          ! Ĵᤵ줿ݤ?. 
   188:                                          ! Whether it was adjusted last time or not?
   189:                real(DP):: xyz_DelPress(0:imax-1, 1:jmax, 1:kmax)
   190:                                          ! $ \Delta p $
   191:                                          !
   192:                real(DP):: xyr_ConvAdjustFactor(0:imax-1, 1:jmax, 0:kmax)
   193:                                          ! $ \frac{1}{2} \frac{ R }{Cp} 
   194:                                          !   \frac{ p_{k} - p_{k+1} }{ p_{k+1/2} } $
   195:            
   196:                real(DP):: TempEquivToExcEne
   197:                                          ! Temperature equivalent to the excess dry static energy
   198:                                          ! (Dry static energy difference devided by specific heat)
   199:            
   200:                real(DP):: DelTempUppLev
   201:                                          ! k+1 ܤؤˤĴˤ벹٤Ѳ. 
   202:                                          ! Temperature variation by adjustment at k+1 level
   203:                real(DP):: DelTempLowLev
   204:                                          ! k ܤؤˤĴˤ벹٤Ѳ. 
   205:                                          ! Temperature variation by adjustment at k level
   206:                logical:: Adjust
   207:                                          ! ΰˤư٤ǤĴᤵ줿ݤ?. 
   208:                                          ! Whether it was adjusted even once in global 
   209:                                          ! this time or not?
   210:            
   211:                real(DP):: TempLowLevBefAdj ! Variables for check routine
   212:                real(DP):: TempUppLevBefAdj
   213:            
   214:                integer:: i               ! ˲ DO 롼Ѻѿ
   215:                                          ! Work variables for DO loop in longitude
   216:                integer:: j               ! ˲ DO 롼Ѻѿ
   217:                                          ! Work variables for DO loop in latitude
   218:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   219:                                          ! Work variables for DO loop in vertical direction
   220:                integer:: itr             ! ƥ졼˲ DO 롼Ѻѿ
   221:                                          ! Work variables for DO loop in iteration direction
   222:            
   223:            
   224:                ! ¹ʸ ; Executable statement
   225:                !
   226:            
   227:                ! ǧ
   228:                ! Initialization check
   229:                !
   230:                if ( .not. dry_conv_adjust_inited ) then
   231:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   232:                end if
   233:            
   234:            
   235:                ! ׻ַ¬
   236:                ! Start measurement of computation time
   237:                !
   238:                call TimesetClockStart( module_name )
   239:            
   240:                ! Ĵ "Temp" ¸
   241:                ! Store "Temp" before adjustment
   242:                !
   243: ++V====        xyz_TempB = xyz_Temp
   244:            
   245:                ! Calculate some values used for dry convective adjustment
   246:                !
   247:            
   248: +------>       do k = 1, kmax
   249: |+V====          xyz_DelPress(:,:,k) = xyr_Press(:,:,k-1) - xyr_Press(:,:,k)
   250: +------        end do
   251:            
   252:                ! \frac{1}{2} \frac{ R }{Cp} \frac{ p_{k} - p_{k+1} }{ p_{k+1/2} }
   253:                !
   254:                !   The value at k = 0 is not used.
   255:                k = 0
   256: +V=====        xyr_ConvAdjustFactor(:,:,k) = 0.0d0
   257:                !
   258: +------>       do k = 1, kmax-1
   259: |+V====          xyr_ConvAdjustFactor(:,:,k) =                     &
   260: |                  & GasRDry / CpDry                               &
   261: |                  &   * ( xyz_Press(:,:,k) - xyz_Press(:,:,k+1) ) &
   262: |                  &   / xyr_Press(:,:,k) / 2.0_DP
   263: +------        end do
   264:                !   The value at k = kmax is not used.
   265:                k = kmax
   266: +V=====        xyr_ConvAdjustFactor(:,:,k) = 0.0d0
   267:            
   268:            
   269:                ! Ĵ
   270:                ! Adjustment
   271:                !
   272: +V=====        xy_AdjustB = .true.
   273:            
   274:                ! ֤
   275:                ! Iteration
   276:                !
   277: +------>       do itr = 1, ItrtMax
   278: |+V====          xy_Adjust = .false.
   279: |          
   280: |+----->         do k = 1, kmax-1
   281: ||+---->           do j = 1, jmax
   282: |||V--->             do i = 0, imax-1
   283: ||||                   if ( xy_AdjustB(i,j) ) then
   284: ||||       
   285: ||||                     ! Temperature equivalent to the excess dry static energy
   286: ||||                     ! (Dry static energy difference devided by specific heat)
   287: ||||                     !
   288: ||||                     TempEquivToExcEne = &
   289: ||||                       &   xyz_Temp(i,j,k) - xyz_Temp(i,j,k+1)                                &
   290: ||||                       & - xyr_ConvAdjustFactor(i,j,k) * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) )
   291: ||||       
   292: ||||                     ! Check vertical gradient of dry static energy
   293: ||||                     !
   294: ||||                     if ( TempEquivToExcEne > AdjustCriterion(itr) ) then
   295: ||||       
   296: ||||                       DelTempUppLev =                                                       &
   297: ||||                         &   xyz_DelPress(i,j,k) * TempEquivToExcEne                         &
   298: ||||                         & / ( xyr_ConvAdjustFactor(i,j,k)                                   &
   299: ||||                         &       * ( xyz_DelPress(i,j,k  )                                   &
   300: ||||                         &         - xyz_DelPress(i,j,k+1) )                                 &
   301: ||||                         &     + xyz_DelPress(i,j,k) + xyz_DelPress(i,j,k+1) )
   302: ||||       
   303: ||||                       DelTempLowLev =                                                       &
   304: ||||                         & - xyz_DelPress(i,j,k+1) * DelTempUppLev                           &
   305: ||||                         & / xyz_DelPress(i,j,k)
   306: ||||       
   307: ||||       
   308: ||||                       !=========
   309: ||||                       ! check routine
   310: ||||                       !---------
   311: ||||       !!$                TempLowLevBefAdj = xyz_Temp(i,j,k  )
   312: ||||       !!$                TempUppLevBefAdj = xyz_Temp(i,j,k+1)
   313: ||||                       !=========
   314: ||||       
   315: ||||       
   316: ||||                       ! ٤Ĵ
   317: ||||                       ! Adjust temperature
   318: ||||                       !
   319: ||||                       xyz_Temp(i,j,k  ) = xyz_Temp(i,j,k  ) + DelTempLowLev
   320: ||||                       xyz_Temp(i,j,k+1) = xyz_Temp(i,j,k+1) + DelTempUppLev
   321: ||||       
   322: ||||       
   323: ||||                       !=========
   324: ||||                       ! check routine
   325: ||||                       !---------
   326: ||||       !!$                write( 6, * ) '====='
   327: ||||       !!$                write( 6, * ) 'Energy difference before and after adjustment and each energy'
   328: ||||       !!$                write( 6, * )                                                        &
   329: ||||       !!$                  &   ( CpDry * TempLowLevBefAdj  )                                  &
   330: ||||       !!$                  &     * xyz_DelPress(i,j,k  ) / Grav                               &
   331: ||||       !!$                  & + ( CpDry * TempUppLevBefAdj  )                                  &
   332: ||||       !!$                  &     * xyz_DelPress(i,j,k+1) / Grav                               &
   333: ||||       !!$                  & - ( CpDry * xyz_Temp(i,j,k  ) )                                  &
   334: ||||       !!$                  &     * xyz_DelPress(i,j,k  ) / Grav                               &
   335: ||||       !!$                  & - ( CpDry * xyz_Temp(i,j,k+1) )                                  &
   336: ||||       !!$                  &     * xyz_DelPress(i,j,k+1) / Grav,                              &
   337: ||||       !!$                  &   ( CpDry * TempLowLevBefAdj  )                                  &
   338: ||||       !!$                  &     * xyz_DelPress(i,j,k  ) / Grav,                              &
   339: ||||       !!$                  &   ( CpDry * TempUppLevBefAdj  )                                  &
   340: ||||       !!$                  &     * xyz_DelPress(i,j,k+1) / Grav,                              &
   341: ||||       !!$                  &   ( CpDry * xyz_Temp(i,j,k  ) )                                  &
   342: ||||       !!$                  &     * xyz_DelPress(i,j,k  ) / Grav,                              &
   343: ||||       !!$                  &   ( CpDry * xyz_Temp(i,j,k+1) )                                  &
   344: ||||       !!$                  &     * xyz_DelPress(i,j,k+1) / Grav
   345: ||||       !!$                write( 6, * ) 'Difference of dry static energy after adjustment'
   346: ||||       !!$                write( 6, * )                                                         &
   347: ||||       !!$                  &   ( CpDry * xyz_Temp(i,j,k  ) )                                   &
   348: ||||       !!$                  & - ( CpDry * xyz_Temp(i,j,k+1) )                                   &
   349: ||||       !!$                  & - CpDry * xyr_ConvAdjustFactor(i,j,k)                             &
   350: ||||       !!$                  &   * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) ),                      &
   351: ||||       !!$                  &   ( CpDry * xyz_Temp(i,j,k  ) ),                                  &
   352: ||||       !!$                  &   ( CpDry * xyz_Temp(i,j,k+1) ),                                  &
   353: ||||       !!$                  & - CpDry * xyr_ConvAdjustFactor(i,j,k)                             &
   354: ||||       !!$                  &   * ( xyz_Temp(i,j,k) + xyz_Temp(i,j,k+1) )
   355: ||||                       !=========
   356: ||||       
   357: ||||                       ! Ĵᤷݤ?
   358: ||||                       ! Whether it was adjusted or not?
   359: ||||                       !
   360: ||||                       xy_Adjust(i,j) = .true.
   361: ||||                     end if
   362: ||||       
   363: ||||                   end if
   364: ||||       
   365: |||V---              end do
   366: ||+----            end do
   367: |+-----          end do
   368: |          
   369: |                Adjust = .false.
   370: |+----->         do i = 0, imax-1
   371: ||+---->           do j = 1, jmax
   372: |||                  xy_AdjustB(i,j) = xy_Adjust(i,j)
   373: |||                  Adjust          = Adjust .or. xy_Adjust(i,j)
   374: ||+----            end do
   375: |+-----          end do
   376: |          
   377: |                if ( .not. Adjust ) exit
   378: |          
   379: +------        end do
   380:            
   381:                ! ѲΨ
   382:                ! Calculate temperature tendency
   383:                !
   384: ++V====        xyz_DTempDt = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
   385:            
   386:            
   387:                ! ҥȥǡ
   388:                ! History data output
   389:                !
   390:                call HistoryAutoPut( TimeN, 'DTempDtDryConv', xyz_DTempDt )
   391:            
   392:            
   393:                ! ׻ַ¬
   394:                ! Pause measurement of computation time
   395:                !
   396:                call TimesetClockStop( module_name )
   397:            
   398:              end subroutine DryConvAdjust
   399:            
   400:              !--------------------------------------------------------------------------------------
   401:            
   402:              subroutine DryConvAdjustInit
   403:                !
   404:                ! dry_conv_adjust ⥸塼νԤޤ. 
   405:                ! NAMELIST#dry_conv_adjust_nml ɤ߹ߤϤμ³ǹԤޤ. 
   406:                !
   407:                ! "dyr_conv_adjust" module is initialized. 
   408:                ! "NAMELIST#dry_conv_adjust_nml" is loaded in this procedure. 
   409:                !
   410:            
   411:                ! ⥸塼 ; USE statements
   412:                !
   413:            
   414:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   415:                ! Utilities for NAMELIST file input
   416:                !
   417:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   418:            
   419:                ! ե
   420:                ! File I/O support
   421:                !
   422:                use dc_iounit, only: FileOpen
   423:            
   424:                ! ̷ѥ᥿
   425:                ! Kind type parameter
   426:                !
   427:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   428:            
   429:                ! ʸ
   430:                ! Character handling
   431:                !
   432:                use dc_string, only: StoA
   433:            
   434:                ! ҥȥǡ
   435:                ! History data output
   436:                !
   437:                use gtool_historyauto, only: HistoryAutoAddVariable
   438:            
   439:                ! ʸ ; Declaration statements
   440:                !
   441:                implicit none
   442:            
   443:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   444:                                          ! Unit number for NAMELIST file open
   445:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   446:                                          ! IOSTAT of NAMELIST read
   447:            
   448:                ! NAMELIST ѿ
   449:                ! NAMELIST group name
   450:                !
   451:                namelist /dry_conv_adjust_nml/ &
   452:                  & CrtlRH, ItrtMax, AdjustCriterion
   453:            
   454:                      ! ǥեͤˤĤƤϽ³ "dry_conv_adjust#DryConvAdjustInit" 
   455:                      ! Υɤ򻲾ȤΤ. 
   456:                      !
   457:                      ! Refer to source codes in the initialization procedure
   458:                      ! "dry_conv_adjust#DryConvAdjustInit" for the default values. 
   459:                      !
   460:            
   461:                ! ¹ʸ ; Executable statement
   462:                !
   463:            
   464:                if ( dry_conv_adjust_inited ) return
   465:            
   466:            
   467:                ! ǥեͤ
   468:                ! Default values settings
   469:                !
   470:                ! default values used in AGCM5
   471:            !!$    CrtlRH  = 0.990_DP
   472:            !!$    ItrtMax = 10
   473:            !!$    AdjustCriterion(1:ItrtMax) = &
   474:            !!$      & (/ 0.01_DP, 0.02_DP, 0.02_DP, 0.05_DP, 0.05_DP, &
   475:            !!$      &    0.10_DP, 0.10_DP, 0.20_DP, 0.20_DP, 0.40_DP  /)
   476:                !
   477:                CrtlRH  = 1.0d0
   478:                ItrtMax = 10
   479: V======        AdjustCriterion(1:ItrtMax) = 0.0d0
   480:            
   481:            
   482:                ! NAMELIST ɤ߹
   483:                ! NAMELIST is input
   484:                !
   485:                if ( trim(namelist_filename) /= '' ) then
   486:                  call FileOpen( unit_nml, &          ! (out)
   487:                    & namelist_filename, mode = 'r' ) ! (in)
   488:            
   489:                  rewind( unit_nml )
   490:                  read( unit_nml,                &  ! (in)
   491:                    & nml = dry_conv_adjust_nml, &  ! (out)
   492:                    & iostat = iostat_nml )         ! (out)
   493:                  close( unit_nml )
   494:            
   495:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   496:            !!$      if ( iostat_nml == 0 ) write( STDOUT, nml = cumulus_adjust_nml )
   497:                end if
   498:            
   499:                ! ƥ졼, ԰εƸΥå
   500:                ! Check number of iteration, admissible error of unstability
   501:                !
   502:                call NmlutilAryValid( module_name, & ! (in)
   503:                  & AdjustCriterion, 'AdjustCriterion', &      ! (in)
   504:                  & ItrtMax,    'ItrtMax' )          ! (in)
   505:            
   506:            
   507:                ! ҥȥǡϤΤΤؤѿϿ
   508:                ! Register of variables for history data output
   509:                !
   510:                call HistoryAutoAddVariable( 'DTempDtDryConv', &
   511:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /),      &
   512:                  & 'dry convective adjustment heating', 'K s-1' )
   513:            
   514:                !  ; Print
   515:                !
   516:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   517:                call MessageNotify( 'M', module_name, '  CrtlRH               = %f', d = (/ CrtlRH /) )
   518:                call MessageNotify( 'M', module_name, '  ItrtMax              = %d', i = (/ ItrtMax /) )
   519: V======        call MessageNotify( 'M', module_name, '  AdjustCriterion      = (/ %*r /)', &
   520:                  & r = real( AdjustCriterion(1:ItrtMax) ), n = (/ ItrtMax /) )
   521:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   522:            
   523:                dry_conv_adjust_inited = .true.
   524:            
   525:              end subroutine DryConvAdjustInit
   526:            
   527:              !--------------------------------------------------------------------------------------
   528:            
   529:            end module dry_conv_adjust
