Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:20 2012
FILE NAME: sl09_diffusion.f90
PROGRAM NAME: sl09_diffusion
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   199  opt  (  11): Fused array assignments. :line 199 - 200
   199  vec  (   4): Vectorized array expression.
   199  vec  (   4): Vectorized array expression.
   200  opt  (1592): Outer loop unrolled inside inner loop.
   205  opt  (1592): Outer loop unrolled inside inner loop.
   205  vec  (   4): Vectorized array expression.
   205  vec  (   4): Vectorized array expression.
   206  opt  (1592): Outer loop unrolled inside inner loop.
   206  vec  (   4): Vectorized array expression.
   206  vec  (   4): Vectorized array expression.
   220  opt  (1592): Outer loop unrolled inside inner loop.
   220  vec  (   4): Vectorized array expression.
   220  vec  (   4): Vectorized array expression.
   384  vec  (   3): Unvectorized loop.
   384  vec  (  13): Overhead of loop division is too large.
   386  vec  (   4): Vectorized array expression.
   388  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:20 2012
FILE NAME: sl09_diffusion.f90
PROGRAM NAME: sl09_diffusion
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Schneider and Liu (2009) ˤľ
     2  !
     3  != Vertical diffusion by Schneider and Liu (2009)
     4  !
     5  ! Authors::   Yoshiyuki O. TAKAHASHI
     6  ! Version::   $Id: sl09_diffusion.f90,v 1.3 2012-09-17 10:59:30 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module sl09_diffusion
    13    !
    14    != Schneider and Liu (2009) ˤľ
    15    !
    16    != Vertical diffusion by Schneider and Liu (2009)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !
    21    !== Procedures List
    22    !
    23  !!$  ! Hs94Forcing   :: Ȼη׻
    24  !!$  ! Hs94Finalize  :: λ (⥸塼ѿγդ)
    25  !!$  ! ------------  :: ------------
    26  !!$  ! Hs94Forcing   :: Calculate forcing and dissipation
    27  !!$  ! Hs94Finalize  :: Termination (deallocate variables in this module)
    28    !
    29    !--
    30    !== NAMELIST
    31    !
    32    ! NAMELIST#sl09_diffusion_nml
    33    !++
    34    !== References
    35    !
    36    !  Schneider, T. and J. Liu,
    37    !    Formation of jets and equatorial superrotation on Jupiter,
    38    !    J. Atmos. Sci., 69, 579, 2009.
    39    !
    40  
    41    ! ⥸塼 ; USE statements
    42    !
    43  
    44    ! ʻ
    45    ! Grid points settings
    46    !
    47    use gridset, only: imax, & ! ٳʻ.
    48                               ! Number of grid points in longitude
    49      &                jmax, & ! ٳʻ.
    50                               ! Number of grid points in latitude
    51      &                kmax    ! ľؿ.
    52                               ! Number of vertical level
    53  
    54    ! ̷ѥ᥿
    55    ! Kind type parameter
    56    !
    57    use dc_types, only: DP, &      ! ټ¿. Double precision.
    58      &                 STRING     ! ʸ.       Strings.
    59  
    60  
    61    ! å
    62    ! Message output
    63    !
    64    use dc_message, only: MessageNotify
    65  
    66    ! ʸ ; Declaration statements
    67    !
    68    implicit none
    69    private
    70  
    71    ! ³
    72    ! Public procedure
    73    !
    74    public:: SL09Diffusion
    75  
    76    ! ѿ
    77    ! Public variables
    78    !
    79    logical, save, public:: sl09_diffusion_inited = .false.
    80                                ! ե饰.
    81                                ! Initialization flag
    82  
    83    ! ѿ
    84    ! Private variables
    85    !
    86    real(DP), save, allocatable :: xyz_kv (:,:,:)
    87                                ! $ k_v $ .
    88    real(DP), save              :: LBHeatFlux
    89  
    90    character(*), parameter:: module_name = 'sl09_diffusion'
    91                                ! ⥸塼̾.
    92                                ! Module name
    93    character(*), parameter:: version = &
    94      & '$Name: dcpam5-20120921 $' // &
    95      & '$Id: sl09_diffusion.f90,v 1.3 2012-09-17 10:59:30 yot Exp $'
    96                                ! ⥸塼ΥС
    97                                ! Module version
    98  
    99  contains
   100  
   101    subroutine SL09Diffusion(      &
   102      & xyz_U, xyz_V, xyr_Press,         & ! (in)
   103      & xyz_DUDt, xyz_DVDt, xyz_DTempDt  & ! (out)
   104      & )
   105      !
   106      !
   107      !
   108  
   109      ! ⥸塼 ; USE statements
   110      !
   111  
   112      ! ɸǡ
   113      ! Axes data settings
   114      !
   115      use axesset, only: &
   116        & y_Lat, &              ! $ \varphi $ [rad.] . . Latitude
   117        & z_Sigma               ! $ \sigma $ ٥ ().
   118                                ! Full $ \sigma $ level
   119  
   120      ! 
   121      ! Time control
   122      !
   123      use timeset, only: &
   124        & DelTime, &            ! $ \Delta t $
   125        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   126        & TimesetClockStart, TimesetClockStop
   127  
   128      ! ҥȥǡ
   129      ! History data output
   130      !
   131      use gtool_historyauto, only: HistoryAutoPut
   132  
   133      ! ʪ
   134      ! Physical constants settings
   135      !
   136      use constants, only:  &
   137        &                  CpDry    ! $ C_p $ [J kg-1 K-1].
   138                                    ! 絤갵Ǯ.
   139                                    ! Specific heat of air at constant pressure
   140  
   141      ! ľȻեå (Mellor and Yamada, 1974, ٥ 2)
   142      ! Vertical diffusion flux (Mellor and Yamada, 1974, Level 2)
   143      !
   144      use vdiffusion_my1974, only: VDiffusionExpTendency
   145  
   146      ! ʸ ; Declaration statements
   147      !
   148      implicit none
   149  
   150      real(DP), intent(in):: xyz_U (0:imax-1, 1:jmax, 1:kmax)
   151                                ! $ u $ . ®.
   152                                ! Eastward wind
   153      real(DP), intent(in):: xyz_V (0:imax-1, 1:jmax, 1:kmax)
   154                                ! $ v $ . ®.
   155                                ! Northward wind
   156      real(DP), intent(in ):: xyr_Press(0:imax-1, 1:jmax, 0:kmax)
   157                                ! $ p_s $ . ɽ̵.
   158                                ! Surface pressure
   159      real(DP), intent(out):: xyz_DUDt (0:imax-1, 1:jmax, 1:kmax)
   160                                ! $ \DP{u}{t} $ . ®Ѳ.
   161                                ! Eastward wind tendency
   162      real(DP), intent(out):: xyz_DVDt (0:imax-1, 1:jmax, 1:kmax)
   163                                ! $ \DP{v}{t} $ . ®Ѳ.
   164                                ! Northward wind tendency
   165      real(DP), intent(out):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   166                                ! $ \DP{T}{t} $ . Ѳ.
   167                                ! Temperature tendency
   168  
   169      ! ѿ
   170      ! Work variables
   171      !
   172      real(DP) :: xyr_HeatFlux (0:imax-1, 1:jmax, 0:kmax)
   173                                ! Ǯեå.
   174                                ! Heat flux
   175  
   176  !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   177  !!$                              ! Work variables for DO loop in latitude
   178  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   179  !!$                              ! Work variables for DO loop in vertical direction
   180  
   181      ! ¹ʸ ; Executable statement
   182      !
   183  
   184      ! 
   185      ! Initialization
   186      !
   187      if ( .not. sl09_diffusion_inited ) then
   188        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   189      end if
   190  
   191      ! ׻ַ¬
   192      ! Start measurement of computation time
   193      !
   194      call TimesetClockStart( module_name )
   195  
   196      ! ® $ u $ ® $ v $ إ쥤꡼໤Ŭ
   197      ! Apply Rayleigh damping to eastward wind $ u $ and northward wind $ v $
   198      !
   199      xyz_DUDt = - xyz_kv * xyz_U
     .        if (xyz_kv.DSC.U2 - xyz_kv.DSC.L2 + 1 .gt. 0) then                
     .           J1 = and(xyz_kv.DSC.U2 - xyz_kv.DSC.L2 + 1,1)                  
     .  !CDIR    NODEP                                                          
     .           do t164 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t166 = 1, xyz_kv.DSC.U1 - xyz_kv.DSC.L1 + 1              
     .                 xyz_dudt(t166-1,t164,t162+1) = -xyz_kv(xyz_kv.DSC.L1+t166
     .       1            -1,t164-1+xyz_kv.DSC.L2,t162+xyz_kv.DSC.L3)*xyz_u(t166
     .       2            -1,t164,t162+1)                                       
     .                 xyz_dvdt(t166-1,t164,t162+1) = -xyz_kv(xyz_kv.DSC.L1+t166
     .       1            -1,t164-1+xyz_kv.DSC.L2,t162+xyz_kv.DSC.L3)*xyz_v(t166
     .       2            -1,t164,t162+1)                                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t164 = J1 + 1, xyz_kv.DSC.U2 - xyz_kv.DSC.L2 + 1, 2         
     .  !CDIR       NODEP                                                       
     .              do t166 = 1, xyz_kv.DSC.U1 - xyz_kv.DSC.L1 + 1              
     .                 xyz_dudt(t166-1,t164,t162+1) = -xyz_kv(xyz_kv.DSC.L1+t166
     .       1            -1,t164-1+xyz_kv.DSC.L2,t162+xyz_kv.DSC.L3)*xyz_u(t166
     .       2            -1,t164,t162+1)                                       
     .                 xyz_dudt(t166-1,t164+1,t162+1) = -xyz_kv(xyz_kv.DSC.L1+  
     .       1            t166-1,t164+xyz_kv.DSC.L2,t162+xyz_kv.DSC.L3)*xyz_u(  
     .       2            t166-1,t164+1,t162+1)                                 
     .                 xyz_dvdt(t166-1,t164,t162+1) = -xyz_kv(xyz_kv.DSC.L1+t166
     .       1            -1,t164-1+xyz_kv.DSC.L2,t162+xyz_kv.DSC.L3)*xyz_v(t166
     .       2            -1,t164,t162+1)                                       
     .                 xyz_dvdt(t166-1,t164+1,t162+1) = -xyz_kv(xyz_kv.DSC.L1+  
     .       1            t166-1,t164+xyz_kv.DSC.L2,t162+xyz_kv.DSC.L3)*xyz_v(  
     .       2            t166-1,t164+1,t162+1)                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   200      xyz_DVDt = - xyz_kv * xyz_V
   201  
   202  
   203      ! Set heat flux at the lower boundary
   204      !
   205      xyr_HeatFlux(:,:,0     ) = LBHeatFlux
     .        if (xyr_heatflux.DSC.U2 .gt. 0) then                              
     .           J2 = and(xyr_heatflux.DSC.U2,3)                                
     .  !CDIR    NODEP                                                          
     .           do t186 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t188 = 1, xyr_heatflux.DSC.U1 + 1                        
     .                 xyr_heatflux(t188-1,t186,0) = lbheatflux                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t186 = J2 + 1, xyr_heatflux.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t188 = 1, xyr_heatflux.DSC.U1 + 1                        
     .                 xyr_heatflux(t188-1,t186,0) = lbheatflux                 
     .                 xyr_heatflux(t188-1,t186+1,0) = lbheatflux               
     .                 xyr_heatflux(t188-1,t186+2,0) = lbheatflux               
     .                 xyr_heatflux(t188-1,t186+3,0) = lbheatflux               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   206      xyr_HeatFlux(:,:,1:kmax) = 0.0_DP
     .        if (xyr_heatflux.DSC.U2 .gt. 0) then                              
     .           J3 = and(xyr_heatflux.DSC.U2,3)                                
     .  !CDIR    NODEP                                                          
     .           do t194 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t196 = 1, xyr_heatflux.DSC.U1 + 1                        
     .                 xyr_heatflux(t196-1,t194,t192+1) =                       
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t194 = J3 + 1, xyr_heatflux.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t196 = 1, xyr_heatflux.DSC.U1 + 1                        
     .                 xyr_heatflux(t196-1,t194,t192+1) =                       
     .       1            0.0000000000000000e+000                               
     .                 xyr_heatflux(t196-1,t194+1,t192+1) =                     
     .       1            0.0000000000000000e+000                               
     .                 xyr_heatflux(t196-1,t194+2,t192+1) =                     
     .       1            0.0000000000000000e+000                               
     .                 xyr_heatflux(t196-1,t194+3,t192+1) =                     
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   207  
   208      ! ѲΨη׻Ԥޤ.
   209      ! Calculate tendencies.
   210      !
   211      call VDiffusionExpTendency(       &
   212        & xyr_Press,                    & ! (in )
   213        & xyr_HeatFlux = xyr_HeatFlux,  & ! (in ) optional
   214        & xyz_DTempDt = xyz_DTempDt     & ! (out) optional
   215        & )
   216  
   217      !
   218      ! Add heating due to MHD drag dissipation
   219      !
   220      xyz_DTempDt = xyz_DTempDt &
     .        if (xyz_dtempdt.DSC.U2 .gt. 0) then                               
     .           J4 = and(xyz_dtempdt.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t203 = 1, J4                                                
     .              D1 = 1.D0/cpdry                                             
     .  !CDIR       NODEP                                                       
     .              do t205 = 1, xyz_dtempdt.DSC.U1 + 1                         
     .                 xyz_dtempdt(t205-1,t203,t201+1) = xyz_dtempdt(t205-1,t203
     .       1            ,t201+1) - (xyz_dudt(t205-1,t203,t201+1)*xyz_u(t205-1,
     .       2            t203,t201+1)+xyz_dvdt(t205-1,t203,t201+1)*xyz_v(t205-1
     .       3            ,t203,t201+1))*D1                                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t203 = J4 + 1, xyz_dtempdt.DSC.U2, 4                        
     .              D2 = 1.D0/cpdry                                             
     .              D3 = 1.D0/cpdry                                             
     .              D4 = 1.D0/cpdry                                             
     .              D5 = 1.D0/cpdry                                             
     .  !CDIR       NODEP                                                       
     .              do t205 = 1, xyz_dtempdt.DSC.U1 + 1                         
     .                 xyz_dtempdt(t205-1,t203,t201+1) = xyz_dtempdt(t205-1,t203
     .       1            ,t201+1) - (xyz_dudt(t205-1,t203,t201+1)*xyz_u(t205-1,
     .       2            t203,t201+1)+xyz_dvdt(t205-1,t203,t201+1)*xyz_v(t205-1
     .       3            ,t203,t201+1))*D2                                     
     .                 xyz_dtempdt(t205-1,t203+1,t201+1) = xyz_dtempdt(t205-1,  
     .       1            t203+1,t201+1) - (xyz_dudt(t205-1,t203+1,t201+1)*xyz_u
     .       2            (t205-1,t203+1,t201+1)+xyz_dvdt(t205-1,t203+1,t201+1)*
     .       3            xyz_v(t205-1,t203+1,t201+1))*D3                       
     .                 xyz_dtempdt(t205-1,t203+2,t201+1) = xyz_dtempdt(t205-1,  
     .       1            t203+2,t201+1) - (xyz_dudt(t205-1,t203+2,t201+1)*xyz_u
     .       2            (t205-1,t203+2,t201+1)+xyz_dvdt(t205-1,t203+2,t201+1)*
     .       3            xyz_v(t205-1,t203+2,t201+1))*D4                       
     .                 xyz_dtempdt(t205-1,t203+3,t201+1) = xyz_dtempdt(t205-1,  
     .       1            t203+3,t201+1) - (xyz_dudt(t205-1,t203+3,t201+1)*xyz_u
     .       2            (t205-1,t203+3,t201+1)+xyz_dvdt(t205-1,t203+3,t201+1)*
     .       3            xyz_v(t205-1,t203+3,t201+1))*D5                       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   221        & - ( xyz_DUDt * xyz_U + xyz_DVDt * xyz_V ) / CpDry
   222  
   223  
   224      ! ҥȥǡ
   225      ! History data output
   226      !
   227      call HistoryAutoPut( TimeN, 'DUDtVDiffSL09',    xyz_DUDt    )
   228      call HistoryAutoPut( TimeN, 'DVDtVDiffSL09',    xyz_DVDt    )
   229      call HistoryAutoPut( TimeN, 'DTempDtVDiffSL09', xyz_DTempDt )
   230  
   231  
   232      ! ׻ַ¬
   233      ! Pause measurement of computation time
   234      !
   235      call TimesetClockStop( module_name )
   236  
   237    end subroutine SL09Diffusion
   238  
   239    !-------------------------------------------------------------------
   240  
   241    subroutine SL09DiffusionInit
   242      !
   243      ! sl09_diffusion ⥸塼νԤޤ.
   244      ! NAMELIST#sl09_diffusion_nml ɤ߹ߤϤμ³ǹԤޤ.
   245      !
   246      ! "sl09_diffusion" module is initialized.
   247      ! "NAMELIST#sl09_diffusion_nml" is loaded in this procedure.
   248      !
   249  
   250      ! ⥸塼 ; USE statements
   251      !
   252  
   253      ! ʪ
   254      ! Physical and mathematical constants settings
   255      !
   256      use constants0, only: &
   257        & PI
   258                                ! $ \pi $ .
   259                                ! ߼Ψ.  Circular constant
   260  
   261      ! ʪ
   262      ! Physical constants settings
   263      !
   264      use constants, only: &
   265        & GasRDry, &
   266                                ! $ R $ [J kg-1 K-1].
   267                                ! 絤ε.
   268                                ! Gas constant of air
   269        & CpDry
   270                                ! $ C_p $ [J kg-1 K-1].
   271                                ! 絤갵Ǯ.
   272                                ! Specific heat of air at constant pressure
   273  
   274      ! ɸǡ
   275      ! Axes data settings
   276      !
   277      use axesset, only: &
   278        & y_Lat, &              ! $ \varphi $ [rad.] . . Latitude
   279        & z_Sigma               ! $ \sigma $ ٥ ().
   280                                ! Full $ \sigma $ level
   281  
   282      ! NAMELIST եϤ˴ؤ桼ƥƥ
   283      ! Utilities for NAMELIST file input
   284      !
   285      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   286  
   287      ! ե
   288      ! File I/O support
   289      !
   290      use dc_iounit, only: FileOpen
   291  
   292      ! ̷ѥ᥿
   293      ! Kind type parameter
   294      !
   295      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   296  
   297      ! ʸ
   298      ! Character handling
   299      !
   300      use dc_string, only: StoA
   301  
   302      ! ҥȥǡ
   303      ! History data output
   304      !
   305      use gtool_historyauto, only: HistoryAutoAddVariable
   306  
   307      ! ʸ ; Declaration statements
   308      !
   309      implicit none
   310  
   311      real(DP), parameter :: day_seconds = 86400.0_DP
   312                                ! 1 ÿ.
   313                                ! Seconds in day.
   314      real(DP):: SigmaB         ! $ \sigma_b $ .
   315      real(DP):: kf             ! $ k_f $ .
   316  
   317      real(DP):: kfTimeScaleInDay
   318      real(DP):: FrictionLBLat
   319  
   320      integer:: j               ! ˲ DO 롼Ѻѿ
   321                                ! Work variables for DO loop in latitude
   322      integer:: k               ! ľ˲ DO 롼Ѻѿ
   323                                ! Work variables for DO loop in vertical direction
   324  
   325      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   326                                ! Unit number for NAMELIST file open
   327      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   328                                ! IOSTAT of NAMELIST read
   329  
   330      ! NAMELIST ѿ
   331      ! NAMELIST group name
   332      !
   333      namelist /sl09_diffusion_nml/ &
   334        & SigmaB, &
   335        & kfTimeScaleInDay, &
   336        & FrictionLBLat, &
   337        & LBHeatFlux
   338            !
   339            ! ǥեͤˤĤƤϽ³ "sl09_diffusion#SL09DiffusionInit"
   340            ! Υɤ򻲾ȤΤ.
   341            !
   342            ! Refer to source codes in the initialization procedure
   343            ! "sl09_diffusion#SL09DiffusionInit" for the default values.
   344            !
   345  
   346      ! ¹ʸ ; Executable statement
   347      !
   348  
   349      if ( sl09_diffusion_inited ) return
   350  
   351      ! ǥեͤ
   352      ! Default values settings
   353      !
   354      SigmaB           =  0.8_DP
   355      kfTimeScaleInDay = 20.0_DP
   356      FrictionLBLat    = 16.3_DP
   357      LBHeatFlux       =  5.7_DP
   358  
   359  
   360      ! NAMELIST ɤ߹
   361      ! NAMELIST is input
   362      !
   363      if ( trim(namelist_filename) /= '' ) then
   364        call FileOpen( unit_nml, &          ! (out)
   365          & namelist_filename, mode = 'r' ) ! (in)
   366  
   367        rewind( unit_nml )
   368        read( unit_nml, &                       ! (in)
   369          & nml = sl09_diffusion_nml, &         ! (out)
   370          & iostat = iostat_nml )               ! (out)
   371        close( unit_nml )
   372  
   373        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   374  !!$      if ( iostat_nml == 0 ) write( STDOUT, nml = held_suarez_1994_nml )
   375      end if
   376  
   377      ! 
   378      ! Configure coefficients
   379      !
   380      kf     = 1.0_DP / ( kfTimeScaleInDay * day_seconds )
   381  
   382      allocate( xyz_kv (0:imax-1, 1:jmax, 1:kmax) )
   383      do k = 1, kmax
   384        do j = 1, jmax
   385          if ( abs( y_Lat(j) ) * 180.0_DP / PI <= FrictionLBLat ) then
   386            xyz_kv(:,j,k) = 0.0_DP
     .  !CDIR NODEP                                                             
     .        do t210 = 1, t0 - t1 + 1                                          
     .           xyz_kv(t1+t210-1,j,k) = 0.0000000000000000e+000                
     .        end do                                                            
     .        go to 10008                                                       
   387          else
   388            xyz_kv(:,j,k) = kf &
     .  !CDIR NODEP                                                             
     .        do t207 = 1, t0 - t1 + 1                                          
     .           xyz_kv(t1+t207-1,j,k) = kf*max(0.0000000000000000e+000,(z_sigma
     .       1      (k)-sigmab)/(1.00000000000000e+000-sigmab))                 
     .        end do                                                            
   389              & * max( 0.0_DP, ( z_Sigma(k) - SigmaB ) / ( 1.0_DP - SigmaB ) )
   390          end if
   391        end do
   392      end do
   393  
   394  
   395      ! ҥȥǡϤΤΤؤѿϿ
   396      ! Register of variables for history data output
   397      !
   398      call HistoryAutoAddVariable( 'DUDtVDiffSL09', &
   399        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   400        & 'eastward wind tendency', 'm s-2' )
   401      call HistoryAutoAddVariable( 'DVDtVDiffSL09', &
   402        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   403        & 'northward wind tendency', 'm s-2' )
   404      call HistoryAutoAddVariable( 'DTempDtVDiffSL09', &
   405        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   406        & 'temperature tendency', 'K s-1' )
   407  
   408      !  ; Print
   409      !
   410      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   411      call MessageNotify( 'M', module_name, 'SigmaB           = %f', d = (/ SigmaB /) )
   412      call MessageNotify( 'M', module_name, 'kfTimeScaleInDay = %f', d = (/ kfTimeScaleInDay /) )
   413      call MessageNotify( 'M', module_name, 'FrictionLBLat    = %f', d = (/ FrictionLBLat /) )
   414      call MessageNotify( 'M', module_name, 'LBHeatFlux       = %f', d = (/ LBHeatFlux /) )
   415      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   416  
   417      sl09_diffusion_inited = .true.
   418    end subroutine SL09DiffusionInit
   419  
   420    !-------------------------------------------------------------------
   421  
   422  end module sl09_diffusion
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:20 2012
FILE NAME: sl09_diffusion.f90
PROGRAM NAME: sl09_diffusion
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Schneider and Liu (2009) ˤľ
     2:            !
     3:            != Vertical diffusion by Schneider and Liu (2009)
     4:            !
     5:            ! Authors::   Yoshiyuki O. TAKAHASHI
     6:            ! Version::   $Id: sl09_diffusion.f90,v 1.3 2012-09-17 10:59:30 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module sl09_diffusion
    13:              !
    14:              != Schneider and Liu (2009) ˤľ
    15:              !
    16:              != Vertical diffusion by Schneider and Liu (2009)
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !
    21:              !== Procedures List
    22:              ! 
    23:            !!$  ! Hs94Forcing   :: Ȼη׻
    24:            !!$  ! Hs94Finalize  :: λ (⥸塼ѿγդ)
    25:            !!$  ! ------------  :: ------------
    26:            !!$  ! Hs94Forcing   :: Calculate forcing and dissipation
    27:            !!$  ! Hs94Finalize  :: Termination (deallocate variables in this module)
    28:              !
    29:              !--
    30:              !== NAMELIST
    31:              !
    32:              ! NAMELIST#sl09_diffusion_nml
    33:              !++
    34:              !== References
    35:              !
    36:              !  Schneider, T. and J. Liu, 
    37:              !    Formation of jets and equatorial superrotation on Jupiter, 
    38:              !    J. Atmos. Sci., 69, 579, 2009.
    39:              !
    40:            
    41:              ! ⥸塼 ; USE statements
    42:              !
    43:            
    44:              ! ʻ
    45:              ! Grid points settings
    46:              !
    47:              use gridset, only: imax, & ! ٳʻ. 
    48:                                         ! Number of grid points in longitude
    49:                &                jmax, & ! ٳʻ. 
    50:                                         ! Number of grid points in latitude
    51:                &                kmax    ! ľؿ. 
    52:                                         ! Number of vertical level
    53:            
    54:              ! ̷ѥ᥿
    55:              ! Kind type parameter
    56:              !
    57:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    58:                &                 STRING     ! ʸ.       Strings. 
    59:            
    60:            
    61:              ! å
    62:              ! Message output
    63:              !
    64:              use dc_message, only: MessageNotify
    65:            
    66:              ! ʸ ; Declaration statements
    67:              !
    68:              implicit none
    69:              private
    70:            
    71:              ! ³
    72:              ! Public procedure
    73:              !
    74:              public:: SL09Diffusion
    75:            
    76:              ! ѿ
    77:              ! Public variables
    78:              !
    79:              logical, save, public:: sl09_diffusion_inited = .false.
    80:                                          ! ե饰. 
    81:                                          ! Initialization flag
    82:            
    83:              ! ѿ
    84:              ! Private variables
    85:              !
    86:              real(DP), save, allocatable :: xyz_kv (:,:,:)
    87:                                          ! $ k_v $ .
    88:              real(DP), save              :: LBHeatFlux
    89:            
    90:              character(*), parameter:: module_name = 'sl09_diffusion'
    91:                                          ! ⥸塼̾. 
    92:                                          ! Module name
    93:              character(*), parameter:: version = &
    94:                & '$Name: dcpam5-20120921 $' // &
    95:                & '$Id: sl09_diffusion.f90,v 1.3 2012-09-17 10:59:30 yot Exp $'
    96:                                          ! ⥸塼ΥС
    97:                                          ! Module version
    98:            
    99:            contains
   100:            
   101:              subroutine SL09Diffusion(      &
   102:                & xyz_U, xyz_V, xyr_Press,         & ! (in)
   103:                & xyz_DUDt, xyz_DVDt, xyz_DTempDt  & ! (out)
   104:                & )
   105:                !
   106:                !
   107:                !
   108:            
   109:                ! ⥸塼 ; USE statements
   110:                !
   111:            
   112:                ! ɸǡ
   113:                ! Axes data settings
   114:                !
   115:                use axesset, only: &
   116:                  & y_Lat, &              ! $ \varphi $ [rad.] . . Latitude
   117:                  & z_Sigma               ! $ \sigma $ ٥ (). 
   118:                                          ! Full $ \sigma $ level
   119:            
   120:                ! 
   121:                ! Time control
   122:                !
   123:                use timeset, only: &
   124:                  & DelTime, &            ! $ \Delta t $
   125:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   126:                  & TimesetClockStart, TimesetClockStop
   127:            
   128:                ! ҥȥǡ
   129:                ! History data output
   130:                !
   131:                use gtool_historyauto, only: HistoryAutoPut
   132:            
   133:                ! ʪ
   134:                ! Physical constants settings
   135:                !
   136:                use constants, only:  &
   137:                  &                  CpDry    ! $ C_p $ [J kg-1 K-1].
   138:                                              ! 絤갵Ǯ.
   139:                                              ! Specific heat of air at constant pressure
   140:            
   141:                ! ľȻեå (Mellor and Yamada, 1974, ٥ 2)
   142:                ! Vertical diffusion flux (Mellor and Yamada, 1974, Level 2)
   143:                !
   144:                use vdiffusion_my1974, only: VDiffusionExpTendency
   145:            
   146:                ! ʸ ; Declaration statements
   147:                !
   148:                implicit none
   149:            
   150:                real(DP), intent(in):: xyz_U (0:imax-1, 1:jmax, 1:kmax)
   151:                                          ! $ u $ . ®. 
   152:                                          ! Eastward wind
   153:                real(DP), intent(in):: xyz_V (0:imax-1, 1:jmax, 1:kmax)
   154:                                          ! $ v $ . ®. 
   155:                                          ! Northward wind
   156:                real(DP), intent(in ):: xyr_Press(0:imax-1, 1:jmax, 0:kmax)
   157:                                          ! $ p_s $ . ɽ̵. 
   158:                                          ! Surface pressure
   159:                real(DP), intent(out):: xyz_DUDt (0:imax-1, 1:jmax, 1:kmax)
   160:                                          ! $ \DP{u}{t} $ . ®Ѳ. 
   161:                                          ! Eastward wind tendency
   162:                real(DP), intent(out):: xyz_DVDt (0:imax-1, 1:jmax, 1:kmax)
   163:                                          ! $ \DP{v}{t} $ . ®Ѳ. 
   164:                                          ! Northward wind tendency
   165:                real(DP), intent(out):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   166:                                          ! $ \DP{T}{t} $ . Ѳ. 
   167:                                          ! Temperature tendency
   168:            
   169:                ! ѿ
   170:                ! Work variables
   171:                !
   172:                real(DP) :: xyr_HeatFlux (0:imax-1, 1:jmax, 0:kmax)
   173:                                          ! Ǯեå. 
   174:                                          ! Heat flux
   175:            
   176:            !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   177:            !!$                              ! Work variables for DO loop in latitude
   178:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   179:            !!$                              ! Work variables for DO loop in vertical direction
   180:            
   181:                ! ¹ʸ ; Executable statement
   182:                !
   183:            
   184:                ! 
   185:                ! Initialization
   186:                !
   187:                if ( .not. sl09_diffusion_inited ) then
   188:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   189:                end if
   190:            
   191:                ! ׻ַ¬
   192:                ! Start measurement of computation time
   193:                !
   194:                call TimesetClockStart( module_name )
   195:            
   196:                ! ® $ u $ ® $ v $ إ쥤꡼໤Ŭ
   197:                ! Apply Rayleigh damping to eastward wind $ u $ and northward wind $ v $
   198:                !
   199: **V---->       xyz_DUDt = - xyz_kv * xyz_U
   200: **V----        xyz_DVDt = - xyz_kv * xyz_V
   201:            
   202:            
   203:                ! Set heat flux at the lower boundary
   204:                !
   205: +V=====        xyr_HeatFlux(:,:,0     ) = LBHeatFlux
   206: ++V====        xyr_HeatFlux(:,:,1:kmax) = 0.0_DP
   207:            
   208:                ! ѲΨη׻Ԥޤ.
   209:                ! Calculate tendencies.
   210:                !
   211:                call VDiffusionExpTendency(       &
   212:                  & xyr_Press,                    & ! (in )
   213:                  & xyr_HeatFlux = xyr_HeatFlux,  & ! (in ) optional
   214:                  & xyz_DTempDt = xyz_DTempDt     & ! (out) optional
   215:                  & )
   216:            
   217:                !
   218:                ! Add heating due to MHD drag dissipation
   219:                !
   220: ++V====        xyz_DTempDt = xyz_DTempDt &
   221:                  & - ( xyz_DUDt * xyz_U + xyz_DVDt * xyz_V ) / CpDry
   222:            
   223:            
   224:                ! ҥȥǡ
   225:                ! History data output
   226:                !
   227:                call HistoryAutoPut( TimeN, 'DUDtVDiffSL09',    xyz_DUDt    )
   228:                call HistoryAutoPut( TimeN, 'DVDtVDiffSL09',    xyz_DVDt    )
   229:                call HistoryAutoPut( TimeN, 'DTempDtVDiffSL09', xyz_DTempDt )
   230:            
   231:            
   232:                ! ׻ַ¬
   233:                ! Pause measurement of computation time
   234:                !
   235:                call TimesetClockStop( module_name )
   236:            
   237:              end subroutine SL09Diffusion
   238:            
   239:              !-------------------------------------------------------------------
   240:            
   241:              subroutine SL09DiffusionInit
   242:                !
   243:                ! sl09_diffusion ⥸塼νԤޤ. 
   244:                ! NAMELIST#sl09_diffusion_nml ɤ߹ߤϤμ³ǹԤޤ. 
   245:                !
   246:                ! "sl09_diffusion" module is initialized. 
   247:                ! "NAMELIST#sl09_diffusion_nml" is loaded in this procedure. 
   248:                !
   249:            
   250:                ! ⥸塼 ; USE statements
   251:                !
   252:            
   253:                ! ʪ
   254:                ! Physical and mathematical constants settings
   255:                !
   256:                use constants0, only: &
   257:                  & PI
   258:                                          ! $ \pi $ .
   259:                                          ! ߼Ψ.  Circular constant
   260:            
   261:                ! ʪ
   262:                ! Physical constants settings
   263:                !
   264:                use constants, only: &
   265:                  & GasRDry, &
   266:                                          ! $ R $ [J kg-1 K-1]. 
   267:                                          ! 絤ε. 
   268:                                          ! Gas constant of air
   269:                  & CpDry
   270:                                          ! $ C_p $ [J kg-1 K-1]. 
   271:                                          ! 絤갵Ǯ. 
   272:                                          ! Specific heat of air at constant pressure
   273:            
   274:                ! ɸǡ
   275:                ! Axes data settings
   276:                !
   277:                use axesset, only: &
   278:                  & y_Lat, &              ! $ \varphi $ [rad.] . . Latitude
   279:                  & z_Sigma               ! $ \sigma $ ٥ (). 
   280:                                          ! Full $ \sigma $ level
   281:            
   282:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   283:                ! Utilities for NAMELIST file input
   284:                !
   285:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   286:            
   287:                ! ե
   288:                ! File I/O support
   289:                !
   290:                use dc_iounit, only: FileOpen
   291:            
   292:                ! ̷ѥ᥿
   293:                ! Kind type parameter
   294:                !
   295:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   296:            
   297:                ! ʸ
   298:                ! Character handling
   299:                !
   300:                use dc_string, only: StoA
   301:            
   302:                ! ҥȥǡ
   303:                ! History data output
   304:                !
   305:                use gtool_historyauto, only: HistoryAutoAddVariable
   306:            
   307:                ! ʸ ; Declaration statements
   308:                !
   309:                implicit none
   310:            
   311:                real(DP), parameter :: day_seconds = 86400.0_DP
   312:                                          ! 1 ÿ. 
   313:                                          ! Seconds in day. 
   314:                real(DP):: SigmaB         ! $ \sigma_b $ .
   315:                real(DP):: kf             ! $ k_f $ .
   316:            
   317:                real(DP):: kfTimeScaleInDay
   318:                real(DP):: FrictionLBLat
   319:            
   320:                integer:: j               ! ˲ DO 롼Ѻѿ
   321:                                          ! Work variables for DO loop in latitude
   322:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   323:                                          ! Work variables for DO loop in vertical direction
   324:            
   325:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   326:                                          ! Unit number for NAMELIST file open
   327:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   328:                                          ! IOSTAT of NAMELIST read
   329:            
   330:                ! NAMELIST ѿ
   331:                ! NAMELIST group name
   332:                !
   333:                namelist /sl09_diffusion_nml/ &
   334:                  & SigmaB, &
   335:                  & kfTimeScaleInDay, &
   336:                  & FrictionLBLat, &
   337:                  & LBHeatFlux
   338:                      !
   339:                      ! ǥեͤˤĤƤϽ³ "sl09_diffusion#SL09DiffusionInit" 
   340:                      ! Υɤ򻲾ȤΤ. 
   341:                      !
   342:                      ! Refer to source codes in the initialization procedure
   343:                      ! "sl09_diffusion#SL09DiffusionInit" for the default values. 
   344:                      !
   345:            
   346:                ! ¹ʸ ; Executable statement
   347:                !
   348:            
   349:                if ( sl09_diffusion_inited ) return
   350:            
   351:                ! ǥեͤ
   352:                ! Default values settings
   353:                !
   354:                SigmaB           =  0.8_DP
   355:                kfTimeScaleInDay = 20.0_DP
   356:                FrictionLBLat    = 16.3_DP
   357:                LBHeatFlux       =  5.7_DP
   358:            
   359:            
   360:                ! NAMELIST ɤ߹
   361:                ! NAMELIST is input
   362:                !
   363:                if ( trim(namelist_filename) /= '' ) then
   364:                  call FileOpen( unit_nml, &          ! (out)
   365:                    & namelist_filename, mode = 'r' ) ! (in)
   366:            
   367:                  rewind( unit_nml )
   368:                  read( unit_nml, &                       ! (in)
   369:                    & nml = sl09_diffusion_nml, &         ! (out)
   370:                    & iostat = iostat_nml )               ! (out)
   371:                  close( unit_nml )
   372:            
   373:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   374:            !!$      if ( iostat_nml == 0 ) write( STDOUT, nml = held_suarez_1994_nml )
   375:                end if
   376:            
   377:                ! 
   378:                ! Configure coefficients
   379:                !
   380:                kf     = 1.0_DP / ( kfTimeScaleInDay * day_seconds )
   381:            
   382:                allocate( xyz_kv (0:imax-1, 1:jmax, 1:kmax) )
   383: +------>       do k = 1, kmax
   384: |+----->         do j = 1, jmax
   385: ||                 if ( abs( y_Lat(j) ) * 180.0_DP / PI <= FrictionLBLat ) then
   386: ||V====              xyz_kv(:,j,k) = 0.0_DP
   387: ||                 else
   388: ||V====              xyz_kv(:,j,k) = kf &
   389: ||                     & * max( 0.0_DP, ( z_Sigma(k) - SigmaB ) / ( 1.0_DP - SigmaB ) )
   390: ||                 end if
   391: |+-----          end do
   392: +------        end do
   393:            
   394:            
   395:                ! ҥȥǡϤΤΤؤѿϿ
   396:                ! Register of variables for history data output
   397:                !
   398:                call HistoryAutoAddVariable( 'DUDtVDiffSL09', &
   399:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   400:                  & 'eastward wind tendency', 'm s-2' )
   401:                call HistoryAutoAddVariable( 'DVDtVDiffSL09', &
   402:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   403:                  & 'northward wind tendency', 'm s-2' )
   404:                call HistoryAutoAddVariable( 'DTempDtVDiffSL09', &
   405:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   406:                  & 'temperature tendency', 'K s-1' )
   407:            
   408:                !  ; Print
   409:                !
   410:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   411:                call MessageNotify( 'M', module_name, 'SigmaB           = %f', d = (/ SigmaB /) )
   412:                call MessageNotify( 'M', module_name, 'kfTimeScaleInDay = %f', d = (/ kfTimeScaleInDay /) )
   413:                call MessageNotify( 'M', module_name, 'FrictionLBLat    = %f', d = (/ FrictionLBLat /) )
   414:                call MessageNotify( 'M', module_name, 'LBHeatFlux       = %f', d = (/ LBHeatFlux /) )
   415:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   416:            
   417:                sl09_diffusion_inited = .true.
   418:              end subroutine SL09DiffusionInit
   419:            
   420:              !-------------------------------------------------------------------
   421:            
   422:            end module sl09_diffusion
