Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:38 2012
FILE NAME: history_file_io.f90
PROGRAM NAME: history_file_io
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   327  vec  (   4): Vectorized array expression.
   329  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:38 2012
FILE NAME: history_file_io.f90
PROGRAM NAME: history_file_io
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ҥȥǡ
     2  !
     3  != History data output
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6  ! Version::   $Id: history_file_io.f90,v 1.15 2012-02-20 08:11:34 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2010. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module history_file_io
    13    !
    14    != ҥȥǡ
    15    !
    16    != History data output
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ҥȥǡϤν, ʹ, Ͽѿɽ
    21    ! λԤޤ.
    22    ! [gtool5 饤֥]{http://www.gfd-dennou.org/library/gtool} 
    23    ! gtool_historyauto ⥸塼Ѥޤ.
    24    !
    25    ! ƥǡνϤ, ǥγƥץˤ,
    26    ! gtool_historyauto ⥸塼뤫󶡤
    27    ! HistoryAutoAddVariable  HistoryAutoPut Ѥޤ.
    28    !
    29  
    30    ! ⥸塼 ; USE statements
    31    !
    32  
    33    ! ʻ
    34    ! Grid points settings
    35    !
    36    use gridset, only:   lmax, & ! ڥȥǡ󥵥
    37                                 ! Size of array for spectral data
    38      &                  imax, & ! ٳʻ.
    39                                 ! Number of grid points in longitude
    40      &                  jmax, & ! ٳʻ.
    41                                 ! Number of grid points in latitude
    42      &                  kmax, & ! ľؿ.
    43                                 ! Number of vertical level
    44      &                kslmax    ! ϲαľؿ.
    45                                 ! Number of subsurface vertical level
    46  
    47    ! ̷ѥ᥿
    48    ! Kind type parameter
    49    !
    50    use dc_types, only: DP, &    ! ټ¿. Double precision.
    51      &                 STRING, &  ! ʸ.       Strings.
    52      &                 TOKEN      ! .   Keywords.
    53  
    54    ! å
    55    ! Message output
    56    !
    57    use dc_message, only: MessageNotify
    58  
    59  
    60    ! ʸ ; Declaration statements
    61    !
    62    implicit none
    63    private
    64  
    65    ! ³
    66    ! Public procedure
    67    !
    68    public:: HistoryFileOpen, HistoryFileClose
    69  
    70    ! ѿ
    71    ! Public variables
    72    !
    73    logical, save, public:: history_file_io_inited = .false.
    74                                ! ե饰.
    75                                ! Initialization flag
    76  
    77    ! ѿ
    78    ! Private variables
    79    !
    80    real(DP),      save:: DefaultIntValue
    81                                ! ҥȥǡνϴֳ֤ο (ǥե).
    82                                ! Numerical value for interval of history data output (default value)
    83    character(12), save:: DefaultIntUnit
    84                                ! ҥȥǡνϴֳ֤ñ (ǥե).
    85                                ! Unit for interval of history data output (default value)
    86    character(STRING):: DefaultFilePrefix
    87                                ! ҥȥǡΥե̾Ƭ (ǥե).
    88                                ! Prefixes of history data filenames (default value)
    89  
    90  !!$  namelist /history_file_io_nml/
    91  
    92    character(*), parameter:: module_name = 'history_file_io'
    93                                ! ⥸塼̾.
    94                                ! Module name
    95    character(*), parameter:: version = &
    96      & '$Name: dcpam5-20120921 $' // &
    97      & '$Id: history_file_io.f90,v 1.15 2012-02-20 08:11:34 yot Exp $'
    98                                ! ⥸塼ΥС
    99                                ! Module version
   100  
   101    ! INTERFACE ʸ ; INTERFACE statements
   102    !
   103    interface HistoryFileOpen
   104      module procedure HistoryFileOpen
   105    end interface
   106  
   107    interface HistoryFileClose
   108      module procedure HistoryFileClose
   109    end interface
   110  
   111  contains
   112  
   113    !-------------------------------------------------------------------
   114  
   115    subroutine HistoryFileOpen
   116      !
   117      ! history_file_io ⥸塼νԤޤ.
   118      !--
   119      ! NAMELIST#history_file_io_nml ɤ߹ߤϤμ³ǹԤޤ.
   120      !++
   121      !
   122      ! "history_file_io" module is initialized.
   123      !--
   124      ! "NAMELIST#history_file_io_nml" is loaded in this procedure.
   125      !++
   126      !
   127  
   128      ! ⥸塼 ; USE statements
   129      !
   130  
   131      ! ϥեδܾ
   132      ! Basic information for output files
   133      !
   134      use fileset, only: &
   135        & FileTitle, &
   136                                ! ϥǡեɽ.
   137                                ! Title of output data files
   138        & FileSource, &
   139                                ! ǡեμ.
   140                                ! Source of data file
   141        & FileInstitution
   142                                ! ǡեǽŪѹȿ/Ŀ.
   143                                ! Institution or person that changes data files for the last time
   144  
   145      ! ʪ
   146      ! Physical and mathematical constants settings
   147      !
   148      use constants0, only: &
   149        & PI                    ! $ \pi $.
   150                                ! ߼Ψ. Circular constant
   151  
   152      ! ɸǡ
   153      ! Axes data settings
   154      !
   155      use axesset, only: &
   156        & x_Lon, &
   157                                ! $ \lambda $ [rad.] . . Longitude
   158        & x_Lon_Weight, &
   159                                ! $ \Delta \lambda $ [rad.] .
   160                                ! ٺɸŤ.
   161                                ! Weight of longitude
   162        & y_Lat, &
   163                                ! $ \varphi $ [rad.] . . Latitude
   164        & y_Lat_Weight, &
   165                                ! $ \Delta \varphi $ [rad.] .
   166                                ! ٺɸŤ.
   167                                ! Weight of latitude
   168        & z_Sigma, &
   169                                ! $ \sigma $ ٥ ().
   170                                ! Full $ \sigma $ level
   171        & r_Sigma, &
   172                                ! $ \sigma $ ٥ (Ⱦ).
   173                                ! Half $ \sigma $ level
   174        & z_DelSigma, &
   175                                ! $ \Delta \sigma $ ().
   176                                ! $ \Delta \sigma $ (Full)
   177        & w_Number, &
   178                                ! ڥȥǡźֹ.
   179                                ! Subscript of spectral data
   180        & r_SSDepth, &
   181                                ! subsurface grid on interface of layer
   182        & z_SSDepth
   183                                ! subsurface grid at midpoint of layer
   184  
   185      ! NAMELIST եϤ˴ؤ桼ƥƥ
   186      ! Utilities for NAMELIST file input
   187      !
   188      use namelist_util, only: namelist_filename, NmlutilMsg
   189  
   190      ! 
   191      ! Time control
   192      !
   193      use timeset, only: &
   194        & RestartTime, &        ! ꥹȳϻ.
   195                                ! Restart time of calculation
   196        & EndTime, &            ! ׻λ.
   197                                ! End time of calculation
   198        & InitialDate, &        ! ׻.
   199                                ! Start date of calculation
   200        & DelTime               ! $ \Delta t $ [s]
   201  
   202      ! gtool4 netCDF ǡϥ󥿡ե (絬ϥǥ)
   203      ! Interface of Input/Output of gtool4 netCDF data (For large models)
   204      !
   205      use gtool_historyauto, only: HistoryAutoCreate, &
   206        & HistoryAutoAddAttr, HistoryAutoAddWeight, HistoryAutoPutAxis, &
   207        & HistoryAutoPutAxisMPI
   208  
   209      ! ե
   210      ! File I/O support
   211      !
   212      use dc_iounit, only: FileOpen
   213  
   214      ! ʸ
   215      ! Character handling
   216      !
   217      use dc_string, only: CPrintf
   218  
   219      ! ̷ѥ᥿
   220      ! Kind type parameter
   221      !
   222      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   223  
   224      ! ʸ ; Declaration statements
   225      !
   226      implicit none
   227  
   228      ! ѿ
   229      ! Work variables
   230      !
   231      logical:: flag_mpi_init
   232  
   233      ! ¹ʸ ; Executable statement
   234      !
   235  
   236      if ( history_file_io_inited ) return
   237      call InitCheck
   238  
   239      ! ǥեͤ
   240      ! Default values settings
   241      !
   242      DefaultIntValue = 1.0
   243      DefaultIntUnit  = 'sec'
   244      DefaultFilePrefix = ''
   245  !!$    DefaultIntValue = 1.0
   246  !!$    DefaultIntUnit  = 'hrs'
   247  !!$    DefaultFilePrefix = 'data01/'
   248  
   249      flag_mpi_init = .false.
   250  
   251      ! HistoryAutoCreate ˤ
   252      ! Initialization by "HistoryAutoCreate"
   253      !
   254      call HistoryAutoCreate( &
   255        &     title = trim(FileTitle) // ' history data', &          ! (in)
   256        &    source = FileSource, institution = FileInstitution, &   ! (in)
   257        &      dims = (/ 'lon ', 'lat ', 'sig ', 'sigm', &
   258        &                'ssz ', 'sszi', &                           ! (in)
   259        &                'wn  ', 'time' /), &                        ! (in)
   260        &  dimsizes = (/ imax, jmax, kmax, kmax + 1, &
   261        &                max(kslmax,1), kslmax+1, &                  ! (in)
   262        &                lmax, 0 /), &                               ! (in)
   263        & longnames = (/ 'longitude                                       ', &
   264        &                'latitude                                        ', &
   265        &                'sigma at layer midpoints                        ', &
   266        &                'sigma at layer interface (half level)           ', &
   267        &                'depth at subsurface layer midpoints             ', &
   268        &                'depth at subsurface layer interface (half level)', &
   269        &                'subscript of spectral data                      ', &
   270        &                'time                                            ' /), & ! (in)
   271        &     units = (/ 'degree_east ', 'degree_north', &
   272        &                '1           ', '1           ', &
   273        &                'm           ', 'm           ', &
   274        &                '1           ', DefaultIntUnit /), &        ! (in)
   275        &     xtypes = (/ 'float', 'float', &
   276        &                 'float', 'float', &
   277        &                 'float', 'float', &
   278        &                 'int  ', 'float' /), &                     ! (in)
   279        &          origin  = RestartTime, &                      ! (in) optional
   280        &         terminus = EndTime + 2. * DelTime, &           ! (in) optional
   281        &         interval = DefaultIntValue, &                  ! (in) optional
   282  !!$      &       start_date = InitialDate, &                      ! (in) optional
   283  !!$      &     slice_start  = (/ 1.0, 1.0, 1.0, 1.0, 1.0 /), & ! (in) optional
   284  !!$      &     slice_end    = (/ 0.0, 0.0, 0.0, 0.0, 0.0 /), & ! (in) optional
   285  !!$      &     slice_stride = (/   1,   1,   1,   1,   1 /), & ! (in) optional
   286  !!$      &    space_average = (/ .false., .false., .false., &
   287  !!$      &                       .false., .false. /), &        ! (in) optional
   288  !!$      & newfile_interval = real( delta_time * 10 ), &       ! (in) optional
   289  
   290  !!$      &  flag_mpi_gather = flag_mpi_init, &                    ! (in) optional
   291        &  flag_mpi_split  = .true., &                           ! (in) optional
   292        &      file_prefix = DefaultFilePrefix, &                ! (in) optional
   293        & namelist_filename = namelist_filename )                ! (in) optional
   294  
   295  
   296      ! ɸǡؤ°
   297      ! Attributes of axes data settings
   298      !
   299      call HistoryAutoAddAttr( &
   300        & varname = 'lon', attrname = 'standard_name', &   ! (in)
   301        & value = 'longitude' )                            ! (in)
   302      call HistoryAutoAddAttr( &
   303        & varname = 'lat', attrname = 'standard_name', &   ! (in)
   304        & value = 'latitude' )                             ! (in)
   305      call HistoryAutoAddAttr( &
   306        & varname = 'sig', attrname = 'standard_name', &   ! (in)
   307        & value = 'atmosphere_sigma_coordinate' )          ! (in)
   308      call HistoryAutoAddAttr( &
   309        & varname = 'sigm', attrname = 'standard_name', &  ! (in)
   310        & value = 'atmosphere_sigma_coordinate' )          ! (in)
   311      call HistoryAutoAddAttr( &
   312        & varname = 'sig', attrname = 'positive', &        ! (in)
   313        & value = 'down' )                                 ! (in)
   314      call HistoryAutoAddAttr( &
   315        & varname = 'sigm', attrname = 'positive', &       ! (in)
   316        & value = 'down' )                                 ! (in)
   317      call HistoryAutoAddAttr( &
   318        & varname = 'ssz', attrname = 'standard_name', &   ! (in)
   319        & value = 'depth' )                                ! (in)
   320      call HistoryAutoAddAttr( &
   321        & varname = 'sszi', attrname = 'standard_name', &  ! (in)
   322        & value = 'depth' )                                ! (in)
   323  
   324      ! ɸǡ
   325      ! Axes data settings
   326      !
   327      call HistoryAutoPutAxis( &
     .        D1 = 1.D0/3.14159265358979e+000                                   
     .  !CDIR NODEP                                                             
     .        do t310 = 1, x_lon.DSC.U1 - x_lon.DSC.L1 + 1                      
     .           %IG8(t310) = x_lon(x_lon.DSC.L1+t310-1)*D1*                    
     .       1      1.80000000000000e+002                                       
     .        end do                                                            
   328        & 'lon',  x_Lon / PI * 180.0_DP )  ! (in)
   329      call HistoryAutoPutAxis( &
     .        D2 = 1.D0/3.14159265358979e+000                                   
     .  !CDIR NODEP                                                             
     .        do t314 = 1, y_lat.DSC.U1 - y_lat.DSC.L1 + 1                      
     .           %IG11(t314) = y_lat(y_lat.DSC.L1+t314-1)*D2*                   
     .       1      1.80000000000000e+002                                       
     .        end do                                                            
   330        & 'lat',  y_Lat / PI * 180.0_DP )  ! (in)
   331      call HistoryAutoPutAxis( &
   332        & 'sig',  z_Sigma )                ! (in)
   333      call HistoryAutoPutAxis( &
   334        & 'sigm', r_Sigma )                ! (in)
   335      if ( kslmax == 0 ) then
   336        call HistoryAutoPutAxis( &
   337          & 'ssz',  r_SSDepth )              ! (in)
   338      else
   339        call HistoryAutoPutAxis( &
   340          & 'ssz',  z_SSDepth )              ! (in)
   341      end if
   342      call HistoryAutoPutAxis( &
   343        & 'sszi', r_SSDepth )              ! (in)
   344      call HistoryAutoPutAxis( &
   345        & 'wn',   w_Number )               ! (in)
   346  
   347      ! ɸŤߤ
   348      ! Axes weights settings
   349      !
   350      call HistoryAutoAddWeight( &
   351        & dim = 'lon', weight = x_Lon_Weight, & ! (in)
   352        & units = 'radian', xtype = 'double' )  ! (in) optional
   353      call HistoryAutoAddWeight( &
   354        & dim = 'lat', weight = y_Lat_Weight, & ! (in)
   355        & units = 'radian', xtype = 'double' )  ! (in) optional
   356      call HistoryAutoAddWeight( &
   357        & dim = 'sig', weight = z_DelSigma, &   ! (in)
   358        & xtype = 'double' )                    ! (in) optional
   359  
   360      !  ; Print
   361      !
   362      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   363      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   364  
   365      history_file_io_inited = .true.
   366    end subroutine HistoryFileOpen
   367  
   368    !-------------------------------------------------------------------
   369  
   370    subroutine HistoryFileClose
   371      !
   372      ! ҥȥǡեϤνλԤޤ.
   373      !
   374      ! Terminate history data files output.
   375  
   376      ! ⥸塼 ; USE statements
   377      !
   378  
   379      ! gtool4 netCDF ǡϥ󥿡ե (絬ϥǥ)
   380      ! Interface of Input/Output of gtool4 netCDF data (For large models)
   381      !
   382      use gtool_historyauto, only: HistoryAutoClose
   383  
   384      ! ʸ ; Declaration statements
   385      !
   386      implicit none
   387  
   388      ! ѿ
   389      ! Work variables
   390      !
   391  
   392      ! ¹ʸ ; Executable statement
   393      !
   394  
   395      call HistoryAutoClose
   396  
   397    end subroutine HistoryFileClose
   398  
   399    !-------------------------------------------------------------------
   400  
   401    subroutine InitCheck
   402      !
   403      ! ¸⥸塼νå
   404      !
   405      ! Check initialization of dependency modules
   406  
   407      ! ⥸塼 ; USE statements
   408      !
   409  
   410      ! NAMELIST եϤ˴ؤ桼ƥƥ
   411      ! Utilities for NAMELIST file input
   412      !
   413      use namelist_util, only: namelist_util_inited
   414  
   415      ! ϥեδܾ
   416      ! Management basic information for output files
   417      !
   418      use fileset, only: fileset_inited
   419  
   420      ! ʻ
   421      ! Grid points settings
   422      !
   423      use gridset, only: gridset_inited
   424  
   425      ! ɸǡ
   426      ! Axes data settings
   427      !
   428      use axesset, only: axesset_inited
   429  
   430      ! 
   431      ! Time control
   432      !
   433      use timeset, only: timeset_inited
   434  
   435      ! ¹ʸ ; Executable statement
   436      !
   437  
   438      if ( .not. namelist_util_inited ) &
   439        & call MessageNotify( 'E', module_name, '"namelist_util" module is not initialized.' )
   440  
   441      if ( .not. fileset_inited ) &
   442        & call MessageNotify( 'E', module_name, '"fileset" module is not initialized.' )
   443  
   444      if ( .not. gridset_inited ) &
   445        & call MessageNotify( 'E', module_name, '"gridset" module is not initialized.' )
   446  
   447      if ( .not. axesset_inited ) &
   448        & call MessageNotify( 'E', module_name, '"axesset" module is not initialized.' )
   449  
   450      if ( .not. timeset_inited ) &
   451        & call MessageNotify( 'E', module_name, '"timeset" module is not initialized.' )
   452  
   453    end subroutine InitCheck
   454  
   455  end module history_file_io
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:38 2012
FILE NAME: history_file_io.f90
PROGRAM NAME: history_file_io
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ҥȥǡ
     2:            !
     3:            != History data output
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6:            ! Version::   $Id: history_file_io.f90,v 1.15 2012-02-20 08:11:34 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2010. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module history_file_io
    13:              !
    14:              != ҥȥǡ
    15:              !
    16:              != History data output
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ҥȥǡϤν, ʹ, Ͽѿɽ
    21:              ! λԤޤ. 
    22:              ! [gtool5 饤֥]{http://www.gfd-dennou.org/library/gtool}  
    23:              ! gtool_historyauto ⥸塼Ѥޤ. 
    24:              ! 
    25:              ! ƥǡνϤ, ǥγƥץˤ, 
    26:              ! gtool_historyauto ⥸塼뤫󶡤
    27:              ! HistoryAutoAddVariable  HistoryAutoPut Ѥޤ. 
    28:              !
    29:            
    30:              ! ⥸塼 ; USE statements
    31:              !
    32:            
    33:              ! ʻ
    34:              ! Grid points settings
    35:              !
    36:              use gridset, only:   lmax, & ! ڥȥǡ󥵥
    37:                                           ! Size of array for spectral data
    38:                &                  imax, & ! ٳʻ. 
    39:                                           ! Number of grid points in longitude
    40:                &                  jmax, & ! ٳʻ. 
    41:                                           ! Number of grid points in latitude
    42:                &                  kmax, & ! ľؿ. 
    43:                                           ! Number of vertical level
    44:                &                kslmax    ! ϲαľؿ. 
    45:                                           ! Number of subsurface vertical level
    46:            
    47:              ! ̷ѥ᥿
    48:              ! Kind type parameter
    49:              !
    50:              use dc_types, only: DP, &    ! ټ¿. Double precision. 
    51:                &                 STRING, &  ! ʸ.       Strings. 
    52:                &                 TOKEN      ! .   Keywords. 
    53:            
    54:              ! å
    55:              ! Message output
    56:              !
    57:              use dc_message, only: MessageNotify
    58:            
    59:            
    60:              ! ʸ ; Declaration statements
    61:              !
    62:              implicit none
    63:              private
    64:            
    65:              ! ³
    66:              ! Public procedure
    67:              !
    68:              public:: HistoryFileOpen, HistoryFileClose
    69:            
    70:              ! ѿ
    71:              ! Public variables
    72:              !
    73:              logical, save, public:: history_file_io_inited = .false.
    74:                                          ! ե饰. 
    75:                                          ! Initialization flag
    76:            
    77:              ! ѿ
    78:              ! Private variables
    79:              !
    80:              real(DP),      save:: DefaultIntValue
    81:                                          ! ҥȥǡνϴֳ֤ο (ǥե). 
    82:                                          ! Numerical value for interval of history data output (default value)
    83:              character(12), save:: DefaultIntUnit
    84:                                          ! ҥȥǡνϴֳ֤ñ (ǥե). 
    85:                                          ! Unit for interval of history data output (default value)
    86:              character(STRING):: DefaultFilePrefix
    87:                                          ! ҥȥǡΥե̾Ƭ (ǥե). 
    88:                                          ! Prefixes of history data filenames (default value)
    89:            
    90:            !!$  namelist /history_file_io_nml/ 
    91:            
    92:              character(*), parameter:: module_name = 'history_file_io'
    93:                                          ! ⥸塼̾. 
    94:                                          ! Module name
    95:              character(*), parameter:: version = &
    96:                & '$Name: dcpam5-20120921 $' // &
    97:                & '$Id: history_file_io.f90,v 1.15 2012-02-20 08:11:34 yot Exp $'
    98:                                          ! ⥸塼ΥС
    99:                                          ! Module version
   100:            
   101:              ! INTERFACE ʸ ; INTERFACE statements
   102:              !
   103:              interface HistoryFileOpen
   104:                module procedure HistoryFileOpen
   105:              end interface
   106:            
   107:              interface HistoryFileClose
   108:                module procedure HistoryFileClose
   109:              end interface
   110:            
   111:            contains
   112:            
   113:              !-------------------------------------------------------------------
   114:            
   115:              subroutine HistoryFileOpen
   116:                !
   117:                ! history_file_io ⥸塼νԤޤ. 
   118:                !--
   119:                ! NAMELIST#history_file_io_nml ɤ߹ߤϤμ³ǹԤޤ. 
   120:                !++
   121:                !
   122:                ! "history_file_io" module is initialized. 
   123:                !--
   124:                ! "NAMELIST#history_file_io_nml" is loaded in this procedure. 
   125:                !++
   126:                !
   127:            
   128:                ! ⥸塼 ; USE statements
   129:                !
   130:            
   131:                ! ϥեδܾ
   132:                ! Basic information for output files
   133:                ! 
   134:                use fileset, only: &
   135:                  & FileTitle, &
   136:                                          ! ϥǡեɽ.
   137:                                          ! Title of output data files
   138:                  & FileSource, &
   139:                                          ! ǡեμ. 
   140:                                          ! Source of data file
   141:                  & FileInstitution
   142:                                          ! ǡեǽŪѹȿ/Ŀ. 
   143:                                          ! Institution or person that changes data files for the last time
   144:            
   145:                ! ʪ
   146:                ! Physical and mathematical constants settings
   147:                !
   148:                use constants0, only: &
   149:                  & PI                    ! $ \pi $.
   150:                                          ! ߼Ψ. Circular constant
   151:            
   152:                ! ɸǡ
   153:                ! Axes data settings
   154:                !
   155:                use axesset, only: &
   156:                  & x_Lon, &
   157:                                          ! $ \lambda $ [rad.] . . Longitude
   158:                  & x_Lon_Weight, &
   159:                                          ! $ \Delta \lambda $ [rad.] . 
   160:                                          ! ٺɸŤ. 
   161:                                          ! Weight of longitude
   162:                  & y_Lat, &
   163:                                          ! $ \varphi $ [rad.] . . Latitude
   164:                  & y_Lat_Weight, &
   165:                                          ! $ \Delta \varphi $ [rad.] . 
   166:                                          ! ٺɸŤ. 
   167:                                          ! Weight of latitude
   168:                  & z_Sigma, &
   169:                                          ! $ \sigma $ ٥ (). 
   170:                                          ! Full $ \sigma $ level
   171:                  & r_Sigma, &
   172:                                          ! $ \sigma $ ٥ (Ⱦ). 
   173:                                          ! Half $ \sigma $ level
   174:                  & z_DelSigma, &
   175:                                          ! $ \Delta \sigma $ (). 
   176:                                          ! $ \Delta \sigma $ (Full)
   177:                  & w_Number, &
   178:                                          ! ڥȥǡźֹ. 
   179:                                          ! Subscript of spectral data
   180:                  & r_SSDepth, &
   181:                                          ! subsurface grid on interface of layer
   182:                  & z_SSDepth
   183:                                          ! subsurface grid at midpoint of layer
   184:            
   185:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   186:                ! Utilities for NAMELIST file input
   187:                !
   188:                use namelist_util, only: namelist_filename, NmlutilMsg
   189:            
   190:                ! 
   191:                ! Time control
   192:                !
   193:                use timeset, only: &
   194:                  & RestartTime, &        ! ꥹȳϻ. 
   195:                                          ! Restart time of calculation
   196:                  & EndTime, &            ! ׻λ. 
   197:                                          ! End time of calculation
   198:                  & InitialDate, &        ! ׻. 
   199:                                          ! Start date of calculation
   200:                  & DelTime               ! $ \Delta t $ [s]
   201:            
   202:                ! gtool4 netCDF ǡϥ󥿡ե (絬ϥǥ)
   203:                ! Interface of Input/Output of gtool4 netCDF data (For large models)
   204:                !
   205:                use gtool_historyauto, only: HistoryAutoCreate, &
   206:                  & HistoryAutoAddAttr, HistoryAutoAddWeight, HistoryAutoPutAxis, &
   207:                  & HistoryAutoPutAxisMPI
   208:            
   209:                ! ե
   210:                ! File I/O support
   211:                !
   212:                use dc_iounit, only: FileOpen
   213:            
   214:                ! ʸ
   215:                ! Character handling
   216:                !
   217:                use dc_string, only: CPrintf
   218:            
   219:                ! ̷ѥ᥿
   220:                ! Kind type parameter
   221:                !
   222:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   223:            
   224:                ! ʸ ; Declaration statements
   225:                !
   226:                implicit none
   227:            
   228:                ! ѿ
   229:                ! Work variables
   230:                !
   231:                logical:: flag_mpi_init
   232:            
   233:                ! ¹ʸ ; Executable statement
   234:                !
   235:            
   236:                if ( history_file_io_inited ) return
   237:                call InitCheck
   238:            
   239:                ! ǥեͤ
   240:                ! Default values settings
   241:                !
   242:                DefaultIntValue = 1.0
   243:                DefaultIntUnit  = 'sec'
   244:                DefaultFilePrefix = ''
   245:            !!$    DefaultIntValue = 1.0
   246:            !!$    DefaultIntUnit  = 'hrs'
   247:            !!$    DefaultFilePrefix = 'data01/'
   248:            
   249:                flag_mpi_init = .false.
   250:            
   251:                ! HistoryAutoCreate ˤ
   252:                ! Initialization by "HistoryAutoCreate"
   253:                !
   254:                call HistoryAutoCreate( &
   255:                  &     title = trim(FileTitle) // ' history data', &          ! (in)
   256:                  &    source = FileSource, institution = FileInstitution, &   ! (in)
   257:                  &      dims = (/ 'lon ', 'lat ', 'sig ', 'sigm', &
   258:                  &                'ssz ', 'sszi', &                           ! (in)
   259:                  &                'wn  ', 'time' /), &                        ! (in)
   260:                  &  dimsizes = (/ imax, jmax, kmax, kmax + 1, &
   261:                  &                max(kslmax,1), kslmax+1, &                  ! (in)
   262:                  &                lmax, 0 /), &                               ! (in)
   263:                  & longnames = (/ 'longitude                                       ', &
   264:                  &                'latitude                                        ', &
   265:                  &                'sigma at layer midpoints                        ', &
   266:                  &                'sigma at layer interface (half level)           ', &
   267:                  &                'depth at subsurface layer midpoints             ', &
   268:                  &                'depth at subsurface layer interface (half level)', &
   269:                  &                'subscript of spectral data                      ', &
   270:                  &                'time                                            ' /), & ! (in)
   271:                  &     units = (/ 'degree_east ', 'degree_north', &
   272:                  &                '1           ', '1           ', &
   273:                  &                'm           ', 'm           ', &
   274:                  &                '1           ', DefaultIntUnit /), &        ! (in)
   275:                  &     xtypes = (/ 'float', 'float', &
   276:                  &                 'float', 'float', &
   277:                  &                 'float', 'float', &
   278:                  &                 'int  ', 'float' /), &                     ! (in)
   279:                  &          origin  = RestartTime, &                      ! (in) optional
   280:                  &         terminus = EndTime + 2. * DelTime, &           ! (in) optional
   281:                  &         interval = DefaultIntValue, &                  ! (in) optional
   282:            !!$      &       start_date = InitialDate, &                      ! (in) optional
   283:            !!$      &     slice_start  = (/ 1.0, 1.0, 1.0, 1.0, 1.0 /), & ! (in) optional
   284:            !!$      &     slice_end    = (/ 0.0, 0.0, 0.0, 0.0, 0.0 /), & ! (in) optional
   285:            !!$      &     slice_stride = (/   1,   1,   1,   1,   1 /), & ! (in) optional
   286:            !!$      &    space_average = (/ .false., .false., .false., &
   287:            !!$      &                       .false., .false. /), &        ! (in) optional
   288:            !!$      & newfile_interval = real( delta_time * 10 ), &       ! (in) optional
   289:            
   290:            !!$      &  flag_mpi_gather = flag_mpi_init, &                    ! (in) optional
   291:                  &  flag_mpi_split  = .true., &                           ! (in) optional
   292:                  &      file_prefix = DefaultFilePrefix, &                ! (in) optional
   293:                  & namelist_filename = namelist_filename )                ! (in) optional
   294:            
   295:            
   296:                ! ɸǡؤ°
   297:                ! Attributes of axes data settings
   298:                !
   299:                call HistoryAutoAddAttr( &
   300:                  & varname = 'lon', attrname = 'standard_name', &   ! (in)
   301:                  & value = 'longitude' )                            ! (in)
   302:                call HistoryAutoAddAttr( &
   303:                  & varname = 'lat', attrname = 'standard_name', &   ! (in)
   304:                  & value = 'latitude' )                             ! (in)
   305:                call HistoryAutoAddAttr( &
   306:                  & varname = 'sig', attrname = 'standard_name', &   ! (in)
   307:                  & value = 'atmosphere_sigma_coordinate' )          ! (in)
   308:                call HistoryAutoAddAttr( &
   309:                  & varname = 'sigm', attrname = 'standard_name', &  ! (in)
   310:                  & value = 'atmosphere_sigma_coordinate' )          ! (in)
   311:                call HistoryAutoAddAttr( &
   312:                  & varname = 'sig', attrname = 'positive', &        ! (in)
   313:                  & value = 'down' )                                 ! (in)
   314:                call HistoryAutoAddAttr( &
   315:                  & varname = 'sigm', attrname = 'positive', &       ! (in)
   316:                  & value = 'down' )                                 ! (in)
   317:                call HistoryAutoAddAttr( &
   318:                  & varname = 'ssz', attrname = 'standard_name', &   ! (in)
   319:                  & value = 'depth' )                                ! (in)
   320:                call HistoryAutoAddAttr( &
   321:                  & varname = 'sszi', attrname = 'standard_name', &  ! (in)
   322:                  & value = 'depth' )                                ! (in)
   323:            
   324:                ! ɸǡ
   325:                ! Axes data settings
   326:                !
   327: V======        call HistoryAutoPutAxis( &
   328:                  & 'lon',  x_Lon / PI * 180.0_DP )  ! (in)
   329: V======        call HistoryAutoPutAxis( &
   330:                  & 'lat',  y_Lat / PI * 180.0_DP )  ! (in)
   331:                call HistoryAutoPutAxis( &
   332:                  & 'sig',  z_Sigma )                ! (in)
   333:                call HistoryAutoPutAxis( &
   334:                  & 'sigm', r_Sigma )                ! (in)
   335:                if ( kslmax == 0 ) then
   336:                  call HistoryAutoPutAxis( &
   337:                    & 'ssz',  r_SSDepth )              ! (in)
   338:                else
   339:                  call HistoryAutoPutAxis( &
   340:                    & 'ssz',  z_SSDepth )              ! (in)
   341:                end if
   342:                call HistoryAutoPutAxis( &
   343:                  & 'sszi', r_SSDepth )              ! (in)
   344:                call HistoryAutoPutAxis( &
   345:                  & 'wn',   w_Number )               ! (in)
   346:            
   347:                ! ɸŤߤ
   348:                ! Axes weights settings
   349:                !
   350:                call HistoryAutoAddWeight( &
   351:                  & dim = 'lon', weight = x_Lon_Weight, & ! (in)
   352:                  & units = 'radian', xtype = 'double' )  ! (in) optional
   353:                call HistoryAutoAddWeight( &
   354:                  & dim = 'lat', weight = y_Lat_Weight, & ! (in)
   355:                  & units = 'radian', xtype = 'double' )  ! (in) optional
   356:                call HistoryAutoAddWeight( &
   357:                  & dim = 'sig', weight = z_DelSigma, &   ! (in)
   358:                  & xtype = 'double' )                    ! (in) optional
   359:            
   360:                !  ; Print
   361:                !
   362:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   363:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   364:            
   365:                history_file_io_inited = .true.
   366:              end subroutine HistoryFileOpen
   367:            
   368:              !-------------------------------------------------------------------
   369:            
   370:              subroutine HistoryFileClose
   371:                !
   372:                ! ҥȥǡեϤνλԤޤ. 
   373:                !
   374:                ! Terminate history data files output. 
   375:            
   376:                ! ⥸塼 ; USE statements
   377:                !
   378:            
   379:                ! gtool4 netCDF ǡϥ󥿡ե (絬ϥǥ)
   380:                ! Interface of Input/Output of gtool4 netCDF data (For large models)
   381:                !
   382:                use gtool_historyauto, only: HistoryAutoClose
   383:            
   384:                ! ʸ ; Declaration statements
   385:                !
   386:                implicit none
   387:            
   388:                ! ѿ
   389:                ! Work variables
   390:                !
   391:            
   392:                ! ¹ʸ ; Executable statement
   393:                !
   394:            
   395:                call HistoryAutoClose
   396:            
   397:              end subroutine HistoryFileClose
   398:            
   399:              !-------------------------------------------------------------------
   400:            
   401:              subroutine InitCheck
   402:                !
   403:                ! ¸⥸塼νå
   404:                !
   405:                ! Check initialization of dependency modules
   406:            
   407:                ! ⥸塼 ; USE statements
   408:                !
   409:            
   410:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   411:                ! Utilities for NAMELIST file input
   412:                !
   413:                use namelist_util, only: namelist_util_inited
   414:            
   415:                ! ϥեδܾ
   416:                ! Management basic information for output files
   417:                !
   418:                use fileset, only: fileset_inited
   419:            
   420:                ! ʻ
   421:                ! Grid points settings
   422:                !
   423:                use gridset, only: gridset_inited
   424:            
   425:                ! ɸǡ
   426:                ! Axes data settings
   427:                !
   428:                use axesset, only: axesset_inited
   429:            
   430:                ! 
   431:                ! Time control
   432:                !
   433:                use timeset, only: timeset_inited
   434:            
   435:                ! ¹ʸ ; Executable statement
   436:                !
   437:            
   438:                if ( .not. namelist_util_inited ) &
   439:                  & call MessageNotify( 'E', module_name, '"namelist_util" module is not initialized.' )
   440:            
   441:                if ( .not. fileset_inited ) &
   442:                  & call MessageNotify( 'E', module_name, '"fileset" module is not initialized.' )
   443:            
   444:                if ( .not. gridset_inited ) &
   445:                  & call MessageNotify( 'E', module_name, '"gridset" module is not initialized.' )
   446:            
   447:                if ( .not. axesset_inited ) &
   448:                  & call MessageNotify( 'E', module_name, '"axesset" module is not initialized.' )
   449:            
   450:                if ( .not. timeset_inited ) &
   451:                  & call MessageNotify( 'E', module_name, '"timeset" module is not initialized.' )
   452:            
   453:              end subroutine InitCheck
   454:            
   455:            end module history_file_io
