Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:43 2012
FILE NAME: read_time_series.f90
PROGRAM NAME: read_time_series
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   377  vec  (   1): Vectorized loop.
   453  opt  (1592): Outer loop unrolled inside inner loop.
   453  vec  (   4): Vectorized array expression.
   453  vec  (   4): Vectorized array expression.
   463  opt  (1592): Outer loop unrolled inside inner loop.
   463  vec  (   4): Vectorized array expression.
   463  vec  (   4): Vectorized array expression.
   485  opt  (1592): Outer loop unrolled inside inner loop.
   485  vec  (   4): Vectorized array expression.
   485  vec  (   4): Vectorized array expression.
   487  opt  (1592): Outer loop unrolled inside inner loop.
   487  vec  (   4): Vectorized array expression.
   487  vec  (   4): Vectorized array expression.
   576  opt  (1592): Outer loop unrolled inside inner loop.
   576  vec  (   4): Vectorized array expression.
   576  vec  (   4): Vectorized array expression.
   582  vec  (   1): Vectorized loop.
   582  vec  (   1): Vectorized loop.
   584  opt  (1059): Unable to determine last value of scalar temporary.
   586  opt  (1592): Outer loop unrolled inside inner loop.
   600  vec  (   1): Vectorized loop.
   639  vec  (   1): Vectorized loop.
   639  vec  (   1): Vectorized loop.
   641  opt  (1592): Outer loop unrolled inside inner loop.
   663  vec  (   1): Vectorized loop.
   684  vec  (   1): Vectorized loop.
   684  vec  (   1): Vectorized loop.
   686  opt  (1592): Outer loop unrolled inside inner loop.
   706  opt  (1593): Loop nest collapsed into one loop.
   706  vec  (   1): Vectorized loop.
   800  vec  (   4): Vectorized array expression.
   800  vec  (  26): Macro operation Sum/InnerProd.
   935  vec  (   4): Vectorized array expression.
   935  vec  (  26): Macro operation Sum/InnerProd.
  1016  vec  (   4): Vectorized array expression.
  1034  vec  (   1): Vectorized loop.
  1118  vec  (   4): Vectorized array expression.
  1227  warn (  82): Name "iostat_nml" is not used.
  1227  warn (  82): Name "unit_nml" is not used.
  1227  warn (  82): Name "flag_mpi_init" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:43 2012
FILE NAME: read_time_series.f90
PROGRAM NAME: read_time_series
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ǡɤ߹
     2  !
     3  != Reading time series
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Satoshi NODA
     6  ! Version::   $Id: read_time_series.f90,v 1.14 2012-07-27 00:52:39 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module read_time_series
    13    !
    14    != ǡɤ߹
    15    !
    16    != Reading time series
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ɽ̲, O3 ̤ʤɤλǡ NetCDF ե뤫ɤ߹.
    21    !
    22    ! Reading time series data, such as sea surface temperature, O3, and so on, from
    23    ! NetCDF file.
    24    !
    25    !== Procedures List
    26  !!$  ! GroundFileGet    :: ɽ̥ǡե
    27  !!$  !--
    28  !!$  ! GroundFileOpen   :: ɽ̥ǡեΥץ
    29  !!$  ! GroundFileOutput :: ɽ̥ǡեؤΥǡ
    30  !!$  ! GroundFileClose  :: ɽ̥ǡեΥ
    31    !++
    32    ! ------------     :: ------------
    33  !!$  ! GroundFileGet    :: Input ground data file
    34  !!$  !--
    35  !!$  ! GroundFileOpen   :: Open ground data file
    36  !!$  ! GroundFileOutput :: Data output to ground data file
    37  !!$  ! GroundFileClose  :: Close ground data file
    38    !++
    39    !
    40    !== NAMELIST
    41    !
    42  !!$  ! NAMELIST#ground_file_io_nml
    43    !
    44  
    45    ! ⥸塼 ; USE statements
    46    !
    47  
    48    ! ̷ѥ᥿
    49    ! Kind type parameter
    50    !
    51    use dc_types, only: DP, &      ! ټ¿. Double precision.
    52      &                 STRING, &  ! ʸ.       Strings.
    53      &                 TOKEN      ! .   Keywords.
    54  
    55    ! å
    56    ! Message output
    57    !
    58    use dc_message, only: MessageNotify
    59  
    60    ! ʻ
    61    ! Grid points settings
    62    !
    63    use gridset, only: imax, & ! ٳʻ.
    64                               ! Number of grid points in longitude
    65      &                jmax, & ! ٳʻ.
    66                               ! Number of grid points in latitude
    67      &                kmax    ! ľؿ.
    68                               ! Number of vertical level
    69  
    70    ! ʸ ; Declaration statements
    71    !
    72    implicit none
    73    private
    74  
    75    ! ³
    76    ! Public procedure
    77    !
    78    public:: SetValuesFromTimeSeriesWrapper
    79  !!$  public:: SetValuesFromTimeSeries
    80    public:: ReadTimeSeriesInit
    81  
    82    ! ѿ
    83    ! Public variables
    84    !
    85    logical, save :: read_time_series_inited = .false.
    86                                ! ե饰.
    87                                ! Initialization flag
    88  
    89  
    90    type time_series_data
    91      character(STRING):: FileName
    92                                ! ե̾.
    93                                ! File name
    94      character(STRING):: VarName
    95                                ! ѿ̾.
    96                                ! Variable name
    97      integer          :: NDims
    98      integer          :: tmax
    99      integer          :: NVLevels
   100      real(DP), pointer:: z_VLevels(:)
   101      real(DP), pointer:: a_time(:)
   102      integer , pointer:: a_tindex(:)
   103      real(DP), pointer:: xyza_SavedData(:,:,:,:)
   104      real(DP), pointer:: xyz_VarTimeInterpolated(:,:,:)
   105    end type time_series_data
   106  
   107    logical, save :: flag_mpi_split = .true.
   108  
   109    type(time_series_data), save :: TSDataInfoSST
   110    type(time_series_data), save :: TSDataInfoSIC
   111    type(time_series_data), save :: TSDataInfoO3
   112    type(time_series_data), save :: TSDataInfoDOD
   113  
   114  
   115    ! ѿ
   116    ! Private variables
   117    !
   118  
   119  
   120    character(*), parameter:: module_name = 'read_time_series_from_file'
   121                                ! ⥸塼̾.
   122                                ! Module name
   123    character(*), parameter:: version = &
   124      & '$Name: dcpam5-20120921 $' // &
   125      & '$Id: read_time_series.f90,v 1.14 2012-07-27 00:52:39 yot Exp $'
   126                                ! ⥸塼ΥС
   127                                ! Module version
   128  
   129    ! INTERFACE ʸ ; INTERFACE statements
   130    !
   131    interface SetValuesFromTimeSeriesWrapper
   132      module procedure SetValFromTimeSeriesWrapper2D, SetValFromTimeSeriesWrapper3D
   133    end interface
   134  
   135  contains
   136  
   137    !--------------------------------------------------------------------------------------
   138  
   139    subroutine SetValFromTimeSeriesWrapper2D( &
   140      & FileName, VarName, &
   141      & xy_Var,            &               ! (inout)
   142      & keyword            &
   143      & )
   144  
   145  
   146      ! ʸ ; Declaration statements
   147      !
   148      implicit none
   149  
   150      character(*), intent(in   ):: FileName
   151                                ! ե̾.
   152                                ! File name
   153      character(*), intent(in   ):: VarName
   154                                ! ѿ̾.
   155                                ! Variable name
   156      real(DP)    , intent(inout):: xy_Var(0:imax-1, 1:jmax)
   157                                ! ɽ̲.
   158                                ! Surface temperature
   159      character(*), intent(in   ):: keyword
   160  
   161  
   162      ! ǧ
   163      ! Initialization check
   164      !
   165      if ( .not. read_time_series_inited ) then
   166        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   167      end if
   168  
   169  
   170      if ( keyword == 'SST' ) then
   171        call SetValuesFromTimeSeries( &
   172          & TSDataInfoSST,     &
   173          & FileName, VarName, &
   174          & xy_Var = xy_Var    &               ! (inout)
   175          & )
   176      else if ( keyword == 'SIC' ) then
   177        call SetValuesFromTimeSeries( &
   178          & TSDataInfoSIC,     &
   179          & FileName, VarName, &
   180          & xy_Var = xy_Var    &               ! (inout)
   181          & )
   182      else if ( keyword == 'DOD' ) then
   183        call SetValuesFromTimeSeries( &
   184          & TSDataInfoDOD,     &
   185          & FileName, VarName, &
   186          & xy_Var = xy_Var    &               ! (inout)
   187          & )
   188      else
   189        stop 'Unsupported keyword'
   190      end if
   191  
   192  
   193    end subroutine SetValFromTimeSeriesWrapper2D
   194  
   195    !--------------------------------------------------------------------------------------
   196  
   197    subroutine SetValFromTimeSeriesWrapper3D( &
   198      & FileName, VarName, &
   199      & xyz_Press,         &               ! (in)
   200      & xyz_Var,           &               ! (inout)
   201      & keyword            &
   202      & )
   203  
   204  
   205      ! ʸ ; Declaration statements
   206      !
   207      implicit none
   208  
   209      character(*), intent(in   ):: FileName
   210                                ! ե̾.
   211                                ! File name
   212      character(*), intent(in   ):: VarName
   213                                ! ѿ̾.
   214                                ! Variable name
   215      real(DP)    , intent(in   ):: xyz_Press(0:imax-1, 1:jmax, 1:kmax)
   216                                ! ɽ̲.
   217                                ! Surface temperature
   218      real(DP)    , intent(inout):: xyz_Var(0:imax-1, 1:jmax, 1:kmax)
   219                                ! ɽ̲.
   220                                ! Surface temperature
   221      character(*), intent(in   ):: keyword
   222  
   223  
   224      ! ǧ
   225      ! Initialization check
   226      !
   227      if ( .not. read_time_series_inited ) then
   228        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   229      end if
   230  
   231  
   232      if ( keyword == 'O3' ) then
   233        call SetValuesFromTimeSeries( &
   234          & TSDataInfoO3,          &
   235          & FileName, VarName,     &
   236          & xyz_Press = xyz_Press, &           ! (in)
   237          & xyz_Var = xyz_Var,      &           ! (inout)
   238          & FlagLogVLev     = .true.,  &
   239          & FlagLog         = .true.,  &
   240          & FlagPositiveDef = .true.   & ! (in ) optional
   241          & )
   242      else
   243        stop 'Unsupported keyword'
   244      end if
   245  
   246  
   247    end subroutine SetValFromTimeSeriesWrapper3D
   248  
   249    !--------------------------------------------------------------------------------------
   250  
   251    subroutine SetValuesFromTimeSeries(          &
   252      & TSDataInfo,                              &
   253      & FileName, VarName,                       &
   254      & xyz_Press,                               & ! (in   ) optional
   255      & xy_Var,                                  & ! (inout) optional
   256      & xyz_Var,                                 & ! (inout) optional
   257      & FlagLogVLev, FlagLog, FlagPositiveDef    & ! (in   ) optional
   258      & )
   259      !
   260      ! ɽ̤νΥǡꤷޤ.
   261      ! xy_SurfTemp ʳϰܤ˸ƤФ줿Τꤵޤ.
   262      !
   263      ! Get various data on ground.
   264      ! Arguments excluding "xy_SurfTemp" are configured at first only.
   265      !
   266  
   267      ! ⥸塼 ; USE statements
   268      !
   269  
   270      ! gtool4 ǡ
   271      ! Gtool4 data input
   272      !
   273      use gtool_history, only: HistoryGet
   274  
   275      ! ʸ
   276      ! Character handling
   277      !
   278      use dc_string, only: toChar
   279  
   280      ! դӻμ갷
   281      ! Date and time handler
   282      !
   283      use dc_calendar, only: DCCalDateEvalSecOfYear
   284  
   285      ! 
   286      ! Time control
   287      !
   288      use timeset, only: TimeN, InitialDate
   289  
   290      ! ʸ ; Declaration statements
   291      !
   292      implicit none
   293  
   294      type(time_series_data), intent(inout):: TSDataInfo
   295      character(*)          , intent(in   ):: FileName
   296                                ! ե̾.
   297                                ! File name
   298      character(*)          , intent(in   ):: VarName
   299                                ! ѿ̾.
   300                                ! Variable name
   301      real(DP)    , optional, intent(in   ):: xyz_Press(0:imax-1, 1:jmax, 1:kmax)
   302                                ! 3 .
   303                                ! 3D array
   304      real(DP)    , optional, intent(inout):: xy_Var (0:imax-1, 1:jmax)
   305                                ! 2 .
   306                                ! 2D array
   307      real(DP)    , optional, intent(inout):: xyz_Var(0:imax-1, 1:jmax, 1:kmax)
   308                                ! 3 .
   309                                ! 3D array
   310      logical     , optional, intent(in   ):: FlagLogVLev
   311      logical     , optional, intent(in   ):: FlagLog
   312      logical     , optional, intent(in   ):: FlagPositiveDef
   313  
   314      ! ѿ
   315      ! Work variables
   316      !
   317      real(DP):: SecOfYear
   318      integer :: tindex
   319  
   320  !!$    real(DP):: xyza_VarInterpolated(0:imax-1, 1:jmax, 1:kmax, 2)
   321  
   322      integer :: t
   323  
   324  
   325      ! ǧ
   326      ! Initialization check
   327      !
   328      if ( .not. read_time_series_inited ) then
   329        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   330      end if
   331  
   332  
   333      if ( ( .not. present( xy_Var ) ) .and. ( .not. present( xyz_Var ) ) ) then
   334        call MessageNotify( 'E', module_name, 'xy_Var or xyz_Var have to be given.' )
   335      end if
   336  
   337      if ( ( present( xyz_Var ) ) .and. ( .not. present( xyz_Press ) ) ) then
   338        call MessageNotify( 'E', module_name, 'xyz_Press has to be given, when xyz_Var is given.' )
   339      end if
   340  
   341      ! ¹ʸ ; Executable statement
   342      !
   343      if ( .not. associated( TSDataInfo % a_time ) ) then
   344        if ( present( xy_Var ) ) then
   345          call StructureInit(       &
   346            & FileName, VarName, 2, &
   347            & TSDataInfo            &
   348            & )
   349        else
   350          call StructureInit(       &
   351            & FileName, VarName, 3, &
   352            & TSDataInfo            &
   353            & )
   354        end if
   355      end if
   356  
   357  
   358      ! Update values of time paying attention to leap year
   359      !
   360      call UpdateTime(     &
   361        & TSDataInfo             & ! (inout)
   362        & )
   363  
   364  
   365      if ( TSDataInfo % tmax >= 2 ) then
   366  
   367        SecOfYear = DCCalDateEvalSecOfYear( TimeN, date = InitialDate )
   368  
   369  !!$      write( 6, * ) TSDataInfo%a_time(TSDataInfo%a_tindex(1)), &
   370  !!$        & SecOfYear, TSDataInfo%a_time(TSDataInfo%a_tindex(2))
   371  
   372        if ( ( SecOfYear <   TSDataInfo%a_time(TSDataInfo%a_tindex(1)) ) .or. &
   373          &  ( SecOfYear >=  TSDataInfo%a_time(TSDataInfo%a_tindex(2)) ) ) then
   374  
   375          TSDataInfo % a_tindex(1) = 0
   376          TSDataInfo % a_tindex(2) = 1
   377          do t = 1, TSDataInfo%tmax
   378            if ( TSDataInfo % a_time(t) <= SecOfYear ) then
   379              TSDataInfo % a_tindex(1) = t
   380              TSDataInfo % a_tindex(2) = t+1
   381            end if
   382          end do
     .        tsdatainfo.a_tindex1 = tsdatainfo.a_tindex(1)                     
     .        if (tsdatainfo%tmax .gt. 0) then                                  
     .           tsdatainfo.a_tindex2 = tsdatainfo.a_tindex(2)                  
     .  !CDIR    NODEP                                                          
     .           do t = 1, tsdatainfo%tmax                                      
     .              if (tsdatainfo.a_time(t) .le. secofyear) then               
     .                 tsdatainfo.a_tindex1 = (t)                               
     .                 tsdatainfo.a_tindex2 = t + 1                             
     .              endif                                                       
     .           end do                                                         
     .           tsdatainfo.a_tindex(2) = tsdatainfo.a_tindex2                  
     .           tsdatainfo.a_tindex(1) = tsdatainfo.a_tindex1                  
     .        endif                                                             
   383  
   384  !!$        write( 6, * ) '##############################################'
   385  !!$        write( 6, * ) '##############################################'
   386  !!$        write( 6, * ) '##############################################'
   387  !!$        write( 6, * ) '##############################################'
   388  !!$        write( 6, * ) '##############################################'
   389  !!$        write( 6, * ) 'in if', TSDataInfo % a_tindex(1), TSDataInfo % a_tindex(2)
   390  !!$        write( 6, * ) '##############################################'
   391  !!$        write( 6, * ) '##############################################'
   392  !!$        write( 6, * ) '##############################################'
   393  !!$        write( 6, * ) '##############################################'
   394  !!$        write( 6, * ) '##############################################'
   395  
   396          tindex = TSDataInfo % a_tindex(1)
   397          if ( tindex == 0 ) then
   398            tindex = TSDataInfo % tmax
   399          else if ( tindex == TSDataInfo % tmax + 1 ) then
   400            tindex = 1
   401          else
   402            tindex = tindex
   403          end if
   404  
   405          if ( present( xy_Var ) ) then
   406            call HistoryGet(                                       &
   407              & TSDataInfo%FileName,                               &
   408              & TSDataInfo%VarName,                                &
   409              & TSDataInfo%xyza_SavedData(:,:,1,1),                &
   410              & range = 'time=^'//toChar(tindex),                  &
   411              & flag_mpi_split = flag_mpi_split                    &
   412              & )
   413          else
   414            call HistoryGet(                                       &
   415              & TSDataInfo%FileName,                               &
   416              & TSDataInfo%VarName,                                &
   417              & TSDataInfo%xyza_SavedData(:,:,:,1),                &
   418              & range = 'time=^'//toChar(tindex),                  &
   419              & flag_mpi_split = flag_mpi_split                    &
   420              & )
   421          end if
   422  
   423          tindex = TSDataInfo % a_tindex(2)
   424          if ( tindex == 0 ) then
   425            tindex = TSDataInfo % tmax
   426          else if ( tindex == TSDataInfo % tmax + 1 ) then
   427            tindex = 1
   428          else
   429            tindex = tindex
   430          end if
   431  
   432          if ( present( xy_Var ) ) then
   433            call HistoryGet(                                       &
   434              & TSDataInfo%FileName,                               &
   435              & TSDataInfo%VarName,                                &
   436              & TSDataInfo%xyza_SavedData(:,:,1,2),                &
   437              & range = 'time=^'//toChar(tindex),                  &
   438              & flag_mpi_split = flag_mpi_split                    &
   439              & )
   440          else
   441            call HistoryGet(                                       &
   442              & TSDataInfo%FileName,                               &
   443              & TSDataInfo%VarName,                                &
   444              & TSDataInfo%xyza_SavedData(:,:,:,2),                &
   445              & range = 'time=^'//toChar(tindex),                  &
   446              & flag_mpi_split = flag_mpi_split                    &
   447              & )
   448          end if
   449  
   450        end if
   451  
   452        if ( present( xy_Var ) ) then
   453          xy_Var =                                              &
     .        if (tsdatainfo.xyza_saveddata.DSC.U2 + 1 -                        
     .       1   tsdatainfo.xyza_saveddata.DSC.L2 .gt. 0) then                  
     .           J3 = and(tsdatainfo.xyza_saveddata.DSC.U2 + 1 -                
     .       1      tsdatainfo.xyza_saveddata.DSC.L2,3)                         
     .  !CDIR    NODEP                                                          
     .           do t1885 = 1, J3                                               
     .              D3 = 1.D0/(tsdatainfo.a_time(tsdatainfo.a_tindex(2))-       
     .       1         tsdatainfo.a_time(tsdatainfo.a_tindex(1)))               
     .  !CDIR       NODEP                                                       
     .              do t1887 = 1, tsdatainfo.xyza_saveddata.DSC.U1 -            
     .       1         tsdatainfo.xyza_saveddata.DSC.L1 + 2 - min0(1,           
     .       2         tsdatainfo.xyza_saveddata.DSC.U1 -                       
     .       3         tsdatainfo.xyza_saveddata.DSC.L1 + 1)                    
     .                 xy_var(t1887-1,t1885) = (tsdatainfo.xyza_saveddata(      
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885-1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,2)-                
     .       3            tsdatainfo.xyza_saveddata(                            
     .       4            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885-1+     
     .       5            tsdatainfo.xyza_saveddata.DSC.L2,1,1))*D3*(secofyear  
     .       6             - tsdatainfo.a_time(tsdatainfo.a_tindex(1))) +       
     .       7            tsdatainfo.xyza_saveddata(                            
     .       8            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885-1+     
     .       9            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1885 = J3 + 1, tsdatainfo.xyza_saveddata.DSC.U2 + 1 -      
     .       1      tsdatainfo.xyza_saveddata.DSC.L2, 4                         
     .              D2 = tsdatainfo.a_time(tsdatainfo.a_tindex(1))              
     .              D1 = tsdatainfo.a_time(tsdatainfo.a_tindex(2))              
     .  !CDIR       NODEP                                                       
     .              do t1887 = 1, tsdatainfo.xyza_saveddata.DSC.U1 -            
     .       1         tsdatainfo.xyza_saveddata.DSC.L1 + 2 - min0(1,           
     .       2         tsdatainfo.xyza_saveddata.DSC.U1 -                       
     .       3         tsdatainfo.xyza_saveddata.DSC.L1 + 1)                    
     .                 xy_var(t1887-1,t1885) = (tsdatainfo.xyza_saveddata(      
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885-1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,2)-                
     .       3            tsdatainfo.xyza_saveddata(                            
     .       4            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885-1+     
     .       5            tsdatainfo.xyza_saveddata.DSC.L2,1,1))/(D1 - D2)*(    
     .       6            secofyear - D2) + tsdatainfo.xyza_saveddata(          
     .       7            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885-1+     
     .       8            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .                 xy_var(t1887-1,t1885+1) = (tsdatainfo.xyza_saveddata(    
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+       
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,2)-                
     .       3            tsdatainfo.xyza_saveddata(                            
     .       4            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+       
     .       5            tsdatainfo.xyza_saveddata.DSC.L2,1,1))/(D1 - D2)*(    
     .       6            secofyear - D2) + tsdatainfo.xyza_saveddata(          
     .       7            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+       
     .       8            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .                 xy_var(t1887-1,t1885+2) = (tsdatainfo.xyza_saveddata(    
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,2)-                
     .       3            tsdatainfo.xyza_saveddata(                            
     .       4            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+1+     
     .       5            tsdatainfo.xyza_saveddata.DSC.L2,1,1))/(D1 - D2)*(    
     .       6            secofyear - D2) + tsdatainfo.xyza_saveddata(          
     .       7            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+1+     
     .       8            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .                 xy_var(t1887-1,t1885+3) = (tsdatainfo.xyza_saveddata(    
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+2+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,2)-                
     .       3            tsdatainfo.xyza_saveddata(                            
     .       4            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+2+     
     .       5            tsdatainfo.xyza_saveddata.DSC.L2,1,1))/(D1 - D2)*(    
     .       6            secofyear - D2) + tsdatainfo.xyza_saveddata(          
     .       7            tsdatainfo.xyza_saveddata.DSC.L1+t1887-1,t1885+2+     
     .       8            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10018                                                       
   454            &   ( TSDataInfo%xyza_SavedData(:,:,1,2)    &
   455            &   - TSDataInfo%xyza_SavedData(:,:,1,1)  ) &
   456            & / ( TSDataInfo%a_time(TSDataInfo%a_tindex(2))    &
   457            &   - TSDataInfo%a_time(TSDataInfo%a_tindex(1))  ) &
   458            & * ( SecOfYear                                     &
   459            &    - TSDataInfo%a_time(TSDataInfo%a_tindex(1))  ) &
   460            & + TSDataInfo%xyza_SavedData(:,:,1,1)
   461        else
   462  
   463          TSDataInfo%xyz_VarTimeInterpolated =                  &
     .        if (tsdatainfo.xyza_saveddata.DSC.U2 + 1 -                        
     .       1   tsdatainfo.xyza_saveddata.DSC.L2 .gt. 0) then                  
     .           J4 = and(tsdatainfo.xyza_saveddata.DSC.U2 + 1 -                
     .       1      tsdatainfo.xyza_saveddata.DSC.L2,3)                         
     .  !CDIR    NODEP                                                          
     .           do t1869 = 1, J4                                               
     .              D6 = 1.D0/(tsdatainfo.a_time(tsdatainfo.a_tindex(2))-       
     .       1         tsdatainfo.a_time(tsdatainfo.a_tindex(1)))               
     .  !CDIR       NODEP                                                       
     .              do t1871 = 1, tsdatainfo.xyza_saveddata.DSC.U1 + 1 -        
     .       1         tsdatainfo.xyza_saveddata.DSC.L1                         
     .                 tsdatainfo.xyz_vartimeinterpolated(                      
     .       1            tsdatainfo.xyz_vartimeinterpolated.DSC.L1+t1871-1,    
     .       2            t1869-1+tsdatainfo.xyz_vartimeinterpolated.DSC.L2,    
     .       3            t1867+tsdatainfo.xyz_vartimeinterpolated.DSC.L3) = (  
     .       4            tsdatainfo.xyza_saveddata(                            
     .       5            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869-1+     
     .       6            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       7            tsdatainfo.xyza_saveddata.DSC.L3,2)-                  
     .       8            tsdatainfo.xyza_saveddata(                            
     .       9            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869-1+     
     .       .            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       1            tsdatainfo.xyza_saveddata.DSC.L3,1))*D6*(secofyear -  
     .       2            tsdatainfo.a_time(tsdatainfo.a_tindex(1))) +          
     .       3            tsdatainfo.xyza_saveddata(                            
     .       4            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869-1+     
     .       5            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       6            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1869 = J4 + 1, tsdatainfo.xyza_saveddata.DSC.U2 + 1 -      
     .       1      tsdatainfo.xyza_saveddata.DSC.L2, 4                         
     .              D5 = tsdatainfo.a_time(tsdatainfo.a_tindex(1))              
     .              D4 = tsdatainfo.a_time(tsdatainfo.a_tindex(2))              
     .  !CDIR       NODEP                                                       
     .              do t1871 = 1, tsdatainfo.xyza_saveddata.DSC.U1 + 1 -        
     .       1         tsdatainfo.xyza_saveddata.DSC.L1                         
     .                 tsdatainfo.xyz_vartimeinterpolated(                      
     .       1            tsdatainfo.xyz_vartimeinterpolated.DSC.L1+t1871-1,    
     .       2            t1869-1+tsdatainfo.xyz_vartimeinterpolated.DSC.L2,    
     .       3            t1867+tsdatainfo.xyz_vartimeinterpolated.DSC.L3) = (  
     .       4            tsdatainfo.xyza_saveddata(                            
     .       5            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869-1+     
     .       6            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       7            tsdatainfo.xyza_saveddata.DSC.L3,2)-                  
     .       8            tsdatainfo.xyza_saveddata(                            
     .       9            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869-1+     
     .       .            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       1            tsdatainfo.xyza_saveddata.DSC.L3,1))/(D4 - D5)*(      
     .       2            secofyear - D5) + tsdatainfo.xyza_saveddata(          
     .       3            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869-1+     
     .       4            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       5            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .                 tsdatainfo.xyz_vartimeinterpolated(                      
     .       1            tsdatainfo.xyz_vartimeinterpolated.DSC.L1+t1871-1,    
     .       2            t1869+tsdatainfo.xyz_vartimeinterpolated.DSC.L2,t1867+
     .       3            tsdatainfo.xyz_vartimeinterpolated.DSC.L3) = (        
     .       4            tsdatainfo.xyza_saveddata(                            
     .       5            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+       
     .       6            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       7            tsdatainfo.xyza_saveddata.DSC.L3,2)-                  
     .       8            tsdatainfo.xyza_saveddata(                            
     .       9            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+       
     .       .            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       1            tsdatainfo.xyza_saveddata.DSC.L3,1))/(D4 - D5)*(      
     .       2            secofyear - D5) + tsdatainfo.xyza_saveddata(          
     .       3            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+       
     .       4            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       5            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .                 tsdatainfo.xyz_vartimeinterpolated(                      
     .       1            tsdatainfo.xyz_vartimeinterpolated.DSC.L1+t1871-1,    
     .       2            t1869+1+tsdatainfo.xyz_vartimeinterpolated.DSC.L2,    
     .       3            t1867+tsdatainfo.xyz_vartimeinterpolated.DSC.L3) = (  
     .       4            tsdatainfo.xyza_saveddata(                            
     .       5            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+1+     
     .       6            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       7            tsdatainfo.xyza_saveddata.DSC.L3,2)-                  
     .       8            tsdatainfo.xyza_saveddata(                            
     .       9            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+1+     
     .       .            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       1            tsdatainfo.xyza_saveddata.DSC.L3,1))/(D4 - D5)*(      
     .       2            secofyear - D5) + tsdatainfo.xyza_saveddata(          
     .       3            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+1+     
     .       4            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       5            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .                 tsdatainfo.xyz_vartimeinterpolated(                      
     .       1            tsdatainfo.xyz_vartimeinterpolated.DSC.L1+t1871-1,    
     .       2            t1869+2+tsdatainfo.xyz_vartimeinterpolated.DSC.L2,    
     .       3            t1867+tsdatainfo.xyz_vartimeinterpolated.DSC.L3) = (  
     .       4            tsdatainfo.xyza_saveddata(                            
     .       5            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+2+     
     .       6            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       7            tsdatainfo.xyza_saveddata.DSC.L3,2)-                  
     .       8            tsdatainfo.xyza_saveddata(                            
     .       9            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+2+     
     .       .            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       1            tsdatainfo.xyza_saveddata.DSC.L3,1))/(D4 - D5)*(      
     .       2            secofyear - D5) + tsdatainfo.xyza_saveddata(          
     .       3            tsdatainfo.xyza_saveddata.DSC.L1+t1871-1,t1869+2+     
     .       4            tsdatainfo.xyza_saveddata.DSC.L2,t1867+               
     .       5            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   464            &   ( TSDataInfo%xyza_SavedData(:,:,:,2)            &
   465            &   - TSDataInfo%xyza_SavedData(:,:,:,1)  )         &
   466            & / ( TSDataInfo%a_time(TSDataInfo%a_tindex(2))     &
   467            &   - TSDataInfo%a_time(TSDataInfo%a_tindex(1))  )  &
   468            & * ( SecOfYear                                     &
   469            &    - TSDataInfo%a_time(TSDataInfo%a_tindex(1))  ) &
   470            & + TSDataInfo%xyza_SavedData(:,:,:,1)
   471  
   472          call VerticalInterpolation(                    &
   473            & TSDataInfo%NVLevels, TSDataInfo%z_VLevels, & ! (in )
   474            & TSDataInfo%xyz_VarTimeInterpolated,        & ! (in )
   475            & xyz_Press,                                 & ! (in )
   476            & xyz_Var,                                   & ! (out)
   477            & FlagLogVLev, FlagLog, FlagPositiveDef      & ! (in ) optional
   478            & )
   479  
   480        end if
   481  
   482      else
   483  
   484        if ( present( xy_Var ) ) then
   485          xy_Var = TSDataInfo%xyza_SavedData(:,:,1,1)
     .        if (jmax .gt. 0) then                                             
     .           J5 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t1859 = 1, J5                                               
     .  !CDIR       NODEP                                                       
     .              do t1861 = 1, imax + 1 - min0(1,imax)                       
     .                 xy_var(t1861-1,t1859) = tsdatainfo.xyza_saveddata(       
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1861-1,t1859-1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1859 = J5 + 1, jmax, 4                                     
     .  !CDIR       NODEP                                                       
     .              do t1861 = 1, imax + 1 - min0(1,imax)                       
     .                 xy_var(t1861-1,t1859) = tsdatainfo.xyza_saveddata(       
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1861-1,t1859-1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .                 xy_var(t1861-1,t1859+1) = tsdatainfo.xyza_saveddata(     
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1861-1,t1859+       
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .                 xy_var(t1861-1,t1859+2) = tsdatainfo.xyza_saveddata(     
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1861-1,t1859+1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .                 xy_var(t1861-1,t1859+3) = tsdatainfo.xyza_saveddata(     
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1861-1,t1859+2+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,1,1)                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10018                                                       
   486        else
   487          call VerticalInterpolation(                    &
     .        if (tsdatainfo.xyza_saveddata.DSC.U2 + 1 -                        
     .       1   tsdatainfo.xyza_saveddata.DSC.L2 .gt. 0) then                  
     .           J6 = and(tsdatainfo.xyza_saveddata.DSC.U2 + 1 -                
     .       1      tsdatainfo.xyza_saveddata.DSC.L2,3)                         
     .  !CDIR    NODEP                                                          
     .           do t1849 = 1, J6                                               
     .  !CDIR       NODEP                                                       
     .              do t1851 = 1, tsdatainfo.xyza_saveddata.DSC.U1 + 1 -        
     .       1         tsdatainfo.xyza_saveddata.DSC.L1                         
     .                 %IG17(t1851,t1849,t1847+1) = tsdatainfo.xyza_saveddata(  
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1851-1,t1849-1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,t1847+               
     .       3            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1849 = J6 + 1, tsdatainfo.xyza_saveddata.DSC.U2 + 1 -      
     .       1      tsdatainfo.xyza_saveddata.DSC.L2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t1851 = 1, tsdatainfo.xyza_saveddata.DSC.U1 + 1 -        
     .       1         tsdatainfo.xyza_saveddata.DSC.L1                         
     .                 %IG17(t1851,t1849,t1847+1) = tsdatainfo.xyza_saveddata(  
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1851-1,t1849-1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,t1847+               
     .       3            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .                 %IG17(t1851,t1849+1,t1847+1) = tsdatainfo.xyza_saveddata(
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1851-1,t1849+       
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,t1847+               
     .       3            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .                 %IG17(t1851,t1849+2,t1847+1) = tsdatainfo.xyza_saveddata(
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1851-1,t1849+1+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,t1847+               
     .       3            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .                 %IG17(t1851,t1849+3,t1847+1) = tsdatainfo.xyza_saveddata(
     .       1            tsdatainfo.xyza_saveddata.DSC.L1+t1851-1,t1849+2+     
     .       2            tsdatainfo.xyza_saveddata.DSC.L2,t1847+               
     .       3            tsdatainfo.xyza_saveddata.DSC.L3,1)                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   488            & TSDataInfo%NVLevels, TSDataInfo%z_VLevels, & ! (in )
   489            & TSDataInfo%xyza_SavedData(:,:,:,1),        & ! (in )
   490            & xyz_Press,                                 & ! (in )
   491            & xyz_Var,                                   & ! (out)
   492            & FlagLogVLev, FlagLog, FlagPositiveDef      & ! (in ) optional
   493            & )
   494        end if
   495  
   496      end if
   497  
   498  
   499    end subroutine SetValuesFromTimeSeries
   500  
   501    !--------------------------------------------------------------------------------------
   502  
   503    subroutine VerticalInterpolation(          &
   504      & NVLevels, z_VLevelsIn, xyz_VarIn,      & ! (in )
   505      & xyz_VLevelsOut,                        & ! (in )
   506      & xyz_VarOut,                            & ! (out)
   507      & FlagLogVLev, FlagLog, FlagPositiveDef  & ! (in ) optional
   508      & )
   509  
   510      ! ⥸塼 ; USE statements
   511      !
   512  
   513      ! ʸ ; Declaration statements
   514      !
   515      implicit none
   516  
   517      integer , intent(in ):: NVLevels
   518      real(DP), intent(in ):: z_VLevelsIn(1:NVLevels)
   519      real(DP), intent(in ):: xyz_VarIn  (0:imax-1, 1:jmax, 1:NVLevels)
   520      real(DP), intent(in ):: xyz_VlevelsOut(0:imax-1, 1:jmax, 1:kmax)
   521      real(DP), intent(out):: xyz_VarOut    (0:imax-1, 1:jmax, 1:kmax)
   522      logical , intent(in ), optional:: FlagLogVLev
   523      logical , intent(in ), optional:: FlagLog
   524      logical , intent(in ), optional:: FlagPositiveDef
   525  
   526  
   527      ! ѿ
   528      ! Work variables
   529      !
   530      logical:: FlagLogVLevLV
   531      logical:: FlagLogLV
   532      logical:: FlagPositiveDefLV
   533      integer:: i
   534      integer:: j
   535      integer:: k
   536      integer:: kk
   537      integer:: xyz_kk(0:imax-1, 1:jmax, 1:kmax)
   538  
   539  
   540      ! ¹ʸ ; Executable statement
   541      !
   542  
   543      ! ǧ
   544      ! Initialization check
   545      !
   546      if ( .not. read_time_series_inited ) then
   547        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   548      end if
   549  
   550      ! Check order of vertical levels
   551      !
   552      if ( z_VlevelsIn(1) < z_VlevelsIn(2) ) then
   553        call MessageNotify( 'E', module_name, 'The order of vertical levels is inappropriate.' )
   554      end if
   555  
   556  
   557      ! Flags are checked
   558      !
   559      if ( present( FlagLogVLev ) ) then
   560        FlagLogVLevLV = FlagLogVLev
   561      else
   562        FlagLogVLevLV = .false.
   563      end if
   564      if ( present( FlagLog ) ) then
   565        FlagLogLV = FlagLog
   566      else
   567        FlagLogLV = .false.
   568      end if
   569      if ( present( FlagPositiveDef ) ) then
   570        FlagPositiveDefLV = FlagPositiveDef
   571      else
   572        FlagPositiveDefLV = .false.
   573      end if
   574  
   575  
   576      xyz_kk = 1
     .        if (xyz_kk.DSC.U2 .gt. 0) then                                    
     .           J1 = and(xyz_kk.DSC.U2,3)                                      
     .  !CDIR    NODEP                                                          
     .           do t534 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t536 = 1, xyz_kk.DSC.U1 + 1                              
     .                 xyz_kk(t536-1,t534,t532+1) = 1                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t534 = J1 + 1, xyz_kk.DSC.U2, 4                             
     .  !CDIR       NODEP                                                       
     .              do t536 = 1, xyz_kk.DSC.U1 + 1                              
     .                 xyz_kk(t536-1,t534,t532+1) = 1                           
     .                 xyz_kk(t536-1,t534+1,t532+1) = 1                         
     .                 xyz_kk(t536-1,t534+2,t532+1) = 1                         
     .                 xyz_kk(t536-1,t534+3,t532+1) = 1                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   577  
   578      do kk = 1, NVLevels-1
   579  
   580        do k = 1, kmax
   581          do j = 1, jmax
   582            do i = 0, imax-1
   583              if ( xyz_VLevelsOut(i,j,k) < z_VLevelsIn(kk) ) then
   584                xyz_kk(i,j,k) = kk
   585              end if
   586            end do
   587          end do
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,1)                                               
     .           do j = 1, J2                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_vlevelsout(i-1,j,k) .lt. z_vlevelsin(kk)) then   
     .                    xyz_kk(i-1,j,k) = kk                                  
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J2 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_vlevelsout(i-1,j,k) .lt. z_vlevelsin(kk)) then   
     .                    xyz_kk(i-1,j,k) = kk                                  
     .                 endif                                                    
     .                 if (xyz_vlevelsout(i-1,j+1,k) .lt. z_vlevelsin(kk)) then 
     .                    xyz_kk(i-1,j+1,k) = kk                                
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   588        end do
   589  
   590      end do
   591  
   592  
   593      if ( FlagLogVLevLV ) then
   594  
   595        if ( FlagLogLV ) then
   596          ! log-log
   597  
   598          do k = 1, kmax
   599            do j = 1, jmax
   600              do i = 0, imax-1
   601  
   602  !!$          if ( xyz_VLevelsOut(i,j,k) > z_VLevelsIn(1) ) then
   603  !!$            xyz_VarOut(i,j,k) = xyz_VarIn(i,j,1)
   604  !!$
   605  !!$!          else if ( xyz_VLevelsOut(i,j,k) < z_VLevelsIn(NVLevels) ) then
   606  !!$!            call MessageNotify( 'E', module_name, 'Vertical level is out of given range.' )
   607  !!$!!            xyz_VarOut(i,j,k) = 0.0d0
   608  !!$
   609  !!$          else
   610  !!$
   611  !!$            xyz_VarOut(i,j,k) = &
   612  !!$              &   ( xyz_VarIn(i,j,xyz_kk(i,j,k)+1)     - xyz_VarIn(i,j,xyz_kk(i,j,k)) ) &
   613  !!$              & / log( z_VLevelsIn   (xyz_kk(i,j,k)+1) / z_VLevelsIn(xyz_kk(i,j,k))   ) &
   614  !!$              & * log( xyz_VLevelsOut(i,j,k)           / z_VLevelsIn(xyz_kk(i,j,k))   ) &
   615  !!$              & + xyz_VarIn(i,j,xyz_kk(i,j,k))
   616  !!$
   617  !!$          end if
   618  
   619  
   620                xyz_VarOut(i,j,k) = &
   621                  &   log(   ( xyz_VarIn(i,j,xyz_kk(i,j,k)+1) + 1.0d-100 )    &
   622                  &        / ( xyz_VarIn(i,j,xyz_kk(i,j,k)  ) + 1.0d-100 )  ) &
   623                  & / log(   z_VLevelsIn   (xyz_kk(i,j,k)+1)                  &
   624                  &        / z_VLevelsIn(xyz_kk(i,j,k))      )                &
   625                  & * log(   xyz_VLevelsOut(i,j,k)                            &
   626                  &        / z_VLevelsIn(xyz_kk(i,j,k))      )                &
   627                  & + log( xyz_VarIn(i,j,xyz_kk(i,j,k)) + 1.0d-100 )
   628                xyz_VarOut(i,j,k) = exp( xyz_VarOut(i,j,k) )
   629  
   630              end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           xyz_varout1 = dlog((xyz_varin(i-1,j,xyz_kk(i-1,j,k)+1)+        
     .       1      1.00000000000000e-100)/(xyz_varin(i-1,j,xyz_kk(i-1,j,k))+   
     .       2      1.00000000000000e-100))/dlog(z_vlevelsin(xyz_kk(i-1,j,k)+1)/
     .       3      (z_vlevelsin(xyz_kk(i-1,j,k))))*dlog(xyz_vlevelsout(i-1,j,k)
     .       4      /(z_vlevelsin(xyz_kk(i-1,j,k)))) + dlog(xyz_varin(i-1,j,    
     .       5      xyz_kk(i-1,j,k))+1.00000000000000e-100)                     
     .           xyz_varout(i-1,j,k) = dexp(xyz_varout1)                        
     .        end do                                                            
   631            end do
   632          end do
   633  
   634        else
   635          ! log-linear
   636  
   637          do k = 1, kmax
   638            do j = 1, jmax
   639              do i = 0, imax-1
   640  
   641                xyz_VarOut(i,j,k) =                            &
   642                  &   (   xyz_VarIn(i,j,xyz_kk(i,j,k)+1)       &
   643                  &     - xyz_VarIn(i,j,xyz_kk(i,j,k)  )     ) &
   644                  & / log(   z_VLevelsIn   (xyz_kk(i,j,k)+1)   &
   645                  &        / z_VLevelsIn(xyz_kk(i,j,k))      ) &
   646                  & * log(   xyz_VLevelsOut(i,j,k)             &
   647                  &        / z_VLevelsIn(xyz_kk(i,j,k))      ) &
   648                  & + xyz_VarIn(i,j,xyz_kk(i,j,k))
   649  
   650              end do
   651            end do
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .           do j = 1, J3                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xyz_varout(i-1,j,k) = (xyz_varin(i-1,j,xyz_kk(i-1,j,k)+1)
     .       1            -xyz_varin(i-1,j,xyz_kk(i-1,j,k)))/dlog(z_vlevelsin(  
     .       2            xyz_kk(i-1,j,k)+1)/(z_vlevelsin(xyz_kk(i-1,j,k))))*   
     .       3            dlog(xyz_vlevelsout(i-1,j,k)/(z_vlevelsin(xyz_kk(i-1,j
     .       4            ,k)))) + xyz_varin(i-1,j,xyz_kk(i-1,j,k))             
     .              end do                                                      
     .           end do                                                         
     .           do j = J3 + 1, jmax, 4                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xyz_varout(i-1,j,k) = (xyz_varin(i-1,j,xyz_kk(i-1,j,k)+1)
     .       1            -xyz_varin(i-1,j,xyz_kk(i-1,j,k)))/dlog(z_vlevelsin(  
     .       2            xyz_kk(i-1,j,k)+1)/(z_vlevelsin(xyz_kk(i-1,j,k))))*   
     .       3            dlog(xyz_vlevelsout(i-1,j,k)/(z_vlevelsin(xyz_kk(i-1,j
     .       4            ,k)))) + xyz_varin(i-1,j,xyz_kk(i-1,j,k))             
     .                 xyz_varout(i-1,j+1,k) = (xyz_varin(i-1,1+j,xyz_kk(i-1,j+1
     .       1            ,k)+1)-xyz_varin(i-1,1+j,xyz_kk(i-1,j+1,k)))/dlog(    
     .       2            z_vlevelsin(xyz_kk(i-1,j+1,k)+1)/(z_vlevelsin(xyz_kk(i
     .       3            -1,j+1,k))))*dlog(xyz_vlevelsout(i-1,j+1,k)/(         
     .       4            z_vlevelsin(xyz_kk(i-1,j+1,k)))) + xyz_varin(i-1,1+j, 
     .       5            xyz_kk(i-1,j+1,k))                                    
     .                 xyz_varout(i-1,j+2,k) = (xyz_varin(i-1,2+j,xyz_kk(i-1,j+2
     .       1            ,k)+1)-xyz_varin(i-1,2+j,xyz_kk(i-1,j+2,k)))/dlog(    
     .       2            z_vlevelsin(xyz_kk(i-1,j+2,k)+1)/(z_vlevelsin(xyz_kk(i
     .       3            -1,j+2,k))))*dlog(xyz_vlevelsout(i-1,j+2,k)/(         
     .       4            z_vlevelsin(xyz_kk(i-1,j+2,k)))) + xyz_varin(i-1,2+j, 
     .       5            xyz_kk(i-1,j+2,k))                                    
     .                 xyz_varout(i-1,j+3,k) = (xyz_varin(i-1,3+j,xyz_kk(i-1,j+3
     .       1            ,k)+1)-xyz_varin(i-1,3+j,xyz_kk(i-1,j+3,k)))/dlog(    
     .       2            z_vlevelsin(xyz_kk(i-1,j+3,k)+1)/(z_vlevelsin(xyz_kk(i
     .       3            -1,j+3,k))))*dlog(xyz_vlevelsout(i-1,j+3,k)/(         
     .       4            z_vlevelsin(xyz_kk(i-1,j+3,k)))) + xyz_varin(i-1,3+j, 
     .       5            xyz_kk(i-1,j+3,k))                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   652          end do
   653  
   654        end if
   655  
   656      else
   657  
   658        if ( FlagLogLV ) then
   659          ! linear-log
   660  
   661          do k = 1, kmax
   662            do j = 1, jmax
   663              do i = 0, imax-1
   664  
   665                xyz_VarOut(i,j,k) = &
   666                  &   log(   ( xyz_VarIn(i,j,xyz_kk(i,j,k)+1) + 1.0d-100 )    &
   667                  &        / ( xyz_VarIn(i,j,xyz_kk(i,j,k)  ) + 1.0d-100 )  ) &
   668                  & / (   z_VLevelsIn(xyz_kk(i,j,k)+1)                        &
   669                  &     - z_VLevelsIn(xyz_kk(i,j,k)  )    )                   &
   670                  & * (   xyz_VLevelsOut(i,j,k)                               &
   671                  &     - z_VLevelsIn(xyz_kk(i,j,k))      )                   &
   672                  & + log( xyz_VarIn(i,j,xyz_kk(i,j,k)) + 1.0d-100 )
   673                xyz_VarOut(i,j,k) = exp( xyz_VarOut(i,j,k) )
   674  
   675              end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           xyz_varout2 = dlog((xyz_varin(i-1,j,xyz_kk(i-1,j,k)+1)+        
     .       1      1.00000000000000e-100)/(xyz_varin(i-1,j,xyz_kk(i-1,j,k))+   
     .       2      1.00000000000000e-100))/(z_vlevelsin(xyz_kk(i-1,j,k)+1)-(   
     .       3      z_vlevelsin(xyz_kk(i-1,j,k))))*(xyz_vlevelsout(i-1,j,k)-(   
     .       4      z_vlevelsin(xyz_kk(i-1,j,k)))) + dlog(xyz_varin(i-1,j,xyz_kk
     .       5      (i-1,j,k))+1.00000000000000e-100)                           
     .           xyz_varout(i-1,j,k) = dexp(xyz_varout2)                        
     .        end do                                                            
   676            end do
   677          end do
   678  
   679        else
   680          ! linear-linear
   681  
   682          do k = 1, kmax
   683            do j = 1, jmax
   684              do i = 0, imax-1
   685  
   686                xyz_VarOut(i,j,k) = &
   687                  &   (   xyz_VarIn(i,j,xyz_kk(i,j,k)+1)   &
   688                  &     - xyz_VarIn(i,j,xyz_kk(i,j,k)  ) ) &
   689                  & / (   z_VLevelsIn(xyz_kk(i,j,k)+1)     &
   690                  &     - z_VLevelsIn(xyz_kk(i,j,k)  )   ) &
   691                  & * (   xyz_VLevelsOut(i,j,k)            &
   692                  &     - z_VLevelsIn(xyz_kk(i,j,k))     ) &
   693                  & + xyz_VarIn(i,j,xyz_kk(i,j,k))
   694  
   695              end do
   696            end do
     .        if (jmax .gt. 0) then                                             
     .           J4 = and(jmax,3)                                               
     .           do j = 1, J4                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xyz_varout(i-1,j,k) = (xyz_varin(i-1,j,xyz_kk(i-1,j,k)+1)
     .       1            -xyz_varin(i-1,j,xyz_kk(i-1,j,k)))/(z_vlevelsin(xyz_kk
     .       2            (i-1,j,k)+1)-(z_vlevelsin(xyz_kk(i-1,j,k))))*(        
     .       3            xyz_vlevelsout(i-1,j,k)-(z_vlevelsin(xyz_kk(i-1,j,k)))
     .       4            ) + xyz_varin(i-1,j,xyz_kk(i-1,j,k))                  
     .              end do                                                      
     .           end do                                                         
     .           do j = J4 + 1, jmax, 4                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xyz_varout(i-1,j,k) = (xyz_varin(i-1,j,xyz_kk(i-1,j,k)+1)
     .       1            -xyz_varin(i-1,j,xyz_kk(i-1,j,k)))/(z_vlevelsin(xyz_kk
     .       2            (i-1,j,k)+1)-(z_vlevelsin(xyz_kk(i-1,j,k))))*(        
     .       3            xyz_vlevelsout(i-1,j,k)-(z_vlevelsin(xyz_kk(i-1,j,k)))
     .       4            ) + xyz_varin(i-1,j,xyz_kk(i-1,j,k))                  
     .                 xyz_varout(i-1,j+1,k) = (xyz_varin(i-1,1+j,xyz_kk(i-1,j+1
     .       1            ,k)+1)-xyz_varin(i-1,1+j,xyz_kk(i-1,j+1,k)))/(        
     .       2            z_vlevelsin(xyz_kk(i-1,j+1,k)+1)-(z_vlevelsin(xyz_kk(i
     .       3            -1,j+1,k))))*(xyz_vlevelsout(i-1,j+1,k)-(z_vlevelsin( 
     .       4            xyz_kk(i-1,j+1,k)))) + xyz_varin(i-1,1+j,xyz_kk(i-1,j+
     .       5            1,k))                                                 
     .                 xyz_varout(i-1,j+2,k) = (xyz_varin(i-1,2+j,xyz_kk(i-1,j+2
     .       1            ,k)+1)-xyz_varin(i-1,2+j,xyz_kk(i-1,j+2,k)))/(        
     .       2            z_vlevelsin(xyz_kk(i-1,j+2,k)+1)-(z_vlevelsin(xyz_kk(i
     .       3            -1,j+2,k))))*(xyz_vlevelsout(i-1,j+2,k)-(z_vlevelsin( 
     .       4            xyz_kk(i-1,j+2,k)))) + xyz_varin(i-1,2+j,xyz_kk(i-1,j+
     .       5            2,k))                                                 
     .                 xyz_varout(i-1,j+3,k) = (xyz_varin(i-1,3+j,xyz_kk(i-1,j+3
     .       1            ,k)+1)-xyz_varin(i-1,3+j,xyz_kk(i-1,j+3,k)))/(        
     .       2            z_vlevelsin(xyz_kk(i-1,j+3,k)+1)-(z_vlevelsin(xyz_kk(i
     .       3            -1,j+3,k))))*(xyz_vlevelsout(i-1,j+3,k)-(z_vlevelsin( 
     .       4            xyz_kk(i-1,j+3,k)))) + xyz_varin(i-1,3+j,xyz_kk(i-1,j+
     .       5            3,k))                                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   697          end do
   698  
   699        end if
   700  
   701      end if
   702  
   703  
   704      if ( FlagPositiveDefLV ) then
   705  
   706        do k = 1, kmax
   707          do j = 1, jmax
   708            do i = 0, imax-1
   709  
   710              if ( xyz_VarOut(i,j,k) < 0.0d0 ) then
   711                xyz_VarOut(i,j,k) = 0.0d0
   712              end if
   713  
   714            end do
   715          end do
   716        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do k = 1, kmax*jmax*imax                                          
     .           if (xyz_varout(k-1,1,1) .lt. 0.0000000000000000e+000) then     
     .              xyz_varout(k-1,1,1) = 0.0000000000000000e+000               
     .           endif                                                          
     .        end do                                                            
   717  
   718      end if
   719  
   720  
   721  !!$    i = 0
   722  !!$    j = jmax / 2
   723  !!$    do k = 1, NVLevels
   724  !!$      write( 92, * ) z_VLevelsIn(k), xyz_VarIn(i,j,k)
   725  !!$    end do
   726  !!$    write( 92, * )
   727  !!$    call flush( 92 )
   728  !!$    do k = 1, kmax
   729  !!$      write( 93, * ) xyz_VLevelsOut(i,j,k), xyz_VarOut(i,j,k)
   730  !!$    end do
   731  !!$    write( 93, * )
   732  !!$    call flush( 93 )
   733  !!$    stop
   734  
   735  
   736    end subroutine VerticalInterpolation
   737  
   738    !--------------------------------------------------------------------------------------
   739  
   740    subroutine UpdateTime(     &
   741      & TSDataInfo             & ! (inout)
   742      & )
   743  
   744      ! ⥸塼 ; USE statements
   745      !
   746  
   747      ! μ갷
   748      ! Calendar and Date handler
   749      !
   750      use dc_calendar, only: &
   751        & DC_CAL_DATE             ! ɽǡ.
   752                                  ! Data type for date and time
   753  
   754      ! դӻμ갷
   755      ! Date and time handler
   756      !
   757      use dc_calendar, only: DCCalInquire, DCCalDateCreate, DCCalDateInquire, DCCalDateDifference, DCCalDateChkLeapYear
   758  
   759      ! 
   760      ! Time control
   761      !
   762      use timeset, only: TimeN, InitialDate
   763  
   764      ! ʸ ; Declaration statements
   765      !
   766      implicit none
   767  
   768      type(time_series_data), intent(inout):: TSDataInfo
   769  
   770  
   771      ! ѿ
   772      ! Work variables
   773      !
   774      integer           :: hour_in_day, min_in_hour, day_in_year
   775      integer, pointer  :: day_in_month_ptr(:) => null()
   776      real(DP)          :: sec_in_min, sec_in_day
   777  
   778      integer           :: year
   779      type(DC_CAL_DATE) :: PreYearDate
   780  
   781  
   782      ! ¹ʸ ; Executable statement
   783      !
   784  
   785      ! ǧ
   786      ! Initialization check
   787      !
   788      if ( .not. read_time_series_inited ) then
   789        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   790      end if
   791  
   792  
   793      if ( TSDataInfo % tmax >= 2 ) then
   794  
   795        call DCCalInquire( &
   796          & day_in_month_ptr = day_in_month_ptr , & ! (out)
   797          & hour_in_day      = hour_in_day  , &     ! (out)
   798          & min_in_hour      = min_in_hour  , &     ! (out)
   799          & sec_in_min       = sec_in_min )         ! (out)
   800        day_in_year = sum( day_in_month_ptr )
   801        deallocate( day_in_month_ptr )
   802        sec_in_day  = hour_in_day * min_in_hour * sec_in_min
   803  
   804  
   805        ! Set TSDataInfo % a_time(0)
   806        !
   807  
   808        call DCCalDateInquire(       &
   809          & year       = year,       & ! (out)
   810          & elapse_sec = TimeN,      & ! (in)
   811          & date       = InitialDate & ! (in)
   812          & )
   813        call DCCalDateCreate(        &
   814          & year       = year - 1,   & ! (in)
   815          & month      = 1,          & ! (in)
   816          & day        = 1,          & ! (in)
   817          & hour       = 0,          & ! (in)
   818          & min        = 0,          & ! (in)
   819          & sec        = 0.0_DP,     & ! (in)
   820          & date       = PreYearDate & ! (out)
   821          & )
   822  
   823        if ( DCCalDateChkLeapYear( 0.0_DP, PreYearDate ) ) then
   824          TSDataInfo % a_time(0                ) = &
   825            & - ( ( day_in_year + 1 ) * sec_in_day - TSDataInfo % a_time(TSDataInfo%tmax) )
   826        else
   827          TSDataInfo % a_time(0                ) = &
   828            & - (   day_in_year       * sec_in_day - TSDataInfo % a_time(TSDataInfo%tmax) )
   829        end if
   830  
   831  
   832        ! Set TSDataInfo % a_time(TSDataInfo%tmax+1)
   833        !
   834  
   835        if ( DCCalDateChkLeapYear( TimeN, InitialDate ) ) then
   836          TSDataInfo % a_time(TSDataInfo%tmax+1) = &
   837            &     ( day_in_year + 1 ) * sec_in_day + TSDataInfo % a_time(1              )
   838        else
   839          TSDataInfo % a_time(TSDataInfo%tmax+1) = &
   840            &       day_in_year       * sec_in_day + TSDataInfo % a_time(1              )
   841        end if
   842  
   843  
   844      end if
   845  
   846  
   847    end subroutine UpdateTime
   848  
   849    !--------------------------------------------------------------------------------------
   850  
   851    subroutine StructureInit(     &
   852      & FileName, VarName, NDims, &
   853      & TSDataInfo                &
   854      & )
   855  
   856      ! ⥸塼 ; USE statements
   857      !
   858  
   859      ! gtool4 ǡ
   860      ! Gtool4 data input
   861      !
   862      use gtool_history, only: HistoryGet, HistoryGetPointer
   863  
   864      ! ʸ
   865      ! Character handling
   866      !
   867      use dc_string, only: toChar
   868  
   869      ! դӻμ갷
   870      ! Date and time handler
   871      !
   872      use dc_calendar, only: DCCalInquire, DCCalDateEvalSecOfYear
   873  
   874      ! 
   875      ! Time control
   876      !
   877      use timeset, only: TimeN, InitialDate
   878  
   879      ! NetCDF wrapper
   880      !
   881      use netcdf_wrapper, only: NWGetAtt, NWInqDimLen
   882  
   883  
   884      ! ʸ ; Declaration statements
   885      !
   886      implicit none
   887  
   888      character(*)          , intent(in   ):: FileName
   889                                ! ե̾.
   890                                ! File name
   891      character(*)          , intent(in   ):: VarName
   892                                ! ѿ̾.
   893                                ! Variable name
   894      integer               , intent(in   ):: NDims
   895                                ! ְʳѿμ.
   896                                ! Number of dimensions except for time dimension
   897      type(time_series_data), intent(inout):: TSDataInfo
   898  
   899  
   900      ! ѿ
   901      ! Work variables
   902      !
   903      real(DP)         :: SecOfYear
   904  !!$    real(DP), pointer:: a_time(:)
   905      integer          :: tindex
   906      integer          :: t
   907  
   908      character(STRING):: VLevelName
   909  
   910      character(STRING):: attchar
   911  
   912      integer:: hour_in_day, min_in_hour, day_in_year
   913      integer, pointer:: day_in_month_ptr(:) => null()
   914      real(DP):: sec_in_min, sec_in_day
   915  
   916      ! ¹ʸ ; Executable statement
   917      !
   918  
   919      ! ǧ
   920      ! Initialization check
   921      !
   922      if ( .not. read_time_series_inited ) then
   923        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   924      end if
   925  
   926  
   927  !!$    nullify( a_time )
   928  
   929  
   930      call DCCalInquire( &
   931        & day_in_month_ptr = day_in_month_ptr , & ! (out)
   932        & hour_in_day      = hour_in_day  , &     ! (out)
   933        & min_in_hour      = min_in_hour  , &     ! (out)
   934        & sec_in_min       = sec_in_min )         ! (out)
   935      day_in_year = sum( day_in_month_ptr )
   936      deallocate( day_in_month_ptr )
   937      sec_in_day  = hour_in_day * min_in_hour * sec_in_min
   938  
   939  
   940      TSDataInfo % FileName = FileName
   941      TSDataInfo % VarName  = VarName
   942      TSDataInfo % NDims    = NDims
   943  
   944  
   945      if ( TSDataInfo % NDims == 2 ) then
   946        TSDataInfo % NVLevels = 1
   947      else
   948        VLevelName = "plev"
   949  
   950        call HistoryGetPointer(               &
   951          & TSDataInfo%FileName,              &
   952          & VLevelName,                       &
   953          & TSDataInfo % z_VLevels,           &
   954          & flag_mpi_split = flag_mpi_split   &
   955          & )
   956        TSDataInfo % NVLevels = size( TSDataInfo % z_Vlevels )
   957  
   958      end if
   959  
   960  
   961      !-----
   962  !!$    call HistoryGetPointer(               &
   963  !!$      & TSDataInfo%FileName,              &
   964  !!$      & 'time',                           &
   965  !!$      & a_time,                           &
   966  !!$      & flag_mpi_split = flag_mpi_split   &
   967  !!$      & )
   968  !!$    TSDataInfo % tmax = size( a_time )
   969  !!$
   970  !!$    call NWGetAtt( TSDataInfo%FileName, 'time', 'units', attchar )
   971  !!$    if ( ( attchar(1:3) == 'day' ) .or. &
   972  !!$      &  ( attchar(1:3) == 'DAY' ) .or. &
   973  !!$      &  ( attchar(1:3) == 'Day' ) ) then
   974  !!$      a_time = a_time * DAY_SECONDS
   975  !!$    else
   976  !!$      call MessageNotify( 'E', module_name, 'Unit of time, %c, is not supported.', c1 = trim(attchar) )
   977  !!$    end if
   978      !-----
   979  
   980  
   981      call NWInqDimLen( &
   982        & TSDataInfo%FileName,    & ! (in )
   983        & 'time', & ! (in )
   984        & TSDataInfo%tmax      & ! (out)
   985        & )
   986  
   987  
   988      if ( TSDataInfo % tmax >= 2 ) then
   989  
   990        SecOfYear = DCCalDateEvalSecOfYear( TimeN, date = InitialDate )
   991  
   992        !-----
   993  !!$      allocate( TSDataInfo % a_time(0:TSDataInfo%tmax+1) )
   994  !!$      TSDataInfo % a_time(0) = - ( YEAR_DAYS * DAY_SECONDS - a_time(TSDataInfo%tmax) )
   995  !!$      do t = 1, TSDataInfo%tmax
   996  !!$        TSDataInfo % a_time(t) = a_time(t)
   997  !!$      end do
   998  !!$      TSDataInfo % a_time(TSDataInfo%tmax+1) = YEAR_DAYS * DAY_SECONDS + a_time(1)
   999  !!$      deallocate( a_time )
  1000        !-----
  1001  
  1002  
  1003        allocate( TSDataInfo % a_time(0:TSDataInfo%tmax+1) )
  1004        call HistoryGet(               &
  1005          & TSDataInfo%FileName,              &
  1006          & 'time',                           &
  1007          & TSDataInfo%a_time(1:TSDataInfo%tmax),                           &
  1008          & flag_mpi_split = flag_mpi_split   &
  1009          & )
  1010        call NWGetAtt( TSDataInfo%FileName, 'time', 'units', attchar )
  1011  
  1012        if ( ( attchar(1:3) == 'day' ) .or. &
  1013          &  ( attchar(1:3) == 'DAY' ) .or. &
  1014          &  ( attchar(1:3) == 'Day' ) ) then
  1015  
  1016          TSDataInfo%a_time(1:TSDataInfo%tmax) = &
  1017            & TSDataInfo%a_time(1:TSDataInfo%tmax) * sec_in_day
  1018        else
  1019          call MessageNotify( 'E', module_name, 'Unit of time, %c, is not supported.', &
  1020            & c1 = trim(attchar) )
  1021        end if
  1022  
  1023        TSDataInfo % a_time(0                ) = &
  1024          & - ( day_in_year * sec_in_day - TSDataInfo % a_time(TSDataInfo%tmax) )
  1025        TSDataInfo % a_time(TSDataInfo%tmax+1) = &
  1026          &     day_in_year * sec_in_day + TSDataInfo % a_time(1              )
  1027  
  1028  
  1029        allocate( TSDataInfo % a_tindex(1:2) )
  1030        allocate( TSDataInfo % xyza_SavedData(0:imax-1,1:jmax,1:TSDataInfo%NVLevels,1:2) )
  1031  
  1032        TSDataInfo % a_tindex(1) = 0
  1033        TSDataInfo % a_tindex(2) = 1
  1034        do t = 1, TSDataInfo%tmax
  1035          if ( TSDataInfo % a_time(t) <= SecOfYear ) then
  1036            TSDataInfo % a_tindex(1) = t
  1037            TSDataInfo % a_tindex(2) = t+1
  1038          end if
  1039        end do
     .           tsdatainfo.a_tindex1 = tsdatainfo.a_tindex(1)                  
     .        if (tsdatainfo%tmax .gt. 0) then                                  
     .           tsdatainfo.a_tindex2 = tsdatainfo.a_tindex(2)                  
     .  !CDIR    NODEP                                                          
     .           do t = 1, tsdatainfo%tmax                                      
     .              if (tsdatainfo.a_time(t) .le. secofyear) then               
     .                 tsdatainfo.a_tindex1 = (t)                               
     .                 tsdatainfo.a_tindex2 = t + 1                             
     .              endif                                                       
     .           end do                                                         
     .           tsdatainfo.a_tindex(2) = tsdatainfo.a_tindex2                  
     .           tsdatainfo.a_tindex(1) = tsdatainfo.a_tindex1                  
     .        endif                                                             
  1040  
  1041        tindex = TSDataInfo % a_tindex(1)
  1042        if ( tindex == 0 ) then
  1043          tindex = TSDataInfo % tmax
  1044        else if ( tindex == TSDataInfo % tmax + 1 ) then
  1045          tindex = 1
  1046        else
  1047          tindex = tindex
  1048        end if
  1049  
  1050        if ( TSDataInfo % NDims == 2 ) then
  1051          call HistoryGet(                                       &
  1052            & TSDataInfo%FileName,                               &
  1053            & TSDataInfo%VarName,                                &
  1054            & TSDataInfo%xyza_SavedData(:,:,1,1),                &
  1055            & range = 'time=^'//toChar(tindex),                  &
  1056            & flag_mpi_split = flag_mpi_split                    &
  1057            & )
  1058        else
  1059          call HistoryGet(                                       &
  1060            & TSDataInfo%FileName,                               &
  1061            & TSDataInfo%VarName,                                &
  1062            & TSDataInfo%xyza_SavedData(:,:,:,1),                &
  1063            & range = 'time=^'//toChar(tindex),                  &
  1064            & flag_mpi_split = flag_mpi_split                    &
  1065            & )
  1066        end if
  1067  
  1068        tindex = TSDataInfo % a_tindex(2)
  1069        if ( tindex == 0 ) then
  1070          tindex = TSDataInfo % tmax
  1071        else if ( tindex == TSDataInfo % tmax + 1 ) then
  1072          tindex = 1
  1073        else
  1074          tindex = tindex
  1075        end if
  1076  
  1077        if ( TSDataInfo % NDims == 2 ) then
  1078          call HistoryGet(                                       &
  1079            & TSDataInfo%FileName,                               &
  1080            & TSDataInfo%VarName,                                &
  1081            & TSDataInfo%xyza_SavedData(:,:,1,2),                &
  1082            & range = 'time=^'//toChar(tindex),                  &
  1083            & flag_mpi_split = flag_mpi_split                    &
  1084            & )
  1085        else
  1086          call HistoryGet(                                       &
  1087            & TSDataInfo%FileName,                               &
  1088            & TSDataInfo%VarName,                                &
  1089            & TSDataInfo%xyza_SavedData(:,:,:,2),                &
  1090            & range = 'time=^'//toChar(tindex),                  &
  1091            & flag_mpi_split = flag_mpi_split                    &
  1092            & )
  1093        end if
  1094  
  1095        allocate( TSDataInfo%xyz_VarTimeInterpolated(0:imax-1, 1:jmax, 1:TSDataInfo%NVLevels) )
  1096  
  1097      else
  1098  
  1099        !-----
  1100  !!$      allocate( TSDataInfo % a_time(TSDataInfo%tmax) )
  1101  !!$      do t = 1, TSDataInfo%tmax
  1102  !!$        TSDataInfo % a_time(t) = a_time(t)
  1103  !!$      end do
  1104        !-----
  1105  
  1106  
  1107        allocate( TSDataInfo % a_time(TSDataInfo%tmax) )
  1108        call HistoryGet(               &
  1109          & TSDataInfo%FileName,              &
  1110          & 'time',                           &
  1111          & TSDataInfo%a_time(1:TSDataInfo%tmax),                           &
  1112          & flag_mpi_split = flag_mpi_split   &
  1113          & )
  1114        call NWGetAtt( TSDataInfo%FileName, 'time', 'units', attchar )
  1115        if ( ( attchar(1:3) == 'day' ) .or. &
  1116          &  ( attchar(1:3) == 'DAY' ) .or. &
  1117          &  ( attchar(1:3) == 'Day' ) ) then
  1118          TSDataInfo%a_time(1:TSDataInfo%tmax) = &
  1119            & TSDataInfo%a_time(1:TSDataInfo%tmax) * sec_in_day
  1120        else
  1121          call MessageNotify( 'E', module_name, 'Unit of time, %c, is not supported.', &
  1122            & c1 = trim(attchar) )
  1123        end if
  1124  
  1125        allocate( TSDataInfo % a_tindex(1:1) )
  1126        allocate( TSDataInfo % xyza_SavedData(0:imax-1,1:jmax,1:TSDataInfo%NVLevels,1:1) )
  1127  
  1128        TSDataInfo % a_tindex(1) = 1
  1129  
  1130        if ( TSDataInfo % NDims == 2 ) then
  1131          call HistoryGet(                                       &
  1132            & TSDataInfo%FileName,                               &
  1133            & TSDataInfo%VarName,                                &
  1134            & TSDataInfo%xyza_SavedData(:,:,1,1),                &
  1135            & range = 'time=^'//toChar(TSDataInfo%a_tindex(1)),  &
  1136            & flag_mpi_split = flag_mpi_split                    &
  1137            & )
  1138        else
  1139          call HistoryGet(                                       &
  1140            & TSDataInfo%FileName,                               &
  1141            & TSDataInfo%VarName,                                &
  1142            & TSDataInfo%xyza_SavedData(:,:,:,1),                &
  1143            & range = 'time=^'//toChar(TSDataInfo%a_tindex(1)),  &
  1144            & flag_mpi_split = flag_mpi_split                    &
  1145            & )
  1146        end if
  1147  
  1148      end if
  1149  
  1150  
  1151    end subroutine StructureInit
  1152  
  1153    !--------------------------------------------------------------------------------------
  1154  
  1155    subroutine ReadTimeSeriesInit
  1156  
  1157      ! ե
  1158      ! File I/O support
  1159      !
  1160      use dc_iounit, only: FileOpen
  1161  
  1162      ! NAMELIST եϤ˴ؤ桼ƥƥ
  1163      ! Utilities for NAMELIST file input
  1164      !
  1165      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
  1166  
  1167  
  1168      ! ʸ ; Declaration statements
  1169      !
  1170  
  1171      logical :: flag_mpi_init
  1172  
  1173      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
  1174                                ! Unit number for NAMELIST file open
  1175      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
  1176                                ! IOSTAT of NAMELIST read
  1177  
  1178      ! NAMELIST ѿ
  1179      ! NAMELIST group name
  1180      !
  1181  !!$    namelist /read_time_series_nml/ &
  1182  !!$      &
  1183            !
  1184            ! ǥեͤˤĤƤϽ³ "read_time_series#ReadTimeSeriesInit"
  1185            ! Υɤ򻲾ȤΤ.
  1186            !
  1187            ! Refer to source codes in the initialization procedure
  1188            ! "read_time_series#ReadTimeSeriesInit" for the default values.
  1189            !
  1190  
  1191      if ( read_time_series_inited ) return
  1192  
  1193  
  1194      ! ǥեͤ
  1195      ! Default values settings
  1196      !
  1197  
  1198  
  1199      ! NAMELIST ɤ߹
  1200      ! NAMELIST is input
  1201      !
  1202  !!$    if ( trim(namelist_filename) /= '' ) then
  1203  !!$      call FileOpen( unit_nml, &          ! (out)
  1204  !!$        & namelist_filename, mode = 'r' ) ! (in)
  1205  !!$
  1206  !!$      rewind( unit_nml )
  1207  !!$      read( unit_nml,                     & ! (in)
  1208  !!$        & nml = read_time_series_nml,       & ! (out)
  1209  !!$        & iostat = iostat_nml )             ! (out)
  1210  !!$      close( unit_nml )
  1211  !!$
  1212  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
  1213  !!$    end if
  1214  
  1215  
  1216  
  1217      !  ; Print
  1218      !
  1219      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
  1220  !!$    call MessageNotify( 'M', module_name, 'InFileName = %c', c1 = trim(InFileName) )
  1221      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
  1222  
  1223  
  1224      read_time_series_inited = .true.
  1225  
  1226  
  1227    end subroutine ReadTimeSeriesInit
  1228  
  1229    !--------------------------------------------------------------------------------------
  1230  
  1231  end module read_time_series
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:43 2012
FILE NAME: read_time_series.f90
PROGRAM NAME: read_time_series
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ǡɤ߹
     2:            !
     3:            != Reading time series
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Satoshi NODA
     6:            ! Version::   $Id: read_time_series.f90,v 1.14 2012-07-27 00:52:39 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module read_time_series
    13:              !
    14:              != ǡɤ߹
    15:              !
    16:              != Reading time series
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ɽ̲, O3 ̤ʤɤλǡ NetCDF ե뤫ɤ߹. 
    21:              !
    22:              ! Reading time series data, such as sea surface temperature, O3, and so on, from 
    23:              ! NetCDF file. 
    24:              !
    25:              !== Procedures List
    26:            !!$  ! GroundFileGet    :: ɽ̥ǡե
    27:            !!$  !--
    28:            !!$  ! GroundFileOpen   :: ɽ̥ǡեΥץ
    29:            !!$  ! GroundFileOutput :: ɽ̥ǡեؤΥǡ
    30:            !!$  ! GroundFileClose  :: ɽ̥ǡեΥ
    31:              !++
    32:              ! ------------     :: ------------
    33:            !!$  ! GroundFileGet    :: Input ground data file
    34:            !!$  !--
    35:            !!$  ! GroundFileOpen   :: Open ground data file
    36:            !!$  ! GroundFileOutput :: Data output to ground data file
    37:            !!$  ! GroundFileClose  :: Close ground data file
    38:              !++
    39:              !
    40:              !== NAMELIST
    41:              !
    42:            !!$  ! NAMELIST#ground_file_io_nml
    43:              !
    44:            
    45:              ! ⥸塼 ; USE statements
    46:              !
    47:            
    48:              ! ̷ѥ᥿
    49:              ! Kind type parameter
    50:              !
    51:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    52:                &                 STRING, &  ! ʸ.       Strings. 
    53:                &                 TOKEN      ! .   Keywords. 
    54:            
    55:              ! å
    56:              ! Message output
    57:              !
    58:              use dc_message, only: MessageNotify
    59:            
    60:              ! ʻ
    61:              ! Grid points settings
    62:              !
    63:              use gridset, only: imax, & ! ٳʻ. 
    64:                                         ! Number of grid points in longitude
    65:                &                jmax, & ! ٳʻ. 
    66:                                         ! Number of grid points in latitude
    67:                &                kmax    ! ľؿ. 
    68:                                         ! Number of vertical level
    69:            
    70:              ! ʸ ; Declaration statements
    71:              !
    72:              implicit none
    73:              private
    74:            
    75:              ! ³
    76:              ! Public procedure
    77:              !
    78:              public:: SetValuesFromTimeSeriesWrapper
    79:            !!$  public:: SetValuesFromTimeSeries
    80:              public:: ReadTimeSeriesInit
    81:            
    82:              ! ѿ
    83:              ! Public variables
    84:              !
    85:              logical, save :: read_time_series_inited = .false.
    86:                                          ! ե饰. 
    87:                                          ! Initialization flag
    88:            
    89:            
    90:              type time_series_data
    91:                character(STRING):: FileName
    92:                                          ! ե̾. 
    93:                                          ! File name
    94:                character(STRING):: VarName
    95:                                          ! ѿ̾. 
    96:                                          ! Variable name
    97:                integer          :: NDims
    98:                integer          :: tmax
    99:                integer          :: NVLevels
   100:                real(DP), pointer:: z_VLevels(:)
   101:                real(DP), pointer:: a_time(:)
   102:                integer , pointer:: a_tindex(:)
   103:                real(DP), pointer:: xyza_SavedData(:,:,:,:)
   104:                real(DP), pointer:: xyz_VarTimeInterpolated(:,:,:)
   105:              end type time_series_data
   106:            
   107:              logical, save :: flag_mpi_split = .true.
   108:            
   109:              type(time_series_data), save :: TSDataInfoSST
   110:              type(time_series_data), save :: TSDataInfoSIC
   111:              type(time_series_data), save :: TSDataInfoO3
   112:              type(time_series_data), save :: TSDataInfoDOD
   113:            
   114:            
   115:              ! ѿ
   116:              ! Private variables
   117:              !
   118:            
   119:            
   120:              character(*), parameter:: module_name = 'read_time_series_from_file'
   121:                                          ! ⥸塼̾. 
   122:                                          ! Module name
   123:              character(*), parameter:: version = &
   124:                & '$Name: dcpam5-20120921 $' // &
   125:                & '$Id: read_time_series.f90,v 1.14 2012-07-27 00:52:39 yot Exp $'
   126:                                          ! ⥸塼ΥС
   127:                                          ! Module version
   128:            
   129:              ! INTERFACE ʸ ; INTERFACE statements
   130:              !
   131:              interface SetValuesFromTimeSeriesWrapper
   132:                module procedure SetValFromTimeSeriesWrapper2D, SetValFromTimeSeriesWrapper3D
   133:              end interface
   134:            
   135:            contains
   136:            
   137:              !--------------------------------------------------------------------------------------
   138:            
   139:              subroutine SetValFromTimeSeriesWrapper2D( &
   140:                & FileName, VarName, &
   141:                & xy_Var,            &               ! (inout)
   142:                & keyword            &
   143:                & )
   144:            
   145:            
   146:                ! ʸ ; Declaration statements
   147:                !
   148:                implicit none
   149:            
   150:                character(*), intent(in   ):: FileName
   151:                                          ! ե̾. 
   152:                                          ! File name
   153:                character(*), intent(in   ):: VarName
   154:                                          ! ѿ̾. 
   155:                                          ! Variable name
   156:                real(DP)    , intent(inout):: xy_Var(0:imax-1, 1:jmax)
   157:                                          ! ɽ̲. 
   158:                                          ! Surface temperature
   159:                character(*), intent(in   ):: keyword
   160:            
   161:            
   162:                ! ǧ
   163:                ! Initialization check
   164:                !
   165:                if ( .not. read_time_series_inited ) then
   166:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   167:                end if
   168:            
   169:            
   170:                if ( keyword == 'SST' ) then
   171:                  call SetValuesFromTimeSeries( &
   172:                    & TSDataInfoSST,     &
   173:                    & FileName, VarName, &
   174:                    & xy_Var = xy_Var    &               ! (inout)
   175:                    & )
   176:                else if ( keyword == 'SIC' ) then
   177:                  call SetValuesFromTimeSeries( &
   178:                    & TSDataInfoSIC,     &
   179:                    & FileName, VarName, &
   180:                    & xy_Var = xy_Var    &               ! (inout)
   181:                    & )
   182:                else if ( keyword == 'DOD' ) then
   183:                  call SetValuesFromTimeSeries( &
   184:                    & TSDataInfoDOD,     &
   185:                    & FileName, VarName, &
   186:                    & xy_Var = xy_Var    &               ! (inout)
   187:                    & )
   188:                else
   189:                  stop 'Unsupported keyword'
   190:                end if
   191:            
   192:            
   193:              end subroutine SetValFromTimeSeriesWrapper2D
   194:            
   195:              !--------------------------------------------------------------------------------------
   196:            
   197:              subroutine SetValFromTimeSeriesWrapper3D( &
   198:                & FileName, VarName, &
   199:                & xyz_Press,         &               ! (in)
   200:                & xyz_Var,           &               ! (inout)
   201:                & keyword            &
   202:                & )
   203:            
   204:            
   205:                ! ʸ ; Declaration statements
   206:                !
   207:                implicit none
   208:            
   209:                character(*), intent(in   ):: FileName
   210:                                          ! ե̾. 
   211:                                          ! File name
   212:                character(*), intent(in   ):: VarName
   213:                                          ! ѿ̾. 
   214:                                          ! Variable name
   215:                real(DP)    , intent(in   ):: xyz_Press(0:imax-1, 1:jmax, 1:kmax)
   216:                                          ! ɽ̲. 
   217:                                          ! Surface temperature
   218:                real(DP)    , intent(inout):: xyz_Var(0:imax-1, 1:jmax, 1:kmax)
   219:                                          ! ɽ̲. 
   220:                                          ! Surface temperature
   221:                character(*), intent(in   ):: keyword
   222:            
   223:            
   224:                ! ǧ
   225:                ! Initialization check
   226:                !
   227:                if ( .not. read_time_series_inited ) then
   228:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   229:                end if
   230:            
   231:            
   232:                if ( keyword == 'O3' ) then
   233:                  call SetValuesFromTimeSeries( &
   234:                    & TSDataInfoO3,          &
   235:                    & FileName, VarName,     &
   236:                    & xyz_Press = xyz_Press, &           ! (in)
   237:                    & xyz_Var = xyz_Var,      &           ! (inout)
   238:                    & FlagLogVLev     = .true.,  &
   239:                    & FlagLog         = .true.,  &
   240:                    & FlagPositiveDef = .true.   & ! (in ) optional
   241:                    & )
   242:                else
   243:                  stop 'Unsupported keyword'
   244:                end if
   245:            
   246:            
   247:              end subroutine SetValFromTimeSeriesWrapper3D
   248:            
   249:              !--------------------------------------------------------------------------------------
   250:            
   251:              subroutine SetValuesFromTimeSeries(          &
   252:                & TSDataInfo,                              &
   253:                & FileName, VarName,                       &
   254:                & xyz_Press,                               & ! (in   ) optional
   255:                & xy_Var,                                  & ! (inout) optional
   256:                & xyz_Var,                                 & ! (inout) optional
   257:                & FlagLogVLev, FlagLog, FlagPositiveDef    & ! (in   ) optional
   258:                & )
   259:                !
   260:                ! ɽ̤νΥǡꤷޤ. 
   261:                ! xy_SurfTemp ʳϰܤ˸ƤФ줿Τꤵޤ. 
   262:                !
   263:                ! Get various data on ground. 
   264:                ! Arguments excluding "xy_SurfTemp" are configured at first only. 
   265:                !
   266:            
   267:                ! ⥸塼 ; USE statements
   268:                !
   269:            
   270:                ! gtool4 ǡ
   271:                ! Gtool4 data input
   272:                !
   273:                use gtool_history, only: HistoryGet
   274:            
   275:                ! ʸ
   276:                ! Character handling
   277:                !
   278:                use dc_string, only: toChar
   279:            
   280:                ! դӻμ갷
   281:                ! Date and time handler
   282:                !
   283:                use dc_calendar, only: DCCalDateEvalSecOfYear
   284:            
   285:                ! 
   286:                ! Time control
   287:                !
   288:                use timeset, only: TimeN, InitialDate
   289:            
   290:                ! ʸ ; Declaration statements
   291:                !
   292:                implicit none
   293:            
   294:                type(time_series_data), intent(inout):: TSDataInfo
   295:                character(*)          , intent(in   ):: FileName
   296:                                          ! ե̾. 
   297:                                          ! File name
   298:                character(*)          , intent(in   ):: VarName
   299:                                          ! ѿ̾. 
   300:                                          ! Variable name
   301:                real(DP)    , optional, intent(in   ):: xyz_Press(0:imax-1, 1:jmax, 1:kmax)
   302:                                          ! 3 . 
   303:                                          ! 3D array
   304:                real(DP)    , optional, intent(inout):: xy_Var (0:imax-1, 1:jmax)
   305:                                          ! 2 . 
   306:                                          ! 2D array
   307:                real(DP)    , optional, intent(inout):: xyz_Var(0:imax-1, 1:jmax, 1:kmax)
   308:                                          ! 3 . 
   309:                                          ! 3D array
   310:                logical     , optional, intent(in   ):: FlagLogVLev
   311:                logical     , optional, intent(in   ):: FlagLog
   312:                logical     , optional, intent(in   ):: FlagPositiveDef
   313:            
   314:                ! ѿ
   315:                ! Work variables
   316:                !
   317:                real(DP):: SecOfYear
   318:                integer :: tindex
   319:            
   320:            !!$    real(DP):: xyza_VarInterpolated(0:imax-1, 1:jmax, 1:kmax, 2)
   321:            
   322:                integer :: t
   323:            
   324:            
   325:                ! ǧ
   326:                ! Initialization check
   327:                !
   328:                if ( .not. read_time_series_inited ) then
   329:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   330:                end if
   331:            
   332:            
   333:                if ( ( .not. present( xy_Var ) ) .and. ( .not. present( xyz_Var ) ) ) then
   334:                  call MessageNotify( 'E', module_name, 'xy_Var or xyz_Var have to be given.' )
   335:                end if
   336:            
   337:                if ( ( present( xyz_Var ) ) .and. ( .not. present( xyz_Press ) ) ) then
   338:                  call MessageNotify( 'E', module_name, 'xyz_Press has to be given, when xyz_Var is given.' )
   339:                end if
   340:            
   341:                ! ¹ʸ ; Executable statement
   342:                !
   343:                if ( .not. associated( TSDataInfo % a_time ) ) then
   344:                  if ( present( xy_Var ) ) then
   345:                    call StructureInit(       &
   346:                      & FileName, VarName, 2, &
   347:                      & TSDataInfo            &
   348:                      & )
   349:                  else
   350:                    call StructureInit(       &
   351:                      & FileName, VarName, 3, &
   352:                      & TSDataInfo            &
   353:                      & )
   354:                  end if
   355:                end if
   356:            
   357:            
   358:                ! Update values of time paying attention to leap year
   359:                !
   360:                call UpdateTime(     &
   361:                  & TSDataInfo             & ! (inout)
   362:                  & )
   363:            
   364:            
   365:                if ( TSDataInfo % tmax >= 2 ) then
   366:            
   367:                  SecOfYear = DCCalDateEvalSecOfYear( TimeN, date = InitialDate )
   368:            
   369:            !!$      write( 6, * ) TSDataInfo%a_time(TSDataInfo%a_tindex(1)), &
   370:            !!$        & SecOfYear, TSDataInfo%a_time(TSDataInfo%a_tindex(2))
   371:            
   372:                  if ( ( SecOfYear <   TSDataInfo%a_time(TSDataInfo%a_tindex(1)) ) .or. &
   373:                    &  ( SecOfYear >=  TSDataInfo%a_time(TSDataInfo%a_tindex(2)) ) ) then
   374:            
   375:                    TSDataInfo % a_tindex(1) = 0
   376:                    TSDataInfo % a_tindex(2) = 1
   377: V------>           do t = 1, TSDataInfo%tmax
   378: |                    if ( TSDataInfo % a_time(t) <= SecOfYear ) then
   379: |                      TSDataInfo % a_tindex(1) = t
   380: |                      TSDataInfo % a_tindex(2) = t+1
   381: |                    end if
   382: V------            end do
   383:            
   384:            !!$        write( 6, * ) '##############################################'
   385:            !!$        write( 6, * ) '##############################################'
   386:            !!$        write( 6, * ) '##############################################'
   387:            !!$        write( 6, * ) '##############################################'
   388:            !!$        write( 6, * ) '##############################################'
   389:            !!$        write( 6, * ) 'in if', TSDataInfo % a_tindex(1), TSDataInfo % a_tindex(2)
   390:            !!$        write( 6, * ) '##############################################'
   391:            !!$        write( 6, * ) '##############################################'
   392:            !!$        write( 6, * ) '##############################################'
   393:            !!$        write( 6, * ) '##############################################'
   394:            !!$        write( 6, * ) '##############################################'
   395:            
   396:                    tindex = TSDataInfo % a_tindex(1)
   397:                    if ( tindex == 0 ) then
   398:                      tindex = TSDataInfo % tmax
   399:                    else if ( tindex == TSDataInfo % tmax + 1 ) then
   400:                      tindex = 1
   401:                    else
   402:                      tindex = tindex
   403:                    end if
   404:            
   405:                    if ( present( xy_Var ) ) then
   406:                      call HistoryGet(                                       &
   407:                        & TSDataInfo%FileName,                               &
   408:                        & TSDataInfo%VarName,                                &
   409:                        & TSDataInfo%xyza_SavedData(:,:,1,1),                &
   410:                        & range = 'time=^'//toChar(tindex),                  &
   411:                        & flag_mpi_split = flag_mpi_split                    &
   412:                        & )
   413:                    else
   414:                      call HistoryGet(                                       &
   415:                        & TSDataInfo%FileName,                               &
   416:                        & TSDataInfo%VarName,                                &
   417:                        & TSDataInfo%xyza_SavedData(:,:,:,1),                &
   418:                        & range = 'time=^'//toChar(tindex),                  &
   419:                        & flag_mpi_split = flag_mpi_split                    &
   420:                        & )
   421:                    end if
   422:            
   423:                    tindex = TSDataInfo % a_tindex(2)
   424:                    if ( tindex == 0 ) then
   425:                      tindex = TSDataInfo % tmax
   426:                    else if ( tindex == TSDataInfo % tmax + 1 ) then
   427:                      tindex = 1
   428:                    else
   429:                      tindex = tindex
   430:                    end if
   431:            
   432:                    if ( present( xy_Var ) ) then
   433:                      call HistoryGet(                                       &
   434:                        & TSDataInfo%FileName,                               &
   435:                        & TSDataInfo%VarName,                                &
   436:                        & TSDataInfo%xyza_SavedData(:,:,1,2),                &
   437:                        & range = 'time=^'//toChar(tindex),                  &
   438:                        & flag_mpi_split = flag_mpi_split                    &
   439:                        & )
   440:                    else
   441:                      call HistoryGet(                                       &
   442:                        & TSDataInfo%FileName,                               &
   443:                        & TSDataInfo%VarName,                                &
   444:                        & TSDataInfo%xyza_SavedData(:,:,:,2),                &
   445:                        & range = 'time=^'//toChar(tindex),                  &
   446:                        & flag_mpi_split = flag_mpi_split                    &
   447:                        & )
   448:                    end if
   449:            
   450:                  end if
   451:            
   452:                  if ( present( xy_Var ) ) then
   453: +V=====            xy_Var =                                              &
   454:                      &   ( TSDataInfo%xyza_SavedData(:,:,1,2)    &
   455:                      &   - TSDataInfo%xyza_SavedData(:,:,1,1)  ) &
   456:                      & / ( TSDataInfo%a_time(TSDataInfo%a_tindex(2))    &
   457:                      &   - TSDataInfo%a_time(TSDataInfo%a_tindex(1))  ) &
   458:                      & * ( SecOfYear                                     &
   459:                      &    - TSDataInfo%a_time(TSDataInfo%a_tindex(1))  ) &
   460:                      & + TSDataInfo%xyza_SavedData(:,:,1,1)
   461:                  else
   462:            
   463: ++V====            TSDataInfo%xyz_VarTimeInterpolated =                  &
   464:                      &   ( TSDataInfo%xyza_SavedData(:,:,:,2)            &
   465:                      &   - TSDataInfo%xyza_SavedData(:,:,:,1)  )         &
   466:                      & / ( TSDataInfo%a_time(TSDataInfo%a_tindex(2))     &
   467:                      &   - TSDataInfo%a_time(TSDataInfo%a_tindex(1))  )  &
   468:                      & * ( SecOfYear                                     &
   469:                      &    - TSDataInfo%a_time(TSDataInfo%a_tindex(1))  ) &
   470:                      & + TSDataInfo%xyza_SavedData(:,:,:,1)
   471:            
   472:                    call VerticalInterpolation(                    &
   473:                      & TSDataInfo%NVLevels, TSDataInfo%z_VLevels, & ! (in )
   474:                      & TSDataInfo%xyz_VarTimeInterpolated,        & ! (in )
   475:                      & xyz_Press,                                 & ! (in )
   476:                      & xyz_Var,                                   & ! (out)
   477:                      & FlagLogVLev, FlagLog, FlagPositiveDef      & ! (in ) optional
   478:                      & )
   479:            
   480:                  end if
   481:            
   482:                else
   483:            
   484:                  if ( present( xy_Var ) ) then
   485: +V=====            xy_Var = TSDataInfo%xyza_SavedData(:,:,1,1)
   486:                  else
   487: ++V====            call VerticalInterpolation(                    &
   488:                      & TSDataInfo%NVLevels, TSDataInfo%z_VLevels, & ! (in )
   489:                      & TSDataInfo%xyza_SavedData(:,:,:,1),        & ! (in )
   490:                      & xyz_Press,                                 & ! (in )
   491:                      & xyz_Var,                                   & ! (out)
   492:                      & FlagLogVLev, FlagLog, FlagPositiveDef      & ! (in ) optional
   493:                      & )
   494:                  end if
   495:            
   496:                end if
   497:            
   498:            
   499:              end subroutine SetValuesFromTimeSeries
   500:            
   501:              !--------------------------------------------------------------------------------------
   502:            
   503:              subroutine VerticalInterpolation(          &
   504:                & NVLevels, z_VLevelsIn, xyz_VarIn,      & ! (in )
   505:                & xyz_VLevelsOut,                        & ! (in )
   506:                & xyz_VarOut,                            & ! (out)
   507:                & FlagLogVLev, FlagLog, FlagPositiveDef  & ! (in ) optional
   508:                & )
   509:            
   510:                ! ⥸塼 ; USE statements
   511:                !
   512:            
   513:                ! ʸ ; Declaration statements
   514:                !
   515:                implicit none
   516:            
   517:                integer , intent(in ):: NVLevels
   518:                real(DP), intent(in ):: z_VLevelsIn(1:NVLevels)
   519:                real(DP), intent(in ):: xyz_VarIn  (0:imax-1, 1:jmax, 1:NVLevels)
   520:                real(DP), intent(in ):: xyz_VlevelsOut(0:imax-1, 1:jmax, 1:kmax)
   521:                real(DP), intent(out):: xyz_VarOut    (0:imax-1, 1:jmax, 1:kmax)
   522:                logical , intent(in ), optional:: FlagLogVLev
   523:                logical , intent(in ), optional:: FlagLog
   524:                logical , intent(in ), optional:: FlagPositiveDef
   525:            
   526:            
   527:                ! ѿ
   528:                ! Work variables
   529:                !
   530:                logical:: FlagLogVLevLV
   531:                logical:: FlagLogLV
   532:                logical:: FlagPositiveDefLV
   533:                integer:: i
   534:                integer:: j
   535:                integer:: k
   536:                integer:: kk
   537:                integer:: xyz_kk(0:imax-1, 1:jmax, 1:kmax)
   538:            
   539:            
   540:                ! ¹ʸ ; Executable statement
   541:                !
   542:            
   543:                ! ǧ
   544:                ! Initialization check
   545:                !
   546:                if ( .not. read_time_series_inited ) then
   547:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   548:                end if
   549:            
   550:                ! Check order of vertical levels
   551:                !
   552:                if ( z_VlevelsIn(1) < z_VlevelsIn(2) ) then
   553:                  call MessageNotify( 'E', module_name, 'The order of vertical levels is inappropriate.' )
   554:                end if
   555:            
   556:            
   557:                ! Flags are checked
   558:                !
   559:                if ( present( FlagLogVLev ) ) then
   560:                  FlagLogVLevLV = FlagLogVLev
   561:                else
   562:                  FlagLogVLevLV = .false.
   563:                end if
   564:                if ( present( FlagLog ) ) then
   565:                  FlagLogLV = FlagLog
   566:                else
   567:                  FlagLogLV = .false.
   568:                end if
   569:                if ( present( FlagPositiveDef ) ) then
   570:                  FlagPositiveDefLV = FlagPositiveDef
   571:                else
   572:                  FlagPositiveDefLV = .false.
   573:                end if
   574:            
   575:            
   576: ++V====        xyz_kk = 1
   577:            
   578: +------>       do kk = 1, NVLevels-1
   579: |          
   580: |+----->         do k = 1, kmax
   581: ||+---->           do j = 1, jmax
   582: |||V--->             do i = 0, imax-1
   583: ||||                   if ( xyz_VLevelsOut(i,j,k) < z_VLevelsIn(kk) ) then
   584: ||||                     xyz_kk(i,j,k) = kk
   585: ||||                   end if
   586: |||V---              end do
   587: ||+----            end do
   588: |+-----          end do
   589: |          
   590: +------        end do
   591:            
   592:            
   593:                if ( FlagLogVLevLV ) then
   594:            
   595:                  if ( FlagLogLV ) then
   596:                    ! log-log
   597:            
   598: +------>           do k = 1, kmax
   599: |+----->             do j = 1, jmax
   600: ||V---->               do i = 0, imax-1
   601: |||        
   602: |||        !!$          if ( xyz_VLevelsOut(i,j,k) > z_VLevelsIn(1) ) then
   603: |||        !!$            xyz_VarOut(i,j,k) = xyz_VarIn(i,j,1)
   604: |||        !!$
   605: |||        !!$!          else if ( xyz_VLevelsOut(i,j,k) < z_VLevelsIn(NVLevels) ) then
   606: |||        !!$!            call MessageNotify( 'E', module_name, 'Vertical level is out of given range.' )
   607: |||        !!$!!            xyz_VarOut(i,j,k) = 0.0d0
   608: |||        !!$
   609: |||        !!$          else
   610: |||        !!$
   611: |||        !!$            xyz_VarOut(i,j,k) = &
   612: |||        !!$              &   ( xyz_VarIn(i,j,xyz_kk(i,j,k)+1)     - xyz_VarIn(i,j,xyz_kk(i,j,k)) ) &
   613: |||        !!$              & / log( z_VLevelsIn   (xyz_kk(i,j,k)+1) / z_VLevelsIn(xyz_kk(i,j,k))   ) &
   614: |||        !!$              & * log( xyz_VLevelsOut(i,j,k)           / z_VLevelsIn(xyz_kk(i,j,k))   ) &
   615: |||        !!$              & + xyz_VarIn(i,j,xyz_kk(i,j,k))
   616: |||        !!$
   617: |||        !!$          end if
   618: |||        
   619: |||        
   620: |||                      xyz_VarOut(i,j,k) = &
   621: |||                        &   log(   ( xyz_VarIn(i,j,xyz_kk(i,j,k)+1) + 1.0d-100 )    &
   622: |||                        &        / ( xyz_VarIn(i,j,xyz_kk(i,j,k)  ) + 1.0d-100 )  ) &
   623: |||                        & / log(   z_VLevelsIn   (xyz_kk(i,j,k)+1)                  &
   624: |||                        &        / z_VLevelsIn(xyz_kk(i,j,k))      )                &
   625: |||                        & * log(   xyz_VLevelsOut(i,j,k)                            &
   626: |||                        &        / z_VLevelsIn(xyz_kk(i,j,k))      )                &
   627: |||                        & + log( xyz_VarIn(i,j,xyz_kk(i,j,k)) + 1.0d-100 )
   628: |||                      xyz_VarOut(i,j,k) = exp( xyz_VarOut(i,j,k) )
   629: |||        
   630: ||V----                end do
   631: |+-----              end do
   632: +------            end do
   633:            
   634:                  else
   635:                    ! log-linear
   636:            
   637: +------>           do k = 1, kmax
   638: |+----->             do j = 1, jmax
   639: ||V---->               do i = 0, imax-1
   640: |||        
   641: |||                      xyz_VarOut(i,j,k) =                            &
   642: |||                        &   (   xyz_VarIn(i,j,xyz_kk(i,j,k)+1)       &
   643: |||                        &     - xyz_VarIn(i,j,xyz_kk(i,j,k)  )     ) &
   644: |||                        & / log(   z_VLevelsIn   (xyz_kk(i,j,k)+1)   &
   645: |||                        &        / z_VLevelsIn(xyz_kk(i,j,k))      ) &
   646: |||                        & * log(   xyz_VLevelsOut(i,j,k)             &
   647: |||                        &        / z_VLevelsIn(xyz_kk(i,j,k))      ) &
   648: |||                        & + xyz_VarIn(i,j,xyz_kk(i,j,k))
   649: |||        
   650: ||V----                end do
   651: |+-----              end do
   652: +------            end do
   653:            
   654:                  end if
   655:            
   656:                else
   657:            
   658:                  if ( FlagLogLV ) then
   659:                    ! linear-log
   660:            
   661: +------>           do k = 1, kmax
   662: |+----->             do j = 1, jmax
   663: ||V---->               do i = 0, imax-1
   664: |||        
   665: |||                      xyz_VarOut(i,j,k) = &
   666: |||                        &   log(   ( xyz_VarIn(i,j,xyz_kk(i,j,k)+1) + 1.0d-100 )    &
   667: |||                        &        / ( xyz_VarIn(i,j,xyz_kk(i,j,k)  ) + 1.0d-100 )  ) &
   668: |||                        & / (   z_VLevelsIn(xyz_kk(i,j,k)+1)                        &
   669: |||                        &     - z_VLevelsIn(xyz_kk(i,j,k)  )    )                   &
   670: |||                        & * (   xyz_VLevelsOut(i,j,k)                               &
   671: |||                        &     - z_VLevelsIn(xyz_kk(i,j,k))      )                   &
   672: |||                        & + log( xyz_VarIn(i,j,xyz_kk(i,j,k)) + 1.0d-100 )
   673: |||                      xyz_VarOut(i,j,k) = exp( xyz_VarOut(i,j,k) )
   674: |||        
   675: ||V----                end do
   676: |+-----              end do
   677: +------            end do
   678:            
   679:                  else
   680:                    ! linear-linear
   681:            
   682: +------>           do k = 1, kmax
   683: |+----->             do j = 1, jmax
   684: ||V---->               do i = 0, imax-1
   685: |||        
   686: |||                      xyz_VarOut(i,j,k) = &
   687: |||                        &   (   xyz_VarIn(i,j,xyz_kk(i,j,k)+1)   &
   688: |||                        &     - xyz_VarIn(i,j,xyz_kk(i,j,k)  ) ) &
   689: |||                        & / (   z_VLevelsIn(xyz_kk(i,j,k)+1)     &
   690: |||                        &     - z_VLevelsIn(xyz_kk(i,j,k)  )   ) &
   691: |||                        & * (   xyz_VLevelsOut(i,j,k)            &
   692: |||                        &     - z_VLevelsIn(xyz_kk(i,j,k))     ) &
   693: |||                        & + xyz_VarIn(i,j,xyz_kk(i,j,k))
   694: |||        
   695: ||V----                end do
   696: |+-----              end do
   697: +------            end do
   698:            
   699:                  end if
   700:            
   701:                end if
   702:            
   703:            
   704:                if ( FlagPositiveDefLV ) then
   705:            
   706: W------>         do k = 1, kmax
   707: |+----->           do j = 1, jmax
   708: ||+---->             do i = 0, imax-1
   709: |||        
   710: |||                    if ( xyz_VarOut(i,j,k) < 0.0d0 ) then
   711: |||                      xyz_VarOut(i,j,k) = 0.0d0
   712: |||                    end if
   713: |||        
   714: ||+----              end do
   715: |+-----            end do
   716: W------          end do
   717:            
   718:                end if
   719:            
   720:            
   721:            !!$    i = 0
   722:            !!$    j = jmax / 2
   723:            !!$    do k = 1, NVLevels
   724:            !!$      write( 92, * ) z_VLevelsIn(k), xyz_VarIn(i,j,k)
   725:            !!$    end do
   726:            !!$    write( 92, * )
   727:            !!$    call flush( 92 )
   728:            !!$    do k = 1, kmax
   729:            !!$      write( 93, * ) xyz_VLevelsOut(i,j,k), xyz_VarOut(i,j,k)
   730:            !!$    end do
   731:            !!$    write( 93, * )
   732:            !!$    call flush( 93 )
   733:            !!$    stop
   734:            
   735:            
   736:              end subroutine VerticalInterpolation
   737:            
   738:              !--------------------------------------------------------------------------------------
   739:            
   740:              subroutine UpdateTime(     &
   741:                & TSDataInfo             & ! (inout)
   742:                & )
   743:            
   744:                ! ⥸塼 ; USE statements
   745:                !
   746:            
   747:                ! μ갷
   748:                ! Calendar and Date handler
   749:                !
   750:                use dc_calendar, only: &
   751:                  & DC_CAL_DATE             ! ɽǡ.
   752:                                            ! Data type for date and time
   753:            
   754:                ! դӻμ갷
   755:                ! Date and time handler
   756:                !
   757:                use dc_calendar, only: DCCalInquire, DCCalDateCreate, DCCalDateInquire, DCCalDateDifference, DCCalDateChkLeapYear
   758:            
   759:                ! 
   760:                ! Time control
   761:                !
   762:                use timeset, only: TimeN, InitialDate
   763:            
   764:                ! ʸ ; Declaration statements
   765:                !
   766:                implicit none
   767:            
   768:                type(time_series_data), intent(inout):: TSDataInfo
   769:            
   770:            
   771:                ! ѿ
   772:                ! Work variables
   773:                !
   774:                integer           :: hour_in_day, min_in_hour, day_in_year
   775:                integer, pointer  :: day_in_month_ptr(:) => null()
   776:                real(DP)          :: sec_in_min, sec_in_day
   777:            
   778:                integer           :: year
   779:                type(DC_CAL_DATE) :: PreYearDate
   780:            
   781:            
   782:                ! ¹ʸ ; Executable statement
   783:                !
   784:            
   785:                ! ǧ
   786:                ! Initialization check
   787:                !
   788:                if ( .not. read_time_series_inited ) then
   789:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   790:                end if
   791:            
   792:            
   793:                if ( TSDataInfo % tmax >= 2 ) then
   794:            
   795:                  call DCCalInquire( &
   796:                    & day_in_month_ptr = day_in_month_ptr , & ! (out)
   797:                    & hour_in_day      = hour_in_day  , &     ! (out)
   798:                    & min_in_hour      = min_in_hour  , &     ! (out)
   799:                    & sec_in_min       = sec_in_min )         ! (out)
   800: V======          day_in_year = sum( day_in_month_ptr )
   801:                  deallocate( day_in_month_ptr )
   802:                  sec_in_day  = hour_in_day * min_in_hour * sec_in_min
   803:            
   804:            
   805:                  ! Set TSDataInfo % a_time(0)
   806:                  !
   807:            
   808:                  call DCCalDateInquire(       &
   809:                    & year       = year,       & ! (out)
   810:                    & elapse_sec = TimeN,      & ! (in)
   811:                    & date       = InitialDate & ! (in)
   812:                    & )
   813:                  call DCCalDateCreate(        &
   814:                    & year       = year - 1,   & ! (in)
   815:                    & month      = 1,          & ! (in)
   816:                    & day        = 1,          & ! (in)
   817:                    & hour       = 0,          & ! (in)
   818:                    & min        = 0,          & ! (in)
   819:                    & sec        = 0.0_DP,     & ! (in)
   820:                    & date       = PreYearDate & ! (out)
   821:                    & )
   822:            
   823:                  if ( DCCalDateChkLeapYear( 0.0_DP, PreYearDate ) ) then
   824:                    TSDataInfo % a_time(0                ) = &
   825:                      & - ( ( day_in_year + 1 ) * sec_in_day - TSDataInfo % a_time(TSDataInfo%tmax) )
   826:                  else
   827:                    TSDataInfo % a_time(0                ) = &
   828:                      & - (   day_in_year       * sec_in_day - TSDataInfo % a_time(TSDataInfo%tmax) )
   829:                  end if
   830:            
   831:            
   832:                  ! Set TSDataInfo % a_time(TSDataInfo%tmax+1)
   833:                  !
   834:            
   835:                  if ( DCCalDateChkLeapYear( TimeN, InitialDate ) ) then
   836:                    TSDataInfo % a_time(TSDataInfo%tmax+1) = &
   837:                      &     ( day_in_year + 1 ) * sec_in_day + TSDataInfo % a_time(1              )
   838:                  else
   839:                    TSDataInfo % a_time(TSDataInfo%tmax+1) = &
   840:                      &       day_in_year       * sec_in_day + TSDataInfo % a_time(1              )
   841:                  end if
   842:            
   843:            
   844:                end if
   845:            
   846:            
   847:              end subroutine UpdateTime
   848:            
   849:              !--------------------------------------------------------------------------------------
   850:            
   851:              subroutine StructureInit(     &
   852:                & FileName, VarName, NDims, &
   853:                & TSDataInfo                &
   854:                & )
   855:            
   856:                ! ⥸塼 ; USE statements
   857:                !
   858:            
   859:                ! gtool4 ǡ
   860:                ! Gtool4 data input
   861:                !
   862:                use gtool_history, only: HistoryGet, HistoryGetPointer
   863:            
   864:                ! ʸ
   865:                ! Character handling
   866:                !
   867:                use dc_string, only: toChar
   868:            
   869:                ! դӻμ갷
   870:                ! Date and time handler
   871:                !
   872:                use dc_calendar, only: DCCalInquire, DCCalDateEvalSecOfYear
   873:            
   874:                ! 
   875:                ! Time control
   876:                !
   877:                use timeset, only: TimeN, InitialDate
   878:            
   879:                ! NetCDF wrapper
   880:                !
   881:                use netcdf_wrapper, only: NWGetAtt, NWInqDimLen
   882:            
   883:            
   884:                ! ʸ ; Declaration statements
   885:                !
   886:                implicit none
   887:            
   888:                character(*)          , intent(in   ):: FileName
   889:                                          ! ե̾. 
   890:                                          ! File name
   891:                character(*)          , intent(in   ):: VarName
   892:                                          ! ѿ̾. 
   893:                                          ! Variable name
   894:                integer               , intent(in   ):: NDims
   895:                                          ! ְʳѿμ. 
   896:                                          ! Number of dimensions except for time dimension
   897:                type(time_series_data), intent(inout):: TSDataInfo
   898:            
   899:            
   900:                ! ѿ
   901:                ! Work variables
   902:                !
   903:                real(DP)         :: SecOfYear
   904:            !!$    real(DP), pointer:: a_time(:)
   905:                integer          :: tindex
   906:                integer          :: t
   907:            
   908:                character(STRING):: VLevelName
   909:            
   910:                character(STRING):: attchar
   911:            
   912:                integer:: hour_in_day, min_in_hour, day_in_year
   913:                integer, pointer:: day_in_month_ptr(:) => null()
   914:                real(DP):: sec_in_min, sec_in_day
   915:            
   916:                ! ¹ʸ ; Executable statement
   917:                !
   918:            
   919:                ! ǧ
   920:                ! Initialization check
   921:                !
   922:                if ( .not. read_time_series_inited ) then
   923:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   924:                end if
   925:            
   926:            
   927:            !!$    nullify( a_time )
   928:            
   929:            
   930:                call DCCalInquire( &
   931:                  & day_in_month_ptr = day_in_month_ptr , & ! (out)
   932:                  & hour_in_day      = hour_in_day  , &     ! (out)
   933:                  & min_in_hour      = min_in_hour  , &     ! (out)
   934:                  & sec_in_min       = sec_in_min )         ! (out)
   935: V======        day_in_year = sum( day_in_month_ptr )
   936:                deallocate( day_in_month_ptr )
   937:                sec_in_day  = hour_in_day * min_in_hour * sec_in_min
   938:            
   939:            
   940:                TSDataInfo % FileName = FileName
   941:                TSDataInfo % VarName  = VarName
   942:                TSDataInfo % NDims    = NDims
   943:            
   944:            
   945:                if ( TSDataInfo % NDims == 2 ) then
   946:                  TSDataInfo % NVLevels = 1
   947:                else
   948:                  VLevelName = "plev"
   949:            
   950:                  call HistoryGetPointer(               &
   951:                    & TSDataInfo%FileName,              &
   952:                    & VLevelName,                       &
   953:                    & TSDataInfo % z_VLevels,           &
   954:                    & flag_mpi_split = flag_mpi_split   &
   955:                    & )
   956:                  TSDataInfo % NVLevels = size( TSDataInfo % z_Vlevels )
   957:            
   958:                end if
   959:            
   960:            
   961:                !-----
   962:            !!$    call HistoryGetPointer(               &
   963:            !!$      & TSDataInfo%FileName,              &
   964:            !!$      & 'time',                           &
   965:            !!$      & a_time,                           &
   966:            !!$      & flag_mpi_split = flag_mpi_split   &
   967:            !!$      & )
   968:            !!$    TSDataInfo % tmax = size( a_time )
   969:            !!$
   970:            !!$    call NWGetAtt( TSDataInfo%FileName, 'time', 'units', attchar )
   971:            !!$    if ( ( attchar(1:3) == 'day' ) .or. &
   972:            !!$      &  ( attchar(1:3) == 'DAY' ) .or. &
   973:            !!$      &  ( attchar(1:3) == 'Day' ) ) then
   974:            !!$      a_time = a_time * DAY_SECONDS
   975:            !!$    else
   976:            !!$      call MessageNotify( 'E', module_name, 'Unit of time, %c, is not supported.', c1 = trim(attchar) )
   977:            !!$    end if
   978:                !-----
   979:            
   980:            
   981:                call NWInqDimLen( &
   982:                  & TSDataInfo%FileName,    & ! (in )
   983:                  & 'time', & ! (in )
   984:                  & TSDataInfo%tmax      & ! (out)
   985:                  & )
   986:            
   987:            
   988:                if ( TSDataInfo % tmax >= 2 ) then
   989:            
   990:                  SecOfYear = DCCalDateEvalSecOfYear( TimeN, date = InitialDate )
   991:            
   992:                  !-----
   993:            !!$      allocate( TSDataInfo % a_time(0:TSDataInfo%tmax+1) )
   994:            !!$      TSDataInfo % a_time(0) = - ( YEAR_DAYS * DAY_SECONDS - a_time(TSDataInfo%tmax) )
   995:            !!$      do t = 1, TSDataInfo%tmax
   996:            !!$        TSDataInfo % a_time(t) = a_time(t)
   997:            !!$      end do
   998:            !!$      TSDataInfo % a_time(TSDataInfo%tmax+1) = YEAR_DAYS * DAY_SECONDS + a_time(1)
   999:            !!$      deallocate( a_time )
  1000:                  !-----
  1001:            
  1002:            
  1003:                  allocate( TSDataInfo % a_time(0:TSDataInfo%tmax+1) )
  1004:                  call HistoryGet(               &
  1005:                    & TSDataInfo%FileName,              &
  1006:                    & 'time',                           &
  1007:                    & TSDataInfo%a_time(1:TSDataInfo%tmax),                           &
  1008:                    & flag_mpi_split = flag_mpi_split   &
  1009:                    & )
  1010:                  call NWGetAtt( TSDataInfo%FileName, 'time', 'units', attchar )
  1011:            
  1012:                  if ( ( attchar(1:3) == 'day' ) .or. &
  1013:                    &  ( attchar(1:3) == 'DAY' ) .or. &
  1014:                    &  ( attchar(1:3) == 'Day' ) ) then
  1015:            
  1016: V======            TSDataInfo%a_time(1:TSDataInfo%tmax) = &
  1017:                      & TSDataInfo%a_time(1:TSDataInfo%tmax) * sec_in_day
  1018:                  else
  1019:                    call MessageNotify( 'E', module_name, 'Unit of time, %c, is not supported.', &
  1020:                      & c1 = trim(attchar) )
  1021:                  end if
  1022:            
  1023:                  TSDataInfo % a_time(0                ) = &
  1024:                    & - ( day_in_year * sec_in_day - TSDataInfo % a_time(TSDataInfo%tmax) )
  1025:                  TSDataInfo % a_time(TSDataInfo%tmax+1) = &
  1026:                    &     day_in_year * sec_in_day + TSDataInfo % a_time(1              )
  1027:            
  1028:            
  1029:                  allocate( TSDataInfo % a_tindex(1:2) )
  1030:                  allocate( TSDataInfo % xyza_SavedData(0:imax-1,1:jmax,1:TSDataInfo%NVLevels,1:2) )
  1031:            
  1032:                  TSDataInfo % a_tindex(1) = 0
  1033:                  TSDataInfo % a_tindex(2) = 1
  1034: V------>         do t = 1, TSDataInfo%tmax
  1035: |                  if ( TSDataInfo % a_time(t) <= SecOfYear ) then
  1036: |                    TSDataInfo % a_tindex(1) = t
  1037: |                    TSDataInfo % a_tindex(2) = t+1
  1038: |                  end if
  1039: V------          end do
  1040:            
  1041:                  tindex = TSDataInfo % a_tindex(1)
  1042:                  if ( tindex == 0 ) then
  1043:                    tindex = TSDataInfo % tmax
  1044:                  else if ( tindex == TSDataInfo % tmax + 1 ) then
  1045:                    tindex = 1
  1046:                  else
  1047:                    tindex = tindex
  1048:                  end if
  1049:            
  1050:                  if ( TSDataInfo % NDims == 2 ) then
  1051:                    call HistoryGet(                                       &
  1052:                      & TSDataInfo%FileName,                               &
  1053:                      & TSDataInfo%VarName,                                &
  1054:                      & TSDataInfo%xyza_SavedData(:,:,1,1),                &
  1055:                      & range = 'time=^'//toChar(tindex),                  &
  1056:                      & flag_mpi_split = flag_mpi_split                    &
  1057:                      & )
  1058:                  else
  1059:                    call HistoryGet(                                       &
  1060:                      & TSDataInfo%FileName,                               &
  1061:                      & TSDataInfo%VarName,                                &
  1062:                      & TSDataInfo%xyza_SavedData(:,:,:,1),                &
  1063:                      & range = 'time=^'//toChar(tindex),                  &
  1064:                      & flag_mpi_split = flag_mpi_split                    &
  1065:                      & )
  1066:                  end if
  1067:            
  1068:                  tindex = TSDataInfo % a_tindex(2)
  1069:                  if ( tindex == 0 ) then
  1070:                    tindex = TSDataInfo % tmax
  1071:                  else if ( tindex == TSDataInfo % tmax + 1 ) then
  1072:                    tindex = 1
  1073:                  else
  1074:                    tindex = tindex
  1075:                  end if
  1076:            
  1077:                  if ( TSDataInfo % NDims == 2 ) then
  1078:                    call HistoryGet(                                       &
  1079:                      & TSDataInfo%FileName,                               &
  1080:                      & TSDataInfo%VarName,                                &
  1081:                      & TSDataInfo%xyza_SavedData(:,:,1,2),                &
  1082:                      & range = 'time=^'//toChar(tindex),                  &
  1083:                      & flag_mpi_split = flag_mpi_split                    &
  1084:                      & )
  1085:                  else
  1086:                    call HistoryGet(                                       &
  1087:                      & TSDataInfo%FileName,                               &
  1088:                      & TSDataInfo%VarName,                                &
  1089:                      & TSDataInfo%xyza_SavedData(:,:,:,2),                &
  1090:                      & range = 'time=^'//toChar(tindex),                  &
  1091:                      & flag_mpi_split = flag_mpi_split                    &
  1092:                      & )
  1093:                  end if
  1094:            
  1095:                  allocate( TSDataInfo%xyz_VarTimeInterpolated(0:imax-1, 1:jmax, 1:TSDataInfo%NVLevels) )
  1096:            
  1097:                else
  1098:            
  1099:                  !-----
  1100:            !!$      allocate( TSDataInfo % a_time(TSDataInfo%tmax) )
  1101:            !!$      do t = 1, TSDataInfo%tmax
  1102:            !!$        TSDataInfo % a_time(t) = a_time(t)
  1103:            !!$      end do
  1104:                  !-----
  1105:            
  1106:            
  1107:                  allocate( TSDataInfo % a_time(TSDataInfo%tmax) )
  1108:                  call HistoryGet(               &
  1109:                    & TSDataInfo%FileName,              &
  1110:                    & 'time',                           &
  1111:                    & TSDataInfo%a_time(1:TSDataInfo%tmax),                           &
  1112:                    & flag_mpi_split = flag_mpi_split   &
  1113:                    & )
  1114:                  call NWGetAtt( TSDataInfo%FileName, 'time', 'units', attchar )
  1115:                  if ( ( attchar(1:3) == 'day' ) .or. &
  1116:                    &  ( attchar(1:3) == 'DAY' ) .or. &
  1117:                    &  ( attchar(1:3) == 'Day' ) ) then
  1118: V======            TSDataInfo%a_time(1:TSDataInfo%tmax) = &
  1119:                      & TSDataInfo%a_time(1:TSDataInfo%tmax) * sec_in_day
  1120:                  else
  1121:                    call MessageNotify( 'E', module_name, 'Unit of time, %c, is not supported.', &
  1122:                      & c1 = trim(attchar) )
  1123:                  end if
  1124:            
  1125:                  allocate( TSDataInfo % a_tindex(1:1) )
  1126:                  allocate( TSDataInfo % xyza_SavedData(0:imax-1,1:jmax,1:TSDataInfo%NVLevels,1:1) )
  1127:            
  1128:                  TSDataInfo % a_tindex(1) = 1
  1129:            
  1130:                  if ( TSDataInfo % NDims == 2 ) then
  1131:                    call HistoryGet(                                       &
  1132:                      & TSDataInfo%FileName,                               &
  1133:                      & TSDataInfo%VarName,                                &
  1134:                      & TSDataInfo%xyza_SavedData(:,:,1,1),                &
  1135:                      & range = 'time=^'//toChar(TSDataInfo%a_tindex(1)),  &
  1136:                      & flag_mpi_split = flag_mpi_split                    &
  1137:                      & )
  1138:                  else
  1139:                    call HistoryGet(                                       &
  1140:                      & TSDataInfo%FileName,                               &
  1141:                      & TSDataInfo%VarName,                                &
  1142:                      & TSDataInfo%xyza_SavedData(:,:,:,1),                &
  1143:                      & range = 'time=^'//toChar(TSDataInfo%a_tindex(1)),  &
  1144:                      & flag_mpi_split = flag_mpi_split                    &
  1145:                      & )
  1146:                  end if
  1147:            
  1148:                end if
  1149:            
  1150:            
  1151:              end subroutine StructureInit
  1152:            
  1153:              !--------------------------------------------------------------------------------------
  1154:            
  1155:              subroutine ReadTimeSeriesInit
  1156:            
  1157:                ! ե
  1158:                ! File I/O support
  1159:                !
  1160:                use dc_iounit, only: FileOpen
  1161:            
  1162:                ! NAMELIST եϤ˴ؤ桼ƥƥ
  1163:                ! Utilities for NAMELIST file input
  1164:                !
  1165:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
  1166:            
  1167:            
  1168:                ! ʸ ; Declaration statements
  1169:                !
  1170:            
  1171:                logical :: flag_mpi_init
  1172:            
  1173:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
  1174:                                          ! Unit number for NAMELIST file open
  1175:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
  1176:                                          ! IOSTAT of NAMELIST read
  1177:            
  1178:                ! NAMELIST ѿ
  1179:                ! NAMELIST group name
  1180:                !
  1181:            !!$    namelist /read_time_series_nml/ &
  1182:            !!$      & 
  1183:                      !
  1184:                      ! ǥեͤˤĤƤϽ³ "read_time_series#ReadTimeSeriesInit"
  1185:                      ! Υɤ򻲾ȤΤ.
  1186:                      !
  1187:                      ! Refer to source codes in the initialization procedure
  1188:                      ! "read_time_series#ReadTimeSeriesInit" for the default values.
  1189:                      !
  1190:            
  1191:                if ( read_time_series_inited ) return
  1192:            
  1193:            
  1194:                ! ǥեͤ
  1195:                ! Default values settings
  1196:                !
  1197:            
  1198:            
  1199:                ! NAMELIST ɤ߹
  1200:                ! NAMELIST is input
  1201:                !
  1202:            !!$    if ( trim(namelist_filename) /= '' ) then
  1203:            !!$      call FileOpen( unit_nml, &          ! (out)
  1204:            !!$        & namelist_filename, mode = 'r' ) ! (in)
  1205:            !!$
  1206:            !!$      rewind( unit_nml )
  1207:            !!$      read( unit_nml,                     & ! (in)
  1208:            !!$        & nml = read_time_series_nml,       & ! (out)
  1209:            !!$        & iostat = iostat_nml )             ! (out)
  1210:            !!$      close( unit_nml )
  1211:            !!$
  1212:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
  1213:            !!$    end if
  1214:            
  1215:            
  1216:            
  1217:                !  ; Print
  1218:                !
  1219:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
  1220:            !!$    call MessageNotify( 'M', module_name, 'InFileName = %c', c1 = trim(InFileName) )
  1221:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
  1222:            
  1223:            
  1224:                read_time_series_inited = .true.
  1225:            
  1226:            
  1227:              end subroutine ReadTimeSeriesInit
  1228:            
  1229:              !--------------------------------------------------------------------------------------
  1230:            
  1231:            end module read_time_series
