Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:41 2012
FILE NAME: restart_surftemp_io.f90
PROGRAM NAME: restart_surftemp_io
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   366  vec  (   4): Vectorized array expression.
   371  vec  (   4): Vectorized array expression.
   713  vec  (   3): Unvectorized loop.
   713  vec  (  13): Overhead of loop division is too large.
   714  opt  (1592): Outer loop unrolled inside inner loop.
   714  vec  (   4): Vectorized array expression.
   714  vec  (   4): Vectorized array expression.
   717  opt  (  11): Fused array assignments. :line 717 - 723
   717  vec  (   4): Vectorized array expression.
   757  vec  (   3): Unvectorized loop.
   757  vec  (  13): Overhead of loop division is too large.
   758  opt  (1592): Outer loop unrolled inside inner loop.
   758  vec  (   4): Vectorized array expression.
   758  vec  (   4): Vectorized array expression.
   776  opt  (1592): Outer loop unrolled inside inner loop.
   776  vec  (   4): Vectorized array expression.
   776  vec  (   4): Vectorized array expression.
   792  opt  (1592): Outer loop unrolled inside inner loop.
   792  vec  (   4): Vectorized array expression.
   792  vec  (   4): Vectorized array expression.
   808  opt  (1592): Outer loop unrolled inside inner loop.
   808  vec  (   4): Vectorized array expression.
   808  vec  (   4): Vectorized array expression.
   824  opt  (1592): Outer loop unrolled inside inner loop.
   824  vec  (   4): Vectorized array expression.
   824  vec  (   4): Vectorized array expression.
   840  opt  (1592): Outer loop unrolled inside inner loop.
   840  vec  (   4): Vectorized array expression.
   840  vec  (   4): Vectorized array expression.
   856  opt  (1592): Outer loop unrolled inside inner loop.
   856  vec  (   4): Vectorized array expression.
   856  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:41 2012
FILE NAME: restart_surftemp_io.f90
PROGRAM NAME: restart_surftemp_io
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ɽ̲٥ꥹȥǡ, ͥǡ
     2  !
     3  != Restart data, initial data of surface temperature input/output
     4  !
     5  ! Authors::   Yasuhiro Morikawa, Yoshiyuki O. Takahashi
     6  ! Version::   $Id: restart_surftemp_io.f90,v 1.10 2012-09-17 10:59:30 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module restart_surftemp_io
    13    !
    14    != ɽ̲٥ꥹȥǡ, ͥǡ
    15    !
    16    != Restart data, initial data of surface temperature input/output
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ɽ̲٤Υꥹȥǡ⤷ϽͥǡϤԤޤ.
    21    ! ϥե, ϥե, ǡνϤδֳ֤
    22    ! NAMELIST#restart_surftemp_io_nml ꤷޤ.
    23    !
    24    ! ꥹȥǡϥե뤬ꤵʤ,
    25    ! surface_data ⥸塼줿ͥǡޤ.
    26    !
    27    ! Restart data or initial data is input/output.
    28    ! Settings of input file, output file, and interval of data output
    29    ! is configured by "NAMELIST#restart_surftemp_io_nml".
    30    !
    31    ! If input file of restart data is not set,
    32    ! initial data is generated in "surface_data" module, and
    33    ! obtained data from the module.
    34    !
    35    !== Procedures List
    36    !
    37    ! RestartSurfTempOpen   :: ꥹȥեΥץ
    38    ! RestartSurfTempOutput :: ꥹȥեؤΥǡ
    39    ! RestartSurfTempClose  :: ꥹȥեΥ
    40    ! RestartSurfTempGet    :: ꥹȥե
    41    ! ------------      :: ------------
    42    ! RestartSurfTempOpen   :: Open restart file
    43    ! RestartSurfTempOutput :: Data output to restart file
    44    ! RestartSurfTempClose  :: Close restart file
    45    ! RestartSurfTempGet    :: Input restart file
    46    !
    47    !== NAMELIST
    48    !
    49    ! NAMELIST#restart_surftemp_io_nml
    50    !
    51  
    52    ! ⥸塼 ; USE statements
    53    !
    54  
    55    ! ʻ
    56    ! Grid points settings
    57    !
    58    use gridset, only: imax, & ! ٳʻ.
    59                               ! Number of grid points in longitude
    60      &                jmax, & ! ٳʻ.
    61                               ! Number of grid points in latitude
    62      &                kmax, & ! ľؿ.
    63                               ! Number of vertical level
    64      &                kslmax  ! ϲαľؿ.
    65                               ! Number of subsurface vertical level
    66  
    67    ! ̷ѥ᥿
    68    ! Kind type parameter
    69    !
    70    use dc_types, only: DP, &      ! ټ¿. Double precision.
    71      &                 STRING, &  ! ʸ.       Strings.
    72      &                 TOKEN      ! .   Keywords.
    73  
    74    ! å
    75    ! Message output
    76    !
    77    use dc_message, only: MessageNotify
    78  
    79    ! gtool4 ǡ
    80    ! Gtool4 data output
    81    !
    82    use gtool_history, only: GT_HISTORY
    83  
    84    ! ʸ ; Declaration statements
    85    !
    86    implicit none
    87    private
    88  
    89    ! ³
    90    ! Public procedure
    91    !
    92    public :: RestartSurfTempInit
    93    public :: RestartSurfTempOpen, RestartSurfTempClose, RestartSurfTempOutPut
    94    public :: RestartSurfTempGet
    95  
    96    ! ѿ
    97    ! Public variables
    98    !
    99    logical, save, public:: restart_surftemp_io_inited = .false.
   100                                ! ե饰.
   101                                ! Initialization flag
   102  
   103    logical, save, public:: restart_surftemp_opened = .false.
   104                                ! ꥹȥեΥץ˴ؤե饰.
   105                                ! Flag of restart file open
   106  
   107    ! ѿ
   108    ! Private variables
   109    !
   110    logical, save:: flag_init_data_save
   111                                ! ͥǡ,
   112                                ! ΰ .true. Ϳޤ.
   113                                !
   114                                ! If initial data is created,
   115                                ! give ".true." to this argument.
   116  
   117    character(STRING), save:: InputFile
   118                                ! ϤꥹȥǡΥե̾
   119                                ! Filename of input restart data
   120  
   121    ! This is not used, and variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   122  !!$  character(TOKEN), save:: InputName
   123  !!$                              ! Ϥꥹȥǡѿ̾
   124  !!$                              ! Variable name of input restart data
   125  
   126    character(STRING), save:: OutputFile
   127                                ! ϤꥹȥǡΥե̾
   128                                ! Filename of output restart data
   129    real(DP), save:: IntValue
   130                                ! ꥹȥǡνϴֳ.
   131                                ! Interval of restart data output
   132    character(TOKEN):: IntUnit
   133                                ! ꥹȥǡνϴֳ֤ñ.
   134                                ! Unit for interval of restart data output
   135  
   136    type(GT_HISTORY), save:: gthst_rst
   137                                ! ꥹȥǡ gtool_history#GT_HISTORY ѿ
   138                                ! "gtool_history#GT_HISTORY" variable for restart data
   139  
   140    real(DP), save:: PrevOutputTime
   141                                ! νϻ.
   142                                ! Previous output time
   143    logical, save:: flag_output_end
   144                                ! ׻ǽνϴλΥե饰.
   145                                ! Flag for completion of output at the end time of calculation
   146  
   147    real(DP), save:: IntTime
   148                                ! ꥹȥǡνϻ.
   149                                ! Time interval of restart data output
   150  
   151    character(*), parameter:: time_name = 'time'
   152                                ! μѿ̾
   153                                ! Variable name of time dimension
   154    character(*), parameter:: deltime_name = 'deltime'
   155                                ! t ѿ̾
   156                                ! Variable name of Delta t
   157  
   158  
   159    character(*), parameter:: module_name = 'restart_surftemp_io'
   160                                ! ⥸塼̾.
   161                                ! Module name
   162    character(*), parameter:: version = &
   163      & '$Name: dcpam5-20120921 $' // &
   164      & '$Id: restart_surftemp_io.f90,v 1.10 2012-09-17 10:59:30 yot Exp $'
   165                                ! ⥸塼ΥС
   166                                ! Module version
   167  
   168  contains
   169  
   170    !--------------------------------------------------------------------------------------
   171  
   172    subroutine RestartSurfTempOpen( flag_init_data )
   173      !
   174      ! ꥹȥե򥪡ץ󤷤ޤ.
   175      !
   176      ! A restart file is opened.
   177      !
   178  
   179      ! ⥸塼 ; USE statements
   180      !
   181  
   182      ! ϥեδܾ
   183      ! Basic information for output files
   184      !
   185      use fileset, only: &
   186        & FileTitle, &
   187                                ! ϥǡեɽ.
   188                                ! Title of output data files
   189        & FileSource, &
   190                                ! ǡեμ.
   191                                ! Source of data file
   192        & FileInstitution
   193                                ! ǡեǽŪѹȿ/Ŀ.
   194                                ! Institution or person that changes data files for the last time
   195  
   196      ! ʪ
   197      ! Physical and mathematical constants settings
   198      !
   199      use constants0, only: &
   200        & PI                    ! $ \pi $.
   201                                ! ߼Ψ. Circular constant
   202  
   203      ! ɸǡ
   204      ! Axes data settings
   205      !
   206      use axesset, only: &
   207        & x_Lon, &
   208                                ! $ \lambda $ [rad.] . . Longitude
   209        & x_Lon_Weight, &
   210                                ! $ \Delta \lambda $ [rad.] .
   211                                ! ٺɸŤ.
   212                                ! Weight of longitude
   213        & y_Lat, &
   214                                ! $ \varphi $ [rad.] . . Latitude
   215        & y_Lat_Weight, &
   216                                ! $ \Delta \varphi $ [rad.] .
   217                                ! ٺɸŤ.
   218                                ! Weight of latitude
   219        & z_SSDepth
   220                                ! ϲγʻο
   221                                ! subsurface grid at midpoint of layer
   222  
   223      ! 
   224      ! Time control
   225      !
   226      use timeset, only: &
   227        & DelTime, &            ! $ \Delta t $ [s]
   228        & RestartTime           ! ꥹȳϻ.
   229                                ! Retart time of calculation
   230  
   231      ! gtool4 ǡ
   232      ! Gtool4 data output
   233      !
   234      use gtool_history, only: HistoryCreate, HistoryAddVariable, &
   235        & HistoryPut, HistoryAddAttr
   236  
   237      ! ʸ
   238      ! Character handling
   239      !
   240      use dc_string, only: StoA, CPrintf, LChar
   241  
   242      ! Ȥ߹ߴؿ PRESENT γĥǴؿ
   243      ! Extended functions of intrinsic function "PRESENT"
   244      !
   245      use dc_present, only: present_and_true
   246  
   247      ! ʸ ; Declaration statements
   248      !
   249      logical, intent(in), optional:: flag_init_data
   250                                ! ͥǡ,
   251                                ! ΰ .true. Ϳޤ.
   252                                !
   253                                ! If initial data is created,
   254                                ! give ".true." to this argument.
   255  
   256      ! ѿ
   257      ! Work variables
   258      !
   259      character(STRING):: title_msg
   260                                ! ɽղäå.
   261                                ! Message added to title
   262      real(DP):: origin_time
   263                                ! ׻ϻ.
   264                                ! Start time of calculation
   265      character(STRING):: time_unit
   266                                ! ñ. Units of date and time
   267  
   268      logical:: flag_mpi_init
   269  
   270      ! ¹ʸ ; Executable statement
   271      !
   272  
   273      ! 
   274      ! Initialization
   275      !
   276      flag_init_data_save = present_and_true( flag_init_data )
   277      if ( .not. restart_surftemp_io_inited ) then
   278        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   279      end if
   280      if ( restart_surftemp_opened ) return
   281  
   282      ! ɽղäå
   283      ! Configure message added to title
   284      !
   285      if ( .not. flag_init_data_save ) then
   286        title_msg = ' restart data of surface temperature'
   287      else
   288        title_msg = ' initial data of surface temperature'
   289      end if
   290  
   291      ! μ
   292      ! Get time information
   293      !
   294      if ( .not. flag_init_data_save ) then
   295        origin_time = RestartTime + IntTime
   296      else
   297        origin_time = RestartTime
   298      end if
   299  
   300      time_unit = IntUnit
   301  
   302      flag_mpi_init = .true.
   303  
   304      ! ꥹȥեΥץ
   305      ! Open a restart file
   306      !
   307      if ( kslmax /= 0 ) then
   308        call HistoryCreate(                                                     &
   309          &      file = OutputFile,                                             &  ! (in)
   310          &     title = trim(FileTitle) // trim(title_msg),                     &  ! (in)
   311          &    source = FileSource, institution = FileInstitution,              &  ! (in)
   312          &      dims = StoA( 'lon', 'lat', 'dep', time_name ),                 &  ! (in)
   313          &  dimsizes = (/ imax, jmax, kslmax, 0 /),                            &  ! (in)
   314          & longnames = StoA( 'longitude', 'latitude', 'depth   ', time_name ), &  ! (in)
   315          &     units = StoA( 'degree_east', 'degree_north', 'm           ',    &  ! (in)
   316          &                    time_unit ),                                     &  ! (in)
   317          &        origind = origin_time,                                       &  ! (in) optional
   318          &      intervald = IntValue,                                          &  ! (in) optional
   319          & flag_mpi_split = flag_mpi_init,                                     &  ! (in) optional
   320          &        history = gthst_rst                                          &  ! (out) optional
   321          & )
   322      else
   323        call HistoryCreate(                                                     &
   324          &      file = OutputFile,                                             &  ! (in)
   325          &     title = trim(FileTitle) // trim(title_msg),                     &  ! (in)
   326          &    source = FileSource, institution = FileInstitution,              &  ! (in)
   327          &      dims = StoA( 'lon', 'lat', time_name ),                        &  ! (in)
   328          &  dimsizes = (/ imax, jmax, 0 /),                                    &  ! (in)
   329          & longnames = StoA( 'longitude', 'latitude', time_name ),             &  ! (in)
   330          &     units = StoA( 'degree_east', 'degree_north',                    &  ! (in)
   331          &                    time_unit ),                                     &  ! (in)
   332          &    xtypes = (/'double', 'double', 'double'/),                       &  ! (in)
   333          &        origind = origin_time,                                       &  ! (in) optional
   334          &      intervald = IntValue,                                          &  ! (in) optional
   335          & flag_mpi_split = flag_mpi_init,                                     &  ! (in) optional
   336          &        history = gthst_rst                                          &  ! (out) optional
   337          & )
   338      end if
   339  
   340      ! ɸǡ
   341      ! Axes data settings
   342      !
   343      call HistoryAddAttr(                                 &
   344        & varname = 'lon', attrname = 'standard_name',     & ! (in)
   345        & value = 'longitude',                             & ! (in)
   346        & history = gthst_rst                              & ! (inout)
   347        & )
   348      call HistoryAddAttr(                                 &
   349        & varname = 'lat', attrname = 'standard_name',     & ! (in)
   350        & value = 'latitude',                              & ! (in)
   351        & history = gthst_rst                              & ! (inout)
   352        & )
   353      if ( kslmax /= 0 ) then
   354        call HistoryAddAttr(                                 &
   355          & varname = 'dep', attrname = 'standard_name',     & ! (in)
   356          & value = 'depth',                                 & ! (in)
   357          & history = gthst_rst                              & ! (inout)
   358          & )
   359      end if
   360      call HistoryAddAttr(                                 &
   361        & varname = time_name, attrname = 'standard_name', & ! (in)
   362        & value = 'time',                                  & ! (in)
   363        & history = gthst_rst                              & ! (inout)
   364        & )
   365  
   366      call HistoryPut(                   &
     .        D1 = 1.D0/3.14159265358979e+000                                   
     .  !CDIR NODEP                                                             
     .        do t361 = 1, x_lon.DSC.U1 - x_lon.DSC.L1 + 1                      
     .           %IG7(t361) = x_lon(x_lon.DSC.L1+t361-1)*D1*                    
     .       1      1.80000000000000e+002                                       
     .        end do                                                            
   367        & varname = 'lon',               & ! (in)
   368        & array = x_Lon / PI * 180.0_DP, & ! (in)
   369        & history = gthst_rst            & ! (inout)
   370        & )
   371      call HistoryPut(                   &
     .        D2 = 1.D0/3.14159265358979e+000                                   
     .  !CDIR NODEP                                                             
     .        do t365 = 1, y_lat.DSC.U1 - y_lat.DSC.L1 + 1                      
     .           %IG10(t365) = y_lat(y_lat.DSC.L1+t365-1)*D2*                   
     .       1      1.80000000000000e+002                                       
     .        end do                                                            
   372        & varname = 'lat',               & ! (in)
   373        & array = y_Lat / PI * 180.0_DP, & ! (in)
   374        & history = gthst_rst            & ! (inout)
   375        & )
   376      if ( kslmax /= 0 ) then
   377        call HistoryPut(                   &
   378          & varname = 'dep',               & ! (in)
   379          & array = z_SSDepth,             & ! (in)
   380          & history = gthst_rst            & ! (inout)
   381          & )
   382      end if
   383  
   384      ! ɸŤߤ
   385      ! Axes weights settings
   386      !
   387      call HistoryAddVariable( &
   388        & varname = 'lon_weight', &                           ! (in)
   389        & dims = StoA('lon'), &                               ! (in)
   390        & longname = 'weight for integration in longitude', & ! (in)
   391        & units = 'radian', xtype = 'double', &               ! (in)
   392        & history = gthst_rst )                               ! (inout)
   393      call HistoryAddAttr( &
   394        & varname = 'lon', attrname = 'gt_calc_weight', &     ! (in)
   395        & value = 'lon_weight', &                             ! (in)
   396        & history = gthst_rst )                               ! (inout)
   397      call HistoryPut( &
   398        & varname = 'lon_weight', array = x_Lon_Weight, &     ! (in)
   399        & history = gthst_rst )                               ! (inout)
   400  
   401      call HistoryAddVariable( &
   402        & varname = 'lat_weight', &                           ! (in)
   403        & dims = StoA('lat'), &                               ! (in)
   404        & longname = 'weight for integration in latitude', &  ! (in)
   405        & units = 'radian', xtype = 'double', &               ! (in)
   406        & history = gthst_rst )                               ! (inout)
   407      call HistoryAddAttr( &
   408        & varname = 'lat', attrname = 'gt_calc_weight', &     ! (in)
   409        & value = 'lat_weight', &                             ! (in)
   410        & history = gthst_rst )                               ! (inout)
   411      call HistoryPut( &
   412        & varname = 'lat_weight', array = y_Lat_Weight, &     ! (in)
   413        & history = gthst_rst )                               ! (inout)
   414  
   415      ! ͽѿ
   416      ! Predictional variables settings
   417      !
   418      call HistoryAddVariable(                  &
   419        & varname = 'SurfTemp',                 & ! (in)
   420        & dims = StoA('lon', 'lat', time_name), & ! (in)
   421        & longname = 'surface temperature',     & ! (in)
   422        & units = 'K', xtype = 'double',        & ! (in)
   423        & history = gthst_rst                   & ! (inout)
   424        & )
   425      if ( kslmax /= 0 ) then
   426        call HistoryAddVariable(                         &
   427          & varname = 'SoilTemp',                        & ! (in)
   428          & dims = StoA('lon', 'lat', 'dep', time_name), & ! (in)
   429          & longname = 'soil temperature',               & ! (in)
   430          & units = 'K', xtype = 'double',               & ! (in)
   431          & history = gthst_rst                          & ! (inout)
   432          & )
   433      end if
   434      call HistoryAddVariable(                  &
   435        & varname = 'SurfMajCompIceB',          & ! (in)
   436        & dims = StoA('lon', 'lat', time_name), & ! (in)
   437        & longname = 'major component ice amount on the surface', & ! (in)
   438        & units = 'kg m-2', xtype = 'double',   & ! (in)
   439        & history = gthst_rst                   & ! (inout)
   440        & )
   441      call HistoryAddVariable(                  &
   442        & varname = 'SoilMoistB',               & ! (in)
   443        & dims = StoA('lon', 'lat', time_name), & ! (in)
   444        & longname = 'soil moisture',           & ! (in)
   445        & units = 'kg m-2', xtype = 'double',   & ! (in)
   446        & history = gthst_rst                   & ! (inout)
   447        & )
   448      call HistoryAddVariable(                     &
   449        & varname = 'SurfSnowB',                   & ! (in)
   450        & dims = StoA('lon', 'lat', time_name),    & ! (in)
   451        & longname = 'snow amount on the surface', & ! (in)
   452        & units = 'kg m-2', xtype = 'double',      & ! (in)
   453        & history = gthst_rst                      & ! (inout)
   454        & )
   455      call HistoryAddVariable(                  &
   456        & varname = 'SurfMajCompIceN',          & ! (in)
   457        & dims = StoA('lon', 'lat', time_name), & ! (in)
   458        & longname = 'major component ice amount on the surface', & ! (in)
   459        & units = 'kg m-2', xtype = 'double',   & ! (in)
   460        & history = gthst_rst                   & ! (inout)
   461        & )
   462      call HistoryAddVariable(                  &
   463        & varname = 'SoilMoistN',               & ! (in)
   464        & dims = StoA('lon', 'lat', time_name), & ! (in)
   465        & longname = 'soil moisture',           & ! (in)
   466        & units = 'kg m-2', xtype = 'double',   & ! (in)
   467        & history = gthst_rst                   & ! (inout)
   468        & )
   469      call HistoryAddVariable(                     &
   470        & varname = 'SurfSnowN',                   & ! (in)
   471        & dims = StoA('lon', 'lat', time_name),    & ! (in)
   472        & longname = 'snow amount on the surface', & ! (in)
   473        & units = 'kg m-2', xtype = 'double',      & ! (in)
   474        & history = gthst_rst                      & ! (inout)
   475        & )
   476  
   477      restart_surftemp_opened = .true.
   478    end subroutine RestartSurfTempOpen
   479  
   480    !--------------------------------------------------------------------------------------
   481  
   482    subroutine RestartSurfTempOutput(                             &
   483      & xy_SurfTemp,                                              & ! (in)
   484      & xyz_SoilTemp,                                             & ! (in) optional
   485      & xy_SurfMajCompIceB, xy_SoilMoistB, xy_SurfSnowB,          & ! (in) optional
   486      & xy_SurfMajCompIceN, xy_SoilMoistN, xy_SurfSnowN           & ! (in) optional
   487      & )
   488      !
   489      ! ꥹȥǡνϤԤޤ.
   490      !
   491      ! Output restart data
   492  
   493      ! ⥸塼 ; USE statements
   494      !
   495  
   496      ! gtool4 ǡ
   497      ! Gtool4 data output
   498      !
   499      use gtool_history, only: HistoryPut, HistorySetTime
   500  
   501      ! 
   502      ! Time control
   503      !
   504      use timeset, only: &
   505        & TimeN, &              ! ƥå $ t $ λ.
   506                                ! Time of step $ t $.
   507        & EndTime               ! ׻λ.
   508                                ! End time of calculation
   509  
   510      ! Ȥ߹ߴؿ PRESENT γĥǴؿ
   511      ! Extended functions of intrinsic function "PRESENT"
   512      !
   513      use dc_present, only: present_and_true
   514  
   515      ! ʸ ; Declaration statements
   516      !
   517      real(DP), intent(in)           :: xy_SurfTemp (0:imax-1, 1:jmax)
   518                                ! ɽ̲.
   519                                ! Surface temperature
   520      real(DP), intent(in), optional :: xyz_SoilTemp      (0:imax-1, 1:jmax, 1:kslmax)
   521      real(DP), intent(in), optional :: xy_SurfMajCompIceB(0:imax-1, 1:jmax)
   522      real(DP), intent(in), optional :: xy_SoilMoistB     (0:imax-1, 1:jmax)
   523      real(DP), intent(in), optional :: xy_SurfSnowB      (0:imax-1, 1:jmax)
   524      real(DP), intent(in), optional :: xy_SurfMajCompIceN(0:imax-1, 1:jmax)
   525      real(DP), intent(in), optional :: xy_SoilMoistN     (0:imax-1, 1:jmax)
   526      real(DP), intent(in), optional :: xy_SurfSnowN      (0:imax-1, 1:jmax)
   527  
   528      ! ѿ
   529      ! Work variables
   530      !
   531      logical:: flag_output
   532                                ! ϤΥե饰.
   533                                ! Flag for output
   534  
   535      ! ¹ʸ ; Executable statement
   536      !
   537  
   538      if ( .not. restart_surftemp_opened ) call RestartSurfTempOpen
   539  
   540      ! ϥߥ󥰤Υå
   541      ! Check output timing
   542      !
   543      flag_output = TimeN - PrevOutputTime >= IntTime
   544      if ( TimeN >= EndTime .and. .not. flag_output_end ) then
   545        flag_output = .true.
   546        flag_output_end = .true.
   547      end if
   548      flag_output = ( .not. TimeN == PrevOutputTime ) .and. flag_output
   549      flag_output = flag_init_data_save .or. flag_output
   550  
   551      if ( .not. flag_output ) return
   552  
   553      ! Ѥ, ν (˾)  ¸
   554      ! Save output time (expected) in this time, for next time
   555      !
   556      PrevOutputTime = PrevOutputTime + IntTime
   557  
   558      ! 
   559      ! Set time
   560      !
   561      call HistorySetTime( timed = TimeN, history = gthst_rst )
   562  
   563      ! ǡ
   564      ! Data output
   565      !
   566      call HistoryPut( 'SurfTemp'  , xy_SurfTemp  , history = gthst_rst ) ! (in)
   567      if ( present( xyz_SoilTemp ) ) then
   568        if ( kslmax /= 0 ) then
   569          call HistoryPut( 'SoilTemp'  , xyz_SoilTemp , history = gthst_rst ) ! (in)
   570        end if
   571      end if
   572      if ( present( xy_SurfMajCompIceB ) ) then
   573        call HistoryPut( 'SurfMajCompIceB', xy_SurfMajCompIceB, history = gthst_rst ) ! (in)
   574      end if
   575      if ( present( xy_SoilMoistB ) ) then
   576        call HistoryPut( 'SoilMoistB', xy_SoilMoistB, history = gthst_rst ) ! (in)
   577      end if
   578      if ( present( xy_SurfSnowB ) ) then
   579        call HistoryPut( 'SurfSnowB' , xy_SurfSnowB , history = gthst_rst ) ! (in)
   580      end if
   581      if ( present( xy_SurfMajCompIceN ) ) then
   582        call HistoryPut( 'SurfMajCompIceN', xy_SurfMajCompIceN, history = gthst_rst ) ! (in)
   583      end if
   584      if ( present( xy_SoilMoistN ) ) then
   585        call HistoryPut( 'SoilMoistN', xy_SoilMoistN, history = gthst_rst ) ! (in)
   586      end if
   587      if ( present( xy_SurfSnowN ) ) then
   588        call HistoryPut( 'SurfSnowN' , xy_SurfSnowN , history = gthst_rst ) ! (in)
   589      end if
   590  
   591    end subroutine RestartSurfTempOutput
   592  
   593    !--------------------------------------------------------------------------------------
   594  
   595    subroutine RestartSurfTempClose
   596      !
   597      ! ꥹȥǡեϤνλԤޤ.
   598      !
   599      ! Terminate restart data files output.
   600  
   601      ! ⥸塼 ; USE statements
   602      !
   603  
   604      ! gtool4 ǡ
   605      ! Gtool4 data output
   606      !
   607      use gtool_history, only: HistoryClose
   608  
   609      ! ʸ ; Declaration statements
   610      !
   611  
   612      ! ѿ
   613      ! Work variables
   614      !
   615  
   616      ! ¹ʸ ; Executable statement
   617      !
   618      if ( .not. restart_surftemp_opened ) return
   619  
   620      call HistoryClose( history = gthst_rst ) ! (inout)
   621  
   622      restart_surftemp_opened = .false.
   623    end subroutine RestartSurfTempClose
   624  
   625    !--------------------------------------------------------------------------------------
   626  
   627    subroutine RestartSurfTempGet(                                &
   628      & xy_SurfTemp,                                              & ! (out)
   629      & xyz_SoilTemp,                                             & ! (out)
   630      & xy_SurfMajCompIceB, xy_SoilMoistB, xy_SurfSnowB,          & ! (out)
   631      & xy_SurfMajCompIceN, xy_SoilMoistN, xy_SurfSnowN           & ! (out)
   632      & )
   633      !
   634      ! ꥹȥǡϤԤޤ.
   635      ! ꥹȥǡ¸ߤʤˤ,
   636      ! surface_data ⥸塼Ѥ, ɽ̲٥ǡԤޤ.
   637      !
   638      ! Input restart data.
   639      ! If restart data is not exist,
   640      ! surface temperature data is created by "surface_data".
   641  
   642  
   643      ! ⥸塼 ; USE statements
   644      !
   645  
   646      ! ɽ̥ǡ
   647      ! Prepare surface data
   648      !
   649      use surface_data, only: SetSurfData
   650  
   651      ! 
   652      ! Time control
   653      !
   654      use timeset, only: &
   655        & RestartTime           ! ꥹȳϻ.
   656                                ! Retart time of calculation
   657  
   658      ! gtool4 ǡ
   659      ! Gtool4 data input
   660      !
   661      use gtool_history, only: HistoryGet
   662  
   663      ! ʸ
   664      ! Character handling
   665      !
   666      use dc_string, only: toChar
   667  
   668      ! NetCDF Υåѡץ
   669      ! NetCDF wrapper
   670      !
   671      use netcdf_wrapper, only: NWPresentAVarInFile
   672  
   673  
   674      ! ʸ ; Declaration statements
   675      !
   676      real(DP), intent(out) :: xy_SurfTemp (0:imax-1, 1:jmax)
   677                                ! ɽ̲.
   678                                ! Surface temperature
   679      real(DP), intent(out) :: xyz_SoilTemp (0:imax-1, 1:jmax, 1:kslmax)
   680      real(DP), intent(out) :: xy_SurfMajCompIceB(0:imax-1, 1:jmax)
   681      real(DP), intent(out) :: xy_SoilMoistB     (0:imax-1, 1:jmax)
   682      real(DP), intent(out) :: xy_SurfSnowB      (0:imax-1, 1:jmax)
   683      real(DP), intent(out) :: xy_SurfMajCompIceN(0:imax-1, 1:jmax)
   684      real(DP), intent(out) :: xy_SoilMoistN     (0:imax-1, 1:jmax)
   685      real(DP), intent(out) :: xy_SurfSnowN      (0:imax-1, 1:jmax)
   686  
   687  
   688      ! ѿ
   689      ! Work variables
   690      !
   691      character(TOKEN) :: time_range
   692                                ! λ.
   693                                ! Specification of time
   694      logical          :: flag_mpi_init
   695      integer          :: k
   696  
   697      ! ¹ʸ ; Executable statement
   698      !
   699  
   700      if ( .not. restart_surftemp_io_inited ) then
   701        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   702      end if
   703  
   704      ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   705  !!$    if ( trim(InputFile) == '' .or. trim(InputName) == '' ) then
   706      if ( trim(InputFile) == '' ) then
   707  
   708        ! ǡ surface_data ⥸塼뤫
   709        ! Data is input from "surface_data" module
   710        !
   711        call SetSurfData( xy_SurfTemp = xy_SurfTemp )  ! (out) optional
   712  
   713        do k = 1, kslmax
   714          xyz_SoilTemp(:,:,k) = xy_SurfTemp
     .        if (xyz_soiltemp.DSC.U2 .gt. 0) then                              
     .           J1 = and(xyz_soiltemp.DSC.U2,3)                                
     .  !CDIR    NODEP                                                          
     .           do t384 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t386 = 1, xyz_soiltemp.DSC.U1 + 1                        
     .                 xyz_soiltemp(t386-1,t384,k) = xy_surftemp(t386-1,t384)   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t384 = J1 + 1, xyz_soiltemp.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t386 = 1, xyz_soiltemp.DSC.U1 + 1                        
     .                 xyz_soiltemp(t386-1,t384,k) = xy_surftemp(t386-1,t384)   
     .                 xyz_soiltemp(t386-1,t384+1,k)=xy_surftemp(t386-1,t384+1) 
     .                 xyz_soiltemp(t386-1,t384+2,k)=xy_surftemp(t386-1,t384+2) 
     .                 xyz_soiltemp(t386-1,t384+3,k)=xy_surftemp(t386-1,t384+3) 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   715        end do
   716  
   717        xy_SurfMajCompIceB = 0.0_DP
     .  !CDIR NODEP                                                             
     .        do t394 = 0, 1 + xy_surfmajcompiceb.DSC.U1 - min0(1,              
     .       1   xy_surfmajcompiceb.DSC.U1 + 1)                                 
   718        xy_SoilMoistB      = 0.0_DP
   719        xy_SurfSnowB       = 0.0_DP
   720  
   721        xy_SurfMajCompIceN = xy_SurfMajCompIceB
   722        xy_SoilMoistN      = xy_SoilMoistB
   723        xy_SurfSnowN       = xy_SurfSnowB
   724  
   725      else
   726  
   727        ! ǡ InputFile 
   728        ! Data is input from InputFile
   729        !
   730  
   731        ! μ
   732        ! Get time information
   733        !
   734        time_range = time_name // '=' // toChar( RestartTime )
   735  
   736  !!$      flag_mpi_init = .false.
   737        flag_mpi_init = .true.
   738  
   739        ! ǡ
   740        ! Data input
   741        !
   742        call HistoryGet(                               &
   743          ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   744  !!$        & InputFile, InputName, range = time_range, &  ! (in)
   745          & InputFile, 'SurfTemp', range = time_range, & ! (in)
   746          & array = xy_SurfTemp,                       & ! (out)
   747          & flag_mpi_split = flag_mpi_init             & ! (in) optional
   748          & )
   749        if ( kslmax /= 0 ) then
   750          if ( NWPresentAVarInFile( InputFile, 'SoilTemp' ) ) then
   751            call HistoryGet(                               &
   752              & InputFile, 'SoilTemp', range = time_range, & ! (in)
   753              & array = xyz_SoilTemp,                      & ! (out)
   754              & flag_mpi_split = flag_mpi_init             & ! (in) optional
   755              & )
   756          else
   757            do k = 1, kslmax
   758              xyz_SoilTemp(:,:,k) = xy_SurfTemp
     .           if (xyz_soiltemp.DSC.U2 .gt. 0) then                           
     .           J2 = and(xyz_soiltemp.DSC.U2,3)                                
     .  !CDIR    NODEP                                                          
     .           do t376 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t378 = 1, xyz_soiltemp.DSC.U1 + 1                        
     .                 xyz_soiltemp(t378-1,t376,k) = xy_surftemp(t378-1,t376)   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t376 = J2 + 1, xyz_soiltemp.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t378 = 1, xyz_soiltemp.DSC.U1 + 1                        
     .                 xyz_soiltemp(t378-1,t376,k) = xy_surftemp(t378-1,t376)   
     .                 xyz_soiltemp(t378-1,t376+1,k)=xy_surftemp(t378-1,t376+1) 
     .                 xyz_soiltemp(t378-1,t376+2,k)=xy_surftemp(t378-1,t376+2) 
     .                 xyz_soiltemp(t378-1,t376+3,k)=xy_surftemp(t378-1,t376+3) 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   759            end do
   760            call MessageNotify( 'M', module_name,             &
   761              & 'Variable, %c, cannot be found in file, %c.', &
   762              & c1 = 'SoilTemp', c2 = trim(InputFile)         &
   763              & )
   764            call MessageNotify( 'M', module_name,                           &
   765              & 'Values in SoilTemp is assumed to be the same as SurfTemp.' &
   766              & )
   767          end if
   768        end if
   769        if ( NWPresentAVarInFile( InputFile, 'SurfMajCompIceB' ) ) then
   770          call HistoryGet(                                      &
   771            & InputFile, 'SurfMajCompIceB', range = time_range, & ! (in)
   772            & array = xy_SurfMajCompIceB,                       & ! (out)
   773            & flag_mpi_split = flag_mpi_init                    & ! (in) optional
   774            & )
   775        else
   776          xy_SurfMajCompIceB = 0.0_DP
     .        if (xy_surfmajcompiceb.DSC.U2 .gt. 0) then                        
     .           J3 = and(xy_surfmajcompiceb.DSC.U2,3)                          
     .  !CDIR    NODEP                                                          
     .           do t334 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t336 = 1, xy_surfmajcompiceb.DSC.U1 + 1                  
     .                 xy_surfmajcompiceb(t336-1,t334) = 0.0000000000000000e+000
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t334 = J3 + 1, xy_surfmajcompiceb.DSC.U2, 4                 
     .  !CDIR       NODEP                                                       
     .              do t336 = 1, xy_surfmajcompiceb.DSC.U1 + 1                  
     .                 xy_surfmajcompiceb(t336-1,t334) = 0.0000000000000000e+000
     .                 xy_surfmajcompiceb(t336-1,t334+1) =                      
     .       1            0.0000000000000000e+000                               
     .                 xy_surfmajcompiceb(t336-1,t334+2) =                      
     .       1            0.0000000000000000e+000                               
     .                 xy_surfmajcompiceb(t336-1,t334+3) =                      
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   777          call MessageNotify( 'M', module_name,             &
   778            & 'Variable, %c, cannot be found in file, %c.', &
   779            & c1 = 'SurfMajCompIceB', c2 = trim(InputFile)  &
   780            & )
   781          call MessageNotify( 'M', module_name,                  &
   782            & 'Values in SurfMajCompIceB is assumed to be zero.' &
   783            & )
   784        end if
   785        if ( NWPresentAVarInFile( InputFile, 'SoilMoistB' ) ) then
   786          call HistoryGet(                                 &
   787            & InputFile, 'SoilMoistB', range = time_range, & ! (in)
   788            & array = xy_SoilMoistB,                       & ! (out)
   789            & flag_mpi_split = flag_mpi_init               & ! (in) optional
   790            & )
   791        else
   792          xy_SoilMoistB = 0.0_DP
     .        if (xy_soilmoistb.DSC.U2 .gt. 0) then                             
     .           J4 = and(xy_soilmoistb.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t340 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t342 = 1, xy_soilmoistb.DSC.U1 + 1                       
     .                 xy_soilmoistb(t342-1,t340) = 0.0000000000000000e+000     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t340 = J4 + 1, xy_soilmoistb.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t342 = 1, xy_soilmoistb.DSC.U1 + 1                       
     .                 xy_soilmoistb(t342-1,t340) = 0.0000000000000000e+000     
     .                 xy_soilmoistb(t342-1,t340+1) = 0.0000000000000000e+000   
     .                 xy_soilmoistb(t342-1,t340+2) = 0.0000000000000000e+000   
     .                 xy_soilmoistb(t342-1,t340+3) = 0.0000000000000000e+000   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   793          call MessageNotify( 'M', module_name,             &
   794            & 'Variable, %c, cannot be found in file, %c.', &
   795            & c1 = 'SoilMoistB', c2 = trim(InputFile)       &
   796            & )
   797          call MessageNotify( 'M', module_name,             &
   798            & 'Values in SoilMoistB is assumed to be zero.' &
   799            & )
   800        end if
   801        if ( NWPresentAVarInFile( InputFile, 'SurfSnowB' ) ) then
   802          call HistoryGet(                                 &
   803            & InputFile, 'SurfSnowB', range = time_range,  & ! (in)
   804            & array = xy_SurfSnowB,                        & ! (out)
   805            & flag_mpi_split = flag_mpi_init               & ! (in) optional
   806            & )
   807        else
   808          xy_SurfSnowB = 0.0_DP
     .        if (xy_surfsnowb.DSC.U2 .gt. 0) then                              
     .           J5 = and(xy_surfsnowb.DSC.U2,3)                                
     .  !CDIR    NODEP                                                          
     .           do t346 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t348 = 1, xy_surfsnowb.DSC.U1 + 1                        
     .                 xy_surfsnowb(t348-1,t346) = 0.0000000000000000e+000      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t346 = J5 + 1, xy_surfsnowb.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t348 = 1, xy_surfsnowb.DSC.U1 + 1                        
     .                 xy_surfsnowb(t348-1,t346) = 0.0000000000000000e+000      
     .                 xy_surfsnowb(t348-1,t346+1) = 0.0000000000000000e+000    
     .                 xy_surfsnowb(t348-1,t346+2) = 0.0000000000000000e+000    
     .                 xy_surfsnowb(t348-1,t346+3) = 0.0000000000000000e+000    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   809          call MessageNotify( 'M', module_name,             &
   810            & 'Variable, %c, cannot be found in file, %c.', &
   811            & c1 = 'SurfSnowB', c2 = trim(InputFile)        &
   812            & )
   813          call MessageNotify( 'M', module_name,             &
   814            & 'Values in SurfSnowB is assumed to be zero.'  &
   815            & )
   816        end if
   817        if ( NWPresentAVarInFile( InputFile, 'SurfMajCompIceN' ) ) then
   818          call HistoryGet(                                      &
   819            & InputFile, 'SurfMajCompIceN', range = time_range, & ! (in)
   820            & array = xy_SurfMajCompIceN,                       & ! (out)
   821            & flag_mpi_split = flag_mpi_init                    & ! (in) optional
   822            & )
   823        else
   824          xy_SurfMajCompIceN = xy_SurfMajCompIceB
     .        if (xy_surfmajcompicen.DSC.U2 .gt. 0) then                        
     .           J6 = and(xy_surfmajcompicen.DSC.U2,3)                          
     .  !CDIR    NODEP                                                          
     .           do t352 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t354 = 1, xy_surfmajcompicen.DSC.U1 + 1                  
     .                 xy_surfmajcompicen(t354-1,t352) = xy_surfmajcompiceb(t354
     .       1            -1,t352)                                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t352 = J6 + 1, xy_surfmajcompicen.DSC.U2, 4                 
     .  !CDIR       NODEP                                                       
     .              do t354 = 1, xy_surfmajcompicen.DSC.U1 + 1                  
     .                 xy_surfmajcompicen(t354-1,t352) = xy_surfmajcompiceb(t354
     .       1            -1,t352)                                              
     .                 xy_surfmajcompicen(t354-1,t352+1) = xy_surfmajcompiceb(  
     .       1            t354-1,t352+1)                                        
     .                 xy_surfmajcompicen(t354-1,t352+2) = xy_surfmajcompiceb(  
     .       1            t354-1,t352+2)                                        
     .                 xy_surfmajcompicen(t354-1,t352+3) = xy_surfmajcompiceb(  
     .       1            t354-1,t352+3)                                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   825          call MessageNotify( 'M', module_name,             &
   826            & 'Variable, %c, cannot be found in file, %c.', &
   827            & c1 = 'SurfMajCompIceN', c2 = trim(InputFile)  &
   828            & )
   829          call MessageNotify( 'M', module_name,                                         &
   830            & 'Values in SurfMajCompIceN is assumed to be the same as SurfMajCompIceB.' &
   831            & )
   832        end if
   833        if ( NWPresentAVarInFile( InputFile, 'SoilMoistN' ) ) then
   834          call HistoryGet(                                 &
   835            & InputFile, 'SoilMoistN', range = time_range, & ! (in)
   836            & array = xy_SoilMoistN,                       & ! (out)
   837            & flag_mpi_split = flag_mpi_init               & ! (in) optional
   838            & )
   839        else
   840          xy_SoilMoistN = xy_SoilMoistB
     .        if (xy_soilmoistn.DSC.U2 .gt. 0) then                             
     .           J7 = and(xy_soilmoistn.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t360 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t362 = 1, xy_soilmoistn.DSC.U1 + 1                       
     .                 xy_soilmoistn(t362-1,t360) = xy_soilmoistb(t362-1,t360)  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t360 = J7 + 1, xy_soilmoistn.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t362 = 1, xy_soilmoistn.DSC.U1 + 1                       
     .                 xy_soilmoistn(t362-1,t360) = xy_soilmoistb(t362-1,t360)  
     .                 xy_soilmoistn(t362-1,t360+1) = xy_soilmoistb(t362-1,t360+
     .       1            1)                                                    
     .                 xy_soilmoistn(t362-1,t360+2) = xy_soilmoistb(t362-1,t360+
     .       1            2)                                                    
     .                 xy_soilmoistn(t362-1,t360+3) = xy_soilmoistb(t362-1,t360+
     .       1            3)                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   841          call MessageNotify( 'M', module_name,             &
   842            & 'Variable, %c, cannot be found in file, %c.', &
   843            & c1 = 'SoilMoistN', c2 = trim(InputFile)       &
   844            & )
   845          call MessageNotify( 'M', module_name,                               &
   846            & 'Values in SoilMoistN is assumed to be the same as SoilMoistB.' &
   847            & )
   848        end if
   849        if ( NWPresentAVarInFile( InputFile, 'SurfSnowN' ) ) then
   850          call HistoryGet(                                 &
   851            & InputFile, 'SurfSnowN', range = time_range,  & ! (in)
   852            & array = xy_SurfSnowN,                        & ! (out)
   853            & flag_mpi_split = flag_mpi_init               & ! (in) optional
   854            & )
   855        else
   856          xy_SurfSnowN = xy_SurfSnowB
     .        if (xy_surfsnown.DSC.U2 .gt. 0) then                              
     .           J8 = and(xy_surfsnown.DSC.U2,3)                                
     .  !CDIR    NODEP                                                          
     .           do t368 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t370 = 1, xy_surfsnown.DSC.U1 + 1                        
     .                 xy_surfsnown(t370-1,t368) = xy_surfsnowb(t370-1,t368)    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t368 = J8 + 1, xy_surfsnown.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t370 = 1, xy_surfsnown.DSC.U1 + 1                        
     .                 xy_surfsnown(t370-1,t368) = xy_surfsnowb(t370-1,t368)    
     .                 xy_surfsnown(t370-1,t368+1) = xy_surfsnowb(t370-1,t368+1)
     .                 xy_surfsnown(t370-1,t368+2) = xy_surfsnowb(t370-1,t368+2)
     .                 xy_surfsnown(t370-1,t368+3) = xy_surfsnowb(t370-1,t368+3)
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   857          call MessageNotify( 'M', module_name,             &
   858            & 'Variable, %c, cannot be found in file, %c.', &
   859            & c1 = 'SurfSnowN', c2 = trim(InputFile)        &
   860            & )
   861          call MessageNotify( 'M', module_name,                             &
   862            & 'Values in SurfSnowN is assumed to be the same as SurfSnowB.' &
   863            & )
   864        end if
   865  
   866      end if
   867  
   868    end subroutine RestartSurfTempGet
   869  
   870    !--------------------------------------------------------------------------------------
   871  
   872    subroutine RestartSurfTempInit
   873      !
   874      ! restart_surftemp_io ⥸塼νԤޤ.
   875      ! NAMELIST#restart_surftemp_io_nml ɤ߹ߤϤμ³ǹԤޤ.
   876      !
   877      ! "restart_surftemp_io" module is initialized.
   878      ! "NAMELIST#restart_surftemp_io_nml" is loaded in this procedure.
   879      !
   880  
   881      ! ⥸塼 ; USE statements
   882      !
   883  
   884      ! ꥹȥǡ
   885      ! Restart data input/output
   886      !
   887      use restart_file_io, only: restart_file_io_inited, &
   888        & RestartFileIntValue => IntValue, &
   889                                ! ꥹȥǡνϴֳ.
   890                                ! Interval of restart data output
   891        & RestartFileIntUnit  => IntUnit
   892                                ! ꥹȥǡνϴֳ֤ñ.
   893                                ! Unit for interval of restart data output
   894  
   895      ! 
   896      ! Time control
   897      !
   898      use timeset, only: &
   899        & RestartTime           ! ꥹȳϻ.
   900                                ! Retart time of calculation
   901  
   902      ! NAMELIST եϤ˴ؤ桼ƥƥ
   903      ! Utilities for NAMELIST file input
   904      !
   905      use namelist_util, only: namelist_filename, NmlutilMsg
   906  
   907      ! μ갷
   908      ! Calendar and Date handler
   909      !
   910      use dc_calendar, only: DCCalConvertByUnit
   911  
   912      ! ե
   913      ! File I/O support
   914      !
   915      use dc_iounit, only: FileOpen
   916  
   917      ! ̷ѥ᥿
   918      ! Kind type parameter
   919      !
   920      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   921  
   922      ! ʸ ; Declaration statements
   923      !
   924  
   925      ! ѿ
   926      ! Work variables
   927      !
   928      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   929                                ! Unit number for NAMELIST file open
   930      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   931                                ! IOSTAT of NAMELIST read
   932  
   933      ! NAMELIST ѿ
   934      ! NAMELIST group name
   935      !
   936      namelist /restart_surftemp_io_nml/ &
   937        & InputFile, &
   938        ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   939  !!$      & InputName, &
   940        & OutputFile, &
   941        & IntValue, IntUnit
   942            !
   943            ! ǥեͤˤĤƤϽ³ "restart_surftemp_io#RestartSurfTempInit"
   944            ! Υɤ򻲾ȤΤ.
   945            !
   946            ! Refer to source codes in the initialization procedure
   947            ! "restart_surftemp_io#RestartSurfTempInit" for the default values.
   948            !
   949  
   950  
   951      ! ¹ʸ ; Executable statement
   952      !
   953  
   954      if ( restart_surftemp_io_inited ) return
   955  
   956  
   957      ! ǥեͤ
   958      ! Default values settings
   959      !
   960      InputFile  = ''
   961      ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   962  !!$    InputName  = 'SurfTemp'
   963      if ( .not. flag_init_data_save ) then
   964        OutputFile = 'rst_sst.nc'
   965      else
   966        OutputFile = 'sst.nc'
   967      end if
   968  
   969      if ( restart_file_io_inited ) then
   970        IntValue   = RestartFileIntValue
   971        IntUnit    = RestartFileIntUnit
   972      else
   973        IntValue   = 365.0d0
   974        IntUnit    = 'day'
   975      end if
   976  
   977      ! NAMELIST ɤ߹
   978      ! NAMELIST is input
   979      !
   980      if ( trim(namelist_filename) /= '' ) then
   981        call FileOpen( unit_nml, &          ! (out)
   982          & namelist_filename, mode = 'r' ) ! (in)
   983  
   984        rewind( unit_nml )
   985        read( unit_nml, &         ! (in)
   986          & nml = restart_surftemp_io_nml, &  ! (out)
   987          & iostat = iostat_nml ) ! (out)
   988        close( unit_nml )
   989  
   990        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   991        if ( iostat_nml == 0 ) write( STDOUT, nml = restart_surftemp_io_nml )
   992      end if
   993  
   994      ! ϻֳִ֤
   995      ! Configure time interval of output
   996      !
   997      IntTime = DCCalConvertByUnit( IntValue, IntUnit, 'sec' ) ! (in)
   998      PrevOutputTime = RestartTime
   999  
  1000      ! ե饰ν
  1001      ! Initialize flag
  1002      !
  1003      flag_output_end = .false.
  1004  
  1005  
  1006      !  ; Print
  1007      !
  1008      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
  1009      call MessageNotify( 'M', module_name, 'Input:: ' )
  1010      call MessageNotify( 'M', module_name, '  InputFile  = %c', c1 = trim(InputFile) )
  1011      ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
  1012  !!$    call MessageNotify( 'M', module_name, '  InputName  = %c', c1 = trim(InputName) )
  1013      call MessageNotify( 'M', module_name, 'Output:: ' )
  1014      call MessageNotify( 'M', module_name, '  OutputFile = %c', c1 = trim(OutputFile) )
  1015      call MessageNotify( 'M', module_name, '  IntTime    = %f [%c]', d = (/ IntValue /), c1 = trim(IntUnit) )
  1016      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
  1017  
  1018      restart_surftemp_io_inited = .true.
  1019  
  1020    end subroutine RestartSurfTempInit
  1021  
  1022    !--------------------------------------------------------------------------------------
  1023  
  1024  end module restart_surftemp_io
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:41 2012
FILE NAME: restart_surftemp_io.f90
PROGRAM NAME: restart_surftemp_io
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ɽ̲٥ꥹȥǡ, ͥǡ
     2:            !
     3:            != Restart data, initial data of surface temperature input/output
     4:            !
     5:            ! Authors::   Yasuhiro Morikawa, Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: restart_surftemp_io.f90,v 1.10 2012-09-17 10:59:30 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module restart_surftemp_io
    13:              !
    14:              != ɽ̲٥ꥹȥǡ, ͥǡ
    15:              !
    16:              != Restart data, initial data of surface temperature input/output
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ɽ̲٤Υꥹȥǡ⤷ϽͥǡϤԤޤ. 
    21:              ! ϥե, ϥե, ǡνϤδֳ֤
    22:              ! NAMELIST#restart_surftemp_io_nml ꤷޤ. 
    23:              !
    24:              ! ꥹȥǡϥե뤬ꤵʤ, 
    25:              ! surface_data ⥸塼줿ͥǡޤ. 
    26:              !
    27:              ! Restart data or initial data is input/output. 
    28:              ! Settings of input file, output file, and interval of data output 
    29:              ! is configured by "NAMELIST#restart_surftemp_io_nml". 
    30:              !
    31:              ! If input file of restart data is not set, 
    32:              ! initial data is generated in "surface_data" module, and 
    33:              ! obtained data from the module. 
    34:              !
    35:              !== Procedures List
    36:              !
    37:              ! RestartSurfTempOpen   :: ꥹȥեΥץ
    38:              ! RestartSurfTempOutput :: ꥹȥեؤΥǡ
    39:              ! RestartSurfTempClose  :: ꥹȥեΥ
    40:              ! RestartSurfTempGet    :: ꥹȥե
    41:              ! ------------      :: ------------
    42:              ! RestartSurfTempOpen   :: Open restart file
    43:              ! RestartSurfTempOutput :: Data output to restart file
    44:              ! RestartSurfTempClose  :: Close restart file
    45:              ! RestartSurfTempGet    :: Input restart file
    46:              !
    47:              !== NAMELIST
    48:              !
    49:              ! NAMELIST#restart_surftemp_io_nml
    50:              !
    51:            
    52:              ! ⥸塼 ; USE statements
    53:              !
    54:            
    55:              ! ʻ
    56:              ! Grid points settings
    57:              !
    58:              use gridset, only: imax, & ! ٳʻ. 
    59:                                         ! Number of grid points in longitude
    60:                &                jmax, & ! ٳʻ. 
    61:                                         ! Number of grid points in latitude
    62:                &                kmax, & ! ľؿ. 
    63:                                         ! Number of vertical level
    64:                &                kslmax  ! ϲαľؿ.
    65:                                         ! Number of subsurface vertical level
    66:            
    67:              ! ̷ѥ᥿
    68:              ! Kind type parameter
    69:              !
    70:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    71:                &                 STRING, &  ! ʸ.       Strings. 
    72:                &                 TOKEN      ! .   Keywords. 
    73:            
    74:              ! å
    75:              ! Message output
    76:              !
    77:              use dc_message, only: MessageNotify
    78:            
    79:              ! gtool4 ǡ
    80:              ! Gtool4 data output
    81:              !
    82:              use gtool_history, only: GT_HISTORY
    83:            
    84:              ! ʸ ; Declaration statements
    85:              !
    86:              implicit none
    87:              private
    88:            
    89:              ! ³
    90:              ! Public procedure
    91:              !
    92:              public :: RestartSurfTempInit
    93:              public :: RestartSurfTempOpen, RestartSurfTempClose, RestartSurfTempOutPut
    94:              public :: RestartSurfTempGet
    95:            
    96:              ! ѿ
    97:              ! Public variables
    98:              !
    99:              logical, save, public:: restart_surftemp_io_inited = .false.
   100:                                          ! ե饰. 
   101:                                          ! Initialization flag
   102:            
   103:              logical, save, public:: restart_surftemp_opened = .false.
   104:                                          ! ꥹȥեΥץ˴ؤե饰. 
   105:                                          ! Flag of restart file open
   106:            
   107:              ! ѿ
   108:              ! Private variables
   109:              !
   110:              logical, save:: flag_init_data_save
   111:                                          ! ͥǡ, 
   112:                                          ! ΰ .true. Ϳޤ. 
   113:                                          ! 
   114:                                          ! If initial data is created, 
   115:                                          ! give ".true." to this argument. 
   116:            
   117:              character(STRING), save:: InputFile
   118:                                          ! ϤꥹȥǡΥե̾
   119:                                          ! Filename of input restart data
   120:            
   121:              ! This is not used, and variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   122:            !!$  character(TOKEN), save:: InputName
   123:            !!$                              ! Ϥꥹȥǡѿ̾
   124:            !!$                              ! Variable name of input restart data
   125:            
   126:              character(STRING), save:: OutputFile
   127:                                          ! ϤꥹȥǡΥե̾
   128:                                          ! Filename of output restart data
   129:              real(DP), save:: IntValue
   130:                                          ! ꥹȥǡνϴֳ. 
   131:                                          ! Interval of restart data output
   132:              character(TOKEN):: IntUnit
   133:                                          ! ꥹȥǡνϴֳ֤ñ. 
   134:                                          ! Unit for interval of restart data output
   135:            
   136:              type(GT_HISTORY), save:: gthst_rst
   137:                                          ! ꥹȥǡ gtool_history#GT_HISTORY ѿ
   138:                                          ! "gtool_history#GT_HISTORY" variable for restart data
   139:            
   140:              real(DP), save:: PrevOutputTime
   141:                                          ! νϻ. 
   142:                                          ! Previous output time
   143:              logical, save:: flag_output_end
   144:                                          ! ׻ǽνϴλΥե饰. 
   145:                                          ! Flag for completion of output at the end time of calculation
   146:            
   147:              real(DP), save:: IntTime
   148:                                          ! ꥹȥǡνϻ. 
   149:                                          ! Time interval of restart data output
   150:            
   151:              character(*), parameter:: time_name = 'time'
   152:                                          ! μѿ̾
   153:                                          ! Variable name of time dimension
   154:              character(*), parameter:: deltime_name = 'deltime'
   155:                                          ! t ѿ̾
   156:                                          ! Variable name of Delta t
   157:            
   158:            
   159:              character(*), parameter:: module_name = 'restart_surftemp_io'
   160:                                          ! ⥸塼̾. 
   161:                                          ! Module name
   162:              character(*), parameter:: version = &
   163:                & '$Name: dcpam5-20120921 $' // &
   164:                & '$Id: restart_surftemp_io.f90,v 1.10 2012-09-17 10:59:30 yot Exp $'
   165:                                          ! ⥸塼ΥС
   166:                                          ! Module version
   167:            
   168:            contains
   169:            
   170:              !--------------------------------------------------------------------------------------
   171:            
   172:              subroutine RestartSurfTempOpen( flag_init_data )
   173:                !
   174:                ! ꥹȥե򥪡ץ󤷤ޤ. 
   175:                !
   176:                ! A restart file is opened. 
   177:                !
   178:            
   179:                ! ⥸塼 ; USE statements
   180:                !
   181:            
   182:                ! ϥեδܾ
   183:                ! Basic information for output files
   184:                ! 
   185:                use fileset, only: &
   186:                  & FileTitle, &
   187:                                          ! ϥǡեɽ.
   188:                                          ! Title of output data files
   189:                  & FileSource, &
   190:                                          ! ǡեμ. 
   191:                                          ! Source of data file
   192:                  & FileInstitution
   193:                                          ! ǡեǽŪѹȿ/Ŀ. 
   194:                                          ! Institution or person that changes data files for the last time
   195:            
   196:                ! ʪ
   197:                ! Physical and mathematical constants settings
   198:                !
   199:                use constants0, only: &
   200:                  & PI                    ! $ \pi $.
   201:                                          ! ߼Ψ. Circular constant
   202:            
   203:                ! ɸǡ
   204:                ! Axes data settings
   205:                !
   206:                use axesset, only: &
   207:                  & x_Lon, &
   208:                                          ! $ \lambda $ [rad.] . . Longitude
   209:                  & x_Lon_Weight, &
   210:                                          ! $ \Delta \lambda $ [rad.] . 
   211:                                          ! ٺɸŤ. 
   212:                                          ! Weight of longitude
   213:                  & y_Lat, &
   214:                                          ! $ \varphi $ [rad.] . . Latitude
   215:                  & y_Lat_Weight, &
   216:                                          ! $ \Delta \varphi $ [rad.] . 
   217:                                          ! ٺɸŤ. 
   218:                                          ! Weight of latitude
   219:                  & z_SSDepth
   220:                                          ! ϲγʻο
   221:                                          ! subsurface grid at midpoint of layer
   222:            
   223:                ! 
   224:                ! Time control
   225:                !
   226:                use timeset, only: &
   227:                  & DelTime, &            ! $ \Delta t $ [s]
   228:                  & RestartTime           ! ꥹȳϻ. 
   229:                                          ! Retart time of calculation
   230:            
   231:                ! gtool4 ǡ
   232:                ! Gtool4 data output
   233:                !
   234:                use gtool_history, only: HistoryCreate, HistoryAddVariable, &
   235:                  & HistoryPut, HistoryAddAttr
   236:            
   237:                ! ʸ
   238:                ! Character handling
   239:                !
   240:                use dc_string, only: StoA, CPrintf, LChar
   241:            
   242:                ! Ȥ߹ߴؿ PRESENT γĥǴؿ
   243:                ! Extended functions of intrinsic function "PRESENT"
   244:                !
   245:                use dc_present, only: present_and_true
   246:            
   247:                ! ʸ ; Declaration statements
   248:                !
   249:                logical, intent(in), optional:: flag_init_data
   250:                                          ! ͥǡ, 
   251:                                          ! ΰ .true. Ϳޤ. 
   252:                                          ! 
   253:                                          ! If initial data is created, 
   254:                                          ! give ".true." to this argument. 
   255:            
   256:                ! ѿ
   257:                ! Work variables
   258:                !
   259:                character(STRING):: title_msg
   260:                                          ! ɽղäå. 
   261:                                          ! Message added to title
   262:                real(DP):: origin_time
   263:                                          ! ׻ϻ. 
   264:                                          ! Start time of calculation
   265:                character(STRING):: time_unit
   266:                                          ! ñ. Units of date and time
   267:            
   268:                logical:: flag_mpi_init
   269:            
   270:                ! ¹ʸ ; Executable statement
   271:                !
   272:            
   273:                ! 
   274:                ! Initialization
   275:                !
   276:                flag_init_data_save = present_and_true( flag_init_data )
   277:                if ( .not. restart_surftemp_io_inited ) then
   278:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   279:                end if
   280:                if ( restart_surftemp_opened ) return
   281:            
   282:                ! ɽղäå
   283:                ! Configure message added to title
   284:                !
   285:                if ( .not. flag_init_data_save ) then
   286:                  title_msg = ' restart data of surface temperature'
   287:                else
   288:                  title_msg = ' initial data of surface temperature'
   289:                end if
   290:            
   291:                ! μ
   292:                ! Get time information
   293:                !
   294:                if ( .not. flag_init_data_save ) then
   295:                  origin_time = RestartTime + IntTime
   296:                else
   297:                  origin_time = RestartTime
   298:                end if
   299:            
   300:                time_unit = IntUnit
   301:            
   302:                flag_mpi_init = .true.
   303:            
   304:                ! ꥹȥեΥץ
   305:                ! Open a restart file
   306:                !
   307:                if ( kslmax /= 0 ) then
   308:                  call HistoryCreate(                                                     &
   309:                    &      file = OutputFile,                                             &  ! (in)
   310:                    &     title = trim(FileTitle) // trim(title_msg),                     &  ! (in)
   311:                    &    source = FileSource, institution = FileInstitution,              &  ! (in)
   312:                    &      dims = StoA( 'lon', 'lat', 'dep', time_name ),                 &  ! (in)
   313:                    &  dimsizes = (/ imax, jmax, kslmax, 0 /),                            &  ! (in)
   314:                    & longnames = StoA( 'longitude', 'latitude', 'depth   ', time_name ), &  ! (in)
   315:                    &     units = StoA( 'degree_east', 'degree_north', 'm           ',    &  ! (in)
   316:                    &                    time_unit ),                                     &  ! (in)
   317:                    &        origind = origin_time,                                       &  ! (in) optional
   318:                    &      intervald = IntValue,                                          &  ! (in) optional
   319:                    & flag_mpi_split = flag_mpi_init,                                     &  ! (in) optional
   320:                    &        history = gthst_rst                                          &  ! (out) optional
   321:                    & )
   322:                else
   323:                  call HistoryCreate(                                                     &
   324:                    &      file = OutputFile,                                             &  ! (in)
   325:                    &     title = trim(FileTitle) // trim(title_msg),                     &  ! (in)
   326:                    &    source = FileSource, institution = FileInstitution,              &  ! (in)
   327:                    &      dims = StoA( 'lon', 'lat', time_name ),                        &  ! (in)
   328:                    &  dimsizes = (/ imax, jmax, 0 /),                                    &  ! (in)
   329:                    & longnames = StoA( 'longitude', 'latitude', time_name ),             &  ! (in)
   330:                    &     units = StoA( 'degree_east', 'degree_north',                    &  ! (in)
   331:                    &                    time_unit ),                                     &  ! (in)
   332:                    &    xtypes = (/'double', 'double', 'double'/),                       &  ! (in)
   333:                    &        origind = origin_time,                                       &  ! (in) optional
   334:                    &      intervald = IntValue,                                          &  ! (in) optional
   335:                    & flag_mpi_split = flag_mpi_init,                                     &  ! (in) optional
   336:                    &        history = gthst_rst                                          &  ! (out) optional
   337:                    & )
   338:                end if
   339:            
   340:                ! ɸǡ
   341:                ! Axes data settings
   342:                !
   343:                call HistoryAddAttr(                                 &
   344:                  & varname = 'lon', attrname = 'standard_name',     & ! (in)
   345:                  & value = 'longitude',                             & ! (in)
   346:                  & history = gthst_rst                              & ! (inout)
   347:                  & )
   348:                call HistoryAddAttr(                                 &
   349:                  & varname = 'lat', attrname = 'standard_name',     & ! (in)
   350:                  & value = 'latitude',                              & ! (in)
   351:                  & history = gthst_rst                              & ! (inout)
   352:                  & )
   353:                if ( kslmax /= 0 ) then
   354:                  call HistoryAddAttr(                                 &
   355:                    & varname = 'dep', attrname = 'standard_name',     & ! (in)
   356:                    & value = 'depth',                                 & ! (in)
   357:                    & history = gthst_rst                              & ! (inout)
   358:                    & )
   359:                end if
   360:                call HistoryAddAttr(                                 &
   361:                  & varname = time_name, attrname = 'standard_name', & ! (in)
   362:                  & value = 'time',                                  & ! (in)
   363:                  & history = gthst_rst                              & ! (inout)
   364:                  & )
   365:            
   366: V======        call HistoryPut(                   &
   367:                  & varname = 'lon',               & ! (in)
   368:                  & array = x_Lon / PI * 180.0_DP, & ! (in)
   369:                  & history = gthst_rst            & ! (inout)
   370:                  & )
   371: V======        call HistoryPut(                   &
   372:                  & varname = 'lat',               & ! (in)
   373:                  & array = y_Lat / PI * 180.0_DP, & ! (in)
   374:                  & history = gthst_rst            & ! (inout)
   375:                  & )
   376:                if ( kslmax /= 0 ) then
   377:                  call HistoryPut(                   &
   378:                    & varname = 'dep',               & ! (in)
   379:                    & array = z_SSDepth,             & ! (in)
   380:                    & history = gthst_rst            & ! (inout)
   381:                    & )
   382:                end if
   383:            
   384:                ! ɸŤߤ
   385:                ! Axes weights settings
   386:                !
   387:                call HistoryAddVariable( &
   388:                  & varname = 'lon_weight', &                           ! (in)
   389:                  & dims = StoA('lon'), &                               ! (in)
   390:                  & longname = 'weight for integration in longitude', & ! (in)
   391:                  & units = 'radian', xtype = 'double', &               ! (in)
   392:                  & history = gthst_rst )                               ! (inout)
   393:                call HistoryAddAttr( &
   394:                  & varname = 'lon', attrname = 'gt_calc_weight', &     ! (in)
   395:                  & value = 'lon_weight', &                             ! (in)
   396:                  & history = gthst_rst )                               ! (inout)
   397:                call HistoryPut( &
   398:                  & varname = 'lon_weight', array = x_Lon_Weight, &     ! (in)
   399:                  & history = gthst_rst )                               ! (inout)
   400:            
   401:                call HistoryAddVariable( &
   402:                  & varname = 'lat_weight', &                           ! (in)
   403:                  & dims = StoA('lat'), &                               ! (in)
   404:                  & longname = 'weight for integration in latitude', &  ! (in)
   405:                  & units = 'radian', xtype = 'double', &               ! (in)
   406:                  & history = gthst_rst )                               ! (inout)
   407:                call HistoryAddAttr( &
   408:                  & varname = 'lat', attrname = 'gt_calc_weight', &     ! (in)
   409:                  & value = 'lat_weight', &                             ! (in)
   410:                  & history = gthst_rst )                               ! (inout)
   411:                call HistoryPut( &
   412:                  & varname = 'lat_weight', array = y_Lat_Weight, &     ! (in)
   413:                  & history = gthst_rst )                               ! (inout)
   414:            
   415:                ! ͽѿ
   416:                ! Predictional variables settings
   417:                !
   418:                call HistoryAddVariable(                  &
   419:                  & varname = 'SurfTemp',                 & ! (in)
   420:                  & dims = StoA('lon', 'lat', time_name), & ! (in)
   421:                  & longname = 'surface temperature',     & ! (in)
   422:                  & units = 'K', xtype = 'double',        & ! (in)
   423:                  & history = gthst_rst                   & ! (inout)
   424:                  & )
   425:                if ( kslmax /= 0 ) then
   426:                  call HistoryAddVariable(                         &
   427:                    & varname = 'SoilTemp',                        & ! (in)
   428:                    & dims = StoA('lon', 'lat', 'dep', time_name), & ! (in)
   429:                    & longname = 'soil temperature',               & ! (in)
   430:                    & units = 'K', xtype = 'double',               & ! (in)
   431:                    & history = gthst_rst                          & ! (inout)
   432:                    & )
   433:                end if
   434:                call HistoryAddVariable(                  &
   435:                  & varname = 'SurfMajCompIceB',          & ! (in)
   436:                  & dims = StoA('lon', 'lat', time_name), & ! (in)
   437:                  & longname = 'major component ice amount on the surface', & ! (in)
   438:                  & units = 'kg m-2', xtype = 'double',   & ! (in)
   439:                  & history = gthst_rst                   & ! (inout)
   440:                  & )
   441:                call HistoryAddVariable(                  &
   442:                  & varname = 'SoilMoistB',               & ! (in)
   443:                  & dims = StoA('lon', 'lat', time_name), & ! (in)
   444:                  & longname = 'soil moisture',           & ! (in)
   445:                  & units = 'kg m-2', xtype = 'double',   & ! (in)
   446:                  & history = gthst_rst                   & ! (inout)
   447:                  & )
   448:                call HistoryAddVariable(                     &
   449:                  & varname = 'SurfSnowB',                   & ! (in)
   450:                  & dims = StoA('lon', 'lat', time_name),    & ! (in)
   451:                  & longname = 'snow amount on the surface', & ! (in)
   452:                  & units = 'kg m-2', xtype = 'double',      & ! (in)
   453:                  & history = gthst_rst                      & ! (inout)
   454:                  & )
   455:                call HistoryAddVariable(                  &
   456:                  & varname = 'SurfMajCompIceN',          & ! (in)
   457:                  & dims = StoA('lon', 'lat', time_name), & ! (in)
   458:                  & longname = 'major component ice amount on the surface', & ! (in)
   459:                  & units = 'kg m-2', xtype = 'double',   & ! (in)
   460:                  & history = gthst_rst                   & ! (inout)
   461:                  & )
   462:                call HistoryAddVariable(                  &
   463:                  & varname = 'SoilMoistN',               & ! (in)
   464:                  & dims = StoA('lon', 'lat', time_name), & ! (in)
   465:                  & longname = 'soil moisture',           & ! (in)
   466:                  & units = 'kg m-2', xtype = 'double',   & ! (in)
   467:                  & history = gthst_rst                   & ! (inout)
   468:                  & )
   469:                call HistoryAddVariable(                     &
   470:                  & varname = 'SurfSnowN',                   & ! (in)
   471:                  & dims = StoA('lon', 'lat', time_name),    & ! (in)
   472:                  & longname = 'snow amount on the surface', & ! (in)
   473:                  & units = 'kg m-2', xtype = 'double',      & ! (in)
   474:                  & history = gthst_rst                      & ! (inout)
   475:                  & )
   476:            
   477:                restart_surftemp_opened = .true.
   478:              end subroutine RestartSurfTempOpen
   479:            
   480:              !--------------------------------------------------------------------------------------
   481:            
   482:              subroutine RestartSurfTempOutput(                             &
   483:                & xy_SurfTemp,                                              & ! (in)
   484:                & xyz_SoilTemp,                                             & ! (in) optional
   485:                & xy_SurfMajCompIceB, xy_SoilMoistB, xy_SurfSnowB,          & ! (in) optional
   486:                & xy_SurfMajCompIceN, xy_SoilMoistN, xy_SurfSnowN           & ! (in) optional
   487:                & )
   488:                !
   489:                ! ꥹȥǡνϤԤޤ. 
   490:                !
   491:                ! Output restart data
   492:            
   493:                ! ⥸塼 ; USE statements
   494:                !
   495:            
   496:                ! gtool4 ǡ
   497:                ! Gtool4 data output
   498:                !
   499:                use gtool_history, only: HistoryPut, HistorySetTime
   500:            
   501:                ! 
   502:                ! Time control
   503:                !
   504:                use timeset, only: &
   505:                  & TimeN, &              ! ƥå $ t $ λ. 
   506:                                          ! Time of step $ t $. 
   507:                  & EndTime               ! ׻λ. 
   508:                                          ! End time of calculation
   509:            
   510:                ! Ȥ߹ߴؿ PRESENT γĥǴؿ
   511:                ! Extended functions of intrinsic function "PRESENT"
   512:                !
   513:                use dc_present, only: present_and_true
   514:            
   515:                ! ʸ ; Declaration statements
   516:                !
   517:                real(DP), intent(in)           :: xy_SurfTemp (0:imax-1, 1:jmax)
   518:                                          ! ɽ̲. 
   519:                                          ! Surface temperature
   520:                real(DP), intent(in), optional :: xyz_SoilTemp      (0:imax-1, 1:jmax, 1:kslmax)
   521:                real(DP), intent(in), optional :: xy_SurfMajCompIceB(0:imax-1, 1:jmax)
   522:                real(DP), intent(in), optional :: xy_SoilMoistB     (0:imax-1, 1:jmax)
   523:                real(DP), intent(in), optional :: xy_SurfSnowB      (0:imax-1, 1:jmax)
   524:                real(DP), intent(in), optional :: xy_SurfMajCompIceN(0:imax-1, 1:jmax)
   525:                real(DP), intent(in), optional :: xy_SoilMoistN     (0:imax-1, 1:jmax)
   526:                real(DP), intent(in), optional :: xy_SurfSnowN      (0:imax-1, 1:jmax)
   527:            
   528:                ! ѿ
   529:                ! Work variables
   530:                !
   531:                logical:: flag_output
   532:                                          ! ϤΥե饰. 
   533:                                          ! Flag for output
   534:            
   535:                ! ¹ʸ ; Executable statement
   536:                !
   537:            
   538:                if ( .not. restart_surftemp_opened ) call RestartSurfTempOpen
   539:            
   540:                ! ϥߥ󥰤Υå
   541:                ! Check output timing
   542:                !
   543:                flag_output = TimeN - PrevOutputTime >= IntTime
   544:                if ( TimeN >= EndTime .and. .not. flag_output_end ) then
   545:                  flag_output = .true.
   546:                  flag_output_end = .true.
   547:                end if
   548:                flag_output = ( .not. TimeN == PrevOutputTime ) .and. flag_output
   549:                flag_output = flag_init_data_save .or. flag_output
   550:            
   551:                if ( .not. flag_output ) return
   552:            
   553:                ! Ѥ, ν (˾)  ¸
   554:                ! Save output time (expected) in this time, for next time
   555:                !
   556:                PrevOutputTime = PrevOutputTime + IntTime
   557:            
   558:                ! 
   559:                ! Set time
   560:                !
   561:                call HistorySetTime( timed = TimeN, history = gthst_rst )
   562:            
   563:                ! ǡ
   564:                ! Data output
   565:                !
   566:                call HistoryPut( 'SurfTemp'  , xy_SurfTemp  , history = gthst_rst ) ! (in)
   567:                if ( present( xyz_SoilTemp ) ) then
   568:                  if ( kslmax /= 0 ) then
   569:                    call HistoryPut( 'SoilTemp'  , xyz_SoilTemp , history = gthst_rst ) ! (in)
   570:                  end if
   571:                end if
   572:                if ( present( xy_SurfMajCompIceB ) ) then
   573:                  call HistoryPut( 'SurfMajCompIceB', xy_SurfMajCompIceB, history = gthst_rst ) ! (in)
   574:                end if
   575:                if ( present( xy_SoilMoistB ) ) then
   576:                  call HistoryPut( 'SoilMoistB', xy_SoilMoistB, history = gthst_rst ) ! (in)
   577:                end if
   578:                if ( present( xy_SurfSnowB ) ) then
   579:                  call HistoryPut( 'SurfSnowB' , xy_SurfSnowB , history = gthst_rst ) ! (in)
   580:                end if
   581:                if ( present( xy_SurfMajCompIceN ) ) then
   582:                  call HistoryPut( 'SurfMajCompIceN', xy_SurfMajCompIceN, history = gthst_rst ) ! (in)
   583:                end if
   584:                if ( present( xy_SoilMoistN ) ) then
   585:                  call HistoryPut( 'SoilMoistN', xy_SoilMoistN, history = gthst_rst ) ! (in)
   586:                end if
   587:                if ( present( xy_SurfSnowN ) ) then
   588:                  call HistoryPut( 'SurfSnowN' , xy_SurfSnowN , history = gthst_rst ) ! (in)
   589:                end if
   590:            
   591:              end subroutine RestartSurfTempOutput
   592:            
   593:              !--------------------------------------------------------------------------------------
   594:            
   595:              subroutine RestartSurfTempClose
   596:                !
   597:                ! ꥹȥǡեϤνλԤޤ. 
   598:                !
   599:                ! Terminate restart data files output. 
   600:            
   601:                ! ⥸塼 ; USE statements
   602:                !
   603:            
   604:                ! gtool4 ǡ
   605:                ! Gtool4 data output
   606:                !
   607:                use gtool_history, only: HistoryClose
   608:            
   609:                ! ʸ ; Declaration statements
   610:                !
   611:            
   612:                ! ѿ
   613:                ! Work variables
   614:                !
   615:            
   616:                ! ¹ʸ ; Executable statement
   617:                !
   618:                if ( .not. restart_surftemp_opened ) return
   619:            
   620:                call HistoryClose( history = gthst_rst ) ! (inout)
   621:            
   622:                restart_surftemp_opened = .false.
   623:              end subroutine RestartSurfTempClose
   624:            
   625:              !--------------------------------------------------------------------------------------
   626:            
   627:              subroutine RestartSurfTempGet(                                &
   628:                & xy_SurfTemp,                                              & ! (out)
   629:                & xyz_SoilTemp,                                             & ! (out)
   630:                & xy_SurfMajCompIceB, xy_SoilMoistB, xy_SurfSnowB,          & ! (out)
   631:                & xy_SurfMajCompIceN, xy_SoilMoistN, xy_SurfSnowN           & ! (out)
   632:                & )
   633:                !
   634:                ! ꥹȥǡϤԤޤ. 
   635:                ! ꥹȥǡ¸ߤʤˤ, 
   636:                ! surface_data ⥸塼Ѥ, ɽ̲٥ǡԤޤ. 
   637:                !
   638:                ! Input restart data. 
   639:                ! If restart data is not exist, 
   640:                ! surface temperature data is created by "surface_data". 
   641:            
   642:            
   643:                ! ⥸塼 ; USE statements
   644:                !
   645:            
   646:                ! ɽ̥ǡ
   647:                ! Prepare surface data
   648:                !
   649:                use surface_data, only: SetSurfData
   650:            
   651:                ! 
   652:                ! Time control
   653:                !
   654:                use timeset, only: &
   655:                  & RestartTime           ! ꥹȳϻ. 
   656:                                          ! Retart time of calculation
   657:            
   658:                ! gtool4 ǡ
   659:                ! Gtool4 data input
   660:                !
   661:                use gtool_history, only: HistoryGet
   662:            
   663:                ! ʸ
   664:                ! Character handling
   665:                !
   666:                use dc_string, only: toChar
   667:            
   668:                ! NetCDF Υåѡץ
   669:                ! NetCDF wrapper
   670:                !
   671:                use netcdf_wrapper, only: NWPresentAVarInFile
   672:            
   673:            
   674:                ! ʸ ; Declaration statements
   675:                !
   676:                real(DP), intent(out) :: xy_SurfTemp (0:imax-1, 1:jmax)
   677:                                          ! ɽ̲. 
   678:                                          ! Surface temperature
   679:                real(DP), intent(out) :: xyz_SoilTemp (0:imax-1, 1:jmax, 1:kslmax)
   680:                real(DP), intent(out) :: xy_SurfMajCompIceB(0:imax-1, 1:jmax)
   681:                real(DP), intent(out) :: xy_SoilMoistB     (0:imax-1, 1:jmax)
   682:                real(DP), intent(out) :: xy_SurfSnowB      (0:imax-1, 1:jmax)
   683:                real(DP), intent(out) :: xy_SurfMajCompIceN(0:imax-1, 1:jmax)
   684:                real(DP), intent(out) :: xy_SoilMoistN     (0:imax-1, 1:jmax)
   685:                real(DP), intent(out) :: xy_SurfSnowN      (0:imax-1, 1:jmax)
   686:            
   687:            
   688:                ! ѿ
   689:                ! Work variables
   690:                !
   691:                character(TOKEN) :: time_range
   692:                                          ! λ. 
   693:                                          ! Specification of time
   694:                logical          :: flag_mpi_init
   695:                integer          :: k
   696:            
   697:                ! ¹ʸ ; Executable statement
   698:                !
   699:            
   700:                if ( .not. restart_surftemp_io_inited ) then
   701:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   702:                end if
   703:            
   704:                ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   705:            !!$    if ( trim(InputFile) == '' .or. trim(InputName) == '' ) then
   706:                if ( trim(InputFile) == '' ) then
   707:            
   708:                  ! ǡ surface_data ⥸塼뤫
   709:                  ! Data is input from "surface_data" module
   710:                  !
   711:                  call SetSurfData( xy_SurfTemp = xy_SurfTemp )  ! (out) optional
   712:            
   713: +------>         do k = 1, kslmax
   714: |+V====            xyz_SoilTemp(:,:,k) = xy_SurfTemp
   715: +------          end do
   716:            
   717: *V----->         xy_SurfMajCompIceB = 0.0_DP
   718: ||               xy_SoilMoistB      = 0.0_DP
   719: ||               xy_SurfSnowB       = 0.0_DP
   720: ||         
   721: ||               xy_SurfMajCompIceN = xy_SurfMajCompIceB
   722: ||               xy_SoilMoistN      = xy_SoilMoistB
   723: *V-----          xy_SurfSnowN       = xy_SurfSnowB
   724:            
   725:                else
   726:            
   727:                  ! ǡ InputFile 
   728:                  ! Data is input from InputFile
   729:                  !
   730:            
   731:                  ! μ
   732:                  ! Get time information
   733:                  !
   734:                  time_range = time_name // '=' // toChar( RestartTime )
   735:            
   736:            !!$      flag_mpi_init = .false.
   737:                  flag_mpi_init = .true.
   738:            
   739:                  ! ǡ
   740:                  ! Data input
   741:                  ! 
   742:                  call HistoryGet(                               &
   743:                    ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   744:            !!$        & InputFile, InputName, range = time_range, &  ! (in)
   745:                    & InputFile, 'SurfTemp', range = time_range, & ! (in)
   746:                    & array = xy_SurfTemp,                       & ! (out)
   747:                    & flag_mpi_split = flag_mpi_init             & ! (in) optional
   748:                    & )
   749:                  if ( kslmax /= 0 ) then
   750:                    if ( NWPresentAVarInFile( InputFile, 'SoilTemp' ) ) then
   751:                      call HistoryGet(                               &
   752:                        & InputFile, 'SoilTemp', range = time_range, & ! (in)
   753:                        & array = xyz_SoilTemp,                      & ! (out)
   754:                        & flag_mpi_split = flag_mpi_init             & ! (in) optional
   755:                        & )
   756:                    else
   757: +------>             do k = 1, kslmax
   758: |+V====                xyz_SoilTemp(:,:,k) = xy_SurfTemp
   759: +------              end do
   760:                      call MessageNotify( 'M', module_name,             &
   761:                        & 'Variable, %c, cannot be found in file, %c.', &
   762:                        & c1 = 'SoilTemp', c2 = trim(InputFile)         &
   763:                        & )
   764:                      call MessageNotify( 'M', module_name,                           &
   765:                        & 'Values in SoilTemp is assumed to be the same as SurfTemp.' &
   766:                        & )
   767:                    end if
   768:                  end if
   769:                  if ( NWPresentAVarInFile( InputFile, 'SurfMajCompIceB' ) ) then
   770:                    call HistoryGet(                                      &
   771:                      & InputFile, 'SurfMajCompIceB', range = time_range, & ! (in)
   772:                      & array = xy_SurfMajCompIceB,                       & ! (out)
   773:                      & flag_mpi_split = flag_mpi_init                    & ! (in) optional
   774:                      & )
   775:                  else
   776: +V=====            xy_SurfMajCompIceB = 0.0_DP
   777:                    call MessageNotify( 'M', module_name,             &
   778:                      & 'Variable, %c, cannot be found in file, %c.', &
   779:                      & c1 = 'SurfMajCompIceB', c2 = trim(InputFile)  &
   780:                      & )
   781:                    call MessageNotify( 'M', module_name,                  &
   782:                      & 'Values in SurfMajCompIceB is assumed to be zero.' &
   783:                      & )
   784:                  end if
   785:                  if ( NWPresentAVarInFile( InputFile, 'SoilMoistB' ) ) then
   786:                    call HistoryGet(                                 &
   787:                      & InputFile, 'SoilMoistB', range = time_range, & ! (in)
   788:                      & array = xy_SoilMoistB,                       & ! (out)
   789:                      & flag_mpi_split = flag_mpi_init               & ! (in) optional
   790:                      & )
   791:                  else
   792: +V=====            xy_SoilMoistB = 0.0_DP
   793:                    call MessageNotify( 'M', module_name,             &
   794:                      & 'Variable, %c, cannot be found in file, %c.', &
   795:                      & c1 = 'SoilMoistB', c2 = trim(InputFile)       &
   796:                      & )
   797:                    call MessageNotify( 'M', module_name,             &
   798:                      & 'Values in SoilMoistB is assumed to be zero.' &
   799:                      & )
   800:                  end if
   801:                  if ( NWPresentAVarInFile( InputFile, 'SurfSnowB' ) ) then
   802:                    call HistoryGet(                                 &
   803:                      & InputFile, 'SurfSnowB', range = time_range,  & ! (in)
   804:                      & array = xy_SurfSnowB,                        & ! (out)
   805:                      & flag_mpi_split = flag_mpi_init               & ! (in) optional
   806:                      & )
   807:                  else
   808: +V=====            xy_SurfSnowB = 0.0_DP
   809:                    call MessageNotify( 'M', module_name,             &
   810:                      & 'Variable, %c, cannot be found in file, %c.', &
   811:                      & c1 = 'SurfSnowB', c2 = trim(InputFile)        &
   812:                      & )
   813:                    call MessageNotify( 'M', module_name,             &
   814:                      & 'Values in SurfSnowB is assumed to be zero.'  &
   815:                      & )
   816:                  end if
   817:                  if ( NWPresentAVarInFile( InputFile, 'SurfMajCompIceN' ) ) then
   818:                    call HistoryGet(                                      &
   819:                      & InputFile, 'SurfMajCompIceN', range = time_range, & ! (in)
   820:                      & array = xy_SurfMajCompIceN,                       & ! (out)
   821:                      & flag_mpi_split = flag_mpi_init                    & ! (in) optional
   822:                      & )
   823:                  else
   824: +V=====            xy_SurfMajCompIceN = xy_SurfMajCompIceB
   825:                    call MessageNotify( 'M', module_name,             &
   826:                      & 'Variable, %c, cannot be found in file, %c.', &
   827:                      & c1 = 'SurfMajCompIceN', c2 = trim(InputFile)  &
   828:                      & )
   829:                    call MessageNotify( 'M', module_name,                                         &
   830:                      & 'Values in SurfMajCompIceN is assumed to be the same as SurfMajCompIceB.' &
   831:                      & )
   832:                  end if
   833:                  if ( NWPresentAVarInFile( InputFile, 'SoilMoistN' ) ) then
   834:                    call HistoryGet(                                 &
   835:                      & InputFile, 'SoilMoistN', range = time_range, & ! (in)
   836:                      & array = xy_SoilMoistN,                       & ! (out)
   837:                      & flag_mpi_split = flag_mpi_init               & ! (in) optional
   838:                      & )
   839:                  else
   840: +V=====            xy_SoilMoistN = xy_SoilMoistB
   841:                    call MessageNotify( 'M', module_name,             &
   842:                      & 'Variable, %c, cannot be found in file, %c.', &
   843:                      & c1 = 'SoilMoistN', c2 = trim(InputFile)       &
   844:                      & )
   845:                    call MessageNotify( 'M', module_name,                               &
   846:                      & 'Values in SoilMoistN is assumed to be the same as SoilMoistB.' &
   847:                      & )
   848:                  end if
   849:                  if ( NWPresentAVarInFile( InputFile, 'SurfSnowN' ) ) then
   850:                    call HistoryGet(                                 &
   851:                      & InputFile, 'SurfSnowN', range = time_range,  & ! (in)
   852:                      & array = xy_SurfSnowN,                        & ! (out)
   853:                      & flag_mpi_split = flag_mpi_init               & ! (in) optional
   854:                      & )
   855:                  else
   856: +V=====            xy_SurfSnowN = xy_SurfSnowB
   857:                    call MessageNotify( 'M', module_name,             &
   858:                      & 'Variable, %c, cannot be found in file, %c.', &
   859:                      & c1 = 'SurfSnowN', c2 = trim(InputFile)        &
   860:                      & )
   861:                    call MessageNotify( 'M', module_name,                             &
   862:                      & 'Values in SurfSnowN is assumed to be the same as SurfSnowB.' &
   863:                      & )
   864:                  end if
   865:            
   866:                end if
   867:            
   868:              end subroutine RestartSurfTempGet
   869:            
   870:              !--------------------------------------------------------------------------------------
   871:            
   872:              subroutine RestartSurfTempInit
   873:                !
   874:                ! restart_surftemp_io ⥸塼νԤޤ. 
   875:                ! NAMELIST#restart_surftemp_io_nml ɤ߹ߤϤμ³ǹԤޤ. 
   876:                !
   877:                ! "restart_surftemp_io" module is initialized. 
   878:                ! "NAMELIST#restart_surftemp_io_nml" is loaded in this procedure. 
   879:                !
   880:            
   881:                ! ⥸塼 ; USE statements
   882:                !
   883:            
   884:                ! ꥹȥǡ
   885:                ! Restart data input/output
   886:                !
   887:                use restart_file_io, only: restart_file_io_inited, &
   888:                  & RestartFileIntValue => IntValue, &
   889:                                          ! ꥹȥǡνϴֳ. 
   890:                                          ! Interval of restart data output
   891:                  & RestartFileIntUnit  => IntUnit
   892:                                          ! ꥹȥǡνϴֳ֤ñ. 
   893:                                          ! Unit for interval of restart data output
   894:            
   895:                ! 
   896:                ! Time control
   897:                !
   898:                use timeset, only: &
   899:                  & RestartTime           ! ꥹȳϻ. 
   900:                                          ! Retart time of calculation
   901:            
   902:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   903:                ! Utilities for NAMELIST file input
   904:                !
   905:                use namelist_util, only: namelist_filename, NmlutilMsg
   906:            
   907:                ! μ갷
   908:                ! Calendar and Date handler
   909:                !
   910:                use dc_calendar, only: DCCalConvertByUnit
   911:            
   912:                ! ե
   913:                ! File I/O support
   914:                !
   915:                use dc_iounit, only: FileOpen
   916:            
   917:                ! ̷ѥ᥿
   918:                ! Kind type parameter
   919:                !
   920:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   921:            
   922:                ! ʸ ; Declaration statements
   923:                !
   924:            
   925:                ! ѿ
   926:                ! Work variables
   927:                !
   928:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   929:                                          ! Unit number for NAMELIST file open
   930:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   931:                                          ! IOSTAT of NAMELIST read
   932:            
   933:                ! NAMELIST ѿ
   934:                ! NAMELIST group name
   935:                !
   936:                namelist /restart_surftemp_io_nml/ &
   937:                  & InputFile, &
   938:                  ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   939:            !!$      & InputName, &
   940:                  & OutputFile, &
   941:                  & IntValue, IntUnit
   942:                      !
   943:                      ! ǥեͤˤĤƤϽ³ "restart_surftemp_io#RestartSurfTempInit" 
   944:                      ! Υɤ򻲾ȤΤ. 
   945:                      !
   946:                      ! Refer to source codes in the initialization procedure
   947:                      ! "restart_surftemp_io#RestartSurfTempInit" for the default values. 
   948:                      !
   949:            
   950:            
   951:                ! ¹ʸ ; Executable statement
   952:                !
   953:            
   954:                if ( restart_surftemp_io_inited ) return
   955:            
   956:            
   957:                ! ǥեͤ
   958:                ! Default values settings
   959:                !
   960:                InputFile  = ''
   961:                ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
   962:            !!$    InputName  = 'SurfTemp'
   963:                if ( .not. flag_init_data_save ) then
   964:                  OutputFile = 'rst_sst.nc'
   965:                else
   966:                  OutputFile = 'sst.nc'
   967:                end if
   968:            
   969:                if ( restart_file_io_inited ) then
   970:                  IntValue   = RestartFileIntValue
   971:                  IntUnit    = RestartFileIntUnit
   972:                else
   973:                  IntValue   = 365.0d0
   974:                  IntUnit    = 'day'
   975:                end if
   976:            
   977:                ! NAMELIST ɤ߹
   978:                ! NAMELIST is input
   979:                !
   980:                if ( trim(namelist_filename) /= '' ) then
   981:                  call FileOpen( unit_nml, &          ! (out)
   982:                    & namelist_filename, mode = 'r' ) ! (in)
   983:            
   984:                  rewind( unit_nml )
   985:                  read( unit_nml, &         ! (in)
   986:                    & nml = restart_surftemp_io_nml, &  ! (out)
   987:                    & iostat = iostat_nml ) ! (out)
   988:                  close( unit_nml )
   989:            
   990:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   991:                  if ( iostat_nml == 0 ) write( STDOUT, nml = restart_surftemp_io_nml )
   992:                end if
   993:            
   994:                ! ϻֳִ֤
   995:                ! Configure time interval of output
   996:                !
   997:                IntTime = DCCalConvertByUnit( IntValue, IntUnit, 'sec' ) ! (in)
   998:                PrevOutputTime = RestartTime
   999:            
  1000:                ! ե饰ν
  1001:                ! Initialize flag
  1002:                !
  1003:                flag_output_end = .false.
  1004:            
  1005:            
  1006:                !  ; Print
  1007:                !
  1008:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
  1009:                call MessageNotify( 'M', module_name, 'Input:: ' )
  1010:                call MessageNotify( 'M', module_name, '  InputFile  = %c', c1 = trim(InputFile) )
  1011:                ! The variable name is fixed, 'SurfTemp' (yot, 2011/09/10).
  1012:            !!$    call MessageNotify( 'M', module_name, '  InputName  = %c', c1 = trim(InputName) )
  1013:                call MessageNotify( 'M', module_name, 'Output:: ' )
  1014:                call MessageNotify( 'M', module_name, '  OutputFile = %c', c1 = trim(OutputFile) )
  1015:                call MessageNotify( 'M', module_name, '  IntTime    = %f [%c]', d = (/ IntValue /), c1 = trim(IntUnit) )
  1016:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
  1017:            
  1018:                restart_surftemp_io_inited = .true.
  1019:            
  1020:              end subroutine RestartSurfTempInit
  1021:            
  1022:              !--------------------------------------------------------------------------------------
  1023:            
  1024:            end module restart_surftemp_io
