Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:49 2012
FILE NAME: init_data.f90
PROGRAM NAME: init_data
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    88  vec  (   3): Unvectorized loop.
    88  vec  (  13): Overhead of loop division is too large.
    90  opt  (1592): Outer loop unrolled inside inner loop.
    90  vec  (   4): Vectorized array expression.
    90  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:49 2012
FILE NAME: init_data.f90
PROGRAM NAME: init_data
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ͥǡեץ
     2  !
     3  != dcpam main program for generation of initial data file
     4  !
     5  ! Authors::   Yasuhiro Morikawa, Yoshiyuki O. Takahashi
     6  ! Version::   $Id: init_data.f90,v 1.6 2012-09-17 10:59:30 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  program init_data
    13    !
    14    ! <b>Note that Japanese and English are described in parallel.</b>
    15    !
    16    ! ͥǡեޤ.
    17    !
    18    ! Initial data file is created.
    19    !
    20  
    21    ! ⥸塼 ; USE statements
    22    !
    23  
    24    ! ˴ؤ
    25    ! Settings of array for atmospheric composition
    26    !
    27    use composition, only : &
    28      &                ncmax, & ! ʬο
    29                                ! Number of composition
    30      &                IndexH2OVap
    31                                ! Υǥå
    32                                ! Index for water vapor
    33  
    34    ! ͥǡ (ꥹȥǡ) 
    35    ! Prepare initial data (restart data)
    36    !
    37    use initial_data, only: SetInitData
    38  
    39    ! ꥹȥǡ
    40    ! Restart data input/output
    41    !
    42    use restart_file_io, only: InitialFileOutPut
    43  
    44    ! ̷ѥ᥿
    45    ! Kind type parameter
    46    !
    47    use dc_types, only: DP, &      ! ټ¿. Double precision.
    48      &                 STRING, &  ! ʸ.       Strings.
    49      &                 TOKEN      ! .   Keywords.
    50  
    51    ! ʸ ; Declaration statements
    52    !
    53    implicit none
    54  
    55    ! ͽѿ (ƥå $ t-\Delta t $ , $ t $ , $ t+\Delta t $ )
    56    ! Prediction variables  (Step $ t-\Delta t $ , $ t $ , $ t+\Delta t $ )
    57    !
    58    real(DP), allocatable:: xyz_U (:,:,:)
    59                                ! $ u $ .   ®. Eastward wind
    60    real(DP), allocatable:: xyz_V (:,:,:)
    61                                ! $ v $ .   ®. Northward wind
    62    real(DP), allocatable:: xyz_Temp (:,:,:)
    63                                ! $ T $ .   . Temperature
    64    real(DP), allocatable:: xyzf_QVap (:,:,:,:)
    65                                ! $ q $ .   漾. Specific humidity
    66    real(DP), allocatable:: xy_Ps (:,:)
    67                                ! $ p_s $ . ɽ̵. Surface pressure
    68  
    69    ! ѿ
    70    ! Work variables
    71    !
    72    integer :: n
    73  
    74  
    75    ! ¹ʸ ; Executable statement
    76    !
    77  
    78    ! ץν (֥롼)
    79    ! Initialization for the main program (Internal subroutine)
    80    !
    81    call MainInit
    82  
    83    ! ͥǡκ
    84    ! Generate initial data
    85    !
    86    call SetInitData( &
    87      & xyz_U, xyz_V, xyz_Temp, xyzf_QVap(:,:,:,IndexH2OVap), xy_Ps )  ! (out)
    88    do n = 1, ncmax
    89      if ( n /= IndexH2OVap ) then
    90        xyzf_QVap(:,:,:,n) = 0.0_DP
     .        if (t81 .gt. 0) then                                              
     .           J1 = and(t81,3)                                                
     .  !CDIR    NODEP                                                          
     .           do t106 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t108 = 1, t82                                            
     .                 xyzf_qvap(t23+t108-1,t106-1+t25,t104+t27,n) =            
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t106 = J1 + 1, t81, 4                                       
     .  !CDIR       NODEP                                                       
     .              do t108 = 1, t82                                            
     .                 xyzf_qvap(t23+t108-1,t106-1+t25,t104+t27,n) =            
     .       1            0.0000000000000000e+000                               
     .                 xyzf_qvap(t23+t108-1,t106+t25,t104+t27,n) =              
     .       1            0.0000000000000000e+000                               
     .                 xyzf_qvap(t23+t108-1,t106+1+t25,t104+t27,n) =            
     .       1            0.0000000000000000e+000                               
     .                 xyzf_qvap(t23+t108-1,t106+2+t25,t104+t27,n) =            
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
    91      end if
    92    end do
    93  
    94    ! ͥǡν
    95    ! Output initial data
    96    !
    97    call InitialFileOutput( &
    98      & xyz_U, xyz_V, xyz_Temp, xyzf_QVap, xy_Ps )  ! (in)
    99  
   100    ! ץνλ (֥롼)
   101    ! Termination for the main program (Internal subroutine)
   102    !
   103    call MainTerminate
   104  
   105  contains
   106  
   107    !-------------------------------------------------------------------
   108  
   109    subroutine MainInit
   110      !
   111      ! ץν³.
   112      !
   113      ! Initialization procedure for the main program.
   114      !
   115  
   116      ! MPI
   117      !
   118      use mpi_wrapper, only : MPIWrapperInit
   119  
   120      use dc_message, only: MessageNotify
   121  
   122      ! ޥɥ饤
   123      ! Command line option parser
   124      !
   125      use option_parser, only: OptParseInit
   126  
   127      ! NAMELIST եϤ˴ؤ桼ƥƥ
   128      ! Utilities for NAMELIST file input
   129      !
   130      use namelist_util, only: NmlutilInit
   131  
   132      ! 
   133      ! Time control
   134      !
   135      use timeset, only: TimesetInit
   136                                ! ƥå $ t $ λ. Time of step $ t $.
   137  
   138      ! ϥեδܾ
   139      ! Management basic information for output files
   140      !
   141      use fileset, only: FilesetInit
   142  
   143      ! ʻ
   144      ! Grid points settings
   145      !
   146      use gridset, only: GridsetInit, &
   147        &                imax, & ! ٳʻ.
   148                                 ! Number of grid points in longitude
   149        &                jmax, & ! ٳʻ.
   150                                 ! Number of grid points in latitude
   151        &                kmax    ! ľؿ.
   152                                 ! Number of vertical level
   153  
   154      ! ˴ؤ
   155      ! Settings of array for atmospheric composition
   156      !
   157      use composition, only : &
   158        &                CompositionInit, &
   159        &                ncmax   ! ʬο
   160                                 ! Number of composition
   161  
   162      ! ʪ
   163      ! Physical constants settings
   164      !
   165      use constants, only: ConstantsInit
   166  
   167      ! ɸǡ
   168      ! Axes data settings
   169      !
   170      use axesset, only: AxessetInit
   171  
   172      ! ꥹȥǡ
   173      ! Restart data input/output
   174      !
   175      use restart_file_io, only: RestartFileInit, RestartFileOpen
   176  
   177      ! ʸ ; Declaration statements
   178      !
   179      implicit none
   180      character(*), parameter:: prog_name = 'init_data'
   181                                ! ץ̾.
   182                                ! Main program name
   183      character(*), parameter:: version = &
   184        & '$Name: dcpam5-20120921 $' // &
   185        & '$Id: init_data.f90,v 1.6 2012-09-17 10:59:30 yot Exp $'
   186                                ! ץΥС
   187                                ! Main program version
   188      character(STRING)      :: namelist_filename
   189                                ! NAMELIST ե̾.
   190                                ! NAMELIST file name
   191  
   192      character(STRING):: brief
   193                                ! ¹ԥեδʷ
   194                                ! Brief account of executable file
   195  
   196      ! ¹ʸ ; Executable statement
   197      !
   198  
   199      ! Initialize MPI
   200      !
   201      call MPIWrapperInit
   202  
   203  
   204      brief = 'Initial data generation'
   205      call MessageNotify( 'M', prog_name, 'Run: %c', c1 = trim(brief) )
   206      call MessageNotify( 'M', prog_name, '-- version = %c', c1 = trim(version) )
   207  
   208      ! ޥɥ饤
   209      ! Command line option parser
   210      !
   211      call OptParseInit(       &
   212        & namelist_filename,   & ! (out)
   213        & prog_name,           & ! (in )
   214        & brief                & ! (in )
   215        & )
   216  
   217      ! NAMELIST ե̾
   218      ! Input NAMELIST file name
   219      !
   220      call NmlutilInit( &
   221        & namelist_filename  & ! (in)
   222        & )
   223  
   224      ! 
   225      ! Time control
   226      !
   227      call TimesetInit
   228  
   229      ! ϥեδܾ
   230      ! Management basic information for output files
   231      !
   232      call FilesetInit
   233  
   234      ! ʻ
   235      ! Grid points settings
   236      !
   237      call GridsetInit
   238  
   239      ! ˴ؤ
   240      ! Settings of array for atmospheric composition
   241      !
   242      call CompositionInit
   243  
   244      ! ʪ
   245      ! Physical constants settings
   246      !
   247      call ConstantsInit
   248  
   249      ! ɸǡ
   250      ! Axes data settings
   251      !
   252      call AxessetInit
   253  
   254      ! ͽѿγ
   255      ! Allocation of prediction variables
   256      !
   257      allocate( xyz_U    (0:imax-1, 1:jmax, 1:kmax) )
   258      allocate( xyz_V    (0:imax-1, 1:jmax, 1:kmax) )
   259      allocate( xyz_Temp (0:imax-1, 1:jmax, 1:kmax) )
   260      allocate( xyzf_QVap(0:imax-1, 1:jmax, 1:kmax, 1:ncmax) )
   261      allocate( xy_Ps    (0:imax-1, 1:jmax) )
   262  
   263      ! ͥǡ
   264      ! Initial data output
   265      !
   266      call RestartFileInit
   267      call RestartFileOpen( flag_init_data = .true. ) ! (in) optional
   268  
   269    end subroutine MainInit
   270  
   271    !-------------------------------------------------------------------
   272  
   273    subroutine MainTerminate
   274      !
   275      ! ץνλ³.
   276      !
   277      ! Termination procedure for the main program.
   278      !
   279  
   280      ! MPI
   281      !
   282      use mpi_wrapper, only : MPIWrapperFinalize
   283  
   284      ! 
   285      ! Time control
   286      !
   287      use timeset, only: TimesetClose
   288  
   289      ! ꥹȥǡ
   290      ! Restart data input/output
   291      !
   292      use restart_file_io, only: RestartFileClose
   293  
   294      ! ʸ ; Declaration statements
   295      !
   296      implicit none
   297  
   298      ! ¹ʸ ; Executable statement
   299      !
   300  
   301      ! ꥹȥǡե륯
   302      ! Close restart data input
   303      !
   304      call RestartFileClose
   305  
   306      ! λ
   307      ! Termination of time control
   308      !
   309      call TimesetClose
   310  
   311      ! ͽѿγղ
   312      ! Deallocation of prediction variables
   313      !
   314      deallocate( xyz_U     )
   315      deallocate( xyz_V     )
   316      deallocate( xyz_Temp  )
   317      deallocate( xyzf_QVap )
   318      deallocate( xy_Ps     )
   319  
   320      ! Finalize MPI
   321      !
   322      call MPIWrapperFinalize
   323  
   324  
   325    end subroutine MainTerminate
   326  
   327  end program init_data
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:52:49 2012
FILE NAME: init_data.f90
PROGRAM NAME: init_data
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ͥǡեץ
     2:            !
     3:            != dcpam main program for generation of initial data file
     4:            !
     5:            ! Authors::   Yasuhiro Morikawa, Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: init_data.f90,v 1.6 2012-09-17 10:59:30 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            program init_data
    13:              !
    14:              ! <b>Note that Japanese and English are described in parallel.</b>
    15:              !
    16:              ! ͥǡեޤ. 
    17:              !
    18:              ! Initial data file is created. 
    19:              !
    20:            
    21:              ! ⥸塼 ; USE statements
    22:              !
    23:            
    24:              ! ˴ؤ
    25:              ! Settings of array for atmospheric composition
    26:              !
    27:              use composition, only : &
    28:                &                ncmax, & ! ʬο
    29:                                          ! Number of composition
    30:                &                IndexH2OVap
    31:                                          ! Υǥå
    32:                                          ! Index for water vapor
    33:            
    34:              ! ͥǡ (ꥹȥǡ) 
    35:              ! Prepare initial data (restart data)
    36:              !
    37:              use initial_data, only: SetInitData
    38:            
    39:              ! ꥹȥǡ
    40:              ! Restart data input/output
    41:              !
    42:              use restart_file_io, only: InitialFileOutPut
    43:            
    44:              ! ̷ѥ᥿
    45:              ! Kind type parameter
    46:              !
    47:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    48:                &                 STRING, &  ! ʸ.       Strings. 
    49:                &                 TOKEN      ! .   Keywords. 
    50:            
    51:              ! ʸ ; Declaration statements
    52:              !
    53:              implicit none
    54:            
    55:              ! ͽѿ (ƥå $ t-\Delta t $ , $ t $ , $ t+\Delta t $ )
    56:              ! Prediction variables  (Step $ t-\Delta t $ , $ t $ , $ t+\Delta t $ )
    57:              !
    58:              real(DP), allocatable:: xyz_U (:,:,:)
    59:                                          ! $ u $ .   ®. Eastward wind
    60:              real(DP), allocatable:: xyz_V (:,:,:)
    61:                                          ! $ v $ .   ®. Northward wind
    62:              real(DP), allocatable:: xyz_Temp (:,:,:)
    63:                                          ! $ T $ .   . Temperature
    64:              real(DP), allocatable:: xyzf_QVap (:,:,:,:)
    65:                                          ! $ q $ .   漾. Specific humidity
    66:              real(DP), allocatable:: xy_Ps (:,:)
    67:                                          ! $ p_s $ . ɽ̵. Surface pressure
    68:            
    69:              ! ѿ
    70:              ! Work variables
    71:              !
    72:              integer :: n
    73:            
    74:            
    75:              ! ¹ʸ ; Executable statement
    76:              !
    77:            
    78:              ! ץν (֥롼)
    79:              ! Initialization for the main program (Internal subroutine)
    80:              !
    81:              call MainInit
    82:            
    83:              ! ͥǡκ
    84:              ! Generate initial data
    85:              !
    86:              call SetInitData( &
    87:                & xyz_U, xyz_V, xyz_Temp, xyzf_QVap(:,:,:,IndexH2OVap), xy_Ps )  ! (out)
    88: +------>     do n = 1, ncmax
    89: |              if ( n /= IndexH2OVap ) then
    90: |++V===          xyzf_QVap(:,:,:,n) = 0.0_DP
    91: |              end if
    92: +------      end do
    93:            
    94:              ! ͥǡν
    95:              ! Output initial data
    96:              !
    97:              call InitialFileOutput( &
    98:                & xyz_U, xyz_V, xyz_Temp, xyzf_QVap, xy_Ps )  ! (in)
    99:            
   100:              ! ץνλ (֥롼)
   101:              ! Termination for the main program (Internal subroutine)
   102:              !
   103:              call MainTerminate
   104:            
   105:            contains
   106:            
   107:              !-------------------------------------------------------------------
   108:            
   109:              subroutine MainInit
   110:                !
   111:                ! ץν³. 
   112:                !
   113:                ! Initialization procedure for the main program. 
   114:                !
   115:            
   116:                ! MPI
   117:                !
   118:                use mpi_wrapper, only : MPIWrapperInit
   119:            
   120:                use dc_message, only: MessageNotify
   121:            
   122:                ! ޥɥ饤
   123:                ! Command line option parser
   124:                !
   125:                use option_parser, only: OptParseInit
   126:            
   127:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   128:                ! Utilities for NAMELIST file input
   129:                !
   130:                use namelist_util, only: NmlutilInit
   131:            
   132:                ! 
   133:                ! Time control
   134:                !
   135:                use timeset, only: TimesetInit
   136:                                          ! ƥå $ t $ λ. Time of step $ t $. 
   137:            
   138:                ! ϥեδܾ
   139:                ! Management basic information for output files
   140:                ! 
   141:                use fileset, only: FilesetInit
   142:            
   143:                ! ʻ
   144:                ! Grid points settings
   145:                !
   146:                use gridset, only: GridsetInit, &
   147:                  &                imax, & ! ٳʻ. 
   148:                                           ! Number of grid points in longitude
   149:                  &                jmax, & ! ٳʻ. 
   150:                                           ! Number of grid points in latitude
   151:                  &                kmax    ! ľؿ. 
   152:                                           ! Number of vertical level
   153:            
   154:                ! ˴ؤ
   155:                ! Settings of array for atmospheric composition
   156:                !
   157:                use composition, only : &
   158:                  &                CompositionInit, &
   159:                  &                ncmax   ! ʬο
   160:                                           ! Number of composition
   161:            
   162:                ! ʪ
   163:                ! Physical constants settings
   164:                !
   165:                use constants, only: ConstantsInit
   166:            
   167:                ! ɸǡ
   168:                ! Axes data settings
   169:                !
   170:                use axesset, only: AxessetInit
   171:            
   172:                ! ꥹȥǡ
   173:                ! Restart data input/output
   174:                !
   175:                use restart_file_io, only: RestartFileInit, RestartFileOpen
   176:            
   177:                ! ʸ ; Declaration statements
   178:                !
   179:                implicit none
   180:                character(*), parameter:: prog_name = 'init_data'
   181:                                          ! ץ̾. 
   182:                                          ! Main program name
   183:                character(*), parameter:: version = &
   184:                  & '$Name: dcpam5-20120921 $' // &
   185:                  & '$Id: init_data.f90,v 1.6 2012-09-17 10:59:30 yot Exp $'
   186:                                          ! ץΥС
   187:                                          ! Main program version
   188:                character(STRING)      :: namelist_filename
   189:                                          ! NAMELIST ե̾. 
   190:                                          ! NAMELIST file name
   191:            
   192:                character(STRING):: brief
   193:                                          ! ¹ԥեδʷ
   194:                                          ! Brief account of executable file
   195:            
   196:                ! ¹ʸ ; Executable statement
   197:                !
   198:            
   199:                ! Initialize MPI
   200:                !
   201:                call MPIWrapperInit
   202:            
   203:            
   204:                brief = 'Initial data generation'
   205:                call MessageNotify( 'M', prog_name, 'Run: %c', c1 = trim(brief) )
   206:                call MessageNotify( 'M', prog_name, '-- version = %c', c1 = trim(version) )
   207:            
   208:                ! ޥɥ饤
   209:                ! Command line option parser
   210:                !
   211:                call OptParseInit(       &
   212:                  & namelist_filename,   & ! (out)
   213:                  & prog_name,           & ! (in )
   214:                  & brief                & ! (in )
   215:                  & )
   216:            
   217:                ! NAMELIST ե̾
   218:                ! Input NAMELIST file name
   219:                !
   220:                call NmlutilInit( &
   221:                  & namelist_filename  & ! (in)
   222:                  & )
   223:            
   224:                ! 
   225:                ! Time control
   226:                !
   227:                call TimesetInit
   228:            
   229:                ! ϥեδܾ
   230:                ! Management basic information for output files
   231:                ! 
   232:                call FilesetInit
   233:            
   234:                ! ʻ
   235:                ! Grid points settings
   236:                !
   237:                call GridsetInit
   238:            
   239:                ! ˴ؤ
   240:                ! Settings of array for atmospheric composition
   241:                !
   242:                call CompositionInit
   243:            
   244:                ! ʪ
   245:                ! Physical constants settings
   246:                !
   247:                call ConstantsInit
   248:            
   249:                ! ɸǡ
   250:                ! Axes data settings
   251:                !
   252:                call AxessetInit
   253:            
   254:                ! ͽѿγ
   255:                ! Allocation of prediction variables
   256:                !
   257:                allocate( xyz_U    (0:imax-1, 1:jmax, 1:kmax) )
   258:                allocate( xyz_V    (0:imax-1, 1:jmax, 1:kmax) )
   259:                allocate( xyz_Temp (0:imax-1, 1:jmax, 1:kmax) )
   260:                allocate( xyzf_QVap(0:imax-1, 1:jmax, 1:kmax, 1:ncmax) )
   261:                allocate( xy_Ps    (0:imax-1, 1:jmax) )
   262:            
   263:                ! ͥǡ
   264:                ! Initial data output
   265:                !
   266:                call RestartFileInit
   267:                call RestartFileOpen( flag_init_data = .true. ) ! (in) optional
   268:            
   269:              end subroutine MainInit
   270:            
   271:              !-------------------------------------------------------------------
   272:            
   273:              subroutine MainTerminate
   274:                !
   275:                ! ץνλ³. 
   276:                !
   277:                ! Termination procedure for the main program. 
   278:                !
   279:            
   280:                ! MPI
   281:                !
   282:                use mpi_wrapper, only : MPIWrapperFinalize
   283:            
   284:                ! 
   285:                ! Time control
   286:                !
   287:                use timeset, only: TimesetClose
   288:            
   289:                ! ꥹȥǡ
   290:                ! Restart data input/output
   291:                !
   292:                use restart_file_io, only: RestartFileClose
   293:            
   294:                ! ʸ ; Declaration statements
   295:                !
   296:                implicit none
   297:            
   298:                ! ¹ʸ ; Executable statement
   299:                !
   300:            
   301:                ! ꥹȥǡե륯
   302:                ! Close restart data input
   303:                !
   304:                call RestartFileClose
   305:            
   306:                ! λ
   307:                ! Termination of time control
   308:                !
   309:                call TimesetClose
   310:            
   311:                ! ͽѿγղ
   312:                ! Deallocation of prediction variables
   313:                !
   314:                deallocate( xyz_U     )
   315:                deallocate( xyz_V     )
   316:                deallocate( xyz_Temp  )
   317:                deallocate( xyzf_QVap )
   318:                deallocate( xy_Ps     )
   319:            
   320:                ! Finalize MPI
   321:                !
   322:                call MPIWrapperFinalize
   323:            
   324:            
   325:              end subroutine MainTerminate
   326:            
   327:            end program init_data
