Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:07 2012
FILE NAME: phy_implicit_utils.f90
PROGRAM NAME: phy_implicit_utils
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   168  vec  (   3): Unvectorized loop.
   168  vec  (  13): Overhead of loop division is too large.
   169  opt  (1593): Loop nest collapsed into one loop.
   169  vec  (   4): Vectorized array expression.
   216  vec  (   1): Vectorized loop.
   221  vec  (   1): Vectorized loop.
   222  opt  (1037): Feedback of array elements.
   229  vec  (   1): Vectorized loop.
   274  opt  (1395): Inner loop stripped and strip loop moved outside outer loop.
   275  vec  (   1): Vectorized loop.
   275  vec  (   1): Vectorized loop.
   276  opt  (1592): Outer loop unrolled inside inner loop.
   281  opt  (1395): Inner loop stripped and strip loop moved outside outer loop.
   282  vec  (   1): Vectorized loop.
   282  vec  (   1): Vectorized loop.
   283  opt  (1037): Feedback of array elements.
   283  opt  (1592): Outer loop unrolled inside inner loop.
   294  opt  (1395): Inner loop stripped and strip loop moved outside outer loop.
   295  vec  (   1): Vectorized loop.
   295  vec  (   1): Vectorized loop.
   296  opt  (1037): Feedback of array elements.
   296  opt  (1592): Outer loop unrolled inside inner loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:07 2012
FILE NAME: phy_implicit_utils.f90
PROGRAM NAME: phy_implicit_utils
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ˡˤʬΤΥ롼
     2  !
     3  != Routines for time integration with implicit scheme
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6  ! Version::   $Id: phy_implicit_utils.f90,v 1.2 2011-07-08 03:55:19 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module phy_implicit_utils
    13    !
    14    != ˡˤʬΤΥ롼
    15    !
    16    != Routines for time integration with implicit scheme
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !== Procedures List
    21    !
    22    ! PhyImplEvalRadLFluxA :: Ĺȥեå
    23    ! ------------         :: ------------
    24    ! PhyImplEvalRadLFluxA :: Longwave flux correction
    25    !
    26    !--
    27    !== NAMELIST
    28    !
    29    ! NAMELIST#phy_implicit_utils_nml
    30    !++
    31  
    32    ! ⥸塼 ; USE statements
    33    !
    34  
    35    ! ʻ
    36    ! Grid points settings
    37    !
    38    use gridset, only: imax, & ! ٳʻ.
    39                               ! Number of grid points in longitude
    40      &                jmax, & ! ٳʻ.
    41                               ! Number of grid points in latitude
    42      &                kmax    ! ľؿ.
    43                               ! Number of vertical level
    44  
    45    ! ˴ؤ
    46    ! Settings of array for atmospheric composition
    47    !
    48    use composition, only: ncmax, IndexH2OVap
    49  
    50    ! ̷ѥ᥿
    51    ! Kind type parameter
    52    !
    53    use dc_types, only: DP, &      ! ټ¿. Double precision.
    54      &                 STRING     ! ʸ.       Strings.
    55  
    56    ! å
    57    ! Message output
    58    !
    59    use dc_message, only: MessageNotify
    60  
    61    ! ʸ ; Declaration statements
    62    !
    63    implicit none
    64    private
    65  
    66    ! ³
    67    ! Public procedure
    68    !
    69    public :: PhyImplEvalRadLFluxA, PhyImplLUDecomp3, PhyImplLUSolve3
    70    public :: PhyImplUtilsInit
    71  
    72    ! ѿ
    73    ! Public variables
    74    !
    75  
    76    ! ѿ
    77    ! Private variables
    78    !
    79    logical, save :: phy_implicit_utils_inited = .false.
    80                                ! ե饰.
    81                                ! Initialization flag
    82  
    83    character(*), parameter:: module_name = 'phy_implicit_utils'
    84                                ! ⥸塼̾.
    85                                ! Module name
    86    character(*), parameter:: version = &
    87      & '$Name: dcpam5-20120921 $' // &
    88      & '$Id: phy_implicit_utils.f90,v 1.2 2011-07-08 03:55:19 yot Exp $'
    89                                ! ⥸塼ΥС
    90                                ! Module version
    91  
    92  contains
    93  
    94    !-------------------------------------------------------------------
    95  
    96    subroutine PhyImplEvalRadLFluxA( &
    97      & xyr_RadLFlux, &                                  ! (in)
    98      & xyz_DTempDt, xy_DSurfTempDt, xyra_DelRadLFlux, & ! (in)
    99      & xyr_RadLFluxA &                                  ! (out)
   100      & )
   101      !
   102      ! $ t-\Delta t $ ˤѲΨ򸵤,
   103      ! $ t+\Delta t $ Ĺȥեå (xyr_RadLFluxA) 򻻽Фޤ.
   104      !
   105      ! Evaluate longwave flux at $ t+\Delta t $ (xyr_RadLFluxA)
   106      ! from the tendency at $ t-\Delta t $ .
   107      !
   108  
   109      ! ⥸塼 ; USE statements
   110      !
   111  
   112      ! 
   113      ! Time control
   114      !
   115      use timeset, only: DelTime, &  ! $ \Delta t $ [s]
   116        & TimesetClockStart, TimesetClockStop
   117  
   118      ! ʸ ; Declaration statements
   119      !
   120      implicit none
   121      real(DP), intent(in):: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   122                                ! Ĺȥեå.
   123                                ! Longwave flux
   124      real(DP), intent(in):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   125                                ! $ \DP{T}{t} $ . Ѳ.
   126                                ! Temperature tendency
   127      real(DP), intent(in):: xy_DSurfTempDt (0:imax-1, 1:jmax)
   128                                ! ɽ̲ѲΨ.
   129                                ! Surface temperature tendency
   130      real(DP), intent(in):: xyra_DelRadLFlux (0:imax-1, 1:jmax, 0:kmax,  0:1)
   131                                ! ĹɽѲ.
   132                                ! Surface temperature tendency with longwave
   133      real(DP), intent(out):: xyr_RadLFluxA (0:imax-1, 1:jmax, 0:kmax)
   134                                ! $ t-\Delta t $ ˤѲΨ򸵤
   135                                ! Ф줿 $ t+\Delta t $ ˤ
   136                                ! Ĺȥեå.
   137                                !
   138                                ! Longwave flux at $ t+\Delta t $
   139                                ! calculated from the tendency at
   140                                ! $ t-\Delta t $ .
   141  
   142      ! ѿ
   143      ! Work variables
   144      !
   145      integer:: k               ! ľ˲ DO 롼Ѻѿ
   146                                ! Work variables for DO loop in vertical direction
   147  
   148      ! ¹ʸ ; Executable statement
   149      !
   150  
   151      ! ǧ
   152      ! Initialization check
   153      !
   154      if ( .not. phy_implicit_utils_inited ) then
   155        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   156      end if
   157  
   158  
   159      ! ׻ַ¬
   160      ! Start measurement of computation time
   161      !
   162      call TimesetClockStart( module_name )
   163  
   164  
   165      ! $ t+\Delta t $ Ĺȥեå (xyr_RadLFluxA) 򻻽
   166      ! Evaluate longwave flux at $ t+\Delta t $ (xyr_RadLFluxA)
   167      !
   168      do k = 0, kmax
   169        xyr_RadLFluxA(:,:,k) = &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t96 = 1, jmax*imax                                             
     .           xyr_radlfluxa(t96-1,1,k) = xyr_radlflux(t96-1,1,k) + (         
     .       1      xy_dsurftempdt(t96-1,1)*xyra_delradlflux(t96-1,1,k,0)+      
     .       2      xyz_dtempdt(t96-1,1,1)*xyra_delradlflux(t96-1,1,k,1))*      
     .       3      2.00000000000000e+000*deltime                               
     .        end do                                                            
   170          &   xyr_RadLFlux(:,:,k) &
   171          & + (   xy_DSurfTempDt     * xyra_DelRadLFlux(:,:,k,0)   &
   172          &     + xyz_DTempDt(:,:,1) * xyra_DelRadLFlux(:,:,k,1) ) &
   173          &   * 2. * DelTime
   174      end do
   175  
   176      ! ׻ַ¬
   177      ! Pause measurement of computation time
   178      !
   179      call TimesetClockStop( module_name )
   180  
   181    end subroutine PhyImplEvalRadLFluxA
   182  
   183    !-------------------------------------------------------------------
   184  
   185    subroutine PhyImplLUDecomp3( &
   186      & jna_LUMtx, &            ! (inout)
   187      & JDim, NDim &            ! (in)
   188      & )
   189      !
   190      ! 3 гѹ LU ʬԤޤ.
   191      !
   192      ! LU decomposition of triple diagonal matrix.
   193      !
   194  
   195      ! ʸ ; Declaration statements
   196      !
   197      implicit none
   198      integer, intent(in):: JDim
   199      integer, intent(in):: NDim
   200      real(DP), intent(inout):: jna_LUMtx(JDim, NDim, -1:1)
   201                                ! LU .
   202                                ! LU matrix
   203  
   204      ! ѿ
   205      ! Work variables
   206      !
   207      integer:: j, n            ! DO 롼Ѻѿ
   208                                ! Work variables for DO loop
   209  
   210      ! ¹ʸ ; Executable statement
   211      !
   212  
   213      ! LU ʬ
   214      ! LU decomposition
   215      !
   216      do j = 1, JDim
   217        jna_LUMtx(j,1,1) = jna_LUMtx(j,1,1) / jna_LUMtx(j,1,0)
   218      end do
   219  
   220      do n = 2, NDim-1
   221        do j = 1, JDim
   222          jna_LUMtx(j,n,0)  =   jna_LUMtx(j,n,0) &
   223            &                 - jna_LUMtx(j,n,-1) * jna_LUMtx(j,n-1,1)
   224  
   225          jna_LUMtx(j,n,1)  =   jna_LUMtx(j,n,1) / jna_LUMtx(j,n,0)
   226        end do
     .  !CDIR    NODEP                                                          
     .        do j = 1, jdim                                                    
     .           jna_lumtx(j,n,0) = jna_lumtx(j,n,0) - jna_lumtx(j,n,-1)*       
     .       1      jna_lumtx(j,n-1,1)                                          
     .           jna_lumtx(j,n,1) = jna_lumtx(j,n,1)/jna_lumtx(j,n,0)           
     .        end do                                                            
   227      end do
   228  
   229      do j = 1, JDim
   230        jna_LUMtx(j,NDim,0) =   jna_LUMtx(j,NDim, 0) &
   231          &                   - jna_LUMtx(j,NDim,-1) * jna_LUMtx(j,NDim-1,1)
   232      end do
   233  
   234    end subroutine PhyImplLUDecomp3
   235  
   236    !-------------------------------------------------------------------
   237  
   238    subroutine PhyImplLUSolve3( &
   239      & ijn_Vector, &       ! (inout)
   240      & jna_LUMtx, &        ! (in)
   241      & IDim, JDim, NDim &  ! (in)
   242      & )
   243      !
   244      ! LU ʬˤη׻ (3гѹ) Ԥޤ.
   245      !
   246      ! Solve with LU decomposition (For triple diagonal matrix).
   247      !
   248  
   249      ! ʸ ; Declaration statements
   250      !
   251      implicit none
   252      integer, intent(in):: IDim
   253      integer, intent(in):: JDim
   254      integer, intent(in):: NDim
   255      real(DP), intent(in):: jna_LUMtx(JDim, NDim, -1:1)
   256                                ! LU .
   257                                ! LU matrix
   258      real(DP), intent(inout):: ijn_Vector(IDim, JDim, NDim)
   259                                ! ե٥ȥ / .
   260                                ! Right-hand side vector / solution
   261  
   262      ! ѿ
   263      ! Work variables
   264      !
   265      integer:: i, j, n         ! DO 롼Ѻѿ
   266                                ! Work variables for DO loop
   267  
   268      ! ¹ʸ ; Executable statement
   269      !
   270  
   271      ! 
   272      ! Forward substitution
   273      !
   274      do i = 1, IDim
   275        do j = 1, JDim
   276          ijn_Vector(i,j,1) = ijn_Vector(i,j,1) / jna_LUMtx(j,1,0)
   277        end do
   278      end do
     .  !CDIR    NOASSUME                                                       
     .        do j1 = 0, jdim - 1, maxvl()                                      
     .           j2 = min0(jdim - j1,maxvl())                                   
     .           if (idim .gt. 0) then                                          
     .              J3 = and(idim,3)                                            
     .              do i = 1, J3                                                
     .  !CDIR          NODEP                                                    
     .                 do j = 1, j2                                             
     .                    ijn_vector(i,j1+j,1) = ijn_vector(i,j1+j,1)/jna_lumtx(
     .       1               j1+j,1,0)                                          
     .                 end do                                                   
     .              end do                                                      
     .              do i = J3 + 1, idim, 4                                      
     .  !CDIR          NODEP                                                    
     .                 do j = 1, j2                                             
     .                    D1 = jna_lumtx(j1+j,1,0)                              
     .                    ijn_vector(i,j1+j,1) = ijn_vector(i,j1+j,1)/D1        
     .                    ijn_vector(i+1,j1+j,1) = ijn_vector(i+1,j1+j,1)/D1    
     .                    ijn_vector(i+2,j1+j,1) = ijn_vector(i+2,j1+j,1)/D1    
     .                    ijn_vector(i+3,j1+j,1) = ijn_vector(i+3,j1+j,1)/D1    
     .                 end do                                                   
     .              end do                                                      
     .           endif                                                          
     .        end do                                                            
   279  
   280      do n = 2, NDim
   281        do i = 1, IDim
   282          do j = 1, JDim
   283            ijn_Vector(i,j,n) = (   ijn_Vector(i,j,n) &
   284              &                   - ijn_Vector(i,j,n-1) * jna_LUMtx(j,n,-1) &
   285              &                  ) / jna_LUMtx(j,n,0)
   286          end do
   287        end do
     .  !CDIR NOASSUME                                                          
     .        do j3 = 0, jdim - 1, maxvl()                                      
     .           j4 = min0(jdim - j3,maxvl())                                   
     .           if (idim .gt. 0) then                                          
     .              J6 = and(idim,3)                                            
     .              do i = 1, J6                                                
     .  !CDIR          NODEP                                                    
     .                 do j = 1, j4                                             
     .                    ijn_vector(i,j3+j,n) = (ijn_vector(i,j3+j,n)-         
     .       1               ijn_vector(i,j3+j,n-1)*jna_lumtx(j3+j,n,-1))/      
     .       2               jna_lumtx(j3+j,n,0)                                
     .                 end do                                                   
     .              end do                                                      
     .              do i = J6 + 1, idim, 4                                      
     .  !CDIR          NODEP                                                    
     .                 do j = 1, j4                                             
     .                    D3 = jna_lumtx(j3+j,n,0)                              
     .                    D2 = jna_lumtx(j3+j,n,-1)                             
     .                    ijn_vector(i,j3+j,n) = (ijn_vector(i,j3+j,n)-         
     .       1               ijn_vector(i,j3+j,n-1)*D2)/D3                      
     .                    ijn_vector(i+1,j3+j,n) = (ijn_vector(i+1,j3+j,n)-     
     .       1               ijn_vector(i+1,j3+j,n-1)*D2)/D3                    
     .                    ijn_vector(i+2,j3+j,n) = (ijn_vector(i+2,j3+j,n)-     
     .       1               ijn_vector(i+2,j3+j,n-1)*D2)/D3                    
     .                    ijn_vector(i+3,j3+j,n) = (ijn_vector(i+3,j3+j,n)-     
     .       1               ijn_vector(i+3,j3+j,n-1)*D2)/D3                    
     .                 end do                                                   
     .              end do                                                      
     .           endif                                                          
     .        end do                                                            
   288      end do
   289  
   290      ! 
   291      ! Backward substitution
   292      !
   293      do n = NDim-1, 1, -1
   294        do i = 1, IDim
   295          do j = 1, JDim
   296            ijn_Vector(i,j,n) =   ijn_Vector(i,j,n) &
   297              &                 - ijn_Vector(i,j,n+1) * jna_LUMtx(j,n,1)
   298          end do
   299        end do
     .  !CDIR NOASSUME                                                          
     .        do j5 = 0, jdim - 1, maxvl()                                      
     .           j6 = min0(jdim - j5,maxvl())                                   
     .           if (idim .gt. 0) then                                          
     .              J9 = and(idim,3)                                            
     .              do i = 1, J9                                                
     .  !CDIR          NODEP                                                    
     .                 do j = 1, j6                                             
     .                    ijn_vector(i,j5+j,n) = ijn_vector(i,j5+j,n) -         
     .       1               ijn_vector(i,j5+j,n+1)*jna_lumtx(j5+j,n,1)         
     .                 end do                                                   
     .              end do                                                      
     .              do i = J9 + 1, idim, 4                                      
     .  !CDIR          NODEP                                                    
     .                 do j = 1, j6                                             
     .                    D4 = jna_lumtx(j5+j,n,1)                              
     .                    ijn_vector(i,j5+j,n) = ijn_vector(i,j5+j,n) -         
     .       1               ijn_vector(i,j5+j,n+1)*D4                          
     .                    ijn_vector(i+1,j5+j,n) = ijn_vector(i+1,j5+j,n) -     
     .       1               ijn_vector(i+1,j5+j,n+1)*D4                        
     .                    ijn_vector(i+2,j5+j,n) = ijn_vector(i+2,j5+j,n) -     
     .       1               ijn_vector(i+2,j5+j,n+1)*D4                        
     .                    ijn_vector(i+3,j5+j,n) = ijn_vector(i+3,j5+j,n) -     
     .       1               ijn_vector(i+3,j5+j,n+1)*D4                        
     .                 end do                                                   
     .              end do                                                      
     .           endif                                                          
     .        end do                                                            
   300      end do
   301  
   302    end subroutine PhyImplLUSolve3
   303  
   304    !-------------------------------------------------------------------
   305  
   306    subroutine PhyImplUtilsInit
   307      !
   308      ! phy_implicit_utils ⥸塼νԤޤ.
   309      ! NAMELIST#phy_implicit_nml ɤ߹ߤϤμ³ǹԤޤ.
   310      !
   311      ! "phy_implicit_utils" module is initialized.
   312      ! "NAMELIST#phy_implicit_utils_nml" is loaded in this procedure.
   313      !
   314  
   315      ! ⥸塼 ; USE statements
   316      !
   317  
   318      ! NAMELIST եϤ˴ؤ桼ƥƥ
   319      ! Utilities for NAMELIST file input
   320      !
   321      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   322  
   323      ! ե
   324      ! File I/O support
   325      !
   326      use dc_iounit, only: FileOpen
   327  
   328      ! ̷ѥ᥿
   329      ! Kind type parameter
   330      !
   331      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   332  
   333      ! ʸ
   334      ! Character handling
   335      !
   336      use dc_string, only: StoA
   337  
   338      ! ҥȥǡ
   339      ! History data output
   340      !
   341      use gtool_historyauto, only: HistoryAutoAddVariable
   342  
   343      ! ʸ ; Declaration statements
   344      !
   345      implicit none
   346  
   347      ! ѿ
   348      ! Work variables
   349      !
   350  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   351  !!$                              ! Unit number for NAMELIST file open
   352  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   353  !!$                              ! IOSTAT of NAMELIST read
   354  
   355      ! NAMELIST ѿ
   356      ! NAMELIST group name
   357      !
   358  !!$    namelist /phy_implicit_nml/
   359  !!$          !
   360  !!$          ! ǥեͤˤĤƤϽ³ "phy_implicit#PhyImplInit"
   361  !!$          ! Υɤ򻲾ȤΤ.
   362  !!$          !
   363  !!$          ! Refer to source codes in the initialization procedure
   364  !!$          ! "phy_implicit#PhyImplInit" for the default values.
   365  !!$          !
   366  
   367      ! ¹ʸ ; Executable statement
   368      !
   369  
   370      if ( phy_implicit_utils_inited ) return
   371  
   372      ! ǥեͤ
   373      ! Default values settings
   374      !
   375  
   376      ! NAMELIST ɤ߹
   377      ! NAMELIST is input
   378      !
   379  !!$    if ( trim(namelist_filename) /= '' ) then
   380  !!$      call FileOpen( unit_nml, &          ! (out)
   381  !!$        & namelist_filename, mode = 'r' ) ! (in)
   382  !!$
   383  !!$      rewind( unit_nml )
   384  !!$      read( unit_nml, &           ! (in)
   385  !!$        & nml = phy_implicit_nml, &  ! (out)
   386  !!$        & iostat = iostat_nml )   ! (out)
   387  !!$      close( unit_nml )
   388  !!$
   389  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   390  !!$    end if
   391  
   392      !  ; Print
   393      !
   394      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   395      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   396  
   397      phy_implicit_utils_inited = .true.
   398  
   399    end subroutine PhyImplUtilsInit
   400  
   401    !-------------------------------------------------------------------
   402  
   403  end module phy_implicit_utils
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:07 2012
FILE NAME: phy_implicit_utils.f90
PROGRAM NAME: phy_implicit_utils
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ˡˤʬΤΥ롼
     2:            !
     3:            != Routines for time integration with implicit scheme
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6:            ! Version::   $Id: phy_implicit_utils.f90,v 1.2 2011-07-08 03:55:19 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module phy_implicit_utils
    13:              !
    14:              != ˡˤʬΤΥ롼
    15:              !
    16:              != Routines for time integration with implicit scheme
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !== Procedures List
    21:              !
    22:              ! PhyImplEvalRadLFluxA :: Ĺȥեå
    23:              ! ------------         :: ------------
    24:              ! PhyImplEvalRadLFluxA :: Longwave flux correction
    25:              !
    26:              !--
    27:              !== NAMELIST
    28:              !
    29:              ! NAMELIST#phy_implicit_utils_nml
    30:              !++
    31:            
    32:              ! ⥸塼 ; USE statements
    33:              !
    34:            
    35:              ! ʻ
    36:              ! Grid points settings
    37:              !
    38:              use gridset, only: imax, & ! ٳʻ. 
    39:                                         ! Number of grid points in longitude
    40:                &                jmax, & ! ٳʻ. 
    41:                                         ! Number of grid points in latitude
    42:                &                kmax    ! ľؿ. 
    43:                                         ! Number of vertical level
    44:            
    45:              ! ˴ؤ
    46:              ! Settings of array for atmospheric composition
    47:              !
    48:              use composition, only: ncmax, IndexH2OVap
    49:            
    50:              ! ̷ѥ᥿
    51:              ! Kind type parameter
    52:              !
    53:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    54:                &                 STRING     ! ʸ.       Strings. 
    55:            
    56:              ! å
    57:              ! Message output
    58:              !
    59:              use dc_message, only: MessageNotify
    60:            
    61:              ! ʸ ; Declaration statements
    62:              !
    63:              implicit none
    64:              private
    65:            
    66:              ! ³
    67:              ! Public procedure
    68:              !
    69:              public :: PhyImplEvalRadLFluxA, PhyImplLUDecomp3, PhyImplLUSolve3
    70:              public :: PhyImplUtilsInit
    71:            
    72:              ! ѿ
    73:              ! Public variables
    74:              !
    75:            
    76:              ! ѿ
    77:              ! Private variables
    78:              !
    79:              logical, save :: phy_implicit_utils_inited = .false.
    80:                                          ! ե饰. 
    81:                                          ! Initialization flag
    82:            
    83:              character(*), parameter:: module_name = 'phy_implicit_utils'
    84:                                          ! ⥸塼̾. 
    85:                                          ! Module name
    86:              character(*), parameter:: version = &
    87:                & '$Name: dcpam5-20120921 $' // &
    88:                & '$Id: phy_implicit_utils.f90,v 1.2 2011-07-08 03:55:19 yot Exp $'
    89:                                          ! ⥸塼ΥС
    90:                                          ! Module version
    91:            
    92:            contains
    93:            
    94:              !-------------------------------------------------------------------
    95:            
    96:              subroutine PhyImplEvalRadLFluxA( &
    97:                & xyr_RadLFlux, &                                  ! (in)
    98:                & xyz_DTempDt, xy_DSurfTempDt, xyra_DelRadLFlux, & ! (in)
    99:                & xyr_RadLFluxA &                                  ! (out)
   100:                & )
   101:                !
   102:                ! $ t-\Delta t $ ˤѲΨ򸵤, 
   103:                ! $ t+\Delta t $ Ĺȥեå (xyr_RadLFluxA) 򻻽Фޤ. 
   104:                ! 
   105:                ! Evaluate longwave flux at $ t+\Delta t $ (xyr_RadLFluxA) 
   106:                ! from the tendency at $ t-\Delta t $ . 
   107:                !
   108:            
   109:                ! ⥸塼 ; USE statements
   110:                !
   111:            
   112:                ! 
   113:                ! Time control
   114:                !
   115:                use timeset, only: DelTime, &  ! $ \Delta t $ [s]
   116:                  & TimesetClockStart, TimesetClockStop
   117:            
   118:                ! ʸ ; Declaration statements
   119:                !
   120:                implicit none
   121:                real(DP), intent(in):: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   122:                                          ! Ĺȥեå. 
   123:                                          ! Longwave flux
   124:                real(DP), intent(in):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   125:                                          ! $ \DP{T}{t} $ . Ѳ. 
   126:                                          ! Temperature tendency
   127:                real(DP), intent(in):: xy_DSurfTempDt (0:imax-1, 1:jmax)
   128:                                          ! ɽ̲ѲΨ. 
   129:                                          ! Surface temperature tendency
   130:                real(DP), intent(in):: xyra_DelRadLFlux (0:imax-1, 1:jmax, 0:kmax,  0:1)
   131:                                          ! ĹɽѲ. 
   132:                                          ! Surface temperature tendency with longwave
   133:                real(DP), intent(out):: xyr_RadLFluxA (0:imax-1, 1:jmax, 0:kmax)
   134:                                          ! $ t-\Delta t $ ˤѲΨ򸵤
   135:                                          ! Ф줿 $ t+\Delta t $ ˤ
   136:                                          ! Ĺȥեå. 
   137:                                          !
   138:                                          ! Longwave flux at $ t+\Delta t $ 
   139:                                          ! calculated from the tendency at 
   140:                                          ! $ t-\Delta t $ . 
   141:            
   142:                ! ѿ
   143:                ! Work variables
   144:                !
   145:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   146:                                          ! Work variables for DO loop in vertical direction
   147:            
   148:                ! ¹ʸ ; Executable statement
   149:                !
   150:            
   151:                ! ǧ
   152:                ! Initialization check
   153:                !
   154:                if ( .not. phy_implicit_utils_inited ) then
   155:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   156:                end if
   157:            
   158:            
   159:                ! ׻ַ¬
   160:                ! Start measurement of computation time
   161:                !
   162:                call TimesetClockStart( module_name )
   163:            
   164:            
   165:                ! $ t+\Delta t $ Ĺȥեå (xyr_RadLFluxA) 򻻽
   166:                ! Evaluate longwave flux at $ t+\Delta t $ (xyr_RadLFluxA)
   167:                !
   168: +------>       do k = 0, kmax
   169: |W*====          xyr_RadLFluxA(:,:,k) = &
   170: |                  &   xyr_RadLFlux(:,:,k) &
   171: |                  & + (   xy_DSurfTempDt     * xyra_DelRadLFlux(:,:,k,0)   &
   172: |                  &     + xyz_DTempDt(:,:,1) * xyra_DelRadLFlux(:,:,k,1) ) &
   173: |                  &   * 2. * DelTime
   174: +------        end do
   175:            
   176:                ! ׻ַ¬
   177:                ! Pause measurement of computation time
   178:                !
   179:                call TimesetClockStop( module_name )
   180:            
   181:              end subroutine PhyImplEvalRadLFluxA
   182:            
   183:              !-------------------------------------------------------------------
   184:            
   185:              subroutine PhyImplLUDecomp3( &
   186:                & jna_LUMtx, &            ! (inout)
   187:                & JDim, NDim &            ! (in)
   188:                & )
   189:                !
   190:                ! 3 гѹ LU ʬԤޤ. 
   191:                !
   192:                ! LU decomposition of triple diagonal matrix.
   193:                !
   194:            
   195:                ! ʸ ; Declaration statements
   196:                !
   197:                implicit none
   198:                integer, intent(in):: JDim
   199:                integer, intent(in):: NDim
   200:                real(DP), intent(inout):: jna_LUMtx(JDim, NDim, -1:1)
   201:                                          ! LU . 
   202:                                          ! LU matrix
   203:            
   204:                ! ѿ
   205:                ! Work variables
   206:                ! 
   207:                integer:: j, n            ! DO 롼Ѻѿ
   208:                                          ! Work variables for DO loop
   209:            
   210:                ! ¹ʸ ; Executable statement
   211:                !
   212:            
   213:                ! LU ʬ
   214:                ! LU decomposition
   215:                !
   216: V------>       do j = 1, JDim
   217: |                jna_LUMtx(j,1,1) = jna_LUMtx(j,1,1) / jna_LUMtx(j,1,0)
   218: V------        end do
   219:            
   220: +------>       do n = 2, NDim-1
   221: |V----->         do j = 1, JDim
   222: ||                 jna_LUMtx(j,n,0)  =   jna_LUMtx(j,n,0) &
   223: ||                   &                 - jna_LUMtx(j,n,-1) * jna_LUMtx(j,n-1,1)
   224: ||         
   225: ||                 jna_LUMtx(j,n,1)  =   jna_LUMtx(j,n,1) / jna_LUMtx(j,n,0)
   226: |V-----          end do
   227: +------        end do
   228:            
   229: V------>       do j = 1, JDim
   230: |                jna_LUMtx(j,NDim,0) =   jna_LUMtx(j,NDim, 0) &
   231: |                  &                   - jna_LUMtx(j,NDim,-1) * jna_LUMtx(j,NDim-1,1)
   232: V------        end do
   233:            
   234:              end subroutine PhyImplLUDecomp3
   235:            
   236:              !-------------------------------------------------------------------
   237:            
   238:              subroutine PhyImplLUSolve3( &
   239:                & ijn_Vector, &       ! (inout)
   240:                & jna_LUMtx, &        ! (in)
   241:                & IDim, JDim, NDim &  ! (in)
   242:                & )
   243:                !
   244:                ! LU ʬˤη׻ (3гѹ) Ԥޤ.
   245:                !
   246:                ! Solve with LU decomposition (For triple diagonal matrix). 
   247:                !
   248:            
   249:                ! ʸ ; Declaration statements
   250:                !
   251:                implicit none
   252:                integer, intent(in):: IDim
   253:                integer, intent(in):: JDim
   254:                integer, intent(in):: NDim
   255:                real(DP), intent(in):: jna_LUMtx(JDim, NDim, -1:1)
   256:                                          ! LU . 
   257:                                          ! LU matrix
   258:                real(DP), intent(inout):: ijn_Vector(IDim, JDim, NDim)
   259:                                          ! ե٥ȥ / . 
   260:                                          ! Right-hand side vector / solution
   261:            
   262:                ! ѿ
   263:                ! Work variables
   264:                ! 
   265:                integer:: i, j, n         ! DO 롼Ѻѿ
   266:                                          ! Work variables for DO loop
   267:            
   268:                ! ¹ʸ ; Executable statement
   269:                !
   270:            
   271:                ! 
   272:                ! Forward substitution
   273:                !
   274: +------>       do i = 1, IDim
   275: |V----->         do j = 1, JDim
   276: ||                 ijn_Vector(i,j,1) = ijn_Vector(i,j,1) / jna_LUMtx(j,1,0)
   277: |V-----          end do
   278: +------        end do
   279:            
   280: +------>       do n = 2, NDim
   281: |+----->         do i = 1, IDim
   282: ||V---->           do j = 1, JDim
   283: |||                  ijn_Vector(i,j,n) = (   ijn_Vector(i,j,n) &
   284: |||                    &                   - ijn_Vector(i,j,n-1) * jna_LUMtx(j,n,-1) &
   285: |||                    &                  ) / jna_LUMtx(j,n,0)
   286: ||V----            end do
   287: |+-----          end do
   288: +------        end do
   289:            
   290:                ! 
   291:                ! Backward substitution
   292:                !
   293: +------>       do n = NDim-1, 1, -1
   294: |+----->         do i = 1, IDim
   295: ||V---->           do j = 1, JDim
   296: |||                  ijn_Vector(i,j,n) =   ijn_Vector(i,j,n) &
   297: |||                    &                 - ijn_Vector(i,j,n+1) * jna_LUMtx(j,n,1)
   298: ||V----            end do
   299: |+-----          end do
   300: +------        end do
   301:            
   302:              end subroutine PhyImplLUSolve3
   303:            
   304:              !-------------------------------------------------------------------
   305:            
   306:              subroutine PhyImplUtilsInit
   307:                !
   308:                ! phy_implicit_utils ⥸塼νԤޤ. 
   309:                ! NAMELIST#phy_implicit_nml ɤ߹ߤϤμ³ǹԤޤ. 
   310:                !
   311:                ! "phy_implicit_utils" module is initialized. 
   312:                ! "NAMELIST#phy_implicit_utils_nml" is loaded in this procedure. 
   313:                !
   314:            
   315:                ! ⥸塼 ; USE statements
   316:                !
   317:            
   318:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   319:                ! Utilities for NAMELIST file input
   320:                !
   321:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   322:            
   323:                ! ե
   324:                ! File I/O support
   325:                !
   326:                use dc_iounit, only: FileOpen
   327:            
   328:                ! ̷ѥ᥿
   329:                ! Kind type parameter
   330:                !
   331:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   332:            
   333:                ! ʸ
   334:                ! Character handling
   335:                !
   336:                use dc_string, only: StoA
   337:            
   338:                ! ҥȥǡ
   339:                ! History data output
   340:                !
   341:                use gtool_historyauto, only: HistoryAutoAddVariable
   342:            
   343:                ! ʸ ; Declaration statements
   344:                !
   345:                implicit none
   346:            
   347:                ! ѿ
   348:                ! Work variables
   349:                !
   350:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   351:            !!$                              ! Unit number for NAMELIST file open
   352:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   353:            !!$                              ! IOSTAT of NAMELIST read
   354:            
   355:                ! NAMELIST ѿ
   356:                ! NAMELIST group name
   357:                !
   358:            !!$    namelist /phy_implicit_nml/
   359:            !!$          !
   360:            !!$          ! ǥեͤˤĤƤϽ³ "phy_implicit#PhyImplInit" 
   361:            !!$          ! Υɤ򻲾ȤΤ. 
   362:            !!$          !
   363:            !!$          ! Refer to source codes in the initialization procedure
   364:            !!$          ! "phy_implicit#PhyImplInit" for the default values. 
   365:            !!$          !
   366:            
   367:                ! ¹ʸ ; Executable statement
   368:                !
   369:            
   370:                if ( phy_implicit_utils_inited ) return
   371:            
   372:                ! ǥեͤ
   373:                ! Default values settings
   374:                !
   375:            
   376:                ! NAMELIST ɤ߹
   377:                ! NAMELIST is input
   378:                !
   379:            !!$    if ( trim(namelist_filename) /= '' ) then
   380:            !!$      call FileOpen( unit_nml, &          ! (out)
   381:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   382:            !!$
   383:            !!$      rewind( unit_nml )
   384:            !!$      read( unit_nml, &           ! (in)
   385:            !!$        & nml = phy_implicit_nml, &  ! (out)
   386:            !!$        & iostat = iostat_nml )   ! (out)
   387:            !!$      close( unit_nml )
   388:            !!$
   389:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   390:            !!$    end if
   391:            
   392:                !  ; Print
   393:                !
   394:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   395:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   396:            
   397:                phy_implicit_utils_inited = .true.
   398:            
   399:              end subroutine PhyImplUtilsInit
   400:            
   401:              !-------------------------------------------------------------------
   402:            
   403:            end module phy_implicit_utils
