Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:47 2012
FILE NAME: cloud_simple.f90
PROGRAM NAME: cloud_simple
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   183  opt  (1593): Loop nest collapsed into one loop.
   183  vec  (   4): Vectorized array expression.
   242  warn (  82): Name "xyz_dqraindt" is not used.
   242  warn (  83): Dummy argument "xyz_dtempdtcond" is not used.
   242  warn (  82): Name "xyz_qh2oliqb" is not used.
   282  opt  (1592): Outer loop unrolled inside inner loop.
   282  vec  (   4): Vectorized array expression.
   282  vec  (   4): Vectorized array expression.
   287  opt  (  11): Fused array assignments. :line 287 - 293
   287  vec  (   4): Vectorized array expression.
   341  opt  (  11): Fused array assignments. :line 341 - 342
   341  vec  (   4): Vectorized array expression.
   341  vec  (   4): Vectorized array expression.
   342  opt  (1592): Outer loop unrolled inside inner loop.
   417  opt  (  11): Fused array assignments. :line 417 - 418
   417  opt  (1593): Loop nest collapsed into one loop.
   417  vec  (   4): Vectorized array expression.
   420  vec  (   3): Unvectorized loop.
   420  vec  (  13): Overhead of loop division is too large.
   421  opt  (  11): Fused array assignments. :line 421 - 434
   421  opt  (1019): Feedback of scalar value from one loop pass to another.
   421  vec  (   4): Vectorized array expression.
   424  opt  (1019): Feedback of scalar value from one loop pass to another.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:47 2012
FILE NAME: cloud_simple.f90
PROGRAM NAME: cloud_simple
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ñǥ
     2  !
     3  != Simple cloud model
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: cloud_simple.f90,v 1.1 2012-09-08 15:16:39 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module cloud_simple
    13    !
    14    != ñǥ
    15    !
    16    != Simple cloud model
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ñǥˤη׻.
    21    !
    22    ! In this module, the amount of cloud is calculated by use of a simple
    23    ! cloud model.
    24    !
    25    !== Procedures List
    26    !
    27  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    28  !!$  ! ------------            :: ------------
    29  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    30    !
    31    !== NAMELIST
    32    !
    33    ! NAMELIST#cloud_simple_nml
    34    !
    35  
    36    ! ⥸塼 ; USE statements
    37  
    38    !
    39    ! Kind type parameter
    40    !
    41    use dc_types, only: DP, &      ! Double precision.
    42      &                 STRING, &  ! Strings.
    43      &                 TOKEN      ! Keywords.
    44  
    45    ! å
    46    ! Message output
    47    !
    48    use dc_message, only: MessageNotify
    49  
    50    ! ʻ
    51    ! Grid points settings
    52    !
    53    use gridset, only: imax, & ! ٳʻ.
    54                               ! Number of grid points in longitude
    55      &                jmax, & ! ٳʻ.
    56                               ! Number of grid points in latitude
    57      &                kmax    ! ľؿ.
    58                               ! Number of vertical level
    59  
    60    implicit none
    61  
    62    private
    63  
    64  
    65    ! ³
    66    ! Public procedure
    67    !
    68    public :: CloudSimple
    69    public :: CloudSimpleCalcCloudCover
    70    public :: CloudSimpleInit
    71  
    72    public :: CloudSimpleDivideWatAndIce
    73    public :: CloudSimpleCalcPRCPWithPC
    74  
    75  
    76    ! ѿ
    77    ! Public variables
    78    !
    79  
    80  
    81    ! ѿ
    82    ! Private variables
    83    !
    84    logical , save        :: FlagSnow
    85                             ! A flag for snow
    86  
    87    integer , save        :: IDCloudCoverMethod
    88    integer , parameter   :: IDCloudCoverMethodConst    = 1
    89    integer , parameter   :: IDCloudCoverMethodRH       = 2
    90  
    91    real(DP), save        :: CloudLifeTime
    92  
    93    real(DP), save        :: CloudCover
    94  
    95    real(DP), save        :: RHCrtl
    96  
    97  
    98    logical, save :: cloud_simple_inited = .false.
    99                                ! ե饰.
   100                                ! Initialization flag
   101  
   102    character(*), parameter:: module_name = 'cloud_simple'
   103                                ! ⥸塼̾.
   104                                ! Module name
   105    character(*), parameter:: version = &
   106      & '$Name: dcpam5-20120921 $' // &
   107      & '$Id: cloud_simple.f90,v 1.1 2012-09-08 15:16:39 yot Exp $'
   108                                ! ⥸塼ΥС
   109                                ! Module version
   110  
   111    !--------------------------------------------------------------------------------------
   112  
   113  contains
   114  
   115    !--------------------------------------------------------------------------------------
   116  
   117    subroutine CloudSimple(                             &
   118      & xyr_Press, xyz_Temp,                            & ! (in)
   119      & xyz_DQH2OLiqDtCum, xyz_DQH2OLiqDtLSC,           & ! (in)
   120      & xyz_QH2OLiq, xyz_DTempDtCond,                   & ! (inout)
   121      & xy_RainCum, xy_SnowCum, xy_RainLsc, xy_SnowLsc  & ! (out)
   122      & )
   123  
   124      ! USE statements
   125      !
   126  
   127      ! 
   128      ! Time control
   129      !
   130      use timeset, only: &
   131        & DelTime            ! $ \Delta t $ [s]
   132  
   133      ! طϥ롼
   134      ! Cloud-related routines
   135      !
   136      use cloud_utils, only : CloudUtilsCalcPRCPKeyLLTemp3D
   137  
   138  
   139      real(DP), intent(in   ) :: xyr_Press        ( 0:imax-1, 1:jmax, 0:kmax )
   140      real(DP), intent(in   ) :: xyz_Temp         ( 0:imax-1, 1:jmax, 1:kmax )
   141      real(DP), intent(in   ) :: xyz_DQH2OLiqDtCum( 0:imax-1, 1:jmax, 1:kmax )
   142      real(DP), intent(in   ) :: xyz_DQH2OLiqDtLSC( 0:imax-1, 1:jmax, 1:kmax )
   143      real(DP), intent(inout) :: xyz_QH2OLiq      ( 0:imax-1, 1:jmax, 1:kmax )
   144      real(DP), intent(inout) :: xyz_DTempDtCond  ( 0:imax-1, 1:jmax, 1:kmax )
   145      real(DP), intent(out  ) :: xy_RainCum       ( 0:imax-1, 1:jmax )
   146      real(DP), intent(out  ) :: xy_SnowCum       ( 0:imax-1, 1:jmax )
   147      real(DP), intent(out  ) :: xy_RainLsc       ( 0:imax-1, 1:jmax )
   148      real(DP), intent(out  ) :: xy_SnowLsc       ( 0:imax-1, 1:jmax )
   149  
   150  
   151      real(DP) :: xyz_QH2OLiqB( 0:imax-1, 1:jmax, 1:kmax )
   152      real(DP) :: xyz_DQRainDt( 0:imax-1, 1:jmax, 1:kmax )
   153  
   154  !!$    real(DP) :: xyz_DTempDtPrcpPCCum( 0:imax-1, 1:jmax, 1:kmax )
   155  !!$    real(DP) :: xyz_DTempDtPrcpPCLsc( 0:imax-1, 1:jmax, 1:kmax )
   156  
   157      ! ¹ʸ ; Executable statement
   158      !
   159  
   160      ! ǧ
   161      ! Initialization check
   162      !
   163      if ( .not. cloud_simple_inited ) then
   164        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   165      end if
   166  
   167  
   168      ! Cloud optical depth
   169      !
   170  
   171      ! Numerical solution
   172  
   173  !!$      xyz_DQCloudWaterDt = xyz_DQCloudWaterDt &
   174  !!$        & - xyz_QCloudWater / ( CloudLifeTime + 1.0d-100 )
   175  
   176  
   177  !!$      ( X_{t+1} - X_{t-1} ) / ( 2 \Delta t ) = Q - X_{t+1} / \tau
   178  !!$
   179  !!$      X_{t+1} / ( 2 \Delta t )  + X_{t+1} / \tau = X_{t-1} / ( 2 \Delta t ) + Q
   180  !!$      ( 1 / ( 2 \Delta t )  + 1 / \tau ) X_{t+1} = X_{t-1} / ( 2 \Delta t ) + Q
   181  !!$      X_{t+1} = ( X_{t-1} / ( 2 \Delta t ) + Q ) / ( 1 / ( 2 \Delta t )  + 1 / \tau )
   182  
   183      xyz_QH2OLiq =                                                           &
     .        D1 = 1.D0/(2.00000000000000e+000*deltime)                         
     .        D2 = 1.D0/(1.00000000000000e+000/(2.00000000000000e+000*deltime)  
     .       1    + 1.00000000000000e+000/(cloudlifetime + 1.00000000000000e-100
     .       2   ))                                                             
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t170 = 1, kmax*jmax*imax                                       
     .           xyz_qh2oliq(t170-1,1,1) = (xyz_qh2oliq(t170-1,1,1)*D1+         
     .       1      xyz_dqh2oliqdtcum(t170-1,1,1)+xyz_dqh2oliqdtlsc(t170-1,1,1))
     .       2      *D2                                                         
     .        end do                                                            
   184        &   (                                                                 &
   185        &       xyz_QH2OLiq / ( 2.0_DP * DelTime )                            &
   186        &     + xyz_DQH2OLiqDtCum + xyz_DQH2OLiqDtLSC                         &
   187        &   )                                                                 &
   188        & / ( 1.0_DP / ( 2.0_DP * DelTime ) + 1.0_DP / ( CloudLifeTime + 1.0d-100 ) )
   189  
   190      call CloudUtilsCalcPRCPKeyLLTemp3D(          &
   191        & xyr_Press, xyz_Temp, xyz_DQH2OLiqDtCum,  &  ! (in )
   192        & xy_RainCum, xy_SnowCum                   &  ! (out)
   193        & )
   194      call CloudUtilsCalcPRCPKeyLLTemp3D(          &
   195        & xyr_Press, xyz_Temp, xyz_DQH2OLiqDtLsc,  &  ! (in )
   196        & xy_RainLsc, xy_SnowLsc                   &  ! (out)
   197        & )
   198  
   199  
   200  !!$    ! Analytical solution
   201  !!$
   202  !!$    ! save cloud water before adjustment
   203  !!$    xyz_QH2OLiqB = xyz_QH2OLiq
   204  !!$
   205  !!$    xyz_QH2OLiq =                                                                 &
   206  !!$      &   xyz_QH2OLiq * exp( - 2.0_DP * DelTime / ( CloudLifeTime + 1.0d-100 ) )  &
   207  !!$      & + ( xyz_DQH2OLiqDtCum + xyz_DQH2OLiqDtLSC ) * CloudLifeTime               &
   208  !!$      &   * ( 1.0_DP - exp( - 2.0_DP * DelTime / ( CloudLifeTime + 1.0d-100 ) ) )
   209  !!$
   210  !!$    xyz_DQRainDt =                                                     &
   211  !!$      &   xyz_QH2OLiqB                                                 &
   212  !!$      & + ( xyz_DQH2OLiqDtCum + xyz_DQH2OLiqDtLSC ) * 2.0_DP * DelTime &
   213  !!$      & - xyz_QH2OLiq
   214  !!$    xyz_DQRainDt = xyz_DQRainDt / ( 2.0_DP * DelTime )
   215  !!$
   216  !!$    call CloudUtilsCalcPRCPKeyLLTemp(      &
   217  !!$      & xyr_Press, xyz_Temp, xyz_DQRainDt, &  ! (in )
   218  !!$      & xy_RainCum, xy_SnowCum             &  ! (out)
   219  !!$      & )
   220  !!$    xy_RainLsc = 0.0_DP
   221  !!$    xy_SnowLsc = 0.0_DP
   222  
   223  
   224  !!$        call CloudSimpleCalcPRCPWithPC(                &
   225  !!$          & xyr_Press, xyz_TempA, xyz_DQH2OLiqDtCum,   & ! (in )
   226  !!$          & xy_RainCumulus, xy_SnowCumulus,            & ! (out)
   227  !!$          & xyz_DTempDtPrcpPCCum                       & ! (out)
   228  !!$          & )
   229  !!$        call CloudSimpleCalcPRCPWithPC(                &
   230  !!$          & xyr_Press, xyz_TempA, xyz_DQH2OLiqDtLsc,   & ! (in )
   231  !!$          & xy_RainLsc, xy_SnowLsc,                    & ! (out)
   232  !!$          & xyz_DTempDtPrcpPCLsc                       & ! (out)
   233  !!$          & )
   234  !!$        xyz_TempA = xyz_TempA                                 &
   235  !!$          & + ( xyz_DTempDtPrcpPCCum + xyz_DTempDtPrcpPCLsc ) &
   236  !!$          &     * 2.0_DP * DelTime
   237  
   238  !!$        xyz_DTempDtCond = xyz_DTempDtCond                  &
   239  !!$          & + xyz_DTempDtPrcpPCCum + xyz_DTempDtPrcpPCLsc
   240  
   241  
   242    end subroutine CloudSimple
   243  
   244    !--------------------------------------------------------------------------------------
   245  
   246    subroutine CloudSimpleCalcCloudCover(  &
   247      & xyz_Press, xyz_Temp, xyz_QH2OTot,  & ! (in )
   248      & xyz_CloudCover                     & ! (out)
   249      & )
   250  
   251      ! USE statements
   252      !
   253  
   254      ! ˰漾λ
   255      ! Evaluate saturation specific humidity
   256      !
   257      use saturate, only: xyz_CalcQVapSat
   258  
   259      real(DP), intent(in ) :: xyz_Press     ( 0:imax-1, 1:jmax, 1:kmax )
   260      real(DP), intent(in ) :: xyz_Temp      ( 0:imax-1, 1:jmax, 1:kmax )
   261      real(DP), intent(in ) :: xyz_QH2OTot   ( 0:imax-1, 1:jmax, 1:kmax )
   262      real(DP), intent(out) :: xyz_CloudCover( 0:imax-1, 1:jmax, 1:kmax )
   263  
   264  
   265      real(DP) :: xyz_RH(0:imax-1, 1:jmax, 1:kmax)
   266  
   267  
   268      ! ¹ʸ ; Executable statement
   269      !
   270  
   271      ! ǧ
   272      ! Initialization check
   273      !
   274      if ( .not. cloud_simple_inited ) then
   275        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   276      end if
   277  
   278  
   279      select case ( IDCloudCoverMethod )
   280      case ( IDCloudCoverMethodConst )
   281  
   282        xyz_CloudCover = CloudCover
     .        if (1 + jmax - min0(1,jmax) .gt. 0) then                          
     .           J1 = and(1 + jmax - min0(1,jmax),3)                            
     .  !CDIR    NODEP                                                          
     .           do t159 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t161 = 1, imax + 1 - min0(1,imax)                        
     .                 xyz_cloudcover(t161-1,t159,t157+1) = cloudcover          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t159 = J1 + 1, 1 + jmax - min0(1,jmax), 4                   
     .  !CDIR       NODEP                                                       
     .              do t161 = 1, imax + 1 - min0(1,imax)                        
     .                 xyz_cloudcover(t161-1,t159,t157+1) = cloudcover          
     .                 xyz_cloudcover(t161-1,t159+1,t157+1) = cloudcover        
     .                 xyz_cloudcover(t161-1,t159+2,t157+1) = cloudcover        
     .                 xyz_cloudcover(t161-1,t159+3,t157+1) = cloudcover        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   283  
   284      case ( IDCloudCoverMethodRH )
   285  
   286        ! see Sundqvist et al. (1989), Del Genio et al. (1996)
   287        xyz_RH = xyz_QH2OTot / xyz_CalcQVapSat( xyz_Temp, xyz_Press )
     .        D1 = 1.D0/(1.00000000000000e+000 - rhcrtl)                        
     .  !CDIR NODEP                                                             
     .        do t122 = 1, imax                                                 
     .           xyz_rh1 = xyz_qh2otot(t122-1,t120+1,t118+1)/%0000fa(t122-1,t120
     .       1      +1,t118+1)                                                  
     .           xyz_rh1 = min(xyz_rh1,1.00000000000000e+000)                   
     .           xyz_cloudcover1 = 1.00000000000000e+000 - dsqrt((              
     .       1      1.00000000000000e+000 - xyz_rh1)*D1)                        
     .           xyz_cloudcover1 = max(xyz_cloudcover1,0.0000000000000000e+000) 
     .           xyz_cloudcover(t122-1,t120+1,t118+1) = min(xyz_cloudcover1,    
     .       1      1.00000000000000e+000)                                      
     .        end do                                                            
   288        xyz_RH = min( xyz_RH, 1.0_DP )
   289  
   290        xyz_CloudCover = 1.0d0 - sqrt( ( 1.0d0 - xyz_RH ) / ( 1.0d0 - RHCrtl ) )
   291  
   292        xyz_CloudCover = max( xyz_CloudCover, 0.0_DP )
   293        xyz_CloudCover = min( xyz_CloudCover, 1.0_DP )
   294  
   295      end select
   296  
   297  
   298    end subroutine CloudSimpleCalcCloudCover
   299  
   300    !--------------------------------------------------------------------------------------
   301  
   302    subroutine CloudSimpleDivideWatAndIce(  &
   303      & xyz_Temp,                           & ! (in )
   304      & xyz_QH2OWatAndIce,                  & ! (in )
   305      & xyz_QH2OWat, xyz_QH2OIce            & ! (out)
   306      & )
   307  
   308      ! USE statements
   309      !
   310  
   311      ! طϥ롼
   312      ! Cloud-related routines
   313      !
   314      use cloud_utils, only : CloudUtilsWatFraction
   315  
   316  
   317      real(DP), intent(in ) :: xyz_Temp         (0:imax-1, 1:jmax, 1:kmax)
   318      real(DP), intent(in ) :: xyz_QH2OWatAndIce(0:imax-1, 1:jmax, 1:kmax)
   319      real(DP), intent(out) :: xyz_QH2OWat      (0:imax-1, 1:jmax, 1:kmax)
   320      real(DP), intent(out) :: xyz_QH2OIce      (0:imax-1, 1:jmax, 1:kmax)
   321  
   322  
   323      real(DP) :: xyz_WatFrac(0:imax-1, 1:jmax, 1:kmax)
   324  
   325      ! ¹ʸ ; Executable statement
   326      !
   327  
   328      ! ǧ
   329      ! Initialization check
   330      !
   331      if ( .not. cloud_simple_inited ) then
   332        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   333      end if
   334  
   335  
   336      call CloudUtilsWatFraction(      &
   337        & xyz_Temp,                    & ! (in )
   338        & xyz_WatFrac                  & ! (out)
   339        & )
   340  
   341      xyz_QH2OWat = xyz_QH2OWatAndIce * xyz_WatFrac
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t87 = 1, J1                                                 
     .  !CDIR       NODEP                                                       
     .              do t89 = 1, imax                                            
     .                 xyz_qh2owat(t89-1,t87,t85+1) = xyz_qh2owatandice(t89-1,  
     .       1            t87,t85+1)*xyz_watfrac(t89-1,t87,t85+1)               
     .                 xyz_qh2oice(t89-1,t87,t85+1) = xyz_qh2owatandice(t89-1,  
     .       1            t87,t85+1)*(1.00000000000000e+000 - xyz_watfrac(t89-1,
     .       2            t87,t85+1))                                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t87 = J1 + 1, jmax, 2                                       
     .  !CDIR       NODEP                                                       
     .              do t89 = 1, imax                                            
     .                 xyz_qh2owat(t89-1,t87,t85+1) = xyz_qh2owatandice(t89-1,  
     .       1            t87,t85+1)*xyz_watfrac(t89-1,t87,t85+1)               
     .                 xyz_qh2owat(t89-1,t87+1,t85+1) = xyz_qh2owatandice(t89-1,
     .       1            t87+1,t85+1)*xyz_watfrac(t89-1,t87+1,t85+1)           
     .                 xyz_qh2oice(t89-1,t87,t85+1) = xyz_qh2owatandice(t89-1,  
     .       1            t87,t85+1)*(1.00000000000000e+000 - xyz_watfrac(t89-1,
     .       2            t87,t85+1))                                           
     .                 xyz_qh2oice(t89-1,t87+1,t85+1) = xyz_qh2owatandice(t89-1,
     .       1            t87+1,t85+1)*(1.00000000000000e+000 - xyz_watfrac(t89-
     .       2            1,t87+1,t85+1))                                       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   342      xyz_QH2OIce = xyz_QH2OWatAndIce * ( 1.0_DP - xyz_WatFrac )
   343  
   344  
   345    end subroutine CloudSimpleDivideWatAndIce
   346  
   347    !--------------------------------------------------------------------------------------
   348  
   349    subroutine CloudSimpleCalcPRCPWithPC(    &
   350      & xyr_Press, xyz_Temp, xyz_DQH2OLiqDt, & ! (in )
   351      & xy_SurfRainFlux, xy_SurfSnowFlux,    & ! (out)
   352      & xyz_DTempDt                          & ! (out)
   353      & )
   354  
   355      ! 
   356      ! Time control
   357      !
   358      use timeset, only: &
   359        & DelTime            ! $ \Delta t $ [s]
   360  
   361      ! ʪ
   362      ! Physical constants settings
   363      !
   364      use constants, only:  &
   365        & CpDry,            &
   366                                ! $ C_p $ [J kg-1 K-1].
   367                                ! 絤갵Ǯ.
   368                                ! Specific heat of air at constant pressure
   369        & Grav,             &
   370                                ! $ g $ [m s-2].
   371                                ! ϲ®.
   372                                ! Gravitational acceleration
   373        & LatentHeatFusion
   374                                ! $ L $ [J kg-1] .
   375                                ! ͻǮ.
   376                                ! Latent heat of fusion
   377  
   378      ! طϥ롼
   379      ! Cloud-related routines
   380      !
   381      use cloud_utils, only : CloudUtilsWatFraction
   382  
   383  
   384      real(DP), intent(in ) :: xyr_Press      ( 0:imax-1, 1:jmax, 0:kmax )
   385      real(DP), intent(in ) :: xyz_Temp       ( 0:imax-1, 1:jmax, 1:kmax )
   386      real(DP), intent(in ) :: xyz_DQH2OLiqDt ( 0:imax-1, 1:jmax, 1:kmax )
   387      real(DP), intent(out) :: xy_SurfRainFlux( 0:imax-1, 1:jmax )
   388      real(DP), intent(out) :: xy_SurfSnowFlux( 0:imax-1, 1:jmax )
   389      real(DP), intent(out) :: xyz_DTempDt    ( 0:imax-1, 1:jmax, 1:kmax )
   390  
   391  
   392      ! ѿ
   393      ! Work variables
   394      !
   395      real(DP) :: xyz_WatFrac( 0:imax-1, 1:jmax, 1:kmax )
   396      real(DP) :: xy_Rain    ( 0:imax-1, 1:jmax )
   397      real(DP) :: xy_Snow    ( 0:imax-1, 1:jmax )
   398      real(DP) :: xy_Tot     ( 0:imax-1, 1:jmax )
   399  
   400      integer:: k
   401  
   402  
   403      ! ǧ
   404      ! Initialization check
   405      !
   406      if ( .not. cloud_simple_inited ) then
   407        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   408      end if
   409  
   410  
   411      call CloudUtilsWatFraction(   &
   412        & xyz_Temp,                 & ! (in )
   413        & xyz_WatFrac               & ! (out)
   414        & )
   415  
   416  
   417      xy_SurfRainFlux = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t189 = 1, jmax*imax                                            
     .           xy_surfrainflux(t189-1,1) = 0.0000000000000000e+000            
     .           xy_surfsnowflux(t189-1,1) = 0.0000000000000000e+000            
     .        end do                                                            
   418      xy_SurfSnowFlux = 0.0_DP
   419  
   420      do k = kmax, 1, -1
   421        xy_Rain = xy_SurfRainFlux   &
     .        D1 = 1.D0/grav                                                    
     .        D2 = 1.D0/grav                                                    
     .        D3 = latentheatfusion/cpdry                                       
     .        D4 = D3/(2.00000000000000e+000*deltime)                           
     .  !CDIR NODEP                                                             
     .        do t199 = 1, imax                                                 
     .           xy_rain1 = xy_surfrainflux(t199-1,t197+1) + xyz_dqh2oliqdt(t199
     .       1      -1,t197+1,k)*(xyr_press(t199-1,t197+1,k-1)-xyr_press(t199-1,
     .       2      t197+1,k))*D1                                               
     .           xy_snow1 = xy_surfsnowflux(t199-1,t197+1)                      
     .           xy_tot1 = xy_rain1 + xy_snow1                                  
     .           xyz_dtempdt(t199-1,t197+1,k) = (xy_rain1 - (xyz_watfrac(t199-1,
     .       1      t197+1,k)*xy_tot1))*2.00000000000000e+000*deltime/((        
     .       2      xyr_press(t199-1,t197+1,k-1)-xyr_press(t199-1,t197+1,k))*D2)
     .       3      *D4                                                         
     .           xy_surfrainflux(t199-1,t197+1) = (xyz_watfrac(t199-1,t197+1,k)*
     .       1      xy_tot1)                                                    
     .           xy_surfsnowflux(t199-1,t197+1) = (1.00000000000000e+000 -      
     .       1      xyz_watfrac(t199-1,t197+1,k))*xy_tot1                       
     .        end do                                                            
   422          & + xyz_DQH2OLiqDt(:,:,k) &
   423          &     * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   424        xy_Snow = xy_SurfSnowFlux
   425        xy_Tot  = xy_Rain + xy_Snow
   426  
   427        xyz_DTempDt(:,:,k) =                                                &
   428          & + ( xy_Rain - xyz_WatFrac(:,:,k) * xy_Tot ) * 2.0_DP * DelTime  &
   429          &     / ( ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav )      &
   430          &     * LatentHeatFusion / CpDry                                  &
   431          & / ( 2.0_DP * DelTime )
   432  
   433        xy_SurfRainFlux = xyz_WatFrac(:,:,k)              * xy_Tot
   434        xy_SurfSnowFlux = ( 1.0_DP - xyz_WatFrac(:,:,k) ) * xy_Tot
   435      end do
   436  
   437  
   438    end subroutine CloudSimpleCalcPRCPWithPC
   439  
   440    !--------------------------------------------------------------------------------------
   441  
   442    subroutine CloudSimpleInit( &
   443      & ArgFlagSnow             &
   444      & )
   445  
   446      ! ե
   447      ! File I/O support
   448      !
   449      use dc_iounit, only: FileOpen
   450  
   451      ! NAMELIST եϤ˴ؤ桼ƥƥ
   452      ! Utilities for NAMELIST file input
   453      !
   454      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   455  
   456      ! ҥȥǡ
   457      ! History data output
   458      !
   459      use gtool_historyauto, only: HistoryAutoAddVariable
   460  
   461      ! 絬϶ŷ (ήŷ)
   462      ! Large scale condensation (non-convective condensation)
   463      !
   464      use lscond, only : LScaleCondInit
   465  
   466  
   467      ! ʸ ; Declaration statements
   468      !
   469  
   470      logical, intent(in) :: ArgFlagSnow
   471  
   472  
   473      character(STRING) :: CloudCoverMethod
   474  
   475      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   476                                ! Unit number for NAMELIST file open
   477      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   478                                ! IOSTAT of NAMELIST read
   479  
   480      ! NAMELIST ѿ
   481      ! NAMELIST group name
   482      !
   483      namelist /cloud_simple_nml/ &
   484        & CloudLifeTime,       &
   485        & CloudCoverMethod,    &
   486        & RHCrtl,              &
   487        & CloudCover
   488            !
   489            ! ǥեͤˤĤƤϽ³ "cloud_simple#CloudSimpleInit"
   490            ! Υɤ򻲾ȤΤ.
   491            !
   492            ! Refer to source codes in the initialization procedure
   493            ! "cloud_simple#CloudSimpleInit" for the default values.
   494            !
   495  
   496      ! ¹ʸ ; Executable statement
   497      !
   498  
   499      if ( cloud_simple_inited ) return
   500  
   501  
   502      FlagSnow = ArgFlagSnow
   503  
   504  
   505      ! ǥեͤ
   506      ! Default values settings
   507      !
   508      CloudLifeTime       = 3600.0_DP
   509  
   510      CloudCoverMethod    = 'Const'
   511  !!$    CloudCoverMethod    = 'RH'
   512  
   513      RHCrtl              = 0.8_DP
   514  
   515      CloudCover          = 1.0_DP
   516  
   517  
   518      ! NAMELIST ɤ߹
   519      ! NAMELIST is input
   520      !
   521      if ( trim(namelist_filename) /= '' ) then
   522        call FileOpen( unit_nml, &          ! (out)
   523          & namelist_filename, mode = 'r' ) ! (in)
   524  
   525        rewind( unit_nml )
   526        read( unit_nml,                     & ! (in)
   527          & nml = cloud_simple_nml,         & ! (out)
   528          & iostat = iostat_nml )             ! (out)
   529        close( unit_nml )
   530  
   531        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   532      end if
   533  
   534  
   535      select case ( CloudCoverMethod )
   536      case ( 'Const' )
   537        IDCloudCoverMethod = IDCloudCoverMethodConst
   538      case ( 'RH' )
   539        IDCloudCoverMethod = IDCloudCoverMethodRH
   540      case default
   541        call MessageNotify( 'E', module_name,         &
   542          & 'CloudCoverMethod=<%c> is not supported.', &
   543          & c1 = trim(CloudCoverMethod) )
   544      end select
   545  
   546  
   547      ! Initialization of modules used in this module
   548      !
   549  
   550      ! 絬϶ŷ (ήŷ) (Manabe, 1965)
   551      ! Large scale condensation (non-convective condensation) (Le Treut and Li, 1991)
   552      !
   553      call LScaleCondInit
   554  
   555  
   556      ! ҥȥǡϤΤΤؤѿϿ
   557      ! Register of variables for history data output
   558      !
   559  !!$    call HistoryAutoAddVariable( 'EffCloudCover', &
   560  !!$      & (/ 'lon ', 'lat ', 'time' /), &
   561  !!$      & 'effective cloud cover', '1' )
   562  
   563  
   564  
   565      !  ; Print
   566      !
   567      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   568      call MessageNotify( 'M', module_name, 'CloudLifeTime       = %f', d = (/ CloudLifeTime /) )
   569      call MessageNotify( 'M', module_name, 'CloudCoverMethod    = %c', c1 = trim(CloudCoverMethod) )
   570      call MessageNotify( 'M', module_name, 'RHCrtl              = %f', d = (/ RHCrtl /) )
   571      call MessageNotify( 'M', module_name, 'CloudCover          = %f', d = (/ CloudCover /) )
   572      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   573  
   574  
   575      cloud_simple_inited = .true.
   576  
   577    end subroutine CloudSimpleInit
   578  
   579    !--------------------------------------------------------------------------------------
   580  
   581  end module cloud_simple
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:47 2012
FILE NAME: cloud_simple.f90
PROGRAM NAME: cloud_simple
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ñǥ
     2:            !
     3:            != Simple cloud model
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: cloud_simple.f90,v 1.1 2012-09-08 15:16:39 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module cloud_simple
    13:              !
    14:              != ñǥ
    15:              !
    16:              != Simple cloud model
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ñǥˤη׻.
    21:              !
    22:              ! In this module, the amount of cloud is calculated by use of a simple
    23:              ! cloud model.
    24:              !
    25:              !== Procedures List
    26:              !
    27:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    28:            !!$  ! ------------            :: ------------
    29:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    30:              !
    31:              !== NAMELIST
    32:              !
    33:              ! NAMELIST#cloud_simple_nml
    34:              !
    35:            
    36:              ! ⥸塼 ; USE statements
    37:            
    38:              !
    39:              ! Kind type parameter
    40:              !
    41:              use dc_types, only: DP, &      ! Double precision.
    42:                &                 STRING, &  ! Strings.
    43:                &                 TOKEN      ! Keywords.
    44:            
    45:              ! å
    46:              ! Message output
    47:              !
    48:              use dc_message, only: MessageNotify
    49:            
    50:              ! ʻ
    51:              ! Grid points settings
    52:              !
    53:              use gridset, only: imax, & ! ٳʻ.
    54:                                         ! Number of grid points in longitude
    55:                &                jmax, & ! ٳʻ.
    56:                                         ! Number of grid points in latitude
    57:                &                kmax    ! ľؿ.
    58:                                         ! Number of vertical level
    59:            
    60:              implicit none
    61:            
    62:              private
    63:            
    64:            
    65:              ! ³
    66:              ! Public procedure
    67:              !
    68:              public :: CloudSimple
    69:              public :: CloudSimpleCalcCloudCover
    70:              public :: CloudSimpleInit
    71:            
    72:              public :: CloudSimpleDivideWatAndIce
    73:              public :: CloudSimpleCalcPRCPWithPC
    74:            
    75:            
    76:              ! ѿ
    77:              ! Public variables
    78:              !
    79:            
    80:            
    81:              ! ѿ
    82:              ! Private variables
    83:              !
    84:              logical , save        :: FlagSnow
    85:                                       ! A flag for snow
    86:            
    87:              integer , save        :: IDCloudCoverMethod
    88:              integer , parameter   :: IDCloudCoverMethodConst    = 1
    89:              integer , parameter   :: IDCloudCoverMethodRH       = 2
    90:            
    91:              real(DP), save        :: CloudLifeTime
    92:            
    93:              real(DP), save        :: CloudCover
    94:            
    95:              real(DP), save        :: RHCrtl
    96:            
    97:            
    98:              logical, save :: cloud_simple_inited = .false.
    99:                                          ! ե饰.
   100:                                          ! Initialization flag
   101:            
   102:              character(*), parameter:: module_name = 'cloud_simple'
   103:                                          ! ⥸塼̾.
   104:                                          ! Module name
   105:              character(*), parameter:: version = &
   106:                & '$Name: dcpam5-20120921 $' // &
   107:                & '$Id: cloud_simple.f90,v 1.1 2012-09-08 15:16:39 yot Exp $'
   108:                                          ! ⥸塼ΥС
   109:                                          ! Module version
   110:            
   111:              !--------------------------------------------------------------------------------------
   112:            
   113:            contains
   114:            
   115:              !--------------------------------------------------------------------------------------
   116:            
   117:              subroutine CloudSimple(                             &
   118:                & xyr_Press, xyz_Temp,                            & ! (in)
   119:                & xyz_DQH2OLiqDtCum, xyz_DQH2OLiqDtLSC,           & ! (in)
   120:                & xyz_QH2OLiq, xyz_DTempDtCond,                   & ! (inout)
   121:                & xy_RainCum, xy_SnowCum, xy_RainLsc, xy_SnowLsc  & ! (out)
   122:                & )
   123:            
   124:                ! USE statements
   125:                !
   126:            
   127:                ! 
   128:                ! Time control
   129:                !
   130:                use timeset, only: &
   131:                  & DelTime            ! $ \Delta t $ [s]
   132:            
   133:                ! طϥ롼
   134:                ! Cloud-related routines
   135:                !
   136:                use cloud_utils, only : CloudUtilsCalcPRCPKeyLLTemp3D
   137:            
   138:            
   139:                real(DP), intent(in   ) :: xyr_Press        ( 0:imax-1, 1:jmax, 0:kmax )
   140:                real(DP), intent(in   ) :: xyz_Temp         ( 0:imax-1, 1:jmax, 1:kmax )
   141:                real(DP), intent(in   ) :: xyz_DQH2OLiqDtCum( 0:imax-1, 1:jmax, 1:kmax )
   142:                real(DP), intent(in   ) :: xyz_DQH2OLiqDtLSC( 0:imax-1, 1:jmax, 1:kmax )
   143:                real(DP), intent(inout) :: xyz_QH2OLiq      ( 0:imax-1, 1:jmax, 1:kmax )
   144:                real(DP), intent(inout) :: xyz_DTempDtCond  ( 0:imax-1, 1:jmax, 1:kmax )
   145:                real(DP), intent(out  ) :: xy_RainCum       ( 0:imax-1, 1:jmax )
   146:                real(DP), intent(out  ) :: xy_SnowCum       ( 0:imax-1, 1:jmax )
   147:                real(DP), intent(out  ) :: xy_RainLsc       ( 0:imax-1, 1:jmax )
   148:                real(DP), intent(out  ) :: xy_SnowLsc       ( 0:imax-1, 1:jmax )
   149:            
   150:            
   151:                real(DP) :: xyz_QH2OLiqB( 0:imax-1, 1:jmax, 1:kmax )
   152:                real(DP) :: xyz_DQRainDt( 0:imax-1, 1:jmax, 1:kmax )
   153:            
   154:            !!$    real(DP) :: xyz_DTempDtPrcpPCCum( 0:imax-1, 1:jmax, 1:kmax )
   155:            !!$    real(DP) :: xyz_DTempDtPrcpPCLsc( 0:imax-1, 1:jmax, 1:kmax )
   156:            
   157:                ! ¹ʸ ; Executable statement
   158:                !
   159:            
   160:                ! ǧ
   161:                ! Initialization check
   162:                !
   163:                if ( .not. cloud_simple_inited ) then
   164:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   165:                end if
   166:            
   167:            
   168:                ! Cloud optical depth
   169:                !
   170:            
   171:                ! Numerical solution
   172:            
   173:            !!$      xyz_DQCloudWaterDt = xyz_DQCloudWaterDt &
   174:            !!$        & - xyz_QCloudWater / ( CloudLifeTime + 1.0d-100 )
   175:            
   176:            
   177:            !!$      ( X_{t+1} - X_{t-1} ) / ( 2 \Delta t ) = Q - X_{t+1} / \tau
   178:            !!$
   179:            !!$      X_{t+1} / ( 2 \Delta t )  + X_{t+1} / \tau = X_{t-1} / ( 2 \Delta t ) + Q
   180:            !!$      ( 1 / ( 2 \Delta t )  + 1 / \tau ) X_{t+1} = X_{t-1} / ( 2 \Delta t ) + Q
   181:            !!$      X_{t+1} = ( X_{t-1} / ( 2 \Delta t ) + Q ) / ( 1 / ( 2 \Delta t )  + 1 / \tau ) 
   182:            
   183: W++====        xyz_QH2OLiq =                                                           &
   184:                  &   (                                                                 &
   185:                  &       xyz_QH2OLiq / ( 2.0_DP * DelTime )                            &
   186:                  &     + xyz_DQH2OLiqDtCum + xyz_DQH2OLiqDtLSC                         &
   187:                  &   )                                                                 &
   188:                  & / ( 1.0_DP / ( 2.0_DP * DelTime ) + 1.0_DP / ( CloudLifeTime + 1.0d-100 ) )
   189:            
   190:                call CloudUtilsCalcPRCPKeyLLTemp3D(          &
   191:                  & xyr_Press, xyz_Temp, xyz_DQH2OLiqDtCum,  &  ! (in )
   192:                  & xy_RainCum, xy_SnowCum                   &  ! (out)
   193:                  & )
   194:                call CloudUtilsCalcPRCPKeyLLTemp3D(          &
   195:                  & xyr_Press, xyz_Temp, xyz_DQH2OLiqDtLsc,  &  ! (in )
   196:                  & xy_RainLsc, xy_SnowLsc                   &  ! (out)
   197:                  & )
   198:            
   199:            
   200:            !!$    ! Analytical solution
   201:            !!$
   202:            !!$    ! save cloud water before adjustment
   203:            !!$    xyz_QH2OLiqB = xyz_QH2OLiq
   204:            !!$
   205:            !!$    xyz_QH2OLiq =                                                                 &
   206:            !!$      &   xyz_QH2OLiq * exp( - 2.0_DP * DelTime / ( CloudLifeTime + 1.0d-100 ) )  &
   207:            !!$      & + ( xyz_DQH2OLiqDtCum + xyz_DQH2OLiqDtLSC ) * CloudLifeTime               &
   208:            !!$      &   * ( 1.0_DP - exp( - 2.0_DP * DelTime / ( CloudLifeTime + 1.0d-100 ) ) )
   209:            !!$
   210:            !!$    xyz_DQRainDt =                                                     &
   211:            !!$      &   xyz_QH2OLiqB                                                 &
   212:            !!$      & + ( xyz_DQH2OLiqDtCum + xyz_DQH2OLiqDtLSC ) * 2.0_DP * DelTime &
   213:            !!$      & - xyz_QH2OLiq
   214:            !!$    xyz_DQRainDt = xyz_DQRainDt / ( 2.0_DP * DelTime )
   215:            !!$
   216:            !!$    call CloudUtilsCalcPRCPKeyLLTemp(      &
   217:            !!$      & xyr_Press, xyz_Temp, xyz_DQRainDt, &  ! (in )
   218:            !!$      & xy_RainCum, xy_SnowCum             &  ! (out)
   219:            !!$      & )
   220:            !!$    xy_RainLsc = 0.0_DP
   221:            !!$    xy_SnowLsc = 0.0_DP
   222:            
   223:            
   224:            !!$        call CloudSimpleCalcPRCPWithPC(                &
   225:            !!$          & xyr_Press, xyz_TempA, xyz_DQH2OLiqDtCum,   & ! (in )
   226:            !!$          & xy_RainCumulus, xy_SnowCumulus,            & ! (out)
   227:            !!$          & xyz_DTempDtPrcpPCCum                       & ! (out)
   228:            !!$          & )
   229:            !!$        call CloudSimpleCalcPRCPWithPC(                &
   230:            !!$          & xyr_Press, xyz_TempA, xyz_DQH2OLiqDtLsc,   & ! (in )
   231:            !!$          & xy_RainLsc, xy_SnowLsc,                    & ! (out)
   232:            !!$          & xyz_DTempDtPrcpPCLsc                       & ! (out)
   233:            !!$          & )
   234:            !!$        xyz_TempA = xyz_TempA                                 &
   235:            !!$          & + ( xyz_DTempDtPrcpPCCum + xyz_DTempDtPrcpPCLsc ) &
   236:            !!$          &     * 2.0_DP * DelTime
   237:            
   238:            !!$        xyz_DTempDtCond = xyz_DTempDtCond                  &
   239:            !!$          & + xyz_DTempDtPrcpPCCum + xyz_DTempDtPrcpPCLsc
   240:            
   241:            
   242:              end subroutine CloudSimple
   243:            
   244:              !--------------------------------------------------------------------------------------
   245:            
   246:              subroutine CloudSimpleCalcCloudCover(  &
   247:                & xyz_Press, xyz_Temp, xyz_QH2OTot,  & ! (in )
   248:                & xyz_CloudCover                     & ! (out)
   249:                & )
   250:            
   251:                ! USE statements
   252:                !
   253:            
   254:                ! ˰漾λ
   255:                ! Evaluate saturation specific humidity
   256:                !
   257:                use saturate, only: xyz_CalcQVapSat
   258:            
   259:                real(DP), intent(in ) :: xyz_Press     ( 0:imax-1, 1:jmax, 1:kmax )
   260:                real(DP), intent(in ) :: xyz_Temp      ( 0:imax-1, 1:jmax, 1:kmax )
   261:                real(DP), intent(in ) :: xyz_QH2OTot   ( 0:imax-1, 1:jmax, 1:kmax )
   262:                real(DP), intent(out) :: xyz_CloudCover( 0:imax-1, 1:jmax, 1:kmax )
   263:            
   264:            
   265:                real(DP) :: xyz_RH(0:imax-1, 1:jmax, 1:kmax)
   266:            
   267:            
   268:                ! ¹ʸ ; Executable statement
   269:                !
   270:            
   271:                ! ǧ
   272:                ! Initialization check
   273:                !
   274:                if ( .not. cloud_simple_inited ) then
   275:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   276:                end if
   277:            
   278:            
   279:                select case ( IDCloudCoverMethod )
   280:                case ( IDCloudCoverMethodConst )
   281:            
   282: ++V====          xyz_CloudCover = CloudCover
   283:            
   284:                case ( IDCloudCoverMethodRH )
   285:            
   286:                  ! see Sundqvist et al. (1989), Del Genio et al. (1996)
   287: **V---->         xyz_RH = xyz_QH2OTot / xyz_CalcQVapSat( xyz_Temp, xyz_Press )
   288: |||              xyz_RH = min( xyz_RH, 1.0_DP )
   289: |||        
   290: |||              xyz_CloudCover = 1.0d0 - sqrt( ( 1.0d0 - xyz_RH ) / ( 1.0d0 - RHCrtl ) )
   291: |||        
   292: |||              xyz_CloudCover = max( xyz_CloudCover, 0.0_DP )
   293: **V----          xyz_CloudCover = min( xyz_CloudCover, 1.0_DP )
   294:            
   295:                end select
   296:            
   297:            
   298:              end subroutine CloudSimpleCalcCloudCover
   299:            
   300:              !--------------------------------------------------------------------------------------
   301:            
   302:              subroutine CloudSimpleDivideWatAndIce(  &
   303:                & xyz_Temp,                           & ! (in )
   304:                & xyz_QH2OWatAndIce,                  & ! (in )
   305:                & xyz_QH2OWat, xyz_QH2OIce            & ! (out)
   306:                & )
   307:            
   308:                ! USE statements
   309:                !
   310:            
   311:                ! طϥ롼
   312:                ! Cloud-related routines
   313:                !
   314:                use cloud_utils, only : CloudUtilsWatFraction
   315:            
   316:            
   317:                real(DP), intent(in ) :: xyz_Temp         (0:imax-1, 1:jmax, 1:kmax)
   318:                real(DP), intent(in ) :: xyz_QH2OWatAndIce(0:imax-1, 1:jmax, 1:kmax)
   319:                real(DP), intent(out) :: xyz_QH2OWat      (0:imax-1, 1:jmax, 1:kmax)
   320:                real(DP), intent(out) :: xyz_QH2OIce      (0:imax-1, 1:jmax, 1:kmax)
   321:            
   322:            
   323:                real(DP) :: xyz_WatFrac(0:imax-1, 1:jmax, 1:kmax)
   324:            
   325:                ! ¹ʸ ; Executable statement
   326:                !
   327:            
   328:                ! ǧ
   329:                ! Initialization check
   330:                !
   331:                if ( .not. cloud_simple_inited ) then
   332:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   333:                end if
   334:            
   335:            
   336:                call CloudUtilsWatFraction(      &
   337:                  & xyz_Temp,                    & ! (in )
   338:                  & xyz_WatFrac                  & ! (out)
   339:                  & )
   340:            
   341: **V---->       xyz_QH2OWat = xyz_QH2OWatAndIce * xyz_WatFrac
   342: **V----        xyz_QH2OIce = xyz_QH2OWatAndIce * ( 1.0_DP - xyz_WatFrac )
   343:            
   344:            
   345:              end subroutine CloudSimpleDivideWatAndIce
   346:            
   347:              !--------------------------------------------------------------------------------------
   348:            
   349:              subroutine CloudSimpleCalcPRCPWithPC(    &
   350:                & xyr_Press, xyz_Temp, xyz_DQH2OLiqDt, & ! (in )
   351:                & xy_SurfRainFlux, xy_SurfSnowFlux,    & ! (out)
   352:                & xyz_DTempDt                          & ! (out)
   353:                & )
   354:            
   355:                ! 
   356:                ! Time control
   357:                !
   358:                use timeset, only: &
   359:                  & DelTime            ! $ \Delta t $ [s]
   360:            
   361:                ! ʪ
   362:                ! Physical constants settings
   363:                !
   364:                use constants, only:  &
   365:                  & CpDry,            &
   366:                                          ! $ C_p $ [J kg-1 K-1].
   367:                                          ! 絤갵Ǯ.
   368:                                          ! Specific heat of air at constant pressure
   369:                  & Grav,             &
   370:                                          ! $ g $ [m s-2].
   371:                                          ! ϲ®.
   372:                                          ! Gravitational acceleration
   373:                  & LatentHeatFusion
   374:                                          ! $ L $ [J kg-1] .
   375:                                          ! ͻǮ.
   376:                                          ! Latent heat of fusion
   377:            
   378:                ! طϥ롼
   379:                ! Cloud-related routines
   380:                !
   381:                use cloud_utils, only : CloudUtilsWatFraction
   382:            
   383:            
   384:                real(DP), intent(in ) :: xyr_Press      ( 0:imax-1, 1:jmax, 0:kmax )
   385:                real(DP), intent(in ) :: xyz_Temp       ( 0:imax-1, 1:jmax, 1:kmax )
   386:                real(DP), intent(in ) :: xyz_DQH2OLiqDt ( 0:imax-1, 1:jmax, 1:kmax )
   387:                real(DP), intent(out) :: xy_SurfRainFlux( 0:imax-1, 1:jmax )
   388:                real(DP), intent(out) :: xy_SurfSnowFlux( 0:imax-1, 1:jmax )
   389:                real(DP), intent(out) :: xyz_DTempDt    ( 0:imax-1, 1:jmax, 1:kmax )
   390:            
   391:            
   392:                ! ѿ
   393:                ! Work variables
   394:                !
   395:                real(DP) :: xyz_WatFrac( 0:imax-1, 1:jmax, 1:kmax )
   396:                real(DP) :: xy_Rain    ( 0:imax-1, 1:jmax )
   397:                real(DP) :: xy_Snow    ( 0:imax-1, 1:jmax )
   398:                real(DP) :: xy_Tot     ( 0:imax-1, 1:jmax )
   399:            
   400:                integer:: k
   401:            
   402:            
   403:                ! ǧ
   404:                ! Initialization check
   405:                !
   406:                if ( .not. cloud_simple_inited ) then
   407:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   408:                end if
   409:            
   410:            
   411:                call CloudUtilsWatFraction(   &
   412:                  & xyz_Temp,                 & ! (in )
   413:                  & xyz_WatFrac               & ! (out)
   414:                  & )
   415:            
   416:            
   417: *W----->       xy_SurfRainFlux = 0.0_DP
   418: *W-----        xy_SurfSnowFlux = 0.0_DP
   419:            
   420: +------>       do k = kmax, 1, -1
   421: |*V---->         xy_Rain = xy_SurfRainFlux   &
   422: |||                & + xyz_DQH2OLiqDt(:,:,k) &
   423: |||                &     * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   424: |||              xy_Snow = xy_SurfSnowFlux
   425: |||              xy_Tot  = xy_Rain + xy_Snow
   426: |||        
   427: |||              xyz_DTempDt(:,:,k) =                                                &
   428: |||                & + ( xy_Rain - xyz_WatFrac(:,:,k) * xy_Tot ) * 2.0_DP * DelTime  &
   429: |||                &     / ( ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav )      &
   430: |||                &     * LatentHeatFusion / CpDry                                  &
   431: |||                & / ( 2.0_DP * DelTime )
   432: |||        
   433: |||              xy_SurfRainFlux = xyz_WatFrac(:,:,k)              * xy_Tot
   434: |*V----          xy_SurfSnowFlux = ( 1.0_DP - xyz_WatFrac(:,:,k) ) * xy_Tot
   435: +------        end do
   436:            
   437:            
   438:              end subroutine CloudSimpleCalcPRCPWithPC
   439:            
   440:              !--------------------------------------------------------------------------------------
   441:            
   442:              subroutine CloudSimpleInit( &
   443:                & ArgFlagSnow             &
   444:                & )
   445:            
   446:                ! ե
   447:                ! File I/O support
   448:                !
   449:                use dc_iounit, only: FileOpen
   450:            
   451:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   452:                ! Utilities for NAMELIST file input
   453:                !
   454:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   455:            
   456:                ! ҥȥǡ
   457:                ! History data output
   458:                !
   459:                use gtool_historyauto, only: HistoryAutoAddVariable
   460:            
   461:                ! 絬϶ŷ (ήŷ)
   462:                ! Large scale condensation (non-convective condensation)
   463:                !
   464:                use lscond, only : LScaleCondInit
   465:            
   466:            
   467:                ! ʸ ; Declaration statements
   468:                !
   469:            
   470:                logical, intent(in) :: ArgFlagSnow
   471:            
   472:            
   473:                character(STRING) :: CloudCoverMethod
   474:            
   475:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   476:                                          ! Unit number for NAMELIST file open
   477:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   478:                                          ! IOSTAT of NAMELIST read
   479:            
   480:                ! NAMELIST ѿ
   481:                ! NAMELIST group name
   482:                !
   483:                namelist /cloud_simple_nml/ &
   484:                  & CloudLifeTime,       &
   485:                  & CloudCoverMethod,    &
   486:                  & RHCrtl,              &
   487:                  & CloudCover
   488:                      !
   489:                      ! ǥեͤˤĤƤϽ³ "cloud_simple#CloudSimpleInit"
   490:                      ! Υɤ򻲾ȤΤ.
   491:                      !
   492:                      ! Refer to source codes in the initialization procedure
   493:                      ! "cloud_simple#CloudSimpleInit" for the default values.
   494:                      !
   495:            
   496:                ! ¹ʸ ; Executable statement
   497:                !
   498:            
   499:                if ( cloud_simple_inited ) return
   500:            
   501:            
   502:                FlagSnow = ArgFlagSnow
   503:            
   504:            
   505:                ! ǥեͤ
   506:                ! Default values settings
   507:                !
   508:                CloudLifeTime       = 3600.0_DP
   509:            
   510:                CloudCoverMethod    = 'Const'
   511:            !!$    CloudCoverMethod    = 'RH'
   512:            
   513:                RHCrtl              = 0.8_DP
   514:            
   515:                CloudCover          = 1.0_DP
   516:            
   517:            
   518:                ! NAMELIST ɤ߹
   519:                ! NAMELIST is input
   520:                !
   521:                if ( trim(namelist_filename) /= '' ) then
   522:                  call FileOpen( unit_nml, &          ! (out)
   523:                    & namelist_filename, mode = 'r' ) ! (in)
   524:            
   525:                  rewind( unit_nml )
   526:                  read( unit_nml,                     & ! (in)
   527:                    & nml = cloud_simple_nml,         & ! (out)
   528:                    & iostat = iostat_nml )             ! (out)
   529:                  close( unit_nml )
   530:            
   531:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   532:                end if
   533:            
   534:            
   535:                select case ( CloudCoverMethod )
   536:                case ( 'Const' )
   537:                  IDCloudCoverMethod = IDCloudCoverMethodConst
   538:                case ( 'RH' )
   539:                  IDCloudCoverMethod = IDCloudCoverMethodRH
   540:                case default
   541:                  call MessageNotify( 'E', module_name,         &
   542:                    & 'CloudCoverMethod=<%c> is not supported.', &
   543:                    & c1 = trim(CloudCoverMethod) )
   544:                end select
   545:            
   546:            
   547:                ! Initialization of modules used in this module
   548:                !
   549:            
   550:                ! 絬϶ŷ (ήŷ) (Manabe, 1965)
   551:                ! Large scale condensation (non-convective condensation) (Le Treut and Li, 1991)
   552:                !
   553:                call LScaleCondInit
   554:            
   555:            
   556:                ! ҥȥǡϤΤΤؤѿϿ
   557:                ! Register of variables for history data output
   558:                !
   559:            !!$    call HistoryAutoAddVariable( 'EffCloudCover', &
   560:            !!$      & (/ 'lon ', 'lat ', 'time' /), &
   561:            !!$      & 'effective cloud cover', '1' )
   562:            
   563:            
   564:            
   565:                !  ; Print
   566:                !
   567:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   568:                call MessageNotify( 'M', module_name, 'CloudLifeTime       = %f', d = (/ CloudLifeTime /) )
   569:                call MessageNotify( 'M', module_name, 'CloudCoverMethod    = %c', c1 = trim(CloudCoverMethod) )
   570:                call MessageNotify( 'M', module_name, 'RHCrtl              = %f', d = (/ RHCrtl /) )
   571:                call MessageNotify( 'M', module_name, 'CloudCover          = %f', d = (/ CloudCover /) )
   572:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   573:            
   574:            
   575:                cloud_simple_inited = .true.
   576:            
   577:              end subroutine CloudSimpleInit
   578:            
   579:              !--------------------------------------------------------------------------------------
   580:            
   581:            end module cloud_simple
