Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:19:49 2012
FILE NAME: gauss_quad.f90
PROGRAM NAME: gauss_quad
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   109  vec  (  13): Overhead of loop division is too large.
   116  vec  (   3): Unvectorized loop.
   116  vec  (  13): Overhead of loop division is too large.
   117  opt  (1019): Feedback of scalar value from one loop pass to another.
   118  opt  (1019): Feedback of scalar value from one loop pass to another.
   118  vec  (  21): Unvectorizable dependency.
   119  vec  (  21): Unvectorizable dependency.
   134  opt  (1082): Backward transfers inhibit loop optimization.
   136  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:x
   138  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:w
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:19:49 2012
FILE NAME: gauss_quad.f90
PROGRAM NAME: gauss_quad
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Ť, ʬη׻
     2  !
     3  != Calculate Gauss node and Gaussian weight
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: gauss_quad.f90,v 1.3 2011-06-19 11:05:23 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module gauss_quad
    13    !
    14    != Ť, ʬη׻
    15    !
    16    != Calculate Gauss node and Gaussian weight
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !
    21    !
    22    !
    23    !
    24    !== References
    25    !
    26    !== Procedures List
    27    !
    28  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    29  !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    30  !!$  ! RadiationFluxOutput     :: ͥեåν
    31  !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    32  !!$  ! ------------            :: ------------
    33  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    34  !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    35  !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    36  !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    37    !
    38    !== NAMELIST
    39    !
    40  !!$  ! NAMELIST#radiation_DennouAGCM_nml
    41    !
    42  
    43    ! USE statements
    44    !
    45  
    46    !
    47    ! Kind type parameter
    48    !
    49    use dc_types, only: DP, &      ! Double precision.
    50      &                 STRING, &  ! Strings.
    51      &                 TOKEN      ! Keywords.
    52  
    53    ! ʪ
    54    ! Physical and mathematical constants settings
    55    !
    56    use constants0, only: &
    57      & PI                    ! $ \pi $ .
    58                              ! Circular constant
    59  
    60    ! Declaration statements
    61    !
    62    implicit none
    63    private
    64  
    65    !
    66    ! Public procedure
    67    !
    68    public:: GauLeg
    69  
    70  
    71    character(*), parameter:: module_name = 'gauss_quad'
    72                                ! ⥸塼̾.
    73                                ! Module name
    74    character(*), parameter:: version = &
    75      & '$Name: dcpam5-20120921 $' // &
    76      & '$Id: gauss_quad.f90,v 1.3 2011-06-19 11:05:23 yot Exp $'
    77                                ! ⥸塼ΥС
    78                                ! Module version
    79  
    80  contains
    81  
    82    !--------------------------------------------------------------------------------------
    83    ! This code is the same as sh_gauleg subrouting in sh_module.f90.
    84    ! This code was obtained from Press et al. [1993], p141.
    85    !--------------------------------------------------------------------------------------
    86  
    87    subroutine GauLeg( x1, x2, n, x, w )
    88  
    89      real(DP), intent(in ) :: x1,x2
    90      integer , intent(in ) :: n
    91      real(DP), intent(out) :: x(n),w(n)
    92  
    93  
    94      real(DP):: eps
    95      real(DP):: z1, z, xm, xl, pp, p3, p2, p1
    96      integer :: i, j, m
    97  
    98  
    99      !
   100      ! changed at 2005/09/14
   101      !
   102  !!$      eps = 1.0e-11
   103      eps = 1.0e-15
   104  
   105      m  = ( n+1 ) / 2
   106      xm = ( x2+x1 ) / 2.0d0
   107      xl = ( x2-x1 ) / 2.0d0
   108  
   109      do i = 1, m
   110        z = cos( pi*dble(i-0.25)/(dble(n+0.5)) )
   111  
   112  100   continue
   113        p1 = 1.0d0
   114        p2 = 0.0d0
   115  !!$         do j = 1, n
   116        do j = 1, n
   117          p3 = p2
   118          p2 = p1
   119          p1 = ( (2.0d0*dble(j)-1.0d0)*z*p2-(dble(j)-1.0d0)*p3 ) / dble(j)
   120        enddo
   121  
   122        pp = dble(n) * (z*p1-p2) / (z*z-1.0d0)
   123        z1 = z
   124        z  = z1 - p1 / pp
   125  
   126        !
   127        ! changed at 2005/09/14
   128        !
   129  !!$         if( abs( z-z1 ) .gt. eps ) go to 100
   130  !!$         if( abs( z-z1 ) / z1 .gt. eps ) go to 100
   131        !
   132        ! changed before 2008/08/03
   133        !
   134        if( abs( z-z1 ) / abs( z1 + 1.0d-200 ) .gt. eps ) go to 100
   135  
   136        x( i     ) = xm-xl*z
   137        x( n+1-i ) = xm+xl*z
   138        w( i     ) = 2.0d0*xl/((1.0d0-z*z)*pp*pp)
   139        w( n+1-i ) = w(i)
   140      end do
   141  
   142  
   143    end subroutine GauLeg
   144  
   145    !--------------------------------------------------------------------------------------
   146  
   147  end module gauss_quad
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:19:49 2012
FILE NAME: gauss_quad.f90
PROGRAM NAME: gauss_quad
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Ť, ʬη׻
     2:            !
     3:            != Calculate Gauss node and Gaussian weight
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: gauss_quad.f90,v 1.3 2011-06-19 11:05:23 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module gauss_quad
    13:              !
    14:              != Ť, ʬη׻
    15:              !
    16:              != Calculate Gauss node and Gaussian weight
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! 
    21:              !
    22:              ! 
    23:              !
    24:              !== References
    25:              !
    26:              !== Procedures List
    27:              !
    28:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    29:            !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    30:            !!$  ! RadiationFluxOutput     :: ͥեåν
    31:            !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    32:            !!$  ! ------------            :: ------------
    33:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    34:            !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    35:            !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    36:            !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    37:              !
    38:              !== NAMELIST
    39:              !
    40:            !!$  ! NAMELIST#radiation_DennouAGCM_nml
    41:              !
    42:            
    43:              ! USE statements
    44:              !
    45:            
    46:              ! 
    47:              ! Kind type parameter
    48:              !
    49:              use dc_types, only: DP, &      ! Double precision.
    50:                &                 STRING, &  ! Strings.
    51:                &                 TOKEN      ! Keywords.
    52:            
    53:              ! ʪ
    54:              ! Physical and mathematical constants settings
    55:              !
    56:              use constants0, only: &
    57:                & PI                    ! $ \pi $ .
    58:                                        ! Circular constant
    59:            
    60:              ! Declaration statements
    61:              !
    62:              implicit none
    63:              private
    64:            
    65:              ! 
    66:              ! Public procedure
    67:              !
    68:              public:: GauLeg
    69:            
    70:            
    71:              character(*), parameter:: module_name = 'gauss_quad'
    72:                                          ! ⥸塼̾.
    73:                                          ! Module name
    74:              character(*), parameter:: version = &
    75:                & '$Name: dcpam5-20120921 $' // &
    76:                & '$Id: gauss_quad.f90,v 1.3 2011-06-19 11:05:23 yot Exp $'
    77:                                          ! ⥸塼ΥС
    78:                                          ! Module version
    79:            
    80:            contains
    81:            
    82:              !--------------------------------------------------------------------------------------
    83:              ! This code is the same as sh_gauleg subrouting in sh_module.f90.
    84:              ! This code was obtained from Press et al. [1993], p141.
    85:              !--------------------------------------------------------------------------------------
    86:            
    87:              subroutine GauLeg( x1, x2, n, x, w )
    88:            
    89:                real(DP), intent(in ) :: x1,x2
    90:                integer , intent(in ) :: n
    91:                real(DP), intent(out) :: x(n),w(n)
    92:            
    93:            
    94:                real(DP):: eps
    95:                real(DP):: z1, z, xm, xl, pp, p3, p2, p1
    96:                integer :: i, j, m
    97:            
    98:            
    99:                !
   100:                ! changed at 2005/09/14
   101:                !
   102:            !!$      eps = 1.0e-11
   103:                eps = 1.0e-15
   104:            
   105:                m  = ( n+1 ) / 2
   106:                xm = ( x2+x1 ) / 2.0d0
   107:                xl = ( x2-x1 ) / 2.0d0
   108:            
   109: +------>       do i = 1, m
   110: |                z = cos( pi*dble(i-0.25)/(dble(n+0.5)) )
   111: |          
   112: |          100   continue
   113: |                p1 = 1.0d0
   114: |                p2 = 0.0d0
   115: |          !!$         do j = 1, n
   116: |+----->         do j = 1, n
   117: ||                 p3 = p2
   118: ||                 p2 = p1
   119: ||                 p1 = ( (2.0d0*dble(j)-1.0d0)*z*p2-(dble(j)-1.0d0)*p3 ) / dble(j)
   120: |+-----          enddo
   121: |          
   122: |                pp = dble(n) * (z*p1-p2) / (z*z-1.0d0)
   123: |                z1 = z
   124: |                z  = z1 - p1 / pp
   125: |          
   126: |                !
   127: |                ! changed at 2005/09/14
   128: |                !
   129: |          !!$         if( abs( z-z1 ) .gt. eps ) go to 100
   130: |          !!$         if( abs( z-z1 ) / z1 .gt. eps ) go to 100
   131: |                !
   132: |                ! changed before 2008/08/03
   133: |                !
   134: |                if( abs( z-z1 ) / abs( z1 + 1.0d-200 ) .gt. eps ) go to 100
   135: |          
   136: |                x( i     ) = xm-xl*z
   137: |                x( n+1-i ) = xm+xl*z
   138: |                w( i     ) = 2.0d0*xl/((1.0d0-z*z)*pp*pp)
   139: |                w( n+1-i ) = w(i)
   140: +------        end do
   141:            
   142:            
   143:              end subroutine GauLeg
   144:            
   145:              !--------------------------------------------------------------------------------------
   146:            
   147:            end module gauss_quad
