Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:13 2012
FILE NAME: rad_rte_nonscat.f90
PROGRAM NAME: rad_rte_nonscat
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   197  opt  (  11): Fused array assignments. :line 197 - 198
   197  opt  (1593): Loop nest collapsed into one loop.
   197  vec  (   4): Vectorized array expression.
   204  vec  (   3): Unvectorized loop.
   204  vec  (  13): Overhead of loop division is too large.
   205  opt  (1593): Loop nest collapsed into one loop.
   205  vec  (   4): Vectorized array expression.
   218  opt  (1593): Loop nest collapsed into one loop.
   218  vec  (   4): Vectorized array expression.
   220  vec  (   3): Unvectorized loop.
   220  vec  (  13): Overhead of loop division is too large.
   221  opt  (1593): Loop nest collapsed into one loop.
   221  vec  (   4): Vectorized array expression.
   232  vec  (   3): Unvectorized loop.
   232  vec  (  13): Overhead of loop division is too large.
   233  opt  (1593): Loop nest collapsed into one loop.
   233  vec  (   4): Vectorized array expression.
   237  opt  (1593): Loop nest collapsed into one loop.
   237  vec  (   4): Vectorized array expression.
   238  vec  (   3): Unvectorized loop.
   238  vec  (  13): Overhead of loop division is too large.
   239  opt  (1593): Loop nest collapsed into one loop.
   239  vec  (   4): Vectorized array expression.
   243  opt  (1593): Loop nest collapsed into one loop.
   243  vec  (   1): Vectorized loop.
   247  opt  (1593): Loop nest collapsed into one loop.
   247  vec  (   4): Vectorized array expression.
   250  opt  (1593): Loop nest collapsed into one loop.
   250  vec  (   1): Vectorized loop.
   376  opt  (1592): Outer loop unrolled inside inner loop.
   376  vec  (   4): Vectorized array expression.
   376  vec  (   4): Vectorized array expression.
   377  opt  (  11): Fused array assignments. :line 377 - 379
   377  vec  (   4): Vectorized array expression.
   385  opt  (1592): Outer loop unrolled inside inner loop.
   385  vec  (   4): Vectorized array expression.
   385  vec  (   4): Vectorized array expression.
   386  opt  (  11): Fused array assignments. :line 386 - 388
   386  vec  (   4): Vectorized array expression.
   386  vec  (   4): Vectorized array expression.
   388  opt  (1592): Outer loop unrolled inside inner loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:13 2012
FILE NAME: rad_rte_nonscat.f90
PROGRAM NAME: rad_rte_nonscat
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ̵뤷ã
     2  !
     3  != Radiative transfer equation without considering scattering
     4  !
     5  ! Authors::   Yoshiyuki O. TAKAHASHI
     6  ! Version::   $Id: rad_rte_nonscat.f90,v 1.3 2012-02-01 05:19:53 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module rad_rte_nonscat
    13    !
    14    != ̵뤷ã
    15    !
    16    != Radiative transfer equation without considering scattering
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !
    21    !
    22    !
    23    !
    24    !== Procedures List
    25    !
    26  !!$  ! RadDTempDt        :: ͥեåˤ벹Ѳη׻
    27  !!$  ! RadFluxOutput     :: ͥեåν
    28  !!$  ! ------------            :: ------------
    29  !!$  ! RadDTempDt        :: Calculate temperature tendency with radiation flux
    30  !!$  ! RadFluxOutput     :: Output radiation fluxes
    31    !
    32    !== NAMELIST
    33    !
    34    ! NAMELIST#rad_rte_nonscat_nml
    35    !
    36  
    37    ! ⥸塼 ; USE statements
    38    !
    39  
    40    ! ̷ѥ᥿
    41    ! Kind type parameter
    42    !
    43    use dc_types, only: DP, &      ! ټ¿. Double precision.
    44      &                 STRING, &  ! ʸ.       Strings.
    45      &                 TOKEN      ! .   Keywords.
    46  
    47    ! ʪ
    48    ! Physical and mathematical constants settings
    49    !
    50    use constants0, only: &
    51      & PI, &
    52                              ! $ \pi $ .
    53                              ! ߼Ψ.  Circular constant
    54      & StB
    55                              ! $ \sigma_{SB} $ .
    56                              ! ƥեܥĥޥ.
    57                              ! Stefan-Boltzmann constant
    58  
    59    ! ʪ
    60    ! Physical constants settings
    61    !
    62    use constants, only: &
    63      & Grav, &
    64                              ! $ g $ [m s-2].
    65                              ! ϲ®.
    66                              ! Gravitational acceleration
    67      & CpDry
    68                              ! $ C_p $ [J kg-1 K-1].
    69                              ! 絤갵Ǯ.
    70                              ! Specific heat of air at constant pressure
    71  
    72  
    73    ! ʻ
    74    ! Grid points settings
    75    !
    76    use gridset, only: imax, & ! ٳʻ.
    77                               ! Number of grid points in longitude
    78      &                jmax, & ! ٳʻ.
    79                               ! Number of grid points in latitude
    80      &                kmax    ! ľؿ.
    81                               ! Number of vertical level
    82  
    83    ! å
    84    ! Message output
    85    !
    86    use dc_message, only: MessageNotify
    87  
    88    ! ʸ ; Declaration statements
    89    !
    90    implicit none
    91    private
    92  
    93    ! ³
    94    ! Public procedure
    95    !
    96    public :: RadRTENonScat
    97    public :: RadRTENonScatWrapper
    98    public :: RadRTENonScatInit
    99  
   100  
   101    ! ѿ
   102    ! Public variables
   103    !
   104    logical, save, public:: rad_rte_nonscat_inited = .false.
   105                                ! ե饰.
   106                                ! Initialization flag
   107  
   108  
   109    ! ѿ
   110    ! Private variables
   111    !
   112    real(DP), save :: DiffFact
   113  
   114  
   115    character(*), parameter:: module_name = 'rad_rte_nonscat'
   116                                ! ⥸塼̾.
   117                                ! Module name
   118    character(*), parameter:: version = &
   119      & '$Name: dcpam5-20120921 $' // &
   120      & '$Id: rad_rte_nonscat.f90,v 1.3 2012-02-01 05:19:53 yot Exp $'
   121                                ! ⥸塼ΥС
   122                                ! Module version
   123  
   124  contains
   125  
   126    !--------------------------------------------------------------------------------------
   127  
   128    subroutine RadRTENonScat(                                    &
   129      & xyz_IntPF, xy_SurfIntPF, xy_IntDPFDT1, xy_SurfIntDPFDT,  & ! (in)
   130      & xyrr_Trans,                                              & ! (in)
   131      & xyr_RadLUwFlux, xyr_RadLDwFlux,                          & ! (out)
   132      & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                   & ! (out)
   133      & )
   134      !
   135      ! ʤξãη׻
   136      !
   137      ! Integrate radiative transfer equation without scattering
   138      !
   139  
   140      ! ⥸塼 ; USE statements
   141      !
   142  
   143  
   144      ! ʸ ; Declaration statements
   145      !
   146  
   147      real(DP), intent(in ) :: xyz_IntPF        (0:imax-1, 1:jmax, 1:kmax)
   148                                ! Integrated Planck function
   149      real(DP), intent(in ) :: xy_SurfIntPF     (0:imax-1, 1:jmax)
   150                                ! Integrated Planck function with surface temperature
   151      real(DP), intent(in ) :: xy_IntDPFDT1     (0:imax-1, 1:jmax)
   152                                ! Integrated temperature derivative of Planck function
   153      real(DP), intent(in ) :: xy_SurfIntDPFDT  (0:imax-1, 1:jmax)
   154                                ! Integrated temperature derivative of Planck function
   155                                ! with surface temperature
   156      real(DP), intent(in ) :: xyrr_Trans   (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   157                                ! Ʃ᷸.
   158                                ! Transmission coefficient
   159      real(DP), intent(out) :: xyr_RadLUwFlux (0:imax-1, 1:jmax, 0:kmax)
   160                                ! Ĺȥեå.
   161                                ! Upward longwave flux
   162      real(DP), intent(out) :: xyr_RadLDwFlux (0:imax-1, 1:jmax, 0:kmax)
   163                                ! Ĺȥեå.
   164                                ! Downward longwave flux
   165      real(DP), intent(out) :: xyra_DelRadLUwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   166                                ! ĹɽѲ.
   167                                ! Upward longwave flux derivative
   168      real(DP), intent(out) :: xyra_DelRadLDwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   169                                ! ĹɽѲ.
   170                                ! Downward longwave flux derivative
   171  
   172  
   173      ! ѿ
   174      ! Work variables
   175      !
   176      integer:: k, kk           ! ľ˲ DO 롼Ѻѿ
   177                                ! Work variables for DO loop in vertical direction
   178  
   179      ! ¹ʸ ; Executable statement
   180      !
   181  
   182      ! ǧ
   183      ! Initialization check
   184      !
   185      if ( .not. rad_rte_nonscat_inited ) then
   186        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   187      end if
   188  
   189  
   190  
   191      ! ͥեå׻
   192      ! Calculate radiation flux
   193      !
   194  
   195      !   Initialization
   196      !
   197      xyr_RadLDwFlux = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t285 = 1, jmax*(kmax + 1)*imax                                 
     .           xyr_radldwflux(t285-1,1,0) = 0.0000000000000000e+000           
     .           xyr_radluwflux(t285-1,1,0) = 0.0000000000000000e+000           
     .        end do                                                            
   198      xyr_RadLUwFlux = 0.0_DP
   199      !
   200      !   Downward flux
   201      !
   202      do k = kmax, 0, -1
   203  
   204        do kk = kmax, k+1, -1
   205          xyr_RadLDwFlux(:,:,k) = xyr_RadLDwFlux(:,:,k)          &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t297 = 1, jmax*imax                                            
     .           xyr_radldwflux(t297-1,1,k) = xyr_radldwflux(t297-1,1,k) +      
     .       1      xyz_intpf(t297-1,1,kk)*(xyrr_trans(t297-1,1,k,kk-1)-        
     .       2      xyrr_trans(t297-1,1,k,kk))                                  
     .        end do                                                            
   206            & + xyz_IntPF(:,:,kk)                                &
   207            & * ( xyrr_Trans(:,:,k,kk-1) - xyrr_Trans(:,:,k,kk) )
   208        end do
   209  
   210      end do
   211      !
   212      !   Upward flux
   213      !
   214      !     Set upward flux
   215      !
   216      do k = 0, kmax
   217  
   218        xyr_RadLUwFlux(:,:,k) = xy_SurfIntPF * xyrr_Trans(:,:,k,0)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t311 = 1, jmax*imax                                            
     .           xyr_radluwflux(t311-1,1,k) = xy_surfintpf(t311-1,1)*xyrr_trans(
     .       1      t311-1,1,k,0)                                               
     .        end do                                                            
   219  
   220        do kk = 1, k
   221          xyr_RadLUwFlux(:,:,k) = xyr_RadLUwFlux(:,:,k)          &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t321 = 1, jmax*imax                                            
     .           xyr_radluwflux(t321-1,1,k) = xyr_radluwflux(t321-1,1,k) -      
     .       1      xyz_intpf(t321-1,1,kk)*(xyrr_trans(t321-1,1,k,kk-1)-        
     .       2      xyrr_trans(t321-1,1,k,kk))                                  
     .        end do                                                            
   222            & - xyz_IntPF(:,:,kk)                                &
   223            & * ( xyrr_Trans(:,:,k,kk-1) - xyrr_Trans(:,:,k,kk) )
   224        end do
   225  
   226      end do
   227  
   228  
   229      ! ͥեåѲΨη׻
   230      ! Calculate rate of change of radiative flux
   231      !
   232      do k = 0, kmax
   233        xyra_DelRadLUwFlux(:,:,k,0) =                         &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t335 = 1, jmax*imax                                            
     .           xyra_delradluwflux(t335-1,1,k,0) = xy_surfintdpfdt(t335-1,1)*  
     .       1      xyrr_trans(t335-1,1,k,0)                                    
     .        end do                                                            
   234          & xy_SurfIntDPFDT * xyrr_Trans(:,:,k,0)
   235      end do
   236      k = 0
   237      xyra_DelRadLUwFlux(:,:,k,1) = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t345 = 1, jmax*imax                                            
     .           xyra_delradluwflux(t345-1,1,0,1) = 0.0000000000000000e+000     
     .        end do                                                            
   238      do k = 1, kmax
   239        xyra_DelRadLUwFlux(:,:,k,1) =                         &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t351 = 1, jmax*imax                                            
     .           xyra_delradluwflux(t351-1,1,k,1) = -xy_intdpfdt1(t351-1,1)*(   
     .       1      xyrr_trans(t351-1,1,k,0)-xyrr_trans(t351-1,1,k,1))          
     .        end do                                                            
   240          & - xy_IntDPFDT1(:,:)                               &
   241          &   * ( xyrr_Trans(:,:,k,0) - xyrr_Trans(:,:,k,1) )
   242      end do
   243      do k = 0, kmax
   244        xyra_DelRadLDwFlux(:,:,k,0) = 0.0_DP
   245      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do k = 1, jmax*(kmax + 1)*imax                                    
     .           xyra_delradldwflux(k-1,1,0,0) = 0.0000000000000000e+000        
     .        end do                                                            
   246      k = 0
   247      xyra_DelRadLDwFlux(:,:,k,1) =                         &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t369 = 1, jmax*imax                                            
     .           xyra_delradldwflux(t369-1,1,0,1) = xy_intdpfdt1(t369-1,1)*(    
     .       1      xyrr_trans(t369-1,1,0,0)-xyrr_trans(t369-1,1,0,1))          
     .        end do                                                            
   248        & + xy_IntDPFDT1(:,:)                               &
   249        &   * ( xyrr_Trans(:,:,k,0) - xyrr_Trans(:,:,k,1) )
   250      do k = 1, kmax
   251        xyra_DelRadLDwFlux(:,:,k,1) = 0.0_DP
   252      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do k = 1, kmax*jmax*imax                                          
     .           xyra_delradldwflux(k-1,1,1,1) = 0.0000000000000000e+000        
     .        end do                                                            
   253  
   254  
   255    end subroutine RadRTENonScat
   256  
   257    !--------------------------------------------------------------------------------------
   258  
   259    subroutine RadRTENonScatWrapper(                    &
   260      & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyrr_Trans, & ! (in )
   261      & xyr_RadLUwFlux, xyr_RadLDwFlux,                 & ! (out)
   262      & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux,         & ! (out)
   263      & WNs, WNe, NumGaussNode                          & ! (in ) optional
   264      & )
   265      !
   266      ! ʤξãη׻
   267      !
   268      ! Integrate radiative transfer equation without scattering
   269      !
   270  
   271      ! ⥸塼 ; USE statements
   272      !
   273  
   274  
   275      ! ץ󥯴ؿη׻
   276      ! Calculate Planck function
   277      !
   278      use planck_func, only :                            &
   279        & Integ_PF_GQ_Array3D, Integ_PF_GQ_Array2D, Integ_DPFDT_GQ_Array2D
   280  
   281      ! ʸ ; Declaration statements
   282      !
   283  
   284      real(DP), intent(in ) :: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   285                                ! $ T $ .     . Temperature
   286      real(DP), intent(in ) :: xy_SurfTemp (0:imax-1, 1:jmax)
   287                                ! ɽ̲.
   288                                ! Surface temperature
   289      real(DP), intent(in ) :: xy_SurfEmis (0:imax-1, 1:jmax)
   290                                ! ɽ̼ͽΨ.
   291                                ! Surface emissivity
   292      real(DP), intent(in ) :: xyrr_Trans   (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   293                                ! Ʃ᷸.
   294                                ! Transmission coefficient
   295      real(DP), intent(out) :: xyr_RadLUwFlux (0:imax-1, 1:jmax, 0:kmax)
   296                                ! Ĺȥեå.
   297                                ! Upward longwave flux
   298      real(DP), intent(out) :: xyr_RadLDwFlux (0:imax-1, 1:jmax, 0:kmax)
   299                                ! Ĺȥեå.
   300                                ! Downward longwave flux
   301      real(DP), intent(out) :: xyra_DelRadLUwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   302                                ! ĹɽѲ.
   303                                ! Upward longwave flux derivative
   304      real(DP), intent(out) :: xyra_DelRadLDwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   305                                ! ĹɽѲ.
   306                                ! Downward longwave flux derivative
   307      real(DP), intent(in ), optional :: WNs
   308      real(DP), intent(in ), optional :: WNe
   309      integer , intent(in ), optional :: NumGaussNode
   310  
   311  
   312      ! ѿ
   313      ! Work variables
   314      !
   315      real(DP):: xyz_IntPF        (0:imax-1, 1:jmax, 1:kmax)
   316                                ! Integrated Planck function
   317      real(DP):: xy_SurfIntPF     (0:imax-1, 1:jmax)
   318                                ! Integrated Planck function with surface temperature
   319      real(DP):: xy_IntDPFDT1     (0:imax-1, 1:jmax)
   320                                ! Integrated temperature derivative of Planck function
   321      real(DP):: xy_SurfIntDPFDT  (0:imax-1, 1:jmax)
   322                                ! Integrated temperature derivative of Planck function
   323                                ! with surface temperature
   324  
   325  
   326      ! ¹ʸ ; Executable statement
   327      !
   328  
   329      ! ǧ
   330      ! Initialization check
   331      !
   332      if ( .not. rad_rte_nonscat_inited ) then
   333        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   334      end if
   335  
   336  
   337      ! Check arguments
   338      !
   339      if ( present( WNs ) .or. present( WNe ) .or. present( NumGaussNode ) ) then
   340        if ( .not. ( present( WNs ) .and. present( WNe ) .and. present( NumGaussNode ) ) ) then
   341          call MessageNotify( 'E', module_name, &
   342            & 'All of WNs, WNe, and NumGaussNode have to be present.' )
   343        end if
   344      end if
   345  
   346  
   347      if ( present( WNs ) ) then
   348        ! Case for non-grey atmosphere
   349        !
   350  
   351        ! Integrate Planck function and temperature derivative of it
   352        !
   353        call Integ_PF_GQ_Array3D( &
   354          & WNs, WNe, NumGaussNode, &
   355          & 0, imax-1, 1, jmax, 1, kmax, &
   356          & xyz_Temp, &
   357          & xyz_IntPF &
   358          & )
   359        call Integ_PF_GQ_Array2D( &
   360          & WNs, WNe, NumGaussNode, &
   361          & 0, imax-1, 1, jmax, &
   362          & xy_SurfTemp, &
   363          & xy_SurfIntPF &
   364          & )
   365        call Integ_DPFDT_GQ_Array2D(             &
   366          & WNs, WNe, NumGaussNode,              & ! (in )
   367          & 0, imax-1, 1, jmax, xyz_Temp(:,:,1), & ! (in )
   368          & xy_IntDPFDT1                         & ! (out)
   369          & )
   370        call Integ_DPFDT_GQ_Array2D(         &
   371          & WNs, WNe, NumGaussNode,          & ! (in )
   372          & 0, imax-1, 1, jmax, xy_SurfTemp, & ! (in )
   373          & xy_SurfIntDPFDT                  & ! (out)
   374          & )
   375  
   376        xyz_IntPF       =               PI * xyz_IntPF
     .        if (xyz_intpf.DSC.U2 .gt. 0) then                                 
     .           J1 = and(xyz_intpf.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t278 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t280 = 1, xyz_intpf.DSC.U1 + 1                           
     .                 xyz_intpf(t280-1,t278,t276+1) = 3.14159265358979e+000*   
     .       1            xyz_intpf(t280-1,t278,t276+1)                         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t278 = J1 + 1, xyz_intpf.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t280 = 1, xyz_intpf.DSC.U1 + 1                           
     .                 xyz_intpf(t280-1,t278,t276+1) = 3.14159265358979e+000*   
     .       1            xyz_intpf(t280-1,t278,t276+1)                         
     .                 xyz_intpf(t280-1,t278+1,t276+1) = 3.14159265358979e+000* 
     .       1            xyz_intpf(t280-1,t278+1,t276+1)                       
     .                 xyz_intpf(t280-1,t278+2,t276+1) = 3.14159265358979e+000* 
     .       1            xyz_intpf(t280-1,t278+2,t276+1)                       
     .                 xyz_intpf(t280-1,t278+3,t276+1) = 3.14159265358979e+000* 
     .       1            xyz_intpf(t280-1,t278+3,t276+1)                       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   377        xy_SurfIntPF    = xy_SurfEmis * PI * xy_SurfIntPF
   378        xy_IntDPFDT1    =               PI * xy_IntDPFDT1
   379        xy_SurfIntDPFDT = xy_SurfEmis * PI * xy_SurfIntDPFDT
   380  
   381      else
   382  
   383        ! Case for grey atmosphere
   384        !
   385        xyz_IntPF       =                        StB * xyz_Temp**4
     .           if (t23 .gt. 0) then                                           
     .           J2 = and(t23,3)                                                
     .  !CDIR    NODEP                                                          
     .           do t246 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t248 = 1, t22 + 1                                        
     .                 xyz_intpf(t248-1,t246,t244+1) = 5.66999999999999e-008*   
     .       1            xyz_temp(t248-1,t246,t244+1)**4                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t246 = J2 + 1, t23, 4                                       
     .  !CDIR       NODEP                                                       
     .              do t248 = 1, t22 + 1                                        
     .                 xyz_intpf(t248-1,t246,t244+1) = 5.66999999999999e-008*   
     .       1            xyz_temp(t248-1,t246,t244+1)**4                       
     .                 xyz_intpf(t248-1,t246+1,t244+1) = 5.66999999999999e-008* 
     .       1            xyz_temp(t248-1,t246+1,t244+1)**4                     
     .                 xyz_intpf(t248-1,t246+2,t244+1) = 5.66999999999999e-008* 
     .       1            xyz_temp(t248-1,t246+2,t244+1)**4                     
     .                 xyz_intpf(t248-1,t246+3,t244+1) = 5.66999999999999e-008* 
     .       1            xyz_temp(t248-1,t246+3,t244+1)**4                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   386        xy_SurfIntPF    = xy_SurfEmis          * StB * xy_SurfTemp**4
     .        if (t35 .gt. 0) then                                              
     .           J3 = and(t35,1)                                                
     .  !CDIR    NODEP                                                          
     .           do t256 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t258 = 1, t34 + 1                                        
     .                 xy_surfintpf(t258-1,t256) = (xy_surfemis(t258-1,t256)*   
     .       1            5.66999999999999e-008)*xy_surftemp(t258-1,t256)**4    
     .                 xy_intdpfdt1(t258-1,t256) = 2.26799999999999e-007*       
     .       1            xyz_temp(t258-1,t256,1)**3                            
     .                 xy_surfintdpfdt(t258-1,t256) = (xy_surfemis(t258-1,t256)*
     .       1            5.66999999999999e-008)*4.00000000000000e+000*         
     .       2            xy_surftemp(t258-1,t256)**3                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t256 = J3 + 1, t35, 2                                       
     .  !CDIR       NODEP                                                       
     .              do t258 = 1, t34 + 1                                        
     .                 xy_surfintpf(t258-1,t256) = (xy_surfemis(t258-1,t256)*   
     .       1            5.66999999999999e-008)*xy_surftemp(t258-1,t256)**4    
     .                 xy_surfintpf(t258-1,t256+1) = (xy_surfemis(t258-1,t256+1)
     .       1            *5.66999999999999e-008)*xy_surftemp(t258-1,t256+1)**4 
     .                 xy_intdpfdt1(t258-1,t256) = 2.26799999999999e-007*       
     .       1            xyz_temp(t258-1,t256,1)**3                            
     .                 xy_intdpfdt1(t258-1,t256+1) = 2.26799999999999e-007*     
     .       1            xyz_temp(t258-1,t256+1,1)**3                          
     .                 xy_surfintdpfdt(t258-1,t256) = (xy_surfemis(t258-1,t256)*
     .       1            5.66999999999999e-008)*4.00000000000000e+000*         
     .       2            xy_surftemp(t258-1,t256)**3                           
     .                 xy_surfintdpfdt(t258-1,t256+1) = (xy_surfemis(t258-1,t256
     .       1            +1)*5.66999999999999e-008)*4.00000000000000e+000*     
     .       2            xy_surftemp(t258-1,t256+1)**3                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   387        xy_IntDPFDT1    =               4.0_DP * StB * xyz_Temp(:,:,1)**3
   388        xy_SurfIntDPFDT = xy_SurfEmis * 4.0_DP * StB * xy_SurfTemp**3
   389  
   390      end if
   391  
   392  
   393      call RadRTENonScat(                                         &
   394        & xyz_IntPF, xy_SurfIntPF, xy_IntDPFDT1, xy_SurfIntDPFDT, & ! (in)
   395        & xyrr_Trans,                                             & ! (in)
   396        & xyr_RadLUwFlux, xyr_RadLDwFlux,                         & ! (out)
   397        & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                  & ! (out)
   398        & )
   399  
   400  
   401    end subroutine RadRTENonScatWrapper
   402  
   403    !--------------------------------------------------------------------------------------
   404  
   405    subroutine RadRTENonScatInit
   406      !
   407      ! rad_rte_nonscat ⥸塼νԤޤ.
   408      ! NAMELIST#rad_rte_nonscat_nml ɤ߹ߤϤμ³ǹԤޤ.
   409      !
   410      ! "rad_rte_nonscat" module is initialized.
   411      ! "NAMELIST#rad_rte_nonscat_nml" is loaded in this procedure.
   412      !
   413  
   414      ! ⥸塼 ; USE statements
   415      !
   416  
   417      ! NAMELIST եϤ˴ؤ桼ƥƥ
   418      ! Utilities for NAMELIST file input
   419      !
   420      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   421  
   422      ! ե
   423      ! File I/O support
   424      !
   425      use dc_iounit, only: FileOpen
   426  
   427      ! ҥȥǡ
   428      ! History data output
   429      !
   430      use gtool_historyauto, only: HistoryAutoAddVariable
   431  
   432      ! ʸ
   433      ! Character handling
   434      !
   435      use dc_string, only: toChar
   436  
   437      ! ʸ ; Declaration statements
   438      !
   439  
   440      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   441                                ! Unit number for NAMELIST file open
   442      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   443                                ! IOSTAT of NAMELIST read
   444  
   445  
   446      ! NAMELIST ѿ
   447      ! NAMELIST group name
   448      !
   449      namelist /rad_rte_nonscat_nml/ &
   450        & DiffFact
   451            !
   452            ! ǥեͤˤĤƤϽ³ "rad_rte_nonscat#RadRTENonScatInit"
   453            ! Υɤ򻲾ȤΤ.
   454            !
   455            ! Refer to source codes in the initialization procedure
   456            ! "rad_rte_nonscat#RadRTENonScatInit" for the default values.
   457            !
   458  
   459      ! ¹ʸ ; Executable statement
   460      !
   461  
   462      if ( rad_rte_nonscat_inited ) return
   463  
   464  
   465      ! ǥեͤ
   466      ! Default values settings
   467      !
   468      DiffFact = 1.66_DP
   469  
   470      ! NAMELIST ɤ߹
   471      ! NAMELIST is input
   472      !
   473      if ( trim(namelist_filename) /= '' ) then
   474        call FileOpen( unit_nml, &          ! (out)
   475          & namelist_filename, mode = 'r' ) ! (in)
   476  
   477        rewind( unit_nml )
   478        read( unit_nml,                     & ! (in)
   479          & nml = rad_rte_nonscat_nml,      & ! (out)
   480          & iostat = iostat_nml )             ! (out)
   481        close( unit_nml )
   482  
   483        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   484      end if
   485  
   486  
   487      !  ; Print
   488      !
   489      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   490      call MessageNotify( 'M', module_name, 'DiffFact = %f', d = (/ DiffFact /) )
   491      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   492  
   493      rad_rte_nonscat_inited = .true.
   494  
   495    end subroutine RadRTENonScatInit
   496  
   497    !-------------------------------------------------------------------
   498  
   499  end module rad_rte_nonscat
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:13 2012
FILE NAME: rad_rte_nonscat.f90
PROGRAM NAME: rad_rte_nonscat
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ̵뤷ã
     2:            !
     3:            != Radiative transfer equation without considering scattering
     4:            !
     5:            ! Authors::   Yoshiyuki O. TAKAHASHI
     6:            ! Version::   $Id: rad_rte_nonscat.f90,v 1.3 2012-02-01 05:19:53 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module rad_rte_nonscat
    13:              !
    14:              != ̵뤷ã
    15:              !
    16:              != Radiative transfer equation without considering scattering
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! 
    21:              !
    22:              ! 
    23:              !
    24:              !== Procedures List
    25:              !
    26:            !!$  ! RadDTempDt        :: ͥեåˤ벹Ѳη׻
    27:            !!$  ! RadFluxOutput     :: ͥեåν
    28:            !!$  ! ------------            :: ------------
    29:            !!$  ! RadDTempDt        :: Calculate temperature tendency with radiation flux
    30:            !!$  ! RadFluxOutput     :: Output radiation fluxes
    31:              !
    32:              !== NAMELIST
    33:              !
    34:              ! NAMELIST#rad_rte_nonscat_nml
    35:              !
    36:            
    37:              ! ⥸塼 ; USE statements
    38:              !
    39:            
    40:              ! ̷ѥ᥿
    41:              ! Kind type parameter
    42:              !
    43:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    44:                &                 STRING, &  ! ʸ.       Strings. 
    45:                &                 TOKEN      ! .   Keywords. 
    46:            
    47:              ! ʪ
    48:              ! Physical and mathematical constants settings
    49:              !
    50:              use constants0, only: &
    51:                & PI, &
    52:                                        ! $ \pi $ .
    53:                                        ! ߼Ψ.  Circular constant
    54:                & StB
    55:                                        ! $ \sigma_{SB} $ .
    56:                                        ! ƥեܥĥޥ.
    57:                                        ! Stefan-Boltzmann constant
    58:            
    59:              ! ʪ
    60:              ! Physical constants settings
    61:              !
    62:              use constants, only: &
    63:                & Grav, &
    64:                                        ! $ g $ [m s-2]. 
    65:                                        ! ϲ®. 
    66:                                        ! Gravitational acceleration
    67:                & CpDry
    68:                                        ! $ C_p $ [J kg-1 K-1]. 
    69:                                        ! 絤갵Ǯ. 
    70:                                        ! Specific heat of air at constant pressure
    71:            
    72:            
    73:              ! ʻ
    74:              ! Grid points settings
    75:              !
    76:              use gridset, only: imax, & ! ٳʻ. 
    77:                                         ! Number of grid points in longitude
    78:                &                jmax, & ! ٳʻ. 
    79:                                         ! Number of grid points in latitude
    80:                &                kmax    ! ľؿ. 
    81:                                         ! Number of vertical level
    82:            
    83:              ! å
    84:              ! Message output
    85:              !
    86:              use dc_message, only: MessageNotify
    87:            
    88:              ! ʸ ; Declaration statements
    89:              !
    90:              implicit none
    91:              private
    92:            
    93:              ! ³
    94:              ! Public procedure
    95:              !
    96:              public :: RadRTENonScat
    97:              public :: RadRTENonScatWrapper
    98:              public :: RadRTENonScatInit
    99:            
   100:            
   101:              ! ѿ
   102:              ! Public variables
   103:              !
   104:              logical, save, public:: rad_rte_nonscat_inited = .false.
   105:                                          ! ե饰. 
   106:                                          ! Initialization flag
   107:            
   108:            
   109:              ! ѿ
   110:              ! Private variables
   111:              !
   112:              real(DP), save :: DiffFact
   113:            
   114:            
   115:              character(*), parameter:: module_name = 'rad_rte_nonscat'
   116:                                          ! ⥸塼̾. 
   117:                                          ! Module name
   118:              character(*), parameter:: version = &
   119:                & '$Name: dcpam5-20120921 $' // &
   120:                & '$Id: rad_rte_nonscat.f90,v 1.3 2012-02-01 05:19:53 yot Exp $'
   121:                                          ! ⥸塼ΥС
   122:                                          ! Module version
   123:            
   124:            contains
   125:            
   126:              !--------------------------------------------------------------------------------------
   127:            
   128:              subroutine RadRTENonScat(                                    &
   129:                & xyz_IntPF, xy_SurfIntPF, xy_IntDPFDT1, xy_SurfIntDPFDT,  & ! (in)
   130:                & xyrr_Trans,                                              & ! (in)
   131:                & xyr_RadLUwFlux, xyr_RadLDwFlux,                          & ! (out)
   132:                & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                   & ! (out)
   133:                & )
   134:                !
   135:                ! ʤξãη׻
   136:                !
   137:                ! Integrate radiative transfer equation without scattering
   138:                !
   139:            
   140:                ! ⥸塼 ; USE statements
   141:                !
   142:            
   143:            
   144:                ! ʸ ; Declaration statements
   145:                !
   146:            
   147:                real(DP), intent(in ) :: xyz_IntPF        (0:imax-1, 1:jmax, 1:kmax)
   148:                                          ! Integrated Planck function
   149:                real(DP), intent(in ) :: xy_SurfIntPF     (0:imax-1, 1:jmax)
   150:                                          ! Integrated Planck function with surface temperature
   151:                real(DP), intent(in ) :: xy_IntDPFDT1     (0:imax-1, 1:jmax)
   152:                                          ! Integrated temperature derivative of Planck function
   153:                real(DP), intent(in ) :: xy_SurfIntDPFDT  (0:imax-1, 1:jmax)
   154:                                          ! Integrated temperature derivative of Planck function
   155:                                          ! with surface temperature
   156:                real(DP), intent(in ) :: xyrr_Trans   (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   157:                                          ! Ʃ᷸. 
   158:                                          ! Transmission coefficient
   159:                real(DP), intent(out) :: xyr_RadLUwFlux (0:imax-1, 1:jmax, 0:kmax)
   160:                                          ! Ĺȥեå. 
   161:                                          ! Upward longwave flux
   162:                real(DP), intent(out) :: xyr_RadLDwFlux (0:imax-1, 1:jmax, 0:kmax)
   163:                                          ! Ĺȥեå. 
   164:                                          ! Downward longwave flux
   165:                real(DP), intent(out) :: xyra_DelRadLUwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   166:                                          ! ĹɽѲ. 
   167:                                          ! Upward longwave flux derivative
   168:                real(DP), intent(out) :: xyra_DelRadLDwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   169:                                          ! ĹɽѲ. 
   170:                                          ! Downward longwave flux derivative
   171:            
   172:            
   173:                ! ѿ
   174:                ! Work variables
   175:                !
   176:                integer:: k, kk           ! ľ˲ DO 롼Ѻѿ
   177:                                          ! Work variables for DO loop in vertical direction
   178:            
   179:                ! ¹ʸ ; Executable statement
   180:                !
   181:            
   182:                ! ǧ
   183:                ! Initialization check
   184:                !
   185:                if ( .not. rad_rte_nonscat_inited ) then
   186:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   187:                end if
   188:            
   189:            
   190:            
   191:                ! ͥեå׻
   192:                ! Calculate radiation flux
   193:                !
   194:            
   195:                !   Initialization
   196:                !
   197: **W---->       xyr_RadLDwFlux = 0.0_DP
   198: **W----        xyr_RadLUwFlux = 0.0_DP
   199:                !
   200:                !   Downward flux
   201:                !
   202: +------>       do k = kmax, 0, -1
   203: |          
   204: |+----->         do kk = kmax, k+1, -1
   205: ||W*===            xyr_RadLDwFlux(:,:,k) = xyr_RadLDwFlux(:,:,k)          &
   206: ||                   & + xyz_IntPF(:,:,kk)                                &
   207: ||                   & * ( xyrr_Trans(:,:,k,kk-1) - xyrr_Trans(:,:,k,kk) )
   208: |+-----          end do
   209: |          
   210: +------        end do
   211:                !
   212:                !   Upward flux
   213:                !
   214:                !     Set upward flux
   215:                !
   216: +------>       do k = 0, kmax
   217: |          
   218: |W*====          xyr_RadLUwFlux(:,:,k) = xy_SurfIntPF * xyrr_Trans(:,:,k,0)
   219: |          
   220: |+----->         do kk = 1, k
   221: ||W*===            xyr_RadLUwFlux(:,:,k) = xyr_RadLUwFlux(:,:,k)          &
   222: ||                   & - xyz_IntPF(:,:,kk)                                &
   223: ||                   & * ( xyrr_Trans(:,:,k,kk-1) - xyrr_Trans(:,:,k,kk) )
   224: |+-----          end do
   225: |          
   226: +------        end do
   227:            
   228:            
   229:                ! ͥեåѲΨη׻
   230:                ! Calculate rate of change of radiative flux
   231:                !
   232: +------>       do k = 0, kmax
   233: |WW====          xyra_DelRadLUwFlux(:,:,k,0) =                         &
   234: |                  & xy_SurfIntDPFDT * xyrr_Trans(:,:,k,0)
   235: +------        end do
   236:                k = 0
   237: **=====        xyra_DelRadLUwFlux(:,:,k,1) = 0.0_DP
   238: +------>       do k = 1, kmax
   239: |W*====          xyra_DelRadLUwFlux(:,:,k,1) =                         &
   240: |                  & - xy_IntDPFDT1(:,:)                               &
   241: |                  &   * ( xyrr_Trans(:,:,k,0) - xyrr_Trans(:,:,k,1) )
   242: +------        end do
   243: W------>       do k = 0, kmax
   244: |W*====          xyra_DelRadLDwFlux(:,:,k,0) = 0.0_DP
   245: W------        end do
   246:                k = 0
   247: **=====        xyra_DelRadLDwFlux(:,:,k,1) =                         &
   248:                  & + xy_IntDPFDT1(:,:)                               &
   249:                  &   * ( xyrr_Trans(:,:,k,0) - xyrr_Trans(:,:,k,1) )
   250: W------>       do k = 1, kmax
   251: |++====          xyra_DelRadLDwFlux(:,:,k,1) = 0.0_DP
   252: W------        end do
   253:            
   254:            
   255:              end subroutine RadRTENonScat
   256:            
   257:              !--------------------------------------------------------------------------------------
   258:            
   259:              subroutine RadRTENonScatWrapper(                    &
   260:                & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyrr_Trans, & ! (in )
   261:                & xyr_RadLUwFlux, xyr_RadLDwFlux,                 & ! (out)
   262:                & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux,         & ! (out)
   263:                & WNs, WNe, NumGaussNode                          & ! (in ) optional
   264:                & )
   265:                !
   266:                ! ʤξãη׻
   267:                !
   268:                ! Integrate radiative transfer equation without scattering
   269:                !
   270:            
   271:                ! ⥸塼 ; USE statements
   272:                !
   273:            
   274:            
   275:                ! ץ󥯴ؿη׻
   276:                ! Calculate Planck function
   277:                !
   278:                use planck_func, only :                            &
   279:                  & Integ_PF_GQ_Array3D, Integ_PF_GQ_Array2D, Integ_DPFDT_GQ_Array2D
   280:            
   281:                ! ʸ ; Declaration statements
   282:                !
   283:            
   284:                real(DP), intent(in ) :: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   285:                                          ! $ T $ .     . Temperature
   286:                real(DP), intent(in ) :: xy_SurfTemp (0:imax-1, 1:jmax)
   287:                                          ! ɽ̲. 
   288:                                          ! Surface temperature
   289:                real(DP), intent(in ) :: xy_SurfEmis (0:imax-1, 1:jmax)
   290:                                          ! ɽ̼ͽΨ. 
   291:                                          ! Surface emissivity
   292:                real(DP), intent(in ) :: xyrr_Trans   (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   293:                                          ! Ʃ᷸. 
   294:                                          ! Transmission coefficient
   295:                real(DP), intent(out) :: xyr_RadLUwFlux (0:imax-1, 1:jmax, 0:kmax)
   296:                                          ! Ĺȥեå. 
   297:                                          ! Upward longwave flux
   298:                real(DP), intent(out) :: xyr_RadLDwFlux (0:imax-1, 1:jmax, 0:kmax)
   299:                                          ! Ĺȥեå. 
   300:                                          ! Downward longwave flux
   301:                real(DP), intent(out) :: xyra_DelRadLUwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   302:                                          ! ĹɽѲ. 
   303:                                          ! Upward longwave flux derivative
   304:                real(DP), intent(out) :: xyra_DelRadLDwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   305:                                          ! ĹɽѲ. 
   306:                                          ! Downward longwave flux derivative
   307:                real(DP), intent(in ), optional :: WNs
   308:                real(DP), intent(in ), optional :: WNe
   309:                integer , intent(in ), optional :: NumGaussNode
   310:            
   311:            
   312:                ! ѿ
   313:                ! Work variables
   314:                !
   315:                real(DP):: xyz_IntPF        (0:imax-1, 1:jmax, 1:kmax)
   316:                                          ! Integrated Planck function
   317:                real(DP):: xy_SurfIntPF     (0:imax-1, 1:jmax)
   318:                                          ! Integrated Planck function with surface temperature
   319:                real(DP):: xy_IntDPFDT1     (0:imax-1, 1:jmax)
   320:                                          ! Integrated temperature derivative of Planck function
   321:                real(DP):: xy_SurfIntDPFDT  (0:imax-1, 1:jmax)
   322:                                          ! Integrated temperature derivative of Planck function
   323:                                          ! with surface temperature
   324:            
   325:            
   326:                ! ¹ʸ ; Executable statement
   327:                !
   328:            
   329:                ! ǧ
   330:                ! Initialization check
   331:                !
   332:                if ( .not. rad_rte_nonscat_inited ) then
   333:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   334:                end if
   335:            
   336:            
   337:                ! Check arguments
   338:                !
   339:                if ( present( WNs ) .or. present( WNe ) .or. present( NumGaussNode ) ) then
   340:                  if ( .not. ( present( WNs ) .and. present( WNe ) .and. present( NumGaussNode ) ) ) then
   341:                    call MessageNotify( 'E', module_name, &
   342:                      & 'All of WNs, WNe, and NumGaussNode have to be present.' )
   343:                  end if
   344:                end if
   345:            
   346:            
   347:                if ( present( WNs ) ) then
   348:                  ! Case for non-grey atmosphere
   349:                  !
   350:            
   351:                  ! Integrate Planck function and temperature derivative of it
   352:                  !
   353:                  call Integ_PF_GQ_Array3D( &
   354:                    & WNs, WNe, NumGaussNode, &
   355:                    & 0, imax-1, 1, jmax, 1, kmax, &
   356:                    & xyz_Temp, &
   357:                    & xyz_IntPF &
   358:                    & )
   359:                  call Integ_PF_GQ_Array2D( &
   360:                    & WNs, WNe, NumGaussNode, &
   361:                    & 0, imax-1, 1, jmax, &
   362:                    & xy_SurfTemp, &
   363:                    & xy_SurfIntPF &
   364:                    & )
   365:                  call Integ_DPFDT_GQ_Array2D(             &
   366:                    & WNs, WNe, NumGaussNode,              & ! (in )
   367:                    & 0, imax-1, 1, jmax, xyz_Temp(:,:,1), & ! (in )
   368:                    & xy_IntDPFDT1                         & ! (out)
   369:                    & )
   370:                  call Integ_DPFDT_GQ_Array2D(         &
   371:                    & WNs, WNe, NumGaussNode,          & ! (in )
   372:                    & 0, imax-1, 1, jmax, xy_SurfTemp, & ! (in )
   373:                    & xy_SurfIntDPFDT                  & ! (out)
   374:                    & )
   375:            
   376: ++V====          xyz_IntPF       =               PI * xyz_IntPF
   377: *V----->         xy_SurfIntPF    = xy_SurfEmis * PI * xy_SurfIntPF
   378: ||               xy_IntDPFDT1    =               PI * xy_IntDPFDT1
   379: *V-----          xy_SurfIntDPFDT = xy_SurfEmis * PI * xy_SurfIntDPFDT
   380:            
   381:                else
   382:            
   383:                  ! Case for grey atmosphere
   384:                  !
   385: ++V====          xyz_IntPF       =                        StB * xyz_Temp**4
   386: *V----->         xy_SurfIntPF    = xy_SurfEmis          * StB * xy_SurfTemp**4
   387: ||               xy_IntDPFDT1    =               4.0_DP * StB * xyz_Temp(:,:,1)**3
   388: *V-----          xy_SurfIntDPFDT = xy_SurfEmis * 4.0_DP * StB * xy_SurfTemp**3
   389:            
   390:                end if
   391:            
   392:            
   393:                call RadRTENonScat(                                         &
   394:                  & xyz_IntPF, xy_SurfIntPF, xy_IntDPFDT1, xy_SurfIntDPFDT, & ! (in)
   395:                  & xyrr_Trans,                                             & ! (in)
   396:                  & xyr_RadLUwFlux, xyr_RadLDwFlux,                         & ! (out)
   397:                  & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                  & ! (out)
   398:                  & )
   399:            
   400:            
   401:              end subroutine RadRTENonScatWrapper
   402:            
   403:              !--------------------------------------------------------------------------------------
   404:            
   405:              subroutine RadRTENonScatInit
   406:                !
   407:                ! rad_rte_nonscat ⥸塼νԤޤ. 
   408:                ! NAMELIST#rad_rte_nonscat_nml ɤ߹ߤϤμ³ǹԤޤ. 
   409:                !
   410:                ! "rad_rte_nonscat" module is initialized. 
   411:                ! "NAMELIST#rad_rte_nonscat_nml" is loaded in this procedure. 
   412:                !
   413:            
   414:                ! ⥸塼 ; USE statements
   415:                !
   416:            
   417:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   418:                ! Utilities for NAMELIST file input
   419:                !
   420:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   421:            
   422:                ! ե
   423:                ! File I/O support
   424:                !
   425:                use dc_iounit, only: FileOpen
   426:            
   427:                ! ҥȥǡ
   428:                ! History data output
   429:                !
   430:                use gtool_historyauto, only: HistoryAutoAddVariable
   431:            
   432:                ! ʸ
   433:                ! Character handling
   434:                !
   435:                use dc_string, only: toChar
   436:            
   437:                ! ʸ ; Declaration statements
   438:                !
   439:            
   440:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   441:                                          ! Unit number for NAMELIST file open
   442:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   443:                                          ! IOSTAT of NAMELIST read
   444:            
   445:            
   446:                ! NAMELIST ѿ
   447:                ! NAMELIST group name
   448:                !
   449:                namelist /rad_rte_nonscat_nml/ &
   450:                  & DiffFact
   451:                      !
   452:                      ! ǥեͤˤĤƤϽ³ "rad_rte_nonscat#RadRTENonScatInit" 
   453:                      ! Υɤ򻲾ȤΤ. 
   454:                      !
   455:                      ! Refer to source codes in the initialization procedure
   456:                      ! "rad_rte_nonscat#RadRTENonScatInit" for the default values. 
   457:                      !
   458:            
   459:                ! ¹ʸ ; Executable statement
   460:                !
   461:            
   462:                if ( rad_rte_nonscat_inited ) return
   463:            
   464:            
   465:                ! ǥեͤ
   466:                ! Default values settings
   467:                !
   468:                DiffFact = 1.66_DP
   469:            
   470:                ! NAMELIST ɤ߹
   471:                ! NAMELIST is input
   472:                !
   473:                if ( trim(namelist_filename) /= '' ) then
   474:                  call FileOpen( unit_nml, &          ! (out)
   475:                    & namelist_filename, mode = 'r' ) ! (in)
   476:            
   477:                  rewind( unit_nml )
   478:                  read( unit_nml,                     & ! (in)
   479:                    & nml = rad_rte_nonscat_nml,      & ! (out)
   480:                    & iostat = iostat_nml )             ! (out)
   481:                  close( unit_nml )
   482:            
   483:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   484:                end if
   485:            
   486:            
   487:                !  ; Print
   488:                !
   489:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   490:                call MessageNotify( 'M', module_name, 'DiffFact = %f', d = (/ DiffFact /) )
   491:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   492:            
   493:                rad_rte_nonscat_inited = .true.
   494:            
   495:              end subroutine RadRTENonScatInit
   496:            
   497:              !-------------------------------------------------------------------
   498:            
   499:            end module rad_rte_nonscat
