Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:05 2012
FILE NAME: rad_simple.f90
PROGRAM NAME: rad_simple
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   212  opt  (  11): Fused array assignments. :line 212 - 213
   212  vec  (   4): Vectorized array expression.
   212  vec  (   4): Vectorized array expression.
   213  opt  (1592): Outer loop unrolled inside inner loop.
   214  opt  (1592): Outer loop unrolled inside inner loop.
   214  vec  (   4): Vectorized array expression.
   214  vec  (   4): Vectorized array expression.
   227  vec  (   3): Unvectorized loop.
   227  vec  (  13): Overhead of loop division is too large.
   228  opt  (1592): Outer loop unrolled inside inner loop.
   228  vec  (   4): Vectorized array expression.
   228  vec  (   4): Vectorized array expression.
   231  opt  (1592): Outer loop unrolled inside inner loop.
   231  vec  (   4): Vectorized array expression.
   231  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:05 2012
FILE NAME: rad_simple.f90
PROGRAM NAME: rad_simple
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ñͥǥ
     2  !
     3  != Simple radiation model
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: rad_simple.f90,v 1.4 2012-09-17 10:59:31 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module rad_simple
    13    !
    14    != ñͥǥ
    15    !
    16    != Simple radiation model
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !
    21    !
    22    ! This is a simple radiation model.
    23    !
    24    !== References
    25    !
    26    !
    27    !
    28    !== Procedures List
    29    !
    30  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    31  !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    32  !!$  ! RadiationFluxOutput     :: ͥեåν
    33  !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    34  !!$  ! ------------            :: ------------
    35  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    36  !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    37  !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    38  !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    39    !
    40    !== NAMELIST
    41    !
    42    ! NAMELIST#rad_Simple_nml
    43    !
    44  
    45    ! USE statements
    46    !
    47  
    48    !
    49    ! Kind type parameter
    50    !
    51    use dc_types, only: DP, &      ! Double precision.
    52      &                 STRING, &  ! Strings.
    53      &                 TOKEN      ! Keywords.
    54  
    55    ! ʻ
    56    ! Grid points settings
    57    !
    58    use gridset, only: imax, & ! ٳʻ.
    59                               ! Number of grid points in longitude
    60      &                jmax, & ! ٳʻ.
    61                               ! Number of grid points in latitude
    62      &                kmax    ! ľؿ.
    63                               ! Number of vertical level
    64  
    65    implicit none
    66  
    67    private
    68  
    69  
    70    ! Private variables
    71    !
    72  !!$  real(DP), save :: SWOptDepAtRefPress
    73  !!$  real(DP), save :: SWRefPress
    74  !!$  real(DP), save :: SWOrd
    75  !!$  real(DP), save :: LWOptDepAtRefPress
    76  !!$  real(DP), save :: LWRefPress
    77  !!$  real(DP), save :: LWOrd
    78    real(DP), save :: SolarConst
    79  
    80  
    81    ! ѿ
    82    ! Public variables
    83    !
    84    logical, save, public:: rad_simple_inited = .false.
    85                                ! ե饰.
    86                                ! Initialization flag
    87  
    88    public :: RadSimpleFlux
    89    public :: RadSimpleInit
    90  
    91    character(*), parameter:: module_name = 'rad_simple'
    92                                ! ⥸塼̾.
    93                                ! Module name
    94    character(*), parameter:: version = &
    95      & '$Name: dcpam5-20120921 $' // &
    96      & '$Id: rad_simple.f90,v 1.4 2012-09-17 10:59:31 yot Exp $'
    97                                ! ⥸塼ΥС
    98                                ! Module version
    99  
   100    !--------------------------------------------------------------------------------------
   101  
   102  contains
   103  
   104    !--------------------------------------------------------------------------------------
   105  
   106    subroutine RadSimpleFlux(                                                    &
   107      & xy_SurfAlbedo, xy_SurfTemp, xyr_Press, xyz_Press, xyz_Temp, xyz_QH2OVap, &
   108      & xyr_RadSUwFlux, xyr_RadSDwFlux,                                          &
   109      & xyr_RadLUwFlux, xyr_RadLDwFlux,                                          &
   110      & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                                   &
   111      & )
   112  
   113  
   114      ! USE statements
   115      !
   116  
   117      ! å
   118      ! Message output
   119      !
   120      use dc_message, only: MessageNotify
   121  
   122      ! ʪ
   123      ! Physical and mathematical constants settings
   124      !
   125      use constants0, only: &
   126        & PI                    ! $ \pi $ .
   127                                ! ߼Ψ.  Circular constant
   128  
   129      !
   130      ! Physical constants settings
   131      !
   132      use constants, only: Grav     ! $ g $ [m s-2].
   133                                    !
   134                                    ! Gravitational acceleration
   135  
   136      ! ɸǡ
   137      ! Axes data settings
   138      !
   139      use axesset, only : y_Lat
   140  
   141      ! û ()
   142      ! Short wave (insolation) incoming
   143      !
   144      use rad_short_income, only : RadShortIncome
   145  
   146      !
   147      ! Solve radiative transfer equation in two stream approximation
   148      !
   149      use rad_rte_two_stream_app, only: RadRTETwoStreamAppSW
   150  
   151      ! Ĺȥեåη׻
   152      ! Calculate long wave flux
   153      !
   154      use rad_simple_LW, only : RadSimpleLWFlux
   155  
   156  
   157      real(DP), intent(in ) :: xy_SurfAlbedo( 0:imax-1, 1:jmax )
   158      real(DP), intent(in ) :: xy_SurfTemp  ( 0:imax-1, 1:jmax )
   159      real(DP), intent(in ) :: xyr_Press    ( 0:imax-1, 1:jmax, 0:kmax )
   160      real(DP), intent(in ) :: xyz_Press    ( 0:imax-1, 1:jmax, 1:kmax )
   161      real(DP), intent(in ) :: xyz_Temp     ( 0:imax-1, 1:jmax, 1:kmax )
   162      real(DP), intent(in ) :: xyz_QH2OVap  ( 0:imax-1, 1:jmax, 1:kmax )
   163      real(DP), intent(out) :: xyr_RadSUwFlux    ( 0:imax-1, 1:jmax, 0:kmax )
   164      real(DP), intent(out) :: xyr_RadSDwFlux    ( 0:imax-1, 1:jmax, 0:kmax )
   165      real(DP), intent(out) :: xyr_RadLUwFlux    (0:imax-1, 1:jmax, 0:kmax)
   166      real(DP), intent(out) :: xyr_RadLDwFlux    (0:imax-1, 1:jmax, 0:kmax)
   167      real(DP), intent(out) :: xyra_DelRadLUwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   168      real(DP), intent(out) :: xyra_DelRadLDwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   169  
   170  
   171      ! Work variables
   172      !
   173      real(DP) :: DistFromStarScld
   174                                 ! Distance between the central star and the planet
   175      real(DP) :: DiurnalMeanFactor
   176  
   177      real(DP) :: SolarFluxTOA
   178  !!$    real(DP) :: QeRatio
   179      real(DP) :: xyz_SSA       (0:imax-1, 1:jmax, 1:kmax)
   180      real(DP) :: xyz_AF        (0:imax-1, 1:jmax, 1:kmax)
   181      real(DP) :: xy_InAngle    (0:imax-1, 1:jmax)
   182      real(DP) :: xyz_DelAtmMass(0:imax-1, 1:jmax, 1:kmax)
   183      real(DP) :: xyr_OptDep    (0:imax-1, 1:jmax, 0:kmax)
   184  
   185      real(DP) :: xy_SurfEmis  (0:imax-1, 1:jmax)
   186  
   187      integer  :: k
   188  
   189  
   190      ! 
   191      ! Initialization
   192      !
   193      if ( .not. rad_Simple_inited ) then
   194        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   195      end if
   196  
   197  
   198      ! Short wave radiation
   199      !
   200  
   201      ! ûͤη׻
   202      ! Calculate short wave (insolation) incoming radiation
   203      !
   204      call RadShortIncome(                       &
   205        & xy_InAngle        = xy_InAngle,        & ! (out) optional
   206        & DistFromStarScld  = DistFromStarScld,  & ! (out) optional
   207        & DiurnalMeanFactor = DiurnalMeanFactor  &
   208        & )
   209  
   210      SolarFluxTOA = SolarConst / DistFromStarScld**2 * DiurnalMeanFactor
   211  
   212      xyz_SSA    = 1.0_DP - 1.0d-10
     .        if (xyz_ssa.DSC.U2 .gt. 0) then                                   
     .           J1 = and(xyz_ssa.DSC.U2,1)                                     
     .  !CDIR    NODEP                                                          
     .           do t285 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t287 = 1, xyz_ssa.DSC.U1 + 1                             
     .                 xyz_ssa(t287-1,t285,t283+1) = 9.99999999899999e-001      
     .                 xyz_af(t287-1,t285,t283+1) = 0.0000000000000000e+000     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t285 = J1 + 1, xyz_ssa.DSC.U2, 2                            
     .  !CDIR       NODEP                                                       
     .              do t287 = 1, xyz_ssa.DSC.U1 + 1                             
     .                 xyz_ssa(t287-1,t285,t283+1) = 9.99999999899999e-001      
     .                 xyz_ssa(t287-1,t285+1,t283+1) = 9.99999999899999e-001    
     .                 xyz_af(t287-1,t285,t283+1) = 0.0000000000000000e+000     
     .                 xyz_af(t287-1,t285+1,t283+1) = 0.0000000000000000e+000   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   213      xyz_AF     = 0.0_DP
   214      xyr_OptDep = 0.0_DP
     .        if (xyr_optdep.DSC.U2 .gt. 0) then                                
     .           J2 = and(xyr_optdep.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t297 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t299 = 1, xyr_optdep.DSC.U1 + 1                          
     .                 xyr_optdep(t299-1,t297,t295) = 0.0000000000000000e+000   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t297 = J2 + 1, xyr_optdep.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t299 = 1, xyr_optdep.DSC.U1 + 1                          
     .                 xyr_optdep(t299-1,t297,t295) = 0.0000000000000000e+000   
     .                 xyr_optdep(t299-1,t297+1,t295) = 0.0000000000000000e+000 
     .                 xyr_optdep(t299-1,t297+2,t295) = 0.0000000000000000e+000 
     .                 xyr_optdep(t299-1,t297+3,t295) = 0.0000000000000000e+000 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   215  
   216      call RadRTETwoStreamAppSW(            &
   217        & xyz_SSA, xyz_AF,                  & ! (in)
   218        & xyr_OptDep,                       & ! (in)
   219        & xy_SurfAlbedo,                    & ! (in)
   220        & SolarFluxTOA, xy_InAngle,         & ! (in)
   221        & xyr_RadSUwFlux, xyr_RadSDwFlux    & ! (out)
   222        & )
   223  
   224      ! Long wave radiation
   225      !
   226  
   227      do k = 1, kmax
   228        xyz_DelAtmMass(:,:,k) = ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k ) ) / Grav
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t304 = 1, J3                                                
     .              D1 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t306 = 1, imax                                           
     .                 xyz_delatmmass(t306-1,t304,k) = (xyr_press(t306-1,t304,k-
     .       1            1)-xyr_press(t306-1,t304,k))*D1                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t304 = J3 + 1, jmax, 4                                      
     .              D2 = 1.D0/grav                                              
     .              D3 = 1.D0/grav                                              
     .              D4 = 1.D0/grav                                              
     .              D5 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t306 = 1, imax                                           
     .                 xyz_delatmmass(t306-1,t304,k) = (xyr_press(t306-1,t304,k-
     .       1            1)-xyr_press(t306-1,t304,k))*D2                       
     .                 xyz_delatmmass(t306-1,t304+1,k) = (xyr_press(t306-1,t304+
     .       1            1,k-1)-xyr_press(t306-1,t304+1,k))*D3                 
     .                 xyz_delatmmass(t306-1,t304+2,k) = (xyr_press(t306-1,t304+
     .       1            2,k-1)-xyr_press(t306-1,t304+2,k))*D4                 
     .                 xyz_delatmmass(t306-1,t304+3,k) = (xyr_press(t306-1,t304+
     .       1            3,k-1)-xyr_press(t306-1,t304+3,k))*D5                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   229      end do
   230  
   231      xy_SurfEmis = 1.0_DP
     .        if (xy_surfemis.DSC.U2 .gt. 0) then                               
     .           J4 = and(xy_surfemis.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t314 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t316 = 1, xy_surfemis.DSC.U1 + 1                         
     .                 xy_surfemis(t316-1,t314) = 1.00000000000000e+000         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t314 = J4 + 1, xy_surfemis.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t316 = 1, xy_surfemis.DSC.U1 + 1                         
     .                 xy_surfemis(t316-1,t314) = 1.00000000000000e+000         
     .                 xy_surfemis(t316-1,t314+1) = 1.00000000000000e+000       
     .                 xy_surfemis(t316-1,t314+2) = 1.00000000000000e+000       
     .                 xy_surfemis(t316-1,t314+3) = 1.00000000000000e+000       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   232  
   233      call RadSimpleLWFlux(                                                &
   234        & xy_SurfEmis, xyz_Temp, xyz_Press, xy_SurfTemp,                   & ! (in)
   235        & xyz_DelAtmMass, xyz_QH2OVap,                                     & ! (in)
   236        & xyr_RadLUwFlux, xyr_RadLDwFlux,                                  & ! (out)
   237        & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                           & ! (out)
   238        & )
   239  
   240  
   241    end subroutine RadSimpleFlux
   242  
   243    !--------------------------------------------------------------------------------------
   244  
   245    subroutine RadSimpleInit
   246  
   247      ! ե
   248      ! File I/O support
   249      !
   250      use dc_iounit, only: FileOpen
   251  
   252      ! NAMELIST եϤ˴ؤ桼ƥƥ
   253      ! Utilities for NAMELIST file input
   254      !
   255      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   256  
   257      ! å
   258      ! Message output
   259      !
   260      use dc_message, only: MessageNotify
   261  
   262      ! û ()
   263      ! Short wave (insolation) incoming
   264      !
   265      use rad_short_income, only : RadShortIncomeInit
   266  
   267      !
   268      ! Solve radiative transfer equation in two stream approximation
   269      !
   270      use rad_rte_two_stream_app, only: RadRTETwoStreamAppInit
   271  
   272      ! ͥեå (ñĹȥХɥǥ)
   273      ! Radiation flux (simple longwave band model)
   274      !
   275      use rad_simple_LW, only : RadSimpleLWInit
   276  
   277  
   278      ! ʸ ; Declaration statements
   279      !
   280  
   281      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   282                                ! Unit number for NAMELIST file open
   283      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   284                                ! IOSTAT of NAMELIST read
   285  
   286      ! NAMELIST ѿ
   287      ! NAMELIST group name
   288      !
   289      namelist /rad_Simple_nml/ &
   290  !!$      & SWOptDepAtRefPress, SWRefPress, SWOrd, &
   291  !!$      & LWOptDepAtRefPress, LWRefPress, LWOrd, &
   292        & SolarConst
   293            !
   294            ! ǥեͤˤĤƤϽ³ "rad_Simple#RadSimpleInit"
   295            ! Υɤ򻲾ȤΤ.
   296            !
   297            ! Refer to source codes in the initialization procedure
   298            ! "rad_Simple#RadSimpleInit" for the default values.
   299            !
   300  
   301      if ( rad_Simple_inited ) return
   302  
   303  
   304      ! ǥեͤ
   305      ! Default values settings
   306      !
   307  !!$    SWOptDepAtRefPress =  3.0_DP
   308  !!$    SWRefPress         =  3.0d5
   309  !!$    SWOrd              =  1.0_DP
   310  !!$
   311  !!$    LWOptDepAtRefPress = 80.0_DP
   312  !!$    LWRefPress         =  3.0d5
   313  !!$    LWOrd              =  2.0_DP
   314  
   315      SolarConst         = 1366.0_DP
   316  
   317  
   318  
   319  
   320      ! NAMELIST ɤ߹
   321      ! NAMELIST is input
   322      !
   323      if ( trim(namelist_filename) /= '' ) then
   324        call FileOpen( unit_nml, &          ! (out)
   325          & namelist_filename, mode = 'r' ) ! (in)
   326  
   327        rewind( unit_nml )
   328        read( unit_nml,                     & ! (in)
   329          & nml = rad_Simple_nml,           & ! (out)
   330          & iostat = iostat_nml )             ! (out)
   331        close( unit_nml )
   332  
   333        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   334      end if
   335  
   336  
   337      ! Initialization of modules used in this module
   338      !
   339  
   340      ! û ()
   341      ! Short wave (insolation) incoming
   342      !
   343      call RadShortIncomeInit
   344  
   345      !
   346      ! Solve radiative transfer equation in two stream approximation
   347      !
   348      call RadRTETwoStreamAppInit
   349  
   350      ! ͥեå (ñĹȥХɥǥ)
   351      ! Radiation flux (simple longwave band model)
   352      !
   353      call RadSimpleLWInit
   354  
   355  
   356      !  ; Print
   357      !
   358      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   359  !!$    call MessageNotify( 'M', module_name, 'SWOptDepAtRefPress = %f', d = (/ SWOptDepAtRefPress /) )
   360  !!$    call MessageNotify( 'M', module_name, 'SWRefPress         = %f', d = (/ SWRefPress /) )
   361  !!$    call MessageNotify( 'M', module_name, 'SWOrd              = %f', d = (/ SWOrd /) )
   362  !!$    call MessageNotify( 'M', module_name, 'LWOptDepAtRefPress = %f', d = (/ LWOptDepAtRefPress /) )
   363  !!$    call MessageNotify( 'M', module_name, 'LWRefPress         = %f', d = (/ LWRefPress /) )
   364  !!$    call MessageNotify( 'M', module_name, 'LWOrd              = %f', d = (/ LWOrd /) )
   365      call MessageNotify( 'M', module_name, 'SolarConst         = %f', d = (/ SolarConst /) )
   366      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   367  
   368  
   369      rad_Simple_inited = .true.
   370  
   371    end subroutine RadSimpleInit
   372  
   373    !--------------------------------------------------------------------------------------
   374  
   375  end module rad_simple
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:05 2012
FILE NAME: rad_simple.f90
PROGRAM NAME: rad_simple
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ñͥǥ
     2:            !
     3:            != Simple radiation model
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: rad_simple.f90,v 1.4 2012-09-17 10:59:31 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module rad_simple
    13:              !
    14:              != ñͥǥ
    15:              !
    16:              != Simple radiation model
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! 
    21:              !
    22:              ! This is a simple radiation model.
    23:              !
    24:              !== References
    25:              !
    26:              !
    27:              !
    28:              !== Procedures List
    29:              !
    30:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    31:            !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    32:            !!$  ! RadiationFluxOutput     :: ͥեåν
    33:            !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    34:            !!$  ! ------------            :: ------------
    35:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    36:            !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    37:            !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    38:            !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    39:              !
    40:              !== NAMELIST
    41:              !
    42:              ! NAMELIST#rad_Simple_nml
    43:              !
    44:            
    45:              ! USE statements
    46:              !
    47:            
    48:              !
    49:              ! Kind type parameter
    50:              !
    51:              use dc_types, only: DP, &      ! Double precision.
    52:                &                 STRING, &  ! Strings.
    53:                &                 TOKEN      ! Keywords.
    54:            
    55:              ! ʻ
    56:              ! Grid points settings
    57:              !
    58:              use gridset, only: imax, & ! ٳʻ.
    59:                                         ! Number of grid points in longitude
    60:                &                jmax, & ! ٳʻ.
    61:                                         ! Number of grid points in latitude
    62:                &                kmax    ! ľؿ.
    63:                                         ! Number of vertical level
    64:            
    65:              implicit none
    66:            
    67:              private
    68:            
    69:            
    70:              ! Private variables
    71:              !
    72:            !!$  real(DP), save :: SWOptDepAtRefPress
    73:            !!$  real(DP), save :: SWRefPress
    74:            !!$  real(DP), save :: SWOrd
    75:            !!$  real(DP), save :: LWOptDepAtRefPress
    76:            !!$  real(DP), save :: LWRefPress
    77:            !!$  real(DP), save :: LWOrd
    78:              real(DP), save :: SolarConst
    79:            
    80:            
    81:              ! ѿ
    82:              ! Public variables
    83:              !
    84:              logical, save, public:: rad_simple_inited = .false.
    85:                                          ! ե饰.
    86:                                          ! Initialization flag
    87:            
    88:              public :: RadSimpleFlux
    89:              public :: RadSimpleInit
    90:            
    91:              character(*), parameter:: module_name = 'rad_simple'
    92:                                          ! ⥸塼̾.
    93:                                          ! Module name
    94:              character(*), parameter:: version = &
    95:                & '$Name: dcpam5-20120921 $' // &
    96:                & '$Id: rad_simple.f90,v 1.4 2012-09-17 10:59:31 yot Exp $'
    97:                                          ! ⥸塼ΥС
    98:                                          ! Module version
    99:            
   100:              !--------------------------------------------------------------------------------------
   101:            
   102:            contains
   103:            
   104:              !--------------------------------------------------------------------------------------
   105:            
   106:              subroutine RadSimpleFlux(                                                    &
   107:                & xy_SurfAlbedo, xy_SurfTemp, xyr_Press, xyz_Press, xyz_Temp, xyz_QH2OVap, &
   108:                & xyr_RadSUwFlux, xyr_RadSDwFlux,                                          &
   109:                & xyr_RadLUwFlux, xyr_RadLDwFlux,                                          &
   110:                & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                                   &
   111:                & )
   112:            
   113:            
   114:                ! USE statements
   115:                !
   116:            
   117:                ! å
   118:                ! Message output
   119:                !
   120:                use dc_message, only: MessageNotify
   121:            
   122:                ! ʪ
   123:                ! Physical and mathematical constants settings
   124:                !
   125:                use constants0, only: &
   126:                  & PI                    ! $ \pi $ .
   127:                                          ! ߼Ψ.  Circular constant
   128:            
   129:                !
   130:                ! Physical constants settings
   131:                !
   132:                use constants, only: Grav     ! $ g $ [m s-2].
   133:                                              !
   134:                                              ! Gravitational acceleration
   135:            
   136:                ! ɸǡ
   137:                ! Axes data settings
   138:                !
   139:                use axesset, only : y_Lat
   140:            
   141:                ! û ()
   142:                ! Short wave (insolation) incoming
   143:                !
   144:                use rad_short_income, only : RadShortIncome
   145:            
   146:                !
   147:                ! Solve radiative transfer equation in two stream approximation
   148:                !
   149:                use rad_rte_two_stream_app, only: RadRTETwoStreamAppSW
   150:            
   151:                ! Ĺȥեåη׻
   152:                ! Calculate long wave flux
   153:                !
   154:                use rad_simple_LW, only : RadSimpleLWFlux
   155:            
   156:            
   157:                real(DP), intent(in ) :: xy_SurfAlbedo( 0:imax-1, 1:jmax )
   158:                real(DP), intent(in ) :: xy_SurfTemp  ( 0:imax-1, 1:jmax )
   159:                real(DP), intent(in ) :: xyr_Press    ( 0:imax-1, 1:jmax, 0:kmax )
   160:                real(DP), intent(in ) :: xyz_Press    ( 0:imax-1, 1:jmax, 1:kmax )
   161:                real(DP), intent(in ) :: xyz_Temp     ( 0:imax-1, 1:jmax, 1:kmax )
   162:                real(DP), intent(in ) :: xyz_QH2OVap  ( 0:imax-1, 1:jmax, 1:kmax )
   163:                real(DP), intent(out) :: xyr_RadSUwFlux    ( 0:imax-1, 1:jmax, 0:kmax )
   164:                real(DP), intent(out) :: xyr_RadSDwFlux    ( 0:imax-1, 1:jmax, 0:kmax )
   165:                real(DP), intent(out) :: xyr_RadLUwFlux    (0:imax-1, 1:jmax, 0:kmax)
   166:                real(DP), intent(out) :: xyr_RadLDwFlux    (0:imax-1, 1:jmax, 0:kmax)
   167:                real(DP), intent(out) :: xyra_DelRadLUwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   168:                real(DP), intent(out) :: xyra_DelRadLDwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   169:            
   170:            
   171:                ! Work variables
   172:                !
   173:                real(DP) :: DistFromStarScld
   174:                                           ! Distance between the central star and the planet
   175:                real(DP) :: DiurnalMeanFactor
   176:            
   177:                real(DP) :: SolarFluxTOA
   178:            !!$    real(DP) :: QeRatio
   179:                real(DP) :: xyz_SSA       (0:imax-1, 1:jmax, 1:kmax)
   180:                real(DP) :: xyz_AF        (0:imax-1, 1:jmax, 1:kmax)
   181:                real(DP) :: xy_InAngle    (0:imax-1, 1:jmax)
   182:                real(DP) :: xyz_DelAtmMass(0:imax-1, 1:jmax, 1:kmax)
   183:                real(DP) :: xyr_OptDep    (0:imax-1, 1:jmax, 0:kmax)
   184:            
   185:                real(DP) :: xy_SurfEmis  (0:imax-1, 1:jmax)
   186:            
   187:                integer  :: k
   188:            
   189:            
   190:                ! 
   191:                ! Initialization
   192:                !
   193:                if ( .not. rad_Simple_inited ) then
   194:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   195:                end if
   196:            
   197:            
   198:                ! Short wave radiation
   199:                !
   200:            
   201:                ! ûͤη׻
   202:                ! Calculate short wave (insolation) incoming radiation
   203:                !
   204:                call RadShortIncome(                       &
   205:                  & xy_InAngle        = xy_InAngle,        & ! (out) optional
   206:                  & DistFromStarScld  = DistFromStarScld,  & ! (out) optional
   207:                  & DiurnalMeanFactor = DiurnalMeanFactor  &
   208:                  & )
   209:            
   210:                SolarFluxTOA = SolarConst / DistFromStarScld**2 * DiurnalMeanFactor
   211:            
   212: **V---->       xyz_SSA    = 1.0_DP - 1.0d-10
   213: **V----        xyz_AF     = 0.0_DP
   214: ++V====        xyr_OptDep = 0.0_DP
   215:            
   216:                call RadRTETwoStreamAppSW(            &
   217:                  & xyz_SSA, xyz_AF,                  & ! (in)
   218:                  & xyr_OptDep,                       & ! (in)
   219:                  & xy_SurfAlbedo,                    & ! (in)
   220:                  & SolarFluxTOA, xy_InAngle,         & ! (in)
   221:                  & xyr_RadSUwFlux, xyr_RadSDwFlux    & ! (out)
   222:                  & )
   223:            
   224:                ! Long wave radiation
   225:                !
   226:            
   227: +------>       do k = 1, kmax
   228: |+V====          xyz_DelAtmMass(:,:,k) = ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k ) ) / Grav
   229: +------        end do
   230:            
   231: +V=====        xy_SurfEmis = 1.0_DP
   232:            
   233:                call RadSimpleLWFlux(                                                &
   234:                  & xy_SurfEmis, xyz_Temp, xyz_Press, xy_SurfTemp,                   & ! (in)
   235:                  & xyz_DelAtmMass, xyz_QH2OVap,                                     & ! (in)
   236:                  & xyr_RadLUwFlux, xyr_RadLDwFlux,                                  & ! (out)
   237:                  & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                           & ! (out)
   238:                  & )
   239:            
   240:            
   241:              end subroutine RadSimpleFlux
   242:            
   243:              !--------------------------------------------------------------------------------------
   244:            
   245:              subroutine RadSimpleInit
   246:            
   247:                ! ե
   248:                ! File I/O support
   249:                !
   250:                use dc_iounit, only: FileOpen
   251:            
   252:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   253:                ! Utilities for NAMELIST file input
   254:                !
   255:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   256:            
   257:                ! å
   258:                ! Message output
   259:                !
   260:                use dc_message, only: MessageNotify
   261:            
   262:                ! û ()
   263:                ! Short wave (insolation) incoming
   264:                !
   265:                use rad_short_income, only : RadShortIncomeInit
   266:            
   267:                !
   268:                ! Solve radiative transfer equation in two stream approximation
   269:                !
   270:                use rad_rte_two_stream_app, only: RadRTETwoStreamAppInit
   271:            
   272:                ! ͥեå (ñĹȥХɥǥ)
   273:                ! Radiation flux (simple longwave band model)
   274:                !
   275:                use rad_simple_LW, only : RadSimpleLWInit
   276:            
   277:            
   278:                ! ʸ ; Declaration statements
   279:                !
   280:            
   281:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   282:                                          ! Unit number for NAMELIST file open
   283:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   284:                                          ! IOSTAT of NAMELIST read
   285:            
   286:                ! NAMELIST ѿ
   287:                ! NAMELIST group name
   288:                !
   289:                namelist /rad_Simple_nml/ &
   290:            !!$      & SWOptDepAtRefPress, SWRefPress, SWOrd, &
   291:            !!$      & LWOptDepAtRefPress, LWRefPress, LWOrd, &
   292:                  & SolarConst
   293:                      !
   294:                      ! ǥեͤˤĤƤϽ³ "rad_Simple#RadSimpleInit"
   295:                      ! Υɤ򻲾ȤΤ.
   296:                      !
   297:                      ! Refer to source codes in the initialization procedure
   298:                      ! "rad_Simple#RadSimpleInit" for the default values.
   299:                      !
   300:            
   301:                if ( rad_Simple_inited ) return
   302:            
   303:            
   304:                ! ǥեͤ
   305:                ! Default values settings
   306:                !
   307:            !!$    SWOptDepAtRefPress =  3.0_DP
   308:            !!$    SWRefPress         =  3.0d5
   309:            !!$    SWOrd              =  1.0_DP
   310:            !!$
   311:            !!$    LWOptDepAtRefPress = 80.0_DP
   312:            !!$    LWRefPress         =  3.0d5
   313:            !!$    LWOrd              =  2.0_DP
   314:            
   315:                SolarConst         = 1366.0_DP
   316:            
   317:            
   318:            
   319:            
   320:                ! NAMELIST ɤ߹
   321:                ! NAMELIST is input
   322:                !
   323:                if ( trim(namelist_filename) /= '' ) then
   324:                  call FileOpen( unit_nml, &          ! (out)
   325:                    & namelist_filename, mode = 'r' ) ! (in)
   326:            
   327:                  rewind( unit_nml )
   328:                  read( unit_nml,                     & ! (in)
   329:                    & nml = rad_Simple_nml,           & ! (out)
   330:                    & iostat = iostat_nml )             ! (out)
   331:                  close( unit_nml )
   332:            
   333:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   334:                end if
   335:            
   336:            
   337:                ! Initialization of modules used in this module
   338:                !
   339:            
   340:                ! û ()
   341:                ! Short wave (insolation) incoming
   342:                !
   343:                call RadShortIncomeInit
   344:            
   345:                !
   346:                ! Solve radiative transfer equation in two stream approximation
   347:                !
   348:                call RadRTETwoStreamAppInit
   349:            
   350:                ! ͥեå (ñĹȥХɥǥ)
   351:                ! Radiation flux (simple longwave band model)
   352:                !
   353:                call RadSimpleLWInit
   354:            
   355:            
   356:                !  ; Print
   357:                !
   358:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   359:            !!$    call MessageNotify( 'M', module_name, 'SWOptDepAtRefPress = %f', d = (/ SWOptDepAtRefPress /) )
   360:            !!$    call MessageNotify( 'M', module_name, 'SWRefPress         = %f', d = (/ SWRefPress /) )
   361:            !!$    call MessageNotify( 'M', module_name, 'SWOrd              = %f', d = (/ SWOrd /) )
   362:            !!$    call MessageNotify( 'M', module_name, 'LWOptDepAtRefPress = %f', d = (/ LWOptDepAtRefPress /) )
   363:            !!$    call MessageNotify( 'M', module_name, 'LWRefPress         = %f', d = (/ LWRefPress /) )
   364:            !!$    call MessageNotify( 'M', module_name, 'LWOrd              = %f', d = (/ LWOrd /) )
   365:                call MessageNotify( 'M', module_name, 'SolarConst         = %f', d = (/ SolarConst /) )
   366:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   367:            
   368:            
   369:                rad_Simple_inited = .true.
   370:            
   371:              end subroutine RadSimpleInit
   372:            
   373:              !--------------------------------------------------------------------------------------
   374:            
   375:            end module rad_simple
