Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:09 2012
FILE NAME: rad_utils.f90
PROGRAM NAME: rad_utils
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   198  opt  (1593): Loop nest collapsed into one loop.
   198  vec  (   1): Vectorized loop.
   199  opt  (  11): Fused array assignments. :line 199 - 204
   299  vec  (   3): Unvectorized loop.
   299  vec  (  13): Overhead of loop division is too large.
   300  opt  (  11): Fused array assignments. :line 300 - 305
   300  opt  (1593): Loop nest collapsed into one loop.
   300  vec  (   4): Vectorized array expression.
   382  opt  (  11): Fused array assignments. :line 382 - 383
   382  vec  (   4): Vectorized array expression.
   382  vec  (   4): Vectorized array expression.
   383  opt  (1592): Outer loop unrolled inside inner loop.
   384  opt  (1592): Outer loop unrolled inside inner loop.
   384  vec  (   4): Vectorized array expression.
   384  vec  (   4): Vectorized array expression.
   391  opt  (  11): Fused array assignments. :line 391 - 392
   391  vec  (   4): Vectorized array expression.
   391  vec  (   4): Vectorized array expression.
   392  opt  (1592): Outer loop unrolled inside inner loop.
   503  opt  (  11): Fused array assignments. :line 503 - 504
   503  vec  (   4): Vectorized array expression.
   503  vec  (   4): Vectorized array expression.
   504  opt  (1592): Outer loop unrolled inside inner loop.
   505  opt  (1772): Loop nest fused with following nest(s).
   505  opt  (1592): Outer loop unrolled inside inner loop.
   505  vec  (   4): Vectorized array expression.
   505  vec  (   4): Vectorized array expression.
   524  vec  (   3): Unvectorized loop.
   524  vec  (  13): Overhead of loop division is too large.
   525  opt  (  11): Fused array assignments. :line 525 - 530
   525  vec  (   4): Vectorized array expression.
   525  vec  (   4): Vectorized array expression.
   530  opt  (1592): Outer loop unrolled inside inner loop.
   536  opt  (1592): Outer loop unrolled inside inner loop.
   536  vec  (   4): Vectorized array expression.
   536  vec  (   4): Vectorized array expression.
   581  vec  (   3): Unvectorized loop.
   581  vec  (  13): Overhead of loop division is too large.
   582  opt  (  11): Fused array assignments. :line 582 - 587
   582  vec  (   4): Vectorized array expression.
   582  vec  (   4): Vectorized array expression.
   587  opt  (1592): Outer loop unrolled inside inner loop.
   593  opt  (1592): Outer loop unrolled inside inner loop.
   593  vec  (   4): Vectorized array expression.
   593  vec  (   4): Vectorized array expression.
   809  warn (  82): Name "iostat_nml" is not used.
   809  warn (  82): Name "unit_nml" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:09 2012
FILE NAME: rad_utils.f90
PROGRAM NAME: rad_utils
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ʹϢ롼
     2  !
     3  != Routines for radiation calculation
     4  !
     5  ! Authors::   Yasuhiro MORIKAWA, Yukiko YAMADA, Satoshi NODA, Yoshiyuki O. TAKAHASHI
     6  ! Version::   $Id: rad_utils.f90,v 1.6 2012-02-01 05:19:54 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module rad_utils
    13    !
    14    != ʹϢ롼
    15    !
    16    != Routines for radiation calculation
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !
    21    !
    22    !
    23    !
    24    !== Procedures List
    25    !
    26    ! RadDTempDt        :: ͥեåˤ벹Ѳη׻
    27    ! RadFluxOutput     :: ͥեåν
    28    ! ------------            :: ------------
    29    ! RadDTempDt        :: Calculate temperature tendency with radiation flux
    30    ! RadFluxOutput     :: Output radiation fluxes
    31    !
    32    !== NAMELIST
    33    !
    34    ! NAMELIST#rad_utils_nml
    35    !
    36  
    37    ! ⥸塼 ; USE statements
    38    !
    39  
    40    ! ̷ѥ᥿
    41    ! Kind type parameter
    42    !
    43    use dc_types, only: DP, &      ! ټ¿. Double precision.
    44      &                 STRING, &  ! ʸ.       Strings.
    45      &                 TOKEN      ! .   Keywords.
    46  
    47    ! ʪ
    48    ! Physical and mathematical constants settings
    49    !
    50    use constants0, only: &
    51      & PI, &                 ! $ \pi $.
    52                              ! ߼Ψ. Circular constant
    53      & StB
    54                              ! $ \sigma_{SB} $ .
    55                              ! ƥեܥĥޥ.
    56                              ! Stefan-Boltzmann constant
    57  
    58    ! ʪ
    59    ! Physical constants settings
    60    !
    61    use constants, only: &
    62      & Grav, &
    63                              ! $ g $ [m s-2].
    64                              ! ϲ®.
    65                              ! Gravitational acceleration
    66      & CpDry
    67                              ! $ C_p $ [J kg-1 K-1].
    68                              ! 絤갵Ǯ.
    69                              ! Specific heat of air at constant pressure
    70  
    71  
    72    ! ʻ
    73    ! Grid points settings
    74    !
    75    use gridset, only: imax, & ! ٳʻ.
    76                               ! Number of grid points in longitude
    77      &                jmax, & ! ٳʻ.
    78                               ! Number of grid points in latitude
    79      &                kmax    ! ľؿ.
    80                               ! Number of vertical level
    81  
    82    ! å
    83    ! Message output
    84    !
    85    use dc_message, only: MessageNotify
    86  
    87    ! ʸ ; Declaration statements
    88    !
    89    implicit none
    90    private
    91  
    92    ! ³
    93    ! Public procedure
    94    !
    95    public :: RadDTempDt
    96    public :: RadDTempDtforNHM2DWrapper
    97    public :: RadFluxOutput
    98    public :: RadUtilsInit
    99  
   100  
   101    ! ѿ
   102    ! Public variables
   103    !
   104    logical, save, public:: rad_utils_inited = .false.
   105                                ! ե饰.
   106                                ! Initialization flag
   107  
   108  
   109    ! ѿ
   110    ! Private variables
   111    !
   112  
   113  
   114    character(*), parameter:: module_name = 'rad_utils'
   115                                ! ⥸塼̾.
   116                                ! Module name
   117    character(*), parameter:: version = &
   118      & '$Name: dcpam5-20120921 $' // &
   119      & '$Id: rad_utils.f90,v 1.6 2012-02-01 05:19:54 yot Exp $'
   120                                ! ⥸塼ΥС
   121                                ! Module version
   122  
   123  contains
   124  
   125    !--------------------------------------------------------------------------------------
   126  
   127    subroutine RadDTempDt( &
   128      & xyr_RadLFlux, xyr_RadSFlux, xyr_Press, & ! (in)
   129      & xyz_DTempDtRadL, xyz_DTempDtRadS &       ! (out)
   130      & )
   131      !
   132      ! ͤˤ벹ѲΨ׻ޤ.
   133      !
   134      ! Temperature tendency with radiation is calculated.
   135      !
   136  
   137      ! ⥸塼 ; USE statements
   138      !
   139  
   140      ! 
   141      ! Time control
   142      !
   143      use timeset, only: &
   144        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   145        & TimesetClockStart, TimesetClockStop
   146  
   147      ! ҥȥǡ
   148      ! History data output
   149      !
   150      use gtool_historyauto, only: HistoryAutoPut
   151  
   152  
   153      ! ʸ ; Declaration statements
   154      !
   155      implicit none
   156      real(DP), intent(in):: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   157                                ! Ĺȥեå.
   158                                ! Longwave flux
   159      real(DP), intent(in):: xyr_RadSFlux (0:imax-1, 1:jmax, 0:kmax)
   160                                ! û () եå.
   161                                ! Shortwave (insolation) flux
   162      real(DP), intent(in):: xyr_Press    (0:imax-1, 1:jmax, 0:kmax)
   163                                ! $ \hat{p} $ .  (Ⱦ٥).
   164                                ! Air pressure (half level)
   165      real(DP), intent(out):: xyz_DTempDtRadL (0:imax-1, 1:jmax, 1:kmax)
   166                                ! ĹȲǮΨ.
   167                                ! Temperature tendency with longwave
   168      real(DP), intent(out):: xyz_DTempDtRadS (0:imax-1, 1:jmax, 1:kmax)
   169                                ! ûȲǮΨ.
   170                                ! Temperature tendency with shortwave
   171  
   172      ! ѿ
   173      ! Work variables
   174      !
   175      integer:: k               ! ľ˲ DO 롼Ѻѿ
   176                                ! Work variables for DO loop in vertical direction
   177  
   178      ! ¹ʸ ; Executable statement
   179      !
   180  
   181      ! ǧ
   182      ! Initialization check
   183      !
   184      if ( .not. rad_utils_inited ) then
   185        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   186      end if
   187  
   188  
   189      ! ׻ַ¬
   190      ! Start measurement of computation time
   191      !
   192      call TimesetClockStart( module_name )
   193  
   194  
   195      ! Ψα黻
   196      ! Calculate radiation cooling rate
   197      !
   198      do k = 1, kmax
   199        xyz_DTempDtRadL(:,:,k) = &
   200          & (     xyr_RadLFlux(:,:,k-1) - xyr_RadLFlux(:,:,k) ) &
   201          &   / ( xyr_Press(:,:,k-1)    - xyr_Press(:,:,k) ) &
   202          &   / CpDry * Grav
   203  
   204        xyz_DTempDtRadS(:,:,k) = &
   205          & (     xyr_RadSFlux(:,:,k-1) - xyr_RadSFlux(:,:,k) ) &
   206          &   / ( xyr_Press(:,:,k-1)    - xyr_Press(:,:,k) ) &
   207          &   / CpDry * Grav
   208      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do k = 1, kmax*jmax*imax                                          
     .           xyz_dtempdtradl(k-1,1,1) = (xyr_radlflux(k-1,1,0)-xyr_radlflux(
     .       1      k-1,1,1))/((xyr_press(k-1,1,0)-xyr_press(k-1,1,1))*cpdry)*  
     .       2      grav                                                        
     .           xyz_dtempdtrads(k-1,1,1) = (xyr_radsflux(k-1,1,0)-xyr_radsflux(
     .       1      k-1,1,1))/((xyr_press(k-1,1,0)-xyr_press(k-1,1,1))*cpdry)*  
     .       2      grav                                                        
     .        end do                                                            
   209  
   210  
   211      ! ҥȥǡ
   212      ! History data output
   213      !
   214      call HistoryAutoPut( TimeN, 'DTempDtRadL' , xyz_DTempDtRadL )
   215      call HistoryAutoPut( TimeN, 'DTempDtRadS' , xyz_DTempDtRadS )
   216  
   217  
   218      ! ׻ַ¬
   219      ! Pause measurement of computation time
   220      !
   221      call TimesetClockStop( module_name )
   222  
   223    end subroutine RadDTempDt
   224  
   225    !--------------------------------------------------------------------------------------
   226  
   227    subroutine RadDTempDtforNHM(                        &
   228      & xyr_RadLFlux, xyr_RadSFlux, r_Height, xyz_Dens, & ! (in)
   229      & xyz_DTempDtRadL, xyz_DTempDtRadS                & ! (out)
   230      & )
   231      !
   232      ! ϳطϤˤͤˤ벹ѲΨ׻ޤ.
   233      !
   234      ! Temperature tendency with radiation is calculated for non-hydrodynamic system.
   235      !
   236  
   237      ! ⥸塼 ; USE statements
   238      !
   239  
   240      ! 
   241      ! Time control
   242      !
   243      use timeset, only: &
   244        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   245        & TimesetClockStart, TimesetClockStop
   246  
   247      ! ҥȥǡ
   248      ! History data output
   249      !
   250      use gtool_historyauto, only: HistoryAutoPut
   251  
   252  
   253      ! ʸ ; Declaration statements
   254      !
   255      implicit none
   256      real(DP), intent(in):: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   257                                ! Ĺȥեå.
   258                                ! Longwave flux
   259      real(DP), intent(in):: xyr_RadSFlux (0:imax-1, 1:jmax, 0:kmax)
   260                                ! û () եå.
   261                                ! Shortwave (insolation) flux
   262      real(DP), intent(in):: r_Height                       (0:kmax)
   263                                ! $ \hat{p} $ .  (Ⱦ٥).
   264                                ! Air pressure (half level)
   265      real(DP), intent(in):: xyz_Dens     (0:imax-1, 1:jmax, 1:kmax)
   266      real(DP), intent(out):: xyz_DTempDtRadL (0:imax-1, 1:jmax, 1:kmax)
   267                                ! ĹȲǮΨ.
   268                                ! Temperature tendency with longwave
   269      real(DP), intent(out):: xyz_DTempDtRadS (0:imax-1, 1:jmax, 1:kmax)
   270                                ! ûȲǮΨ.
   271                                ! Temperature tendency with shortwave
   272  
   273      ! ѿ
   274      ! Work variables
   275      !
   276      integer:: k               ! ľ˲ DO 롼Ѻѿ
   277                                ! Work variables for DO loop in vertical direction
   278  
   279      ! ¹ʸ ; Executable statement
   280      !
   281  
   282      ! ǧ
   283      ! Initialization check
   284      !
   285      if ( .not. rad_utils_inited ) then
   286        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   287      end if
   288  
   289  
   290      ! ׻ַ¬
   291      ! Start measurement of computation time
   292      !
   293      call TimesetClockStart( module_name )
   294  
   295  
   296      ! Ψα黻
   297      ! Calculate radiation cooling rate
   298      !
   299      do k = 1, kmax
   300        xyz_DTempDtRadL(:,:,k) = &
     .        D1 = 1.D0/(r_height(k)-r_height(k-1))                             
     .        D2 = 1.D0/(r_height(k)-r_height(k-1))                             
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t131 = 1, jmax*imax                                            
     .           xyz_dtempdtradl(t131-1,1,k) = -(xyr_radlflux(t131-1,1,k)-      
     .       1      xyr_radlflux(t131-1,1,k-1))*D1/(cpdry*xyz_dens(t131-1,1,k)) 
     .           xyz_dtempdtrads(t131-1,1,k) = -(xyr_radsflux(t131-1,1,k)-      
     .       1      xyr_radsflux(t131-1,1,k-1))*D2/(cpdry*xyz_dens(t131-1,1,k)) 
     .        end do                                                            
   301          &   - ( xyr_RadLFlux(:,:,k) - xyr_RadLFlux(:,:,k-1) ) &
   302          &   / (   r_Height      (k) -   r_Height      (k-1) ) &
   303          &   / ( CpDry * xyz_Dens(:,:,k) )
   304  
   305        xyz_DTempDtRadS(:,:,k) = &
   306          &   - ( xyr_RadSFlux(:,:,k) - xyr_RadSFlux(:,:,k-1) ) &
   307          &   / (   r_Height      (k) -   r_Height      (k-1) ) &
   308          &   / ( CpDry * xyz_Dens(:,:,k) )
   309      end do
   310  
   311  
   312      ! ҥȥǡ
   313      ! History data output
   314      !
   315      call HistoryAutoPut( TimeN, 'DTempDtRadL' , xyz_DTempDtRadL )
   316      call HistoryAutoPut( TimeN, 'DTempDtRadS' , xyz_DTempDtRadS )
   317  
   318  
   319      ! ׻ַ¬
   320      ! Pause measurement of computation time
   321      !
   322      call TimesetClockStop( module_name )
   323  
   324    end subroutine RadDTempDtforNHM
   325  
   326    !--------------------------------------------------------------------------------------
   327  
   328    subroutine RadDTempDtforNHM2DWrapper(             &
   329      & xr_RadLFlux, xr_RadSFlux, r_Height, xz_Dens,  & ! (in)
   330      & xz_DTempDtRadL, xz_DTempDtRadS                & ! (out)
   331      & )
   332      !
   333      ! ͤˤ벹ѲΨ׻ޤ.
   334      !
   335      ! Temperature tendency with radiation is calculated.
   336      !
   337  
   338      ! ⥸塼 ; USE statements
   339      !
   340  
   341      ! ʸ ; Declaration statements
   342      !
   343      implicit none
   344      real(DP), intent(in):: xr_RadLFlux (0:imax-1, 0:kmax)
   345                                ! Ĺȥեå.
   346                                ! Longwave flux
   347      real(DP), intent(in):: xr_RadSFlux (0:imax-1, 0:kmax)
   348                                ! û () եå.
   349                                ! Shortwave (insolation) flux
   350      real(DP), intent(in):: r_Height    (0:kmax)
   351                                ! $ \hat{p} $ .  (Ⱦ٥).
   352                                ! Air pressure (half level)
   353      real(DP), intent(in):: xz_Dens     (0:imax-1, 1:kmax)
   354      real(DP), intent(out):: xz_DTempDtRadL (0:imax-1, 1:kmax)
   355                                ! ĹȲǮΨ.
   356                                ! Temperature tendency with longwave
   357      real(DP), intent(out):: xz_DTempDtRadS (0:imax-1, 1:kmax)
   358                                ! ûȲǮΨ.
   359                                ! Temperature tendency with shortwave
   360  
   361      ! ѿ
   362      ! Work variables
   363      !
   364      real(DP) :: xyr_RadLFlux   (0:imax-1, 1:jmax, 0:kmax)
   365      real(DP) :: xyr_RadSFlux   (0:imax-1, 1:jmax, 0:kmax)
   366      real(DP) :: xyz_Dens       (0:imax-1, 1:jmax, 1:kmax)
   367      real(DP) :: xyz_DTempDtRadL(0:imax-1, 1:jmax, 1:kmax)
   368      real(DP) :: xyz_DTempDtRadS(0:imax-1, 1:jmax, 1:kmax)
   369  
   370  
   371      ! ¹ʸ ; Executable statement
   372      !
   373  
   374      ! ǧ
   375      ! Initialization check
   376      !
   377      if ( .not. rad_utils_inited ) then
   378        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   379      end if
   380  
   381  
   382      xyr_RadLFlux(:,1,:) = xr_RadLFlux(:,:)
     .        if (xyr_radlflux.DSC.U3 + 1 .gt. 0) then                          
     .           J1 = and(xyr_radlflux.DSC.U3 + 1,1)                            
     .  !CDIR    NODEP                                                          
     .           do t138 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t140 = 1, xyr_radlflux.DSC.U1 + 1                        
     .                 xyr_radlflux(t140-1,1,t138-1)=xr_radlflux(t140-1,t138-1) 
     .                 xyr_radsflux(t140-1,1,t138-1)=xr_radsflux(t140-1,t138-1) 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t138 = J1 + 1, xyr_radlflux.DSC.U3 + 1, 2                   
     .  !CDIR       NODEP                                                       
     .              do t140 = 1, xyr_radlflux.DSC.U1 + 1                        
     .                 xyr_radlflux(t140-1,1,t138-1)=xr_radlflux(t140-1,t138-1) 
     .                 xyr_radlflux(t140-1,1,t138) = xr_radlflux(t140-1,t138)   
     .                 xyr_radsflux(t140-1,1,t138-1)=xr_radsflux(t140-1,t138-1) 
     .                 xyr_radsflux(t140-1,1,t138) = xr_radsflux(t140-1,t138)   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   383      xyr_RadSFlux(:,1,:) = xr_RadSFlux(:,:)
   384      xyz_Dens    (:,1,:) = xz_Dens    (:,:)
     .        if (xyz_dens.DSC.U3 .gt. 0) then                                  
     .           J2 = and(xyz_dens.DSC.U3,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t150 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t152 = 1, xyz_dens.DSC.U1 + 1                            
     .                 xyz_dens(t152-1,1,t150) = xz_dens(t152-1,t150)           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t150 = J2 + 1, xyz_dens.DSC.U3, 4                           
     .  !CDIR       NODEP                                                       
     .              do t152 = 1, xyz_dens.DSC.U1 + 1                            
     .                 xyz_dens(t152-1,1,t150) = xz_dens(t152-1,t150)           
     .                 xyz_dens(t152-1,1,t150+1) = xz_dens(t152-1,t150+1)       
     .                 xyz_dens(t152-1,1,t150+2) = xz_dens(t152-1,t150+2)       
     .                 xyz_dens(t152-1,1,t150+3) = xz_dens(t152-1,t150+3)       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   385  
   386      call RadDTempDtforNHM(                              &
   387        & xyr_RadLFlux, xyr_RadSFlux, r_Height, xyz_Dens, & ! (in)
   388        & xyz_DTempDtRadL, xyz_DTempDtRadS                & ! (out)
   389        & )
   390  
   391      xz_DTempDtRadL(:,:) = xyz_DTempDtRadL(:,1,:)
     .        if (kmax .gt. 0) then                                             
     .           J3 = and(kmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t158 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t160 = 1, imax                                           
     .                 xz_dtempdtradl(t160-1,t158) = xyz_dtempdtradl(t160-1,1,  
     .       1            t158)                                                 
     .                 xz_dtempdtrads(t160-1,t158) = xyz_dtempdtrads(t160-1,1,  
     .       1            t158)                                                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t158 = J3 + 1, kmax, 2                                      
     .  !CDIR       NODEP                                                       
     .              do t160 = 1, imax                                           
     .                 xz_dtempdtradl(t160-1,t158) = xyz_dtempdtradl(t160-1,1,  
     .       1            t158)                                                 
     .                 xz_dtempdtradl(t160-1,t158+1) = xyz_dtempdtradl(t160-1,1,
     .       1            t158+1)                                               
     .                 xz_dtempdtrads(t160-1,t158) = xyz_dtempdtrads(t160-1,1,  
     .       1            t158)                                                 
     .                 xz_dtempdtrads(t160-1,t158+1) = xyz_dtempdtrads(t160-1,1,
     .       1            t158+1)                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   392      xz_DTempDtRadS(:,:) = xyz_DTempDtRadS(:,1,:)
   393  
   394  
   395    end subroutine RadDTempDtforNHM2DWrapper
   396  
   397    !-------------------------------------------------------------------
   398  
   399    subroutine RadFluxOutput(                          &
   400      & xyr_RadSUwFlux, xyr_RadSDwFlux,                & ! (in)
   401      & xyr_RadLUwFlux, xyr_RadLDwFlux,                & ! (in)
   402      & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux,        & ! (in)
   403      & xy_DSurfTempDt, xyz_DTempDt                    & ! (in)
   404      & )
   405      !
   406      ! ͥեå (xyr_RadSFlux, xyr_RadLFlux)
   407      ! ˤĤ, ¾ΰѤ, ϤԤ.
   408      !
   409      ! Radiation fluxes (xyr_RadSFlux, xyr_RadLFlux) are
   410      ! corrected by using other arguments, and the corrected values are output.
   411      !
   412  
   413      ! ⥸塼 ; USE statements
   414      !
   415  
   416      ! 
   417      ! Time control
   418      !
   419      use timeset, only: &
   420        & DelTime, &            ! $ \Delta t $ [s]
   421        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   422        & TimesetClockStart, TimesetClockStop
   423  
   424      ! ҥȥǡ
   425      ! History data output
   426      !
   427      use gtool_historyauto, only: HistoryAutoPut
   428  
   429      ! ʸ ; Declaration statements
   430      !
   431      implicit none
   432      real(DP), intent(in):: xyr_RadSUwFlux  (0:imax-1, 1:jmax, 0:kmax)
   433                                ! û () եå.
   434                                ! Upward shortwave (insolation) flux
   435      real(DP), intent(in):: xyr_RadSDwFlux  (0:imax-1, 1:jmax, 0:kmax)
   436                                ! û () եå.
   437                                ! Downward shortwave (insolation) flux
   438  
   439      real(DP), intent(in):: xyr_RadLUwFlux    (0:imax-1, 1:jmax, 0:kmax)
   440                                ! Ĺȥեå.
   441                                ! Upward longwave flux
   442      real(DP), intent(in):: xyr_RadLDwFlux    (0:imax-1, 1:jmax, 0:kmax)
   443                                ! Ĺȥեå.
   444                                ! Downward longwave flux
   445      real(DP), intent(in):: xyra_DelRadLUwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   446                                ! ĹɽѲ.
   447                                !
   448      real(DP), intent(in):: xyra_DelRadLDwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   449                                ! ĹɽѲ.
   450                                !
   451  
   452      real(DP), intent(in):: xy_DSurfTempDt  (0:imax-1, 1:jmax)
   453                                ! ɽ̲ѲΨ.
   454                                ! Surface temperature tendency
   455      real(DP), intent(in):: xyz_DTempDt     (0:imax-1, 1:jmax, 1:kmax)
   456                                ! $ \DP{T}{t} $ . Ѳ (K s-1)
   457                                ! Temperature tendency (K s-1)
   458  
   459      ! ϤΤκѿ
   460      ! Work variables for output
   461      !
   462      real(DP):: xyr_RadSFlux    (0:imax-1, 1:jmax, 0:kmax)
   463                                ! û () եå.
   464                                ! Shortwave (insolation) flux
   465      real(DP):: xyr_RadLFlux    (0:imax-1, 1:jmax, 0:kmax)
   466                                ! Ĺȥեå.
   467                                ! Longwave flux
   468      real(DP):: xyra_DelRadLFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   469                                ! ĹɽѲ.
   470                                ! Surface temperature tendency with longwave
   471      real(DP):: xyr_RadLUwFluxCor(0:imax-1, 1:jmax, 0:kmax)
   472                                ! 줿Ĺȥեå.
   473                                ! Corrected longwave flux
   474      real(DP):: xyr_RadLDwFluxCor(0:imax-1, 1:jmax, 0:kmax)
   475                                ! 줿Ĺȥեå.
   476                                ! Corrected longwave flux
   477      real(DP):: xyr_RadLFluxCor  (0:imax-1, 1:jmax, 0:kmax)
   478                                ! 줿Ĺȥեå.
   479                                ! Corrected longwave flux
   480  
   481      ! ѿ
   482      ! Work variables
   483      !
   484      integer:: k               ! ľ˲ DO 롼Ѻѿ
   485                                ! Work variables for DO loop in vertical direction
   486      ! ¹ʸ ; Executable statement
   487      !
   488  
   489      ! ǧ
   490      ! Initialization check
   491      !
   492      if ( .not. rad_utils_inited ) then
   493        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   494      end if
   495  
   496  
   497      ! ׻ַ¬
   498      ! Start measurement of computation time
   499      !
   500      call TimesetClockStart( module_name )
   501  
   502  
   503      xyr_RadSFlux     = xyr_RadSUwFlux     - xyr_RadSDwFlux
     .        if (xyr_radsuwflux.DSC.U2 .gt. 0) then                            
     .           J1 = and(xyr_radsuwflux.DSC.U2,1)                              
     .  !CDIR    NODEP                                                          
     .           do t440 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t442 = 1, xyr_radsuwflux.DSC.U1 + 1                      
     .                 xyr_radsflux(t442-1,t440,t438) = xyr_radsuwflux(t442-1,  
     .       1            t440,t438) - xyr_radsdwflux(t442-1,t440,t438)         
     .                 xyr_radlflux(t442-1,t440,t438) = xyr_radluwflux(t442-1,  
     .       1            t440,t438) - xyr_radldwflux(t442-1,t440,t438)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t440 = J1 + 1, xyr_radsuwflux.DSC.U2, 2                     
     .  !CDIR       NODEP                                                       
     .              do t442 = 1, xyr_radsuwflux.DSC.U1 + 1                      
     .                 xyr_radsflux(t442-1,t440,t438) = xyr_radsuwflux(t442-1,  
     .       1            t440,t438) - xyr_radsdwflux(t442-1,t440,t438)         
     .                 xyr_radsflux(t442-1,t440+1,t438) = xyr_radsuwflux(t442-1,
     .       1            t440+1,t438) - xyr_radsdwflux(t442-1,t440+1,t438)     
     .                 xyr_radlflux(t442-1,t440,t438) = xyr_radluwflux(t442-1,  
     .       1            t440,t438) - xyr_radldwflux(t442-1,t440,t438)         
     .                 xyr_radlflux(t442-1,t440+1,t438) = xyr_radluwflux(t442-1,
     .       1            t440+1,t438) - xyr_radldwflux(t442-1,t440+1,t438)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   504      xyr_RadLFlux     = xyr_RadLUwFlux     - xyr_RadLDwFlux
   505      xyra_DelRadLFlux = xyra_DelRadLUwFlux - xyra_DelRadLDwFlux
     .  !CDIR NODEP                                                             
     .        do t464 = 1, kmax + 1                                             
     .           if (jmax .gt. 0) then                                          
     .              J2 = and(jmax,1)                                            
     .  !CDIR       NODEP                                                       
     .              do t466 = 1, J2                                             
     .  !CDIR          NODEP                                                    
     .                 do t468 = 1, imax                                        
     .                    xyra_delradlflux(t468-1,t466,t464-1,0) =              
     .       1               xyra_delradluwflux(t468-1,t466,t464-1,0) -         
     .       2               xyra_delradldwflux(t468-1,t466,t464-1,0)           
     .                 end do                                                   
     .              end do                                                      
     .  !CDIR       NODEP                                                       
     .              do t466 = J2 + 1, jmax, 2                                   
     .  !CDIR          NODEP                                                    
     .                 do t468 = 1, imax                                        
     .                    xyra_delradlflux(t468-1,t466,t464-1,0) =              
     .       1               xyra_delradluwflux(t468-1,t466,t464-1,0) -         
     .       2               xyra_delradldwflux(t468-1,t466,t464-1,0)           
     .                    xyra_delradlflux(t468-1,t466+1,t464-1,0) =            
     .       1               xyra_delradluwflux(t468-1,t466+1,t464-1,0) -       
     .       2               xyra_delradldwflux(t468-1,t466+1,t464-1,0)         
     .                    xyra_delradlflux(t468-1,t466,t464-1,1) =              
     .       1               xyra_delradluwflux(t468-1,t466,t464-1,1) -         
     .       2               xyra_delradldwflux(t468-1,t466,t464-1,1)           
     .                 end do                                                   
     .              end do                                                      
     .           endif                                                          
     .        end do                                                            
   506  
   507  
   508      ! Ĺȥեå ( ɽեåʬ )
   509      ! Correct longwave flux ( amount of surface flux )
   510      !
   511      ! Lines commented out below will be deleted soon (yot, 2010/10/31).
   512  !!$    do k = 0, kmax
   513  !!$      xyr_RadLFluxCor (:,:,k) = &
   514  !!$        &     xyr_RadLFlux (:,:,k) &
   515  !!$        &   + xyra_DelRadLFlux(:,:,k,0) * xy_DSurfTempDt (:,:) * DelTime
   516  !!$    end do
   517  !!$    do k = 0, kmax
   518  !!$      xyr_RadLFluxCor(:,:,k) = &
   519  !!$        &   xyr_RadLFlux(:,:,k) &
   520  !!$        & + (   xy_DSurfTempDt     * xyra_DelRadLFlux(:,:,k,0)   &
   521  !!$        &     + xyz_DTempDt(:,:,1) * xyra_DelRadLFlux(:,:,k,1) ) &
   522  !!$        &   * DelTime
   523  !!$    end do
   524      do k = 0, kmax
   525        xyr_RadLUwFluxCor(:,:,k) =                                   &
     .        if (xyr_radluwflux.DSC.U2 .gt. 0) then                            
     .           J3 = and(xyr_radluwflux.DSC.U2,1)                              
     .  !CDIR    NODEP                                                          
     .           do t482 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t484 = 1, xyr_radluwflux.DSC.U1 + 1                      
     .                 xyr_radluwfluxcor(t484-1,t482,k) = xyr_radluwflux(t484-1,
     .       1            t482,k) + (xy_dsurftempdt(t484-1,t482)*               
     .       2            xyra_delradluwflux(t484-1,t482,k,0)+xyz_dtempdt(t484-1
     .       3            ,t482,1)*xyra_delradluwflux(t484-1,t482,k,1))*deltime 
     .                 xyr_radldwfluxcor(t484-1,t482,k) = xyr_radldwflux(t484-1,
     .       1            t482,k) + (xy_dsurftempdt(t484-1,t482)*               
     .       2            xyra_delradldwflux(t484-1,t482,k,0)+xyz_dtempdt(t484-1
     .       3            ,t482,1)*xyra_delradldwflux(t484-1,t482,k,1))*deltime 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t482 = J3 + 1, xyr_radluwflux.DSC.U2, 2                     
     .  !CDIR       NODEP                                                       
     .              do t484 = 1, xyr_radluwflux.DSC.U1 + 1                      
     .                 xyr_radluwfluxcor(t484-1,t482,k) = xyr_radluwflux(t484-1,
     .       1            t482,k) + (xy_dsurftempdt(t484-1,t482)*               
     .       2            xyra_delradluwflux(t484-1,t482,k,0)+xyz_dtempdt(t484-1
     .       3            ,t482,1)*xyra_delradluwflux(t484-1,t482,k,1))*deltime 
     .                 xyr_radluwfluxcor(t484-1,t482+1,k) = xyr_radluwflux(t484-
     .       1            1,t482+1,k) + (xy_dsurftempdt(t484-1,t482+1)*         
     .       2            xyra_delradluwflux(t484-1,t482+1,k,0)+xyz_dtempdt(t484
     .       3            -1,t482+1,1)*xyra_delradluwflux(t484-1,t482+1,k,1))*  
     .       4            deltime                                               
     .                 xyr_radldwfluxcor(t484-1,t482,k) = xyr_radldwflux(t484-1,
     .       1            t482,k) + (xy_dsurftempdt(t484-1,t482)*               
     .       2            xyra_delradldwflux(t484-1,t482,k,0)+xyz_dtempdt(t484-1
     .       3            ,t482,1)*xyra_delradldwflux(t484-1,t482,k,1))*deltime 
     .                 xyr_radldwfluxcor(t484-1,t482+1,k) = xyr_radldwflux(t484-
     .       1            1,t482+1,k) + (xy_dsurftempdt(t484-1,t482+1)*         
     .       2            xyra_delradldwflux(t484-1,t482+1,k,0)+xyz_dtempdt(t484
     .       3            -1,t482+1,1)*xyra_delradldwflux(t484-1,t482+1,k,1))*  
     .       4            deltime                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   526          &   xyr_RadLUwFlux(:,:,k)                                  &
   527          & + (   xy_DSurfTempDt     * xyra_DelRadLUwFlux(:,:,k,0)   &
   528          &     + xyz_DTempDt(:,:,1) * xyra_DelRadLUwFlux(:,:,k,1) ) &
   529          &   * DelTime
   530        xyr_RadLDwFluxCor(:,:,k) =                                   &
   531          &   xyr_RadLDwFlux(:,:,k)                                  &
   532          & + (   xy_DSurfTempDt     * xyra_DelRadLDwFlux(:,:,k,0)   &
   533          &     + xyz_DTempDt(:,:,1) * xyra_DelRadLDwFlux(:,:,k,1) ) &
   534          &   * DelTime
   535      end do
   536      xyr_RadLFluxCor = xyr_RadLUwFluxCor - xyr_RadLDwFluxCor
     .        if (xyr_radluwfluxcor.DSC.U2 .gt. 0) then                         
     .           J4 = and(xyr_radluwfluxcor.DSC.U2,3)                           
     .  !CDIR    NODEP                                                          
     .           do t512 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t514 = 1, xyr_radluwfluxcor.DSC.U1 + 1                   
     .                 xyr_radlfluxcor(t514-1,t512,t510) = xyr_radluwfluxcor(   
     .       1            t514-1,t512,t510) - xyr_radldwfluxcor(t514-1,t512,t510
     .       2            )                                                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t512 = J4 + 1, xyr_radluwfluxcor.DSC.U2, 4                  
     .  !CDIR       NODEP                                                       
     .              do t514 = 1, xyr_radluwfluxcor.DSC.U1 + 1                   
     .                 xyr_radlfluxcor(t514-1,t512,t510) = xyr_radluwfluxcor(   
     .       1            t514-1,t512,t510) - xyr_radldwfluxcor(t514-1,t512,t510
     .       2            )                                                     
     .                 xyr_radlfluxcor(t514-1,t512+1,t510) = xyr_radluwfluxcor( 
     .       1            t514-1,t512+1,t510) - xyr_radldwfluxcor(t514-1,t512+1,
     .       2            t510)                                                 
     .                 xyr_radlfluxcor(t514-1,t512+2,t510) = xyr_radluwfluxcor( 
     .       1            t514-1,t512+2,t510) - xyr_radldwfluxcor(t514-1,t512+2,
     .       2            t510)                                                 
     .                 xyr_radlfluxcor(t514-1,t512+3,t510) = xyr_radluwfluxcor( 
     .       1            t514-1,t512+3,t510) - xyr_radldwfluxcor(t514-1,t512+3,
     .       2            t510)                                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   537  
   538  
   539      ! ҥȥǡ
   540      ! History data output
   541      !
   542      call HistoryAutoPut( TimeN, 'OLR', xyr_RadLFluxCor(:,:,kmax) )
   543      call HistoryAutoPut( TimeN, 'SLR', xyr_RadLFluxCor(:,:,0)    )
   544      call HistoryAutoPut( TimeN, 'OSR', xyr_RadSFlux   (:,:,kmax) )
   545      call HistoryAutoPut( TimeN, 'SSR', xyr_RadSFlux   (:,:,0)    )
   546      call HistoryAutoPut( TimeN, 'RadLUWFLX', xyr_RadLUwFluxCor )
   547      call HistoryAutoPut( TimeN, 'RadLDWFLX', xyr_RadLDwFluxCor )
   548      call HistoryAutoPut( TimeN, 'RadSUWFLX', xyr_RadSUwFlux    )
   549      call HistoryAutoPut( TimeN, 'RadSDWFLX', xyr_RadSDwFlux    )
   550  
   551  
   552      ! ҥȥǡ
   553      ! History data output
   554      !
   555      call HistoryAutoPut( TimeN, 'OLRB', xyr_RadLFlux(:,:,kmax) )
   556      call HistoryAutoPut( TimeN, 'SLRB', xyr_RadLFlux(:,:,0)    )
   557      call HistoryAutoPut( TimeN, 'OSRB', xyr_RadSFlux(:,:,kmax) )
   558      call HistoryAutoPut( TimeN, 'SSRB', xyr_RadSFlux(:,:,0)    )
   559      call HistoryAutoPut( TimeN, 'RadLUWFLXB', xyr_RadLUwFlux )
   560      call HistoryAutoPut( TimeN, 'RadLDWFLXB', xyr_RadLDwFlux )
   561      call HistoryAutoPut( TimeN, 'RadSUWFLXB', xyr_RadSUwFlux )
   562      call HistoryAutoPut( TimeN, 'RadSDWFLXB', xyr_RadSDwFlux )
   563  
   564  
   565      ! Ĺȥեå ( ɽեåʬ )
   566      ! Correct longwave flux ( amount of surface flux )
   567      !
   568      ! Lines commented out below will be deleted soon (yot, 2010/10/31).
   569  !!$    do k = 0, kmax
   570  !!$      xyr_RadLFluxCor (:,:,k) = &
   571  !!$        &     xyr_RadLFlux (:,:,k) &
   572  !!$        &   + xyra_DelRadLFlux(:,:,k,0) * xy_DSurfTempDt (:,:) * 2.0d0 * DelTime
   573  !!$    end do
   574  !!$    do k = 0, kmax
   575  !!$      xyr_RadLFluxCor(:,:,k) = &
   576  !!$        &   xyr_RadLFlux(:,:,k) &
   577  !!$        & + (   xy_DSurfTempDt     * xyra_DelRadLFlux(:,:,k,0)   &
   578  !!$        &     + xyz_DTempDt(:,:,1) * xyra_DelRadLFlux(:,:,k,1) ) &
   579  !!$        &   * 2.0_DP * DelTime
   580  !!$    end do
   581      do k = 0, kmax
   582        xyr_RadLUwFluxCor(:,:,k) =                                   &
     .        if (xyr_radluwflux.DSC.U2 .gt. 0) then                            
     .           J5 = and(xyr_radluwflux.DSC.U2,1)                              
     .  !CDIR    NODEP                                                          
     .           do t525 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t527 = 1, xyr_radluwflux.DSC.U1 + 1                      
     .                 xyr_radluwfluxcor(t527-1,t525,k) = xyr_radluwflux(t527-1,
     .       1            t525,k) + (xy_dsurftempdt(t527-1,t525)*               
     .       2            xyra_delradluwflux(t527-1,t525,k,0)+xyz_dtempdt(t527-1
     .       3            ,t525,1)*xyra_delradluwflux(t527-1,t525,k,1))*        
     .       4            2.00000000000000e+000*deltime                         
     .                 xyr_radldwfluxcor(t527-1,t525,k) = xyr_radldwflux(t527-1,
     .       1            t525,k) + (xy_dsurftempdt(t527-1,t525)*               
     .       2            xyra_delradldwflux(t527-1,t525,k,0)+xyz_dtempdt(t527-1
     .       3            ,t525,1)*xyra_delradldwflux(t527-1,t525,k,1))*        
     .       4            2.00000000000000e+000*deltime                         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t525 = J5 + 1, xyr_radluwflux.DSC.U2, 2                     
     .  !CDIR       NODEP                                                       
     .              do t527 = 1, xyr_radluwflux.DSC.U1 + 1                      
     .                 xyr_radluwfluxcor(t527-1,t525,k) = xyr_radluwflux(t527-1,
     .       1            t525,k) + (xy_dsurftempdt(t527-1,t525)*               
     .       2            xyra_delradluwflux(t527-1,t525,k,0)+xyz_dtempdt(t527-1
     .       3            ,t525,1)*xyra_delradluwflux(t527-1,t525,k,1))*        
     .       4            2.00000000000000e+000*deltime                         
     .                 xyr_radluwfluxcor(t527-1,t525+1,k) = xyr_radluwflux(t527-
     .       1            1,t525+1,k) + (xy_dsurftempdt(t527-1,t525+1)*         
     .       2            xyra_delradluwflux(t527-1,t525+1,k,0)+xyz_dtempdt(t527
     .       3            -1,t525+1,1)*xyra_delradluwflux(t527-1,t525+1,k,1))*  
     .       4            2.00000000000000e+000*deltime                         
     .                 xyr_radldwfluxcor(t527-1,t525,k) = xyr_radldwflux(t527-1,
     .       1            t525,k) + (xy_dsurftempdt(t527-1,t525)*               
     .       2            xyra_delradldwflux(t527-1,t525,k,0)+xyz_dtempdt(t527-1
     .       3            ,t525,1)*xyra_delradldwflux(t527-1,t525,k,1))*        
     .       4            2.00000000000000e+000*deltime                         
     .                 xyr_radldwfluxcor(t527-1,t525+1,k) = xyr_radldwflux(t527-
     .       1            1,t525+1,k) + (xy_dsurftempdt(t527-1,t525+1)*         
     .       2            xyra_delradldwflux(t527-1,t525+1,k,0)+xyz_dtempdt(t527
     .       3            -1,t525+1,1)*xyra_delradldwflux(t527-1,t525+1,k,1))*  
     .       4            2.00000000000000e+000*deltime                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   583          &   xyr_RadLUwFlux(:,:,k)                                  &
   584          & + (   xy_DSurfTempDt     * xyra_DelRadLUwFlux(:,:,k,0)   &
   585          &     + xyz_DTempDt(:,:,1) * xyra_DelRadLUwFlux(:,:,k,1) ) &
   586          &   * 2.0_DP * DelTime
   587        xyr_RadLDwFluxCor(:,:,k) =                                   &
   588          &   xyr_RadLDwFlux(:,:,k)                                  &
   589          & + (   xy_DSurfTempDt     * xyra_DelRadLDwFlux(:,:,k,0)   &
   590          &     + xyz_DTempDt(:,:,1) * xyra_DelRadLDwFlux(:,:,k,1) ) &
   591          &   * 2.0_DP * DelTime
   592      end do
   593      xyr_RadLFluxCor = xyr_RadLUwFluxCor - xyr_RadLDwFluxCor
     .        if (xyr_radluwfluxcor.DSC.U2 .gt. 0) then                         
     .           J6 = and(xyr_radluwfluxcor.DSC.U2,3)                           
     .  !CDIR    NODEP                                                          
     .           do t555 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t557 = 1, xyr_radluwfluxcor.DSC.U1 + 1                   
     .                 xyr_radlfluxcor(t557-1,t555,t553) = xyr_radluwfluxcor(   
     .       1            t557-1,t555,t553) - xyr_radldwfluxcor(t557-1,t555,t553
     .       2            )                                                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t555 = J6 + 1, xyr_radluwfluxcor.DSC.U2, 4                  
     .  !CDIR       NODEP                                                       
     .              do t557 = 1, xyr_radluwfluxcor.DSC.U1 + 1                   
     .                 xyr_radlfluxcor(t557-1,t555,t553) = xyr_radluwfluxcor(   
     .       1            t557-1,t555,t553) - xyr_radldwfluxcor(t557-1,t555,t553
     .       2            )                                                     
     .                 xyr_radlfluxcor(t557-1,t555+1,t553) = xyr_radluwfluxcor( 
     .       1            t557-1,t555+1,t553) - xyr_radldwfluxcor(t557-1,t555+1,
     .       2            t553)                                                 
     .                 xyr_radlfluxcor(t557-1,t555+2,t553) = xyr_radluwfluxcor( 
     .       1            t557-1,t555+2,t553) - xyr_radldwfluxcor(t557-1,t555+2,
     .       2            t553)                                                 
     .                 xyr_radlfluxcor(t557-1,t555+3,t553) = xyr_radluwfluxcor( 
     .       1            t557-1,t555+3,t553) - xyr_radldwfluxcor(t557-1,t555+3,
     .       2            t553)                                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   594  
   595  
   596      ! ҥȥǡ
   597      ! History data output
   598      !
   599      call HistoryAutoPut( TimeN, 'OLRA', xyr_RadLFluxCor(:,:,kmax) )
   600      call HistoryAutoPut( TimeN, 'SLRA', xyr_RadLFluxCor(:,:,0)    )
   601      call HistoryAutoPut( TimeN, 'OSRA', xyr_RadSFlux   (:,:,kmax) )
   602      call HistoryAutoPut( TimeN, 'SSRA', xyr_RadSFlux   (:,:,0)    )
   603      call HistoryAutoPut( TimeN, 'RadLUWFLXA', xyr_RadLUwFluxCor )
   604      call HistoryAutoPut( TimeN, 'RadLDWFLXA', xyr_RadLDwFluxCor )
   605      call HistoryAutoPut( TimeN, 'RadSUWFLXA', xyr_RadSUwFlux    )
   606      call HistoryAutoPut( TimeN, 'RadSDWFLXA', xyr_RadSDwFlux    )
   607  
   608  
   609      ! ׻ַ¬
   610      ! Pause measurement of computation time
   611      !
   612      call TimesetClockStop( module_name )
   613  
   614    end subroutine RadFluxOutput
   615  
   616    !-------------------------------------------------------------------
   617  
   618    subroutine RadUtilsInit
   619      !
   620      ! rad_utils ⥸塼νԤޤ.
   621      ! NAMELIST#rad_utils_nml ɤ߹ߤϤμ³ǹԤޤ.
   622      !
   623      ! "rad_utils" module is initialized.
   624      ! "NAMELIST#rad_utils_nml" is loaded in this procedure.
   625      !
   626  
   627      ! ⥸塼 ; USE statements
   628      !
   629  
   630      ! ʸ
   631      ! Character handling
   632      !
   633      use dc_string, only: toChar
   634  
   635      ! ե
   636      ! File I/O support
   637      !
   638      use dc_iounit, only: FileOpen
   639  
   640      ! ҥȥǡ
   641      ! History data output
   642      !
   643      use gtool_historyauto, only: HistoryAutoAddVariable
   644  
   645      ! NAMELIST եϤ˴ؤ桼ƥƥ
   646      ! Utilities for NAMELIST file input
   647      !
   648      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   649  
   650      ! ʸ ; Declaration statements
   651      !
   652  
   653      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   654                                ! Unit number for NAMELIST file open
   655      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   656                                ! IOSTAT of NAMELIST read
   657  
   658  
   659      ! NAMELIST ѿ
   660      ! NAMELIST group name
   661      !
   662  !!$    namelist /rad_utils_nml/ &
   663  !!$      & DiffFact
   664  !!$      & DelTimeLongValue, DelTimeLongUnit, &
   665  !!$      & DelTimeShortValue, DelTimeShortUnit, &
   666  !!$!
   667  !!$      & LongBandNum, &
   668  !!$      & LongAbsorpCoefQVap, LongAbsorpCoefDryAir, &
   669  !!$      & LongBandWeight, LongPathLengthFact, &
   670  !!$!
   671  !!$      & ShortBandNum, &
   672  !!$      & ShortAbsorpCoefQVap, ShortAbsorpCoefDryAir, &
   673  !!$      & ShortBandWeight, ShortSecScat, &
   674  !!$      & ShortAtmosAlbedo, &
   675  !!$!
   676  !!$      & RstInputFile, RstOutputFile
   677            !
   678            ! ǥեͤˤĤƤϽ³ "rad_utils#RadInit"
   679            ! Υɤ򻲾ȤΤ.
   680            !
   681            ! Refer to source codes in the initialization procedure
   682            ! "rad_utils#RadInit" for the default values.
   683            !
   684  
   685      ! ¹ʸ ; Executable statement
   686      !
   687  
   688      if ( rad_utils_inited ) return
   689  
   690  
   691      ! ǥեͤ
   692      ! Default values settings
   693      !
   694  
   695      ! NAMELIST ɤ߹
   696      ! NAMELIST is input
   697      !
   698  !!$    if ( trim(namelist_filename) /= '' ) then
   699  !!$      call FileOpen( unit_nml, &          ! (out)
   700  !!$        & namelist_filename, mode = 'r' ) ! (in)
   701  !!$
   702  !!$      rewind( unit_nml )
   703  !!$      read( unit_nml,                     & ! (in)
   704  !!$        & nml = rad_utils_nml,            & ! (out)
   705  !!$        & iostat = iostat_nml )             ! (out)
   706  !!$      close( unit_nml )
   707  !!$
   708  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   709  !!$    end if
   710  
   711  
   712      ! ҥȥǡϤΤΤؤѿϿ
   713      ! Register of variables for history data output
   714      !
   715      call HistoryAutoAddVariable( 'OLR', &
   716        & (/ 'lon ', 'lat ', 'time' /), &
   717        & 'outgoing longwave', 'W m-2' )
   718      call HistoryAutoAddVariable( 'SLR', &
   719        & (/ 'lon ', 'lat ', 'time' /), &
   720        & 'surface longwave', 'W m-2' )
   721      call HistoryAutoAddVariable( 'OSR', &
   722        & (/ 'lon ', 'lat ', 'time' /), &
   723        & 'outgoing shortwave', 'W m-2' )
   724      call HistoryAutoAddVariable( 'SSR', &
   725        & (/ 'lon ', 'lat ', 'time' /), &
   726        & 'surface shortwave', 'W m-2' )
   727  
   728      call HistoryAutoAddVariable( 'RadLUWFLX', &
   729        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   730        & 'upward longwave net flux', 'W m-2' )
   731      call HistoryAutoAddVariable( 'RadLDWFLX', &
   732        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   733        & 'downward longwave net flux', 'W m-2' )
   734      call HistoryAutoAddVariable( 'RadSUWFLX', &
   735        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   736        & 'upward shortwave net flux', 'W m-2' )
   737      call HistoryAutoAddVariable( 'RadSDWFLX', &
   738        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   739        & 'downward shortwave net flux', 'W m-2' )
   740  
   741      call HistoryAutoAddVariable( 'OLRB', &
   742        & (/ 'lon ', 'lat ', 'time' /), &
   743        & 'outgoing longwave', 'W m-2' )
   744      call HistoryAutoAddVariable( 'SLRB', &
   745        & (/ 'lon ', 'lat ', 'time' /), &
   746        & 'surface longwave', 'W m-2' )
   747      call HistoryAutoAddVariable( 'OSRB', &
   748        & (/ 'lon ', 'lat ', 'time' /), &
   749        & 'outgoing shortwave', 'W m-2' )
   750      call HistoryAutoAddVariable( 'SSRB', &
   751        & (/ 'lon ', 'lat ', 'time' /), &
   752        & 'surface shortwave', 'W m-2' )
   753  
   754      call HistoryAutoAddVariable( 'RadLUWFLXB', &
   755        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   756        & 'upward longwave net flux', 'W m-2' )
   757      call HistoryAutoAddVariable( 'RadLDWFLXB', &
   758        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   759        & 'downward longwave net flux', 'W m-2' )
   760      call HistoryAutoAddVariable( 'RadSUWFLXB', &
   761        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   762        & 'upward shortwave net flux', 'W m-2' )
   763      call HistoryAutoAddVariable( 'RadSDWFLXB', &
   764        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   765        & 'downward shortwave net flux', 'W m-2' )
   766  
   767      call HistoryAutoAddVariable( 'OLRA', &
   768        & (/ 'lon ', 'lat ', 'time' /), &
   769        & 'outgoing longwave', 'W m-2' )
   770      call HistoryAutoAddVariable( 'SLRA', &
   771        & (/ 'lon ', 'lat ', 'time' /), &
   772        & 'surface longwave', 'W m-2' )
   773      call HistoryAutoAddVariable( 'OSRA', &
   774        & (/ 'lon ', 'lat ', 'time' /), &
   775        & 'outgoing shortwave', 'W m-2' )
   776      call HistoryAutoAddVariable( 'SSRA', &
   777        & (/ 'lon ', 'lat ', 'time' /), &
   778        & 'surface shortwave', 'W m-2' )
   779  
   780      call HistoryAutoAddVariable( 'RadLUWFLXA', &
   781        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   782        & 'upward longwave net flux', 'W m-2' )
   783      call HistoryAutoAddVariable( 'RadLDWFLXA', &
   784        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   785        & 'downward longwave net flux', 'W m-2' )
   786      call HistoryAutoAddVariable( 'RadSUWFLXA', &
   787        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   788        & 'upward shortwave net flux', 'W m-2' )
   789      call HistoryAutoAddVariable( 'RadSDWFLXA', &
   790        & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   791        & 'downward shortwave net flux', 'W m-2' )
   792  
   793      call HistoryAutoAddVariable( 'DTempDtRadL', &
   794        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   795        & 'long wave radiative heating rate', 'K s-1' )
   796      call HistoryAutoAddVariable( 'DTempDtRadS', &
   797        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   798        & 'short wave radiative heating rate', 'K s-1' )
   799  
   800  
   801      !  ; Print
   802      !
   803      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   804  !!$    call MessageNotify( 'M', module_name, 'DiffFact = %f', d = (/ DiffFact /) )
   805      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   806  
   807      rad_utils_inited = .true.
   808  
   809    end subroutine RadUtilsInit
   810  
   811    !-------------------------------------------------------------------
   812  
   813  end module rad_utils
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:09 2012
FILE NAME: rad_utils.f90
PROGRAM NAME: rad_utils
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ʹϢ롼
     2:            !
     3:            != Routines for radiation calculation
     4:            !
     5:            ! Authors::   Yasuhiro MORIKAWA, Yukiko YAMADA, Satoshi NODA, Yoshiyuki O. TAKAHASHI
     6:            ! Version::   $Id: rad_utils.f90,v 1.6 2012-02-01 05:19:54 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module rad_utils
    13:              !
    14:              != ʹϢ롼
    15:              !
    16:              != Routines for radiation calculation
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! 
    21:              !
    22:              ! 
    23:              !
    24:              !== Procedures List
    25:              !
    26:              ! RadDTempDt        :: ͥեåˤ벹Ѳη׻
    27:              ! RadFluxOutput     :: ͥեåν
    28:              ! ------------            :: ------------
    29:              ! RadDTempDt        :: Calculate temperature tendency with radiation flux
    30:              ! RadFluxOutput     :: Output radiation fluxes
    31:              !
    32:              !== NAMELIST
    33:              !
    34:              ! NAMELIST#rad_utils_nml
    35:              !
    36:            
    37:              ! ⥸塼 ; USE statements
    38:              !
    39:            
    40:              ! ̷ѥ᥿
    41:              ! Kind type parameter
    42:              !
    43:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    44:                &                 STRING, &  ! ʸ.       Strings. 
    45:                &                 TOKEN      ! .   Keywords. 
    46:            
    47:              ! ʪ
    48:              ! Physical and mathematical constants settings
    49:              !
    50:              use constants0, only: &
    51:                & PI, &                 ! $ \pi $.
    52:                                        ! ߼Ψ. Circular constant
    53:                & StB
    54:                                        ! $ \sigma_{SB} $ .
    55:                                        ! ƥեܥĥޥ.
    56:                                        ! Stefan-Boltzmann constant
    57:            
    58:              ! ʪ
    59:              ! Physical constants settings
    60:              !
    61:              use constants, only: &
    62:                & Grav, &
    63:                                        ! $ g $ [m s-2]. 
    64:                                        ! ϲ®. 
    65:                                        ! Gravitational acceleration
    66:                & CpDry
    67:                                        ! $ C_p $ [J kg-1 K-1]. 
    68:                                        ! 絤갵Ǯ. 
    69:                                        ! Specific heat of air at constant pressure
    70:            
    71:            
    72:              ! ʻ
    73:              ! Grid points settings
    74:              !
    75:              use gridset, only: imax, & ! ٳʻ. 
    76:                                         ! Number of grid points in longitude
    77:                &                jmax, & ! ٳʻ. 
    78:                                         ! Number of grid points in latitude
    79:                &                kmax    ! ľؿ. 
    80:                                         ! Number of vertical level
    81:            
    82:              ! å
    83:              ! Message output
    84:              !
    85:              use dc_message, only: MessageNotify
    86:            
    87:              ! ʸ ; Declaration statements
    88:              !
    89:              implicit none
    90:              private
    91:            
    92:              ! ³
    93:              ! Public procedure
    94:              !
    95:              public :: RadDTempDt
    96:              public :: RadDTempDtforNHM2DWrapper
    97:              public :: RadFluxOutput
    98:              public :: RadUtilsInit
    99:            
   100:            
   101:              ! ѿ
   102:              ! Public variables
   103:              !
   104:              logical, save, public:: rad_utils_inited = .false.
   105:                                          ! ե饰. 
   106:                                          ! Initialization flag
   107:            
   108:            
   109:              ! ѿ
   110:              ! Private variables
   111:              !
   112:            
   113:            
   114:              character(*), parameter:: module_name = 'rad_utils'
   115:                                          ! ⥸塼̾. 
   116:                                          ! Module name
   117:              character(*), parameter:: version = &
   118:                & '$Name: dcpam5-20120921 $' // &
   119:                & '$Id: rad_utils.f90,v 1.6 2012-02-01 05:19:54 yot Exp $'
   120:                                          ! ⥸塼ΥС
   121:                                          ! Module version
   122:            
   123:            contains
   124:            
   125:              !--------------------------------------------------------------------------------------
   126:            
   127:              subroutine RadDTempDt( &
   128:                & xyr_RadLFlux, xyr_RadSFlux, xyr_Press, & ! (in)
   129:                & xyz_DTempDtRadL, xyz_DTempDtRadS &       ! (out)
   130:                & )
   131:                !
   132:                ! ͤˤ벹ѲΨ׻ޤ. 
   133:                ! 
   134:                ! Temperature tendency with radiation is calculated. 
   135:                !
   136:            
   137:                ! ⥸塼 ; USE statements
   138:                !
   139:            
   140:                ! 
   141:                ! Time control
   142:                !
   143:                use timeset, only: &
   144:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   145:                  & TimesetClockStart, TimesetClockStop
   146:            
   147:                ! ҥȥǡ
   148:                ! History data output
   149:                !
   150:                use gtool_historyauto, only: HistoryAutoPut
   151:            
   152:            
   153:                ! ʸ ; Declaration statements
   154:                !
   155:                implicit none
   156:                real(DP), intent(in):: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   157:                                          ! Ĺȥեå. 
   158:                                          ! Longwave flux
   159:                real(DP), intent(in):: xyr_RadSFlux (0:imax-1, 1:jmax, 0:kmax)
   160:                                          ! û () եå. 
   161:                                          ! Shortwave (insolation) flux
   162:                real(DP), intent(in):: xyr_Press    (0:imax-1, 1:jmax, 0:kmax)
   163:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   164:                                          ! Air pressure (half level)
   165:                real(DP), intent(out):: xyz_DTempDtRadL (0:imax-1, 1:jmax, 1:kmax)
   166:                                          ! ĹȲǮΨ. 
   167:                                          ! Temperature tendency with longwave
   168:                real(DP), intent(out):: xyz_DTempDtRadS (0:imax-1, 1:jmax, 1:kmax)
   169:                                          ! ûȲǮΨ. 
   170:                                          ! Temperature tendency with shortwave
   171:            
   172:                ! ѿ
   173:                ! Work variables
   174:                !
   175:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   176:                                          ! Work variables for DO loop in vertical direction
   177:            
   178:                ! ¹ʸ ; Executable statement
   179:                !
   180:            
   181:                ! ǧ
   182:                ! Initialization check
   183:                !
   184:                if ( .not. rad_utils_inited ) then
   185:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   186:                end if
   187:            
   188:            
   189:                ! ׻ַ¬
   190:                ! Start measurement of computation time
   191:                !
   192:                call TimesetClockStart( module_name )
   193:            
   194:            
   195:                ! Ψα黻
   196:                ! Calculate radiation cooling rate
   197:                !
   198: W------>       do k = 1, kmax
   199: |**---->         xyz_DTempDtRadL(:,:,k) = &
   200: |||                & (     xyr_RadLFlux(:,:,k-1) - xyr_RadLFlux(:,:,k) ) &
   201: |||                &   / ( xyr_Press(:,:,k-1)    - xyr_Press(:,:,k) ) &
   202: |||                &   / CpDry * Grav
   203: |||        
   204: |**----          xyz_DTempDtRadS(:,:,k) = &
   205: |                  & (     xyr_RadSFlux(:,:,k-1) - xyr_RadSFlux(:,:,k) ) &
   206: |                  &   / ( xyr_Press(:,:,k-1)    - xyr_Press(:,:,k) ) &
   207: |                  &   / CpDry * Grav
   208: W------        end do
   209:            
   210:            
   211:                ! ҥȥǡ
   212:                ! History data output
   213:                !
   214:                call HistoryAutoPut( TimeN, 'DTempDtRadL' , xyz_DTempDtRadL )
   215:                call HistoryAutoPut( TimeN, 'DTempDtRadS' , xyz_DTempDtRadS )
   216:            
   217:            
   218:                ! ׻ַ¬
   219:                ! Pause measurement of computation time
   220:                !
   221:                call TimesetClockStop( module_name )
   222:            
   223:              end subroutine RadDTempDt
   224:            
   225:              !--------------------------------------------------------------------------------------
   226:            
   227:              subroutine RadDTempDtforNHM(                        &
   228:                & xyr_RadLFlux, xyr_RadSFlux, r_Height, xyz_Dens, & ! (in)
   229:                & xyz_DTempDtRadL, xyz_DTempDtRadS                & ! (out)
   230:                & )
   231:                !
   232:                ! ϳطϤˤͤˤ벹ѲΨ׻ޤ. 
   233:                ! 
   234:                ! Temperature tendency with radiation is calculated for non-hydrodynamic system. 
   235:                !
   236:            
   237:                ! ⥸塼 ; USE statements
   238:                !
   239:            
   240:                ! 
   241:                ! Time control
   242:                !
   243:                use timeset, only: &
   244:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   245:                  & TimesetClockStart, TimesetClockStop
   246:            
   247:                ! ҥȥǡ
   248:                ! History data output
   249:                !
   250:                use gtool_historyauto, only: HistoryAutoPut
   251:            
   252:            
   253:                ! ʸ ; Declaration statements
   254:                !
   255:                implicit none
   256:                real(DP), intent(in):: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   257:                                          ! Ĺȥեå. 
   258:                                          ! Longwave flux
   259:                real(DP), intent(in):: xyr_RadSFlux (0:imax-1, 1:jmax, 0:kmax)
   260:                                          ! û () եå. 
   261:                                          ! Shortwave (insolation) flux
   262:                real(DP), intent(in):: r_Height                       (0:kmax)
   263:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   264:                                          ! Air pressure (half level)
   265:                real(DP), intent(in):: xyz_Dens     (0:imax-1, 1:jmax, 1:kmax)
   266:                real(DP), intent(out):: xyz_DTempDtRadL (0:imax-1, 1:jmax, 1:kmax)
   267:                                          ! ĹȲǮΨ. 
   268:                                          ! Temperature tendency with longwave
   269:                real(DP), intent(out):: xyz_DTempDtRadS (0:imax-1, 1:jmax, 1:kmax)
   270:                                          ! ûȲǮΨ. 
   271:                                          ! Temperature tendency with shortwave
   272:            
   273:                ! ѿ
   274:                ! Work variables
   275:                !
   276:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   277:                                          ! Work variables for DO loop in vertical direction
   278:            
   279:                ! ¹ʸ ; Executable statement
   280:                !
   281:            
   282:                ! ǧ
   283:                ! Initialization check
   284:                !
   285:                if ( .not. rad_utils_inited ) then
   286:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   287:                end if
   288:            
   289:            
   290:                ! ׻ַ¬
   291:                ! Start measurement of computation time
   292:                !
   293:                call TimesetClockStart( module_name )
   294:            
   295:            
   296:                ! Ψα黻
   297:                ! Calculate radiation cooling rate
   298:                !
   299: +------>       do k = 1, kmax
   300: |*W---->         xyz_DTempDtRadL(:,:,k) = &
   301: |||                &   - ( xyr_RadLFlux(:,:,k) - xyr_RadLFlux(:,:,k-1) ) &
   302: |||                &   / (   r_Height      (k) -   r_Height      (k-1) ) &
   303: |||                &   / ( CpDry * xyz_Dens(:,:,k) )
   304: |||        
   305: |*W----          xyz_DTempDtRadS(:,:,k) = &
   306: |                  &   - ( xyr_RadSFlux(:,:,k) - xyr_RadSFlux(:,:,k-1) ) &
   307: |                  &   / (   r_Height      (k) -   r_Height      (k-1) ) &
   308: |                  &   / ( CpDry * xyz_Dens(:,:,k) )
   309: +------        end do
   310:            
   311:            
   312:                ! ҥȥǡ
   313:                ! History data output
   314:                !
   315:                call HistoryAutoPut( TimeN, 'DTempDtRadL' , xyz_DTempDtRadL )
   316:                call HistoryAutoPut( TimeN, 'DTempDtRadS' , xyz_DTempDtRadS )
   317:            
   318:            
   319:                ! ׻ַ¬
   320:                ! Pause measurement of computation time
   321:                !
   322:                call TimesetClockStop( module_name )
   323:            
   324:              end subroutine RadDTempDtforNHM
   325:            
   326:              !--------------------------------------------------------------------------------------
   327:            
   328:              subroutine RadDTempDtforNHM2DWrapper(             &
   329:                & xr_RadLFlux, xr_RadSFlux, r_Height, xz_Dens,  & ! (in)
   330:                & xz_DTempDtRadL, xz_DTempDtRadS                & ! (out)
   331:                & )
   332:                !
   333:                ! ͤˤ벹ѲΨ׻ޤ. 
   334:                ! 
   335:                ! Temperature tendency with radiation is calculated. 
   336:                !
   337:            
   338:                ! ⥸塼 ; USE statements
   339:                !
   340:            
   341:                ! ʸ ; Declaration statements
   342:                !
   343:                implicit none
   344:                real(DP), intent(in):: xr_RadLFlux (0:imax-1, 0:kmax)
   345:                                          ! Ĺȥեå. 
   346:                                          ! Longwave flux
   347:                real(DP), intent(in):: xr_RadSFlux (0:imax-1, 0:kmax)
   348:                                          ! û () եå. 
   349:                                          ! Shortwave (insolation) flux
   350:                real(DP), intent(in):: r_Height    (0:kmax)
   351:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   352:                                          ! Air pressure (half level)
   353:                real(DP), intent(in):: xz_Dens     (0:imax-1, 1:kmax)
   354:                real(DP), intent(out):: xz_DTempDtRadL (0:imax-1, 1:kmax)
   355:                                          ! ĹȲǮΨ. 
   356:                                          ! Temperature tendency with longwave
   357:                real(DP), intent(out):: xz_DTempDtRadS (0:imax-1, 1:kmax)
   358:                                          ! ûȲǮΨ. 
   359:                                          ! Temperature tendency with shortwave
   360:            
   361:                ! ѿ
   362:                ! Work variables
   363:                !
   364:                real(DP) :: xyr_RadLFlux   (0:imax-1, 1:jmax, 0:kmax)
   365:                real(DP) :: xyr_RadSFlux   (0:imax-1, 1:jmax, 0:kmax)
   366:                real(DP) :: xyz_Dens       (0:imax-1, 1:jmax, 1:kmax)
   367:                real(DP) :: xyz_DTempDtRadL(0:imax-1, 1:jmax, 1:kmax)
   368:                real(DP) :: xyz_DTempDtRadS(0:imax-1, 1:jmax, 1:kmax)
   369:            
   370:            
   371:                ! ¹ʸ ; Executable statement
   372:                !
   373:            
   374:                ! ǧ
   375:                ! Initialization check
   376:                !
   377:                if ( .not. rad_utils_inited ) then
   378:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   379:                end if
   380:            
   381:            
   382: *V----->       xyr_RadLFlux(:,1,:) = xr_RadLFlux(:,:)
   383: *V-----        xyr_RadSFlux(:,1,:) = xr_RadSFlux(:,:)
   384: +V=====        xyz_Dens    (:,1,:) = xz_Dens    (:,:)
   385:            
   386:                call RadDTempDtforNHM(                              &
   387:                  & xyr_RadLFlux, xyr_RadSFlux, r_Height, xyz_Dens, & ! (in)
   388:                  & xyz_DTempDtRadL, xyz_DTempDtRadS                & ! (out)
   389:                  & )
   390:            
   391: *V----->       xz_DTempDtRadL(:,:) = xyz_DTempDtRadL(:,1,:)
   392: *V-----        xz_DTempDtRadS(:,:) = xyz_DTempDtRadS(:,1,:)
   393:            
   394:            
   395:              end subroutine RadDTempDtforNHM2DWrapper
   396:            
   397:              !-------------------------------------------------------------------
   398:            
   399:              subroutine RadFluxOutput(                          &
   400:                & xyr_RadSUwFlux, xyr_RadSDwFlux,                & ! (in)
   401:                & xyr_RadLUwFlux, xyr_RadLDwFlux,                & ! (in)
   402:                & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux,        & ! (in)
   403:                & xy_DSurfTempDt, xyz_DTempDt                    & ! (in)
   404:                & )
   405:                !
   406:                ! ͥեå (xyr_RadSFlux, xyr_RadLFlux) 
   407:                ! ˤĤ, ¾ΰѤ, ϤԤ. 
   408:                !
   409:                ! Radiation fluxes (xyr_RadSFlux, xyr_RadLFlux) are
   410:                ! corrected by using other arguments, and the corrected values are output.
   411:                !
   412:            
   413:                ! ⥸塼 ; USE statements
   414:                !
   415:            
   416:                ! 
   417:                ! Time control
   418:                !
   419:                use timeset, only: &
   420:                  & DelTime, &            ! $ \Delta t $ [s]
   421:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   422:                  & TimesetClockStart, TimesetClockStop
   423:            
   424:                ! ҥȥǡ
   425:                ! History data output
   426:                !
   427:                use gtool_historyauto, only: HistoryAutoPut
   428:            
   429:                ! ʸ ; Declaration statements
   430:                !
   431:                implicit none
   432:                real(DP), intent(in):: xyr_RadSUwFlux  (0:imax-1, 1:jmax, 0:kmax)
   433:                                          ! û () եå. 
   434:                                          ! Upward shortwave (insolation) flux
   435:                real(DP), intent(in):: xyr_RadSDwFlux  (0:imax-1, 1:jmax, 0:kmax)
   436:                                          ! û () եå. 
   437:                                          ! Downward shortwave (insolation) flux
   438:            
   439:                real(DP), intent(in):: xyr_RadLUwFlux    (0:imax-1, 1:jmax, 0:kmax)
   440:                                          ! Ĺȥեå. 
   441:                                          ! Upward longwave flux
   442:                real(DP), intent(in):: xyr_RadLDwFlux    (0:imax-1, 1:jmax, 0:kmax)
   443:                                          ! Ĺȥեå. 
   444:                                          ! Downward longwave flux
   445:                real(DP), intent(in):: xyra_DelRadLUwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   446:                                          ! ĹɽѲ. 
   447:                                          ! 
   448:                real(DP), intent(in):: xyra_DelRadLDwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   449:                                          ! ĹɽѲ. 
   450:                                          ! 
   451:            
   452:                real(DP), intent(in):: xy_DSurfTempDt  (0:imax-1, 1:jmax)
   453:                                          ! ɽ̲ѲΨ. 
   454:                                          ! Surface temperature tendency
   455:                real(DP), intent(in):: xyz_DTempDt     (0:imax-1, 1:jmax, 1:kmax)
   456:                                          ! $ \DP{T}{t} $ . Ѳ (K s-1)
   457:                                          ! Temperature tendency (K s-1)
   458:            
   459:                ! ϤΤκѿ
   460:                ! Work variables for output
   461:                !
   462:                real(DP):: xyr_RadSFlux    (0:imax-1, 1:jmax, 0:kmax)
   463:                                          ! û () եå. 
   464:                                          ! Shortwave (insolation) flux
   465:                real(DP):: xyr_RadLFlux    (0:imax-1, 1:jmax, 0:kmax)
   466:                                          ! Ĺȥեå. 
   467:                                          ! Longwave flux
   468:                real(DP):: xyra_DelRadLFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   469:                                          ! ĹɽѲ. 
   470:                                          ! Surface temperature tendency with longwave
   471:                real(DP):: xyr_RadLUwFluxCor(0:imax-1, 1:jmax, 0:kmax)
   472:                                          ! 줿Ĺȥեå. 
   473:                                          ! Corrected longwave flux
   474:                real(DP):: xyr_RadLDwFluxCor(0:imax-1, 1:jmax, 0:kmax)
   475:                                          ! 줿Ĺȥեå. 
   476:                                          ! Corrected longwave flux
   477:                real(DP):: xyr_RadLFluxCor  (0:imax-1, 1:jmax, 0:kmax)
   478:                                          ! 줿Ĺȥեå. 
   479:                                          ! Corrected longwave flux
   480:            
   481:                ! ѿ
   482:                ! Work variables
   483:                !
   484:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   485:                                          ! Work variables for DO loop in vertical direction
   486:                ! ¹ʸ ; Executable statement
   487:                !
   488:            
   489:                ! ǧ
   490:                ! Initialization check
   491:                !
   492:                if ( .not. rad_utils_inited ) then
   493:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   494:                end if
   495:            
   496:            
   497:                ! ׻ַ¬
   498:                ! Start measurement of computation time
   499:                !
   500:                call TimesetClockStart( module_name )
   501:            
   502:            
   503: **V---->       xyr_RadSFlux     = xyr_RadSUwFlux     - xyr_RadSDwFlux
   504: **V----        xyr_RadLFlux     = xyr_RadLUwFlux     - xyr_RadLDwFlux
   505: +++V===        xyra_DelRadLFlux = xyra_DelRadLUwFlux - xyra_DelRadLDwFlux
   506:            
   507:            
   508:                ! Ĺȥեå ( ɽեåʬ )
   509:                ! Correct longwave flux ( amount of surface flux )
   510:                !
   511:                ! Lines commented out below will be deleted soon (yot, 2010/10/31).
   512:            !!$    do k = 0, kmax
   513:            !!$      xyr_RadLFluxCor (:,:,k) = &
   514:            !!$        &     xyr_RadLFlux (:,:,k) &
   515:            !!$        &   + xyra_DelRadLFlux(:,:,k,0) * xy_DSurfTempDt (:,:) * DelTime
   516:            !!$    end do
   517:            !!$    do k = 0, kmax
   518:            !!$      xyr_RadLFluxCor(:,:,k) = &
   519:            !!$        &   xyr_RadLFlux(:,:,k) &
   520:            !!$        & + (   xy_DSurfTempDt     * xyra_DelRadLFlux(:,:,k,0)   &
   521:            !!$        &     + xyz_DTempDt(:,:,1) * xyra_DelRadLFlux(:,:,k,1) ) &
   522:            !!$        &   * DelTime
   523:            !!$    end do
   524: +------>       do k = 0, kmax
   525: |*V---->         xyr_RadLUwFluxCor(:,:,k) =                                   &
   526: |||                &   xyr_RadLUwFlux(:,:,k)                                  &
   527: |||                & + (   xy_DSurfTempDt     * xyra_DelRadLUwFlux(:,:,k,0)   &
   528: |||                &     + xyz_DTempDt(:,:,1) * xyra_DelRadLUwFlux(:,:,k,1) ) &
   529: |||                &   * DelTime
   530: |*V----          xyr_RadLDwFluxCor(:,:,k) =                                   &
   531: |                  &   xyr_RadLDwFlux(:,:,k)                                  &
   532: |                  & + (   xy_DSurfTempDt     * xyra_DelRadLDwFlux(:,:,k,0)   &
   533: |                  &     + xyz_DTempDt(:,:,1) * xyra_DelRadLDwFlux(:,:,k,1) ) &
   534: |                  &   * DelTime
   535: +------        end do
   536: ++V====        xyr_RadLFluxCor = xyr_RadLUwFluxCor - xyr_RadLDwFluxCor
   537:            
   538:            
   539:                ! ҥȥǡ
   540:                ! History data output
   541:                !
   542:                call HistoryAutoPut( TimeN, 'OLR', xyr_RadLFluxCor(:,:,kmax) )
   543:                call HistoryAutoPut( TimeN, 'SLR', xyr_RadLFluxCor(:,:,0)    )
   544:                call HistoryAutoPut( TimeN, 'OSR', xyr_RadSFlux   (:,:,kmax) )
   545:                call HistoryAutoPut( TimeN, 'SSR', xyr_RadSFlux   (:,:,0)    )
   546:                call HistoryAutoPut( TimeN, 'RadLUWFLX', xyr_RadLUwFluxCor )
   547:                call HistoryAutoPut( TimeN, 'RadLDWFLX', xyr_RadLDwFluxCor )
   548:                call HistoryAutoPut( TimeN, 'RadSUWFLX', xyr_RadSUwFlux    )
   549:                call HistoryAutoPut( TimeN, 'RadSDWFLX', xyr_RadSDwFlux    )
   550:            
   551:            
   552:                ! ҥȥǡ
   553:                ! History data output
   554:                !
   555:                call HistoryAutoPut( TimeN, 'OLRB', xyr_RadLFlux(:,:,kmax) )
   556:                call HistoryAutoPut( TimeN, 'SLRB', xyr_RadLFlux(:,:,0)    )
   557:                call HistoryAutoPut( TimeN, 'OSRB', xyr_RadSFlux(:,:,kmax) )
   558:                call HistoryAutoPut( TimeN, 'SSRB', xyr_RadSFlux(:,:,0)    )
   559:                call HistoryAutoPut( TimeN, 'RadLUWFLXB', xyr_RadLUwFlux )
   560:                call HistoryAutoPut( TimeN, 'RadLDWFLXB', xyr_RadLDwFlux )
   561:                call HistoryAutoPut( TimeN, 'RadSUWFLXB', xyr_RadSUwFlux )
   562:                call HistoryAutoPut( TimeN, 'RadSDWFLXB', xyr_RadSDwFlux )
   563:            
   564:            
   565:                ! Ĺȥեå ( ɽեåʬ )
   566:                ! Correct longwave flux ( amount of surface flux )
   567:                !
   568:                ! Lines commented out below will be deleted soon (yot, 2010/10/31).
   569:            !!$    do k = 0, kmax
   570:            !!$      xyr_RadLFluxCor (:,:,k) = &
   571:            !!$        &     xyr_RadLFlux (:,:,k) &
   572:            !!$        &   + xyra_DelRadLFlux(:,:,k,0) * xy_DSurfTempDt (:,:) * 2.0d0 * DelTime
   573:            !!$    end do
   574:            !!$    do k = 0, kmax
   575:            !!$      xyr_RadLFluxCor(:,:,k) = &
   576:            !!$        &   xyr_RadLFlux(:,:,k) &
   577:            !!$        & + (   xy_DSurfTempDt     * xyra_DelRadLFlux(:,:,k,0)   &
   578:            !!$        &     + xyz_DTempDt(:,:,1) * xyra_DelRadLFlux(:,:,k,1) ) &
   579:            !!$        &   * 2.0_DP * DelTime
   580:            !!$    end do
   581: +------>       do k = 0, kmax
   582: |*V---->         xyr_RadLUwFluxCor(:,:,k) =                                   &
   583: |||                &   xyr_RadLUwFlux(:,:,k)                                  &
   584: |||                & + (   xy_DSurfTempDt     * xyra_DelRadLUwFlux(:,:,k,0)   &
   585: |||                &     + xyz_DTempDt(:,:,1) * xyra_DelRadLUwFlux(:,:,k,1) ) &
   586: |||                &   * 2.0_DP * DelTime
   587: |*V----          xyr_RadLDwFluxCor(:,:,k) =                                   &
   588: |                  &   xyr_RadLDwFlux(:,:,k)                                  &
   589: |                  & + (   xy_DSurfTempDt     * xyra_DelRadLDwFlux(:,:,k,0)   &
   590: |                  &     + xyz_DTempDt(:,:,1) * xyra_DelRadLDwFlux(:,:,k,1) ) &
   591: |                  &   * 2.0_DP * DelTime
   592: +------        end do
   593: ++V====        xyr_RadLFluxCor = xyr_RadLUwFluxCor - xyr_RadLDwFluxCor
   594:            
   595:            
   596:                ! ҥȥǡ
   597:                ! History data output
   598:                !
   599:                call HistoryAutoPut( TimeN, 'OLRA', xyr_RadLFluxCor(:,:,kmax) )
   600:                call HistoryAutoPut( TimeN, 'SLRA', xyr_RadLFluxCor(:,:,0)    )
   601:                call HistoryAutoPut( TimeN, 'OSRA', xyr_RadSFlux   (:,:,kmax) )
   602:                call HistoryAutoPut( TimeN, 'SSRA', xyr_RadSFlux   (:,:,0)    )
   603:                call HistoryAutoPut( TimeN, 'RadLUWFLXA', xyr_RadLUwFluxCor )
   604:                call HistoryAutoPut( TimeN, 'RadLDWFLXA', xyr_RadLDwFluxCor )
   605:                call HistoryAutoPut( TimeN, 'RadSUWFLXA', xyr_RadSUwFlux    )
   606:                call HistoryAutoPut( TimeN, 'RadSDWFLXA', xyr_RadSDwFlux    )
   607:            
   608:            
   609:                ! ׻ַ¬
   610:                ! Pause measurement of computation time
   611:                !
   612:                call TimesetClockStop( module_name )
   613:            
   614:              end subroutine RadFluxOutput
   615:            
   616:              !-------------------------------------------------------------------
   617:            
   618:              subroutine RadUtilsInit
   619:                !
   620:                ! rad_utils ⥸塼νԤޤ. 
   621:                ! NAMELIST#rad_utils_nml ɤ߹ߤϤμ³ǹԤޤ. 
   622:                !
   623:                ! "rad_utils" module is initialized. 
   624:                ! "NAMELIST#rad_utils_nml" is loaded in this procedure. 
   625:                !
   626:            
   627:                ! ⥸塼 ; USE statements
   628:                !
   629:            
   630:                ! ʸ
   631:                ! Character handling
   632:                !
   633:                use dc_string, only: toChar
   634:            
   635:                ! ե
   636:                ! File I/O support
   637:                !
   638:                use dc_iounit, only: FileOpen
   639:            
   640:                ! ҥȥǡ
   641:                ! History data output
   642:                !
   643:                use gtool_historyauto, only: HistoryAutoAddVariable
   644:            
   645:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   646:                ! Utilities for NAMELIST file input
   647:                !
   648:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   649:            
   650:                ! ʸ ; Declaration statements
   651:                !
   652:            
   653:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   654:                                          ! Unit number for NAMELIST file open
   655:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   656:                                          ! IOSTAT of NAMELIST read
   657:            
   658:            
   659:                ! NAMELIST ѿ
   660:                ! NAMELIST group name
   661:                !
   662:            !!$    namelist /rad_utils_nml/ &
   663:            !!$      & DiffFact
   664:            !!$      & DelTimeLongValue, DelTimeLongUnit, &
   665:            !!$      & DelTimeShortValue, DelTimeShortUnit, &
   666:            !!$!
   667:            !!$      & LongBandNum, &
   668:            !!$      & LongAbsorpCoefQVap, LongAbsorpCoefDryAir, &
   669:            !!$      & LongBandWeight, LongPathLengthFact, &
   670:            !!$!
   671:            !!$      & ShortBandNum, &
   672:            !!$      & ShortAbsorpCoefQVap, ShortAbsorpCoefDryAir, &
   673:            !!$      & ShortBandWeight, ShortSecScat, &
   674:            !!$      & ShortAtmosAlbedo, &
   675:            !!$!
   676:            !!$      & RstInputFile, RstOutputFile
   677:                      !
   678:                      ! ǥեͤˤĤƤϽ³ "rad_utils#RadInit" 
   679:                      ! Υɤ򻲾ȤΤ. 
   680:                      !
   681:                      ! Refer to source codes in the initialization procedure
   682:                      ! "rad_utils#RadInit" for the default values. 
   683:                      !
   684:            
   685:                ! ¹ʸ ; Executable statement
   686:                !
   687:            
   688:                if ( rad_utils_inited ) return
   689:            
   690:            
   691:                ! ǥեͤ
   692:                ! Default values settings
   693:                !
   694:            
   695:                ! NAMELIST ɤ߹
   696:                ! NAMELIST is input
   697:                !
   698:            !!$    if ( trim(namelist_filename) /= '' ) then
   699:            !!$      call FileOpen( unit_nml, &          ! (out)
   700:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   701:            !!$
   702:            !!$      rewind( unit_nml )
   703:            !!$      read( unit_nml,                     & ! (in)
   704:            !!$        & nml = rad_utils_nml,            & ! (out)
   705:            !!$        & iostat = iostat_nml )             ! (out)
   706:            !!$      close( unit_nml )
   707:            !!$
   708:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   709:            !!$    end if
   710:            
   711:            
   712:                ! ҥȥǡϤΤΤؤѿϿ
   713:                ! Register of variables for history data output
   714:                !
   715:                call HistoryAutoAddVariable( 'OLR', &
   716:                  & (/ 'lon ', 'lat ', 'time' /), &
   717:                  & 'outgoing longwave', 'W m-2' )
   718:                call HistoryAutoAddVariable( 'SLR', &
   719:                  & (/ 'lon ', 'lat ', 'time' /), &
   720:                  & 'surface longwave', 'W m-2' )
   721:                call HistoryAutoAddVariable( 'OSR', &
   722:                  & (/ 'lon ', 'lat ', 'time' /), &
   723:                  & 'outgoing shortwave', 'W m-2' )
   724:                call HistoryAutoAddVariable( 'SSR', &
   725:                  & (/ 'lon ', 'lat ', 'time' /), &
   726:                  & 'surface shortwave', 'W m-2' )
   727:            
   728:                call HistoryAutoAddVariable( 'RadLUWFLX', &
   729:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   730:                  & 'upward longwave net flux', 'W m-2' )
   731:                call HistoryAutoAddVariable( 'RadLDWFLX', &
   732:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   733:                  & 'downward longwave net flux', 'W m-2' )
   734:                call HistoryAutoAddVariable( 'RadSUWFLX', &
   735:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   736:                  & 'upward shortwave net flux', 'W m-2' )
   737:                call HistoryAutoAddVariable( 'RadSDWFLX', &
   738:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   739:                  & 'downward shortwave net flux', 'W m-2' )
   740:            
   741:                call HistoryAutoAddVariable( 'OLRB', &
   742:                  & (/ 'lon ', 'lat ', 'time' /), &
   743:                  & 'outgoing longwave', 'W m-2' )
   744:                call HistoryAutoAddVariable( 'SLRB', &
   745:                  & (/ 'lon ', 'lat ', 'time' /), &
   746:                  & 'surface longwave', 'W m-2' )
   747:                call HistoryAutoAddVariable( 'OSRB', &
   748:                  & (/ 'lon ', 'lat ', 'time' /), &
   749:                  & 'outgoing shortwave', 'W m-2' )
   750:                call HistoryAutoAddVariable( 'SSRB', &
   751:                  & (/ 'lon ', 'lat ', 'time' /), &
   752:                  & 'surface shortwave', 'W m-2' )
   753:            
   754:                call HistoryAutoAddVariable( 'RadLUWFLXB', &
   755:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   756:                  & 'upward longwave net flux', 'W m-2' )
   757:                call HistoryAutoAddVariable( 'RadLDWFLXB', &
   758:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   759:                  & 'downward longwave net flux', 'W m-2' )
   760:                call HistoryAutoAddVariable( 'RadSUWFLXB', &
   761:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   762:                  & 'upward shortwave net flux', 'W m-2' )
   763:                call HistoryAutoAddVariable( 'RadSDWFLXB', &
   764:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   765:                  & 'downward shortwave net flux', 'W m-2' )
   766:            
   767:                call HistoryAutoAddVariable( 'OLRA', &
   768:                  & (/ 'lon ', 'lat ', 'time' /), &
   769:                  & 'outgoing longwave', 'W m-2' )
   770:                call HistoryAutoAddVariable( 'SLRA', &
   771:                  & (/ 'lon ', 'lat ', 'time' /), &
   772:                  & 'surface longwave', 'W m-2' )
   773:                call HistoryAutoAddVariable( 'OSRA', &
   774:                  & (/ 'lon ', 'lat ', 'time' /), &
   775:                  & 'outgoing shortwave', 'W m-2' )
   776:                call HistoryAutoAddVariable( 'SSRA', &
   777:                  & (/ 'lon ', 'lat ', 'time' /), &
   778:                  & 'surface shortwave', 'W m-2' )
   779:            
   780:                call HistoryAutoAddVariable( 'RadLUWFLXA', &
   781:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   782:                  & 'upward longwave net flux', 'W m-2' )
   783:                call HistoryAutoAddVariable( 'RadLDWFLXA', &
   784:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   785:                  & 'downward longwave net flux', 'W m-2' )
   786:                call HistoryAutoAddVariable( 'RadSUWFLXA', &
   787:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   788:                  & 'upward shortwave net flux', 'W m-2' )
   789:                call HistoryAutoAddVariable( 'RadSDWFLXA', &
   790:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /), &
   791:                  & 'downward shortwave net flux', 'W m-2' )
   792:            
   793:                call HistoryAutoAddVariable( 'DTempDtRadL', &
   794:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   795:                  & 'long wave radiative heating rate', 'K s-1' )
   796:                call HistoryAutoAddVariable( 'DTempDtRadS', &
   797:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   798:                  & 'short wave radiative heating rate', 'K s-1' )
   799:            
   800:            
   801:                !  ; Print
   802:                !
   803:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   804:            !!$    call MessageNotify( 'M', module_name, 'DiffFact = %f', d = (/ DiffFact /) )
   805:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   806:            
   807:                rad_utils_inited = .true.
   808:            
   809:              end subroutine RadUtilsInit
   810:            
   811:              !-------------------------------------------------------------------
   812:            
   813:            end module rad_utils
