Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:26 2012
FILE NAME: set_o3.f90
PROGRAM NAME: set_o3
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   184  opt  (1592): Outer loop unrolled inside inner loop.
   184  vec  (   4): Vectorized array expression.
   184  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:26 2012
FILE NAME: set_o3.f90
PROGRAM NAME: set_o3
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != O3 ʬۤ
     2  !
     3  != Set O3 distribution
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: set_o3.f90,v 1.4 2011-06-19 11:12:43 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module set_o3
    13    !
    14    != O3 ʬۤ
    15    !
    16    != Set O3 distribution
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! O3 ʬ.
    21    !
    22    ! Set O3 distribution.
    23    !
    24    !== References
    25    !
    26  !!$  !  Roewe, D., and K.-N. Liou, Influence of cirrus clouds on the infrared cooling
    27  !!$  !    rate in the troposphere and lower stratosphere, J. Appl. Met., 17, 92-106, 1978.
    28    !
    29    !== Procedures List
    30    !
    31  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    32  !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    33  !!$  ! RadiationFluxOutput     :: ͥեåν
    34  !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    35  !!$  ! ------------            :: ------------
    36  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    37  !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    38  !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    39  !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    40    !
    41    !== NAMELIST
    42    !
    43  !!$  ! NAMELIST#radiation_DennouAGCM_nml
    44    !
    45  
    46    ! USE statements
    47    !
    48  
    49    !
    50    ! Kind type parameter
    51    !
    52    use dc_types, only: DP, &      ! Double precision.
    53      &                 STRING, &  ! Strings.
    54      &                 TOKEN      ! Keywords.
    55  
    56    ! å
    57    ! Message output
    58    !
    59    use dc_message, only: MessageNotify
    60  
    61  
    62    ! Declaration statements
    63    !
    64    implicit none
    65    private
    66  
    67    !
    68    ! Public procedure
    69    !
    70    public:: SetO3
    71    public:: SetO3Init
    72  
    73  
    74    character(*), parameter:: module_name = 'set_o3'
    75                                ! ⥸塼̾.
    76                                ! Module name
    77    character(*), parameter:: version = &
    78      & '$Name: dcpam5-20120921 $' // &
    79      & '$Id: set_o3.f90,v 1.4 2011-06-19 11:12:43 yot Exp $'
    80                                ! ⥸塼ΥС
    81                                ! Module version
    82  
    83    logical          , save:: FlagO3
    84    logical          , save:: Flag1D
    85  
    86    character(STRING), save:: O3File
    87  
    88    logical, save :: set_o3_inited = .false.
    89                                ! ե饰.
    90                                ! Initialization flag
    91  
    92  contains
    93  
    94    !--------------------------------------------------------------------------------------
    95  
    96    subroutine SetO3( &
    97      & xyz_Press, & ! (in )
    98      & xyz_QO3    & ! (out)
    99      & )
   100  
   101  
   102      ! USE statements
   103      !
   104  
   105      !
   106      ! Grid points settings
   107      !
   108      use gridset, only: imax, & !
   109                                 ! Number of grid points in longitude
   110        &                jmax, & !
   111                                 ! Number of grid points in latitude
   112        &                kmax    !
   113                                 ! Number of vertical level
   114  
   115      ! ҥȥǡ
   116      ! History data output
   117      !
   118      use gtool_historyauto, only: HistoryAutoAddVariable, HistoryAutoPut
   119  
   120      ! 
   121      ! Time control
   122      !
   123      use timeset, only: &
   124        & TimeN, &              ! ƥå $ t $ λ.
   125                                ! Time of step $ t $.
   126        & TimesetClockStart, TimesetClockStop
   127  
   128      ! ǡɤ߹
   129      ! Reading time series
   130      !
   131      use read_time_series, only: SetValuesFromTimeSeriesWrapper
   132  
   133      ! ե뤫 1 ץեɤꤹ.
   134      ! read 1-D profile from a file and set it
   135      !
   136      use set_1d_profile, only : Set1DProfileO3
   137  
   138  
   139      real(DP), intent(in ):: xyz_Press(0:imax-1, 1:jmax, 1:kmax)
   140      real(DP), intent(out):: xyz_QO3  (0:imax-1, 1:jmax, 1:kmax)
   141  
   142  
   143      !
   144      ! Work variables
   145      !
   146  
   147  
   148      ! ǧ
   149      ! Initialization check
   150      !
   151      if ( .not. set_o3_inited ) then
   152        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   153      end if
   154  
   155  
   156      ! ׻ַ¬
   157      ! Start measurement of computation time
   158      !
   159      call TimesetClockStart( module_name )
   160  
   161  
   162      if ( FlagO3 ) then
   163  
   164        if ( Flag1D ) then
   165  
   166          call Set1DProfileO3( &
   167            & xyz_Press,             & ! (in )
   168            & xyz_QO3                & ! (out)
   169            & )
   170  
   171        else
   172  
   173          call SetValuesFromTimeSeriesWrapper( &
   174            & O3File, "O3",   &
   175            & xyz_Press,      &               ! (in)
   176            & xyz_QO3,        &               ! (inout)
   177            & "O3"            &
   178            & )
   179  
   180        end if
   181  
   182      else
   183  
   184        xyz_QO3 (:,:,:) = 0.0d0
     .        if (xyz_qo3.DSC.U2 .gt. 0) then                                   
     .           J1 = and(xyz_qo3.DSC.U2,3)                                     
     .  !CDIR    NODEP                                                          
     .           do t44 = 1, J1                                                 
     .  !CDIR       NODEP                                                       
     .              do t46 = 1, xyz_qo3.DSC.U1 + 1                              
     .                 xyz_qo3(t46-1,t44,t42+1) = 0.0000000000000000e+000       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t44 = J1 + 1, xyz_qo3.DSC.U2, 4                             
     .  !CDIR       NODEP                                                       
     .              do t46 = 1, xyz_qo3.DSC.U1 + 1                              
     .                 xyz_qo3(t46-1,t44,t42+1) = 0.0000000000000000e+000       
     .                 xyz_qo3(t46-1,t44+1,t42+1) = 0.0000000000000000e+000     
     .                 xyz_qo3(t46-1,t44+2,t42+1) = 0.0000000000000000e+000     
     .                 xyz_qo3(t46-1,t44+3,t42+1) = 0.0000000000000000e+000     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   185  
   186      end if
   187  
   188      call HistoryAutoPut( TimeN, "O3", xyz_QO3 )
   189  
   190  
   191      ! ׻ַ¬
   192      ! Pause measurement of computation time
   193      !
   194      call TimesetClockStop( module_name )
   195  
   196  
   197    end subroutine SetO3
   198  
   199    !--------------------------------------------------------------------------------------
   200  
   201    subroutine SetO3Init
   202  
   203  
   204      ! ե
   205      ! File I/O support
   206      !
   207      use dc_iounit, only: FileOpen
   208  
   209      ! ҥȥǡ
   210      ! History data output
   211      !
   212      use gtool_historyauto, only: HistoryAutoAddVariable
   213  
   214      ! NAMELIST եϤ˴ؤ桼ƥƥ
   215      ! Utilities for NAMELIST file input
   216      !
   217      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   218  
   219  
   220  
   221      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   222                                ! Unit number for NAMELIST file open
   223      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   224                                ! IOSTAT of NAMELIST read
   225  
   226      ! NAMELIST ѿ
   227      ! NAMELIST group name
   228      !
   229      namelist /set_O3_nml/ &
   230        & FlagO3,  &
   231        & Flag1D,  &
   232        & O3File
   233            !
   234            ! ǥեͤˤĤƤϽ³ "set_o3#SetO3Init"
   235            ! Υɤ򻲾ȤΤ.
   236            !
   237            ! Refer to source codes in the initialization procedure
   238            ! "set_o3#SetO3Init" for the default values.
   239            !
   240  
   241      if ( set_o3_inited ) return
   242  
   243  
   244      ! ǥեͤ
   245      ! Default values settings
   246      !
   247  
   248      FlagO3 = .true.
   249  
   250      Flag1D = .false.
   251  
   252      O3File = ""
   253  
   254  
   255      ! NAMELIST ɤ߹
   256      ! NAMELIST is input
   257      !
   258      if ( trim(namelist_filename) /= '' ) then
   259        call FileOpen( unit_nml, &          ! (out)
   260          & namelist_filename, mode = 'r' ) ! (in)
   261  
   262        rewind( unit_nml )
   263        read( unit_nml,                     & ! (in)
   264          & nml = set_O3_nml,               & ! (out)
   265          & iostat = iostat_nml )             ! (out)
   266        close( unit_nml )
   267  
   268        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   269      end if
   270  
   271  
   272      call HistoryAutoAddVariable( "O3",         & ! (in)
   273        & (/ 'lon ', 'lat ', 'sig ', 'time' /),  & ! (in)
   274        & "ozone", 'kg kg-1' )                     ! (in)
   275  
   276      !  ; Print
   277      !
   278      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   279      call MessageNotify( 'M', module_name, '  FlagO3 = %b', l = (/ FlagO3 /) )
   280      call MessageNotify( 'M', module_name, '  Flag1D = %b', l = (/ Flag1D /) )
   281      call MessageNotify( 'M', module_name, '  O3File = %c', c1 = trim( O3File ) )
   282      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   283  
   284  
   285      set_o3_inited = .true.
   286  
   287    end subroutine SetO3Init
   288  
   289    !--------------------------------------------------------------------------------------
   290  
   291  end module set_o3
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:26 2012
FILE NAME: set_o3.f90
PROGRAM NAME: set_o3
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != O3 ʬۤ
     2:            !
     3:            != Set O3 distribution
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: set_o3.f90,v 1.4 2011-06-19 11:12:43 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module set_o3
    13:              !
    14:              != O3 ʬۤ
    15:              !
    16:              != Set O3 distribution
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! O3 ʬ.
    21:              !
    22:              ! Set O3 distribution. 
    23:              !
    24:              !== References
    25:              !
    26:            !!$  !  Roewe, D., and K.-N. Liou, Influence of cirrus clouds on the infrared cooling 
    27:            !!$  !    rate in the troposphere and lower stratosphere, J. Appl. Met., 17, 92-106, 1978.
    28:              !
    29:              !== Procedures List
    30:              !
    31:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    32:            !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    33:            !!$  ! RadiationFluxOutput     :: ͥեåν
    34:            !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    35:            !!$  ! ------------            :: ------------
    36:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    37:            !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    38:            !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    39:            !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    40:              !
    41:              !== NAMELIST
    42:              !
    43:            !!$  ! NAMELIST#radiation_DennouAGCM_nml
    44:              !
    45:            
    46:              ! USE statements
    47:              !
    48:            
    49:              ! 
    50:              ! Kind type parameter
    51:              !
    52:              use dc_types, only: DP, &      ! Double precision.
    53:                &                 STRING, &  ! Strings.
    54:                &                 TOKEN      ! Keywords.
    55:            
    56:              ! å
    57:              ! Message output
    58:              !
    59:              use dc_message, only: MessageNotify
    60:            
    61:            
    62:              ! Declaration statements
    63:              !
    64:              implicit none
    65:              private
    66:            
    67:              ! 
    68:              ! Public procedure
    69:              !
    70:              public:: SetO3
    71:              public:: SetO3Init
    72:            
    73:            
    74:              character(*), parameter:: module_name = 'set_o3'
    75:                                          ! ⥸塼̾.
    76:                                          ! Module name
    77:              character(*), parameter:: version = &
    78:                & '$Name: dcpam5-20120921 $' // &
    79:                & '$Id: set_o3.f90,v 1.4 2011-06-19 11:12:43 yot Exp $'
    80:                                          ! ⥸塼ΥС
    81:                                          ! Module version
    82:            
    83:              logical          , save:: FlagO3
    84:              logical          , save:: Flag1D
    85:            
    86:              character(STRING), save:: O3File
    87:            
    88:              logical, save :: set_o3_inited = .false.
    89:                                          ! ե饰.
    90:                                          ! Initialization flag
    91:            
    92:            contains
    93:            
    94:              !--------------------------------------------------------------------------------------
    95:            
    96:              subroutine SetO3( &
    97:                & xyz_Press, & ! (in )
    98:                & xyz_QO3    & ! (out)
    99:                & )
   100:            
   101:            
   102:                ! USE statements
   103:                !
   104:            
   105:                ! 
   106:                ! Grid points settings
   107:                !
   108:                use gridset, only: imax, & ! 
   109:                                           ! Number of grid points in longitude
   110:                  &                jmax, & ! 
   111:                                           ! Number of grid points in latitude
   112:                  &                kmax    ! 
   113:                                           ! Number of vertical level
   114:            
   115:                ! ҥȥǡ
   116:                ! History data output
   117:                !
   118:                use gtool_historyauto, only: HistoryAutoAddVariable, HistoryAutoPut
   119:            
   120:                ! 
   121:                ! Time control
   122:                !
   123:                use timeset, only: &
   124:                  & TimeN, &              ! ƥå $ t $ λ.
   125:                                          ! Time of step $ t $.
   126:                  & TimesetClockStart, TimesetClockStop
   127:            
   128:                ! ǡɤ߹
   129:                ! Reading time series
   130:                !
   131:                use read_time_series, only: SetValuesFromTimeSeriesWrapper
   132:            
   133:                ! ե뤫 1 ץեɤꤹ. 
   134:                ! read 1-D profile from a file and set it 
   135:                !
   136:                use set_1d_profile, only : Set1DProfileO3
   137:            
   138:            
   139:                real(DP), intent(in ):: xyz_Press(0:imax-1, 1:jmax, 1:kmax)
   140:                real(DP), intent(out):: xyz_QO3  (0:imax-1, 1:jmax, 1:kmax)
   141:            
   142:            
   143:                !
   144:                ! Work variables
   145:                !
   146:            
   147:            
   148:                ! ǧ
   149:                ! Initialization check
   150:                !
   151:                if ( .not. set_o3_inited ) then
   152:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   153:                end if
   154:            
   155:            
   156:                ! ׻ַ¬
   157:                ! Start measurement of computation time
   158:                !
   159:                call TimesetClockStart( module_name )
   160:            
   161:            
   162:                if ( FlagO3 ) then
   163:            
   164:                  if ( Flag1D ) then
   165:            
   166:                    call Set1DProfileO3( &
   167:                      & xyz_Press,             & ! (in )
   168:                      & xyz_QO3                & ! (out)
   169:                      & )
   170:            
   171:                  else
   172:            
   173:                    call SetValuesFromTimeSeriesWrapper( &
   174:                      & O3File, "O3",   &
   175:                      & xyz_Press,      &               ! (in)
   176:                      & xyz_QO3,        &               ! (inout)
   177:                      & "O3"            &
   178:                      & )
   179:            
   180:                  end if
   181:            
   182:                else
   183:            
   184: ++V====          xyz_QO3 (:,:,:) = 0.0d0
   185:            
   186:                end if
   187:            
   188:                call HistoryAutoPut( TimeN, "O3", xyz_QO3 )
   189:            
   190:            
   191:                ! ׻ַ¬
   192:                ! Pause measurement of computation time
   193:                !
   194:                call TimesetClockStop( module_name )
   195:            
   196:            
   197:              end subroutine SetO3
   198:            
   199:              !--------------------------------------------------------------------------------------
   200:            
   201:              subroutine SetO3Init
   202:            
   203:            
   204:                ! ե
   205:                ! File I/O support
   206:                !
   207:                use dc_iounit, only: FileOpen
   208:            
   209:                ! ҥȥǡ
   210:                ! History data output
   211:                !
   212:                use gtool_historyauto, only: HistoryAutoAddVariable
   213:            
   214:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   215:                ! Utilities for NAMELIST file input
   216:                !
   217:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   218:            
   219:            
   220:            
   221:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   222:                                          ! Unit number for NAMELIST file open
   223:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   224:                                          ! IOSTAT of NAMELIST read
   225:            
   226:                ! NAMELIST ѿ
   227:                ! NAMELIST group name
   228:                !
   229:                namelist /set_O3_nml/ &
   230:                  & FlagO3,  &
   231:                  & Flag1D,  &
   232:                  & O3File
   233:                      !
   234:                      ! ǥեͤˤĤƤϽ³ "set_o3#SetO3Init"
   235:                      ! Υɤ򻲾ȤΤ.
   236:                      !
   237:                      ! Refer to source codes in the initialization procedure
   238:                      ! "set_o3#SetO3Init" for the default values.
   239:                      !
   240:            
   241:                if ( set_o3_inited ) return
   242:            
   243:            
   244:                ! ǥեͤ
   245:                ! Default values settings
   246:                !
   247:            
   248:                FlagO3 = .true.
   249:            
   250:                Flag1D = .false.
   251:            
   252:                O3File = ""
   253:            
   254:            
   255:                ! NAMELIST ɤ߹
   256:                ! NAMELIST is input
   257:                !
   258:                if ( trim(namelist_filename) /= '' ) then
   259:                  call FileOpen( unit_nml, &          ! (out)
   260:                    & namelist_filename, mode = 'r' ) ! (in)
   261:            
   262:                  rewind( unit_nml )
   263:                  read( unit_nml,                     & ! (in)
   264:                    & nml = set_O3_nml,               & ! (out)
   265:                    & iostat = iostat_nml )             ! (out)
   266:                  close( unit_nml )
   267:            
   268:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   269:                end if
   270:            
   271:            
   272:                call HistoryAutoAddVariable( "O3",         & ! (in)
   273:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /),  & ! (in)
   274:                  & "ozone", 'kg kg-1' )                     ! (in)
   275:            
   276:                !  ; Print
   277:                !
   278:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   279:                call MessageNotify( 'M', module_name, '  FlagO3 = %b', l = (/ FlagO3 /) )
   280:                call MessageNotify( 'M', module_name, '  Flag1D = %b', l = (/ Flag1D /) )
   281:                call MessageNotify( 'M', module_name, '  O3File = %c', c1 = trim( O3File ) )
   282:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   283:            
   284:            
   285:                set_o3_inited = .true.
   286:            
   287:              end subroutine SetO3Init
   288:            
   289:              !--------------------------------------------------------------------------------------
   290:            
   291:            end module set_o3
