Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:24 2012
FILE NAME: saturate_nha1992.f90
PROGRAM NAME: saturate_nha1992
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   200  opt  (1593): Loop nest collapsed into one loop.
   200  vec  (   4): Vectorized array expression.
   255  opt  (1593): Loop nest collapsed into one loop.
   255  vec  (   4): Vectorized array expression.
   305  opt  (  11): Fused array assignments. :line 305 - 306
   305  vec  (   4): Vectorized array expression.
   305  vec  (   4): Vectorized array expression.
   306  opt  (1592): Outer loop unrolled inside inner loop.
   310  opt  (1592): Outer loop unrolled inside inner loop.
   310  vec  (   4): Vectorized array expression.
   310  vec  (   4): Vectorized array expression.
   358  opt  (  11): Fused array assignments. :line 358 - 359
   358  vec  (   4): Vectorized array expression.
   358  vec  (   4): Vectorized array expression.
   359  opt  (1592): Outer loop unrolled inside inner loop.
   363  opt  (1592): Outer loop unrolled inside inner loop.
   363  vec  (   4): Vectorized array expression.
   363  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:24 2012
FILE NAME: saturate_nha1992.f90
PROGRAM NAME: saturate_nha1992
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Nakajima et al. (1992) Ѥ˰漾λ
     2  !
     3  != Evaluate saturation specific humidity with Nakajima et al. (1992)
     4  !
     5  ! Authors::   Masaki ISHIWATARI, Yasuhiro MORIKAWA
     6  ! Version::   $Id: saturate_nha1992.f90,v 1.5 2011-06-19 10:56:27 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module saturate_nha1992
    13    !
    14    != Nakajima et al. (1992) Ѥ˰漾λ
    15    !
    16    != Evaluate saturation specific humidity with Nakajima et al. (1992)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! Nakajima et al. (1992) Ѥ줿˰¾ $ p^{*} $ ˴ؤʲμ
    21    ! Ѥ, ˰漾˰漾βʬͤ򻻽Фޤ.
    22    !
    23    ! Saturation specific humidity and temperature derivative of it
    24    ! are calculated with a folloing formula for saturation watar vapor pressure
    25    ! $ p^{*} $ in Nakajima et al. (1992).
    26    !
    27    ! \[
    28    !    p^{*} (T) = p_0^{*} \exp \left( - \frac{l}{RT} \right).
    29    ! \]
    30    !
    31    ! , $ T $ ϲ, $ R $ ׵Ǥ.
    32    ! $ R $ Ǯ $ l $ ,
    33    ! ˰¶ $ p_0^{*} $ ϰʲΤ褦Ϳޤ.
    34    !
    35    ! where $ T $ is temperature, $ R $ is the gas constant.
    36    ! $ R $ and latent heat $ l $ ,
    37    ! constant for the water vapor saturation curve $ p_0^{*} $ are as follows.
    38    !
    39    ! * $ R = 8.314 $ [J mol-1 K-1]
    40    ! * $ l = 43655 $ [J mol-1]
    41    ! * $ p_0^{*} = 1.4 \times 10^{11} $ [Pa]
    42    !
    43    ! ˰¿˰漾 $ q^{*} $ ݤˤ, ʲμѤޤ.
    44    !
    45    ! Saturation specific humidity $ q^{*} $ is calculated from
    46    ! saturation watar vapor pressure as follows.
    47    !
    48    ! \[
    49    !    q^{*} (T, p) = \varepsilon \frac{p^{*} (T)}{p}
    50    ! \]
    51    !
    52    !  $ \varepsilon $ ϶ŷʬ絤ʬ,
    53    ! $ p $ ϵǤ.
    54    !
    55    ! where $ \varepsilon $ is molecular weight ratio of water vapor to air,
    56    ! $ p $ is air pressure.
    57    !
    58    ! ä, ˰漾, ˰漾βѲ뼰ϰʲΤ褦
    59    ! ʤޤ.
    60    !
    61    ! Therefore, saturation specific humidity and temperature derivative of it
    62    ! are calculated as follows.
    63    !
    64    ! \[
    65    !    q^{*} (T, p) = \varepsilon \frac{p_0^{*}}{p} \exp \left( - \frac{l}{RT} \right), \] \[
    66    !    \DP{q^{*} (T, p)}{T} = \varepsilon \frac{p_0^{*}}{p} \frac{l}{RT^2} \exp \left( - \frac{l}{RT} \right)
    67    !    = q^{*} \frac{l}{RT^2}
    68    ! \]
    69    !
    70    !== References
    71    !
    72    ! * Nakajima, S., Hayashi, Y.-Y., Abe, Y., 1992:
    73    !   A study on the "runaway greenhouse effect" with a
    74    !   one dimensional radiative convective equilibrium model.
    75    !   <i>J. Atmos. Sci.</i>, <b>49</b>, 2256--2266.
    76    !
    77    !== Procedures List
    78    !
    79    ! CalcQVapSat            :: ˰漾η׻
    80    ! CalcDQVapSatDTemp      :: ˰漾βʬη׻
    81    ! ------------  :: ------------
    82    ! CalcQVapSat            :: Calculate saturation specific humidity
    83    ! CalcDQVapSatDTemp      :: Calculate temperature derivative of saturation specific humidity
    84    !
    85    !--
    86    !== NAMELIST
    87    !
    88    ! NAMELIST#saturate_nha1992_nml
    89    !++
    90  
    91    ! ⥸塼 ; USE statements
    92    !
    93  
    94    ! ̷ѥ᥿
    95    ! Kind type parameter
    96    !
    97    use dc_types, only: DP, &      ! ټ¿. Double precision.
    98      &                 STRING     ! ʸ.       Strings.
    99  
   100    ! å
   101    ! Message output
   102    !
   103    use dc_message, only: MessageNotify
   104  
   105    ! ʸ ; Declaration statements
   106    !
   107    implicit none
   108    private
   109  
   110    ! ³
   111    ! Public procedure
   112    !
   113    public:: xy_CalcQVapSat , xy_CalcDQVapSatDTemp
   114    public:: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
   115  
   116    ! ѿ
   117    ! Public variables
   118    !
   119    logical, save, public:: saturate_nha1992_inited = .false.
   120                                ! ե饰.
   121                                ! Initialization flag
   122  
   123    ! ѿ
   124    ! Private variables
   125    !
   126    real(DP), parameter:: LatHeat = 43655_DP
   127                                ! $ l $ [J mol-1].
   128                                ! ζŷǮ. Latent heat of condensation of water vapor
   129    real(DP), parameter:: P0 = 1.4e+11_DP
   130                                ! $ p_0^{*} $ [Pa].
   131                                ! ˰¶. constant for water vapor saturation curve
   132  
   133    character(*), parameter:: module_name = 'saturate_nha1992'
   134                                ! ⥸塼̾.
   135                                ! Module name
   136    character(*), parameter:: version = &
   137      & '$Name: dcpam5-20120921 $' // &
   138      & '$Id: saturate_nha1992.f90,v 1.5 2011-06-19 10:56:27 yot Exp $'
   139                                ! ⥸塼ΥС
   140                                ! Module version
   141  
   142  contains
   143  
   144    !--------------------------------------------------------------------------------------
   145  
   146    function xyz_CalcQVapSat( is, ie, js, je, ks, ke, xyz_Temp, xyz_Press ) result( xyz_QVapSat )
   147      !
   148      !  *Temp* ȵ *Press* Ѥ,
   149      ! ˰漾 *QVapSat* ޤ.
   150      !
   151      ! Calculate saturation specific humidity *QVapSat* using
   152      ! temperature *Temp* and air pressure *Press*.
   153      !
   154  
   155      ! ⥸塼 ; USE statements
   156      !
   157  
   158      ! ʪ
   159      ! Physical and mathematical constants settings
   160      !
   161      use constants0, only: &
   162        & GasRUniv              ! $ R^{*} $ [J K-1 mol-1].
   163                                ! ׵.  Universal gas constant
   164  
   165      ! ʪ
   166      ! Physical constants settings
   167      !
   168      use constants, only: &
   169        & EpsV                  ! $ \epsilon_v $ .
   170                                ! ʬ.
   171                                ! Molecular weight of water vapor
   172  
   173      ! ʸ ; Declaration statements
   174      !
   175      implicit none
   176  
   177      integer , intent(in):: is
   178      integer , intent(in):: ie
   179      integer , intent(in):: js
   180      integer , intent(in):: je
   181      integer , intent(in):: ks
   182      integer , intent(in):: ke
   183      real(DP), intent(in):: xyz_Temp (is:ie, js:je, ks:ke)
   184                                ! $ T $ . . Temperature
   185      real(DP), intent(in):: xyz_Press(is:ie, js:je, ks:ke)
   186                                ! $ p $ . . Air pressure
   187      real(DP):: xyz_QVapSat(is:ie, js:je, ks:ke)
   188                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   189  
   190      ! ѿ
   191      ! Work variables
   192      !
   193  
   194      ! ¹ʸ ; Executable statement
   195      !
   196  
   197      ! ˰漾η׻
   198      ! Calculate saturation specific humidity
   199      !
   200      xyz_QVapSat = EpsV * ( P0 / xyz_Press ) * exp ( - LatHeat / ( GasRUniv * xyz_Temp ) )
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t83 = 1, (ke + 1 - ks)*(je + 1 - js)*(ie + 1 - is)             
     .           xyz_qvapsat(xyz_qvapsat.DESCRIPT.RETVAL.DSC.L1+t83-1,          
     .       1      xyz_qvapsat.DESCRIPT.RETVAL.DSC.L2,                         
     .       2      xyz_qvapsat.DESCRIPT.RETVAL.DSC.L3) = epsv*(                
     .       3      1.40000000000000e+011/xyz_press(t28+t83-1,t30,t32))*dexp((- 
     .       4      4.36550000000000e+004/(8.31400000000000e+000*xyz_temp(t18+  
     .       5      t83-1,t20,t22))))                                           
     .        end do                                                            
   201  
   202  
   203    end function xyz_CalcQVapSat
   204  
   205    !--------------------------------------------------------------------------------------
   206  
   207    function xyz_CalcDQVapSatDTemp( is, ie, js, je, ks, ke, xyz_Temp, xyz_QVapSat ) result( xyz_DQVapSatDTemp )
   208      !
   209      !  *Temp* ˰漾 *QVapSat* Ѥ,
   210      ! ˰漾βʬ *DQVapSatDTemp* ޤ.
   211      !
   212      ! Calculate temperature derivative of saturation specific humidity
   213      ! *DQVapSatDTemp* using
   214      ! temperature *Temp* and saturation specific humidity *QVapSat*.
   215      !
   216  
   217      ! ⥸塼 ; USE statements
   218      !
   219  
   220      ! ʪ
   221      ! Physical and mathematical constants settings
   222      !
   223      use constants0, only: &
   224        & GasRUniv              ! $ R^{*} $ [J K-1 mol-1].
   225                                ! ׵.  Universal gas constant
   226  
   227      ! ʸ ; Declaration statements
   228      !
   229      implicit none
   230  
   231      integer , intent(in):: is
   232      integer , intent(in):: ie
   233      integer , intent(in):: js
   234      integer , intent(in):: je
   235      integer , intent(in):: ks
   236      integer , intent(in):: ke
   237      real(DP), intent(in):: xyz_Temp   (is:ie, js:je, ks:ke)
   238                                ! $ T $ . . Temperature
   239      real(DP), intent(in):: xyz_QVapSat(is:ie, js:je, ks:ke)
   240                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   241      real(DP):: xyz_DQVapSatDTemp(is:ie, js:je, ks:ke)
   242                                ! $ \DP{q^{*}}{T} $ . ˰漾βʬ.
   243                                ! Temperature derivative of saturation specific humidity.
   244  
   245      ! ѿ
   246      ! Work variables
   247      !
   248  
   249      ! ¹ʸ ; Executable statement
   250      !
   251  
   252      ! ˰漾βʬη׻
   253      ! Calculate temperature derivative of saturation specific humidity
   254      !
   255      xyz_DQVapSatDTemp = xyz_QVapSat * LatHeat / ( GasRUniv * xyz_Temp**2 )
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t79 = 1, (ke + 1 - ks)*(je + 1 - js)*(ie + 1 - is)             
     .           xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+t79-
     .       1      1,xyz_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2,                 
     .       2      xyz_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L3) = xyz_qvapsat(t28+
     .       3      t79-1,t30,t32)*4.36550000000000e+004/(8.31400000000000e+000*
     .       4      xyz_temp(t18+t79-1,t20,t22)**2)                             
     .        end do                                                            
   256  
   257  
   258    end function xyz_CalcDQVapSatDTemp
   259  
   260    !--------------------------------------------------------------------------------------
   261  
   262    function xy_CalcQVapSat( is, ie, js, je, xy_Temp, xy_Press ) result( xy_QVapSat )
   263      !
   264      !  *Temp* ȵ *Press* Ѥ,
   265      ! ˰漾 *QVapSat* ޤ.
   266      !
   267      ! Calculate saturation specific humidity *QVapSat* using
   268      ! temperature *Temp* and air pressure *Press*.
   269      !
   270  
   271      ! ⥸塼 ; USE statements
   272      !
   273  
   274      ! ʸ ; Declaration statements
   275      !
   276      implicit none
   277  
   278      integer , intent(in):: is
   279      integer , intent(in):: ie
   280      integer , intent(in):: js
   281      integer , intent(in):: je
   282      real(DP), intent(in):: xy_Temp (is:ie, js:je)
   283                                ! $ T $ . . Temperature
   284      real(DP), intent(in):: xy_Press(is:ie, js:je)
   285                                ! $ p $ . . Air pressure
   286      real(DP):: xy_QVapSat(is:ie, js:je)
   287                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   288  
   289      ! ѿ
   290      ! Work variables
   291      !
   292      real(DP):: xyz_Temp   (is:ie, js:je, 1:1)
   293                                ! $ T $ . . Temperature
   294      real(DP):: xyz_Press  (is:ie, js:je, 1:1)
   295                                ! $ p $ . . Air pressure
   296      real(DP):: xyz_QVapSat(is:ie, js:je, 1:1)
   297                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   298  
   299      ! ¹ʸ ; Executable statement
   300      !
   301  
   302      ! ˰漾η׻
   303      ! Calculate saturation specific humidity
   304      !
   305      xyz_Temp (:,:,1) = xy_Temp
     .        if (xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2 .gt. 0) then            
     .           J1 = and(xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2,1)              
     .  !CDIR    NODEP                                                          
     .           do t119 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t121 = 1, xyz_temp.DSC.U1 + 1 - xyz_temp.DSC.L1          
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119-1+xyz_temp.DSC.L2,1)
     .       1             = xy_temp(t37+t121-1,t119-1+t39)                     
     .                 xyz_press(xyz_press.DSC.L1+t121-1,t119-1+xyz_press.DSC.L2
     .       1            ,1) = xy_press(t44+t121-1,t119-1+t46)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t119 = J1 + 1, xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2, 2     
     .  !CDIR       NODEP                                                       
     .              do t121 = 1, xyz_temp.DSC.U1 + 1 - xyz_temp.DSC.L1          
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119-1+xyz_temp.DSC.L2,1)
     .       1             = xy_temp(t37+t121-1,t119-1+t39)                     
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119+xyz_temp.DSC.L2,1)  
     .       1             = xy_temp(t37+t121-1,t119+t39)                       
     .                 xyz_press(xyz_press.DSC.L1+t121-1,t119-1+xyz_press.DSC.L2
     .       1            ,1) = xy_press(t44+t121-1,t119-1+t46)                 
     .                 xyz_press(xyz_press.DSC.L1+t121-1,t119+xyz_press.DSC.L2,1
     .       1            ) = xy_press(t44+t121-1,t119+t46)                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   306      xyz_Press(:,:,1) = xy_Press
   307  
   308      xyz_QVapSat = xyz_CalcQVapSat( is, ie, js, je, 1, 1, xyz_Temp, xyz_Press )
   309  
   310      xy_QVapSat = xyz_QVapSat(:,:,1)
     .        if (xy_qvapsat.DESCRIPT.RETVAL.DSC.U2 + 1 -                       
     .       1   xy_qvapsat.DESCRIPT.RETVAL.DSC.L2 .gt. 0) then                 
     .           J2 = and(xy_qvapsat.DESCRIPT.RETVAL.DSC.U2 + 1 -               
     .       1      xy_qvapsat.DESCRIPT.RETVAL.DSC.L2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t131 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t133 = 1, xy_qvapsat.DESCRIPT.RETVAL.DSC.U1 + 1 -        
     .       1         xy_qvapsat.DESCRIPT.RETVAL.DSC.L1                        
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131-
     .       1            1+xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(   
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131-1+xyz_qvapsat.DSC.L2,1)
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t131 = J2 + 1, xy_qvapsat.DESCRIPT.RETVAL.DSC.U2 + 1 -      
     .       1      xy_qvapsat.DESCRIPT.RETVAL.DSC.L2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t133 = 1, xy_qvapsat.DESCRIPT.RETVAL.DSC.U1 + 1 -        
     .       1         xy_qvapsat.DESCRIPT.RETVAL.DSC.L1                        
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131-
     .       1            1+xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(   
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131-1+xyz_qvapsat.DSC.L2,1)
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131+
     .       1            xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(     
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131+xyz_qvapsat.DSC.L2,1)  
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131+
     .       1            1+xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(   
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131+1+xyz_qvapsat.DSC.L2,1)
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131+
     .       1            2+xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(   
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131+2+xyz_qvapsat.DSC.L2,1)
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   311  
   312  
   313    end function xy_CalcQVapSat
   314  
   315    !--------------------------------------------------------------------------------------
   316  
   317    function xy_CalcDQVapSatDTemp( is, ie, js, je, xy_Temp, xy_QVapSat ) result( xy_DQVapSatDTemp )
   318      !
   319      !  *Temp* ˰漾 *QVapSat* Ѥ,
   320      ! ˰漾βʬ *DQVapSatDTemp* ޤ.
   321      !
   322      ! Calculate temperature derivative of saturation specific humidity
   323      ! *DQVapSatDTemp* using
   324      ! temperature *Temp* and saturation specific humidity *QVapSat*.
   325      !
   326  
   327      ! ⥸塼 ; USE statements
   328      !
   329  
   330      ! ʸ ; Declaration statements
   331      !
   332      implicit none
   333  
   334      integer , intent(in):: is
   335      integer , intent(in):: ie
   336      integer , intent(in):: js
   337      integer , intent(in):: je
   338      real(DP), intent(in):: xy_Temp   (is:ie, js:je)
   339                                ! $ T $ . . Temperature
   340      real(DP), intent(in):: xy_QVapSat(is:ie, js:je)
   341                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   342      real(DP):: xy_DQVapSatDTemp(is:ie, js:je)
   343                                ! $ \DP{q^{*}}{T} $ . ˰漾βʬ.
   344                                ! Temperature derivative of saturation specific humidity.
   345  
   346      ! ѿ
   347      ! Work variables
   348      !
   349      real(DP):: xyz_Temp         (is:ie, js:je, 1:1)
   350                                ! $ T $ . . Temperature
   351      real(DP):: xyz_QVapSat      (is:ie, js:je, 1:1)
   352                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   353      real(DP):: xyz_DQVapSatDTemp(is:ie, js:je, 1:1)
   354                                ! $ \DP{q^{*}}{T} $ . ˰漾βʬ.
   355                                ! Temperature derivative of saturation specific humidity.
   356  
   357  
   358      xyz_Temp   (:,:,1) = xy_Temp
     .        if (xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2 .gt. 0) then            
     .           J1 = and(xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2,1)              
     .  !CDIR    NODEP                                                          
     .           do t119 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t121 = 1, xyz_temp.DSC.U1 + 1 - xyz_temp.DSC.L1          
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119-1+xyz_temp.DSC.L2,1)
     .       1             = xy_temp(t37+t121-1,t119-1+t39)                     
     .                 xyz_qvapsat(xyz_qvapsat.DSC.L1+t121-1,t119-1+            
     .       1            xyz_qvapsat.DSC.L2,1) = xy_qvapsat(t44+t121-1,t119-1+ 
     .       2            t46)                                                  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t119 = J1 + 1, xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2, 2     
     .  !CDIR       NODEP                                                       
     .              do t121 = 1, xyz_temp.DSC.U1 + 1 - xyz_temp.DSC.L1          
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119-1+xyz_temp.DSC.L2,1)
     .       1             = xy_temp(t37+t121-1,t119-1+t39)                     
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119+xyz_temp.DSC.L2,1)  
     .       1             = xy_temp(t37+t121-1,t119+t39)                       
     .                 xyz_qvapsat(xyz_qvapsat.DSC.L1+t121-1,t119-1+            
     .       1            xyz_qvapsat.DSC.L2,1) = xy_qvapsat(t44+t121-1,t119-1+ 
     .       2            t46)                                                  
     .                 xyz_qvapsat(xyz_qvapsat.DSC.L1+t121-1,t119+              
     .       1            xyz_qvapsat.DSC.L2,1) = xy_qvapsat(t44+t121-1,t119+t46
     .       2            )                                                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   359      xyz_QVapSat(:,:,1) = xy_QVapSat
   360  
   361      xyz_DQVapSatDTemp = xyz_CalcDQVapSatDTemp( is, ie, js, je, 1, 1, xyz_Temp, xyz_QVapSat )
   362  
   363      xy_DQVapSatDTemp = xyz_DQVapSatDTemp(:,:,1)
     .        if (xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U2 + 1 -                 
     .       1   xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2 .gt. 0) then           
     .           J2 = and(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U2 + 1 -         
     .       1      xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2,3)                  
     .  !CDIR    NODEP                                                          
     .           do t131 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t133 = 1, xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U1 + 1 -  
     .       1         xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1                  
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131-1+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131-1+xyz_dqvapsatdtemp.DSC.L2,1)                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t131 = J2 + 1, xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U2 + 1  
     .       1       - xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2, 4               
     .  !CDIR       NODEP                                                       
     .              do t133 = 1, xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U1 + 1 -  
     .       1         xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1                  
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131-1+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131-1+xyz_dqvapsatdtemp.DSC.L2,1)                    
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)  
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131+xyz_dqvapsatdtemp.DSC.L2,1)                      
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131+1+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131+1+xyz_dqvapsatdtemp.DSC.L2,1)                    
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131+2+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131+2+xyz_dqvapsatdtemp.DSC.L2,1)                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   364  
   365  
   366    end function xy_CalcDQVapSatDTemp
   367  
   368    !--------------------------------------------------------------------------------------
   369  
   370    subroutine SaturateInit
   371      !
   372      ! saturate_nha1992 ⥸塼νԤޤ.
   373      !--
   374      ! NAMELIST#saturate_nha1992_nml ɤ߹ߤϤμ³ǹԤޤ.
   375      !++
   376      !
   377      ! "saturate_nha1992" module is initialized.
   378      !--
   379      ! "NAMELIST#saturate_nha1992_nml" is loaded in this procedure.
   380      !++
   381  
   382      ! ⥸塼 ; USE statements
   383      !
   384  
   385      ! NAMELIST եϤ˴ؤ桼ƥƥ
   386      ! Utilities for NAMELIST file input
   387      !
   388      use namelist_util, only: namelist_filename, NmlutilMsg
   389  
   390      ! ե
   391      ! File I/O support
   392      !
   393      use dc_iounit, only: FileOpen
   394  
   395      ! ̷ѥ᥿
   396      ! Kind type parameter
   397      !
   398      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   399  
   400      ! ʸ
   401      ! Character handling
   402      !
   403      use dc_string, only: StoA
   404  
   405      ! ҥȥǡ
   406      ! History data output
   407      !
   408      use gtool_historyauto, only: HistoryAutoAddVariable
   409  
   410      ! ʸ ; Declaration statements
   411      !
   412      implicit none
   413  
   414  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   415  !!$                              ! Unit number for NAMELIST file open
   416  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   417  !!$                              ! IOSTAT of NAMELIST read
   418  
   419      ! NAMELIST ѿ
   420      ! NAMELIST group name
   421      !
   422  !!$    namelist /saturate_nha1992_nml/
   423            !
   424            ! ǥեͤˤĤƤϽ³ "saturate_nha1992#SaturateInit"
   425            ! Υɤ򻲾ȤΤ.
   426            !
   427            ! Refer to source codes in the initialization procedure
   428            ! "saturate_nha1992#SaturateInit" for the default values.
   429            !
   430  
   431      ! ¹ʸ ; Executable statement
   432      !
   433  
   434      if ( saturate_nha1992_inited ) return
   435  
   436  
   437      ! ǥեͤ
   438      ! Default values settings
   439      !
   440  
   441  
   442  !!$    ! NAMELIST ɤ߹
   443  !!$    ! NAMELIST is input
   444  !!$    !
   445  !!$    if ( trim(namelist_filename) /= '' ) then
   446  !!$      call FileOpen( unit_nml, &          ! (out)
   447  !!$        & namelist_filename, mode = 'r' ) ! (in)
   448  !!$
   449  !!$      rewind( unit_nml )
   450  !!$      read( unit_nml, &           ! (in)
   451  !!$        & nml = saturate_nha1992_nml, &  ! (out)
   452  !!$        & iostat = iostat_nml )   ! (out)
   453  !!$      close( unit_nml )
   454  !!$
   455  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   456  !!$    end if
   457  
   458      !  ; Print
   459      !
   460      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   461      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   462  
   463      saturate_nha1992_inited = .true.
   464  
   465    end subroutine SaturateInit
   466  
   467    !--------------------------------------------------------------------------------------
   468  
   469  end module saturate_nha1992
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:24 2012
FILE NAME: saturate_nha1992.f90
PROGRAM NAME: saturate_nha1992
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Nakajima et al. (1992) Ѥ˰漾λ
     2:            !
     3:            != Evaluate saturation specific humidity with Nakajima et al. (1992)
     4:            !
     5:            ! Authors::   Masaki ISHIWATARI, Yasuhiro MORIKAWA
     6:            ! Version::   $Id: saturate_nha1992.f90,v 1.5 2011-06-19 10:56:27 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module saturate_nha1992
    13:              !
    14:              != Nakajima et al. (1992) Ѥ˰漾λ
    15:              !
    16:              != Evaluate saturation specific humidity with Nakajima et al. (1992)
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! Nakajima et al. (1992) Ѥ줿˰¾ $ p^{*} $ ˴ؤʲμ
    21:              ! Ѥ, ˰漾˰漾βʬͤ򻻽Фޤ. 
    22:              !
    23:              ! Saturation specific humidity and temperature derivative of it 
    24:              ! are calculated with a folloing formula for saturation watar vapor pressure 
    25:              ! $ p^{*} $ in Nakajima et al. (1992). 
    26:              ! 
    27:              ! \[
    28:              !    p^{*} (T) = p_0^{*} \exp \left( - \frac{l}{RT} \right). 
    29:              ! \]
    30:              !
    31:              ! , $ T $ ϲ, $ R $ ׵Ǥ. 
    32:              ! $ R $ Ǯ $ l $ , 
    33:              ! ˰¶ $ p_0^{*} $ ϰʲΤ褦Ϳޤ. 
    34:              !
    35:              ! where $ T $ is temperature, $ R $ is the gas constant. 
    36:              ! $ R $ and latent heat $ l $ , 
    37:              ! constant for the water vapor saturation curve $ p_0^{*} $ are as follows.
    38:              ! 
    39:              ! * $ R = 8.314 $ [J mol-1 K-1]
    40:              ! * $ l = 43655 $ [J mol-1]
    41:              ! * $ p_0^{*} = 1.4 \times 10^{11} $ [Pa]
    42:              !
    43:              ! ˰¿˰漾 $ q^{*} $ ݤˤ, ʲμѤޤ. 
    44:              !
    45:              ! Saturation specific humidity $ q^{*} $ is calculated from 
    46:              ! saturation watar vapor pressure as follows.
    47:              !
    48:              ! \[
    49:              !    q^{*} (T, p) = \varepsilon \frac{p^{*} (T)}{p}
    50:              ! \]
    51:              !
    52:              !  $ \varepsilon $ ϶ŷʬ絤ʬ, 
    53:              ! $ p $ ϵǤ. 
    54:              !
    55:              ! where $ \varepsilon $ is molecular weight ratio of water vapor to air, 
    56:              ! $ p $ is air pressure. 
    57:              ! 
    58:              ! ä, ˰漾, ˰漾βѲ뼰ϰʲΤ褦
    59:              ! ʤޤ. 
    60:              !
    61:              ! Therefore, saturation specific humidity and temperature derivative of it 
    62:              ! are calculated as follows. 
    63:              !
    64:              ! \[
    65:              !    q^{*} (T, p) = \varepsilon \frac{p_0^{*}}{p} \exp \left( - \frac{l}{RT} \right), \] \[
    66:              !    \DP{q^{*} (T, p)}{T} = \varepsilon \frac{p_0^{*}}{p} \frac{l}{RT^2} \exp \left( - \frac{l}{RT} \right) 
    67:              !    = q^{*} \frac{l}{RT^2}
    68:              ! \]
    69:              !
    70:              !== References
    71:              !
    72:              ! * Nakajima, S., Hayashi, Y.-Y., Abe, Y., 1992: 
    73:              !   A study on the "runaway greenhouse effect" with a 
    74:              !   one dimensional radiative convective equilibrium model. 
    75:              !   <i>J. Atmos. Sci.</i>, <b>49</b>, 2256--2266.
    76:              !
    77:              !== Procedures List
    78:              !
    79:              ! CalcQVapSat            :: ˰漾η׻
    80:              ! CalcDQVapSatDTemp      :: ˰漾βʬη׻
    81:              ! ------------  :: ------------
    82:              ! CalcQVapSat            :: Calculate saturation specific humidity
    83:              ! CalcDQVapSatDTemp      :: Calculate temperature derivative of saturation specific humidity
    84:              !
    85:              !--
    86:              !== NAMELIST
    87:              !
    88:              ! NAMELIST#saturate_nha1992_nml
    89:              !++
    90:            
    91:              ! ⥸塼 ; USE statements
    92:              !
    93:            
    94:              ! ̷ѥ᥿
    95:              ! Kind type parameter
    96:              !
    97:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    98:                &                 STRING     ! ʸ.       Strings. 
    99:            
   100:              ! å
   101:              ! Message output
   102:              !
   103:              use dc_message, only: MessageNotify
   104:            
   105:              ! ʸ ; Declaration statements
   106:              !
   107:              implicit none
   108:              private
   109:            
   110:              ! ³
   111:              ! Public procedure
   112:              !
   113:              public:: xy_CalcQVapSat , xy_CalcDQVapSatDTemp
   114:              public:: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
   115:            
   116:              ! ѿ
   117:              ! Public variables
   118:              !
   119:              logical, save, public:: saturate_nha1992_inited = .false.
   120:                                          ! ե饰. 
   121:                                          ! Initialization flag
   122:            
   123:              ! ѿ
   124:              ! Private variables
   125:              !
   126:              real(DP), parameter:: LatHeat = 43655_DP
   127:                                          ! $ l $ [J mol-1].
   128:                                          ! ζŷǮ. Latent heat of condensation of water vapor
   129:              real(DP), parameter:: P0 = 1.4e+11_DP
   130:                                          ! $ p_0^{*} $ [Pa].
   131:                                          ! ˰¶. constant for water vapor saturation curve
   132:            
   133:              character(*), parameter:: module_name = 'saturate_nha1992'
   134:                                          ! ⥸塼̾. 
   135:                                          ! Module name
   136:              character(*), parameter:: version = &
   137:                & '$Name: dcpam5-20120921 $' // &
   138:                & '$Id: saturate_nha1992.f90,v 1.5 2011-06-19 10:56:27 yot Exp $'
   139:                                          ! ⥸塼ΥС
   140:                                          ! Module version
   141:            
   142:            contains
   143:            
   144:              !--------------------------------------------------------------------------------------
   145:            
   146:              function xyz_CalcQVapSat( is, ie, js, je, ks, ke, xyz_Temp, xyz_Press ) result( xyz_QVapSat )
   147:                !
   148:                !  *Temp* ȵ *Press* Ѥ, 
   149:                ! ˰漾 *QVapSat* ޤ. 
   150:                !
   151:                ! Calculate saturation specific humidity *QVapSat* using
   152:                ! temperature *Temp* and air pressure *Press*. 
   153:                !
   154:            
   155:                ! ⥸塼 ; USE statements
   156:                !
   157:            
   158:                ! ʪ
   159:                ! Physical and mathematical constants settings
   160:                !
   161:                use constants0, only: &
   162:                  & GasRUniv              ! $ R^{*} $ [J K-1 mol-1].
   163:                                          ! ׵.  Universal gas constant
   164:            
   165:                ! ʪ
   166:                ! Physical constants settings
   167:                !
   168:                use constants, only: &
   169:                  & EpsV                  ! $ \epsilon_v $ . 
   170:                                          ! ʬ. 
   171:                                          ! Molecular weight of water vapor
   172:            
   173:                ! ʸ ; Declaration statements
   174:                !
   175:                implicit none
   176:            
   177:                integer , intent(in):: is
   178:                integer , intent(in):: ie
   179:                integer , intent(in):: js
   180:                integer , intent(in):: je
   181:                integer , intent(in):: ks
   182:                integer , intent(in):: ke
   183:                real(DP), intent(in):: xyz_Temp (is:ie, js:je, ks:ke)
   184:                                          ! $ T $ . . Temperature
   185:                real(DP), intent(in):: xyz_Press(is:ie, js:je, ks:ke)
   186:                                          ! $ p $ . . Air pressure
   187:                real(DP):: xyz_QVapSat(is:ie, js:je, ks:ke)
   188:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   189:            
   190:                ! ѿ
   191:                ! Work variables
   192:                !
   193:            
   194:                ! ¹ʸ ; Executable statement
   195:                !
   196:            
   197:                ! ˰漾η׻
   198:                ! Calculate saturation specific humidity
   199:                !
   200: WW*====        xyz_QVapSat = EpsV * ( P0 / xyz_Press ) * exp ( - LatHeat / ( GasRUniv * xyz_Temp ) )
   201:            
   202:            
   203:              end function xyz_CalcQVapSat
   204:            
   205:              !--------------------------------------------------------------------------------------
   206:            
   207:              function xyz_CalcDQVapSatDTemp( is, ie, js, je, ks, ke, xyz_Temp, xyz_QVapSat ) result( xyz_DQVapSatDTemp )
   208:                !
   209:                !  *Temp* ˰漾 *QVapSat* Ѥ, 
   210:                ! ˰漾βʬ *DQVapSatDTemp* ޤ. 
   211:                !
   212:                ! Calculate temperature derivative of saturation specific humidity 
   213:                ! *DQVapSatDTemp* using
   214:                ! temperature *Temp* and saturation specific humidity *QVapSat*. 
   215:                !
   216:            
   217:                ! ⥸塼 ; USE statements
   218:                !
   219:            
   220:                ! ʪ
   221:                ! Physical and mathematical constants settings
   222:                !
   223:                use constants0, only: &
   224:                  & GasRUniv              ! $ R^{*} $ [J K-1 mol-1].
   225:                                          ! ׵.  Universal gas constant
   226:            
   227:                ! ʸ ; Declaration statements
   228:                !
   229:                implicit none
   230:            
   231:                integer , intent(in):: is
   232:                integer , intent(in):: ie
   233:                integer , intent(in):: js
   234:                integer , intent(in):: je
   235:                integer , intent(in):: ks
   236:                integer , intent(in):: ke
   237:                real(DP), intent(in):: xyz_Temp   (is:ie, js:je, ks:ke)
   238:                                          ! $ T $ . . Temperature
   239:                real(DP), intent(in):: xyz_QVapSat(is:ie, js:je, ks:ke)
   240:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   241:                real(DP):: xyz_DQVapSatDTemp(is:ie, js:je, ks:ke)
   242:                                          ! $ \DP{q^{*}}{T} $ . ˰漾βʬ. 
   243:                                          ! Temperature derivative of saturation specific humidity. 
   244:            
   245:                ! ѿ
   246:                ! Work variables
   247:                !
   248:            
   249:                ! ¹ʸ ; Executable statement
   250:                !
   251:            
   252:                ! ˰漾βʬη׻
   253:                ! Calculate temperature derivative of saturation specific humidity
   254:                !
   255: ***====        xyz_DQVapSatDTemp = xyz_QVapSat * LatHeat / ( GasRUniv * xyz_Temp**2 )
   256:            
   257:            
   258:              end function xyz_CalcDQVapSatDTemp
   259:            
   260:              !--------------------------------------------------------------------------------------
   261:            
   262:              function xy_CalcQVapSat( is, ie, js, je, xy_Temp, xy_Press ) result( xy_QVapSat )
   263:                !
   264:                !  *Temp* ȵ *Press* Ѥ, 
   265:                ! ˰漾 *QVapSat* ޤ. 
   266:                !
   267:                ! Calculate saturation specific humidity *QVapSat* using
   268:                ! temperature *Temp* and air pressure *Press*. 
   269:                !
   270:            
   271:                ! ⥸塼 ; USE statements
   272:                !
   273:            
   274:                ! ʸ ; Declaration statements
   275:                !
   276:                implicit none
   277:            
   278:                integer , intent(in):: is
   279:                integer , intent(in):: ie
   280:                integer , intent(in):: js
   281:                integer , intent(in):: je
   282:                real(DP), intent(in):: xy_Temp (is:ie, js:je)
   283:                                          ! $ T $ . . Temperature
   284:                real(DP), intent(in):: xy_Press(is:ie, js:je)
   285:                                          ! $ p $ . . Air pressure
   286:                real(DP):: xy_QVapSat(is:ie, js:je)
   287:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   288:            
   289:                ! ѿ
   290:                ! Work variables
   291:                !
   292:                real(DP):: xyz_Temp   (is:ie, js:je, 1:1)
   293:                                          ! $ T $ . . Temperature
   294:                real(DP):: xyz_Press  (is:ie, js:je, 1:1)
   295:                                          ! $ p $ . . Air pressure
   296:                real(DP):: xyz_QVapSat(is:ie, js:je, 1:1)
   297:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   298:            
   299:                ! ¹ʸ ; Executable statement
   300:                !
   301:            
   302:                ! ˰漾η׻
   303:                ! Calculate saturation specific humidity
   304:                !
   305: *V----->       xyz_Temp (:,:,1) = xy_Temp
   306: *V-----        xyz_Press(:,:,1) = xy_Press
   307:            
   308:                xyz_QVapSat = xyz_CalcQVapSat( is, ie, js, je, 1, 1, xyz_Temp, xyz_Press )
   309:            
   310: +V=====        xy_QVapSat = xyz_QVapSat(:,:,1)
   311:            
   312:            
   313:              end function xy_CalcQVapSat
   314:            
   315:              !--------------------------------------------------------------------------------------
   316:            
   317:              function xy_CalcDQVapSatDTemp( is, ie, js, je, xy_Temp, xy_QVapSat ) result( xy_DQVapSatDTemp )
   318:                !
   319:                !  *Temp* ˰漾 *QVapSat* Ѥ, 
   320:                ! ˰漾βʬ *DQVapSatDTemp* ޤ. 
   321:                !
   322:                ! Calculate temperature derivative of saturation specific humidity 
   323:                ! *DQVapSatDTemp* using
   324:                ! temperature *Temp* and saturation specific humidity *QVapSat*. 
   325:                !
   326:            
   327:                ! ⥸塼 ; USE statements
   328:                !
   329:            
   330:                ! ʸ ; Declaration statements
   331:                !
   332:                implicit none
   333:            
   334:                integer , intent(in):: is
   335:                integer , intent(in):: ie
   336:                integer , intent(in):: js
   337:                integer , intent(in):: je
   338:                real(DP), intent(in):: xy_Temp   (is:ie, js:je)
   339:                                          ! $ T $ . . Temperature
   340:                real(DP), intent(in):: xy_QVapSat(is:ie, js:je)
   341:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   342:                real(DP):: xy_DQVapSatDTemp(is:ie, js:je)
   343:                                          ! $ \DP{q^{*}}{T} $ . ˰漾βʬ. 
   344:                                          ! Temperature derivative of saturation specific humidity. 
   345:            
   346:                ! ѿ
   347:                ! Work variables
   348:                !
   349:                real(DP):: xyz_Temp         (is:ie, js:je, 1:1)
   350:                                          ! $ T $ . . Temperature
   351:                real(DP):: xyz_QVapSat      (is:ie, js:je, 1:1)
   352:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   353:                real(DP):: xyz_DQVapSatDTemp(is:ie, js:je, 1:1)
   354:                                          ! $ \DP{q^{*}}{T} $ . ˰漾βʬ. 
   355:                                          ! Temperature derivative of saturation specific humidity. 
   356:            
   357:            
   358: *V----->       xyz_Temp   (:,:,1) = xy_Temp
   359: *V-----        xyz_QVapSat(:,:,1) = xy_QVapSat
   360:            
   361:                xyz_DQVapSatDTemp = xyz_CalcDQVapSatDTemp( is, ie, js, je, 1, 1, xyz_Temp, xyz_QVapSat )
   362:            
   363: +V=====        xy_DQVapSatDTemp = xyz_DQVapSatDTemp(:,:,1)
   364:            
   365:            
   366:              end function xy_CalcDQVapSatDTemp
   367:            
   368:              !--------------------------------------------------------------------------------------
   369:            
   370:              subroutine SaturateInit
   371:                !
   372:                ! saturate_nha1992 ⥸塼νԤޤ. 
   373:                !--
   374:                ! NAMELIST#saturate_nha1992_nml ɤ߹ߤϤμ³ǹԤޤ. 
   375:                !++
   376:                !
   377:                ! "saturate_nha1992" module is initialized. 
   378:                !--
   379:                ! "NAMELIST#saturate_nha1992_nml" is loaded in this procedure. 
   380:                !++
   381:            
   382:                ! ⥸塼 ; USE statements
   383:                !
   384:            
   385:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   386:                ! Utilities for NAMELIST file input
   387:                !
   388:                use namelist_util, only: namelist_filename, NmlutilMsg
   389:            
   390:                ! ե
   391:                ! File I/O support
   392:                !
   393:                use dc_iounit, only: FileOpen
   394:            
   395:                ! ̷ѥ᥿
   396:                ! Kind type parameter
   397:                !
   398:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   399:            
   400:                ! ʸ
   401:                ! Character handling
   402:                !
   403:                use dc_string, only: StoA
   404:            
   405:                ! ҥȥǡ
   406:                ! History data output
   407:                !
   408:                use gtool_historyauto, only: HistoryAutoAddVariable
   409:            
   410:                ! ʸ ; Declaration statements
   411:                !
   412:                implicit none
   413:            
   414:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   415:            !!$                              ! Unit number for NAMELIST file open
   416:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   417:            !!$                              ! IOSTAT of NAMELIST read
   418:            
   419:                ! NAMELIST ѿ
   420:                ! NAMELIST group name
   421:                !
   422:            !!$    namelist /saturate_nha1992_nml/ 
   423:                      !
   424:                      ! ǥեͤˤĤƤϽ³ "saturate_nha1992#SaturateInit" 
   425:                      ! Υɤ򻲾ȤΤ. 
   426:                      !
   427:                      ! Refer to source codes in the initialization procedure
   428:                      ! "saturate_nha1992#SaturateInit" for the default values. 
   429:                      !
   430:            
   431:                ! ¹ʸ ; Executable statement
   432:                !
   433:            
   434:                if ( saturate_nha1992_inited ) return
   435:            
   436:            
   437:                ! ǥեͤ
   438:                ! Default values settings
   439:                !
   440:            
   441:            
   442:            !!$    ! NAMELIST ɤ߹
   443:            !!$    ! NAMELIST is input
   444:            !!$    !
   445:            !!$    if ( trim(namelist_filename) /= '' ) then
   446:            !!$      call FileOpen( unit_nml, &          ! (out)
   447:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   448:            !!$
   449:            !!$      rewind( unit_nml )
   450:            !!$      read( unit_nml, &           ! (in)
   451:            !!$        & nml = saturate_nha1992_nml, &  ! (out)
   452:            !!$        & iostat = iostat_nml )   ! (out)
   453:            !!$      close( unit_nml )
   454:            !!$
   455:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   456:            !!$    end if
   457:            
   458:                !  ; Print
   459:                !
   460:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   461:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   462:            
   463:                saturate_nha1992_inited = .true.
   464:            
   465:              end subroutine SaturateInit
   466:            
   467:              !--------------------------------------------------------------------------------------
   468:            
   469:            end module saturate_nha1992
