Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:25 2012
FILE NAME: saturate_t1930.f90
PROGRAM NAME: saturate_t1930
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   170  opt  (1593): Loop nest collapsed into one loop.
   170  vec  (   4): Vectorized array expression.
   232  opt  (1593): Loop nest collapsed into one loop.
   232  vec  (   4): Vectorized array expression.
   278  opt  (  11): Fused array assignments. :line 278 - 279
   278  vec  (   4): Vectorized array expression.
   278  vec  (   4): Vectorized array expression.
   279  opt  (1592): Outer loop unrolled inside inner loop.
   283  opt  (1592): Outer loop unrolled inside inner loop.
   283  vec  (   4): Vectorized array expression.
   283  vec  (   4): Vectorized array expression.
   334  opt  (  11): Fused array assignments. :line 334 - 335
   334  vec  (   4): Vectorized array expression.
   334  vec  (   4): Vectorized array expression.
   335  opt  (1592): Outer loop unrolled inside inner loop.
   339  opt  (1592): Outer loop unrolled inside inner loop.
   339  vec  (   4): Vectorized array expression.
   339  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:25 2012
FILE NAME: saturate_t1930.f90
PROGRAM NAME: saturate_t1930
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Tetens (1930) Ѥ˰漾λ
     2  !
     3  != Evaluate saturation specific humidity with Tetens (1930)
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6  ! Version::   $Id: saturate_t1930.f90,v 1.2 2011-06-19 10:56:27 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module saturate_t1930
    13    !
    14    != Tetens (1930) Ѥ˰漾λ
    15    !
    16    != Evaluate saturation specific humidity with Tetens (1930)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! Tetens (1930) , ˰¾ $ p^{*} $ ˴ؤʲμ
    21    ! Ѥ, ˰漾˰漾βʬͤ򻻽Фޤ.
    22    !
    23    ! Saturation specific humidity and temperature derivative of it
    24    ! are calculated with a folloing formula for saturation watar vapor pressure
    25    ! $ p^{*} $ in Tetens (1930).
    26    !
    27    ! \[
    28    !    q^{*} (T, p)
    29    !      = 611 \varepsilon
    30    !        \frac{ \exp \left( \frac{l}{R_v}
    31    !                           \left( \frac{1}{273} - \frac{1}{T} \right)
    32    !                    \right) } { p } \] \[
    33    !    \DP{q^{*} (T, p)}{T}
    34    !      = 611 \varepsilon \frac{l}{R_v T^2}
    35    !        \frac{ \exp \left( \frac{l}{R_v}
    36    !                           \left( \frac{1}{273} - \frac{1}{T} \right)
    37    !                    \right) } { p }
    38    !      = \frac{q^{*} l}{R_v T^2}
    39    ! \]
    40    !
    41    ! , $ T $ ϲ, $ p $ ϵ, $ R_v $ ϶ŷʬε,
    42    ! $ \varepsilon $ ϶ŷʬ絤ʬ,
    43    ! $ l $ ϶ŷʬǮǤ.
    44    !
    45    !== References
    46    !
    47    ! * Tetens, O., 1930:
    48    !   Uder einige meteorologische Begriffe.
    49    !   <i>Zeitschrift fur Geophysik</i>, <b>6</b>, 297--309.
    50    !
    51    !== Procedures List
    52    !
    53    ! CalcQVapSat            :: ˰漾η׻
    54    ! CalcDQVapSatDTemp      :: ˰漾βʬη׻
    55    ! ------------  :: ------------
    56    ! CalcQVapSat            :: Calculate saturation specific humidity
    57    ! CalcDQVapSatDTemp      :: Calculate temperature derivative of saturation specific humidity
    58    !
    59    !--
    60    !== NAMELIST
    61    !
    62    ! NAMELIST#saturate_t1930_nml
    63    !++
    64  
    65    ! ⥸塼 ; USE statements
    66    !
    67  
    68    ! ̷ѥ᥿
    69    ! Kind type parameter
    70    !
    71    use dc_types, only: DP, &      ! ټ¿. Double precision.
    72      &                 STRING     ! ʸ.       Strings.
    73  
    74    ! å
    75    ! Message output
    76    !
    77    use dc_message, only: MessageNotify
    78  
    79    ! ʸ ; Declaration statements
    80    !
    81    implicit none
    82    private
    83  
    84    ! ³
    85    ! Public procedure
    86    !
    87    public:: xy_CalcQVapSat , xy_CalcDQVapSatDTemp
    88    public:: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
    89  
    90    ! ѿ
    91    ! Public variables
    92    !
    93    logical, save, public:: saturate_t1930_inited = .false.
    94                                ! ե饰.
    95                                ! Initialization flag
    96  
    97    ! ѿ
    98    ! Private variables
    99    !
   100    real(DP), parameter:: Es0 = 611.0_DP
   101                                ! 0 ˰¾ [Pa].
   102                                ! Saturation water vapor pressure at 0 deg C [Pa]
   103  
   104    character(*), parameter:: module_name = 'saturate_t1930'
   105                                ! ⥸塼̾.
   106                                ! Module name
   107    character(*), parameter:: version = &
   108      & '$Name: dcpam5-20120921 $' // &
   109      & '$Id: saturate_t1930.f90,v 1.2 2011-06-19 10:56:27 yot Exp $'
   110                                ! ⥸塼ΥС
   111                                ! Module version
   112  
   113  contains
   114  
   115    !--------------------------------------------------------------------------------------
   116  
   117    function xyz_CalcQVapSat( is, ie, js, je, ks, ke, xyz_Temp, xyz_Press ) result( xyz_QVapSat )
   118      !
   119      !  *Temp* ȵ *Press* Ѥ,
   120      ! ˰漾 *QVapSat* ޤ.
   121      !
   122      ! Calculate saturation specific humidity *QVapSat* using
   123      ! temperature *Temp* and air pressure *Press*.
   124      !
   125  
   126      ! ⥸塼 ; USE statements
   127      !
   128  
   129      ! ʪ
   130      ! Physical constants settings
   131      !
   132      use constants, only: &
   133        & GasRWet, &
   134                                ! $ R_v $ [J kg-1 K-1].
   135                                ! ŷʬε.
   136                                ! Gas constant of condensible elements
   137        & LatentHeat, &
   138                                ! $ L $ [J kg-1] .
   139                                ! ŷǮ.
   140                                ! Latent heat of condensation
   141        & EpsV                  ! $ \epsilon_v $ .
   142                                ! ʬ.
   143                                ! Molecular weight of water vapor
   144  
   145      ! ʸ ; Declaration statements
   146      !
   147      implicit none
   148  
   149      integer , intent(in):: is
   150      integer , intent(in):: ie
   151      integer , intent(in):: js
   152      integer , intent(in):: je
   153      integer , intent(in):: ks
   154      integer , intent(in):: ke
   155      real(DP), intent(in):: xyz_Temp (is:ie, js:je, ks:ke)
   156                                ! $ T $ . . Temperature
   157      real(DP), intent(in):: xyz_Press(is:ie, js:je, ks:ke)
   158                                ! $ p $ . . Air pressure
   159  
   160      real(DP):: xyz_QVapSat(is:ie, js:je, ks:ke)
   161                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   162  
   163      ! ѿ
   164      ! Work variables
   165      !
   166  
   167      ! ¹ʸ ; Executable statement
   168      !
   169  
   170      xyz_QVapSat = &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t84 = 1, (ke + 1 - ks)*(je + 1 - js)*(ie + 1 - is)             
     .           xyz_qvapsat(xyz_qvapsat.DESCRIPT.RETVAL.DSC.L1+t84-1,          
     .       1      xyz_qvapsat.DESCRIPT.RETVAL.DSC.L2,                         
     .       2      xyz_qvapsat.DESCRIPT.RETVAL.DSC.L3) = epsv*                 
     .       3      6.11000000000000e+002*dexp(latentheat/gasrwet*(             
     .       4      3.66300367750227e-003 - 1.00000000000000e+000/xyz_temp(t18+ 
     .       5      t84-1,t20,t22)))/xyz_press(t28+t84-1,t30,t32)               
     .        end do                                                            
   171        & EpsV * Es0 * exp( LatentHeat / GasRWet * ( 1./273. - 1./xyz_Temp ) ) &
   172        & / xyz_Press
   173  
   174  
   175    end function xyz_CalcQVapSat
   176  
   177    !--------------------------------------------------------------------------------------
   178  
   179    function xyz_CalcDQVapSatDTemp( is, ie, js, je, ks, ke, xyz_Temp, xyz_QVapSat ) result( xyz_DQVapSatDTemp )
   180      !
   181      !  *Temp* ˰漾 *QVapSat* Ѥ,
   182      ! ˰漾βʬ *DQVapSatDTemp* ޤ.
   183      !
   184      ! Calculate temperature derivative of saturation specific humidity
   185      ! *DQVapSatDTemp* using
   186      ! temperature *Temp* and saturation specific humidity *QVapSat*.
   187      !
   188  
   189      ! ⥸塼 ; USE statements
   190      !
   191  
   192      ! ʪ
   193      ! Physical constants settings
   194      !
   195      use constants, only: &
   196        & GasRWet, &
   197                                ! $ R_v $ [J kg-1 K-1].
   198                                ! ŷʬε.
   199                                ! Gas constant of condensible elements
   200        & LatentHeat, &
   201                                ! $ L $ [J kg-1] .
   202                                ! ŷǮ.
   203                                ! Latent heat of condensation
   204        & EpsV                  ! $ \epsilon_v $ .
   205                                ! ʬ.
   206                                ! Molecular weight of water vapor
   207  
   208      ! ʸ ; Declaration statements
   209      !
   210      implicit none
   211  
   212      integer , intent(in):: is
   213      integer , intent(in):: ie
   214      integer , intent(in):: js
   215      integer , intent(in):: je
   216      integer , intent(in):: ks
   217      integer , intent(in):: ke
   218      real(DP), intent(in):: xyz_Temp   (is:ie, js:je, ks:ke)
   219                                ! $ T $ . . Temperature
   220      real(DP), intent(in):: xyz_QVapSat(is:ie, js:je, ks:ke)
   221                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   222      real(DP):: xyz_DQVapSatDTemp(is:ie, js:je, ks:ke)
   223                                ! $ \DP{q^{*}}{T} $ . ˰漾βʬ.
   224                                ! Temperature derivative of saturation specific humidity.
   225  
   226      ! ѿ
   227      ! Work variables
   228      !
   229  
   230      ! ¹ʸ ; Executable statement
   231      !
   232      xyz_DQVapSatDTemp = LatentHeat * xyz_QVapSat / ( GasRWet * xyz_Temp**2 )
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t81 = 1, (ke + 1 - ks)*(je + 1 - js)*(ie + 1 - is)             
     .           xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+t81-
     .       1      1,xyz_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2,                 
     .       2      xyz_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L3) = latentheat*     
     .       3      xyz_qvapsat(t28+t81-1,t30,t32)/(gasrwet*xyz_temp(t18+t81-1, 
     .       4      t20,t22)**2)                                                
     .        end do                                                            
   233  
   234  
   235    end function xyz_CalcDQVapSatDTemp
   236  
   237    !--------------------------------------------------------------------------------------
   238  
   239    function xy_CalcQVapSat( is, ie, js, je, xy_Temp, xy_Press ) result( xy_QVapSat )
   240      !
   241      !  *Temp* ȵ *Press* Ѥ,
   242      ! ˰漾 *QVapSat* ޤ.
   243      !
   244      ! Calculate saturation specific humidity *QVapSat* using
   245      ! temperature *Temp* and air pressure *Press*.
   246      !
   247  
   248      ! ⥸塼 ; USE statements
   249      !
   250  
   251      ! ʸ ; Declaration statements
   252      !
   253      implicit none
   254  
   255      integer , intent(in):: is
   256      integer , intent(in):: ie
   257      integer , intent(in):: js
   258      integer , intent(in):: je
   259      real(DP), intent(in):: xy_Temp (is:ie, js:je)
   260                                ! $ T $ . . Temperature
   261      real(DP), intent(in):: xy_Press(is:ie, js:je)
   262                                ! $ p $ . . Air pressure
   263  
   264      real(DP):: xy_QVapSat(is:ie, js:je)
   265                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   266  
   267      ! ѿ
   268      ! Work variables
   269      !
   270      real(DP):: xyz_Temp   (is:ie, js:je, 1:1)
   271                                ! $ T $ . . Temperature
   272      real(DP):: xyz_Press  (is:ie, js:je, 1:1)
   273                                ! $ p $ . . Air pressure
   274      real(DP):: xyz_QVapSat(is:ie, js:je, 1:1)
   275                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   276  
   277  
   278      xyz_Temp (:,:,1) = xy_Temp
     .        if (xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2 .gt. 0) then            
     .           J1 = and(xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2,1)              
     .  !CDIR    NODEP                                                          
     .           do t119 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t121 = 1, xyz_temp.DSC.U1 + 1 - xyz_temp.DSC.L1          
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119-1+xyz_temp.DSC.L2,1)
     .       1             = xy_temp(t37+t121-1,t119-1+t39)                     
     .                 xyz_press(xyz_press.DSC.L1+t121-1,t119-1+xyz_press.DSC.L2
     .       1            ,1) = xy_press(t44+t121-1,t119-1+t46)                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t119 = J1 + 1, xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2, 2     
     .  !CDIR       NODEP                                                       
     .              do t121 = 1, xyz_temp.DSC.U1 + 1 - xyz_temp.DSC.L1          
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119-1+xyz_temp.DSC.L2,1)
     .       1             = xy_temp(t37+t121-1,t119-1+t39)                     
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119+xyz_temp.DSC.L2,1)  
     .       1             = xy_temp(t37+t121-1,t119+t39)                       
     .                 xyz_press(xyz_press.DSC.L1+t121-1,t119-1+xyz_press.DSC.L2
     .       1            ,1) = xy_press(t44+t121-1,t119-1+t46)                 
     .                 xyz_press(xyz_press.DSC.L1+t121-1,t119+xyz_press.DSC.L2,1
     .       1            ) = xy_press(t44+t121-1,t119+t46)                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   279      xyz_Press(:,:,1) = xy_Press
   280  
   281      xyz_QVapSat = xyz_CalcQVapSat( is, ie, js, je, 1, 1, xyz_Temp, xyz_Press )
   282  
   283      xy_QVapSat = xyz_QVapSat(:,:,1)
     .        if (xy_qvapsat.DESCRIPT.RETVAL.DSC.U2 + 1 -                       
     .       1   xy_qvapsat.DESCRIPT.RETVAL.DSC.L2 .gt. 0) then                 
     .           J2 = and(xy_qvapsat.DESCRIPT.RETVAL.DSC.U2 + 1 -               
     .       1      xy_qvapsat.DESCRIPT.RETVAL.DSC.L2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t131 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t133 = 1, xy_qvapsat.DESCRIPT.RETVAL.DSC.U1 + 1 -        
     .       1         xy_qvapsat.DESCRIPT.RETVAL.DSC.L1                        
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131-
     .       1            1+xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(   
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131-1+xyz_qvapsat.DSC.L2,1)
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t131 = J2 + 1, xy_qvapsat.DESCRIPT.RETVAL.DSC.U2 + 1 -      
     .       1      xy_qvapsat.DESCRIPT.RETVAL.DSC.L2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t133 = 1, xy_qvapsat.DESCRIPT.RETVAL.DSC.U1 + 1 -        
     .       1         xy_qvapsat.DESCRIPT.RETVAL.DSC.L1                        
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131-
     .       1            1+xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(   
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131-1+xyz_qvapsat.DSC.L2,1)
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131+
     .       1            xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(     
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131+xyz_qvapsat.DSC.L2,1)  
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131+
     .       1            1+xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(   
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131+1+xyz_qvapsat.DSC.L2,1)
     .                 xy_qvapsat(xy_qvapsat.DESCRIPT.RETVAL.DSC.L1+t133-1,t131+
     .       1            2+xy_qvapsat.DESCRIPT.RETVAL.DSC.L2) = xyz_qvapsat(   
     .       2            xyz_qvapsat.DSC.L1+t133-1,t131+2+xyz_qvapsat.DSC.L2,1)
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   284  
   285  
   286    end function xy_CalcQVapSat
   287  
   288    !--------------------------------------------------------------------------------------
   289  
   290    function xy_CalcDQVapSatDTemp( is, ie, js, je, xy_Temp, xy_QVapSat ) result( xy_DQVapSatDTemp )
   291      !
   292      !  *Temp* ˰漾 *QVapSat* Ѥ,
   293      ! ˰漾βʬ *DQVapSatDTemp* ޤ.
   294      !
   295      ! Calculate temperature derivative of saturation specific humidity
   296      ! *DQVapSatDTemp* using
   297      ! temperature *Temp* and saturation specific humidity *QVapSat*.
   298      !
   299  
   300      ! ⥸塼 ; USE statements
   301      !
   302  
   303      ! ʸ ; Declaration statements
   304      !
   305      implicit none
   306  
   307      integer , intent(in):: is
   308      integer , intent(in):: ie
   309      integer , intent(in):: js
   310      integer , intent(in):: je
   311      real(DP), intent(in):: xy_Temp   (is:ie, js:je)
   312                                ! $ T $ . . Temperature
   313      real(DP), intent(in):: xy_QVapSat(is:ie, js:je)
   314                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   315      real(DP):: xy_DQVapSatDTemp(is:ie, js:je)
   316                                ! $ \DP{q^{*}}{T} $ . ˰漾βʬ.
   317                                ! Temperature derivative of saturation specific humidity.
   318  
   319      ! ѿ
   320      ! Work variables
   321      !
   322      real(DP):: xyz_Temp   (is:ie, js:je, 1:1)
   323                                ! $ T $ . . Temperature
   324      real(DP):: xyz_QVapSat(is:ie, js:je, 1:1)
   325                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   326      real(DP):: xyz_DQVapSatDTemp(is:ie, js:je, 1:1)
   327                                ! $ \DP{q^{*}}{T} $ . ˰漾βʬ.
   328                                ! Temperature derivative of saturation specific humidity.
   329  
   330  
   331      ! ¹ʸ ; Executable statement
   332      !
   333  
   334      xyz_Temp   (:,:,1) = xy_Temp
     .        if (xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2 .gt. 0) then            
     .           J1 = and(xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2,1)              
     .  !CDIR    NODEP                                                          
     .           do t119 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t121 = 1, xyz_temp.DSC.U1 + 1 - xyz_temp.DSC.L1          
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119-1+xyz_temp.DSC.L2,1)
     .       1             = xy_temp(t37+t121-1,t119-1+t39)                     
     .                 xyz_qvapsat(xyz_qvapsat.DSC.L1+t121-1,t119-1+            
     .       1            xyz_qvapsat.DSC.L2,1) = xy_qvapsat(t44+t121-1,t119-1+ 
     .       2            t46)                                                  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t119 = J1 + 1, xyz_temp.DSC.U2 + 1 - xyz_temp.DSC.L2, 2     
     .  !CDIR       NODEP                                                       
     .              do t121 = 1, xyz_temp.DSC.U1 + 1 - xyz_temp.DSC.L1          
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119-1+xyz_temp.DSC.L2,1)
     .       1             = xy_temp(t37+t121-1,t119-1+t39)                     
     .                 xyz_temp(xyz_temp.DSC.L1+t121-1,t119+xyz_temp.DSC.L2,1)  
     .       1             = xy_temp(t37+t121-1,t119+t39)                       
     .                 xyz_qvapsat(xyz_qvapsat.DSC.L1+t121-1,t119-1+            
     .       1            xyz_qvapsat.DSC.L2,1) = xy_qvapsat(t44+t121-1,t119-1+ 
     .       2            t46)                                                  
     .                 xyz_qvapsat(xyz_qvapsat.DSC.L1+t121-1,t119+              
     .       1            xyz_qvapsat.DSC.L2,1) = xy_qvapsat(t44+t121-1,t119+t46
     .       2            )                                                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   335      xyz_QVapSat(:,:,1) = xy_QVapSat
   336  
   337      xyz_DQVapSatDTemp = xyz_CalcDQVapSatDTemp( is, ie, js, je, 1, 1, xyz_Temp, xyz_QVapSat )
   338  
   339      xy_DQVapSatDTemp = xyz_DQVapSatDTemp(:,:,1)
     .        if (xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U2 + 1 -                 
     .       1   xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2 .gt. 0) then           
     .           J2 = and(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U2 + 1 -         
     .       1      xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2,3)                  
     .  !CDIR    NODEP                                                          
     .           do t131 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t133 = 1, xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U1 + 1 -  
     .       1         xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1                  
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131-1+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131-1+xyz_dqvapsatdtemp.DSC.L2,1)                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t131 = J2 + 1, xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U2 + 1  
     .       1       - xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2, 4               
     .  !CDIR       NODEP                                                       
     .              do t133 = 1, xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.U1 + 1 -  
     .       1         xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1                  
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131-1+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131-1+xyz_dqvapsatdtemp.DSC.L2,1)                    
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)  
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131+xyz_dqvapsatdtemp.DSC.L2,1)                      
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131+1+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131+1+xyz_dqvapsatdtemp.DSC.L2,1)                    
     .                 xy_dqvapsatdtemp(xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L1+
     .       1            t133-1,t131+2+xy_dqvapsatdtemp.DESCRIPT.RETVAL.DSC.L2)
     .       2             = xyz_dqvapsatdtemp(xyz_dqvapsatdtemp.DSC.L1+t133-1, 
     .       3            t131+2+xyz_dqvapsatdtemp.DSC.L2,1)                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   340  
   341  
   342    end function xy_CalcDQVapSatDTemp
   343  
   344    !--------------------------------------------------------------------------------------
   345  
   346    subroutine SaturateInit
   347      !
   348      ! saturate_t1930 ⥸塼νԤޤ.
   349      !--
   350      ! NAMELIST#saturate_t1930_nml ɤ߹ߤϤμ³ǹԤޤ.
   351      !++
   352      !
   353      ! "saturate_t1930" module is initialized.
   354      !--
   355      ! "NAMELIST#saturate_t1930_nml" is loaded in this procedure.
   356      !++
   357  
   358      ! ⥸塼 ; USE statements
   359      !
   360  
   361      ! NAMELIST եϤ˴ؤ桼ƥƥ
   362      ! Utilities for NAMELIST file input
   363      !
   364      use namelist_util, only: namelist_filename, NmlutilMsg
   365  
   366      ! ե
   367      ! File I/O support
   368      !
   369      use dc_iounit, only: FileOpen
   370  
   371      ! ̷ѥ᥿
   372      ! Kind type parameter
   373      !
   374      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   375  
   376      ! ʸ
   377      ! Character handling
   378      !
   379      use dc_string, only: StoA
   380  
   381      ! ҥȥǡ
   382      ! History data output
   383      !
   384      use gtool_historyauto, only: HistoryAutoAddVariable
   385  
   386      ! ʸ ; Declaration statements
   387      !
   388      implicit none
   389  
   390  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   391  !!$                              ! Unit number for NAMELIST file open
   392  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   393  !!$                              ! IOSTAT of NAMELIST read
   394  
   395      ! NAMELIST ѿ
   396      ! NAMELIST group name
   397      !
   398  !!$    namelist /saturate_t1930_nml/
   399            !
   400            ! ǥեͤˤĤƤϽ³ "saturate_t1930#SaturateInit"
   401            ! Υɤ򻲾ȤΤ.
   402            !
   403            ! Refer to source codes in the initialization procedure
   404            ! "saturate_t1930#SaturateInit" for the default values.
   405            !
   406  
   407      ! ¹ʸ ; Executable statement
   408      !
   409  
   410      if ( saturate_t1930_inited ) return
   411  
   412  
   413      ! ǥեͤ
   414      ! Default values settings
   415      !
   416  
   417  
   418  !!$    ! NAMELIST ɤ߹
   419  !!$    ! NAMELIST is input
   420  !!$    !
   421  !!$    if ( trim(namelist_filename) /= '' ) then
   422  !!$      call FileOpen( unit_nml, &          ! (out)
   423  !!$        & namelist_filename, mode = 'r' ) ! (in)
   424  !!$
   425  !!$      rewind( unit_nml )
   426  !!$      read( unit_nml, &           ! (in)
   427  !!$        & nml = saturate_t1930_nml, &  ! (out)
   428  !!$        & iostat = iostat_nml )   ! (out)
   429  !!$      close( unit_nml )
   430  !!$
   431  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   432  !!$    end if
   433  
   434      !  ; Print
   435      !
   436      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   437      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   438  
   439      saturate_t1930_inited = .true.
   440  
   441    end subroutine SaturateInit
   442  
   443    !--------------------------------------------------------------------------------------
   444  
   445  end module saturate_t1930
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:25 2012
FILE NAME: saturate_t1930.f90
PROGRAM NAME: saturate_t1930
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Tetens (1930) Ѥ˰漾λ
     2:            !
     3:            != Evaluate saturation specific humidity with Tetens (1930)
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6:            ! Version::   $Id: saturate_t1930.f90,v 1.2 2011-06-19 10:56:27 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module saturate_t1930
    13:              !
    14:              != Tetens (1930) Ѥ˰漾λ
    15:              !
    16:              != Evaluate saturation specific humidity with Tetens (1930)
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! Tetens (1930) , ˰¾ $ p^{*} $ ˴ؤʲμ
    21:              ! Ѥ, ˰漾˰漾βʬͤ򻻽Фޤ. 
    22:              !
    23:              ! Saturation specific humidity and temperature derivative of it 
    24:              ! are calculated with a folloing formula for saturation watar vapor pressure 
    25:              ! $ p^{*} $ in Tetens (1930). 
    26:              !
    27:              ! \[
    28:              !    q^{*} (T, p) 
    29:              !      = 611 \varepsilon 
    30:              !        \frac{ \exp \left( \frac{l}{R_v} 
    31:              !                           \left( \frac{1}{273} - \frac{1}{T} \right)
    32:              !                    \right) } { p } \] \[
    33:              !    \DP{q^{*} (T, p)}{T} 
    34:              !      = 611 \varepsilon \frac{l}{R_v T^2}
    35:              !        \frac{ \exp \left( \frac{l}{R_v} 
    36:              !                           \left( \frac{1}{273} - \frac{1}{T} \right)
    37:              !                    \right) } { p }
    38:              !      = \frac{q^{*} l}{R_v T^2}
    39:              ! \]
    40:              !
    41:              ! , $ T $ ϲ, $ p $ ϵ, $ R_v $ ϶ŷʬε,  
    42:              ! $ \varepsilon $ ϶ŷʬ絤ʬ, 
    43:              ! $ l $ ϶ŷʬǮǤ. 
    44:              !
    45:              !== References
    46:              !
    47:              ! * Tetens, O., 1930: 
    48:              !   Uder einige meteorologische Begriffe.
    49:              !   <i>Zeitschrift fur Geophysik</i>, <b>6</b>, 297--309.
    50:              !
    51:              !== Procedures List
    52:              !
    53:              ! CalcQVapSat            :: ˰漾η׻
    54:              ! CalcDQVapSatDTemp      :: ˰漾βʬη׻
    55:              ! ------------  :: ------------
    56:              ! CalcQVapSat            :: Calculate saturation specific humidity
    57:              ! CalcDQVapSatDTemp      :: Calculate temperature derivative of saturation specific humidity
    58:              !
    59:              !--
    60:              !== NAMELIST
    61:              !
    62:              ! NAMELIST#saturate_t1930_nml
    63:              !++
    64:            
    65:              ! ⥸塼 ; USE statements
    66:              !
    67:            
    68:              ! ̷ѥ᥿
    69:              ! Kind type parameter
    70:              !
    71:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    72:                &                 STRING     ! ʸ.       Strings. 
    73:            
    74:              ! å
    75:              ! Message output
    76:              !
    77:              use dc_message, only: MessageNotify
    78:            
    79:              ! ʸ ; Declaration statements
    80:              !
    81:              implicit none
    82:              private
    83:            
    84:              ! ³
    85:              ! Public procedure
    86:              !
    87:              public:: xy_CalcQVapSat , xy_CalcDQVapSatDTemp
    88:              public:: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
    89:            
    90:              ! ѿ
    91:              ! Public variables
    92:              !
    93:              logical, save, public:: saturate_t1930_inited = .false.
    94:                                          ! ե饰. 
    95:                                          ! Initialization flag
    96:            
    97:              ! ѿ
    98:              ! Private variables
    99:              !
   100:              real(DP), parameter:: Es0 = 611.0_DP
   101:                                          ! 0 ˰¾ [Pa]. 
   102:                                          ! Saturation water vapor pressure at 0 deg C [Pa]
   103:            
   104:              character(*), parameter:: module_name = 'saturate_t1930'
   105:                                          ! ⥸塼̾. 
   106:                                          ! Module name
   107:              character(*), parameter:: version = &
   108:                & '$Name: dcpam5-20120921 $' // &
   109:                & '$Id: saturate_t1930.f90,v 1.2 2011-06-19 10:56:27 yot Exp $'
   110:                                          ! ⥸塼ΥС
   111:                                          ! Module version
   112:            
   113:            contains
   114:            
   115:              !--------------------------------------------------------------------------------------
   116:            
   117:              function xyz_CalcQVapSat( is, ie, js, je, ks, ke, xyz_Temp, xyz_Press ) result( xyz_QVapSat )
   118:                !
   119:                !  *Temp* ȵ *Press* Ѥ, 
   120:                ! ˰漾 *QVapSat* ޤ. 
   121:                !
   122:                ! Calculate saturation specific humidity *QVapSat* using
   123:                ! temperature *Temp* and air pressure *Press*. 
   124:                !
   125:            
   126:                ! ⥸塼 ; USE statements
   127:                !
   128:            
   129:                ! ʪ
   130:                ! Physical constants settings
   131:                !
   132:                use constants, only: &
   133:                  & GasRWet, &
   134:                                          ! $ R_v $ [J kg-1 K-1]. 
   135:                                          ! ŷʬε. 
   136:                                          ! Gas constant of condensible elements
   137:                  & LatentHeat, &
   138:                                          ! $ L $ [J kg-1] . 
   139:                                          ! ŷǮ. 
   140:                                          ! Latent heat of condensation
   141:                  & EpsV                  ! $ \epsilon_v $ . 
   142:                                          ! ʬ. 
   143:                                          ! Molecular weight of water vapor
   144:            
   145:                ! ʸ ; Declaration statements
   146:                !
   147:                implicit none
   148:            
   149:                integer , intent(in):: is
   150:                integer , intent(in):: ie
   151:                integer , intent(in):: js
   152:                integer , intent(in):: je
   153:                integer , intent(in):: ks
   154:                integer , intent(in):: ke
   155:                real(DP), intent(in):: xyz_Temp (is:ie, js:je, ks:ke)
   156:                                          ! $ T $ . . Temperature
   157:                real(DP), intent(in):: xyz_Press(is:ie, js:je, ks:ke)
   158:                                          ! $ p $ . . Air pressure
   159:            
   160:                real(DP):: xyz_QVapSat(is:ie, js:je, ks:ke)
   161:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   162:            
   163:                ! ѿ
   164:                ! Work variables
   165:                !
   166:            
   167:                ! ¹ʸ ; Executable statement
   168:                !
   169:            
   170: WW*====        xyz_QVapSat = &
   171:                  & EpsV * Es0 * exp( LatentHeat / GasRWet * ( 1./273. - 1./xyz_Temp ) ) &
   172:                  & / xyz_Press
   173:            
   174:            
   175:              end function xyz_CalcQVapSat
   176:            
   177:              !--------------------------------------------------------------------------------------
   178:            
   179:              function xyz_CalcDQVapSatDTemp( is, ie, js, je, ks, ke, xyz_Temp, xyz_QVapSat ) result( xyz_DQVapSatDTemp )
   180:                !
   181:                !  *Temp* ˰漾 *QVapSat* Ѥ, 
   182:                ! ˰漾βʬ *DQVapSatDTemp* ޤ. 
   183:                !
   184:                ! Calculate temperature derivative of saturation specific humidity 
   185:                ! *DQVapSatDTemp* using
   186:                ! temperature *Temp* and saturation specific humidity *QVapSat*. 
   187:                !
   188:            
   189:                ! ⥸塼 ; USE statements
   190:                !
   191:            
   192:                ! ʪ
   193:                ! Physical constants settings
   194:                !
   195:                use constants, only: &
   196:                  & GasRWet, &
   197:                                          ! $ R_v $ [J kg-1 K-1]. 
   198:                                          ! ŷʬε. 
   199:                                          ! Gas constant of condensible elements
   200:                  & LatentHeat, &
   201:                                          ! $ L $ [J kg-1] . 
   202:                                          ! ŷǮ. 
   203:                                          ! Latent heat of condensation
   204:                  & EpsV                  ! $ \epsilon_v $ . 
   205:                                          ! ʬ. 
   206:                                          ! Molecular weight of water vapor
   207:            
   208:                ! ʸ ; Declaration statements
   209:                !
   210:                implicit none
   211:            
   212:                integer , intent(in):: is
   213:                integer , intent(in):: ie
   214:                integer , intent(in):: js
   215:                integer , intent(in):: je
   216:                integer , intent(in):: ks
   217:                integer , intent(in):: ke
   218:                real(DP), intent(in):: xyz_Temp   (is:ie, js:je, ks:ke)
   219:                                          ! $ T $ . . Temperature
   220:                real(DP), intent(in):: xyz_QVapSat(is:ie, js:je, ks:ke)
   221:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   222:                real(DP):: xyz_DQVapSatDTemp(is:ie, js:je, ks:ke)
   223:                                          ! $ \DP{q^{*}}{T} $ . ˰漾βʬ. 
   224:                                          ! Temperature derivative of saturation specific humidity. 
   225:            
   226:                ! ѿ
   227:                ! Work variables
   228:                !
   229:            
   230:                ! ¹ʸ ; Executable statement
   231:                !
   232: ***====        xyz_DQVapSatDTemp = LatentHeat * xyz_QVapSat / ( GasRWet * xyz_Temp**2 )
   233:            
   234:            
   235:              end function xyz_CalcDQVapSatDTemp
   236:            
   237:              !--------------------------------------------------------------------------------------
   238:            
   239:              function xy_CalcQVapSat( is, ie, js, je, xy_Temp, xy_Press ) result( xy_QVapSat )
   240:                !
   241:                !  *Temp* ȵ *Press* Ѥ, 
   242:                ! ˰漾 *QVapSat* ޤ. 
   243:                !
   244:                ! Calculate saturation specific humidity *QVapSat* using
   245:                ! temperature *Temp* and air pressure *Press*. 
   246:                !
   247:            
   248:                ! ⥸塼 ; USE statements
   249:                !
   250:            
   251:                ! ʸ ; Declaration statements
   252:                !
   253:                implicit none
   254:            
   255:                integer , intent(in):: is
   256:                integer , intent(in):: ie
   257:                integer , intent(in):: js
   258:                integer , intent(in):: je
   259:                real(DP), intent(in):: xy_Temp (is:ie, js:je)
   260:                                          ! $ T $ . . Temperature
   261:                real(DP), intent(in):: xy_Press(is:ie, js:je)
   262:                                          ! $ p $ . . Air pressure
   263:            
   264:                real(DP):: xy_QVapSat(is:ie, js:je)
   265:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   266:            
   267:                ! ѿ
   268:                ! Work variables
   269:                !
   270:                real(DP):: xyz_Temp   (is:ie, js:je, 1:1)
   271:                                          ! $ T $ . . Temperature
   272:                real(DP):: xyz_Press  (is:ie, js:je, 1:1)
   273:                                          ! $ p $ . . Air pressure
   274:                real(DP):: xyz_QVapSat(is:ie, js:je, 1:1)
   275:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   276:            
   277:            
   278: *V----->       xyz_Temp (:,:,1) = xy_Temp
   279: *V-----        xyz_Press(:,:,1) = xy_Press
   280:            
   281:                xyz_QVapSat = xyz_CalcQVapSat( is, ie, js, je, 1, 1, xyz_Temp, xyz_Press )
   282:            
   283: +V=====        xy_QVapSat = xyz_QVapSat(:,:,1)
   284:            
   285:            
   286:              end function xy_CalcQVapSat
   287:            
   288:              !--------------------------------------------------------------------------------------
   289:            
   290:              function xy_CalcDQVapSatDTemp( is, ie, js, je, xy_Temp, xy_QVapSat ) result( xy_DQVapSatDTemp )
   291:                !
   292:                !  *Temp* ˰漾 *QVapSat* Ѥ, 
   293:                ! ˰漾βʬ *DQVapSatDTemp* ޤ. 
   294:                !
   295:                ! Calculate temperature derivative of saturation specific humidity 
   296:                ! *DQVapSatDTemp* using
   297:                ! temperature *Temp* and saturation specific humidity *QVapSat*. 
   298:                !
   299:            
   300:                ! ⥸塼 ; USE statements
   301:                !
   302:            
   303:                ! ʸ ; Declaration statements
   304:                !
   305:                implicit none
   306:            
   307:                integer , intent(in):: is
   308:                integer , intent(in):: ie
   309:                integer , intent(in):: js
   310:                integer , intent(in):: je
   311:                real(DP), intent(in):: xy_Temp   (is:ie, js:je)
   312:                                          ! $ T $ . . Temperature
   313:                real(DP), intent(in):: xy_QVapSat(is:ie, js:je)
   314:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   315:                real(DP):: xy_DQVapSatDTemp(is:ie, js:je)
   316:                                          ! $ \DP{q^{*}}{T} $ . ˰漾βʬ. 
   317:                                          ! Temperature derivative of saturation specific humidity. 
   318:            
   319:                ! ѿ
   320:                ! Work variables
   321:                !
   322:                real(DP):: xyz_Temp   (is:ie, js:je, 1:1)
   323:                                          ! $ T $ . . Temperature
   324:                real(DP):: xyz_QVapSat(is:ie, js:je, 1:1)
   325:                                          ! $ q^{*} $ . ˰漾. Saturation specific humidity
   326:                real(DP):: xyz_DQVapSatDTemp(is:ie, js:je, 1:1)
   327:                                          ! $ \DP{q^{*}}{T} $ . ˰漾βʬ. 
   328:                                          ! Temperature derivative of saturation specific humidity. 
   329:            
   330:            
   331:                ! ¹ʸ ; Executable statement
   332:                !
   333:            
   334: *V----->       xyz_Temp   (:,:,1) = xy_Temp
   335: *V-----        xyz_QVapSat(:,:,1) = xy_QVapSat
   336:            
   337:                xyz_DQVapSatDTemp = xyz_CalcDQVapSatDTemp( is, ie, js, je, 1, 1, xyz_Temp, xyz_QVapSat )
   338:            
   339: +V=====        xy_DQVapSatDTemp = xyz_DQVapSatDTemp(:,:,1)
   340:            
   341:            
   342:              end function xy_CalcDQVapSatDTemp
   343:            
   344:              !--------------------------------------------------------------------------------------
   345:            
   346:              subroutine SaturateInit
   347:                !
   348:                ! saturate_t1930 ⥸塼νԤޤ. 
   349:                !--
   350:                ! NAMELIST#saturate_t1930_nml ɤ߹ߤϤμ³ǹԤޤ. 
   351:                !++
   352:                !
   353:                ! "saturate_t1930" module is initialized. 
   354:                !--
   355:                ! "NAMELIST#saturate_t1930_nml" is loaded in this procedure. 
   356:                !++
   357:            
   358:                ! ⥸塼 ; USE statements
   359:                !
   360:            
   361:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   362:                ! Utilities for NAMELIST file input
   363:                !
   364:                use namelist_util, only: namelist_filename, NmlutilMsg
   365:            
   366:                ! ե
   367:                ! File I/O support
   368:                !
   369:                use dc_iounit, only: FileOpen
   370:            
   371:                ! ̷ѥ᥿
   372:                ! Kind type parameter
   373:                !
   374:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   375:            
   376:                ! ʸ
   377:                ! Character handling
   378:                !
   379:                use dc_string, only: StoA
   380:            
   381:                ! ҥȥǡ
   382:                ! History data output
   383:                !
   384:                use gtool_historyauto, only: HistoryAutoAddVariable
   385:            
   386:                ! ʸ ; Declaration statements
   387:                !
   388:                implicit none
   389:            
   390:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   391:            !!$                              ! Unit number for NAMELIST file open
   392:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   393:            !!$                              ! IOSTAT of NAMELIST read
   394:            
   395:                ! NAMELIST ѿ
   396:                ! NAMELIST group name
   397:                !
   398:            !!$    namelist /saturate_t1930_nml/ 
   399:                      !
   400:                      ! ǥեͤˤĤƤϽ³ "saturate_t1930#SaturateInit" 
   401:                      ! Υɤ򻲾ȤΤ. 
   402:                      !
   403:                      ! Refer to source codes in the initialization procedure
   404:                      ! "saturate_t1930#SaturateInit" for the default values. 
   405:                      !
   406:            
   407:                ! ¹ʸ ; Executable statement
   408:                !
   409:            
   410:                if ( saturate_t1930_inited ) return
   411:            
   412:            
   413:                ! ǥեͤ
   414:                ! Default values settings
   415:                !
   416:            
   417:            
   418:            !!$    ! NAMELIST ɤ߹
   419:            !!$    ! NAMELIST is input
   420:            !!$    !
   421:            !!$    if ( trim(namelist_filename) /= '' ) then
   422:            !!$      call FileOpen( unit_nml, &          ! (out)
   423:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   424:            !!$
   425:            !!$      rewind( unit_nml )
   426:            !!$      read( unit_nml, &           ! (in)
   427:            !!$        & nml = saturate_t1930_nml, &  ! (out)
   428:            !!$        & iostat = iostat_nml )   ! (out)
   429:            !!$      close( unit_nml )
   430:            !!$
   431:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   432:            !!$    end if
   433:            
   434:                !  ; Print
   435:                !
   436:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   437:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   438:            
   439:                saturate_t1930_inited = .true.
   440:            
   441:              end subroutine SaturateInit
   442:            
   443:              !--------------------------------------------------------------------------------------
   444:            
   445:            end module saturate_t1930
