Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:11 2012
FILE NAME: constants_snowseaice.f90
PROGRAM NAME: constants_snowseaice
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ȳɹ
     2  !
     3  != Setting constants of snow and sea ice
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: constants_snowseaice.f90,v 1.3 2012-01-20 00:18:56 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module constants_snowseaice
    13    !
    14    != ȳɹ
    15    !
    16    != Setting constants of snow and sea ice
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ȳɹꤪݴɤԤޤ.
    21    ! ͤ NAMELIST ѿ constants_snowseaice_nml ˤäѹ뤳Ȥ
    22    ! ǽǤ.
    23    !
    24    ! Constants of snow and sea ice are set and stored.
    25    ! These values can be changed by NAMELIST group name
    26    ! "constants_snowseaice_nml".
    27    !
    28    !== Procedures List
    29    !
    30    ! ConstantsSnowSeaIceInit :: ʪ
    31    ! ------------  :: ------------
    32    ! ConstantsSnowSeaIceInit :: Settings of constants of snow and sea ice
    33    !
    34    !== NAMELIST
    35    !
    36    ! NAMELIST#constants_snowseaice_nml
    37    !
    38  
    39  
    40    ! ⥸塼 ; USE statements
    41    !
    42  
    43    ! ̷ѥ᥿
    44    ! Kind type parameter
    45    !
    46    use dc_types, only: DP     ! ټ¿. Double precision.
    47  
    48    ! ʸ ; Declaration statements
    49    !
    50    implicit none
    51    private
    52  
    53    ! ³
    54    ! Public procedure
    55    !
    56    public:: ConstantsSnowSeaIceInit
    57  
    58    ! ѿ
    59    ! Public variables
    60    !
    61    logical, save :: constants_snowseaice_inited = .false.
    62                                ! ե饰.
    63                                ! Initialization flag
    64  
    65    real(DP), public, save:: ThresholdSurfSnow
    66    real(DP), public, save:: SnowAlbedo
    67    real(DP), public, save:: TempCondWater
    68                          ! <Japanese>
    69                          ! Condensation temperature of water
    70  
    71    real(DP), public, save:: SeaIceVolHeatCap
    72                                ! Volumetric heat capacity of sea ice (J m-3 K-1)
    73    real(DP), public, save:: SeaIceThermCondCoef
    74                                ! Thermal conductivity of sea ice (W m-1 K-1)
    75  
    76    real(DP), public, save:: SeaIceThreshold
    77    real(DP), public, save:: SeaIceThickness
    78    real(DP), public, save:: TempBelowSeaIce
    79  
    80    real(DP), public, save:: SeaIceAlbedo
    81  
    82  
    83    real(DP), public, save:: CO2IceThreshold
    84    real(DP), public, save:: CO2IceAlbedoS
    85    real(DP), public, save:: CO2IceAlbedoN
    86    real(DP), public, save:: CO2IceEmisS
    87    real(DP), public, save:: CO2IceEmisN
    88  
    89  
    90  
    91    ! ѿ
    92    ! Private variables
    93    !
    94  
    95    character(*), parameter:: module_name = 'constants_snowseaice'
    96                                ! ⥸塼̾.
    97                                ! Module name
    98    character(*), parameter:: version = &
    99      & '$Name: dcpam5-20120921 $' // &
   100      & '$Id: constants_snowseaice.f90,v 1.3 2012-01-20 00:18:56 yot Exp $'
   101                                ! ⥸塼ΥС
   102                                ! Module version
   103  
   104  contains
   105  
   106    !--------------------------------------------------------------------------------------
   107  
   108    subroutine ConstantsSnowSeaIceInit
   109      !
   110      ! constants_snowseaice ⥸塼νԤޤ.
   111      ! NAMELIST#constants_snowseaice_nml ɤ߹ߤϤμ³ǹԤޤ.
   112      !
   113      ! "constants_snowseaice" module is initialized.
   114      ! NAMELIST#constants_snowseaice_nml is loaded in this procedure.
   115      !
   116  
   117      ! ⥸塼 ; USE statements
   118      !
   119  
   120      ! NAMELIST եϤ˴ؤ桼ƥƥ
   121      ! Utilities for NAMELIST file input
   122      !
   123      use namelist_util, only: namelist_filename, NmlutilMsg
   124  
   125      ! ե
   126      ! File I/O support
   127      !
   128      use dc_iounit, only: FileOpen
   129  
   130      ! ̷ѥ᥿
   131      ! Kind type parameter
   132      !
   133      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   134  
   135      ! å
   136      ! Message output
   137      !
   138      use dc_message, only: MessageNotify
   139  
   140      ! ʸ ; Declaration statements
   141      !
   142      implicit none
   143  
   144      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   145                                ! Unit number for NAMELIST file open
   146      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   147                                ! IOSTAT of NAMELIST read
   148  
   149      ! NAMELIST ѿ
   150      ! NAMELIST group name
   151      !
   152      namelist /constants_snowseaice_nml/ &
   153        & ThresholdSurfSnow  , &
   154        & SnowAlbedo         , &
   155        & TempCondWater      , &
   156        & SeaIceVolHeatCap   , &
   157        & SeaIceThermCondCoef, &
   158        & SeaIceThreshold    , &
   159        & SeaIceThickness    , &
   160        & TempBelowSeaIce    , &
   161        & SeaIceAlbedo       , &
   162        & CO2IceAlbedoS      , &
   163        & CO2IceAlbedoN      , &
   164        & CO2IceEmisS        , &
   165        & CO2IceEmisN
   166  
   167            !
   168            ! ǥեͤˤĤƤϽ³ "constants#ConstantsInit"
   169            ! Υɤ򻲾ȤΤ.
   170            !
   171            ! Refer to source codes in the initialization procedure
   172            ! "constants#ConstantsInit" for the default values.
   173            !
   174  
   175      ! ¹ʸ ; Executable statement
   176      !
   177  
   178      if ( constants_snowseaice_inited ) return
   179  
   180  
   181      ! ǥեͤ
   182      ! Default values settings
   183      !
   184  
   185      ThresholdSurfSnow  = 0.1d0 * 1.0d3 * 0.01d0
   186                          ! 1 cm snow depth
   187                          ! 0.1 * 1000 (kg m-3; water density) x 1 cm
   188                          ! This value is selected arbitrarily.
   189  !!$    SnowAlbedo         = 0.7d0
   190      SnowAlbedo         = 0.75d0
   191                          ! This value is selected arbitrarily.
   192      TempCondWater      = 273.15d0
   193                          ! <Japanese>
   194                          ! Condensation temperature of water
   195  
   196  !!$    ! https://www.myroms.org/wiki/index.php/Sea-Ice_Model
   197  !!$    SeaIceDens         = 900.0d0   ! no reliable reference
   198  !!$    SeaIceSpecHeat     = 2093.0d0  ! no reliable reference
   199  !!$    SeaIceHeatDiffCoef = 2.04d0 / ( SeaIceDens * SeaIceSpecHeat )  ! 2.04d0 (W (m K)-1),  no reliable reference
   200  
   201  !!$    SeaIceDens         = 0.92d3
   202  !!$    ! kg m-3
   203  !!$    SeaIceHeatDiffCoef = 2.04d0 / ( SeaIceDens * SeaIceSpecHeat )
   204  !!$    ! 2.04d0 (W (m K)-1),  no reliable reference
   205  !!$    SeaIceSpecHeat     = 1.9d6 / SeaIceDens
   206  !!$    ! no reliable reference
   207  
   208      SeaIceVolHeatCap    = 1.9d6
   209      ! J m-3 K-1
   210      ! Value of ice in Table 12.1 by Hillel (2004).
   211      SeaIceThermCondCoef = 2.2d0
   212      ! W m-1 K-1
   213      ! Value of ice in Table 12.2 by Hillel (2004).
   214  
   215      ! Reference
   216      !
   217      ! Hillet, D.,
   218      !   Introduction to Environmental Soil Physics,
   219      !   Elsevier Academic Press, pp494, 2004.
   220  
   221  
   222      SeaIceThreshold    = 0.5d0            ! arbitrarily set, no reliable reference
   223      SeaIceThickness    = 2.0d0            ! arbitrarily set, no reliable reference
   224      TempBelowSeaIce    = 273.15d0 - 2.0d0 ! arbitrarily set, no reliable reference
   225  
   226  !!$    SeaIceAlbedo       = 0.5d0            ! arbitrarily set, no reliable reference
   227      SeaIceAlbedo       = 0.75d0           ! arbitrarily set, no reliable reference
   228  
   229  
   230      CO2IceThreshold = 1.0_DP         ! No reference
   231      CO2IceAlbedoS   = 0.75_DP        ! No reference
   232      CO2IceAlbedoN   = 0.75_DP        ! No reference
   233      CO2IceEmisS     = 1.0_DP         ! No reference
   234      CO2IceEmisN     = 1.0_DP         ! No reference
   235  
   236  
   237      ! NAMELIST 
   238      ! Input from NAMELIST
   239      !
   240      if ( trim(namelist_filename) /= '' ) then
   241        call FileOpen( unit_nml, &          ! (out)
   242          & namelist_filename, mode = 'r' ) ! (in)
   243  
   244        rewind( unit_nml )
   245        read( unit_nml,                     &  ! (in)
   246          & nml = constants_snowseaice_nml, &  ! (out)
   247          & iostat = iostat_nml            )   ! (out)
   248        close( unit_nml )
   249  
   250        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   251        if ( iostat_nml == 0 ) write( STDOUT, nml = constants_snowseaice_nml )
   252      end if
   253  
   254      !  ; Print
   255      !
   256      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   257      call MessageNotify( 'M', module_name, '  ThresholdSurfSnow   = %f', d = (/ ThresholdSurfSnow   /) )
   258      call MessageNotify( 'M', module_name, '  SnowAlbedo          = %f', d = (/ SnowAlbedo          /) )
   259      call MessageNotify( 'M', module_name, '  TempCondWater       = %f', d = (/ TempCondWater       /) )
   260      call MessageNotify( 'M', module_name, '  SeaIceThreshold     = %f', d = (/ SeaIceThreshold     /) )
   261      call MessageNotify( 'M', module_name, '  SeaIceVolHeatCap    = %f', d = (/ SeaIceVolHeatCap    /) )
   262      call MessageNotify( 'M', module_name, '  SeaIceThermCondCoef = %f', d = (/ SeaIceThermCondCoef /) )
   263  
   264  !!$    call MessageNotify( 'M', module_name, '  SeaIceDens         = %f', d = (/ SeaIceDens         /) )
   265  !!$    call MessageNotify( 'M', module_name, '  SeaIceSpecHeat     = %f', d = (/ SeaIceSpecHeat     /) )
   266  !!$    call MessageNotify( 'M', module_name, '  SeaIceHeatDiffCoef = %f', d = (/ SeaIceHeatDiffCoef /) )
   267  
   268      call MessageNotify( 'M', module_name, '  SeaIceThickness     = %f', d = (/ SeaIceThickness     /) )
   269      call MessageNotify( 'M', module_name, '  TempBelowSeaIce     = %f', d = (/ TempBelowSeaIce     /) )
   270      call MessageNotify( 'M', module_name, '  SeaIceAlbedo        = %f', d = (/ SeaIceAlbedo        /) )
   271      call MessageNotify( 'M', module_name, '  CO2IceAlbedoS       = %f', d = (/ CO2IceAlbedoS       /) )
   272      call MessageNotify( 'M', module_name, '  CO2IceAlbedoN       = %f', d = (/ CO2IceAlbedoN       /) )
   273      call MessageNotify( 'M', module_name, '  CO2IceEmisS         = %f', d = (/ CO2IceEmisS       /) )
   274      call MessageNotify( 'M', module_name, '  CO2IceEmisN         = %f', d = (/ CO2IceEmisN       /) )
   275      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   276  
   277      constants_snowseaice_inited = .true.
   278  
   279    end subroutine ConstantsSnowSeaIceInit
   280  
   281    !--------------------------------------------------------------------------------------
   282  
   283  end module constants_snowseaice
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:11 2012
FILE NAME: constants_snowseaice.f90
PROGRAM NAME: constants_snowseaice
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ȳɹ
     2:            !
     3:            != Setting constants of snow and sea ice
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: constants_snowseaice.f90,v 1.3 2012-01-20 00:18:56 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module constants_snowseaice
    13:              !
    14:              != ȳɹ
    15:              !
    16:              != Setting constants of snow and sea ice
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ȳɹꤪݴɤԤޤ. 
    21:              ! ͤ NAMELIST ѿ constants_snowseaice_nml ˤäѹ뤳Ȥ
    22:              ! ǽǤ. 
    23:              !
    24:              ! Constants of snow and sea ice are set and stored. 
    25:              ! These values can be changed by NAMELIST group name 
    26:              ! "constants_snowseaice_nml". 
    27:              !
    28:              !== Procedures List
    29:              !
    30:              ! ConstantsSnowSeaIceInit :: ʪ
    31:              ! ------------  :: ------------
    32:              ! ConstantsSnowSeaIceInit :: Settings of constants of snow and sea ice
    33:              !
    34:              !== NAMELIST
    35:              !
    36:              ! NAMELIST#constants_snowseaice_nml
    37:              !
    38:            
    39:            
    40:              ! ⥸塼 ; USE statements
    41:              !
    42:            
    43:              ! ̷ѥ᥿
    44:              ! Kind type parameter
    45:              !
    46:              use dc_types, only: DP     ! ټ¿. Double precision. 
    47:            
    48:              ! ʸ ; Declaration statements
    49:              !
    50:              implicit none
    51:              private
    52:            
    53:              ! ³
    54:              ! Public procedure
    55:              !
    56:              public:: ConstantsSnowSeaIceInit
    57:            
    58:              ! ѿ
    59:              ! Public variables
    60:              !
    61:              logical, save :: constants_snowseaice_inited = .false.
    62:                                          ! ե饰. 
    63:                                          ! Initialization flag
    64:            
    65:              real(DP), public, save:: ThresholdSurfSnow
    66:              real(DP), public, save:: SnowAlbedo
    67:              real(DP), public, save:: TempCondWater
    68:                                    ! <Japanese>
    69:                                    ! Condensation temperature of water
    70:            
    71:              real(DP), public, save:: SeaIceVolHeatCap
    72:                                          ! Volumetric heat capacity of sea ice (J m-3 K-1)
    73:              real(DP), public, save:: SeaIceThermCondCoef
    74:                                          ! Thermal conductivity of sea ice (W m-1 K-1)
    75:            
    76:              real(DP), public, save:: SeaIceThreshold
    77:              real(DP), public, save:: SeaIceThickness
    78:              real(DP), public, save:: TempBelowSeaIce
    79:            
    80:              real(DP), public, save:: SeaIceAlbedo
    81:            
    82:            
    83:              real(DP), public, save:: CO2IceThreshold
    84:              real(DP), public, save:: CO2IceAlbedoS
    85:              real(DP), public, save:: CO2IceAlbedoN
    86:              real(DP), public, save:: CO2IceEmisS
    87:              real(DP), public, save:: CO2IceEmisN
    88:            
    89:            
    90:            
    91:              ! ѿ
    92:              ! Private variables
    93:              !
    94:            
    95:              character(*), parameter:: module_name = 'constants_snowseaice'
    96:                                          ! ⥸塼̾. 
    97:                                          ! Module name
    98:              character(*), parameter:: version = &
    99:                & '$Name: dcpam5-20120921 $' // &
   100:                & '$Id: constants_snowseaice.f90,v 1.3 2012-01-20 00:18:56 yot Exp $'
   101:                                          ! ⥸塼ΥС
   102:                                          ! Module version
   103:            
   104:            contains
   105:            
   106:              !--------------------------------------------------------------------------------------
   107:            
   108:              subroutine ConstantsSnowSeaIceInit
   109:                !
   110:                ! constants_snowseaice ⥸塼νԤޤ. 
   111:                ! NAMELIST#constants_snowseaice_nml ɤ߹ߤϤμ³ǹԤޤ. 
   112:                !
   113:                ! "constants_snowseaice" module is initialized. 
   114:                ! NAMELIST#constants_snowseaice_nml is loaded in this procedure. 
   115:                !
   116:            
   117:                ! ⥸塼 ; USE statements
   118:                !
   119:            
   120:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   121:                ! Utilities for NAMELIST file input
   122:                !
   123:                use namelist_util, only: namelist_filename, NmlutilMsg
   124:            
   125:                ! ե
   126:                ! File I/O support
   127:                !
   128:                use dc_iounit, only: FileOpen
   129:            
   130:                ! ̷ѥ᥿
   131:                ! Kind type parameter
   132:                !
   133:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   134:            
   135:                ! å
   136:                ! Message output
   137:                !
   138:                use dc_message, only: MessageNotify
   139:            
   140:                ! ʸ ; Declaration statements
   141:                !
   142:                implicit none
   143:            
   144:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   145:                                          ! Unit number for NAMELIST file open
   146:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   147:                                          ! IOSTAT of NAMELIST read
   148:            
   149:                ! NAMELIST ѿ
   150:                ! NAMELIST group name
   151:                !
   152:                namelist /constants_snowseaice_nml/ &
   153:                  & ThresholdSurfSnow  , &
   154:                  & SnowAlbedo         , &
   155:                  & TempCondWater      , &
   156:                  & SeaIceVolHeatCap   , &
   157:                  & SeaIceThermCondCoef, &
   158:                  & SeaIceThreshold    , &
   159:                  & SeaIceThickness    , &
   160:                  & TempBelowSeaIce    , &
   161:                  & SeaIceAlbedo       , &
   162:                  & CO2IceAlbedoS      , &
   163:                  & CO2IceAlbedoN      , &
   164:                  & CO2IceEmisS        , &
   165:                  & CO2IceEmisN
   166:            
   167:                      !
   168:                      ! ǥեͤˤĤƤϽ³ "constants#ConstantsInit" 
   169:                      ! Υɤ򻲾ȤΤ. 
   170:                      !
   171:                      ! Refer to source codes in the initialization procedure
   172:                      ! "constants#ConstantsInit" for the default values. 
   173:                      !
   174:            
   175:                ! ¹ʸ ; Executable statement
   176:                !
   177:            
   178:                if ( constants_snowseaice_inited ) return
   179:            
   180:            
   181:                ! ǥեͤ
   182:                ! Default values settings
   183:                !
   184:            
   185:                ThresholdSurfSnow  = 0.1d0 * 1.0d3 * 0.01d0
   186:                                    ! 1 cm snow depth
   187:                                    ! 0.1 * 1000 (kg m-3; water density) x 1 cm
   188:                                    ! This value is selected arbitrarily. 
   189:            !!$    SnowAlbedo         = 0.7d0
   190:                SnowAlbedo         = 0.75d0
   191:                                    ! This value is selected arbitrarily. 
   192:                TempCondWater      = 273.15d0
   193:                                    ! <Japanese>
   194:                                    ! Condensation temperature of water
   195:            
   196:            !!$    ! https://www.myroms.org/wiki/index.php/Sea-Ice_Model
   197:            !!$    SeaIceDens         = 900.0d0   ! no reliable reference
   198:            !!$    SeaIceSpecHeat     = 2093.0d0  ! no reliable reference
   199:            !!$    SeaIceHeatDiffCoef = 2.04d0 / ( SeaIceDens * SeaIceSpecHeat )  ! 2.04d0 (W (m K)-1),  no reliable reference
   200:            
   201:            !!$    SeaIceDens         = 0.92d3
   202:            !!$    ! kg m-3
   203:            !!$    SeaIceHeatDiffCoef = 2.04d0 / ( SeaIceDens * SeaIceSpecHeat )
   204:            !!$    ! 2.04d0 (W (m K)-1),  no reliable reference
   205:            !!$    SeaIceSpecHeat     = 1.9d6 / SeaIceDens
   206:            !!$    ! no reliable reference
   207:            
   208:                SeaIceVolHeatCap    = 1.9d6
   209:                ! J m-3 K-1
   210:                ! Value of ice in Table 12.1 by Hillel (2004). 
   211:                SeaIceThermCondCoef = 2.2d0
   212:                ! W m-1 K-1
   213:                ! Value of ice in Table 12.2 by Hillel (2004). 
   214:            
   215:                ! Reference
   216:                !
   217:                ! Hillet, D., 
   218:                !   Introduction to Environmental Soil Physics, 
   219:                !   Elsevier Academic Press, pp494, 2004.
   220:            
   221:            
   222:                SeaIceThreshold    = 0.5d0            ! arbitrarily set, no reliable reference
   223:                SeaIceThickness    = 2.0d0            ! arbitrarily set, no reliable reference
   224:                TempBelowSeaIce    = 273.15d0 - 2.0d0 ! arbitrarily set, no reliable reference
   225:            
   226:            !!$    SeaIceAlbedo       = 0.5d0            ! arbitrarily set, no reliable reference
   227:                SeaIceAlbedo       = 0.75d0           ! arbitrarily set, no reliable reference
   228:            
   229:            
   230:                CO2IceThreshold = 1.0_DP         ! No reference
   231:                CO2IceAlbedoS   = 0.75_DP        ! No reference
   232:                CO2IceAlbedoN   = 0.75_DP        ! No reference
   233:                CO2IceEmisS     = 1.0_DP         ! No reference
   234:                CO2IceEmisN     = 1.0_DP         ! No reference
   235:            
   236:            
   237:                ! NAMELIST 
   238:                ! Input from NAMELIST
   239:                !
   240:                if ( trim(namelist_filename) /= '' ) then
   241:                  call FileOpen( unit_nml, &          ! (out)
   242:                    & namelist_filename, mode = 'r' ) ! (in)
   243:            
   244:                  rewind( unit_nml )
   245:                  read( unit_nml,                     &  ! (in)
   246:                    & nml = constants_snowseaice_nml, &  ! (out)
   247:                    & iostat = iostat_nml            )   ! (out)
   248:                  close( unit_nml )
   249:            
   250:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   251:                  if ( iostat_nml == 0 ) write( STDOUT, nml = constants_snowseaice_nml )
   252:                end if
   253:            
   254:                !  ; Print
   255:                !
   256:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   257:                call MessageNotify( 'M', module_name, '  ThresholdSurfSnow   = %f', d = (/ ThresholdSurfSnow   /) )
   258:                call MessageNotify( 'M', module_name, '  SnowAlbedo          = %f', d = (/ SnowAlbedo          /) )
   259:                call MessageNotify( 'M', module_name, '  TempCondWater       = %f', d = (/ TempCondWater       /) )
   260:                call MessageNotify( 'M', module_name, '  SeaIceThreshold     = %f', d = (/ SeaIceThreshold     /) )
   261:                call MessageNotify( 'M', module_name, '  SeaIceVolHeatCap    = %f', d = (/ SeaIceVolHeatCap    /) )
   262:                call MessageNotify( 'M', module_name, '  SeaIceThermCondCoef = %f', d = (/ SeaIceThermCondCoef /) )
   263:            
   264:            !!$    call MessageNotify( 'M', module_name, '  SeaIceDens         = %f', d = (/ SeaIceDens         /) )
   265:            !!$    call MessageNotify( 'M', module_name, '  SeaIceSpecHeat     = %f', d = (/ SeaIceSpecHeat     /) )
   266:            !!$    call MessageNotify( 'M', module_name, '  SeaIceHeatDiffCoef = %f', d = (/ SeaIceHeatDiffCoef /) )
   267:            
   268:                call MessageNotify( 'M', module_name, '  SeaIceThickness     = %f', d = (/ SeaIceThickness     /) )
   269:                call MessageNotify( 'M', module_name, '  TempBelowSeaIce     = %f', d = (/ TempBelowSeaIce     /) )
   270:                call MessageNotify( 'M', module_name, '  SeaIceAlbedo        = %f', d = (/ SeaIceAlbedo        /) )
   271:                call MessageNotify( 'M', module_name, '  CO2IceAlbedoS       = %f', d = (/ CO2IceAlbedoS       /) )
   272:                call MessageNotify( 'M', module_name, '  CO2IceAlbedoN       = %f', d = (/ CO2IceAlbedoN       /) )
   273:                call MessageNotify( 'M', module_name, '  CO2IceEmisS         = %f', d = (/ CO2IceEmisS       /) )
   274:                call MessageNotify( 'M', module_name, '  CO2IceEmisN         = %f', d = (/ CO2IceEmisN       /) )
   275:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   276:            
   277:                constants_snowseaice_inited = .true.
   278:            
   279:              end subroutine ConstantsSnowSeaIceInit
   280:            
   281:              !--------------------------------------------------------------------------------------
   282:            
   283:            end module constants_snowseaice
