Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:02 2012
FILE NAME: option_parser.f90
PROGRAM NAME: option_parser
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ޥɥ饤Ͻ
     2  !
     3  != Command line option parser
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6  ! Version::   $Id: option_parser.f90,v 1.3 2010-08-30 01:54:45 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module option_parser
    13    !
    14    != ޥɥ饤Ͻ
    15    !
    16    != Command line option parser
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ޥɥ饤βϽԤޤ.
    21    !
    22    ! Command line options are parsed
    23    !
    24    !== Procedures List
    25    !
    26    ! OptParseInit  :: ޥɥ饤βϽ
    27    ! ------------  :: ------------
    28    ! OptParseInit  :: Parse of command line options
    29  
    30    ! ⥸塼 ; USE statements
    31    !
    32  
    33    ! ̷ѥ᥿
    34    ! Kind type parameter
    35    !
    36    use dc_types, only: STRING  ! ʸ. Strings.
    37  
    38    ! ʸ ; Declaration statements
    39    !
    40    implicit none
    41    private
    42  
    43    ! ³
    44    ! Public procedure
    45    !
    46    public:: OptParseInit
    47  
    48    ! ѿ
    49    ! Public variables
    50    !
    51    logical, save, public:: option_parser_inited = .false.
    52                                ! ե饰.
    53                                ! Initialization flag
    54    logical, save:: namelist_flag = .false.
    55                                ! NAMELIST ե̵ͭ򼨤ե饰.
    56                                ! Flag of NAMELIST file specification
    57  
    58    ! ѿ
    59    ! Private variables
    60    !
    61    character(*), parameter:: module_name = 'option_parser'
    62                                ! ⥸塼̾.
    63                                ! Module name
    64    character(*), parameter:: version = &
    65      & '$Name: dcpam5-20120921 $' // &
    66      & '$Id: option_parser.f90,v 1.3 2010-08-30 01:54:45 yot Exp $'
    67                                ! ⥸塼ΥС
    68                                ! Module version
    69  
    70  contains
    71  
    72    subroutine OptParseInit( &
    73      & namelist_filename,   & ! (out)
    74      & exec_name, brief     & ! (in ) optional
    75      & )
    76      !
    77      ! option_parser ⥸塼νԤޤ.
    78      !
    79      ! Initialize "option_parser" module.
    80      !
    81  
    82      ! ⥸塼 ; USE statements
    83      !
    84  
    85      ! ʸ
    86      ! Character handling
    87      !
    88      use dc_string, only: StoA
    89  
    90      ! ޥɥ饤
    91      ! Command line option parser subcontractor
    92      !
    93      use dc_args, only: ARGS, &
    94        & DCArgsOpen,  DCArgsHelpMsg, DCArgsOption, &
    95        & DCArgsDebug, DCArgsHelp,    DCArgsStrict, DCArgsClose
    96  
    97      ! Ȥ߹ߴؿ PRESENT γĥǴؿ
    98      ! Extended functions of intrinsic function "PRESENT"
    99      !
   100      use dc_present, only: present_and_not_empty
   101  
   102      ! ʸ ; Declaration statements
   103      !
   104      implicit none
   105      character(*), intent(out)          :: namelist_filename
   106                                ! NAMELIST ե̾.
   107                                ! NAMELIST file name
   108      character(*), intent(in ), optional:: exec_name
   109                                ! ¹ԥե̾.
   110                                ! Executable file name
   111      character(*), intent(in ), optional:: brief
   112                                ! ¹ԥեδʷ
   113                                ! Brief account of executable file
   114  
   115      character(STRING):: ename
   116                                ! ¹ԥե̾.
   117                                ! Executable file name
   118      character(STRING):: brief_msg
   119                                ! ¹ԥեδʷ
   120                                ! Brief account of executable file
   121  
   122      type(ARGS):: arg          ! ޥɥ饤.
   123                                ! Command line options
   124  
   125      ! ¹ʸ ; Executable statement
   126      !
   127  
   128      if ( option_parser_inited ) return
   129      call InitCheck
   130  
   131      ! ץʥν.
   132      ! Handling of optional arguments
   133      !
   134      if ( present_and_not_empty(exec_name) ) then
   135        ename = exec_name
   136      else
   137        ename = 'dcpam'
   138      end if
   139  
   140      if ( present_and_not_empty(brief) ) then
   141        brief_msg = brief
   142      else
   143        brief_msg = 'dcpam main program'
   144      end if
   145  
   146      ! ޥɥ饤βϽ
   147      ! Parse command line arguments
   148      !
   149      call DCArgsOpen( arg )               ! (out)
   150  
   151      call DCArgsHelpMsg( arg, &                          ! (inout)
   152        & category = 'Title', &                           ! (in)
   153        & msg = trim(ename) // ': ' // trim(brief_msg) )  ! (in)
   154      call DCArgsHelpMsg( arg, &                      ! (inout)
   155        & category = 'Usage', &                       ! (in)
   156        & msg = './' // trim(ename) // ' [Options]' ) ! (in)
   157  
   158      call DCArgsOption( arg, &                 ! (inout)
   159        & options = StoA('-N', '--namelist'), & ! (in)
   160        & flag = namelist_flag, &               ! (out)
   161        & value = namelist_filename, &          ! (out)
   162        & help = "Namelist filename")           ! (in)
   163  
   164      call DCArgsDebug( arg )  ! (inout)
   165      call DCArgsHelp( arg )   ! (inout)
   166      call DCArgsStrict( arg ) ! (inout)
   167  
   168      call DCArgsClose( arg )  ! (inout)
   169  
   170      option_parser_inited = .true.
   171    end subroutine OptParseInit
   172  
   173    subroutine InitCheck
   174      !
   175      ! ¸⥸塼νå
   176      !
   177      ! Check initialization of dependency modules
   178  
   179      ! ¹ʸ ; Executable statement
   180      !
   181  
   182  
   183    end subroutine InitCheck
   184  
   185  
   186  end module option_parser
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:02 2012
FILE NAME: option_parser.f90
PROGRAM NAME: option_parser
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ޥɥ饤Ͻ
     2:            !
     3:            != Command line option parser
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6:            ! Version::   $Id: option_parser.f90,v 1.3 2010-08-30 01:54:45 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module option_parser
    13:              !
    14:              != ޥɥ饤Ͻ
    15:              !
    16:              != Command line option parser
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ޥɥ饤βϽԤޤ. 
    21:              !
    22:              ! Command line options are parsed
    23:              !
    24:              !== Procedures List
    25:              !
    26:              ! OptParseInit  :: ޥɥ饤βϽ
    27:              ! ------------  :: ------------
    28:              ! OptParseInit  :: Parse of command line options
    29:            
    30:              ! ⥸塼 ; USE statements
    31:              !
    32:            
    33:              ! ̷ѥ᥿
    34:              ! Kind type parameter
    35:              !
    36:              use dc_types, only: STRING  ! ʸ. Strings. 
    37:            
    38:              ! ʸ ; Declaration statements
    39:              !
    40:              implicit none
    41:              private
    42:            
    43:              ! ³
    44:              ! Public procedure
    45:              !
    46:              public:: OptParseInit
    47:            
    48:              ! ѿ
    49:              ! Public variables
    50:              !
    51:              logical, save, public:: option_parser_inited = .false.
    52:                                          ! ե饰. 
    53:                                          ! Initialization flag
    54:              logical, save:: namelist_flag = .false.
    55:                                          ! NAMELIST ե̵ͭ򼨤ե饰. 
    56:                                          ! Flag of NAMELIST file specification
    57:            
    58:              ! ѿ
    59:              ! Private variables
    60:              !
    61:              character(*), parameter:: module_name = 'option_parser'
    62:                                          ! ⥸塼̾. 
    63:                                          ! Module name
    64:              character(*), parameter:: version = &
    65:                & '$Name: dcpam5-20120921 $' // &
    66:                & '$Id: option_parser.f90,v 1.3 2010-08-30 01:54:45 yot Exp $'
    67:                                          ! ⥸塼ΥС
    68:                                          ! Module version
    69:            
    70:            contains
    71:            
    72:              subroutine OptParseInit( &
    73:                & namelist_filename,   & ! (out)
    74:                & exec_name, brief     & ! (in ) optional
    75:                & )
    76:                !
    77:                ! option_parser ⥸塼νԤޤ. 
    78:                !
    79:                ! Initialize "option_parser" module. 
    80:                !
    81:            
    82:                ! ⥸塼 ; USE statements
    83:                !
    84:            
    85:                ! ʸ
    86:                ! Character handling
    87:                !
    88:                use dc_string, only: StoA
    89:            
    90:                ! ޥɥ饤
    91:                ! Command line option parser subcontractor
    92:                !
    93:                use dc_args, only: ARGS, &
    94:                  & DCArgsOpen,  DCArgsHelpMsg, DCArgsOption, &
    95:                  & DCArgsDebug, DCArgsHelp,    DCArgsStrict, DCArgsClose
    96:            
    97:                ! Ȥ߹ߴؿ PRESENT γĥǴؿ
    98:                ! Extended functions of intrinsic function "PRESENT"
    99:                !
   100:                use dc_present, only: present_and_not_empty
   101:            
   102:                ! ʸ ; Declaration statements
   103:                !
   104:                implicit none
   105:                character(*), intent(out)          :: namelist_filename
   106:                                          ! NAMELIST ե̾. 
   107:                                          ! NAMELIST file name
   108:                character(*), intent(in ), optional:: exec_name
   109:                                          ! ¹ԥե̾. 
   110:                                          ! Executable file name
   111:                character(*), intent(in ), optional:: brief
   112:                                          ! ¹ԥեδʷ
   113:                                          ! Brief account of executable file
   114:            
   115:                character(STRING):: ename
   116:                                          ! ¹ԥե̾. 
   117:                                          ! Executable file name
   118:                character(STRING):: brief_msg
   119:                                          ! ¹ԥեδʷ
   120:                                          ! Brief account of executable file
   121:            
   122:                type(ARGS):: arg          ! ޥɥ饤. 
   123:                                          ! Command line options
   124:            
   125:                ! ¹ʸ ; Executable statement
   126:                !
   127:            
   128:                if ( option_parser_inited ) return
   129:                call InitCheck
   130:            
   131:                ! ץʥν. 
   132:                ! Handling of optional arguments 
   133:                !
   134:                if ( present_and_not_empty(exec_name) ) then
   135:                  ename = exec_name
   136:                else
   137:                  ename = 'dcpam'
   138:                end if
   139:            
   140:                if ( present_and_not_empty(brief) ) then
   141:                  brief_msg = brief
   142:                else
   143:                  brief_msg = 'dcpam main program'
   144:                end if
   145:            
   146:                ! ޥɥ饤βϽ
   147:                ! Parse command line arguments
   148:                !
   149:                call DCArgsOpen( arg )               ! (out)
   150:            
   151:                call DCArgsHelpMsg( arg, &                          ! (inout)
   152:                  & category = 'Title', &                           ! (in)
   153:                  & msg = trim(ename) // ': ' // trim(brief_msg) )  ! (in)
   154:                call DCArgsHelpMsg( arg, &                      ! (inout)
   155:                  & category = 'Usage', &                       ! (in)
   156:                  & msg = './' // trim(ename) // ' [Options]' ) ! (in)
   157:            
   158:                call DCArgsOption( arg, &                 ! (inout)
   159:                  & options = StoA('-N', '--namelist'), & ! (in)
   160:                  & flag = namelist_flag, &               ! (out)
   161:                  & value = namelist_filename, &          ! (out)
   162:                  & help = "Namelist filename")           ! (in)
   163:            
   164:                call DCArgsDebug( arg )  ! (inout)
   165:                call DCArgsHelp( arg )   ! (inout)
   166:                call DCArgsStrict( arg ) ! (inout)
   167:            
   168:                call DCArgsClose( arg )  ! (inout)
   169:            
   170:                option_parser_inited = .true.
   171:              end subroutine OptParseInit
   172:            
   173:              subroutine InitCheck
   174:                !
   175:                ! ¸⥸塼νå
   176:                !
   177:                ! Check initialization of dependency modules
   178:            
   179:                ! ¹ʸ ; Executable statement
   180:                !
   181:            
   182:            
   183:              end subroutine InitCheck
   184:            
   185:            
   186:            end module option_parser
