Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:24 2012
FILE NAME: bucket_model.f90
PROGRAM NAME: bucket_model
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   141  opt  (1593): Loop nest collapsed into one loop.
   141  vec  (   1): Vectorized loop.
   220  opt  (1593): Loop nest collapsed into one loop.
   220  vec  (   4): Vectorized array expression.
   224  opt  (1593): Loop nest collapsed into one loop.
   224  vec  (   1): Vectorized loop.
   231  opt  (1593): Loop nest collapsed into one loop.
   231  vec  (   4): Vectorized array expression.
   235  opt  (1593): Loop nest collapsed into one loop.
   235  vec  (   1): Vectorized loop.
   241  opt  (1593): Loop nest collapsed into one loop.
   241  vec  (   4): Vectorized array expression.
   247  opt  (1593): Loop nest collapsed into one loop.
   247  vec  (   1): Vectorized loop.
   541  opt  (1593): Loop nest collapsed into one loop.
   541  vec  (   1): Vectorized loop.
   555  opt  (1593): Loop nest collapsed into one loop.
   555  vec  (   4): Vectorized array expression.
   561  opt  (1772): Loop nest fused with following nest(s).
   561  opt  (1593): Loop nest collapsed into one loop.
   561  vec  (   1): Vectorized loop.
   645  opt  (1593): Loop nest collapsed into one loop.
   645  vec  (   1): Vectorized loop.
   658  opt  (1593): Loop nest collapsed into one loop.
   658  vec  (   1): Vectorized loop.
   743  opt  (1593): Loop nest collapsed into one loop.
   743  vec  (   1): Vectorized loop.
   792  opt  (1593): Loop nest collapsed into one loop.
   792  vec  (   1): Vectorized loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:24 2012
FILE NAME: bucket_model.f90
PROGRAM NAME: bucket_model
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Хĥǥ
     2  !
     3  != Bucket model
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: bucket_model.f90,v 1.12 2012-09-08 15:26:44 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module Bucket_Model
    13  
    14    ! ⥸塼 ; USE statements
    15    !
    16  
    17  
    18    ! ̷ѥ᥿
    19    ! Kind type parameter
    20    !
    21    use dc_types, only: DP      ! ټ¿. Double precision.
    22  
    23    ! å
    24    ! Message output
    25    !
    26    use dc_message, only: MessageNotify
    27  
    28    ! ʸ ; Declaration statements
    29    !
    30    implicit none
    31    private
    32  
    33    logical, save :: bucket_model_inited = .false.
    34                                ! ե饰.
    35                                ! Initialization flag
    36  
    37  
    38    logical, save :: FlagSnow   ! ΰ 󡿥.
    39                                ! treatment of snow on/off.
    40  
    41    ! ³
    42    ! Public procedure
    43    !
    44    public :: BucketSetFlagOceanFromMatthews
    45  !!$  public :: BucketEvap
    46  !!$  public :: BucketEvapAdjust
    47    public :: BucketIntegration
    48    public :: BucketPRCPAdjust
    49    public :: BucketModHumidCoef
    50    public :: BucketModEvapAndLatentHeatFlux
    51    public :: BucketModelInit
    52  
    53  
    54    ! ѿ
    55    ! Private variables
    56    !
    57    real(DP), save:: SoilMoistCritAmnt
    58                          ! ھʬ̤ξ
    59                          ! Critical amount of soil moisture
    60    real(DP), save:: SoilMoistCritAmntforEvapEff
    61                          ! ɽ٤ 1 Ȥ
    62                          ! Critical amount of soil moisture for evaporation efficiency
    63  
    64    real(DP), save:: SoilMoistMeaningLess = -1.0d0
    65                          ! ξξ˻ѤʪŪˤϰ̣Τʤѿ
    66                          ! Meaning less value for soil moisture on the ocean
    67  
    68  
    69    character(*), parameter:: module_name = 'bucket_model'
    70                                ! ⥸塼̾.
    71                                ! Module name
    72    character(*), parameter:: version = &
    73      & '$Name: dcpam5-20120921 $' // &
    74      & '$Id: bucket_model.f90,v 1.12 2012-09-08 15:26:44 yot Exp $'
    75                                ! ⥸塼ΥС
    76                                ! Module version
    77  
    78  contains
    79  
    80    !--------------------------------------------------------------------------------------
    81  
    82    subroutine BucketSetFlagOceanFromMatthews( &
    83      & xy_SurfCond,                           & ! (in)
    84      & xy_FlagOceanGrid                       & ! (out)
    85      & )
    86      !
    87      !
    88      !
    89      ! Set flagx for ocean grid point from Matthews' index
    90      !
    91  
    92      ! ⥸塼 ; USE statements
    93      !
    94  
    95      ! ʻ
    96      ! Grid points settings
    97      !
    98      use gridset, only: imax, & ! ٳʻ.
    99                                 ! Number of grid points in longitude
   100        &                jmax, & ! ٳʻ.
   101                                 ! Number of grid points in latitude
   102        &                kmax    ! ľؿ.
   103                                 ! Number of vertical level
   104  
   105      ! ʸ ; Declaration statements
   106      !
   107      implicit none
   108  
   109      integer , intent(in ) :: xy_SurfCond     (0:imax-1, 1:jmax)
   110                                ! ɽ.
   111                                ! Surface condition
   112      logical , intent(out) :: xy_FlagOceanGrid(0:imax-1, 1:jmax)
   113                                !
   114                                ! Flag for ocean grid
   115  
   116  
   117      ! ѿ
   118      ! Work variables
   119      !
   120  
   121      integer:: i               ! ˲ DO 롼Ѻѿ
   122                                ! Work variables for DO loop in longitude
   123      integer:: j               ! ˲ DO 롼Ѻѿ
   124                                ! Work variables for DO loop in latitude
   125  
   126  
   127      ! ¹ʸ ; Executable statement
   128      !
   129  
   130      ! ǧ
   131      ! Initialization check
   132      !
   133      if ( .not. bucket_model_inited ) then
   134        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   135      end if
   136  
   137  
   138      !
   139      ! Set index for calculation method
   140      !
   141      do j = 1, jmax
   142        do i = 0, imax-1
   143          if ( xy_SurfCond(i,j) == 0 ) then
   144            ! ocean
   145            xy_FlagOceanGrid(i,j) = .true.
   146          else
   147            ! land
   148            xy_FlagOceanGrid(i,j) = .false.
   149          end if
   150        end do
   151      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xy_surfcond(j-1,1) .eq. 0) then                            
     .              xy_flagoceangrid(j-1,1) = 1                                 
     .           else                                                           
     .              xy_flagoceangrid(j-1,1) = 0                                 
     .           endif                                                          
     .        end do                                                            
   152  
   153  
   154    end subroutine BucketSetFlagOceanFromMatthews
   155  
   156    !--------------------------------------------------------------------------------------
   157  
   158    subroutine BucketIntegration(        &
   159      & xy_FlagOceanGrid,                & ! (in )
   160      & xy_DSoilMoistDt, xy_DSurfSnowDt, & ! (in )
   161      & xy_SoilMoistB, xy_SurfSnowB,     & ! (in )
   162      & xy_SoilMoistA, xy_SurfSnowA      & ! (out)
   163      )
   164  
   165      ! ȳɹ
   166      ! Setting constants of snow and sea ice
   167      !
   168      use constants_snowseaice, only: &
   169        & ThresholdSurfSnow,          &
   170        & TempCondWater
   171  
   172      ! 
   173      ! Time control
   174      !
   175      use timeset, only: &
   176        & DelTime, &             ! $ \Delta t $ [s]
   177        & TimesetClockStart, TimesetClockStop
   178  
   179      ! ʻ
   180      ! Grid points settings
   181      !
   182      use gridset, only: imax, & ! ٳʻ.
   183                                 ! Number of grid points in longitude
   184        &                jmax, & ! ٳʻ.
   185                                 ! Number of grid points in latitude
   186        &                kmax    ! ľؿ.
   187                                 ! Number of vertical level
   188  
   189      logical , intent(in ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   190      real(DP), intent(in ) :: xy_DSoilMoistDt ( 0:imax-1, 1:jmax )
   191      real(DP), intent(in ) :: xy_DSurfSnowDt  ( 0:imax-1, 1:jmax )
   192      real(DP), intent(in ) :: xy_SoilMoistB   ( 0:imax-1, 1:jmax )
   193      real(DP), intent(in ) :: xy_SurfSnowB    ( 0:imax-1, 1:jmax )
   194      real(DP), intent(out) :: xy_SoilMoistA   ( 0:imax-1, 1:jmax )
   195      real(DP), intent(out) :: xy_SurfSnowA    ( 0:imax-1, 1:jmax )
   196  
   197      ! ѿ
   198      ! Work variables
   199      !
   200      integer:: i               ! ˲ DO 롼Ѻѿ
   201                                ! Work variables for DO loop in longitude
   202      integer:: j               ! ˲ DO 롼Ѻѿ
   203                                ! Work variables for DO loop in latitude
   204  
   205  
   206      ! ǧ
   207      ! Initialization check
   208      !
   209      if ( .not. bucket_model_inited ) then
   210        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   211      end if
   212  
   213  
   214      ! ׻ַ¬
   215      ! Start measurement of computation time
   216      !
   217      call TimesetClockStart( module_name )
   218  
   219  
   220      xy_SoilMoistA = xy_SoilMoistB + xy_DSoilMoistDt * 2.0d0 * DelTime
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t176 = 1, jmax*imax                                            
     .           xy_soilmoista(t176-1,1) = xy_soilmoistb(t176-1,1) +            
     .       1      xy_dsoilmoistdt(t176-1,1)*2.00000000000000e+000*deltime     
     .        end do                                                            
   221  
   222      ! Remove negative values
   223      !
   224      do j = 1, jmax
   225        do i = 0, imax-1
   226          if( xy_SoilMoistA(i,j) < 0.0d0 ) xy_SoilMoistA(i,j) = 0.0d0
   227        end do
   228      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xy_soilmoista(j-1,1) .lt. 0.0000000000000000e+000) then    
     .              xy_soilmoista(j-1,1) = 0.0000000000000000e+000              
     .           endif                                                          
     .        end do                                                            
   229  
   230      if ( FlagSnow ) then
   231        xy_SurfSnowA = xy_SurfSnowB + xy_DSurfSnowDt * 2.0d0 * DelTime
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t194 = 1, jmax*imax                                            
     .           xy_surfsnowa(t194-1,1) = xy_surfsnowb(t194-1,1) +              
     .       1      xy_dsurfsnowdt(t194-1,1)*2.00000000000000e+000*deltime      
     .        end do                                                            
   232  
   233        ! Remove negative values
   234        !
   235        do j = 1, jmax
   236          do i = 0, imax-1
   237            if( xy_SurfSnowA (i,j) < 0.0d0 ) xy_SurfSnowA (i,j) = 0.0d0
   238          end do
   239        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xy_surfsnowa(j-1,1) .lt. 0.0000000000000000e+000) then     
     .              xy_surfsnowa(j-1,1) = 0.0000000000000000e+000               
     .           endif                                                          
     .        end do                                                            
     .        go to 10020                                                       
   240      else
   241        xy_SurfSnowA = xy_SurfSnowB
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t186 = 1, jmax*imax                                            
     .           xy_surfsnowa(t186-1,1) = xy_surfsnowb(t186-1,1)                
     .        end do                                                            
   242      end if
   243  
   244  
   245      ! Fill meaningless value in ocean grid
   246      !
   247      do j = 1, jmax
   248        do i = 0, imax-1
   249          if ( xy_FlagOceanGrid(i,j) ) then
   250            xy_SoilMoistA(i,j) = SoilMoistMeaningLess
   251            xy_SurfSnowA(i,j)  = SoilMoistMeaningLess
   252          end if
   253        end do
   254      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xy_flagoceangrid(j-1,1) .ne. 0) then                       
     .              xy_soilmoista(j-1,1) = soilmoistmeaningless                 
     .              xy_surfsnowa(j-1,1) = soilmoistmeaningless                  
     .           endif                                                          
     .        end do                                                            
   255  
   256  
   257      ! ׻ַ¬
   258      ! Pause measurement of computation time
   259      !
   260      call TimesetClockStop( module_name )
   261  
   262  
   263    end subroutine BucketIntegration
   264  
   265    !--------------------------------------------------------------------------------------
   266  !!$
   267  !!$  ! This is wrong under the condition that water vapor flux is negative (transported
   268  !!$  ! downward). (2011/12/17, yot)
   269  !!$
   270  !!$  subroutine BucketEvap(                 &
   271  !!$    & xy_FlagOceanGrid, xy_SurfEvapFlux, & ! (in )
   272  !!$    & xy_SoilMoistB, xy_SurfSnowB,       & ! (in )
   273  !!$    & xy_SoilMoistA, xy_SurfSnowA        & ! (out)
   274  !!$    )
   275  !!$
   276  !!$    ! 
   277  !!$    ! Time control
   278  !!$    !
   279  !!$    use timeset, only: &
   280  !!$      & DelTime, &             ! $ \Delta t $ [s]
   281  !!$      & TimesetClockStart, TimesetClockStop
   282  !!$
   283  !!$    ! ʻ
   284  !!$    ! Grid points settings
   285  !!$    !
   286  !!$    use gridset, only: imax, & ! ٳʻ.
   287  !!$                               ! Number of grid points in longitude
   288  !!$      &                jmax, & ! ٳʻ.
   289  !!$                               ! Number of grid points in latitude
   290  !!$      &                kmax    ! ľؿ.
   291  !!$                               ! Number of vertical level
   292  !!$
   293  !!$    ! ȳɹ
   294  !!$    ! Setting constants of snow and sea ice
   295  !!$    !
   296  !!$    use constants_snowseaice, only: &
   297  !!$      & ThresholdSurfSnow,          &
   298  !!$      & TempCondWater
   299  !!$
   300  !!$    logical , intent(in ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   301  !!$    real(DP), intent(in ) :: xy_SurfEvapFlux ( 0:imax-1, 1:jmax )
   302  !!$    real(DP), intent(in ) :: xy_SoilMoistB   ( 0:imax-1, 1:jmax )
   303  !!$    real(DP), intent(in ) :: xy_SurfSnowB    ( 0:imax-1, 1:jmax )
   304  !!$    real(DP), intent(out) :: xy_SoilMoistA   ( 0:imax-1, 1:jmax )
   305  !!$    real(DP), intent(out) :: xy_SurfSnowA    ( 0:imax-1, 1:jmax )
   306  !!$
   307  !!$    ! ѿ
   308  !!$    ! Work variables
   309  !!$    !
   310  !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   311  !!$                              ! Work variables for DO loop in longitude
   312  !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   313  !!$                              ! Work variables for DO loop in latitude
   314  !!$
   315  !!$
   316  !!$    ! ǧ
   317  !!$    ! Initialization check
   318  !!$    !
   319  !!$    if ( .not. bucket_model_inited ) then
   320  !!$      call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   321  !!$    end if
   322  !!$
   323  !!$
   324  !!$    ! ׻ַ¬
   325  !!$    ! Start measurement of computation time
   326  !!$    !
   327  !!$    call TimesetClockStart( module_name )
   328  !!$
   329  !!$
   330  !!$    if ( .not. FlagBucketModel ) then
   331  !!$      xy_SoilMoistA = xy_SoilMoistB
   332  !!$      xy_SurfSnowA  = xy_SurfSnowB
   333  !!$      return
   334  !!$    end if
   335  !!$
   336  !!$
   337  !!$    if ( FlagBucketModelSnow ) then
   338  !!$
   339  !!$      ! Evaporation is subtracted from surface snow and soil moisture
   340  !!$      !
   341  !!$      xy_SurfSnowA = xy_SurfSnowB - xy_SurfEvapFlux * 2.0d0 * DelTime
   342  !!$      do j = 1, jmax
   343  !!$        do i = 0, imax-1
   344  !!$          if ( xy_SurfSnowA(i,j) < 0.0d0 ) then
   345  !!$            xy_SoilMoistA(i,j) = xy_SoilMoistB(i,j) + xy_SurfSnowA(i,j)
   346  !!$            xy_SurfSnowA (i,j) = 0.0d0
   347  !!$          else
   348  !!$            xy_SoilMoistA(i,j) = xy_SoilMoistB(i,j)
   349  !!$          end if
   350  !!$        end do
   351  !!$      end do
   352  !!$    else
   353  !!$      ! Evaporation is subtracted from soil moisture
   354  !!$      !
   355  !!$      xy_SoilMoistA = xy_SoilMoistB - xy_SurfEvapFlux * 2.0d0 * DelTime
   356  !!$      xy_SurfSnowA  = xy_SurfSnowB
   357  !!$    end if
   358  !!$
   359  !!$    ! Remove negative values
   360  !!$    !
   361  !!$    do j = 1, jmax
   362  !!$      do i = 0, imax-1
   363  !!$        if( xy_SoilMoistA(i,j) < 0.0d0 ) xy_SoilMoistA(i,j) = 0.0d0
   364  !!$        if( xy_SurfSnowA (i,j) < 0.0d0 ) xy_SurfSnowA (i,j) = 0.0d0
   365  !!$      end do
   366  !!$    end do
   367  !!$
   368  !!$    ! Fill meaningless value in ocean grid
   369  !!$    !
   370  !!$    do j = 1, jmax
   371  !!$      do i = 0, imax-1
   372  !!$        if ( xy_FlagOceanGrid(i,j) ) then
   373  !!$          xy_SoilMoistA(i,j) = SoilMoistMeaningLess
   374  !!$          xy_SurfSnowA(i,j)  = SoilMoistMeaningLess
   375  !!$        end if
   376  !!$      end do
   377  !!$    end do
   378  !!$
   379  !!$    ! ׻ַ¬
   380  !!$    ! Pause measurement of computation time
   381  !!$    !
   382  !!$    call TimesetClockStop( module_name )
   383  !!$
   384  !!$
   385  !!$  end subroutine BucketEvap
   386  !!$
   387  !!$  !--------------------------------------------------------------------------------------
   388  !!$
   389  !!$  subroutine BucketEvapAdjust(           &
   390  !!$    & xy_FlagOceanGrid, xy_SurfEvapFlux, & ! (in   )
   391  !!$    & xy_SoilMoist, xy_SurfSnow          & ! (inout)
   392  !!$    )
   393  !!$
   394  !!$    ! ʻ
   395  !!$    ! Grid points settings
   396  !!$    !
   397  !!$    use gridset, only: imax, & ! ٳʻ.
   398  !!$                               ! Number of grid points in longitude
   399  !!$      &                jmax, & ! ٳʻ.
   400  !!$                               ! Number of grid points in latitude
   401  !!$      &                kmax    ! ľؿ.
   402  !!$                               ! Number of vertical level
   403  !!$
   404  !!$    logical , intent(in   ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   405  !!$    real(DP), intent(in   ) :: xy_SurfEvapFlux ( 0:imax-1, 1:jmax )
   406  !!$    real(DP), intent(inout) :: xy_SoilMoist    ( 0:imax-1, 1:jmax )
   407  !!$    real(DP), intent(inout) :: xy_SurfSnow     ( 0:imax-1, 1:jmax )
   408  !!$
   409  !!$    ! ѿ
   410  !!$    ! Work variables
   411  !!$    !
   412  !!$    real(DP) :: xy_SoilMoistB( 0:imax-1, 1:jmax )
   413  !!$    real(DP) :: xy_SurfSnowB ( 0:imax-1, 1:jmax )
   414  !!$    real(DP) :: xy_SoilMoistA( 0:imax-1, 1:jmax )
   415  !!$    real(DP) :: xy_SurfSnowA ( 0:imax-1, 1:jmax )
   416  !!$
   417  !!$
   418  !!$    ! ǧ
   419  !!$    ! Initialization check
   420  !!$    !
   421  !!$    if ( .not. bucket_model_inited ) then
   422  !!$      call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   423  !!$    end if
   424  !!$
   425  !!$
   426  !!$    xy_SoilMoistB = xy_SoilMoist
   427  !!$    xy_SurfSnowB  = xy_SurfSnow
   428  !!$
   429  !!$    call BucketEvap(                       &
   430  !!$      & xy_FlagOceanGrid, xy_SurfEvapFlux, & ! (in )
   431  !!$      & xy_SoilMoistB, xy_SurfSnowB,       & ! (in )
   432  !!$      & xy_SoilMoistA, xy_SurfSnowA        & ! (out)
   433  !!$      )
   434  !!$
   435  !!$    xy_SoilMoist = xy_SoilMoistA
   436  !!$    xy_SurfSnow  = xy_SurfSnowA
   437  !!$
   438  !!$
   439  !!$  end subroutine BucketEvapAdjust
   440  !!$
   441    !--------------------------------------------------------------------------------------
   442  
   443    subroutine BucketPRCPAdjust(                            &
   444      & xy_FlagOceanGrid, xy_SurfRainFlux, xy_SurfSnowFlux, &  ! (in )
   445      & xy_SoilMoist, xy_SurfSnow                           &  ! (inout)
   446      & )
   447  
   448      ! ҥȥǡ
   449      ! History data output
   450      !
   451      use gtool_historyauto, only: HistoryAutoPut
   452  
   453      ! ʪ
   454      ! Physical constants settings
   455      !
   456      use constants, only:  &
   457        & CpDry,            &
   458                                ! $ C_p $ [J kg-1 K-1].
   459                                ! 絤갵Ǯ.
   460                                ! Specific heat of air at constant pressure
   461        & Grav,             &
   462                                ! $ g $ [m s-2].
   463                                ! ϲ®.
   464                                ! Gravitational acceleration
   465        & LatentHeat,       &
   466                                ! $ L $ [J kg-1] .
   467                                ! ŷǮ.
   468                                ! Latent heat of condensation
   469        & LatentHeatFusion
   470                                ! $ L $ [J kg-1] .
   471                                ! ͻǮ.
   472                                ! Latent heat of fusion
   473  
   474      ! 
   475      ! Time control
   476      !
   477      use timeset, only: &
   478        & TimeN,   &             ! ƥå $ t $ λ. Time of step $ t $.
   479        & DelTime, &             ! $ \Delta t $ [s]
   480        & TimesetClockStart, TimesetClockStop
   481  
   482      ! ʻ
   483      ! Grid points settings
   484      !
   485      use gridset, only: imax, & ! ٳʻ.
   486                                 ! Number of grid points in longitude
   487        &                jmax, & ! ٳʻ.
   488                                 ! Number of grid points in latitude
   489        &                kmax    ! ľؿ.
   490                                 ! Number of vertical level
   491  
   492      ! ɸǡ
   493      ! Axes data settings
   494      !
   495      use axesset, only: &
   496        & z_DelSigma
   497                                ! $ \Delta \sigma $ ().
   498                                ! $ \Delta \sigma $ (Full)
   499  
   500      logical , intent(in   ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   501      real(DP), intent(in   ) :: xy_SurfRainFlux ( 0:imax-1, 1:jmax )
   502      real(DP), intent(in   ) :: xy_SurfSnowFlux ( 0:imax-1, 1:jmax )
   503      real(DP), intent(inout) :: xy_SoilMoist    ( 0:imax-1, 1:jmax )
   504      real(DP), intent(inout) :: xy_SurfSnow     ( 0:imax-1, 1:jmax )
   505  
   506  
   507      ! ѿ
   508      ! Work variables
   509      !
   510  !!$    real(DP) :: xy_TempIncByFusion( 0:imax-1, 1:jmax )
   511  !!$                              ! Temperature increase by fusion
   512  
   513      integer:: i               ! ˲ DO 롼Ѻѿ
   514                                ! Work variables for DO loop in longitude
   515      integer:: j               ! ˲ DO 롼Ѻѿ
   516                                ! Work variables for DO loop in latitude
   517  
   518  
   519      ! ǧ
   520      ! Initialization check
   521      !
   522      if ( .not. bucket_model_inited ) then
   523        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   524      end if
   525  
   526  
   527      ! ׻ַ¬
   528      ! Start measurement of computation time
   529      !
   530      call TimesetClockStart( module_name )
   531  
   532  
   533  !!$    ! Initialize an array for temperature increase by fusion
   534  !!$    !
   535  !!$    xy_TempIncByFusion = 0.0d0
   536  
   537  
   538      if ( FlagSnow ) then
   539        ! Precipitation is added to soil moisture or surface snow
   540        !
   541        do j = 1, jmax
   542          do i = 0, imax-1
   543  
   544            xy_SoilMoist(i,j) = xy_SoilMoist(i,j) &
   545              & + xy_SurfRainFlux(i,j) * 2.0d0 * DelTime
   546            xy_SurfSnow (i,j) = xy_SurfSnow (i,j) &
   547              & + xy_SurfSnowFlux(i,j) * 2.0d0 * DelTime
   548  
   549          end do
   550        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           xy_soilmoist(j-1,1) = xy_soilmoist(j-1,1) + (                  
     .       1      2.00000000000000e+000*deltime)*xy_surfrainflux(j-1,1)       
     .           xy_surfsnow(j-1,1) = xy_surfsnow(j-1,1) + (                    
     .       1      2.00000000000000e+000*deltime)*xy_surfsnowflux(j-1,1)       
     .        end do                                                            
     .        go to 10009                                                       
   551      else
   552        ! Precipitation is added to soil moisture
   553        !
   554  !!$      xy_SoilMoist = xy_SoilMoist + xy_SurfPRCPFlux * 2.0d0 * DelTime
   555        xy_SoilMoist = xy_SoilMoist &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t165 = 1, jmax*imax                                            
     .           xy_soilmoist(t165-1,1) = xy_soilmoist(t165-1,1) + (            
     .       1      xy_surfrainflux(t165-1,1)+xy_surfsnowflux(t165-1,1))*       
     .       2      2.00000000000000e+000*deltime                               
     .        end do                                                            
   556          & + ( xy_SurfRainFlux + xy_SurfSnowFlux ) * 2.0d0 * DelTime
   557      end if
   558  
   559      ! Calculation of Run-off
   560      !
   561      do j = 1, jmax
   562        do i = 0, imax-1
   563          if ( xy_SoilMoist(i,j) > SoilMoistCritAmnt ) &
   564            & xy_SoilMoist(i,j) = SoilMoistCritAmnt
   565        end do
   566      end do
   567  
   568      ! Fill meaningless value in ocean grid
   569      !
   570      do j = 1, jmax
   571        do i = 0, imax-1
   572          if ( xy_FlagOceanGrid(i,j) ) then
   573            xy_SoilMoist(i,j) = SoilMoistMeaningLess
   574            xy_SurfSnow (i,j) = SoilMoistMeaningLess
   575          end if
   576        end do
   577      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xy_soilmoist(j-1,1) .gt. soilmoistcritamnt) then           
     .              xy_soilmoist(j-1,1) = soilmoistcritamnt                     
     .           endif                                                          
     .           if (xy_flagoceangrid(j-1,1) .ne. 0) then                       
     .              xy_soilmoist(j-1,1) = soilmoistmeaningless                  
     .              xy_surfsnow(j-1,1) = soilmoistmeaningless                   
     .           endif                                                          
     .        end do                                                            
   578  
   579      ! ҥȥǡ
   580      ! History data output
   581      !
   582  !!$    call HistoryAutoPut( TimeN, 'TempIncByFusion' , xy_TempIncByFusion )
   583  
   584      ! ׻ַ¬
   585      ! Pause measurement of computation time
   586      !
   587      call TimesetClockStop( module_name )
   588  
   589    end subroutine BucketPRCPAdjust
   590  
   591    !--------------------------------------------------------------------------------------
   592  
   593    subroutine BucketModHumidCoef(                   &
   594      & xy_FlagOceanGrid, xy_SoilMoist, xy_SurfSnow, & ! (in   )
   595      & xy_SurfHumidCoef                             & ! (inout)
   596      & )
   597  
   598      ! ȳɹ
   599      ! Setting constants of snow and sea ice
   600      !
   601      use constants_snowseaice, only: &
   602        & ThresholdSurfSnow
   603  
   604      ! 
   605      ! Time control
   606      !
   607      use timeset, only: &
   608        & DelTime            ! $ \Delta t $ [s]
   609  
   610      ! ʻ
   611      ! Grid points settings
   612      !
   613      use gridset, only: imax, & ! ٳʻ.
   614                                 ! Number of grid points in longitude
   615        &                jmax, & ! ٳʻ.
   616                                 ! Number of grid points in latitude
   617        &                kmax    ! ľؿ.
   618                                 ! Number of vertical level
   619  
   620      logical , intent(in   ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   621      real(DP), intent(in   ) :: xy_SoilMoist    ( 0:imax-1, 1:jmax )
   622      real(DP), intent(in   ) :: xy_SurfSnow     ( 0:imax-1, 1:jmax )
   623      real(DP), intent(inout) :: xy_SurfHumidCoef( 0:imax-1, 1:jmax )
   624  
   625  
   626      ! ѿ
   627      ! Work variables
   628      !
   629      integer:: i               ! ˲ DO 롼Ѻѿ
   630                                ! Work variables for DO loop in longitude
   631      integer:: j               ! ˲ DO 롼Ѻѿ
   632                                ! Work variables for DO loop in latitude
   633  
   634      ! ǧ
   635      ! Initialization check
   636      !
   637      if ( .not. bucket_model_inited ) then
   638        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   639      end if
   640  
   641  
   642      ! Surface humidity coefficient is modified.
   643      !
   644      if ( FlagSnow ) then
   645        do j = 1, jmax
   646          do i = 0, imax-1
   647            if ( xy_FlagOceanGrid(i,j) ) then
   648              xy_SurfHumidCoef(i,j) = xy_SurfHumidCoef(i,j)
   649            else if ( xy_SurfSnow(i,j) > ThresholdSurfSnow ) then
   650              xy_SurfHumidCoef(i,j) = 1.0d0
   651            else
   652              xy_SurfHumidCoef(i,j) = xy_SoilMoist(i,j) / SoilMoistCritAmntforEvapEff
   653              if ( xy_SurfHumidCoef(i,j) > 1.0d0 ) xy_SurfHumidCoef(i,j) = 1.0d0
   654            end if
   655          end do
   656        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (.not.xy_flagoceangrid(j-1,1).ne.0) then                    
     .              if (xy_surfsnow(j-1,1) .gt. thresholdsurfsnow) then         
     .                 xy_surfhumidcoef(j-1,1) = 1.00000000000000e+000          
     .              else                                                        
     .                 xy_surfhumidcoef(j-1,1) = xy_soilmoist(j-1,1)/           
     .       1            soilmoistcritamntforevapeff                           
     .                 if (xy_surfhumidcoef(j-1,1) .gt. 1.00000000000000e+000)  
     .       1            then                                                  
     .                    xy_surfhumidcoef(j-1,1) = 1.00000000000000e+000       
     .                 endif                                                    
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
     .        go to 10008                                                       
   657      else
   658        do j = 1, jmax
   659          do i = 0, imax-1
   660            if ( xy_FlagOceanGrid(i,j) ) then
   661              xy_SurfHumidCoef(i,j) = xy_SurfHumidCoef(i,j)
   662            else
   663              xy_SurfHumidCoef(i,j) = xy_SoilMoist(i,j) / SoilMoistCritAmntforEvapEff
   664              if ( xy_SurfHumidCoef(i,j) > 1.0d0 ) xy_SurfHumidCoef(i,j) = 1.0d0
   665            end if
   666          end do
   667        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (.not.xy_flagoceangrid(j-1,1).ne.0) then                    
     .              xy_surfhumidcoef(j-1,1) = xy_soilmoist(j-1,1)/              
     .       1         soilmoistcritamntforevapeff                              
     .              if (xy_surfhumidcoef(j-1,1) .gt. 1.00000000000000e+000) then
     .                 xy_surfhumidcoef(j-1,1) = 1.00000000000000e+000          
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   668      end if
   669  
   670  
   671    end subroutine BucketModHumidCoef
   672  
   673    !--------------------------------------------------------------------------------------
   674  
   675    subroutine BucketModEvapAndLatentHeatFlux(       &
   676      & xy_FlagOceanGrid, xy_SoilMoist, xy_SurfSnow, & ! (in   )
   677      & xy_SurfEvapFlux, xy_SurfLatentHeatFlux       & ! (inout)
   678      & )
   679  
   680      ! 
   681      ! Time control
   682      !
   683      use timeset, only: &
   684        & DelTime, &             ! $ \Delta t $ [s]
   685        & TimesetClockStart, TimesetClockStop
   686  
   687      ! ʻ
   688      ! Grid points settings
   689      !
   690      use gridset, only: imax, & ! ٳʻ.
   691                                 ! Number of grid points in longitude
   692        &                jmax, & ! ٳʻ.
   693                                 ! Number of grid points in latitude
   694        &                kmax    ! ľؿ.
   695                                 ! Number of vertical level
   696  
   697      ! ʪ
   698      ! Physical constants settings
   699      !
   700      use constants, only:  &
   701        & LatentHeat,       &
   702                                ! $ L $ [J kg-1] .
   703                                ! ŷǮ.
   704                                ! Latent heat of condensation
   705        & LatentHeatFusion
   706                                ! $ L $ [J kg-1] .
   707                                ! ͻǮ.
   708                                ! Latent heat of fusion
   709  
   710      logical , intent(in   ) :: xy_FlagOceanGrid     ( 0:imax-1, 1:jmax )
   711      real(DP), intent(in   ) :: xy_SoilMoist         ( 0:imax-1, 1:jmax )
   712      real(DP), intent(in   ) :: xy_SurfSnow          ( 0:imax-1, 1:jmax )
   713      real(DP), intent(inout) :: xy_SurfEvapFlux      ( 0:imax-1, 1:jmax )
   714      real(DP), intent(inout) :: xy_SurfLatentHeatFlux( 0:imax-1, 1:jmax )
   715  
   716  
   717      ! ѿ
   718      ! Work variables
   719      !
   720      integer:: i               ! ˲ DO 롼Ѻѿ
   721                                ! Work variables for DO loop in longitude
   722      integer:: j               ! ˲ DO 롼Ѻѿ
   723                                ! Work variables for DO loop in latitude
   724  
   725  
   726      ! ǧ
   727      ! Initialization check
   728      !
   729      if ( .not. bucket_model_inited ) then
   730        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   731      end if
   732  
   733  
   734      ! ׻ַ¬
   735      ! Start measurement of computation time
   736      !
   737      call TimesetClockStart( module_name )
   738  
   739  
   740      if ( FlagSnow ) then
   741        ! Surface water vapor flux is limited up to the water and snow amount on land.
   742        !
   743        do j = 1, jmax
   744          do i = 0, imax-1
   745  
   746            if ( .not. xy_FlagOceanGrid(i,j)  ) then
   747              if ( xy_SurfEvapFlux(i,j) > 0.0d0 ) then
   748                ! Water vapor flux is positive (transported upward).
   749  
   750                if ( xy_SurfEvapFlux(i,j) * 2.0d0 * DelTime >           &
   751                  &     xy_SoilMoist(i,j) + xy_SurfSnow(i,j)          ) then
   752                  ! All snow and all water is evaporated.
   753                  xy_SurfEvapFlux(i,j) = &
   754                    & ( xy_SoilMoist(i,j) + xy_SurfSnow(i,j) ) / ( 2.0d0 * DelTime )
   755                  xy_SurfLatentHeatFlux(i,j) =                                    &
   756                    & (                                                           &
   757                    &     LatentHeat                        * xy_SoilMoist(i,j)   &
   758                    &   + ( LatentHeat + LatentHeatFusion ) * xy_SurfSnow(i,j)    &
   759                    & )                                                           &
   760                    & / ( 2.0d0 * DelTime )
   761                else if ( xy_SurfEvapFlux(i,j) * 2.0d0 * DelTime > xy_SurfSnow(i,j) ) then
   762                  ! All snow and a part of water is evaporated.
   763                  xy_SurfLatentHeatFlux(i,j) =                                      &
   764                    & (                                                             &
   765                    &     LatentHeat * ( xy_SurfEvapFlux(i,j) * 2.0d0 * DelTime - xy_SurfSnow(i,j) )  &
   766                    &   + ( LatentHeat + LatentHeatFusion ) * xy_SurfSnow(i,j)      &
   767                    & )                                                             &
   768                    & / ( 2.0d0 * DelTime )
   769                else
   770                  ! Only a part of snow is evaporated.
   771                  xy_SurfLatentHeatFlux(i,j) =                                      &
   772                    & ( LatentHeat + LatentHeatFusion ) * xy_SurfEvapFlux(i,j)
   773                end if
   774  
   775              else
   776                ! Water vapor flux is negative (transported downward).
   777  
   778                if ( xy_SurfSnow(i,j) > 0.0_DP ) then
   779                  ! Water vapor is converted to snow.
   780                  xy_SurfLatentHeatFlux(i,j) =                                      &
   781                    &   ( LatentHeat + LatentHeatFusion ) * xy_SurfEvapFlux(i,j)
   782                end if
   783  
   784              end if
   785            end if
   786  
   787          end do
   788        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xy_flagoceangrid(j-1,1) .eq. 0) then                       
     .              if (xy_surfevapflux(j-1,1) .gt. 0.0000000000000000e+000)    
     .       1         then                                                     
     .                 if (xy_surfevapflux(j-1,1)*2.00000000000000e+000*deltime 
     .       1             .gt. xy_soilmoist(j-1,1)+xy_surfsnow(j-1,1)) then    
     .                    xy_surfevapflux(j-1,1) = (xy_soilmoist(j-1,1)+        
     .       1               xy_surfsnow(j-1,1))/(2.00000000000000e+000*deltime)
     .                    xy_surflatentheatflux(j-1,1) = (latentheat*           
     .       1               xy_soilmoist(j-1,1)+(latentheat+latentheatfusion)* 
     .       2               xy_surfsnow(j-1,1))/(2.00000000000000e+000*deltime)
     .                 else                                                     
     .                    if (xy_surfevapflux(j-1,1)*2.00000000000000e+000*     
     .       1               deltime .le. xy_surfsnow(j-1,1)) then              
     .                       xy_surflatentheatflux(j-1,1) = (latentheat +       
     .       1                  latentheatfusion)*xy_surfevapflux(j-1,1)        
     .                    else                                                  
     .                       xy_surflatentheatflux(j-1,1) = (latentheat*((      
     .       1                  2.00000000000000e+000*deltime)*xy_surfevapflux(j
     .       2                  -1,1)-xy_surfsnow(j-1,1))+(latentheat+          
     .       3                  latentheatfusion)*xy_surfsnow(j-1,1))/(         
     .       4                  2.00000000000000e+000*deltime)                  
     .                    endif                                                 
     .                 endif                                                    
     .              else                                                        
     .                 if (xy_surfsnow(j-1,1) .gt. 0.0000000000000000e+000) then
     .                    xy_surflatentheatflux(j-1,1) = (latentheat +          
     .       1               latentheatfusion)*xy_surfevapflux(j-1,1)           
     .                 endif                                                    
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
     .        go to 10008                                                       
   789      else
   790        ! Surface water vapor flux is limited up to the water amount on land.
   791        !
   792        do j = 1, jmax
   793          do i = 0, imax-1
   794            if ( ( .not. xy_FlagOceanGrid(i,j)                                 ) .and.&
   795              &  ( xy_SurfEvapFlux(i,j)                   >  0.0d0             ) .and.&
   796              &  ( xy_SurfEvapFlux(i,j) * 2.0d0 * DelTime >  xy_SoilMoist(i,j) ) ) &
   797              & then
   798              xy_SurfEvapFlux(i,j) = xy_SoilMoist(i,j) / ( 2.0d0 * DelTime )
   799  
   800              xy_SurfLatentHeatFlux(i,j) = LatentHeat * xy_SoilMoist(i,j) / ( 2.0d0 * DelTime )
   801  
   802            end if
   803          end do
   804        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (.not.xy_flagoceangrid(j-1,1) .and. xy_surfevapflux(j-1,1)  
     .       1      .gt.0.0000000000000000e+000 .and. (2.00000000000000e+000*   
     .       2      deltime)*xy_surfevapflux(j-1,1).gt.xy_soilmoist(j-1,1)) then
     .              xy_surfevapflux(j-1,1) = xy_soilmoist(j-1,1)/(              
     .       1         2.00000000000000e+000*deltime)                           
     .              xy_surflatentheatflux(j-1,1) = latentheat*xy_soilmoist(j-1,1
     .       1         )/(2.00000000000000e+000*deltime)                        
     .           endif                                                          
     .        end do                                                            
   805      end if
   806  
   807      ! ׻ַ¬
   808      ! Pause measurement of computation time
   809      !
   810      call TimesetClockStop( module_name )
   811  
   812  
   813    end subroutine BucketModEvapAndLatentHeatFlux
   814  
   815    !-------------------------------------------------------------------------------------
   816  
   817    subroutine BucketModelInit( &
   818      & ArgFlagSnow             & ! (in)
   819      & )
   820      !
   821      ! bucket_model ⥸塼νԤޤ.
   822      ! NAMELIST#bucket_model_nml ɤ߹ߤϤμ³ǹԤޤ.
   823      !
   824      ! "bucket_model" module is initialized.
   825      ! "NAMELIST#bucket_model_nml" is loaded in this procedure.
   826      !
   827  
   828      ! ⥸塼 ; USE statements
   829      !
   830  
   831      ! ̷ѥ᥿
   832      ! Kind type parameter
   833      !
   834      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   835  
   836      ! ʸ
   837      ! Character handling
   838      !
   839      use dc_string, only: StoA
   840  
   841      ! ե
   842      ! File I/O support
   843      !
   844      use dc_iounit, only: FileOpen
   845  
   846      ! ҥȥǡ
   847      ! History data output
   848      !
   849      use gtool_historyauto, only: HistoryAutoAddVariable
   850  
   851      ! NAMELIST եϤ˴ؤ桼ƥƥ
   852      ! Utilities for NAMELIST file input
   853      !
   854      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   855  
   856  
   857      ! ʸ ; Declaration statements
   858      !
   859      implicit none
   860  
   861      logical, intent(in) :: ArgFlagSnow
   862  
   863  
   864      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   865                                ! Unit number for NAMELIST file open
   866      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   867                                ! IOSTAT of NAMELIST read
   868  
   869      ! NAMELIST ѿ
   870      ! NAMELIST group name
   871      !
   872      namelist /bucket_model_nml/                         &
   873        & SoilMoistCritAmnt, SoilMoistCritAmntforEvapEff
   874  
   875  
   876      ! ¹ʸ ; Executable statement
   877      !
   878  
   879      if ( bucket_model_inited ) return
   880  
   881  
   882      FlagSnow = ArgFlagSnow
   883  
   884  
   885      ! ǥեͤ
   886      ! Default values settings
   887      !
   888  
   889      ! Values from Manabe (1969)
   890      !  Manabe, Climate and the ocean circulation I. The atmospheric circulation and
   891      !  the hydrology of the Earth's surface, Mon. Wea. Rev., 97, 739-774, 1969
   892      !
   893      SoilMoistCritAmnt            = 1.0d3 * 0.15d0
   894      SoilMoistCritAmntforEvapEff  = 1.0d3 * 0.15d0 * 0.75d0
   895  
   896  
   897      ! NAMELIST ɤ߹
   898      ! NAMELIST is input
   899      !
   900      if ( trim(namelist_filename) /= '' ) then
   901        call FileOpen( unit_nml, &          ! (out)
   902          & namelist_filename, mode = 'r' ) ! (in)
   903  
   904        rewind( unit_nml )
   905        read( unit_nml, &                ! (in)
   906          & nml = bucket_model_nml, &    ! (out)
   907          & iostat = iostat_nml )        ! (out)
   908        close( unit_nml )
   909  
   910        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   911      end if
   912  
   913  
   914  !!$    ! ҥȥǡϤΤΤؤѿϿ
   915  !!$    ! Register of variables for history data output
   916  !!$    !
   917  !!$    call HistoryAutoAddVariable( 'TempIncByFusion', &
   918  !!$      & (/ 'lon ', 'lat ', 'time' /), &
   919  !!$      & 'temperature increase by fusion', 'K' )
   920  
   921  
   922      !  ; Print
   923      !
   924      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   925  
   926      call MessageNotify( 'M', module_name, '  SoilMoistCritAmnt           = %f', d = (/ SoilMoistCritAmnt  /) )
   927      call MessageNotify( 'M', module_name, '  SoilMoistCritAmntforEvapEff = %f', d = (/ SoilMoistCritAmntforEvapEff /) )
   928      call MessageNotify( 'M', module_name, '  FlagSnow                    = %y', l = (/ FlagSnow /) )
   929  
   930  
   931      bucket_model_inited = .true.
   932  
   933    end subroutine BucketModelInit
   934  
   935    !--------------------------------------------------------------------------------------
   936  
   937  end module Bucket_Model
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:24 2012
FILE NAME: bucket_model.f90
PROGRAM NAME: bucket_model
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Хĥǥ
     2:            !
     3:            != Bucket model
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: bucket_model.f90,v 1.12 2012-09-08 15:26:44 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module Bucket_Model
    13:            
    14:              ! ⥸塼 ; USE statements
    15:              !
    16:            
    17:            
    18:              ! ̷ѥ᥿
    19:              ! Kind type parameter
    20:              !
    21:              use dc_types, only: DP      ! ټ¿. Double precision.
    22:            
    23:              ! å
    24:              ! Message output
    25:              !
    26:              use dc_message, only: MessageNotify
    27:            
    28:              ! ʸ ; Declaration statements
    29:              !
    30:              implicit none
    31:              private
    32:            
    33:              logical, save :: bucket_model_inited = .false.
    34:                                          ! ե饰.
    35:                                          ! Initialization flag
    36:            
    37:            
    38:              logical, save :: FlagSnow   ! ΰ 󡿥.
    39:                                          ! treatment of snow on/off.
    40:            
    41:              ! ³
    42:              ! Public procedure
    43:              !
    44:              public :: BucketSetFlagOceanFromMatthews
    45:            !!$  public :: BucketEvap
    46:            !!$  public :: BucketEvapAdjust
    47:              public :: BucketIntegration
    48:              public :: BucketPRCPAdjust
    49:              public :: BucketModHumidCoef
    50:              public :: BucketModEvapAndLatentHeatFlux
    51:              public :: BucketModelInit
    52:            
    53:            
    54:              ! ѿ
    55:              ! Private variables
    56:              !
    57:              real(DP), save:: SoilMoistCritAmnt
    58:                                    ! ھʬ̤ξ
    59:                                    ! Critical amount of soil moisture
    60:              real(DP), save:: SoilMoistCritAmntforEvapEff
    61:                                    ! ɽ٤ 1 Ȥ
    62:                                    ! Critical amount of soil moisture for evaporation efficiency
    63:            
    64:              real(DP), save:: SoilMoistMeaningLess = -1.0d0
    65:                                    ! ξξ˻ѤʪŪˤϰ̣Τʤѿ
    66:                                    ! Meaning less value for soil moisture on the ocean
    67:            
    68:            
    69:              character(*), parameter:: module_name = 'bucket_model'
    70:                                          ! ⥸塼̾. 
    71:                                          ! Module name
    72:              character(*), parameter:: version = &
    73:                & '$Name: dcpam5-20120921 $' // &
    74:                & '$Id: bucket_model.f90,v 1.12 2012-09-08 15:26:44 yot Exp $'
    75:                                          ! ⥸塼ΥС
    76:                                          ! Module version
    77:            
    78:            contains
    79:            
    80:              !--------------------------------------------------------------------------------------
    81:            
    82:              subroutine BucketSetFlagOceanFromMatthews( &
    83:                & xy_SurfCond,                           & ! (in)
    84:                & xy_FlagOceanGrid                       & ! (out)
    85:                & )
    86:                !
    87:                !
    88:                !
    89:                ! Set flagx for ocean grid point from Matthews' index
    90:                !
    91:            
    92:                ! ⥸塼 ; USE statements
    93:                !
    94:            
    95:                ! ʻ
    96:                ! Grid points settings
    97:                !
    98:                use gridset, only: imax, & ! ٳʻ.
    99:                                           ! Number of grid points in longitude
   100:                  &                jmax, & ! ٳʻ.
   101:                                           ! Number of grid points in latitude
   102:                  &                kmax    ! ľؿ.
   103:                                           ! Number of vertical level
   104:            
   105:                ! ʸ ; Declaration statements
   106:                !
   107:                implicit none
   108:            
   109:                integer , intent(in ) :: xy_SurfCond     (0:imax-1, 1:jmax)
   110:                                          ! ɽ. 
   111:                                          ! Surface condition
   112:                logical , intent(out) :: xy_FlagOceanGrid(0:imax-1, 1:jmax)
   113:                                          ! 
   114:                                          ! Flag for ocean grid
   115:            
   116:            
   117:                ! ѿ
   118:                ! Work variables
   119:                !
   120:            
   121:                integer:: i               ! ˲ DO 롼Ѻѿ
   122:                                          ! Work variables for DO loop in longitude
   123:                integer:: j               ! ˲ DO 롼Ѻѿ
   124:                                          ! Work variables for DO loop in latitude
   125:            
   126:            
   127:                ! ¹ʸ ; Executable statement
   128:                !
   129:            
   130:                ! ǧ
   131:                ! Initialization check
   132:                !
   133:                if ( .not. bucket_model_inited ) then
   134:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   135:                end if
   136:            
   137:            
   138:                !
   139:                ! Set index for calculation method
   140:                !
   141: W------>       do j = 1, jmax
   142: |W----->         do i = 0, imax-1
   143: ||                 if ( xy_SurfCond(i,j) == 0 ) then
   144: ||                   ! ocean
   145: ||                   xy_FlagOceanGrid(i,j) = .true.
   146: ||                 else
   147: ||                   ! land
   148: ||                   xy_FlagOceanGrid(i,j) = .false.
   149: ||                 end if
   150: |W-----          end do
   151: W------        end do
   152:            
   153:            
   154:              end subroutine BucketSetFlagOceanFromMatthews
   155:            
   156:              !--------------------------------------------------------------------------------------
   157:            
   158:              subroutine BucketIntegration(        &
   159:                & xy_FlagOceanGrid,                & ! (in )
   160:                & xy_DSoilMoistDt, xy_DSurfSnowDt, & ! (in )
   161:                & xy_SoilMoistB, xy_SurfSnowB,     & ! (in )
   162:                & xy_SoilMoistA, xy_SurfSnowA      & ! (out)
   163:                )
   164:            
   165:                ! ȳɹ
   166:                ! Setting constants of snow and sea ice
   167:                !
   168:                use constants_snowseaice, only: &
   169:                  & ThresholdSurfSnow,          &
   170:                  & TempCondWater
   171:            
   172:                ! 
   173:                ! Time control
   174:                !
   175:                use timeset, only: &
   176:                  & DelTime, &             ! $ \Delta t $ [s]
   177:                  & TimesetClockStart, TimesetClockStop
   178:            
   179:                ! ʻ
   180:                ! Grid points settings
   181:                !
   182:                use gridset, only: imax, & ! ٳʻ.
   183:                                           ! Number of grid points in longitude
   184:                  &                jmax, & ! ٳʻ.
   185:                                           ! Number of grid points in latitude
   186:                  &                kmax    ! ľؿ.
   187:                                           ! Number of vertical level
   188:            
   189:                logical , intent(in ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   190:                real(DP), intent(in ) :: xy_DSoilMoistDt ( 0:imax-1, 1:jmax )
   191:                real(DP), intent(in ) :: xy_DSurfSnowDt  ( 0:imax-1, 1:jmax )
   192:                real(DP), intent(in ) :: xy_SoilMoistB   ( 0:imax-1, 1:jmax )
   193:                real(DP), intent(in ) :: xy_SurfSnowB    ( 0:imax-1, 1:jmax )
   194:                real(DP), intent(out) :: xy_SoilMoistA   ( 0:imax-1, 1:jmax )
   195:                real(DP), intent(out) :: xy_SurfSnowA    ( 0:imax-1, 1:jmax )
   196:            
   197:                ! ѿ
   198:                ! Work variables
   199:                !
   200:                integer:: i               ! ˲ DO 롼Ѻѿ
   201:                                          ! Work variables for DO loop in longitude
   202:                integer:: j               ! ˲ DO 롼Ѻѿ
   203:                                          ! Work variables for DO loop in latitude
   204:            
   205:            
   206:                ! ǧ
   207:                ! Initialization check
   208:                !
   209:                if ( .not. bucket_model_inited ) then
   210:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   211:                end if
   212:            
   213:            
   214:                ! ׻ַ¬
   215:                ! Start measurement of computation time
   216:                !
   217:                call TimesetClockStart( module_name )
   218:            
   219:            
   220: **=====        xy_SoilMoistA = xy_SoilMoistB + xy_DSoilMoistDt * 2.0d0 * DelTime
   221:            
   222:                ! Remove negative values
   223:                !
   224: W------>       do j = 1, jmax
   225: |W----->         do i = 0, imax-1
   226: ||                 if( xy_SoilMoistA(i,j) < 0.0d0 ) xy_SoilMoistA(i,j) = 0.0d0
   227: |W-----          end do
   228: W------        end do
   229:            
   230:                if ( FlagSnow ) then
   231: **=====          xy_SurfSnowA = xy_SurfSnowB + xy_DSurfSnowDt * 2.0d0 * DelTime
   232:            
   233:                  ! Remove negative values
   234:                  !
   235: W------>         do j = 1, jmax
   236: |W----->           do i = 0, imax-1
   237: ||                   if( xy_SurfSnowA (i,j) < 0.0d0 ) xy_SurfSnowA (i,j) = 0.0d0
   238: |W-----            end do
   239: W------          end do
   240:                else
   241: **=====          xy_SurfSnowA = xy_SurfSnowB
   242:                end if
   243:            
   244:            
   245:                ! Fill meaningless value in ocean grid
   246:                !
   247: W------>       do j = 1, jmax
   248: |*----->         do i = 0, imax-1
   249: ||                 if ( xy_FlagOceanGrid(i,j) ) then
   250: ||                   xy_SoilMoistA(i,j) = SoilMoistMeaningLess
   251: ||                   xy_SurfSnowA(i,j)  = SoilMoistMeaningLess
   252: ||                 end if
   253: |*-----          end do
   254: W------        end do
   255:            
   256:            
   257:                ! ׻ַ¬
   258:                ! Pause measurement of computation time
   259:                !
   260:                call TimesetClockStop( module_name )
   261:            
   262:            
   263:              end subroutine BucketIntegration
   264:            
   265:              !--------------------------------------------------------------------------------------
   266:            !!$
   267:            !!$  ! This is wrong under the condition that water vapor flux is negative (transported 
   268:            !!$  ! downward). (2011/12/17, yot)
   269:            !!$
   270:            !!$  subroutine BucketEvap(                 &
   271:            !!$    & xy_FlagOceanGrid, xy_SurfEvapFlux, & ! (in )
   272:            !!$    & xy_SoilMoistB, xy_SurfSnowB,       & ! (in )
   273:            !!$    & xy_SoilMoistA, xy_SurfSnowA        & ! (out)
   274:            !!$    )
   275:            !!$
   276:            !!$    ! 
   277:            !!$    ! Time control
   278:            !!$    !
   279:            !!$    use timeset, only: &
   280:            !!$      & DelTime, &             ! $ \Delta t $ [s]
   281:            !!$      & TimesetClockStart, TimesetClockStop
   282:            !!$
   283:            !!$    ! ʻ
   284:            !!$    ! Grid points settings
   285:            !!$    !
   286:            !!$    use gridset, only: imax, & ! ٳʻ.
   287:            !!$                               ! Number of grid points in longitude
   288:            !!$      &                jmax, & ! ٳʻ.
   289:            !!$                               ! Number of grid points in latitude
   290:            !!$      &                kmax    ! ľؿ.
   291:            !!$                               ! Number of vertical level
   292:            !!$
   293:            !!$    ! ȳɹ
   294:            !!$    ! Setting constants of snow and sea ice
   295:            !!$    !
   296:            !!$    use constants_snowseaice, only: &
   297:            !!$      & ThresholdSurfSnow,          &
   298:            !!$      & TempCondWater
   299:            !!$
   300:            !!$    logical , intent(in ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   301:            !!$    real(DP), intent(in ) :: xy_SurfEvapFlux ( 0:imax-1, 1:jmax )
   302:            !!$    real(DP), intent(in ) :: xy_SoilMoistB   ( 0:imax-1, 1:jmax )
   303:            !!$    real(DP), intent(in ) :: xy_SurfSnowB    ( 0:imax-1, 1:jmax )
   304:            !!$    real(DP), intent(out) :: xy_SoilMoistA   ( 0:imax-1, 1:jmax )
   305:            !!$    real(DP), intent(out) :: xy_SurfSnowA    ( 0:imax-1, 1:jmax )
   306:            !!$
   307:            !!$    ! ѿ
   308:            !!$    ! Work variables
   309:            !!$    !
   310:            !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   311:            !!$                              ! Work variables for DO loop in longitude
   312:            !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   313:            !!$                              ! Work variables for DO loop in latitude
   314:            !!$
   315:            !!$
   316:            !!$    ! ǧ
   317:            !!$    ! Initialization check
   318:            !!$    !
   319:            !!$    if ( .not. bucket_model_inited ) then
   320:            !!$      call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   321:            !!$    end if
   322:            !!$
   323:            !!$
   324:            !!$    ! ׻ַ¬
   325:            !!$    ! Start measurement of computation time
   326:            !!$    !
   327:            !!$    call TimesetClockStart( module_name )
   328:            !!$
   329:            !!$
   330:            !!$    if ( .not. FlagBucketModel ) then
   331:            !!$      xy_SoilMoistA = xy_SoilMoistB
   332:            !!$      xy_SurfSnowA  = xy_SurfSnowB
   333:            !!$      return
   334:            !!$    end if
   335:            !!$
   336:            !!$
   337:            !!$    if ( FlagBucketModelSnow ) then
   338:            !!$
   339:            !!$      ! Evaporation is subtracted from surface snow and soil moisture
   340:            !!$      !
   341:            !!$      xy_SurfSnowA = xy_SurfSnowB - xy_SurfEvapFlux * 2.0d0 * DelTime
   342:            !!$      do j = 1, jmax
   343:            !!$        do i = 0, imax-1
   344:            !!$          if ( xy_SurfSnowA(i,j) < 0.0d0 ) then
   345:            !!$            xy_SoilMoistA(i,j) = xy_SoilMoistB(i,j) + xy_SurfSnowA(i,j)
   346:            !!$            xy_SurfSnowA (i,j) = 0.0d0
   347:            !!$          else
   348:            !!$            xy_SoilMoistA(i,j) = xy_SoilMoistB(i,j)
   349:            !!$          end if
   350:            !!$        end do
   351:            !!$      end do
   352:            !!$    else
   353:            !!$      ! Evaporation is subtracted from soil moisture
   354:            !!$      !
   355:            !!$      xy_SoilMoistA = xy_SoilMoistB - xy_SurfEvapFlux * 2.0d0 * DelTime
   356:            !!$      xy_SurfSnowA  = xy_SurfSnowB
   357:            !!$    end if
   358:            !!$
   359:            !!$    ! Remove negative values
   360:            !!$    !
   361:            !!$    do j = 1, jmax
   362:            !!$      do i = 0, imax-1
   363:            !!$        if( xy_SoilMoistA(i,j) < 0.0d0 ) xy_SoilMoistA(i,j) = 0.0d0
   364:            !!$        if( xy_SurfSnowA (i,j) < 0.0d0 ) xy_SurfSnowA (i,j) = 0.0d0
   365:            !!$      end do
   366:            !!$    end do
   367:            !!$
   368:            !!$    ! Fill meaningless value in ocean grid
   369:            !!$    !
   370:            !!$    do j = 1, jmax
   371:            !!$      do i = 0, imax-1
   372:            !!$        if ( xy_FlagOceanGrid(i,j) ) then
   373:            !!$          xy_SoilMoistA(i,j) = SoilMoistMeaningLess
   374:            !!$          xy_SurfSnowA(i,j)  = SoilMoistMeaningLess
   375:            !!$        end if
   376:            !!$      end do
   377:            !!$    end do
   378:            !!$
   379:            !!$    ! ׻ַ¬
   380:            !!$    ! Pause measurement of computation time
   381:            !!$    !
   382:            !!$    call TimesetClockStop( module_name )
   383:            !!$
   384:            !!$
   385:            !!$  end subroutine BucketEvap
   386:            !!$
   387:            !!$  !--------------------------------------------------------------------------------------
   388:            !!$
   389:            !!$  subroutine BucketEvapAdjust(           &
   390:            !!$    & xy_FlagOceanGrid, xy_SurfEvapFlux, & ! (in   )
   391:            !!$    & xy_SoilMoist, xy_SurfSnow          & ! (inout)
   392:            !!$    )
   393:            !!$
   394:            !!$    ! ʻ
   395:            !!$    ! Grid points settings
   396:            !!$    !
   397:            !!$    use gridset, only: imax, & ! ٳʻ.
   398:            !!$                               ! Number of grid points in longitude
   399:            !!$      &                jmax, & ! ٳʻ.
   400:            !!$                               ! Number of grid points in latitude
   401:            !!$      &                kmax    ! ľؿ.
   402:            !!$                               ! Number of vertical level
   403:            !!$
   404:            !!$    logical , intent(in   ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   405:            !!$    real(DP), intent(in   ) :: xy_SurfEvapFlux ( 0:imax-1, 1:jmax )
   406:            !!$    real(DP), intent(inout) :: xy_SoilMoist    ( 0:imax-1, 1:jmax )
   407:            !!$    real(DP), intent(inout) :: xy_SurfSnow     ( 0:imax-1, 1:jmax )
   408:            !!$
   409:            !!$    ! ѿ
   410:            !!$    ! Work variables
   411:            !!$    !
   412:            !!$    real(DP) :: xy_SoilMoistB( 0:imax-1, 1:jmax )
   413:            !!$    real(DP) :: xy_SurfSnowB ( 0:imax-1, 1:jmax )
   414:            !!$    real(DP) :: xy_SoilMoistA( 0:imax-1, 1:jmax )
   415:            !!$    real(DP) :: xy_SurfSnowA ( 0:imax-1, 1:jmax )
   416:            !!$
   417:            !!$
   418:            !!$    ! ǧ
   419:            !!$    ! Initialization check
   420:            !!$    !
   421:            !!$    if ( .not. bucket_model_inited ) then
   422:            !!$      call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   423:            !!$    end if
   424:            !!$
   425:            !!$
   426:            !!$    xy_SoilMoistB = xy_SoilMoist
   427:            !!$    xy_SurfSnowB  = xy_SurfSnow
   428:            !!$
   429:            !!$    call BucketEvap(                       &
   430:            !!$      & xy_FlagOceanGrid, xy_SurfEvapFlux, & ! (in )
   431:            !!$      & xy_SoilMoistB, xy_SurfSnowB,       & ! (in )
   432:            !!$      & xy_SoilMoistA, xy_SurfSnowA        & ! (out)
   433:            !!$      )
   434:            !!$
   435:            !!$    xy_SoilMoist = xy_SoilMoistA
   436:            !!$    xy_SurfSnow  = xy_SurfSnowA
   437:            !!$
   438:            !!$
   439:            !!$  end subroutine BucketEvapAdjust
   440:            !!$
   441:              !--------------------------------------------------------------------------------------
   442:            
   443:              subroutine BucketPRCPAdjust(                            &
   444:                & xy_FlagOceanGrid, xy_SurfRainFlux, xy_SurfSnowFlux, &  ! (in )
   445:                & xy_SoilMoist, xy_SurfSnow                           &  ! (inout)
   446:                & )
   447:            
   448:                ! ҥȥǡ
   449:                ! History data output
   450:                !
   451:                use gtool_historyauto, only: HistoryAutoPut
   452:            
   453:                ! ʪ
   454:                ! Physical constants settings
   455:                !
   456:                use constants, only:  &
   457:                  & CpDry,            &
   458:                                          ! $ C_p $ [J kg-1 K-1].
   459:                                          ! 絤갵Ǯ.
   460:                                          ! Specific heat of air at constant pressure
   461:                  & Grav,             &
   462:                                          ! $ g $ [m s-2].
   463:                                          ! ϲ®.
   464:                                          ! Gravitational acceleration
   465:                  & LatentHeat,       &
   466:                                          ! $ L $ [J kg-1] .
   467:                                          ! ŷǮ.
   468:                                          ! Latent heat of condensation
   469:                  & LatentHeatFusion
   470:                                          ! $ L $ [J kg-1] .
   471:                                          ! ͻǮ.
   472:                                          ! Latent heat of fusion
   473:            
   474:                ! 
   475:                ! Time control
   476:                !
   477:                use timeset, only: &
   478:                  & TimeN,   &             ! ƥå $ t $ λ. Time of step $ t $.
   479:                  & DelTime, &             ! $ \Delta t $ [s]
   480:                  & TimesetClockStart, TimesetClockStop
   481:            
   482:                ! ʻ
   483:                ! Grid points settings
   484:                !
   485:                use gridset, only: imax, & ! ٳʻ.
   486:                                           ! Number of grid points in longitude
   487:                  &                jmax, & ! ٳʻ.
   488:                                           ! Number of grid points in latitude
   489:                  &                kmax    ! ľؿ.
   490:                                           ! Number of vertical level
   491:            
   492:                ! ɸǡ
   493:                ! Axes data settings
   494:                !
   495:                use axesset, only: &
   496:                  & z_DelSigma
   497:                                          ! $ \Delta \sigma $ ().
   498:                                          ! $ \Delta \sigma $ (Full)
   499:            
   500:                logical , intent(in   ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   501:                real(DP), intent(in   ) :: xy_SurfRainFlux ( 0:imax-1, 1:jmax )
   502:                real(DP), intent(in   ) :: xy_SurfSnowFlux ( 0:imax-1, 1:jmax )
   503:                real(DP), intent(inout) :: xy_SoilMoist    ( 0:imax-1, 1:jmax )
   504:                real(DP), intent(inout) :: xy_SurfSnow     ( 0:imax-1, 1:jmax )
   505:            
   506:            
   507:                ! ѿ
   508:                ! Work variables
   509:                !
   510:            !!$    real(DP) :: xy_TempIncByFusion( 0:imax-1, 1:jmax )
   511:            !!$                              ! Temperature increase by fusion
   512:            
   513:                integer:: i               ! ˲ DO 롼Ѻѿ
   514:                                          ! Work variables for DO loop in longitude
   515:                integer:: j               ! ˲ DO 롼Ѻѿ
   516:                                          ! Work variables for DO loop in latitude
   517:            
   518:            
   519:                ! ǧ
   520:                ! Initialization check
   521:                !
   522:                if ( .not. bucket_model_inited ) then
   523:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   524:                end if
   525:            
   526:            
   527:                ! ׻ַ¬
   528:                ! Start measurement of computation time
   529:                !
   530:                call TimesetClockStart( module_name )
   531:            
   532:            
   533:            !!$    ! Initialize an array for temperature increase by fusion
   534:            !!$    !
   535:            !!$    xy_TempIncByFusion = 0.0d0
   536:            
   537:            
   538:                if ( FlagSnow ) then
   539:                  ! Precipitation is added to soil moisture or surface snow
   540:                  !
   541: W------>         do j = 1, jmax
   542: |W----->           do i = 0, imax-1
   543: ||         
   544: ||                   xy_SoilMoist(i,j) = xy_SoilMoist(i,j) &
   545: ||                     & + xy_SurfRainFlux(i,j) * 2.0d0 * DelTime
   546: ||                   xy_SurfSnow (i,j) = xy_SurfSnow (i,j) &
   547: ||                     & + xy_SurfSnowFlux(i,j) * 2.0d0 * DelTime
   548: ||         
   549: |W-----            end do
   550: W------          end do
   551:                else
   552:                  ! Precipitation is added to soil moisture
   553:                  !
   554:            !!$      xy_SoilMoist = xy_SoilMoist + xy_SurfPRCPFlux * 2.0d0 * DelTime
   555: **=====          xy_SoilMoist = xy_SoilMoist &
   556:                    & + ( xy_SurfRainFlux + xy_SurfSnowFlux ) * 2.0d0 * DelTime
   557:                end if
   558:            
   559:                ! Calculation of Run-off
   560:                !
   561: W------>       do j = 1, jmax
   562: |*----->         do i = 0, imax-1
   563: ||                 if ( xy_SoilMoist(i,j) > SoilMoistCritAmnt ) &
   564: ||                   & xy_SoilMoist(i,j) = SoilMoistCritAmnt
   565: ||               end do
   566: ||             end do
   567: ||         
   568: ||             ! Fill meaningless value in ocean grid
   569: ||             !
   570: ||             do j = 1, jmax
   571: ||               do i = 0, imax-1
   572: ||                 if ( xy_FlagOceanGrid(i,j) ) then
   573: ||                   xy_SoilMoist(i,j) = SoilMoistMeaningLess
   574: ||                   xy_SurfSnow (i,j) = SoilMoistMeaningLess
   575: ||                 end if
   576: |*-----          end do
   577: W------        end do
   578:            
   579:                ! ҥȥǡ
   580:                ! History data output
   581:                !
   582:            !!$    call HistoryAutoPut( TimeN, 'TempIncByFusion' , xy_TempIncByFusion )
   583:            
   584:                ! ׻ַ¬
   585:                ! Pause measurement of computation time
   586:                !
   587:                call TimesetClockStop( module_name )
   588:            
   589:              end subroutine BucketPRCPAdjust
   590:            
   591:              !--------------------------------------------------------------------------------------
   592:            
   593:              subroutine BucketModHumidCoef(                   &
   594:                & xy_FlagOceanGrid, xy_SoilMoist, xy_SurfSnow, & ! (in   )
   595:                & xy_SurfHumidCoef                             & ! (inout)
   596:                & )
   597:            
   598:                ! ȳɹ
   599:                ! Setting constants of snow and sea ice
   600:                !
   601:                use constants_snowseaice, only: &
   602:                  & ThresholdSurfSnow
   603:            
   604:                ! 
   605:                ! Time control
   606:                !
   607:                use timeset, only: &
   608:                  & DelTime            ! $ \Delta t $ [s]
   609:            
   610:                ! ʻ
   611:                ! Grid points settings
   612:                !
   613:                use gridset, only: imax, & ! ٳʻ.
   614:                                           ! Number of grid points in longitude
   615:                  &                jmax, & ! ٳʻ.
   616:                                           ! Number of grid points in latitude
   617:                  &                kmax    ! ľؿ.
   618:                                           ! Number of vertical level
   619:            
   620:                logical , intent(in   ) :: xy_FlagOceanGrid( 0:imax-1, 1:jmax )
   621:                real(DP), intent(in   ) :: xy_SoilMoist    ( 0:imax-1, 1:jmax )
   622:                real(DP), intent(in   ) :: xy_SurfSnow     ( 0:imax-1, 1:jmax )
   623:                real(DP), intent(inout) :: xy_SurfHumidCoef( 0:imax-1, 1:jmax )
   624:            
   625:            
   626:                ! ѿ
   627:                ! Work variables
   628:                !
   629:                integer:: i               ! ˲ DO 롼Ѻѿ
   630:                                          ! Work variables for DO loop in longitude
   631:                integer:: j               ! ˲ DO 롼Ѻѿ
   632:                                          ! Work variables for DO loop in latitude
   633:            
   634:                ! ǧ
   635:                ! Initialization check
   636:                !
   637:                if ( .not. bucket_model_inited ) then
   638:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   639:                end if
   640:            
   641:            
   642:                ! Surface humidity coefficient is modified.
   643:                !
   644:                if ( FlagSnow ) then
   645: W------>         do j = 1, jmax
   646: |*----->           do i = 0, imax-1
   647: ||                   if ( xy_FlagOceanGrid(i,j) ) then
   648: ||                     xy_SurfHumidCoef(i,j) = xy_SurfHumidCoef(i,j)
   649: ||                   else if ( xy_SurfSnow(i,j) > ThresholdSurfSnow ) then
   650: ||                     xy_SurfHumidCoef(i,j) = 1.0d0
   651: ||                   else
   652: ||                     xy_SurfHumidCoef(i,j) = xy_SoilMoist(i,j) / SoilMoistCritAmntforEvapEff
   653: ||                     if ( xy_SurfHumidCoef(i,j) > 1.0d0 ) xy_SurfHumidCoef(i,j) = 1.0d0
   654: ||                   end if
   655: |*-----            end do
   656: W------          end do
   657:                else
   658: W------>         do j = 1, jmax
   659: |*----->           do i = 0, imax-1
   660: ||                   if ( xy_FlagOceanGrid(i,j) ) then
   661: ||                     xy_SurfHumidCoef(i,j) = xy_SurfHumidCoef(i,j)
   662: ||                   else
   663: ||                     xy_SurfHumidCoef(i,j) = xy_SoilMoist(i,j) / SoilMoistCritAmntforEvapEff
   664: ||                     if ( xy_SurfHumidCoef(i,j) > 1.0d0 ) xy_SurfHumidCoef(i,j) = 1.0d0
   665: ||                   end if
   666: |*-----            end do
   667: W------          end do
   668:                end if
   669:            
   670:            
   671:              end subroutine BucketModHumidCoef
   672:            
   673:              !--------------------------------------------------------------------------------------
   674:            
   675:              subroutine BucketModEvapAndLatentHeatFlux(       &
   676:                & xy_FlagOceanGrid, xy_SoilMoist, xy_SurfSnow, & ! (in   )
   677:                & xy_SurfEvapFlux, xy_SurfLatentHeatFlux       & ! (inout)
   678:                & )
   679:            
   680:                ! 
   681:                ! Time control
   682:                !
   683:                use timeset, only: &
   684:                  & DelTime, &             ! $ \Delta t $ [s]
   685:                  & TimesetClockStart, TimesetClockStop
   686:            
   687:                ! ʻ
   688:                ! Grid points settings
   689:                !
   690:                use gridset, only: imax, & ! ٳʻ.
   691:                                           ! Number of grid points in longitude
   692:                  &                jmax, & ! ٳʻ.
   693:                                           ! Number of grid points in latitude
   694:                  &                kmax    ! ľؿ.
   695:                                           ! Number of vertical level
   696:            
   697:                ! ʪ
   698:                ! Physical constants settings
   699:                !
   700:                use constants, only:  &
   701:                  & LatentHeat,       &
   702:                                          ! $ L $ [J kg-1] .
   703:                                          ! ŷǮ.
   704:                                          ! Latent heat of condensation
   705:                  & LatentHeatFusion
   706:                                          ! $ L $ [J kg-1] .
   707:                                          ! ͻǮ.
   708:                                          ! Latent heat of fusion
   709:            
   710:                logical , intent(in   ) :: xy_FlagOceanGrid     ( 0:imax-1, 1:jmax )
   711:                real(DP), intent(in   ) :: xy_SoilMoist         ( 0:imax-1, 1:jmax )
   712:                real(DP), intent(in   ) :: xy_SurfSnow          ( 0:imax-1, 1:jmax )
   713:                real(DP), intent(inout) :: xy_SurfEvapFlux      ( 0:imax-1, 1:jmax )
   714:                real(DP), intent(inout) :: xy_SurfLatentHeatFlux( 0:imax-1, 1:jmax )
   715:            
   716:            
   717:                ! ѿ
   718:                ! Work variables
   719:                !
   720:                integer:: i               ! ˲ DO 롼Ѻѿ
   721:                                          ! Work variables for DO loop in longitude
   722:                integer:: j               ! ˲ DO 롼Ѻѿ
   723:                                          ! Work variables for DO loop in latitude
   724:            
   725:            
   726:                ! ǧ
   727:                ! Initialization check
   728:                !
   729:                if ( .not. bucket_model_inited ) then
   730:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   731:                end if
   732:            
   733:            
   734:                ! ׻ַ¬
   735:                ! Start measurement of computation time
   736:                !
   737:                call TimesetClockStart( module_name )
   738:            
   739:            
   740:                if ( FlagSnow ) then
   741:                  ! Surface water vapor flux is limited up to the water and snow amount on land. 
   742:                  !
   743: W------>         do j = 1, jmax
   744: |*----->           do i = 0, imax-1
   745: ||         
   746: ||                   if ( .not. xy_FlagOceanGrid(i,j)  ) then
   747: ||                     if ( xy_SurfEvapFlux(i,j) > 0.0d0 ) then
   748: ||                       ! Water vapor flux is positive (transported upward).
   749: ||         
   750: ||                       if ( xy_SurfEvapFlux(i,j) * 2.0d0 * DelTime >           &
   751: ||                         &     xy_SoilMoist(i,j) + xy_SurfSnow(i,j)          ) then
   752: ||                         ! All snow and all water is evaporated.
   753: ||                         xy_SurfEvapFlux(i,j) = &
   754: ||                           & ( xy_SoilMoist(i,j) + xy_SurfSnow(i,j) ) / ( 2.0d0 * DelTime )
   755: ||                         xy_SurfLatentHeatFlux(i,j) =                                    &
   756: ||                           & (                                                           &
   757: ||                           &     LatentHeat                        * xy_SoilMoist(i,j)   &
   758: ||                           &   + ( LatentHeat + LatentHeatFusion ) * xy_SurfSnow(i,j)    &
   759: ||                           & )                                                           &
   760: ||                           & / ( 2.0d0 * DelTime )
   761: ||                       else if ( xy_SurfEvapFlux(i,j) * 2.0d0 * DelTime > xy_SurfSnow(i,j) ) then
   762: ||                         ! All snow and a part of water is evaporated.
   763: ||                         xy_SurfLatentHeatFlux(i,j) =                                      &
   764: ||                           & (                                                             &
   765: ||                           &     LatentHeat * ( xy_SurfEvapFlux(i,j) * 2.0d0 * DelTime - xy_SurfSnow(i,j) )  &
   766: ||                           &   + ( LatentHeat + LatentHeatFusion ) * xy_SurfSnow(i,j)      &
   767: ||                           & )                                                             &
   768: ||                           & / ( 2.0d0 * DelTime )
   769: ||                       else
   770: ||                         ! Only a part of snow is evaporated.
   771: ||                         xy_SurfLatentHeatFlux(i,j) =                                      &
   772: ||                           & ( LatentHeat + LatentHeatFusion ) * xy_SurfEvapFlux(i,j)
   773: ||                       end if
   774: ||         
   775: ||                     else
   776: ||                       ! Water vapor flux is negative (transported downward).
   777: ||         
   778: ||                       if ( xy_SurfSnow(i,j) > 0.0_DP ) then
   779: ||                         ! Water vapor is converted to snow. 
   780: ||                         xy_SurfLatentHeatFlux(i,j) =                                      &
   781: ||                           &   ( LatentHeat + LatentHeatFusion ) * xy_SurfEvapFlux(i,j)
   782: ||                       end if
   783: ||         
   784: ||                     end if
   785: ||                   end if
   786: ||         
   787: |*-----            end do
   788: W------          end do
   789:                else
   790:                  ! Surface water vapor flux is limited up to the water amount on land. 
   791:                  !
   792: W------>         do j = 1, jmax
   793: |*----->           do i = 0, imax-1
   794: ||                   if ( ( .not. xy_FlagOceanGrid(i,j)                                 ) .and.&
   795: ||                     &  ( xy_SurfEvapFlux(i,j)                   >  0.0d0             ) .and.&
   796: ||                     &  ( xy_SurfEvapFlux(i,j) * 2.0d0 * DelTime >  xy_SoilMoist(i,j) ) ) &
   797: ||                     & then
   798: ||                     xy_SurfEvapFlux(i,j) = xy_SoilMoist(i,j) / ( 2.0d0 * DelTime )
   799: ||         
   800: ||                     xy_SurfLatentHeatFlux(i,j) = LatentHeat * xy_SoilMoist(i,j) / ( 2.0d0 * DelTime )
   801: ||         
   802: ||                   end if
   803: |*-----            end do
   804: W------          end do
   805:                end if
   806:            
   807:                ! ׻ַ¬
   808:                ! Pause measurement of computation time
   809:                !
   810:                call TimesetClockStop( module_name )
   811:            
   812:            
   813:              end subroutine BucketModEvapAndLatentHeatFlux
   814:            
   815:              !-------------------------------------------------------------------------------------
   816:            
   817:              subroutine BucketModelInit( &
   818:                & ArgFlagSnow             & ! (in)
   819:                & )
   820:                !
   821:                ! bucket_model ⥸塼νԤޤ. 
   822:                ! NAMELIST#bucket_model_nml ɤ߹ߤϤμ³ǹԤޤ. 
   823:                !
   824:                ! "bucket_model" module is initialized. 
   825:                ! "NAMELIST#bucket_model_nml" is loaded in this procedure. 
   826:                !
   827:            
   828:                ! ⥸塼 ; USE statements
   829:                !
   830:            
   831:                ! ̷ѥ᥿
   832:                ! Kind type parameter
   833:                !
   834:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   835:            
   836:                ! ʸ
   837:                ! Character handling
   838:                !
   839:                use dc_string, only: StoA
   840:            
   841:                ! ե
   842:                ! File I/O support
   843:                !
   844:                use dc_iounit, only: FileOpen
   845:            
   846:                ! ҥȥǡ
   847:                ! History data output
   848:                !
   849:                use gtool_historyauto, only: HistoryAutoAddVariable
   850:            
   851:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   852:                ! Utilities for NAMELIST file input
   853:                !
   854:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   855:            
   856:            
   857:                ! ʸ ; Declaration statements
   858:                !
   859:                implicit none
   860:            
   861:                logical, intent(in) :: ArgFlagSnow
   862:            
   863:            
   864:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   865:                                          ! Unit number for NAMELIST file open
   866:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   867:                                          ! IOSTAT of NAMELIST read
   868:            
   869:                ! NAMELIST ѿ
   870:                ! NAMELIST group name
   871:                !
   872:                namelist /bucket_model_nml/                         &
   873:                  & SoilMoistCritAmnt, SoilMoistCritAmntforEvapEff
   874:            
   875:            
   876:                ! ¹ʸ ; Executable statement
   877:                !
   878:            
   879:                if ( bucket_model_inited ) return
   880:            
   881:            
   882:                FlagSnow = ArgFlagSnow
   883:            
   884:            
   885:                ! ǥեͤ
   886:                ! Default values settings
   887:                !
   888:            
   889:                ! Values from Manabe (1969)
   890:                !  Manabe, Climate and the ocean circulation I. The atmospheric circulation and 
   891:                !  the hydrology of the Earth's surface, Mon. Wea. Rev., 97, 739-774, 1969
   892:                !
   893:                SoilMoistCritAmnt            = 1.0d3 * 0.15d0
   894:                SoilMoistCritAmntforEvapEff  = 1.0d3 * 0.15d0 * 0.75d0
   895:            
   896:            
   897:                ! NAMELIST ɤ߹
   898:                ! NAMELIST is input
   899:                !
   900:                if ( trim(namelist_filename) /= '' ) then
   901:                  call FileOpen( unit_nml, &          ! (out)
   902:                    & namelist_filename, mode = 'r' ) ! (in)
   903:            
   904:                  rewind( unit_nml )
   905:                  read( unit_nml, &                ! (in)
   906:                    & nml = bucket_model_nml, &    ! (out)
   907:                    & iostat = iostat_nml )        ! (out)
   908:                  close( unit_nml )
   909:            
   910:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   911:                end if
   912:            
   913:            
   914:            !!$    ! ҥȥǡϤΤΤؤѿϿ
   915:            !!$    ! Register of variables for history data output
   916:            !!$    !
   917:            !!$    call HistoryAutoAddVariable( 'TempIncByFusion', &
   918:            !!$      & (/ 'lon ', 'lat ', 'time' /), &
   919:            !!$      & 'temperature increase by fusion', 'K' )
   920:            
   921:            
   922:                !  ; Print
   923:                !
   924:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   925:            
   926:                call MessageNotify( 'M', module_name, '  SoilMoistCritAmnt           = %f', d = (/ SoilMoistCritAmnt  /) )
   927:                call MessageNotify( 'M', module_name, '  SoilMoistCritAmntforEvapEff = %f', d = (/ SoilMoistCritAmntforEvapEff /) )
   928:                call MessageNotify( 'M', module_name, '  FlagSnow                    = %y', l = (/ FlagSnow /) )
   929:            
   930:            
   931:                bucket_model_inited = .true.
   932:            
   933:              end subroutine BucketModelInit
   934:            
   935:              !--------------------------------------------------------------------------------------
   936:            
   937:            end module Bucket_Model
