Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:45 2012
FILE NAME: albedo_Matthews.f90
PROGRAM NAME: albedo_matthews
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   211  opt  (1593): Loop nest collapsed into one loop.
   211  vec  (   4): Vectorized array expression.
   214  opt  (1772): Loop nest fused with following nest(s).
   214  opt  (1593): Loop nest collapsed into one loop.
   214  vec  (   1): Vectorized loop.
   221  opt  (1592): Outer loop unrolled inside inner loop.
   221  vec  (   4): Vectorized array expression.
   221  vec  (   4): Vectorized array expression.
   233  vec  (   4): Vectorized array expression.
   233  vec  (  26): Macro operation Sum/InnerProd.
   249  vec  (   3): Unvectorized loop.
   249  vec  (   7): Iteration count is too small.
   267  vec  (   1): Vectorized loop.
   267  vec  (   1): Vectorized loop.
   268  opt  (1592): Outer loop unrolled inside inner loop.
   282  vec  (   1): Vectorized loop.
   282  vec  (   1): Vectorized loop.
   283  opt  (1592): Outer loop unrolled inside inner loop.
   288  opt  (1592): Outer loop unrolled inside inner loop.
   288  vec  (   4): Vectorized array expression.
   288  vec  (   4): Vectorized array expression.
   368  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:45 2012
FILE NAME: albedo_Matthews.f90
PROGRAM NAME: albedo_matthews
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Matthews Υǡ˴Ťɽ̥٥
     2  !
     3  != set surface albedo based on data by Matthews
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Satoshi Noda
     6  ! Version::   $Id: albedo_Matthews.f90,v 1.7 2011-07-29 07:25:23 noda Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module albedo_Matthews
    13  
    14    ! ⥸塼 ; USE statements
    15    !
    16  
    17    ! ̷ѥ᥿
    18    ! Kind type parameter
    19    !
    20    use dc_types, only: DP, &      ! ټ¿. Double precision.
    21      &                 STRING     ! ʸ.       Strings.
    22  
    23    ! å
    24    ! Message output
    25    !
    26    use dc_message, only: MessageNotify
    27  
    28    ! ʻ
    29    ! Grid points settings
    30  
    31    ! ʸ ; Declaration statements
    32    !
    33    implicit none
    34    private
    35  
    36    ! ³
    37    ! Public procedure
    38    !
    39    public:: SetAlbedoMatthews
    40    public:: AlbedoMatthewsInit
    41  
    42    ! ѿ
    43    ! Public variables
    44    !
    45  
    46    ! ѿ
    47    ! Private variables
    48    !
    49    logical, save :: albedo_matthews_inited = .false.
    50                                ! ե饰.
    51                                ! Initialization flag
    52    logical   , save      :: flag_annual_mean
    53                                ! ǯʿѥե饰.
    54                                ! Flag of annual mean
    55    real(DP)  , save      :: OceanAlbedo
    56                                ! ΤΥ٥.
    57                                ! Albedo of ocean.
    58  
    59    integer , parameter :: NAlbType = 32
    60                                ! μο.
    61                                ! Number of vegetation type.
    62    integer , parameter :: NSeason = 4
    63                                ! ο.
    64                                ! Number of season.
    65    real(DP), save      :: a_Data_DOY( NSeason )
    66                                ! Ƶγ.
    67                                ! Start date of each season.
    68    real(DP), save      :: aa_Data_Albedo( NSeason, 0:NAlbType )
    69                                ! ƿ, Ƶˤ륢٥.
    70                                ! Albedo of each vegetation type, each season.
    71  
    72    !    win.  spr.  sum.  fall
    73    data a_Data_DOY / 0.0d0, 90.0d0, 181.0d0, 273.0d0 /
    74  
    75    !
    76    ! Matthews, 1985, NASA Technical memorandum #86199
    77    ! ATLAS, OF ARCHIVED VEGETATION, LAND-USE AND SEASONAL ALBEDO DATA SET
    78    ! http://ntrs.nasa.gov/archive/nasa/casi.ntrs.nasa.gov/19850016197_1985016197.pdf
    79    !
    80    ! Notice: The unit of the following values is percent.
    81    !         0.01 is multiplied in initialization.
    82    !
    83    !    win.  spr.  sum.  fall
    84    !    Jan.  Apr.  Jul.  Oct.   for nothern hemisphere
    85    !    Jul.  Oct.  Jan.  Apr.   for southern hemisphere
    86    data aa_Data_Albedo / &
    87      10,   10,   10,   10, & !  0  The values for 0 are not included in Matthes compilation.
    88      11,   11,   11,   11, & !  1
    89      11,   11,   11,   11, & !  2
    90      11,   11,   11,   11, & !  3
    91      12,   12,   12,   12, & !  4
    92      12,   13,   14,   13, & !  5
    93      17,   14,   13,   14, & !  6
    94      13,   14,   16,   13, & !  7
    95      11,   12,   15,   12, & !  8
    96      18,   16,   15,   16, & !  9
    97      12,   15,   18,   13, & ! 10
    98      12,   15,   18,   13, & ! 11
    99      28,   32,   28,   28, & ! 12
   100      15,   13,   12,   13, & ! 13
   101      14,   14,   16,   14, & ! 14
   102      20,   18,   17,   18, & ! 15
   103      14,   14,   17,   14, & ! 16
   104      15,   15,   18,   15, & ! 17
   105      15,   15,   18,   15, & ! 18
   106      17,   20,   20,   17, & ! 19
   107      17,   20,   20,   17, & ! 20
   108      28,   32,   28,   28, & ! 21
   109      12,   12,   17,   15, & ! 22
   110      14,   15,   17,   15, & ! 23
   111      14,   15,   16,   14, & ! 24
   112      16,   18,   25,   20, & ! 25
   113      17,   17,   20,   17, & ! 26
   114      16,   20,   20,   18, & ! 27
   115      16,   20,   20,   18, & ! 28
   116      16,   20,   20,   18, & ! 29
   117      30,   30,   30,   30, & ! 30
   118      75,   75,   75,   75, & ! 31
   119      16,   18,   20,   18  & ! 32
   120      /
   121  
   122  
   123    character(*), parameter:: module_name = 'albedo_Matthews'
   124                                ! ⥸塼̾.
   125                                ! Module name
   126    character(*), parameter:: version = &
   127      & '$Name: dcpam5-20120921 $' // &
   128      & '$Id: albedo_Matthews.f90,v 1.7 2011-07-29 07:25:23 noda Exp $'
   129                                ! ⥸塼ΥС
   130                                ! Module version
   131  
   132    ! INTERFACE ʸ ; INTERFACE statements
   133    !
   134  
   135  contains
   136  
   137    !--------------------------------------------------------------------------------------
   138  
   139    subroutine SetAlbedoMatthews( xy_SurfCond, xy_SurfAlbedo )
   140  
   141      ! ⥸塼 ; USE statements
   142      !
   143  
   144      ! ʻ
   145      ! Grid points settings
   146      !
   147      use gridset, only: imax, & ! ٳʻ.
   148                                 ! Number of grid points in longitude
   149        &                jmax, & ! ٳʻ.
   150                                 ! Number of grid points in latitude
   151        &                kmax    ! ľؿ.
   152                                 ! Number of vertical level
   153  
   154      ! դӻμ갷
   155      ! Date and time handler
   156      !
   157      use dc_calendar, only: DCCalInquire, DCCalDateEvalSecOfYear
   158  
   159      ! 
   160      ! Time control
   161      !
   162      use timeset, only: TimeN, InitialDate
   163  
   164      ! ʸ ; Declaration statements
   165      !
   166      integer , intent(in ) :: xy_SurfCond  ( 0:imax-1, 1:jmax )
   167                                ! Υǥå
   168                                ! Index of vegetation
   169      real(DP), intent(out) :: xy_SurfAlbedo( 0:imax-1, 1:jmax )
   170                                ! ɽ٥.
   171                                ! Surface albedo
   172  
   173      ! ѿ
   174      ! Work variables
   175      !
   176      real(DP):: SecOfYear
   177      real(DP):: a_Data_SOY_Ex( 0:nseason+1 )
   178                                ! Ƶγϻ (ޤΤ˳ĥ).
   179                                ! Start time of each season (extended for interpolation).
   180      real(DP):: xya_SurfAlbedoLocal( 0:imax-1, 1:jmax, 1:2 )
   181      integer :: i              ! ˲ DO 롼Ѻѿ
   182                                ! Work variables for DO loop in longitude
   183      integer :: j              ! ˲ DO 롼Ѻѿ
   184                                ! Work variables for DO loop in latitude
   185      integer :: l              ! ˲ DO 롼Ѻѿ
   186                                ! Work variables for DO loop in season
   187      integer :: t
   188      integer :: tindex
   189      integer :: a_tindex(1:2)
   190  
   191      integer:: hour_in_day, min_in_hour, day_in_year
   192      integer, pointer:: day_in_month_ptr(:) => null()
   193      real(DP):: sec_in_min, sec_in_day
   194  
   195      ! ¹ʸ ; Executable statement
   196      !
   197  
   198      ! ǧ
   199      ! Initialization check
   200      !
   201      if ( .not. albedo_matthews_inited ) then
   202        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   203      end if
   204  
   205  
   206      if ( flag_annual_mean ) then
   207  
   208        !
   209        ! Now, annual mean value is used, temporarily.
   210        !
   211        xy_SurfAlbedo = 0.0d0
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t303 = 1, jmax*imax                                            
     .           xy_surfalbedo(t303-1,1) = 0.0000000000000000e+000              
     .        end do                                                            
   212  
   213        do l = 1, nseason
   214          do j = 1, jmax
   215            do i = 0, imax-1
   216              xy_SurfAlbedo(i,j) = xy_SurfAlbedo(i,j) + aa_Data_Albedo( l, xy_SurfCond(i,j) )
   217            end do
   218          end do
   219        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           xy_surfalbedo1 = xy_surfalbedo(j-1,1)                          
     .           xy_surfalbedo1 = xy_surfalbedo1 + aa_data_albedo(1,xy_surfcond(
     .       1      j-1,1))                                                     
     .           xy_surfalbedo1 = xy_surfalbedo1 + aa_data_albedo(2,xy_surfcond(
     .       1      j-1,1))                                                     
     .           xy_surfalbedo1 = xy_surfalbedo1 + aa_data_albedo(3,xy_surfcond(
     .       1      j-1,1))                                                     
     .           xy_surfalbedo(j-1,1) = xy_surfalbedo1 + aa_data_albedo(4,      
     .       1      xy_surfcond(j-1,1))                                         
     .        end do                                                            
   220  
   221        xy_SurfAlbedo = xy_SurfAlbedo / dble( nseason )
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t309 = 1, J1                                                
     .              D2 = 1.D0/4.00000000000000e+000                             
     .  !CDIR       NODEP                                                       
     .              do t311 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surfalbedo(t311-1,t309) = xy_surfalbedo(t311-1,t309)* 
     .       1            D2                                                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t309 = J1 + 1, jmax, 4                                      
     .              D3 = 1.D0/4.00000000000000e+000                             
     .              D4 = 1.D0/4.00000000000000e+000                             
     .              D5 = 1.D0/4.00000000000000e+000                             
     .              D6 = 1.D0/4.00000000000000e+000                             
     .  !CDIR       NODEP                                                       
     .              do t311 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surfalbedo(t311-1,t309) = xy_surfalbedo(t311-1,t309)* 
     .       1            D3                                                    
     .                 xy_surfalbedo(t311-1,t309+1) = xy_surfalbedo(t311-1,t309+
     .       1            1)*D4                                                 
     .                 xy_surfalbedo(t311-1,t309+2) = xy_surfalbedo(t311-1,t309+
     .       1            2)*D5                                                 
     .                 xy_surfalbedo(t311-1,t309+3) = xy_surfalbedo(t311-1,t309+
     .       1            3)*D6                                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10035                                                       
   222  
   223      else
   224  
   225        SecOfYear = DCCalDateEvalSecOfYear( TimeN, date = InitialDate )
   226  
   227        call DCCalInquire( &
   228          & day_in_month_ptr = day_in_month_ptr , & ! (out)
   229          & hour_in_day      = hour_in_day  , &     ! (out)
   230          & min_in_hour      = min_in_hour  , &     ! (out)
   231          & sec_in_min       = sec_in_min )         ! (out)
   232  
   233        day_in_year = sum( day_in_month_ptr )
   234        deallocate( day_in_month_ptr )
   235        sec_in_day  = hour_in_day * min_in_hour * sec_in_min
   236  
   237  
   238        if ( SecOfYear > day_in_year * sec_in_day ) SecOfYear = day_in_year * sec_in_day
   239  
   240        a_Data_SOY_Ex(0) = ( 0.0d0 - ( day_in_year - a_Data_DOY(nseason) ) ) * sec_in_day
   241        do t = 1, nseason
   242          a_Data_SOY_Ex(t) = a_Data_DOY(t) * sec_in_day
   243        end do
     .           a_data_soy_ex(1) = a_data_doy(1)*sec_in_day                    
     .        a_data_soy_ex(2) = a_data_doy(2)*sec_in_day                       
     .        a_data_soy_ex(3) = a_data_doy(3)*sec_in_day                       
     .        a_data_soy_ex(4) = a_data_doy(4)*sec_in_day                       
   244        a_Data_SOY_Ex(nseason+1) = ( day_in_year + a_Data_DOY(1) ) * sec_in_day
   245  
   246  
   247        a_tindex(1) = 0
   248        a_tindex(2) = 1
   249        do t = 1, nseason
   250          if ( a_Data_DOY(t) * sec_in_day <= SecOfYear ) then
   251            a_tindex(1) = t
   252            a_tindex(2) = t+1
   253          end if
   254        end do
   255  
   256        do t = 1, 2
   257          ! for northern hemisphere
   258          tindex = a_tindex(t)
   259          if ( tindex == 0 ) then
   260            tindex = nseason
   261          else if ( tindex == nseason+1 ) then
   262            tindex = 1
   263          else
   264            tindex = tindex
   265          end if
   266          do j = jmax/2+1, jmax
   267            do i = 0, imax-1
   268              xya_SurfAlbedoLocal(i,j,t) = aa_Data_Albedo( tindex, xy_SurfCond(i,j) )
   269            end do
   270          end do
     .        if (jmax - jmax/2 .gt. 0) then                                    
     .           J2 = and(jmax - jmax/2,3)                                      
     .           do j = 1, J2                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xya_surfalbedolocal(i-1,j+jmax/2,t) = aa_data_albedo(    
     .       1            tindex,xy_surfcond(i-1,j+jmax/2))                     
     .              end do                                                      
     .           end do                                                         
     .           do j = J2 + 1, jmax - jmax/2, 4                                
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xya_surfalbedolocal(i-1,j+jmax/2,t) = aa_data_albedo(    
     .       1            tindex,xy_surfcond(i-1,j+jmax/2))                     
     .                 xya_surfalbedolocal(i-1,j+1+jmax/2,t) = aa_data_albedo(  
     .       1            tindex,xy_surfcond(i-1,j+1+jmax/2))                   
     .                 xya_surfalbedolocal(i-1,j+2+jmax/2,t) = aa_data_albedo(  
     .       1            tindex,xy_surfcond(i-1,j+2+jmax/2))                   
     .                 xya_surfalbedolocal(i-1,j+3+jmax/2,t) = aa_data_albedo(  
     .       1            tindex,xy_surfcond(i-1,j+3+jmax/2))                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   271          ! for southern hemisphere
   272          tindex = a_tindex(t) + nseason / 2
   273          if ( tindex > nseason ) tindex = tindex - nseason
   274          if ( tindex == 0 ) then
   275            tindex = nseason
   276          else if ( tindex == nseason+1 ) then
   277            tindex = 1
   278          else
   279            tindex = tindex
   280          end if
   281          do j = 1, jmax/2
   282            do i = 0, imax-1
   283              xya_SurfAlbedoLocal(i,j,t) = aa_Data_Albedo( tindex, xy_SurfCond(i,j) )
   284            end do
   285          end do
     .        if (jmax/2 .gt. 0) then                                           
     .           J3 = and(jmax/2,3)                                             
     .           do j = 1, J3                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xya_surfalbedolocal(i-1,j,t) = aa_data_albedo(tindex,    
     .       1            xy_surfcond(i-1,j))                                   
     .              end do                                                      
     .           end do                                                         
     .           do j = J3 + 1, jmax/2, 4                                       
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 xya_surfalbedolocal(i-1,j,t) = aa_data_albedo(tindex,    
     .       1            xy_surfcond(i-1,j))                                   
     .                 xya_surfalbedolocal(i-1,j+1,t) = aa_data_albedo(tindex,  
     .       1            xy_surfcond(i-1,j+1))                                 
     .                 xya_surfalbedolocal(i-1,j+2,t) = aa_data_albedo(tindex,  
     .       1            xy_surfcond(i-1,j+2))                                 
     .                 xya_surfalbedolocal(i-1,j+3,t) = aa_data_albedo(tindex,  
     .       1            xy_surfcond(i-1,j+3))                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   286        end do
   287  
   288        xy_SurfAlbedo =                                                   &
     .        if (xya_surfalbedolocal.DSC.U2 .gt. 0) then                       
     .           J4 = and(xya_surfalbedolocal.DSC.U2,3)                         
     .  !CDIR    NODEP                                                          
     .           do t291 = 1, J4                                                
     .              D9 = 1.D0/(a_data_soy_ex(a_tindex(2))-a_data_soy_ex(a_tindex
     .       1         (1)))                                                    
     .  !CDIR       NODEP                                                       
     .              do t293 = 1, xya_surfalbedolocal.DSC.U1 + 1                 
     .                 xy_surfalbedo(t293-1,t291) = (xya_surfalbedolocal(t293-1,
     .       1            t291,2)-xya_surfalbedolocal(t293-1,t291,1))*D9*(      
     .       2            secofyear - a_data_soy_ex(a_tindex(1))) +             
     .       3            xya_surfalbedolocal(t293-1,t291,1)                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t291 = J4 + 1, xya_surfalbedolocal.DSC.U2, 4                
     .              D8 = a_data_soy_ex(a_tindex(1))                             
     .              D7 = a_data_soy_ex(a_tindex(2))                             
     .  !CDIR       NODEP                                                       
     .              do t293 = 1, xya_surfalbedolocal.DSC.U1 + 1                 
     .                 xy_surfalbedo(t293-1,t291) = (xya_surfalbedolocal(t293-1,
     .       1            t291,2)-xya_surfalbedolocal(t293-1,t291,1))/(D7 - D8)*
     .       2            (secofyear - D8) + xya_surfalbedolocal(t293-1,t291,1) 
     .                 xy_surfalbedo(t293-1,t291+1) = (xya_surfalbedolocal(t293-
     .       1            1,t291+1,2)-xya_surfalbedolocal(t293-1,t291+1,1))/(D7 
     .       2             - D8)*(secofyear - D8) + xya_surfalbedolocal(t293-1, 
     .       3            t291+1,1)                                             
     .                 xy_surfalbedo(t293-1,t291+2) = (xya_surfalbedolocal(t293-
     .       1            1,t291+2,2)-xya_surfalbedolocal(t293-1,t291+2,1))/(D7 
     .       2             - D8)*(secofyear - D8) + xya_surfalbedolocal(t293-1, 
     .       3            t291+2,1)                                             
     .                 xy_surfalbedo(t293-1,t291+3) = (xya_surfalbedolocal(t293-
     .       1            1,t291+3,2)-xya_surfalbedolocal(t293-1,t291+3,1))/(D7 
     .       2             - D8)*(secofyear - D8) + xya_surfalbedolocal(t293-1, 
     .       3            t291+3,1)                                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   289          &   ( xya_SurfAlbedoLocal(:,:,2) - xya_SurfAlbedoLocal(:,:,1) ) &
   290          & / ( a_Data_SOY_Ex(a_tindex(2)) - a_Data_SOY_Ex(a_tindex(1)) ) &
   291          & * ( SecOfYear                  - a_Data_SOY_Ex(a_tindex(1)) ) &
   292          & + xya_SurfAlbedoLocal(:,:,1)
   293  
   294      end if
   295  
   296  
   297    end subroutine SetAlbedoMatthews
   298  
   299    !--------------------------------------------------------------------------------------
   300  
   301    subroutine AlbedoMatthewsInit
   302  
   303      ! NAMELIST եϤ˴ؤ桼ƥƥ
   304      ! Utilities for NAMELIST file input
   305      !
   306      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   307  
   308      ! ե
   309      ! File I/O support
   310      !
   311      use dc_iounit, only: FileOpen
   312  
   313      ! å
   314      ! Message output
   315      !
   316      use dc_message, only: MessageNotify
   317  
   318      ! ѿ
   319      ! Work variables
   320      !
   321      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   322                                ! Unit number for NAMELIST file open
   323      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   324                                ! IOSTAT of NAMELIST read
   325  
   326      ! NAMELIST ѿ
   327      ! NAMELIST group name
   328      !
   329      namelist /albedo_Matthews_nml/ &
   330        & flag_annual_mean, &
   331        & OceanAlbedo
   332            !
   333            ! ǥեͤˤĤƤϽ³ "surface_flux_bulk#SurfFluxInit"
   334            ! Υɤ򻲾ȤΤ.
   335            !
   336            ! Refer to source codes in the initialization procedure
   337            ! "surface_flux_bulk#SurfFluxInit" for the default values.
   338            !
   339  
   340      if ( albedo_matthews_inited ) return
   341  
   342  
   343      ! ǥեͤ
   344      ! Default values settings
   345      !
   346      flag_annual_mean = .false.
   347      OceanAlbedo      = 0.1d0
   348  
   349  
   350      ! NAMELIST ɤ߹
   351      ! NAMELIST is input
   352      !
   353      if ( trim(namelist_filename) /= '' ) then
   354        call FileOpen( unit_nml, &          ! (out)
   355          & namelist_filename, mode = 'r' ) ! (in)
   356  
   357        rewind( unit_nml )
   358        read( unit_nml, &                ! (in)
   359          & nml = albedo_Matthews_nml, &  ! (out)
   360          & iostat = iostat_nml )        ! (out)
   361        close( unit_nml )
   362  
   363        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   364      end if
   365  
   366  
   367  
   368      aa_Data_Albedo = aa_Data_Albedo * 1.0d-2
     .  !CDIR NODEP                                                             
     .        do t72 = 0, 32                                                    
     .           aa_data_albedo(1,t72) = aa_data_albedo(1,t72)*                 
     .       1      1.00000000000000e-002                                       
     .           aa_data_albedo(2,t72) = aa_data_albedo(2,t72)*                 
     .       1      1.00000000000000e-002                                       
     .           aa_data_albedo(3,t72) = aa_data_albedo(3,t72)*                 
     .       1      1.00000000000000e-002                                       
     .           aa_data_albedo(4,t72) = aa_data_albedo(4,t72)*                 
     .       1      1.00000000000000e-002                                       
     .        end do                                                            
   369  
   370  
   371      aa_Data_Albedo(:,0) = OceanAlbedo
     .        aa_data_albedo(1,0) = oceanalbedo                                 
     .        aa_data_albedo(2,0) = oceanalbedo                                 
     .        aa_data_albedo(3,0) = oceanalbedo                                 
     .        aa_data_albedo(4,0) = oceanalbedo                                 
   372  
   373  
   374  
   375      !  ; Print
   376      !
   377      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   378      call MessageNotify( 'M', module_name, '  flag_annual_mean = %b', l = (/ flag_annual_mean /) )
   379      call MessageNotify( 'M', module_name, '  OceanAlbedo      = %f', d = (/ OceanAlbedo      /) )
   380      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   381  
   382  
   383      albedo_matthews_inited = .true.
   384  
   385    end subroutine AlbedoMatthewsInit
   386  
   387    !--------------------------------------------------------------------------------------
   388  
   389  end module albedo_Matthews
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:45 2012
FILE NAME: albedo_Matthews.f90
PROGRAM NAME: albedo_matthews
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Matthews Υǡ˴Ťɽ̥٥
     2:            !
     3:            != set surface albedo based on data by Matthews
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Satoshi Noda
     6:            ! Version::   $Id: albedo_Matthews.f90,v 1.7 2011-07-29 07:25:23 noda Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module albedo_Matthews
    13:            
    14:              ! ⥸塼 ; USE statements
    15:              !
    16:            
    17:              ! ̷ѥ᥿
    18:              ! Kind type parameter
    19:              !
    20:              use dc_types, only: DP, &      ! ټ¿. Double precision.
    21:                &                 STRING     ! ʸ.       Strings.
    22:            
    23:              ! å
    24:              ! Message output
    25:              !
    26:              use dc_message, only: MessageNotify
    27:            
    28:              ! ʻ
    29:              ! Grid points settings
    30:            
    31:              ! ʸ ; Declaration statements
    32:              !
    33:              implicit none
    34:              private
    35:            
    36:              ! ³
    37:              ! Public procedure
    38:              !
    39:              public:: SetAlbedoMatthews
    40:              public:: AlbedoMatthewsInit
    41:            
    42:              ! ѿ
    43:              ! Public variables
    44:              !
    45:            
    46:              ! ѿ
    47:              ! Private variables
    48:              !
    49:              logical, save :: albedo_matthews_inited = .false.
    50:                                          ! ե饰.
    51:                                          ! Initialization flag
    52:              logical   , save      :: flag_annual_mean
    53:                                          ! ǯʿѥե饰.
    54:                                          ! Flag of annual mean
    55:              real(DP)  , save      :: OceanAlbedo
    56:                                          ! ΤΥ٥.
    57:                                          ! Albedo of ocean.
    58:            
    59:              integer , parameter :: NAlbType = 32
    60:                                          ! μο.
    61:                                          ! Number of vegetation type.
    62:              integer , parameter :: NSeason = 4
    63:                                          ! ο.
    64:                                          ! Number of season.
    65:              real(DP), save      :: a_Data_DOY( NSeason )
    66:                                          ! Ƶγ.
    67:                                          ! Start date of each season.
    68:              real(DP), save      :: aa_Data_Albedo( NSeason, 0:NAlbType )
    69:                                          ! ƿ, Ƶˤ륢٥.
    70:                                          ! Albedo of each vegetation type, each season.
    71:            
    72:              !    win.  spr.  sum.  fall
    73:              data a_Data_DOY / 0.0d0, 90.0d0, 181.0d0, 273.0d0 /
    74:            
    75:              !
    76:              ! Matthews, 1985, NASA Technical memorandum #86199 
    77:              ! ATLAS, OF ARCHIVED VEGETATION, LAND-USE AND SEASONAL ALBEDO DATA SET
    78:              ! http://ntrs.nasa.gov/archive/nasa/casi.ntrs.nasa.gov/19850016197_1985016197.pdf
    79:              ! 
    80:              ! Notice: The unit of the following values is percent.
    81:              !         0.01 is multiplied in initialization.
    82:              !
    83:              !    win.  spr.  sum.  fall
    84:              !    Jan.  Apr.  Jul.  Oct.   for nothern hemisphere
    85:              !    Jul.  Oct.  Jan.  Apr.   for southern hemisphere
    86:              data aa_Data_Albedo / &
    87:                10,   10,   10,   10, & !  0  The values for 0 are not included in Matthes compilation.
    88:                11,   11,   11,   11, & !  1
    89:                11,   11,   11,   11, & !  2
    90:                11,   11,   11,   11, & !  3
    91:                12,   12,   12,   12, & !  4
    92:                12,   13,   14,   13, & !  5
    93:                17,   14,   13,   14, & !  6
    94:                13,   14,   16,   13, & !  7
    95:                11,   12,   15,   12, & !  8
    96:                18,   16,   15,   16, & !  9
    97:                12,   15,   18,   13, & ! 10
    98:                12,   15,   18,   13, & ! 11
    99:                28,   32,   28,   28, & ! 12
   100:                15,   13,   12,   13, & ! 13
   101:                14,   14,   16,   14, & ! 14
   102:                20,   18,   17,   18, & ! 15
   103:                14,   14,   17,   14, & ! 16
   104:                15,   15,   18,   15, & ! 17
   105:                15,   15,   18,   15, & ! 18
   106:                17,   20,   20,   17, & ! 19
   107:                17,   20,   20,   17, & ! 20
   108:                28,   32,   28,   28, & ! 21
   109:                12,   12,   17,   15, & ! 22
   110:                14,   15,   17,   15, & ! 23
   111:                14,   15,   16,   14, & ! 24
   112:                16,   18,   25,   20, & ! 25
   113:                17,   17,   20,   17, & ! 26
   114:                16,   20,   20,   18, & ! 27
   115:                16,   20,   20,   18, & ! 28
   116:                16,   20,   20,   18, & ! 29
   117:                30,   30,   30,   30, & ! 30
   118:                75,   75,   75,   75, & ! 31
   119:                16,   18,   20,   18  & ! 32
   120:                /
   121:            
   122:            
   123:              character(*), parameter:: module_name = 'albedo_Matthews'
   124:                                          ! ⥸塼̾.
   125:                                          ! Module name
   126:              character(*), parameter:: version = &
   127:                & '$Name: dcpam5-20120921 $' // &
   128:                & '$Id: albedo_Matthews.f90,v 1.7 2011-07-29 07:25:23 noda Exp $'
   129:                                          ! ⥸塼ΥС
   130:                                          ! Module version
   131:            
   132:              ! INTERFACE ʸ ; INTERFACE statements
   133:              !
   134:            
   135:            contains
   136:            
   137:              !--------------------------------------------------------------------------------------
   138:            
   139:              subroutine SetAlbedoMatthews( xy_SurfCond, xy_SurfAlbedo )
   140:            
   141:                ! ⥸塼 ; USE statements
   142:                !
   143:            
   144:                ! ʻ
   145:                ! Grid points settings
   146:                !
   147:                use gridset, only: imax, & ! ٳʻ.
   148:                                           ! Number of grid points in longitude
   149:                  &                jmax, & ! ٳʻ.
   150:                                           ! Number of grid points in latitude
   151:                  &                kmax    ! ľؿ.
   152:                                           ! Number of vertical level
   153:            
   154:                ! դӻμ갷
   155:                ! Date and time handler
   156:                !
   157:                use dc_calendar, only: DCCalInquire, DCCalDateEvalSecOfYear
   158:            
   159:                ! 
   160:                ! Time control
   161:                !
   162:                use timeset, only: TimeN, InitialDate
   163:            
   164:                ! ʸ ; Declaration statements
   165:                !
   166:                integer , intent(in ) :: xy_SurfCond  ( 0:imax-1, 1:jmax )
   167:                                          ! Υǥå
   168:                                          ! Index of vegetation
   169:                real(DP), intent(out) :: xy_SurfAlbedo( 0:imax-1, 1:jmax )
   170:                                          ! ɽ٥.
   171:                                          ! Surface albedo
   172:            
   173:                ! ѿ
   174:                ! Work variables
   175:                !
   176:                real(DP):: SecOfYear
   177:                real(DP):: a_Data_SOY_Ex( 0:nseason+1 )
   178:                                          ! Ƶγϻ (ޤΤ˳ĥ).
   179:                                          ! Start time of each season (extended for interpolation).
   180:                real(DP):: xya_SurfAlbedoLocal( 0:imax-1, 1:jmax, 1:2 )
   181:                integer :: i              ! ˲ DO 롼Ѻѿ
   182:                                          ! Work variables for DO loop in longitude
   183:                integer :: j              ! ˲ DO 롼Ѻѿ
   184:                                          ! Work variables for DO loop in latitude
   185:                integer :: l              ! ˲ DO 롼Ѻѿ
   186:                                          ! Work variables for DO loop in season
   187:                integer :: t
   188:                integer :: tindex
   189:                integer :: a_tindex(1:2)
   190:            
   191:                integer:: hour_in_day, min_in_hour, day_in_year
   192:                integer, pointer:: day_in_month_ptr(:) => null()
   193:                real(DP):: sec_in_min, sec_in_day
   194:            
   195:                ! ¹ʸ ; Executable statement
   196:                !
   197:            
   198:                ! ǧ
   199:                ! Initialization check
   200:                !
   201:                if ( .not. albedo_matthews_inited ) then
   202:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   203:                end if
   204:            
   205:            
   206:                if ( flag_annual_mean ) then
   207:            
   208:                  !
   209:                  ! Now, annual mean value is used, temporarily.
   210:                  !
   211: W*=====          xy_SurfAlbedo = 0.0d0
   212:            
   213: *------>         do l = 1, nseason
   214: |W----->           do j = 1, jmax
   215: ||+---->             do i = 0, imax-1
   216: |||                    xy_SurfAlbedo(i,j) = xy_SurfAlbedo(i,j) + aa_Data_Albedo( l, xy_SurfCond(i,j) )
   217: ||+----              end do
   218: |W-----            end do
   219: *------          end do
   220:            
   221: +V=====          xy_SurfAlbedo = xy_SurfAlbedo / dble( nseason )
   222:            
   223:                else
   224:            
   225:                  SecOfYear = DCCalDateEvalSecOfYear( TimeN, date = InitialDate )
   226:            
   227:                  call DCCalInquire( &
   228:                    & day_in_month_ptr = day_in_month_ptr , & ! (out)
   229:                    & hour_in_day      = hour_in_day  , &     ! (out)
   230:                    & min_in_hour      = min_in_hour  , &     ! (out)
   231:                    & sec_in_min       = sec_in_min )         ! (out)
   232:            
   233: V======          day_in_year = sum( day_in_month_ptr )
   234:                  deallocate( day_in_month_ptr )
   235:                  sec_in_day  = hour_in_day * min_in_hour * sec_in_min
   236:            
   237:            
   238:                  if ( SecOfYear > day_in_year * sec_in_day ) SecOfYear = day_in_year * sec_in_day
   239:            
   240:                  a_Data_SOY_Ex(0) = ( 0.0d0 - ( day_in_year - a_Data_DOY(nseason) ) ) * sec_in_day
   241: *------>         do t = 1, nseason
   242: |                  a_Data_SOY_Ex(t) = a_Data_DOY(t) * sec_in_day
   243: *------          end do
   244:                  a_Data_SOY_Ex(nseason+1) = ( day_in_year + a_Data_DOY(1) ) * sec_in_day
   245:            
   246:            
   247:                  a_tindex(1) = 0
   248:                  a_tindex(2) = 1
   249: +------>         do t = 1, nseason
   250: |                  if ( a_Data_DOY(t) * sec_in_day <= SecOfYear ) then
   251: |                    a_tindex(1) = t
   252: |                    a_tindex(2) = t+1
   253: |                  end if
   254: +------          end do
   255:            
   256: +------>         do t = 1, 2
   257: |                  ! for northern hemisphere
   258: |                  tindex = a_tindex(t)
   259: |                  if ( tindex == 0 ) then
   260: |                    tindex = nseason
   261: |                  else if ( tindex == nseason+1 ) then
   262: |                    tindex = 1
   263: |                  else
   264: |                    tindex = tindex
   265: |                  end if
   266: |+----->           do j = jmax/2+1, jmax
   267: ||V---->             do i = 0, imax-1
   268: |||                    xya_SurfAlbedoLocal(i,j,t) = aa_Data_Albedo( tindex, xy_SurfCond(i,j) )
   269: ||V----              end do
   270: |+-----            end do
   271: |                  ! for southern hemisphere
   272: |                  tindex = a_tindex(t) + nseason / 2
   273: |                  if ( tindex > nseason ) tindex = tindex - nseason
   274: |                  if ( tindex == 0 ) then
   275: |                    tindex = nseason
   276: |                  else if ( tindex == nseason+1 ) then
   277: |                    tindex = 1
   278: |                  else
   279: |                    tindex = tindex
   280: |                  end if
   281: |+----->           do j = 1, jmax/2
   282: ||V---->             do i = 0, imax-1
   283: |||                    xya_SurfAlbedoLocal(i,j,t) = aa_Data_Albedo( tindex, xy_SurfCond(i,j) )
   284: ||V----              end do
   285: |+-----            end do
   286: +------          end do
   287:            
   288: +V=====          xy_SurfAlbedo =                                                   &
   289:                    &   ( xya_SurfAlbedoLocal(:,:,2) - xya_SurfAlbedoLocal(:,:,1) ) &
   290:                    & / ( a_Data_SOY_Ex(a_tindex(2)) - a_Data_SOY_Ex(a_tindex(1)) ) &
   291:                    & * ( SecOfYear                  - a_Data_SOY_Ex(a_tindex(1)) ) &
   292:                    & + xya_SurfAlbedoLocal(:,:,1)
   293:            
   294:                end if
   295:            
   296:            
   297:              end subroutine SetAlbedoMatthews
   298:            
   299:              !--------------------------------------------------------------------------------------
   300:            
   301:              subroutine AlbedoMatthewsInit
   302:            
   303:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   304:                ! Utilities for NAMELIST file input
   305:                !
   306:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   307:            
   308:                ! ե
   309:                ! File I/O support
   310:                !
   311:                use dc_iounit, only: FileOpen
   312:            
   313:                ! å
   314:                ! Message output
   315:                !
   316:                use dc_message, only: MessageNotify
   317:            
   318:                ! ѿ
   319:                ! Work variables
   320:                !
   321:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   322:                                          ! Unit number for NAMELIST file open
   323:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   324:                                          ! IOSTAT of NAMELIST read
   325:            
   326:                ! NAMELIST ѿ
   327:                ! NAMELIST group name
   328:                !
   329:                namelist /albedo_Matthews_nml/ &
   330:                  & flag_annual_mean, &
   331:                  & OceanAlbedo
   332:                      !
   333:                      ! ǥեͤˤĤƤϽ³ "surface_flux_bulk#SurfFluxInit"
   334:                      ! Υɤ򻲾ȤΤ.
   335:                      !
   336:                      ! Refer to source codes in the initialization procedure
   337:                      ! "surface_flux_bulk#SurfFluxInit" for the default values.
   338:                      !
   339:            
   340:                if ( albedo_matthews_inited ) return
   341:            
   342:            
   343:                ! ǥեͤ
   344:                ! Default values settings
   345:                !
   346:                flag_annual_mean = .false.
   347:                OceanAlbedo      = 0.1d0
   348:            
   349:            
   350:                ! NAMELIST ɤ߹
   351:                ! NAMELIST is input
   352:                !
   353:                if ( trim(namelist_filename) /= '' ) then
   354:                  call FileOpen( unit_nml, &          ! (out)
   355:                    & namelist_filename, mode = 'r' ) ! (in)
   356:            
   357:                  rewind( unit_nml )
   358:                  read( unit_nml, &                ! (in)
   359:                    & nml = albedo_Matthews_nml, &  ! (out)
   360:                    & iostat = iostat_nml )        ! (out)
   361:                  close( unit_nml )
   362:            
   363:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   364:                end if
   365:            
   366:            
   367:            
   368: +V=====        aa_Data_Albedo = aa_Data_Albedo * 1.0d-2
   369:            
   370:            
   371: *======        aa_Data_Albedo(:,0) = OceanAlbedo
   372:            
   373:            
   374:            
   375:                !  ; Print
   376:                !
   377:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   378:                call MessageNotify( 'M', module_name, '  flag_annual_mean = %b', l = (/ flag_annual_mean /) )
   379:                call MessageNotify( 'M', module_name, '  OceanAlbedo      = %f', d = (/ OceanAlbedo      /) )
   380:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   381:            
   382:            
   383:                albedo_matthews_inited = .true.
   384:            
   385:              end subroutine AlbedoMatthewsInit
   386:            
   387:              !--------------------------------------------------------------------------------------
   388:            
   389:            end module albedo_Matthews
