Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:47 2012
FILE NAME: modify_albedo_snowseaice.f90
PROGRAM NAME: modify_albedo_snowseaice
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   136  vec  (   1): Vectorized loop.
   164  opt  (1593): Loop nest collapsed into one loop.
   164  vec  (   1): Vectorized loop.
   192  opt  (1593): Loop nest collapsed into one loop.
   192  vec  (   1): Vectorized loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:47 2012
FILE NAME: modify_albedo_snowseaice.f90
PROGRAM NAME: modify_albedo_snowseaice
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ȳɹˤ륢٥Ѳ
     2  !
     3  != modification of surface albedo on the snow covered ground and on the sea ice
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: modify_albedo_snowseaice.f90,v 1.4 2012-01-20 00:16:41 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module modify_albedo_snowseaice
    13  
    14    ! ⥸塼 ; USE statements
    15    !
    16  
    17    ! ̷ѥ᥿
    18    ! Kind type parameter
    19    !
    20    use dc_types, only: DP, &      ! ټ¿. Double precision.
    21      &                 STRING     ! ʸ.       Strings.
    22  
    23    ! å
    24    ! Message output
    25    !
    26    use dc_message, only: MessageNotify
    27  
    28    ! ʻ
    29    ! Grid points settings
    30  
    31    ! ʸ ; Declaration statements
    32    !
    33    implicit none
    34    private
    35  
    36    ! ³
    37    ! Public procedure
    38    !
    39    public :: ModAlbedoDueToSnowSeaIce
    40    public :: ModAlbedoSnowSeaIceInit
    41  
    42    ! ѿ
    43    ! Public variables
    44    !
    45  
    46    ! ѿ
    47    ! Private variables
    48    !
    49    logical, save :: modify_albedo_snowseaice_inited = .false.
    50                                ! ե饰.
    51                                ! Initialization flag
    52  
    53    character(*), parameter:: module_name = 'modify_albedo_snowseaice'
    54                                ! ⥸塼̾.
    55                                ! Module name
    56    character(*), parameter:: version = &
    57      & '$Name: dcpam5-20120921 $' // &
    58      & '$Id: modify_albedo_snowseaice.f90,v 1.4 2012-01-20 00:16:41 yot Exp $'
    59                                ! ⥸塼ΥС
    60                                ! Module version
    61  
    62  contains
    63  
    64    !--------------------------------------------------------------------------------------
    65  
    66    subroutine ModAlbedoDueToSnowSeaIce(                &
    67      & xy_SurfCond,                                    &
    68      & xy_SurfMajCompIce, xy_SurfSnow, xy_SeaIceConc,  & ! (in   ) optional
    69      & xy_SurfAlbedo                                   & ! (inout)
    70      )
    71  
    72      ! ʻ
    73      ! Grid points settings
    74      !
    75      use gridset, only: imax, & ! ٳʻ.
    76                                 ! Number of grid points in longitude
    77        &                jmax, & ! ٳʻ.
    78                                 ! Number of grid points in latitude
    79        &                kmax    ! ľؿ.
    80                                 ! Number of vertical level
    81  
    82      ! ɸǡ
    83      ! Axes data settings
    84      !
    85      use axesset, only: y_Lat
    86  
    87      ! ȳɹ
    88      ! Setting constants of snow and sea ice
    89      !
    90      use constants_snowseaice, only:            &
    91        & SnowThreshold => ThresholdSurfSnow,    &
    92        & SnowAlbedo,                            &
    93        & SeaIceThreshold,                       &
    94        & SeaIceAlbedo,                          &
    95        & CO2IceThreshold,                       &
    96        & CO2IceAlbedoS,                         &
    97        & CO2IceAlbedoN
    98  
    99  
   100      integer , intent(in   )           :: xy_SurfCond      ( 0:imax-1, 1:jmax )
   101      real(DP), intent(in   ), optional :: xy_SurfMajCompIce( 0:imax-1, 1:jmax )
   102      real(DP), intent(in   ), optional :: xy_SurfSnow      ( 0:imax-1, 1:jmax )
   103      real(DP), intent(in   ), optional :: xy_SeaIceConc    ( 0:imax-1, 1:jmax )
   104      real(DP), intent(inout)           :: xy_SurfAlbedo    ( 0:imax-1, 1:jmax )
   105  
   106  
   107      ! ѿ
   108      ! Work variables
   109      !
   110      real(DP):: MajCompIceThreshold
   111      real(DP):: MajCompIceAlbedo
   112      integer:: i               ! ˲ DO 롼Ѻѿ
   113                                ! Work variables for DO loop in longitude
   114      integer:: j               ! ˲ DO 롼Ѻѿ
   115                                ! Work variables for DO loop in latitude
   116  
   117      ! ǧ
   118      ! Initialization check
   119      !
   120      if ( .not. modify_albedo_snowseaice_inited ) then
   121        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   122      end if
   123  
   124  
   125  
   126      if ( present( xy_SurfMajCompIce ) ) then
   127        ! modify surface albedo on the major component ice covered ground
   128        !
   129        MajCompIceThreshold = CO2IceThreshold
   130        do j = 1, jmax
   131          if ( y_Lat(j) < 0.0_DP ) then
   132            MajCompIceAlbedo = CO2IceAlbedoS
   133          else
   134            MajCompIceAlbedo = CO2IceAlbedoN
   135          end if
   136          do i = 0, imax-1
   137  
   138  !!$          if ( xy_SurfCond(i,j) > 0 .and. xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
   139  !!$            xy_SurfAlbedo(i,j) = MajCompIceAlbedo
   140  !!$          end if
   141  
   142            if ( xy_SurfCond(i,j) > 0 ) then
   143              if ( xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
   144                xy_SurfAlbedo(i,j) = MajCompIceAlbedo
   145              else if ( xy_SurfMajCompIce(i,j) < 0.0_DP ) then
   146                xy_SurfAlbedo(i,j) = xy_SurfAlbedo(i,j)
   147              else
   148                xy_SurfAlbedo(i,j) =                                                  &
   149                  & ( MajCompIceAlbedo - xy_SurfAlbedo(i,j) ) / ( MajCompIceThreshold - 0.0_DP )  &
   150                  & * ( xy_SurfMajCompIce(i,j) - 0.0_DP )                                   &
   151                  & + xy_SurfAlbedo(i,j)
   152              end if
   153            end if
   154  
   155          end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           if (xy_surfcond(i-1,j) .gt. 0) then                            
     .              if (xy_surfmajcompice(i-1,j) .gt. majcompicethreshold) then 
     .                 xy_surfalbedo(i-1,j) = majcompicealbedo                  
     .              else                                                        
     .                 if (xy_surfmajcompice(i-1,j) .ge. 0.0000000000000000e+000
     .       1            ) then                                                
     .                    xy_surfalbedo(i-1,j) = (majcompicealbedo -            
     .       1               xy_surfalbedo(i-1,j))/(majcompicethreshold -       
     .       2               0.0000000000000000e+000)*(xy_surfmajcompice(i-1,j)-
     .       3               0.0000000000000000e+000) + xy_surfalbedo(i-1,j)    
     .                 endif                                                    
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   156        end do
   157  
   158      end if
   159  
   160  
   161      if ( present( xy_SurfSnow ) ) then
   162        ! modify surface albedo on the snow covered ground
   163        !
   164        do j = 1, jmax
   165          do i = 0, imax-1
   166  
   167  !!$          if ( xy_SurfCond(i,j) > 0 .and. xy_SurfSnow(i,j) > SnowThreshold ) then
   168  !!$            xy_SurfAlbedo(i,j) = SnowAlbedo
   169  !!$          end if
   170  !!$
   171            if ( xy_SurfCond(i,j) > 0 ) then
   172              if ( xy_SurfSnow(i,j) > SnowThreshold ) then
   173                xy_SurfAlbedo(i,j) = SnowAlbedo
   174              else if ( xy_SurfSnow(i,j) < 0.0_DP ) then
   175                xy_SurfAlbedo(i,j) = xy_SurfAlbedo(i,j)
   176              else
   177                xy_SurfAlbedo(i,j) =                                                  &
   178                  & ( SnowAlbedo - xy_SurfAlbedo(i,j) ) / ( SnowThreshold - 0.0_DP )  &
   179                  & * ( xy_SurfSnow(i,j) - 0.0_DP )                                   &
   180                  & + xy_SurfAlbedo(i,j)
   181              end if
   182            end if
   183  
   184          end do
   185        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xy_surfcond(j-1,1) .gt. 0) then                            
     .              if (xy_surfsnow(j-1,1) .gt. snowthreshold) then             
     .                 xy_surfalbedo(j-1,1) = snowalbedo                        
     .              else                                                        
     .                 if (xy_surfsnow(j-1,1) .ge. 0.0000000000000000e+000) then
     .                    xy_surfalbedo(j-1,1) = (snowalbedo - xy_surfalbedo(j-1
     .       1               ,1))/(snowthreshold - 0.0000000000000000e+000)*(   
     .       2               xy_surfsnow(j-1,1)-0.0000000000000000e+000) +      
     .       3               xy_surfalbedo(j-1,1)                               
     .                 endif                                                    
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   186  
   187      end if
   188  
   189      if ( present( xy_SeaIceConc ) ) then
   190        ! modify surface albedo on the sea ice
   191        !
   192        do j = 1, jmax
   193          do i = 0, imax-1
   194  
   195            if ( xy_SurfCond(i,j) == 0 .and. xy_SeaIceConc(i,j) > SeaIceThreshold ) then
   196              xy_SurfAlbedo(i,j) = SeaIceAlbedo
   197            end if
   198  
   199  !!$          if ( xy_SurfCond(i,j) == 0 ) then
   200  !!$            if ( xy_SeaIceConc(i,j) > 1.0_DP ) then
   201  !!$!              call MessageNotify( 'E', module_name,                &
   202  !!$!                & 'The value of SeaIceConc is inappropriate, %f.', &
   203  !!$!                & d = (/ xy_SeaIceConc(i,j) / ) )
   204  !!$              xy_SurfAlbedo(i,j) = SeaIceAlbedo
   205  !!$            else if ( xy_SeaIceConc(i,j) < 0.0_DP ) then
   206  !!$!              call MessageNotify( 'E', module_name,                &
   207  !!$!                & 'The value of SeaIceConc is inappropriate, %f.', &
   208  !!$!                & d = (/ xy_SeaIceConc(i,j) / ) )
   209  !!$              xy_SurfAlbedo(i,j) = xy_SurfAlbedo(i,j)
   210  !!$            else
   211  !!$              xy_SurfAlbedo(i,j) =                                             &
   212  !!$                & ( SeaIceAlbedo - xy_SurfAlbedo(i,j) ) / ( 1.0_DP - 0.0_DP )  &
   213  !!$                & * ( xy_SeaIceConc(i,j) - 0.0_DP )                            &
   214  !!$                & + xy_SurfAlbedo(i,j)
   215  !!$            end if
   216  !!$          end if
   217  
   218          end do
   219        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xy_surfcond(j-1,1).eq.0 .and. xy_seaiceconc(j-1,1).gt.     
     .       1      seaicethreshold) then                                       
     .              xy_surfalbedo(j-1,1) = seaicealbedo                         
     .           endif                                                          
     .        end do                                                            
   220      end if
   221  
   222  
   223    end subroutine ModAlbedoDueToSnowSeaIce
   224  
   225    !--------------------------------------------------------------------------------------
   226  
   227    subroutine ModAlbedoSnowSeaIceInit
   228  
   229      if ( modify_albedo_snowseaice_inited ) return
   230  
   231  
   232      !  ; Print
   233      !
   234      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   235      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   236  
   237  
   238      modify_albedo_snowseaice_inited = .true.
   239  
   240    end subroutine ModAlbedoSnowSeaIceInit
   241  
   242    !--------------------------------------------------------------------------------------
   243  
   244  end module modify_albedo_snowseaice
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:47 2012
FILE NAME: modify_albedo_snowseaice.f90
PROGRAM NAME: modify_albedo_snowseaice
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ȳɹˤ륢٥Ѳ
     2:            !
     3:            != modification of surface albedo on the snow covered ground and on the sea ice
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: modify_albedo_snowseaice.f90,v 1.4 2012-01-20 00:16:41 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module modify_albedo_snowseaice
    13:            
    14:              ! ⥸塼 ; USE statements
    15:              !
    16:            
    17:              ! ̷ѥ᥿
    18:              ! Kind type parameter
    19:              !
    20:              use dc_types, only: DP, &      ! ټ¿. Double precision.
    21:                &                 STRING     ! ʸ.       Strings.
    22:            
    23:              ! å
    24:              ! Message output
    25:              !
    26:              use dc_message, only: MessageNotify
    27:            
    28:              ! ʻ
    29:              ! Grid points settings
    30:            
    31:              ! ʸ ; Declaration statements
    32:              !
    33:              implicit none
    34:              private
    35:            
    36:              ! ³
    37:              ! Public procedure
    38:              !
    39:              public :: ModAlbedoDueToSnowSeaIce
    40:              public :: ModAlbedoSnowSeaIceInit
    41:            
    42:              ! ѿ
    43:              ! Public variables
    44:              !
    45:            
    46:              ! ѿ
    47:              ! Private variables
    48:              !
    49:              logical, save :: modify_albedo_snowseaice_inited = .false.
    50:                                          ! ե饰.
    51:                                          ! Initialization flag
    52:            
    53:              character(*), parameter:: module_name = 'modify_albedo_snowseaice'
    54:                                          ! ⥸塼̾.
    55:                                          ! Module name
    56:              character(*), parameter:: version = &
    57:                & '$Name: dcpam5-20120921 $' // &
    58:                & '$Id: modify_albedo_snowseaice.f90,v 1.4 2012-01-20 00:16:41 yot Exp $'
    59:                                          ! ⥸塼ΥС
    60:                                          ! Module version
    61:            
    62:            contains
    63:            
    64:              !--------------------------------------------------------------------------------------
    65:            
    66:              subroutine ModAlbedoDueToSnowSeaIce(                &
    67:                & xy_SurfCond,                                    &
    68:                & xy_SurfMajCompIce, xy_SurfSnow, xy_SeaIceConc,  & ! (in   ) optional
    69:                & xy_SurfAlbedo                                   & ! (inout)
    70:                )
    71:            
    72:                ! ʻ
    73:                ! Grid points settings
    74:                !
    75:                use gridset, only: imax, & ! ٳʻ.
    76:                                           ! Number of grid points in longitude
    77:                  &                jmax, & ! ٳʻ.
    78:                                           ! Number of grid points in latitude
    79:                  &                kmax    ! ľؿ.
    80:                                           ! Number of vertical level
    81:            
    82:                ! ɸǡ
    83:                ! Axes data settings
    84:                !
    85:                use axesset, only: y_Lat
    86:            
    87:                ! ȳɹ
    88:                ! Setting constants of snow and sea ice
    89:                !
    90:                use constants_snowseaice, only:            &
    91:                  & SnowThreshold => ThresholdSurfSnow,    &
    92:                  & SnowAlbedo,                            &
    93:                  & SeaIceThreshold,                       &
    94:                  & SeaIceAlbedo,                          &
    95:                  & CO2IceThreshold,                       &
    96:                  & CO2IceAlbedoS,                         &
    97:                  & CO2IceAlbedoN
    98:            
    99:            
   100:                integer , intent(in   )           :: xy_SurfCond      ( 0:imax-1, 1:jmax )
   101:                real(DP), intent(in   ), optional :: xy_SurfMajCompIce( 0:imax-1, 1:jmax )
   102:                real(DP), intent(in   ), optional :: xy_SurfSnow      ( 0:imax-1, 1:jmax )
   103:                real(DP), intent(in   ), optional :: xy_SeaIceConc    ( 0:imax-1, 1:jmax )
   104:                real(DP), intent(inout)           :: xy_SurfAlbedo    ( 0:imax-1, 1:jmax )
   105:            
   106:            
   107:                ! ѿ
   108:                ! Work variables
   109:                !
   110:                real(DP):: MajCompIceThreshold
   111:                real(DP):: MajCompIceAlbedo
   112:                integer:: i               ! ˲ DO 롼Ѻѿ
   113:                                          ! Work variables for DO loop in longitude
   114:                integer:: j               ! ˲ DO 롼Ѻѿ
   115:                                          ! Work variables for DO loop in latitude
   116:            
   117:                ! ǧ
   118:                ! Initialization check
   119:                !
   120:                if ( .not. modify_albedo_snowseaice_inited ) then
   121:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   122:                end if
   123:            
   124:            
   125:            
   126:                if ( present( xy_SurfMajCompIce ) ) then
   127:                  ! modify surface albedo on the major component ice covered ground
   128:                  !
   129:                  MajCompIceThreshold = CO2IceThreshold
   130: +------>         do j = 1, jmax
   131: |                  if ( y_Lat(j) < 0.0_DP ) then
   132: |                    MajCompIceAlbedo = CO2IceAlbedoS
   133: |                  else
   134: |                    MajCompIceAlbedo = CO2IceAlbedoN
   135: |                  end if
   136: |V----->           do i = 0, imax-1
   137: ||         
   138: ||         !!$          if ( xy_SurfCond(i,j) > 0 .and. xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
   139: ||         !!$            xy_SurfAlbedo(i,j) = MajCompIceAlbedo
   140: ||         !!$          end if
   141: ||         
   142: ||                   if ( xy_SurfCond(i,j) > 0 ) then
   143: ||                     if ( xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
   144: ||                       xy_SurfAlbedo(i,j) = MajCompIceAlbedo
   145: ||                     else if ( xy_SurfMajCompIce(i,j) < 0.0_DP ) then
   146: ||                       xy_SurfAlbedo(i,j) = xy_SurfAlbedo(i,j)
   147: ||                     else
   148: ||                       xy_SurfAlbedo(i,j) =                                                  &
   149: ||                         & ( MajCompIceAlbedo - xy_SurfAlbedo(i,j) ) / ( MajCompIceThreshold - 0.0_DP )  &
   150: ||                         & * ( xy_SurfMajCompIce(i,j) - 0.0_DP )                                   &
   151: ||                         & + xy_SurfAlbedo(i,j)
   152: ||                     end if
   153: ||                   end if
   154: ||         
   155: |V-----            end do
   156: +------          end do
   157:            
   158:                end if
   159:            
   160:            
   161:                if ( present( xy_SurfSnow ) ) then
   162:                  ! modify surface albedo on the snow covered ground
   163:                  !
   164: W------>         do j = 1, jmax
   165: |*----->           do i = 0, imax-1
   166: ||         
   167: ||         !!$          if ( xy_SurfCond(i,j) > 0 .and. xy_SurfSnow(i,j) > SnowThreshold ) then
   168: ||         !!$            xy_SurfAlbedo(i,j) = SnowAlbedo
   169: ||         !!$          end if
   170: ||         !!$
   171: ||                   if ( xy_SurfCond(i,j) > 0 ) then
   172: ||                     if ( xy_SurfSnow(i,j) > SnowThreshold ) then
   173: ||                       xy_SurfAlbedo(i,j) = SnowAlbedo
   174: ||                     else if ( xy_SurfSnow(i,j) < 0.0_DP ) then
   175: ||                       xy_SurfAlbedo(i,j) = xy_SurfAlbedo(i,j)
   176: ||                     else
   177: ||                       xy_SurfAlbedo(i,j) =                                                  &
   178: ||                         & ( SnowAlbedo - xy_SurfAlbedo(i,j) ) / ( SnowThreshold - 0.0_DP )  &
   179: ||                         & * ( xy_SurfSnow(i,j) - 0.0_DP )                                   &
   180: ||                         & + xy_SurfAlbedo(i,j)
   181: ||                     end if
   182: ||                   end if
   183: ||         
   184: |*-----            end do
   185: W------          end do
   186:            
   187:                end if
   188:            
   189:                if ( present( xy_SeaIceConc ) ) then
   190:                  ! modify surface albedo on the sea ice
   191:                  !
   192: W------>         do j = 1, jmax
   193: |*----->           do i = 0, imax-1
   194: ||         
   195: ||                   if ( xy_SurfCond(i,j) == 0 .and. xy_SeaIceConc(i,j) > SeaIceThreshold ) then
   196: ||                     xy_SurfAlbedo(i,j) = SeaIceAlbedo
   197: ||                   end if
   198: ||         
   199: ||         !!$          if ( xy_SurfCond(i,j) == 0 ) then
   200: ||         !!$            if ( xy_SeaIceConc(i,j) > 1.0_DP ) then
   201: ||         !!$!              call MessageNotify( 'E', module_name,                &
   202: ||         !!$!                & 'The value of SeaIceConc is inappropriate, %f.', &
   203: ||         !!$!                & d = (/ xy_SeaIceConc(i,j) / ) )
   204: ||         !!$              xy_SurfAlbedo(i,j) = SeaIceAlbedo
   205: ||         !!$            else if ( xy_SeaIceConc(i,j) < 0.0_DP ) then
   206: ||         !!$!              call MessageNotify( 'E', module_name,                &
   207: ||         !!$!                & 'The value of SeaIceConc is inappropriate, %f.', &
   208: ||         !!$!                & d = (/ xy_SeaIceConc(i,j) / ) )
   209: ||         !!$              xy_SurfAlbedo(i,j) = xy_SurfAlbedo(i,j)
   210: ||         !!$            else
   211: ||         !!$              xy_SurfAlbedo(i,j) =                                             &
   212: ||         !!$                & ( SeaIceAlbedo - xy_SurfAlbedo(i,j) ) / ( 1.0_DP - 0.0_DP )  &
   213: ||         !!$                & * ( xy_SeaIceConc(i,j) - 0.0_DP )                            &
   214: ||         !!$                & + xy_SurfAlbedo(i,j)
   215: ||         !!$            end if
   216: ||         !!$          end if
   217: ||         
   218: |*-----            end do
   219: W------          end do
   220:                end if
   221:            
   222:            
   223:              end subroutine ModAlbedoDueToSnowSeaIce
   224:            
   225:              !--------------------------------------------------------------------------------------
   226:            
   227:              subroutine ModAlbedoSnowSeaIceInit
   228:            
   229:                if ( modify_albedo_snowseaice_inited ) return
   230:            
   231:            
   232:                !  ; Print
   233:                !
   234:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   235:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   236:            
   237:            
   238:                modify_albedo_snowseaice_inited = .true.
   239:            
   240:              end subroutine ModAlbedoSnowSeaIceInit
   241:            
   242:              !--------------------------------------------------------------------------------------
   243:            
   244:            end module modify_albedo_snowseaice
