Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:17 2012
FILE NAME: auxiliary.f90
PROGRAM NAME: auxiliary
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   268  opt  (1593): Loop nest collapsed into one loop.
   268  vec  (   4): Vectorized array expression.
   276  opt  (1592): Outer loop unrolled inside inner loop.
   276  vec  (   4): Vectorized array expression.
   276  vec  (   4): Vectorized array expression.
   278  opt  (1592): Outer loop unrolled inside inner loop.
   278  vec  (   4): Vectorized array expression.
   278  vec  (   4): Vectorized array expression.
   318  opt  (1592): Outer loop unrolled inside inner loop.
   318  vec  (   4): Vectorized array expression.
   318  vec  (   4): Vectorized array expression.
   319  opt  (1592): Outer loop unrolled inside inner loop.
   319  vec  (   4): Vectorized array expression.
   319  vec  (   4): Vectorized array expression.
   344  opt  (1592): Outer loop unrolled inside inner loop.
   344  vec  (   4): Vectorized array expression.
   344  vec  (   4): Vectorized array expression.
   347  vec  (   3): Unvectorized loop.
   347  vec  (  13): Overhead of loop division is too large.
   348  opt  (1037): Feedback of array elements.
   348  opt  (1592): Outer loop unrolled inside inner loop.
   348  vec  (   4): Vectorized array expression.
   348  vec  (   4): Vectorized array expression.
   357  opt  (1592): Outer loop unrolled inside inner loop.
   357  vec  (   4): Vectorized array expression.
   357  vec  (   4): Vectorized array expression.
   371  opt  (1593): Loop nest collapsed into one loop.
   371  vec  (   4): Vectorized array expression.
   372  vec  (   3): Unvectorized loop.
   372  vec  (  13): Overhead of loop division is too large.
   376  opt  (1037): Feedback of array elements.
   376  opt  (1592): Outer loop unrolled inside inner loop.
   376  vec  (   4): Vectorized array expression.
   376  vec  (   4): Vectorized array expression.
   387  opt  (1592): Outer loop unrolled inside inner loop.
   387  vec  (   4): Vectorized array expression.
   387  vec  (   4): Vectorized array expression.
   395  opt  (1592): Outer loop unrolled inside inner loop.
   395  vec  (   4): Vectorized array expression.
   395  vec  (   4): Vectorized array expression.
   401  opt  (1592): Outer loop unrolled inside inner loop.
   401  vec  (   4): Vectorized array expression.
   401  vec  (   4): Vectorized array expression.
   409  opt  (1592): Outer loop unrolled inside inner loop.
   409  vec  (   4): Vectorized array expression.
   409  vec  (   4): Vectorized array expression.
   417  warn (  82): Name "xyr_tempwork" is not used.
   489  vec  (   3): Unvectorized loop.
   489  vec  (  13): Overhead of loop division is too large.
   490  opt  (1593): Loop nest collapsed into one loop.
   490  vec  (   4): Vectorized array expression.
   494  opt  (  11): Fused array assignments. :line 494 - 495
   494  opt  (1593): Loop nest collapsed into one loop.
   494  vec  (   4): Vectorized array expression.
   503  vec  (   3): Unvectorized loop.
   503  vec  (  13): Overhead of loop division is too large.
   504  opt  (1593): Loop nest collapsed into one loop.
   504  vec  (   4): Vectorized array expression.
   509  vec  (   3): Unvectorized loop.
   509  vec  (  13): Overhead of loop division is too large.
   510  opt  (1593): Loop nest collapsed into one loop.
   510  vec  (   4): Vectorized array expression.
   623  vec  (   1): Vectorized loop.
   635  vec  (   4): Vectorized array expression.
   636  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:17 2012
FILE NAME: auxiliary.f90
PROGRAM NAME: auxiliary
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Ūѿ׻륵֥롼󡦴ؿ
     2  !
     3  != Subroutines and functions for calculating auxiliary variables
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6  ! Version::   $Id: auxiliary.f90,v 1.14 2012-02-20 08:09:17 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module auxiliary
    13    !
    14    != Ūѿ׻륵֥롼󡦴ؿ
    15    !
    16    != Subroutines and functions for calculating auxiliary variables
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! Υ⥸塼Ǥ, Ūѿ׻륵֥롼ؿ󶡤ޤ.
    21    !
    22    ! This module provides subroutines and functions for calculating auxiliary variables.
    23    !
    24    !== Procedures List
    25    !
    26    ! AuxVars          :: ٤Ⱦ $ \sigma $ ٥֤
    27    !                     ȹ٤λ
    28    ! AuxVarsInit      ::
    29    ! AuxVarsFinalize  :: λ (⥸塼ѿγդ)
    30    ! ---------------  :: ---------------
    31    ! AuxVars          :: Interpolate temperature on half $ \sigma $ level,
    32    !                     and calculate pressure and height
    33    ! AuxVarsInit      ::
    34    ! AuxVarsFinalize  :: Termination (deallocate variables in this module)
    35    !
    36    !--
    37    !== NAMELIST
    38    !
    39    ! NAMELIST#auxiliary_nml
    40    !++
    41  
    42    ! ⥸塼 ; USE statements
    43    !
    44  
    45    ! ʻ
    46    ! Grid points settings
    47    !
    48    use gridset, only: imax, & ! ٳʻ.
    49                               ! Number of grid points in longitude
    50      &                jmax, & ! ٳʻ.
    51                               ! Number of grid points in latitude
    52      &                kmax    ! ľؿ.
    53                               ! Number of vertical level
    54  
    55    ! ̷ѥ᥿
    56    ! Kind type parameter
    57    !
    58    use dc_types, only: DP, &      ! ټ¿. Double precision.
    59      &                 STRING     ! ʸ.       Strings.
    60  
    61    ! å
    62    ! Message output
    63    !
    64    use dc_message, only: MessageNotify
    65  
    66    ! ʸ ; Declaration statements
    67    !
    68    implicit none
    69    private
    70  
    71    ! ³
    72    ! Public procedure
    73    !
    74    public :: AuxVars
    75    public :: AuxVarsFinalize
    76    public :: AuxVarsInit
    77  
    78    ! ѿ
    79    ! Public variables
    80    !
    81  
    82    ! ѿ
    83    ! Private variables
    84    !
    85    logical, save :: auxiliary_inited = .false.
    86                                ! ե饰.
    87                                ! Initialization flag
    88  
    89    real(DP), save, allocatable:: z_TempInpolM (:)
    90                                ! ٤Ѥη.
    91                                ! Coefficient for interpolation of temperature
    92    real(DP), save, allocatable:: z_TempInpol (:)
    93                                ! ٤Ѥη.
    94                                ! Coefficient for interpolation of temperature
    95    real(DP), save:: RefPress
    96                                ! ൤.
    97                                ! Reference air pressure
    98  
    99    character(*), parameter:: module_name = 'auxiliary'
   100                                ! ⥸塼̾.
   101                                ! Module name
   102    character(*), parameter:: version = &
   103      & '$Name: dcpam5-20120921 $' // &
   104      & '$Id: auxiliary.f90,v 1.14 2012-02-20 08:09:17 yot Exp $'
   105                                ! ⥸塼ΥС
   106                                ! Module version
   107  
   108  contains
   109  
   110    !--------------------------------------------------------------------------------------
   111  
   112    recursive subroutine AuxVars(            &
   113      & xy_Ps, xyz_Temp, xyz_QVap,           &  ! (in )
   114      & xyr_Temp, xyz_VirTemp, xyr_VirTemp,  &  ! (out) optional
   115      & xyz_Press,  xyr_Press,               &  ! (out) optional
   116      & xy_SurfHeight,                       &  ! (in ) optional
   117      & xyz_Height, xyr_Height,              &  ! (out) optional
   118      & xyz_Exner,  xyr_Exner                &  ! (out) optional
   119      & )
   120      !
   121      ! ٤Ⱦҥ٥, ȹ٤λ,
   122      ! ʡؿη׻Ԥޤ.
   123      !
   124      ! Interpolate temperature on half sigma level,
   125      ! and calculate pressure and height,
   126      ! and calculate exner function.
   127  
   128      ! ⥸塼 ; USE statements
   129      !
   130  
   131      ! ɸǡ
   132      ! Axes data settings
   133      !
   134      use axesset, only: &
   135        & z_Sigma, &
   136                                ! $ \sigma $ ٥ ().
   137                                ! Full $ \sigma $ level
   138        & r_Sigma, &
   139                                ! $ \sigma $ ٥ (Ⱦ).
   140                                ! Half $ \sigma $ level
   141        & z_DelSigma, &
   142                                ! $ \Delta \sigma $ ().
   143                                ! $ \Delta \sigma $ (Full)
   144        & r_DelSigma
   145                                ! $ \Delta \sigma $ (Ⱦ).
   146                                ! $ \Delta \sigma $ (Half)
   147  
   148      ! ʪ
   149      ! Physical constants settings
   150      !
   151      use constants, only: &
   152        & Grav, &               ! $ g $ [m s-2].
   153                                ! ϲ®.
   154                                ! Gravitational acceleration
   155        & GasRDry, &
   156                                ! $ R $ [J kg-1 K-1].
   157                                ! 絤ε.
   158                                ! Gas constant of air
   159        & CpDry, &
   160                                ! $ C_p $ [J kg-1 K-1].
   161                                ! 絤갵Ǯ.
   162                                ! Specific heat of air at constant pressure
   163        & EpsV
   164                                ! $ \epsilon_v $ .
   165                                ! ʬ.
   166                                ! Molecular weight of water vapor
   167  
   168      ! 
   169      ! Time control
   170      !
   171      use timeset, only: TimesetClockStart, TimesetClockStop
   172  
   173      ! ʸ ; Declaration statements
   174      !
   175      implicit none
   176  
   177      real(DP), intent(in):: xy_Ps       (0:imax-1, 1:jmax)
   178                                ! $ p_s (t-\Delta t) $ . ɽ̵. Surface pressure
   179      real(DP), intent(in):: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   180                                ! $ T $ .     . Temperature
   181      real(DP), intent(in):: xyz_QVap    (0:imax-1, 1:jmax, 1:kmax)
   182                                ! $ q $ .     漾. Specific humidity
   183      real(DP), intent(out), optional:: xyr_Temp   (0:imax-1, 1:jmax, 0:kmax)
   184                                ! $ \hat{T} $ .  (Ⱦ٥).
   185                                ! Temperature (half level)
   186      real(DP), intent(out), optional:: xyz_VirTemp(0:imax-1, 1:jmax, 1:kmax)
   187                                ! $ \hat{T} $ . 
   188                                ! Virtual temperature
   189      real(DP), intent(out), optional:: xyr_VirTemp(0:imax-1, 1:jmax, 0:kmax)
   190                                ! $ \hat{T} $ .  (Ⱦ٥).
   191                                ! Virtual temperature (half level)
   192      real(DP), intent(out), optional:: xyz_Press  (0:imax-1, 1:jmax, 1:kmax)
   193                                ! $ p $ .  (٥).
   194                                ! Air pressure (full level)
   195      real(DP), intent(out), optional:: xyr_Press  (0:imax-1, 1:jmax, 0:kmax)
   196                                ! $ \hat{p} $ .  (Ⱦ٥).
   197                                ! Air pressure (half level)
   198      real(DP), intent(in ), optional:: xy_SurfHeight(0:imax-1,1:jmax)
   199                                ! $ z_s $ . ɽ̹.
   200                                ! Surface height.
   201      real(DP), intent(out), optional:: xyz_Height (0:imax-1, 1:jmax, 1:kmax)
   202                                !  (٥).
   203                                ! Height (full level)
   204      real(DP), intent(out), optional:: xyr_Height (0:imax-1, 1:jmax, 0:kmax)
   205                                !  (Ⱦ٥).
   206                                ! Height (half level)
   207      real(DP), intent(out), optional:: xyz_Exner (0:imax-1, 1:jmax, 1:kmax)
   208                                ! Exner ؿ (٥).
   209                                ! Exner function (full level)
   210      real(DP), intent(out), optional:: xyr_Exner (0:imax-1, 1:jmax, 0:kmax)
   211                                ! Exner ؿ (Ⱦ٥).
   212                                ! Exner function (half level)
   213  
   214  
   215      ! ѿ
   216      ! Work variables
   217      !
   218      real(DP):: xyz_PressWork  (0:imax-1, 1:jmax, 1:kmax)
   219                                ! $ p $ .  (٥).
   220                                ! Air pressure (full level)
   221      real(DP):: xyr_PressWork  (0:imax-1, 1:jmax, 0:kmax)
   222                                ! $ \hat{p} $ .  (Ⱦ٥).
   223                                ! Air pressure (half level)
   224      real(DP):: xyr_TempWork   (0:imax-1, 1:jmax, 0:kmax)
   225                                ! $ \hat{T} $ .  (Ⱦ٥).
   226                                ! Temperature (half level)
   227      real(DP):: xyz_VirTempWork(0:imax-1, 1:jmax, 1:kmax)
   228                                ! $ T_v $ . .
   229                                ! Virtual temperature
   230      real(DP):: xyr_VirTempWork(0:imax-1, 1:jmax, 0:kmax)
   231                                ! $ \hat{T}_v $ .  (Ⱦ٥).
   232                                ! Virtual temperature (half level)
   233  
   234      integer:: k               ! ľ˲ DO 롼Ѻѿ
   235                                ! Work variables for DO loop in vertical direction
   236  
   237      ! ¹ʸ ; Executable statement
   238      !
   239  
   240      ! ǧ
   241      ! Initialization check
   242      !
   243      if ( .not. auxiliary_inited ) then
   244        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   245      end if
   246  
   247  
   248      ! ׻ַ¬
   249      ! Start measurement of computation time
   250      !
   251      call TimesetClockStart( module_name )
   252  
   253  
   254      ! ٤
   255      ! Interpolate temperature
   256      !
   257      if ( present( xyr_Temp ) ) then
   258        call AuxVarsInternalRoutine(   &
   259          & xy_Ps,      xyz_Temp,      &  ! (in )
   260          & xyr_Temp = xyr_Temp  &  ! (out) optional
   261          & )
   262      end if
   263  
   264      ! ٤η׻
   265      ! Calculate virtual temperature
   266      !
   267      if ( present( xyz_VirTemp ) ) then
   268        xyz_VirTemp = xyz_Temp * ( 1.0_DP + ((( 1.0_DP / EpsV ) - 1.0_DP ) * xyz_QVap) )
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t611 = 1, kmax*jmax*imax                                       
     .           xyz_virtemp(t611-1,1,1) = xyz_temp(t611-1,1,1)*(               
     .       1      1.00000000000000e+000 + (1.00000000000000e+000/epsv -       
     .       2      1.00000000000000e+000)*xyz_qvap(t611-1,1,1))                
     .        end do                                                            
   269      end if
   270  
   271      ! ٤
   272      ! Interpolate virtual temperature
   273      !
   274      if ( present( xyr_VirTemp ) ) then
   275        if ( present( xyz_VirTemp ) ) then
   276          xyz_VirTempWork = xyz_VirTemp
     .        if (1 + xyz_virtempwork.DSC.U2 - min0(1,xyz_virtempwork.DSC.U2)   
     .       1    .gt. 0) then                                                  
     .           J1 = and(1 + xyz_virtempwork.DSC.U2 - min0(1,                  
     .       1      xyz_virtempwork.DSC.U2),3)                                  
     .  !CDIR    NODEP                                                          
     .           do t601 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t603 = 1, xyz_virtempwork.DSC.U1 + 2 - min0(1,           
     .       1         xyz_virtempwork.DSC.U1 + 1)                              
     .                 xyz_virtempwork(t603-1,t601,t599+1) = xyz_virtemp(t603-1,
     .       1            t601,t599+1)                                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t601 = J1 + 1, 1 + xyz_virtempwork.DSC.U2 - min0(1,         
     .       1      xyz_virtempwork.DSC.U2), 4                                  
     .  !CDIR       NODEP                                                       
     .              do t603 = 1, xyz_virtempwork.DSC.U1 + 2 - min0(1,           
     .       1         xyz_virtempwork.DSC.U1 + 1)                              
     .                 xyz_virtempwork(t603-1,t601,t599+1) = xyz_virtemp(t603-1,
     .       1            t601,t599+1)                                          
     .                 xyz_virtempwork(t603-1,t601+1,t599+1) = xyz_virtemp(t603-
     .       1            1,t601+1,t599+1)                                      
     .                 xyz_virtempwork(t603-1,t601+2,t599+1) = xyz_virtemp(t603-
     .       1            1,t601+2,t599+1)                                      
     .                 xyz_virtempwork(t603-1,t601+3,t599+1) = xyz_virtemp(t603-
     .       1            1,t601+3,t599+1)                                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   277        else
   278          xyz_VirTempWork = &
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t586 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t588 = 1, imax                                           
     .                 xyz_virtempwork(t588-1,t586,t584+1) = xyz_temp(t588-1,   
     .       1            t586,t584+1)*(1.00000000000000e+000 + (               
     .       2            1.00000000000000e+000/epsv - 1.00000000000000e+000)*  
     .       3            xyz_qvap(t588-1,t586,t584+1))                         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t586 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t588 = 1, imax                                           
     .                 xyz_virtempwork(t588-1,t586,t584+1) = xyz_temp(t588-1,   
     .       1            t586,t584+1)*(1.00000000000000e+000 + ((              
     .       2            1.00000000000000e+000/epsv) - 1.00000000000000e+000)* 
     .       3            xyz_qvap(t588-1,t586,t584+1))                         
     .                 xyz_virtempwork(t588-1,t586+1,t584+1) = xyz_temp(t588-1, 
     .       1            t586+1,t584+1)*(1.00000000000000e+000 + ((            
     .       2            1.00000000000000e+000/epsv) - 1.00000000000000e+000)* 
     .       3            xyz_qvap(t588-1,t586+1,t584+1))                       
     .                 xyz_virtempwork(t588-1,t586+2,t584+1) = xyz_temp(t588-1, 
     .       1            t586+2,t584+1)*(1.00000000000000e+000 + ((            
     .       2            1.00000000000000e+000/epsv) - 1.00000000000000e+000)* 
     .       3            xyz_qvap(t588-1,t586+2,t584+1))                       
     .                 xyz_virtempwork(t588-1,t586+3,t584+1) = xyz_temp(t588-1, 
     .       1            t586+3,t584+1)*(1.00000000000000e+000 + ((            
     .       2            1.00000000000000e+000/epsv) - 1.00000000000000e+000)* 
     .       3            xyz_qvap(t588-1,t586+3,t584+1))                       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   279            & xyz_Temp * ( 1.0_DP + ((( 1.0_DP / EpsV ) - 1.0_DP ) * xyz_QVap) )
   280        end if
   281        call AuxVarsInternalRoutine(   &
   282          & xy_Ps, xyz_VirTempWork,    &  ! (in )
   283          & xyr_Temp = xyr_VirTemp     &  ! (out) optional
   284          & )
   285      end if
   286  
   287      ! η׻
   288      ! Calculate pressure
   289      !
   290      if ( present( xyz_Press ) ) then
   291        call AuxVarsInternalRoutine(   &
   292          & xy_Ps,      xyz_Temp,      &  ! (in )
   293          & xyz_Press = xyz_Press  &  ! (out) optional
   294          & )
   295      end if
   296  
   297      if ( present( xyr_Press ) ) then
   298        call AuxVarsInternalRoutine(   &
   299          & xy_Ps,      xyz_Temp,      &  ! (in )
   300          & xyr_Press = xyr_Press  &  ! (out) optional
   301          & )
   302      end if
   303  
   304      ! ٤η׻
   305      ! Calculate height
   306      !
   307      if ( present( xyz_Height ) .and. present( xy_SurfHeight ) ) then
   308  
   309  !!$      if ( present( xyr_Temp ) ) then
   310  !!$        xyr_TempWork = xyr_Temp
   311  !!$      else
   312  !!$        call AuxVarsInternalRoutine( &
   313  !!$          & xy_Ps, xyz_Temp,         &  ! (in )
   314  !!$          & xyr_Temp = xyr_TempWork  &  ! (out) optional
   315  !!$          & )
   316  !!$      end if
   317        if ( present( xyz_VirTemp ) .and. present( xyr_VirTemp ) ) then
   318          xyz_VirTempWork = xyz_VirTemp
     .        if (xyz_virtempwork.DSC.U2 .gt. 0) then                           
     .           J3 = and(xyz_virtempwork.DSC.U2,3)                             
     .  !CDIR    NODEP                                                          
     .           do t562 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t564 = 1, xyz_virtempwork.DSC.U1 + 1                     
     .                 xyz_virtempwork(t564-1,t562,t560+1) = xyz_virtemp(t564-1,
     .       1            t562,t560+1)                                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t562 = J3 + 1, xyz_virtempwork.DSC.U2, 4                    
     .  !CDIR       NODEP                                                       
     .              do t564 = 1, xyz_virtempwork.DSC.U1 + 1                     
     .                 xyz_virtempwork(t564-1,t562,t560+1) = xyz_virtemp(t564-1,
     .       1            t562,t560+1)                                          
     .                 xyz_virtempwork(t564-1,t562+1,t560+1) = xyz_virtemp(t564-
     .       1            1,t562+1,t560+1)                                      
     .                 xyz_virtempwork(t564-1,t562+2,t560+1) = xyz_virtemp(t564-
     .       1            1,t562+2,t560+1)                                      
     .                 xyz_virtempwork(t564-1,t562+3,t560+1) = xyz_virtemp(t564-
     .       1            1,t562+3,t560+1)                                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   319          xyr_VirTempWork = xyr_VirTemp
     .        if (1 + xyr_virtempwork.DSC.U2 - min0(1,xyr_virtempwork.DSC.U2)   
     .       1    .gt. 0) then                                                  
     .           J4 = and(1 + xyr_virtempwork.DSC.U2 - min0(1,                  
     .       1      xyr_virtempwork.DSC.U2),3)                                  
     .  !CDIR    NODEP                                                          
     .           do t574 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t576 = 1, xyr_virtempwork.DSC.U1 + 2 - min0(1,           
     .       1         xyr_virtempwork.DSC.U1 + 1)                              
     .                 xyr_virtempwork(t576-1,t574,t572) = xyr_virtemp(t576-1,  
     .       1            t574,t572)                                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t574 = J4 + 1, 1 + xyr_virtempwork.DSC.U2 - min0(1,         
     .       1      xyr_virtempwork.DSC.U2), 4                                  
     .  !CDIR       NODEP                                                       
     .              do t576 = 1, xyr_virtempwork.DSC.U1 + 2 - min0(1,           
     .       1         xyr_virtempwork.DSC.U1 + 1)                              
     .                 xyr_virtempwork(t576-1,t574,t572) = xyr_virtemp(t576-1,  
     .       1            t574,t572)                                            
     .                 xyr_virtempwork(t576-1,t574+1,t572) = xyr_virtemp(t576-1,
     .       1            t574+1,t572)                                          
     .                 xyr_virtempwork(t576-1,t574+2,t572) = xyr_virtemp(t576-1,
     .       1            t574+2,t572)                                          
     .                 xyr_virtempwork(t576-1,t574+3,t572) = xyr_virtemp(t576-1,
     .       1            t574+3,t572)                                          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   320        else
   321          ! ׻ַ¬
   322          ! Pause measurement of computation time
   323          call TimesetClockStop( module_name )
   324          call AuxVars(                      &
   325            & xy_Ps, xyz_Temp, xyz_QVap,     &  ! (in )
   326            & xyz_VirTemp = xyz_VirTempWork, &  ! (out) optional
   327            & xyr_VirTemp = xyr_VirTempWork  &  ! (out) optional
   328            & )
   329          ! ׻ַ¬
   330          ! Start measurement of computation time
   331          call TimesetClockStart( module_name )
   332        end if
   333  
   334  !!$      xyz_Height(:,:,1) = &
   335  !!$        & xy_SurfHeight(:,:) &
   336  !!$        & + GasRDry / Grav * xyz_Temp(:,:,1) * ( 1. - z_Sigma(1) )
   337  !!$      do k = 2, kmax
   338  !!$        xyz_Height(:,:,k) = &
   339  !!$          &   xyz_Height(:,:,k-1) &
   340  !!$          & + GasRDry / Grav * xyr_TempWork(:,:,k-1) &
   341  !!$          &   * r_DelSigma(k-1) / r_Sigma(k-1)
   342  !!$      end do
   343  
   344        xyz_Height(:,:,1) =                          &
     .        if (jmax .gt. 0) then                                             
     .           J5 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t540 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t542 = 1, imax                                           
     .                 xyz_height(t542-1,t540,1) = xy_surfheight(t542-1,t540) + 
     .       1            gasrdry/grav*xyz_virtempwork(t542-1,t540,1)*(         
     .       2            1.00000000000000e+000 - z_sigma(1))                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t540 = J5 + 1, jmax, 4                                      
     .              D1 = z_sigma(1)                                             
     .  !CDIR       NODEP                                                       
     .              do t542 = 1, imax                                           
     .                 xyz_height(t542-1,t540,1) = xy_surfheight(t542-1,t540) + 
     .       1            (gasrdry/grav)*xyz_virtempwork(t542-1,t540,1)*(       
     .       2            1.00000000000000e+000 - D1)                           
     .                 xyz_height(t542-1,t540+1,1) = xy_surfheight(t542-1,t540+1
     .       1            ) + (gasrdry/grav)*xyz_virtempwork(t542-1,t540+1,1)*( 
     .       2            1.00000000000000e+000 - D1)                           
     .                 xyz_height(t542-1,t540+2,1) = xy_surfheight(t542-1,t540+2
     .       1            ) + (gasrdry/grav)*xyz_virtempwork(t542-1,t540+2,1)*( 
     .       2            1.00000000000000e+000 - D1)                           
     .                 xyz_height(t542-1,t540+3,1) = xy_surfheight(t542-1,t540+3
     .       1            ) + (gasrdry/grav)*xyz_virtempwork(t542-1,t540+3,1)*( 
     .       2            1.00000000000000e+000 - D1)                           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   345          & xy_SurfHeight                            &
   346          & + GasRDry / Grav * xyz_VirTempWork(:,:,1) * ( 1.0_DP - z_Sigma(1) )
   347        do k = 2, kmax
   348          xyz_Height(:,:,k) = xyz_Height(:,:,k-1)         &
     .        if (jmax .gt. 0) then                                             
     .           J6 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t550 = 1, J6                                                
     .              D4 = r_delsigma(k-1)/r_sigma(k-1)                           
     .  !CDIR       NODEP                                                       
     .              do t552 = 1, imax                                           
     .                 xyz_height(t552-1,t550,k) = xyz_height(t552-1,t550,k-1)  
     .       1             + gasrdry/grav*xyr_virtempwork(t552-1,t550,k-1)*D4   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t550 = J6 + 1, jmax, 4                                      
     .              D3 = r_sigma(k-1)                                           
     .              D2 = r_delsigma(k-1)                                        
     .  !CDIR       NODEP                                                       
     .              do t552 = 1, imax                                           
     .                 xyz_height(t552-1,t550,k) = xyz_height(t552-1,t550,k-1)  
     .       1             + (gasrdry/grav)*xyr_virtempwork(t552-1,t550,k-1)*D2/
     .       2            D3                                                    
     .                 xyz_height(t552-1,t550+1,k) = xyz_height(t552-1,t550+1,k-
     .       1            1) + (gasrdry/grav)*xyr_virtempwork(t552-1,t550+1,k-1)
     .       2            *D2/D3                                                
     .                 xyz_height(t552-1,t550+2,k) = xyz_height(t552-1,t550+2,k-
     .       1            1) + (gasrdry/grav)*xyr_virtempwork(t552-1,t550+2,k-1)
     .       2            *D2/D3                                                
     .                 xyz_height(t552-1,t550+3,k) = xyz_height(t552-1,t550+3,k-
     .       1            1) + (gasrdry/grav)*xyr_virtempwork(t552-1,t550+3,k-1)
     .       2            *D2/D3                                                
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   349            & + GasRDry / Grav * xyr_VirTempWork(:,:,k-1) &
   350            &   * r_DelSigma(k-1) / r_Sigma(k-1)
   351        end do
   352      end if
   353  
   354      if ( present( xyr_Height ) .and. present( xy_SurfHeight ) ) then
   355  
   356        if ( present( xyz_VirTemp ) ) then
   357          xyz_VirTempWork = xyz_VirTemp
     .        if (1 + xyz_virtempwork.DSC.U2 - min0(1,xyz_virtempwork.DSC.U2)   
     .       1    .gt. 0) then                                                  
     .           J7 = and(1 + xyz_virtempwork.DSC.U2 - min0(1,                  
     .       1      xyz_virtempwork.DSC.U2),3)                                  
     .  !CDIR    NODEP                                                          
     .           do t530 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t532 = 1, xyz_virtempwork.DSC.U1 + 2 - min0(1,           
     .       1         xyz_virtempwork.DSC.U1 + 1)                              
     .                 xyz_virtempwork(t532-1,t530,t528+1) = xyz_virtemp(t532-1,
     .       1            t530,t528+1)                                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t530 = J7 + 1, 1 + xyz_virtempwork.DSC.U2 - min0(1,         
     .       1      xyz_virtempwork.DSC.U2), 4                                  
     .  !CDIR       NODEP                                                       
     .              do t532 = 1, xyz_virtempwork.DSC.U1 + 2 - min0(1,           
     .       1         xyz_virtempwork.DSC.U1 + 1)                              
     .                 xyz_virtempwork(t532-1,t530,t528+1) = xyz_virtemp(t532-1,
     .       1            t530,t528+1)                                          
     .                 xyz_virtempwork(t532-1,t530+1,t528+1) = xyz_virtemp(t532-
     .       1            1,t530+1,t528+1)                                      
     .                 xyz_virtempwork(t532-1,t530+2,t528+1) = xyz_virtemp(t532-
     .       1            1,t530+2,t528+1)                                      
     .                 xyz_virtempwork(t532-1,t530+3,t528+1) = xyz_virtemp(t532-
     .       1            1,t530+3,t528+1)                                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   358        else
   359          ! ׻ַ¬
   360          ! Pause measurement of computation time
   361          call TimesetClockStop( module_name )
   362          call AuxVars(                      &
   363            & xy_Ps, xyz_Temp, xyz_QVap,     &  ! (in )
   364            & xyz_VirTemp = xyz_VirTempWork  &  ! (out) optional
   365            & )
   366          ! ׻ַ¬
   367          ! Start measurement of computation time
   368          call TimesetClockStart( module_name )
   369        end if
   370  
   371        xyr_Height(:,:,0) = xy_SurfHeight
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t510 = 1, jmax*imax                                            
     .           xyr_height(t510-1,1,0) = xy_surfheight(t510-1,1)               
     .        end do                                                            
   372        do k = 1, kmax
   373  !!$        xyr_Height(:,:,k) = xyr_Height(:,:,k-1)        &
   374  !!$          & + GasRDry / Grav * xyz_Temp(:,:,k)     &
   375  !!$          &   * z_DelSigma(k) / z_Sigma(k)
   376          xyr_Height(:,:,k) = xyr_Height(:,:,k-1)        &
     .        if (jmax .gt. 0) then                                             
     .           J8 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t518 = 1, J8                                                
     .              D7 = z_delsigma(k)/z_sigma(k)                               
     .  !CDIR       NODEP                                                       
     .              do t520 = 1, imax                                           
     .                 xyr_height(t520-1,t518,k) = xyr_height(t520-1,t518,k-1)  
     .       1             + gasrdry/grav*xyz_virtempwork(t520-1,t518,k)*D7     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t518 = J8 + 1, jmax, 4                                      
     .              D6 = z_sigma(k)                                             
     .              D5 = z_delsigma(k)                                          
     .  !CDIR       NODEP                                                       
     .              do t520 = 1, imax                                           
     .                 xyr_height(t520-1,t518,k) = xyr_height(t520-1,t518,k-1)  
     .       1             + (gasrdry/grav)*xyz_virtempwork(t520-1,t518,k)*D5/D6
     .                 xyr_height(t520-1,t518+1,k) = xyr_height(t520-1,t518+1,k-
     .       1            1) + (gasrdry/grav)*xyz_virtempwork(t520-1,t518+1,k)* 
     .       2            D5/D6                                                 
     .                 xyr_height(t520-1,t518+2,k) = xyr_height(t520-1,t518+2,k-
     .       1            1) + (gasrdry/grav)*xyz_virtempwork(t520-1,t518+2,k)* 
     .       2            D5/D6                                                 
     .                 xyr_height(t520-1,t518+3,k) = xyr_height(t520-1,t518+3,k-
     .       1            1) + (gasrdry/grav)*xyz_virtempwork(t520-1,t518+3,k)* 
     .       2            D5/D6                                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   377            & + GasRDry / Grav * xyz_VirTempWork(:,:,k)  &
   378            &   * z_DelSigma(k) / z_Sigma(k)
   379        end do
   380      end if
   381  
   382      ! ʡؿη׻
   383      ! Calculate exner function
   384      !
   385      if ( present( xyz_Exner ) ) then
   386        if ( present( xyz_Press ) ) then
   387          xyz_PressWork = xyz_Press
     .        if(1+xyz_presswork.DSC.U2-min0(1,xyz_presswork.DSC.U2).gt.0)then  
     .           J9=and(1+xyz_presswork.DSC.U2-min0(1,xyz_presswork.DSC.U2),3)  
     .  !CDIR    NODEP                                                          
     .           do t500 = 1, J9                                                
     .  !CDIR       NODEP                                                       
     .              do t502 = 1, xyz_presswork.DSC.U1 + 2 - min0(1,             
     .       1         xyz_presswork.DSC.U1 + 1)                                
     .                 xyz_presswork(t502-1,t500,t498+1) = xyz_press(t502-1,t500
     .       1            ,t498+1)                                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t500 = J9 + 1, 1 + xyz_presswork.DSC.U2 - min0(1,           
     .       1      xyz_presswork.DSC.U2), 4                                    
     .  !CDIR       NODEP                                                       
     .              do t502 = 1, xyz_presswork.DSC.U1 + 2 - min0(1,             
     .       1         xyz_presswork.DSC.U1 + 1)                                
     .                 xyz_presswork(t502-1,t500,t498+1) = xyz_press(t502-1,t500
     .       1            ,t498+1)                                              
     .                 xyz_presswork(t502-1,t500+1,t498+1) = xyz_press(t502-1,  
     .       1            t500+1,t498+1)                                        
     .                 xyz_presswork(t502-1,t500+2,t498+1) = xyz_press(t502-1,  
     .       1            t500+2,t498+1)                                        
     .                 xyz_presswork(t502-1,t500+3,t498+1) = xyz_press(t502-1,  
     .       1            t500+3,t498+1)                                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   388        else
   389          call AuxVarsInternalRoutine(   &
   390            & xy_Ps,      xyz_Temp,      &  ! (in )
   391            & xyz_Press = xyz_PressWork  &  ! (out) optional
   392            & )
   393        end if
   394  
   395        xyz_Exner = ( xyz_PressWork / RefPress ) ** ( GasRDry / CpDry )
     .        if (xyz_presswork.DSC.U2 .gt. 0) then                             
     .           J10 = and(xyz_presswork.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t488 = 1, J10                                               
     .              D8 = 1.D0/refpress                                          
     .  !CDIR       NODEP                                                       
     .              do t490 = 1, xyz_presswork.DSC.U1 + 1                       
     .                 xyz_exner(t490-1,t488,t486+1) = (xyz_presswork(t490-1,   
     .       1            t488,t486+1)*D8)**(gasrdry/cpdry)                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t488 = J10 + 1, xyz_presswork.DSC.U2, 4                     
     .              D9 = 1.D0/refpress                                          
     .              D10 = 1.D0/refpress                                         
     .              D11 = 1.D0/refpress                                         
     .              D12 = 1.D0/refpress                                         
     .  !CDIR       NODEP                                                       
     .              do t490 = 1, xyz_presswork.DSC.U1 + 1                       
     .                 xyz_exner(t490-1,t488,t486+1) = (xyz_presswork(t490-1,   
     .       1            t488,t486+1)*D9)**(gasrdry/cpdry)                     
     .                 xyz_exner(t490-1,t488+1,t486+1) = (xyz_presswork(t490-1, 
     .       1            t488+1,t486+1)*D10)**(gasrdry/cpdry)                  
     .                 xyz_exner(t490-1,t488+2,t486+1) = (xyz_presswork(t490-1, 
     .       1            t488+2,t486+1)*D11)**(gasrdry/cpdry)                  
     .                 xyz_exner(t490-1,t488+3,t486+1) = (xyz_presswork(t490-1, 
     .       1            t488+3,t486+1)*D12)**(gasrdry/cpdry)                  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   396      end if
   397  
   398  
   399      if ( present( xyr_Exner ) ) then
   400        if ( present( xyr_Press ) ) then
   401          xyr_PressWork = xyr_Press
     .        if(1+xyr_presswork.DSC.U2-min0(1,xyr_presswork.DSC.U2).gt.0)then  
     .           J11 = and(1 + xyr_presswork.DSC.U2 - min0(1,                   
     .       1      xyr_presswork.DSC.U2),3)                                    
     .  !CDIR    NODEP                                                          
     .           do t476 = 1, J11                                               
     .  !CDIR       NODEP                                                       
     .              do t478 = 1, xyr_presswork.DSC.U1 + 2 - min0(1,             
     .       1         xyr_presswork.DSC.U1 + 1)                                
     .                 xyr_presswork(t478-1,t476,t474) = xyr_press(t478-1,t476, 
     .       1            t474)                                                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t476 = J11 + 1, 1 + xyr_presswork.DSC.U2 - min0(1,          
     .       1      xyr_presswork.DSC.U2), 4                                    
     .  !CDIR       NODEP                                                       
     .              do t478 = 1, xyr_presswork.DSC.U1 + 2 - min0(1,             
     .       1         xyr_presswork.DSC.U1 + 1)                                
     .                 xyr_presswork(t478-1,t476,t474) = xyr_press(t478-1,t476, 
     .       1            t474)                                                 
     .                 xyr_presswork(t478-1,t476+1,t474) = xyr_press(t478-1,t476
     .       1            +1,t474)                                              
     .                 xyr_presswork(t478-1,t476+2,t474) = xyr_press(t478-1,t476
     .       1            +2,t474)                                              
     .                 xyr_presswork(t478-1,t476+3,t474) = xyr_press(t478-1,t476
     .       1            +3,t474)                                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   402        else
   403          call AuxVarsInternalRoutine(   &
   404            & xy_Ps,      xyz_Temp,      &  ! (in )
   405            & xyr_Press = xyr_PressWork  &  ! (out) optional
   406            & )
   407        end if
   408  
   409        xyr_Exner = ( xyr_PressWork / RefPress ) ** ( GasRDry / CpDry )
     .        if (xyr_presswork.DSC.U2 .gt. 0) then                             
     .           J12 = and(xyr_presswork.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t464 = 1, J12                                               
     .              D13 = 1.D0/refpress                                         
     .  !CDIR       NODEP                                                       
     .              do t466 = 1, xyr_presswork.DSC.U1 + 1                       
     .                 xyr_exner(t466-1,t464,t462) = (xyr_presswork(t466-1,t464,
     .       1            t462)*D13)**(gasrdry/cpdry)                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t464 = J12 + 1, xyr_presswork.DSC.U2, 4                     
     .              D14 = 1.D0/refpress                                         
     .              D15 = 1.D0/refpress                                         
     .              D16 = 1.D0/refpress                                         
     .              D17 = 1.D0/refpress                                         
     .  !CDIR       NODEP                                                       
     .              do t466 = 1, xyr_presswork.DSC.U1 + 1                       
     .                 xyr_exner(t466-1,t464,t462) = (xyr_presswork(t466-1,t464,
     .       1            t462)*D14)**(gasrdry/cpdry)                           
     .                 xyr_exner(t466-1,t464+1,t462) = (xyr_presswork(t466-1,   
     .       1            t464+1,t462)*D15)**(gasrdry/cpdry)                    
     .                 xyr_exner(t466-1,t464+2,t462) = (xyr_presswork(t466-1,   
     .       1            t464+2,t462)*D16)**(gasrdry/cpdry)                    
     .                 xyr_exner(t466-1,t464+3,t462) = (xyr_presswork(t466-1,   
     .       1            t464+3,t462)*D17)**(gasrdry/cpdry)                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   410      end if
   411  
   412      ! ׻ַ¬
   413      ! Pause measurement of computation time
   414      !
   415      call TimesetClockStop( module_name )
   416  
   417    end subroutine AuxVars
   418  
   419    !--------------------------------------------------------------------------------------
   420  
   421    subroutine AuxVarsInternalRoutine( &
   422      & xy_Ps,      xyz_Temp,   &  ! (in )
   423      & xyr_Temp,               &  ! (out) optional
   424      & xyz_Press,  xyr_Press   &  ! (out) optional
   425      & )
   426      !
   427      ! ٤Ⱦҥ٥, λ,
   428      ! ʡؿη׻Ԥޤ.
   429      !
   430      ! Interpolate temperature on half sigma level,
   431      ! and calculate pressure,
   432      ! and calculate exner function.
   433  
   434      ! ⥸塼 ; USE statements
   435      !
   436  
   437      ! ɸǡ
   438      ! Axes data settings
   439      !
   440      use axesset, only: &
   441        & z_Sigma, &
   442                                ! $ \sigma $ ٥ ().
   443                                ! Full $ \sigma $ level
   444        & r_Sigma
   445                                ! $ \sigma $ ٥ (Ⱦ).
   446                                ! Half $ \sigma $ level
   447  
   448      ! ʸ ; Declaration statements
   449      !
   450      implicit none
   451  
   452      real(DP), intent(in):: xy_Ps       (0:imax-1, 1:jmax)
   453                                ! $ p_s (t-\Delta t) $ . ɽ̵. Surface pressure
   454      real(DP), intent(in):: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   455                                ! $ T $ .     . Temperature
   456      real(DP), intent(out), optional:: xyr_Temp   (0:imax-1, 1:jmax, 0:kmax)
   457                                ! $ \hat{T} $ .  (Ⱦ٥).
   458                                ! Temperature (half level)
   459      real(DP), intent(out), optional:: xyz_Press  (0:imax-1, 1:jmax, 1:kmax)
   460                                ! $ p $ .  (٥).
   461                                ! Air pressure (full level)
   462      real(DP), intent(out), optional:: xyr_Press  (0:imax-1, 1:jmax, 0:kmax)
   463                                ! $ \hat{p} $ .  (Ⱦ٥).
   464                                ! Air pressure (half level)
   465  
   466  
   467      ! ѿ
   468      ! Work variables
   469      !
   470      integer:: k               ! ľ˲ DO 롼Ѻѿ
   471                                ! Work variables for DO loop in vertical direction
   472  
   473      ! ¹ʸ ; Executable statement
   474      !
   475  
   476  
   477      ! ǧ
   478      ! Initialization check
   479      !
   480      if ( .not. auxiliary_inited ) then
   481        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   482      end if
   483  
   484  
   485      ! ٤
   486      ! Interpolate temperature
   487      !
   488      if ( present( xyr_Temp ) ) then
   489        do k = 2, kmax
   490          xyr_Temp(:,:,k-1) =   z_TempInpolM(k) * xyz_Temp(:,:,k-1)  &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t185 = 1, jmax*imax                                            
     .           xyr_temp(t185-1,1,k-1) = z_tempinpolm(k)*xyz_temp(t185-1,1,k-1)
     .       1       + z_tempinpol(k)*xyz_temp(t185-1,1,k)                      
     .        end do                                                            
   491            &                 + z_TempInpol (k) * xyz_Temp(:,:,k)
   492        end do
   493  
   494        xyr_Temp(:,:,kmax) = xyz_Temp(:,:,kmax)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t195 = 1, jmax*imax                                            
     .           xyr_temp(t195-1,1,kmax) = xyz_temp(t195-1,1,kmax)              
     .           xyr_temp(t195-1,1,0) = xyz_temp(t195-1,1,1)                    
     .        end do                                                            
   495        xyr_Temp(:,:,0)    = xyz_Temp(:,:,1)
   496  
   497      end if
   498  
   499      ! η׻
   500      ! Calculate pressure
   501      !
   502      if ( present( xyz_Press ) ) then
   503        do k = 1, kmax
   504          xyz_Press(:,:,k) = xy_Ps * z_Sigma(k)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t177 = 1, jmax*imax                                            
     .           xyz_press(t177-1,1,k) = xy_ps(t177-1,1)*z_sigma(k)             
     .        end do                                                            
   505        end do
   506      end if
   507  
   508      if ( present( xyr_Press ) ) then
   509        do k = 0, kmax
   510          xyr_Press(:,:,k) = xy_Ps * r_Sigma(k)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t169 = 1, jmax*imax                                            
     .           xyr_press(t169-1,1,k) = xy_ps(t169-1,1)*r_sigma(k)             
     .        end do                                                            
   511        end do
   512      end if
   513  
   514  
   515    end subroutine AuxVarsInternalRoutine
   516  
   517    !--------------------------------------------------------------------------------------
   518  
   519    subroutine AuxVarsInit
   520      !
   521      ! auxiliary ⥸塼νԤޤ.
   522      ! NAMELIST#auxiliary_nml ɤ߹ߤϤμ³ǹԤޤ.
   523      !
   524      ! "auxiliary" module is initialized.
   525      ! "NAMELIST#auxiliary_nml" is loaded in this procedure.
   526      !
   527  
   528      ! ⥸塼 ; USE statements
   529      !
   530  
   531      ! ɸǡ
   532      ! Axes data settings
   533      !
   534      use axesset, only: &
   535        & z_Sigma, &
   536                                ! $ \sigma $ ٥ ().
   537                                ! Full $ \sigma $ level
   538        & r_Sigma
   539                                ! $ \sigma $ ٥ (Ⱦ).
   540                                ! Half $ \sigma $ level
   541  
   542      ! NAMELIST եϤ˴ؤ桼ƥƥ
   543      ! Utilities for NAMELIST file input
   544      !
   545      use namelist_util, only: namelist_filename, NmlutilMsg
   546  
   547      ! ե
   548      ! File I/O support
   549      !
   550      use dc_iounit, only: FileOpen
   551  
   552      ! ̷ѥ᥿
   553      ! Kind type parameter
   554      !
   555      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   556  
   557      ! ʸ
   558      ! Character handling
   559      !
   560      use dc_string, only: StoA
   561  
   562      ! ʸ ; Declaration statements
   563      !
   564      implicit none
   565  
   566      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   567                                ! Unit number for NAMELIST file open
   568      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   569                                ! IOSTAT of NAMELIST read
   570  
   571      integer:: k               ! ľ˲ DO 롼Ѻѿ
   572                                ! Work variables for DO loop in vertical direction
   573  
   574      ! NAMELIST ѿ
   575      ! NAMELIST group name
   576      !
   577      namelist /auxiliary_nml/ &
   578        & RefPress
   579            !
   580            ! ǥեͤˤĤƤϽ³ "auxiliary#AuxVarsInit"
   581            ! Υɤ򻲾ȤΤ.
   582            !
   583            ! Refer to source codes in the initialization procedure
   584            ! "auxiliary#AuxVarsInit" for the default values.
   585            !
   586  
   587      ! ¹ʸ ; Executable statement
   588      !
   589  
   590      if ( auxiliary_inited ) return
   591  
   592  
   593      ! ǥեͤ
   594      ! Default values settings
   595      !
   596      RefPress        =   1.0d5
   597  
   598      ! NAMELIST ɤ߹
   599      ! NAMELIST is input
   600      !
   601      if ( trim(namelist_filename) /= '' ) then
   602        call FileOpen( unit_nml, &          ! (out)
   603          & namelist_filename, mode = 'r' ) ! (in)
   604  
   605        rewind( unit_nml )
   606        read( unit_nml, &           ! (in)
   607          & nml = auxiliary_nml, &  ! (out)
   608          & iostat = iostat_nml )   ! (out)
   609        close( unit_nml )
   610  
   611        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   612      end if
   613  
   614      !  Ѥηη׻
   615      !  Calculate coefficient for interpolation
   616      !
   617      allocate( z_TempInpolM(1:kmax) )
   618      allocate( z_TempInpol(1:kmax) )
   619  
   620      z_TempInpolM(1) = 0.
   621      z_TempInpol (1) = 0.
   622  
   623      do k = 2, kmax
   624        z_TempInpolM(k) = &
   625          &    ( log( r_Sigma( k-1 ) ) - log( z_Sigma( k ) ) ) &
   626          &  / ( log( z_Sigma( k-1 ) ) - log( z_Sigma( k ) ) )
   627        z_TempInpol(k) = &
   628          &    ( log( z_Sigma( k-1 ) ) - log( r_Sigma( k-1 ) ) ) &
   629          &  / ( log( z_Sigma( k-1 ) ) - log( z_Sigma( k )   ) )
   630      end  do
     .  !CDIR NODEP                                                             
     .        do k = 1, kmax - 1                                                
     .           z_tempinpolm(1+k) = ((dlog(r_sigma(k)))-(dlog(z_sigma(1+k))))/(
     .       1      (dlog(z_sigma(k)))-(dlog(z_sigma(1+k))))                    
     .           z_tempinpol(1+k) = ((dlog(z_sigma(k)))-(dlog(r_sigma(k))))/((  
     .       1      dlog(z_sigma(k)))-(dlog(z_sigma(1+k))))                     
     .        end do                                                            
   631  
   632      !  ; Print
   633      !
   634      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   635      call MessageNotify( 'M', module_name, '  z_TempInpolM = %*r', r = real( z_TempInpolM ), n = (/ kmax /) )
   636      call MessageNotify( 'M', module_name, '  z_TempInpol  = %*r', r = real( z_TempInpol  ), n = (/ kmax /) )
   637      call MessageNotify( 'M', module_name, '  RefPress     = %f', d = (/ RefPress /) )
   638      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   639  
   640      auxiliary_inited = .true.
   641  
   642    end subroutine AuxVarsInit
   643  
   644    !--------------------------------------------------------------------------------------
   645  
   646    subroutine AuxVarsFinalize
   647      !
   648      ! ⥸塼ѿγդԤޤ.
   649      !
   650      ! Deallocate variables in this module.
   651      !
   652  
   653      ! ʸ ; Declaration statements
   654      !
   655      implicit none
   656  
   657      ! ¹ʸ ; Executable statement
   658      !
   659  
   660      if ( .not. auxiliary_inited ) return
   661  
   662      ! դ
   663      ! Deallocation
   664      !
   665      if ( allocated( z_TempInpolM ) ) deallocate( z_TempInpolM )
   666      if ( allocated( z_TempInpol  ) ) deallocate( z_TempInpol  )
   667  
   668      auxiliary_inited = .false.
   669  
   670    end subroutine AuxVarsFinalize
   671  
   672    !--------------------------------------------------------------------------------------
   673  
   674  end module auxiliary
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:17 2012
FILE NAME: auxiliary.f90
PROGRAM NAME: auxiliary
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Ūѿ׻륵֥롼󡦴ؿ
     2:            !
     3:            != Subroutines and functions for calculating auxiliary variables
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6:            ! Version::   $Id: auxiliary.f90,v 1.14 2012-02-20 08:09:17 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module auxiliary
    13:              !
    14:              != Ūѿ׻륵֥롼󡦴ؿ
    15:              !
    16:              != Subroutines and functions for calculating auxiliary variables
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! Υ⥸塼Ǥ, Ūѿ׻륵֥롼ؿ󶡤ޤ. 
    21:              !
    22:              ! This module provides subroutines and functions for calculating auxiliary variables. 
    23:              !
    24:              !== Procedures List
    25:              !
    26:              ! AuxVars          :: ٤Ⱦ $ \sigma $ ٥֤
    27:              !                     ȹ٤λ
    28:              ! AuxVarsInit      ::
    29:              ! AuxVarsFinalize  :: λ (⥸塼ѿγդ)
    30:              ! ---------------  :: ---------------
    31:              ! AuxVars          :: Interpolate temperature on half $ \sigma $ level, 
    32:              !                     and calculate pressure and height
    33:              ! AuxVarsInit      ::
    34:              ! AuxVarsFinalize  :: Termination (deallocate variables in this module)
    35:              !
    36:              !--
    37:              !== NAMELIST
    38:              !
    39:              ! NAMELIST#auxiliary_nml
    40:              !++
    41:            
    42:              ! ⥸塼 ; USE statements
    43:              !
    44:            
    45:              ! ʻ
    46:              ! Grid points settings
    47:              !
    48:              use gridset, only: imax, & ! ٳʻ. 
    49:                                         ! Number of grid points in longitude
    50:                &                jmax, & ! ٳʻ. 
    51:                                         ! Number of grid points in latitude
    52:                &                kmax    ! ľؿ. 
    53:                                         ! Number of vertical level
    54:            
    55:              ! ̷ѥ᥿
    56:              ! Kind type parameter
    57:              !
    58:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    59:                &                 STRING     ! ʸ.       Strings. 
    60:            
    61:              ! å
    62:              ! Message output
    63:              !
    64:              use dc_message, only: MessageNotify
    65:            
    66:              ! ʸ ; Declaration statements
    67:              !
    68:              implicit none
    69:              private
    70:            
    71:              ! ³
    72:              ! Public procedure
    73:              !
    74:              public :: AuxVars
    75:              public :: AuxVarsFinalize
    76:              public :: AuxVarsInit
    77:            
    78:              ! ѿ
    79:              ! Public variables
    80:              !
    81:            
    82:              ! ѿ
    83:              ! Private variables
    84:              !
    85:              logical, save :: auxiliary_inited = .false.
    86:                                          ! ե饰. 
    87:                                          ! Initialization flag
    88:            
    89:              real(DP), save, allocatable:: z_TempInpolM (:)
    90:                                          ! ٤Ѥη. 
    91:                                          ! Coefficient for interpolation of temperature
    92:              real(DP), save, allocatable:: z_TempInpol (:)
    93:                                          ! ٤Ѥη. 
    94:                                          ! Coefficient for interpolation of temperature
    95:              real(DP), save:: RefPress
    96:                                          ! ൤. 
    97:                                          ! Reference air pressure
    98:            
    99:              character(*), parameter:: module_name = 'auxiliary'
   100:                                          ! ⥸塼̾. 
   101:                                          ! Module name
   102:              character(*), parameter:: version = &
   103:                & '$Name: dcpam5-20120921 $' // &
   104:                & '$Id: auxiliary.f90,v 1.14 2012-02-20 08:09:17 yot Exp $'
   105:                                          ! ⥸塼ΥС
   106:                                          ! Module version
   107:            
   108:            contains
   109:            
   110:              !--------------------------------------------------------------------------------------
   111:            
   112:              recursive subroutine AuxVars(            &
   113:                & xy_Ps, xyz_Temp, xyz_QVap,           &  ! (in )
   114:                & xyr_Temp, xyz_VirTemp, xyr_VirTemp,  &  ! (out) optional
   115:                & xyz_Press,  xyr_Press,               &  ! (out) optional
   116:                & xy_SurfHeight,                       &  ! (in ) optional
   117:                & xyz_Height, xyr_Height,              &  ! (out) optional
   118:                & xyz_Exner,  xyr_Exner                &  ! (out) optional
   119:                & )
   120:                !
   121:                ! ٤Ⱦҥ٥, ȹ٤λ, 
   122:                ! ʡؿη׻Ԥޤ. 
   123:                !
   124:                ! Interpolate temperature on half sigma level, 
   125:                ! and calculate pressure and height, 
   126:                ! and calculate exner function. 
   127:            
   128:                ! ⥸塼 ; USE statements
   129:                !
   130:            
   131:                ! ɸǡ
   132:                ! Axes data settings
   133:                !
   134:                use axesset, only: &
   135:                  & z_Sigma, &
   136:                                          ! $ \sigma $ ٥ (). 
   137:                                          ! Full $ \sigma $ level
   138:                  & r_Sigma, &
   139:                                          ! $ \sigma $ ٥ (Ⱦ). 
   140:                                          ! Half $ \sigma $ level
   141:                  & z_DelSigma, &
   142:                                          ! $ \Delta \sigma $ (). 
   143:                                          ! $ \Delta \sigma $ (Full)
   144:                  & r_DelSigma
   145:                                          ! $ \Delta \sigma $ (Ⱦ). 
   146:                                          ! $ \Delta \sigma $ (Half)
   147:            
   148:                ! ʪ
   149:                ! Physical constants settings
   150:                !
   151:                use constants, only: &
   152:                  & Grav, &               ! $ g $ [m s-2]. 
   153:                                          ! ϲ®. 
   154:                                          ! Gravitational acceleration
   155:                  & GasRDry, &
   156:                                          ! $ R $ [J kg-1 K-1]. 
   157:                                          ! 絤ε. 
   158:                                          ! Gas constant of air
   159:                  & CpDry, &
   160:                                          ! $ C_p $ [J kg-1 K-1]. 
   161:                                          ! 絤갵Ǯ. 
   162:                                          ! Specific heat of air at constant pressure
   163:                  & EpsV
   164:                                          ! $ \epsilon_v $ .
   165:                                          ! ʬ.
   166:                                          ! Molecular weight of water vapor
   167:            
   168:                ! 
   169:                ! Time control
   170:                !
   171:                use timeset, only: TimesetClockStart, TimesetClockStop
   172:            
   173:                ! ʸ ; Declaration statements
   174:                !
   175:                implicit none
   176:            
   177:                real(DP), intent(in):: xy_Ps       (0:imax-1, 1:jmax)
   178:                                          ! $ p_s (t-\Delta t) $ . ɽ̵. Surface pressure
   179:                real(DP), intent(in):: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   180:                                          ! $ T $ .     . Temperature
   181:                real(DP), intent(in):: xyz_QVap    (0:imax-1, 1:jmax, 1:kmax)
   182:                                          ! $ q $ .     漾. Specific humidity
   183:                real(DP), intent(out), optional:: xyr_Temp   (0:imax-1, 1:jmax, 0:kmax)
   184:                                          ! $ \hat{T} $ .  (Ⱦ٥). 
   185:                                          ! Temperature (half level)
   186:                real(DP), intent(out), optional:: xyz_VirTemp(0:imax-1, 1:jmax, 1:kmax)
   187:                                          ! $ \hat{T} $ . 
   188:                                          ! Virtual temperature
   189:                real(DP), intent(out), optional:: xyr_VirTemp(0:imax-1, 1:jmax, 0:kmax)
   190:                                          ! $ \hat{T} $ .  (Ⱦ٥). 
   191:                                          ! Virtual temperature (half level)
   192:                real(DP), intent(out), optional:: xyz_Press  (0:imax-1, 1:jmax, 1:kmax)
   193:                                          ! $ p $ .  (٥). 
   194:                                          ! Air pressure (full level)
   195:                real(DP), intent(out), optional:: xyr_Press  (0:imax-1, 1:jmax, 0:kmax)
   196:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   197:                                          ! Air pressure (half level)
   198:                real(DP), intent(in ), optional:: xy_SurfHeight(0:imax-1,1:jmax)
   199:                                          ! $ z_s $ . ɽ̹. 
   200:                                          ! Surface height. 
   201:                real(DP), intent(out), optional:: xyz_Height (0:imax-1, 1:jmax, 1:kmax)
   202:                                          !  (٥). 
   203:                                          ! Height (full level)
   204:                real(DP), intent(out), optional:: xyr_Height (0:imax-1, 1:jmax, 0:kmax)
   205:                                          !  (Ⱦ٥). 
   206:                                          ! Height (half level)
   207:                real(DP), intent(out), optional:: xyz_Exner (0:imax-1, 1:jmax, 1:kmax)
   208:                                          ! Exner ؿ (٥). 
   209:                                          ! Exner function (full level)
   210:                real(DP), intent(out), optional:: xyr_Exner (0:imax-1, 1:jmax, 0:kmax)
   211:                                          ! Exner ؿ (Ⱦ٥). 
   212:                                          ! Exner function (half level)
   213:            
   214:            
   215:                ! ѿ
   216:                ! Work variables
   217:                !
   218:                real(DP):: xyz_PressWork  (0:imax-1, 1:jmax, 1:kmax)
   219:                                          ! $ p $ .  (٥). 
   220:                                          ! Air pressure (full level)
   221:                real(DP):: xyr_PressWork  (0:imax-1, 1:jmax, 0:kmax)
   222:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   223:                                          ! Air pressure (half level)
   224:                real(DP):: xyr_TempWork   (0:imax-1, 1:jmax, 0:kmax)
   225:                                          ! $ \hat{T} $ .  (Ⱦ٥). 
   226:                                          ! Temperature (half level)
   227:                real(DP):: xyz_VirTempWork(0:imax-1, 1:jmax, 1:kmax)
   228:                                          ! $ T_v $ . .
   229:                                          ! Virtual temperature
   230:                real(DP):: xyr_VirTempWork(0:imax-1, 1:jmax, 0:kmax)
   231:                                          ! $ \hat{T}_v $ .  (Ⱦ٥). 
   232:                                          ! Virtual temperature (half level)
   233:            
   234:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   235:                                          ! Work variables for DO loop in vertical direction
   236:            
   237:                ! ¹ʸ ; Executable statement
   238:                !
   239:            
   240:                ! ǧ
   241:                ! Initialization check
   242:                !
   243:                if ( .not. auxiliary_inited ) then
   244:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   245:                end if
   246:            
   247:            
   248:                ! ׻ַ¬
   249:                ! Start measurement of computation time
   250:                !
   251:                call TimesetClockStart( module_name )
   252:            
   253:            
   254:                ! ٤
   255:                ! Interpolate temperature
   256:                !
   257:                if ( present( xyr_Temp ) ) then
   258:                  call AuxVarsInternalRoutine(   &
   259:                    & xy_Ps,      xyz_Temp,      &  ! (in )
   260:                    & xyr_Temp = xyr_Temp  &  ! (out) optional
   261:                    & )
   262:                end if
   263:            
   264:                ! ٤η׻
   265:                ! Calculate virtual temperature
   266:                !
   267:                if ( present( xyz_VirTemp ) ) then
   268: W++====          xyz_VirTemp = xyz_Temp * ( 1.0_DP + ((( 1.0_DP / EpsV ) - 1.0_DP ) * xyz_QVap) )
   269:                end if
   270:            
   271:                ! ٤
   272:                ! Interpolate virtual temperature
   273:                !
   274:                if ( present( xyr_VirTemp ) ) then
   275:                  if ( present( xyz_VirTemp ) ) then
   276: ++V====            xyz_VirTempWork = xyz_VirTemp
   277:                  else
   278: ++V====            xyz_VirTempWork = &
   279:                      & xyz_Temp * ( 1.0_DP + ((( 1.0_DP / EpsV ) - 1.0_DP ) * xyz_QVap) )
   280:                  end if
   281:                  call AuxVarsInternalRoutine(   &
   282:                    & xy_Ps, xyz_VirTempWork,    &  ! (in )
   283:                    & xyr_Temp = xyr_VirTemp     &  ! (out) optional
   284:                    & )
   285:                end if
   286:            
   287:                ! η׻
   288:                ! Calculate pressure
   289:                !
   290:                if ( present( xyz_Press ) ) then
   291:                  call AuxVarsInternalRoutine(   &
   292:                    & xy_Ps,      xyz_Temp,      &  ! (in )
   293:                    & xyz_Press = xyz_Press  &  ! (out) optional
   294:                    & )
   295:                end if
   296:            
   297:                if ( present( xyr_Press ) ) then
   298:                  call AuxVarsInternalRoutine(   &
   299:                    & xy_Ps,      xyz_Temp,      &  ! (in )
   300:                    & xyr_Press = xyr_Press  &  ! (out) optional
   301:                    & )
   302:                end if
   303:            
   304:                ! ٤η׻
   305:                ! Calculate height
   306:                !
   307:                if ( present( xyz_Height ) .and. present( xy_SurfHeight ) ) then
   308:            
   309:            !!$      if ( present( xyr_Temp ) ) then
   310:            !!$        xyr_TempWork = xyr_Temp
   311:            !!$      else
   312:            !!$        call AuxVarsInternalRoutine( &
   313:            !!$          & xy_Ps, xyz_Temp,         &  ! (in )
   314:            !!$          & xyr_Temp = xyr_TempWork  &  ! (out) optional
   315:            !!$          & )
   316:            !!$      end if
   317:                  if ( present( xyz_VirTemp ) .and. present( xyr_VirTemp ) ) then
   318: ++V====            xyz_VirTempWork = xyz_VirTemp
   319: ++V====            xyr_VirTempWork = xyr_VirTemp
   320:                  else
   321:                    ! ׻ַ¬
   322:                    ! Pause measurement of computation time
   323:                    call TimesetClockStop( module_name )
   324:                    call AuxVars(                      &
   325:                      & xy_Ps, xyz_Temp, xyz_QVap,     &  ! (in )
   326:                      & xyz_VirTemp = xyz_VirTempWork, &  ! (out) optional
   327:                      & xyr_VirTemp = xyr_VirTempWork  &  ! (out) optional
   328:                      & )
   329:                    ! ׻ַ¬
   330:                    ! Start measurement of computation time
   331:                    call TimesetClockStart( module_name )
   332:                  end if
   333:            
   334:            !!$      xyz_Height(:,:,1) = &
   335:            !!$        & xy_SurfHeight(:,:) &
   336:            !!$        & + GasRDry / Grav * xyz_Temp(:,:,1) * ( 1. - z_Sigma(1) )
   337:            !!$      do k = 2, kmax
   338:            !!$        xyz_Height(:,:,k) = &
   339:            !!$          &   xyz_Height(:,:,k-1) &
   340:            !!$          & + GasRDry / Grav * xyr_TempWork(:,:,k-1) &
   341:            !!$          &   * r_DelSigma(k-1) / r_Sigma(k-1)
   342:            !!$      end do
   343:            
   344: +V=====          xyz_Height(:,:,1) =                          &
   345:                    & xy_SurfHeight                            &
   346:                    & + GasRDry / Grav * xyz_VirTempWork(:,:,1) * ( 1.0_DP - z_Sigma(1) )
   347: +------>         do k = 2, kmax
   348: |+V====            xyz_Height(:,:,k) = xyz_Height(:,:,k-1)         &
   349: |                    & + GasRDry / Grav * xyr_VirTempWork(:,:,k-1) &
   350: |                    &   * r_DelSigma(k-1) / r_Sigma(k-1)
   351: +------          end do
   352:                end if
   353:            
   354:                if ( present( xyr_Height ) .and. present( xy_SurfHeight ) ) then
   355:            
   356:                  if ( present( xyz_VirTemp ) ) then
   357: ++V====            xyz_VirTempWork = xyz_VirTemp
   358:                  else
   359:                    ! ׻ַ¬
   360:                    ! Pause measurement of computation time
   361:                    call TimesetClockStop( module_name )
   362:                    call AuxVars(                      &
   363:                      & xy_Ps, xyz_Temp, xyz_QVap,     &  ! (in )
   364:                      & xyz_VirTemp = xyz_VirTempWork  &  ! (out) optional
   365:                      & )
   366:                    ! ׻ַ¬
   367:                    ! Start measurement of computation time
   368:                    call TimesetClockStart( module_name )
   369:                  end if
   370:            
   371: W*=====          xyr_Height(:,:,0) = xy_SurfHeight
   372: +------>         do k = 1, kmax
   373: |          !!$        xyr_Height(:,:,k) = xyr_Height(:,:,k-1)        &
   374: |          !!$          & + GasRDry / Grav * xyz_Temp(:,:,k)     &
   375: |          !!$          &   * z_DelSigma(k) / z_Sigma(k)
   376: |+V====            xyr_Height(:,:,k) = xyr_Height(:,:,k-1)        &
   377: |                    & + GasRDry / Grav * xyz_VirTempWork(:,:,k)  &
   378: |                    &   * z_DelSigma(k) / z_Sigma(k)
   379: +------          end do
   380:                end if
   381:            
   382:                ! ʡؿη׻
   383:                ! Calculate exner function
   384:                !
   385:                if ( present( xyz_Exner ) ) then
   386:                  if ( present( xyz_Press ) ) then
   387: ++V====            xyz_PressWork = xyz_Press
   388:                  else
   389:                    call AuxVarsInternalRoutine(   &
   390:                      & xy_Ps,      xyz_Temp,      &  ! (in )
   391:                      & xyz_Press = xyz_PressWork  &  ! (out) optional
   392:                      & )
   393:                  end if
   394:            
   395: ++V====          xyz_Exner = ( xyz_PressWork / RefPress ) ** ( GasRDry / CpDry )
   396:                end if
   397:            
   398:            
   399:                if ( present( xyr_Exner ) ) then
   400:                  if ( present( xyr_Press ) ) then
   401: ++V====            xyr_PressWork = xyr_Press
   402:                  else
   403:                    call AuxVarsInternalRoutine(   &
   404:                      & xy_Ps,      xyz_Temp,      &  ! (in )
   405:                      & xyr_Press = xyr_PressWork  &  ! (out) optional
   406:                      & )
   407:                  end if
   408:            
   409: ++V====          xyr_Exner = ( xyr_PressWork / RefPress ) ** ( GasRDry / CpDry )
   410:                end if
   411:            
   412:                ! ׻ַ¬
   413:                ! Pause measurement of computation time
   414:                !
   415:                call TimesetClockStop( module_name )
   416:            
   417:              end subroutine AuxVars
   418:            
   419:              !--------------------------------------------------------------------------------------
   420:            
   421:              subroutine AuxVarsInternalRoutine( &
   422:                & xy_Ps,      xyz_Temp,   &  ! (in )
   423:                & xyr_Temp,               &  ! (out) optional
   424:                & xyz_Press,  xyr_Press   &  ! (out) optional
   425:                & )
   426:                !
   427:                ! ٤Ⱦҥ٥, λ, 
   428:                ! ʡؿη׻Ԥޤ. 
   429:                !
   430:                ! Interpolate temperature on half sigma level, 
   431:                ! and calculate pressure, 
   432:                ! and calculate exner function. 
   433:            
   434:                ! ⥸塼 ; USE statements
   435:                !
   436:            
   437:                ! ɸǡ
   438:                ! Axes data settings
   439:                !
   440:                use axesset, only: &
   441:                  & z_Sigma, &
   442:                                          ! $ \sigma $ ٥ (). 
   443:                                          ! Full $ \sigma $ level
   444:                  & r_Sigma
   445:                                          ! $ \sigma $ ٥ (Ⱦ). 
   446:                                          ! Half $ \sigma $ level
   447:            
   448:                ! ʸ ; Declaration statements
   449:                !
   450:                implicit none
   451:            
   452:                real(DP), intent(in):: xy_Ps       (0:imax-1, 1:jmax)
   453:                                          ! $ p_s (t-\Delta t) $ . ɽ̵. Surface pressure
   454:                real(DP), intent(in):: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   455:                                          ! $ T $ .     . Temperature
   456:                real(DP), intent(out), optional:: xyr_Temp   (0:imax-1, 1:jmax, 0:kmax)
   457:                                          ! $ \hat{T} $ .  (Ⱦ٥). 
   458:                                          ! Temperature (half level)
   459:                real(DP), intent(out), optional:: xyz_Press  (0:imax-1, 1:jmax, 1:kmax)
   460:                                          ! $ p $ .  (٥). 
   461:                                          ! Air pressure (full level)
   462:                real(DP), intent(out), optional:: xyr_Press  (0:imax-1, 1:jmax, 0:kmax)
   463:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   464:                                          ! Air pressure (half level)
   465:            
   466:            
   467:                ! ѿ
   468:                ! Work variables
   469:                !
   470:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   471:                                          ! Work variables for DO loop in vertical direction
   472:            
   473:                ! ¹ʸ ; Executable statement
   474:                !
   475:            
   476:            
   477:                ! ǧ
   478:                ! Initialization check
   479:                !
   480:                if ( .not. auxiliary_inited ) then
   481:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   482:                end if
   483:            
   484:            
   485:                ! ٤
   486:                ! Interpolate temperature
   487:                !
   488:                if ( present( xyr_Temp ) ) then
   489: +------>         do k = 2, kmax
   490: |W*====            xyr_Temp(:,:,k-1) =   z_TempInpolM(k) * xyz_Temp(:,:,k-1)  &
   491: |                    &                 + z_TempInpol (k) * xyz_Temp(:,:,k)
   492: +------          end do
   493:            
   494: *W----->         xyr_Temp(:,:,kmax) = xyz_Temp(:,:,kmax)
   495: *W-----          xyr_Temp(:,:,0)    = xyz_Temp(:,:,1)
   496:            
   497:                end if
   498:            
   499:                ! η׻
   500:                ! Calculate pressure
   501:                !
   502:                if ( present( xyz_Press ) ) then
   503: +------>         do k = 1, kmax
   504: |W*====            xyz_Press(:,:,k) = xy_Ps * z_Sigma(k)
   505: +------          end do
   506:                end if
   507:            
   508:                if ( present( xyr_Press ) ) then
   509: +------>         do k = 0, kmax
   510: |W*====            xyr_Press(:,:,k) = xy_Ps * r_Sigma(k)
   511: +------          end do
   512:                end if
   513:            
   514:            
   515:              end subroutine AuxVarsInternalRoutine
   516:            
   517:              !--------------------------------------------------------------------------------------
   518:            
   519:              subroutine AuxVarsInit
   520:                !
   521:                ! auxiliary ⥸塼νԤޤ. 
   522:                ! NAMELIST#auxiliary_nml ɤ߹ߤϤμ³ǹԤޤ. 
   523:                !
   524:                ! "auxiliary" module is initialized. 
   525:                ! "NAMELIST#auxiliary_nml" is loaded in this procedure. 
   526:                !
   527:            
   528:                ! ⥸塼 ; USE statements
   529:                !
   530:            
   531:                ! ɸǡ
   532:                ! Axes data settings
   533:                !
   534:                use axesset, only: &
   535:                  & z_Sigma, &
   536:                                          ! $ \sigma $ ٥ (). 
   537:                                          ! Full $ \sigma $ level
   538:                  & r_Sigma
   539:                                          ! $ \sigma $ ٥ (Ⱦ). 
   540:                                          ! Half $ \sigma $ level
   541:            
   542:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   543:                ! Utilities for NAMELIST file input
   544:                !
   545:                use namelist_util, only: namelist_filename, NmlutilMsg
   546:            
   547:                ! ե
   548:                ! File I/O support
   549:                !
   550:                use dc_iounit, only: FileOpen
   551:            
   552:                ! ̷ѥ᥿
   553:                ! Kind type parameter
   554:                !
   555:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   556:            
   557:                ! ʸ
   558:                ! Character handling
   559:                !
   560:                use dc_string, only: StoA
   561:            
   562:                ! ʸ ; Declaration statements
   563:                !
   564:                implicit none
   565:            
   566:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   567:                                          ! Unit number for NAMELIST file open
   568:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   569:                                          ! IOSTAT of NAMELIST read
   570:            
   571:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   572:                                          ! Work variables for DO loop in vertical direction
   573:            
   574:                ! NAMELIST ѿ
   575:                ! NAMELIST group name
   576:                !
   577:                namelist /auxiliary_nml/ &
   578:                  & RefPress
   579:                      !
   580:                      ! ǥեͤˤĤƤϽ³ "auxiliary#AuxVarsInit" 
   581:                      ! Υɤ򻲾ȤΤ. 
   582:                      !
   583:                      ! Refer to source codes in the initialization procedure
   584:                      ! "auxiliary#AuxVarsInit" for the default values. 
   585:                      !
   586:            
   587:                ! ¹ʸ ; Executable statement
   588:                !
   589:            
   590:                if ( auxiliary_inited ) return
   591:            
   592:            
   593:                ! ǥեͤ
   594:                ! Default values settings
   595:                !
   596:                RefPress        =   1.0d5
   597:            
   598:                ! NAMELIST ɤ߹
   599:                ! NAMELIST is input
   600:                !
   601:                if ( trim(namelist_filename) /= '' ) then
   602:                  call FileOpen( unit_nml, &          ! (out)
   603:                    & namelist_filename, mode = 'r' ) ! (in)
   604:            
   605:                  rewind( unit_nml )
   606:                  read( unit_nml, &           ! (in)
   607:                    & nml = auxiliary_nml, &  ! (out)
   608:                    & iostat = iostat_nml )   ! (out)
   609:                  close( unit_nml )
   610:            
   611:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   612:                end if
   613:            
   614:                !  Ѥηη׻
   615:                !  Calculate coefficient for interpolation
   616:                !
   617:                allocate( z_TempInpolM(1:kmax) )
   618:                allocate( z_TempInpol(1:kmax) )
   619:            
   620:                z_TempInpolM(1) = 0.
   621:                z_TempInpol (1) = 0.
   622:            
   623: V------>       do k = 2, kmax
   624: |                z_TempInpolM(k) = &
   625: |                  &    ( log( r_Sigma( k-1 ) ) - log( z_Sigma( k ) ) ) &
   626: |                  &  / ( log( z_Sigma( k-1 ) ) - log( z_Sigma( k ) ) )
   627: |                z_TempInpol(k) = &
   628: |                  &    ( log( z_Sigma( k-1 ) ) - log( r_Sigma( k-1 ) ) ) &
   629: |                  &  / ( log( z_Sigma( k-1 ) ) - log( z_Sigma( k )   ) )
   630: V------        end  do
   631:            
   632:                !  ; Print
   633:                !
   634:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   635: V======        call MessageNotify( 'M', module_name, '  z_TempInpolM = %*r', r = real( z_TempInpolM ), n = (/ kmax /) )
   636: V======        call MessageNotify( 'M', module_name, '  z_TempInpol  = %*r', r = real( z_TempInpol  ), n = (/ kmax /) )
   637:                call MessageNotify( 'M', module_name, '  RefPress     = %f', d = (/ RefPress /) )
   638:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   639:            
   640:                auxiliary_inited = .true.
   641:            
   642:              end subroutine AuxVarsInit
   643:            
   644:              !--------------------------------------------------------------------------------------
   645:            
   646:              subroutine AuxVarsFinalize
   647:                !
   648:                ! ⥸塼ѿγդԤޤ. 
   649:                !
   650:                ! Deallocate variables in this module. 
   651:                !
   652:            
   653:                ! ʸ ; Declaration statements
   654:                !
   655:                implicit none
   656:            
   657:                ! ¹ʸ ; Executable statement
   658:                !
   659:            
   660:                if ( .not. auxiliary_inited ) return
   661:            
   662:                ! դ
   663:                ! Deallocation
   664:                !
   665:                if ( allocated( z_TempInpolM ) ) deallocate( z_TempInpolM )
   666:                if ( allocated( z_TempInpol  ) ) deallocate( z_TempInpol  )
   667:            
   668:                auxiliary_inited = .false.
   669:            
   670:              end subroutine AuxVarsFinalize
   671:            
   672:              !--------------------------------------------------------------------------------------
   673:            
   674:            end module auxiliary
