Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:21 2012
FILE NAME: check_prog_vars.f90
PROGRAM NAME: check_prog_vars
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   210  vec  (   1): Vectorized loop.
   211  opt  (1019): Feedback of scalar value from one loop pass to another.
   211  vec  (  26): Macro operation Max/Min.
   217  opt  (1019): Feedback of scalar value from one loop pass to another.
   217  vec  (  26): Macro operation Max/Min.
   218  opt  (1059): Unable to determine last value of scalar temporary.
   248  vec  (   1): Vectorized loop.
   249  opt  (1019): Feedback of scalar value from one loop pass to another.
   249  vec  (  26): Macro operation Max/Min.
   255  opt  (1019): Feedback of scalar value from one loop pass to another.
   255  vec  (  26): Macro operation Max/Min.
   256  opt  (1059): Unable to determine last value of scalar temporary.
   286  vec  (   1): Vectorized loop.
   287  opt  (1019): Feedback of scalar value from one loop pass to another.
   287  vec  (  26): Macro operation Max/Min.
   293  opt  (1019): Feedback of scalar value from one loop pass to another.
   293  vec  (  26): Macro operation Max/Min.
   294  opt  (1059): Unable to determine last value of scalar temporary.
   321  warn (  82): Name "n" is not used.
   321  warn (  83): Dummy argument "xyzf_qmix" is not used.
   321  warn (  83): Dummy argument "xy_ps" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:21 2012
FILE NAME: check_prog_vars.f90
PROGRAM NAME: check_prog_vars
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ͽѿͤγǧ
     2  !
     3  != Check values of prognostic variables
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: check_prog_vars.f90,v 1.4 2011-07-08 03:55:20 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module check_prog_vars
    13    !
    14    != ͽѿͤγǧ
    15    !
    16    != Check values of prognostic variables
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ͽѿͤγǧ
    21    !
    22    ! Check values of prognostic variables
    23    !
    24    !== Procedures List
    25    !
    26  !!$  ! SurfaceFlux       :: ɽ̥եåη׻
    27  !!$  ! SurfaceFluxOutput :: ɽ̥եåν
    28  !!$  ! ------------      :: ------------
    29  !!$  ! SurfaceFlux       :: Calculate surface fluxes
    30  !!$  ! SurfaceFluxOutput :: Output surface fluxes
    31    !
    32    !== NAMELIST
    33    !
    34    ! NAMELIST#check_prog_vars_nml
    35    !
    36  
    37    ! ⥸塼 ; USE statements
    38    !
    39  
    40    ! ̷ѥ᥿
    41    ! Kind type parameter
    42    !
    43    use dc_types, only: DP, &      ! ټ¿. Double precision.
    44      &                 STRING     ! ʸ.       Strings.
    45  
    46  
    47    ! ʸ ; Declaration statements
    48    !
    49    implicit none
    50    private
    51  
    52    ! ³
    53    ! Public procedure
    54    !
    55    public :: CheckProgVars
    56    public :: CheckProgVarsInit
    57  
    58    ! ѿ
    59    ! Public variables
    60    !
    61  
    62    ! ѿ
    63    ! Private variables
    64    !
    65    logical, save :: check_prog_vars_inited = .false.
    66                                ! ե饰.
    67                                ! Initialization flag
    68  
    69    real(DP), save:: TempMin
    70                              ! ٺǾ
    71                              ! Minimum value of temperature
    72    real(DP), save:: TempMax
    73                              ! ٺ
    74                              ! Maximum value of temperature
    75    real(DP), save:: VelMin
    76                              ! ®Ǿ
    77                              ! Minimum value of wind velocity
    78    real(DP), save:: VelMax
    79                              ! ®
    80                              ! Maximum value of wind velocity
    81  
    82    character(*), parameter:: module_name = 'check_prog_vars'
    83                                ! ⥸塼̾.
    84                                ! Module name
    85    character(*), parameter:: version = &
    86      & '$Name: dcpam5-20120921 $' // &
    87      & '$Id: check_prog_vars.f90,v 1.4 2011-07-08 03:55:20 yot Exp $'
    88                                ! ⥸塼ΥС
    89                                ! Module version
    90  
    91    ! INTERFACE ʸ ; INTERFACE statements
    92    !
    93  !!$  interface SurfaceFlux
    94  !!$    module procedure SurfaceFlux
    95  !!$  end interface
    96  !!$
    97  !!$  interface SurfaceFluxOutput
    98  !!$    module procedure SurfaceFluxOutput
    99  !!$  end interface
   100  
   101  contains
   102  
   103    subroutine CheckProgVars( &
   104      & xy_Ps, xyz_U, xyz_V, xyz_Temp, xyzf_QMix   & ! (in)
   105      & )
   106      !
   107      ! ͽѿͤγǧ
   108      !
   109      ! Check values of prognostic variables
   110      !
   111  
   112      ! ⥸塼 ; USE statements
   113      !
   114  
   115      ! ʻ
   116      ! Grid points settings
   117      !
   118      use gridset, only: imax, & ! ٳʻ.
   119                                 ! Number of grid points in longitude
   120        &                jmax, & ! ٳʻ.
   121                                 ! Number of grid points in latitude
   122        &                kmax    ! ľؿ.
   123                                 ! Number of vertical level
   124  
   125      ! ˴ؤ
   126      ! Settings of array for atmospheric composition
   127      !
   128      use composition, only: ncmax, IndexH2OVap
   129  
   130      ! å
   131      ! Message output
   132      !
   133      use dc_message, only: MessageNotify
   134  
   135      ! 
   136      ! Time control
   137      !
   138      use timeset, only: &
   139        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   140        & TimesetClockStart, TimesetClockStop
   141  
   142      ! ǥХåѥ桼ƥƥ
   143      ! Utilities for debug
   144      !
   145      use dc_trace, only: DbgMessage, BeginSub, EndSub
   146  
   147      ! ʸ ; Declaration statements
   148      !
   149      implicit none
   150      real(DP), intent(in):: xy_Ps (0:imax-1, 1:jmax)
   151                                ! $ p_s (t-\Delta t) $ . ɽ̵. Surface pressure (Pa)
   152      real(DP), intent(in):: xyz_U (0:imax-1, 1:jmax, 1:kmax)
   153                                ! $ u $ . ®. Eastward wind
   154      real(DP), intent(in):: xyz_V (0:imax-1, 1:jmax, 1:kmax)
   155                                ! $ v $ . ®. Northward wind
   156      real(DP), intent(in):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   157                                ! $ T $ .  (٥).
   158                                ! Temperature (full level)
   159      real(DP), intent(in):: xyzf_QMix(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   160                                ! $ q $ .     漾. Specific humidity
   161  
   162      ! ѿ
   163      ! Work variables
   164      !
   165      integer:: i               ! ˲ DO 롼Ѻѿ
   166                                ! Work variables for DO loop in longitude
   167      integer:: j               ! ˲ DO 롼Ѻѿ
   168                                ! Work variables for DO loop in latitude
   169      integer:: k               ! ľ˲ DO 롼Ѻѿ
   170                                ! Work variables for DO loop in vertical direction
   171      integer:: n               ! ˲ DO 롼Ѻѿ
   172                                ! Work variables for DO loop in dimension of constituents
   173  
   174      real(DP) :: minval, maxval
   175      integer  :: mini, minj, mink
   176      integer  :: maxi, maxj, maxk
   177  
   178  
   179      ! ¹ʸ ; Executable statement
   180      !
   181  
   182      ! ǧ
   183      ! Initialization check
   184      !
   185      if ( .not. check_prog_vars_inited ) then
   186        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   187      end if
   188  
   189  
   190      ! ׻ַ¬
   191      ! Start measurement of computation time
   192      !
   193      call TimesetClockStart( module_name )
   194  
   195  
   196  
   197      i = 0
   198      j = 1
   199      k = 1
   200      minval = xyz_U(i,j,k)
   201      maxval = xyz_U(i,j,k)
   202      mini   = i
   203      minj   = j
   204      mink   = k
   205      maxi   = i
   206      maxj   = j
   207      maxk   = k
   208      do k = 1, kmax
   209        do j = 1, jmax
   210          do i = 0, imax-1
   211            if ( xyz_U   (i,j,k) < minval ) then
   212              minval = xyz_U   (i,j,k)
   213              mini   = i
   214              minj   = j
   215              mink   = k
   216            end if
   217            if ( maxval < xyz_U   (i,j,k) ) then
   218              maxval = xyz_U   (i,j,k)
   219              maxi   = i
   220              maxj   = j
   221              maxk   = k
   222            end if
   223          end do
   224        end do
   225      end do
   226      if ( minval  < VelMin  ) then
   227        call MessageNotify( 'M', module_name, 'Minimum value : U(%d,%d,%d) = %f.', &
   228          & i = (/ mini, minj, mink /), d = (/ minval /) )
   229      end if
   230      if ( VelMax  < maxval  ) then
   231        call MessageNotify( 'M', module_name, 'Maximum value : U(%d,%d,%d) = %f.', &
   232          & i = (/ maxi, maxj, maxk /), d = (/ maxval /) )
   233      end if
   234  
   235      i = 0
   236      j = 1
   237      k = 1
   238      minval = xyz_V(i,j,k)
   239      maxval = xyz_V(i,j,k)
   240      mini   = i
   241      minj   = j
   242      mink   = k
   243      maxi   = i
   244      maxj   = j
   245      maxk   = k
   246      do k = 1, kmax
   247        do j = 1, jmax
   248          do i = 0, imax-1
   249            if ( xyz_V   (i,j,k) < minval ) then
   250              minval = xyz_V   (i,j,k)
   251              mini   = i
   252              minj   = j
   253              mink   = k
   254            end if
   255            if ( maxval < xyz_V   (i,j,k) ) then
   256              maxval = xyz_V   (i,j,k)
   257              maxi   = i
   258              maxj   = j
   259              maxk   = k
   260            end if
   261          end do
   262        end do
   263      end do
   264      if ( minval  < VelMin  ) then
   265        call MessageNotify( 'M', module_name, 'Minimum value : V(%d,%d,%d) = %f.', &
   266          & i = (/ mini, minj, mink /), d = (/ minval /) )
   267      end if
   268      if ( VelMax  < maxval  ) then
   269        call MessageNotify( 'M', module_name, 'Maximum value : V(%d,%d,%d) = %f.', &
   270          & i = (/ maxi, maxj, maxk /), d = (/ maxval /) )
   271      end if
   272  
   273      i = 0
   274      j = 1
   275      k = 1
   276      minval = xyz_Temp(i,j,k)
   277      maxval = xyz_Temp(i,j,k)
   278      mini   = i
   279      minj   = j
   280      mink   = k
   281      maxi   = i
   282      maxj   = j
   283      maxk   = k
   284      do k = 1, kmax
   285        do j = 1, jmax
   286          do i = 0, imax-1
   287            if ( xyz_Temp(i,j,k) < minval ) then
   288              minval = xyz_Temp(i,j,k)
   289              mini   = i
   290              minj   = j
   291              mink   = k
   292            end if
   293            if ( maxval < xyz_Temp(i,j,k) ) then
   294              maxval = xyz_Temp(i,j,k)
   295              maxi   = i
   296              maxj   = j
   297              maxk   = k
   298            end if
   299          end do
   300        end do
   301      end do
   302      if ( minval  < TempMin ) then
   303        call MessageNotify( 'M', module_name, 'Minimum value : Temp(%d,%d,%d) = %f.', &
   304          & i = (/ mini, minj, mink /), d = (/ minval /) )
   305      end if
   306      if ( TempMax < maxval  ) then
   307        call MessageNotify( 'M', module_name, 'Maximum value : Temp(%d,%d,%d) = %f.', &
   308          & i = (/ maxi, maxj, maxk /), d = (/ maxval /) )
   309      end if
   310  
   311  
   312      ! ҥȥǡ
   313      ! History data output
   314      !
   315  
   316      ! ׻ַ¬
   317      ! Pause measurement of computation time
   318      !
   319      call TimesetClockStop( module_name )
   320  
   321    end subroutine CheckProgVars
   322  
   323    !-------------------------------------------------------------------
   324  
   325    subroutine CheckProgVarsInit
   326      !
   327      ! check_prog_vars ⥸塼νԤޤ.
   328      ! NAMELIST#check_prog_vars_nml ɤ߹ߤϤμ³ǹԤޤ.
   329      !
   330      ! "check_prog_vars" module is initialized.
   331      ! "NAMELIST#check_prog_vars_nml" is loaded in this procedure.
   332      !
   333  
   334      ! ⥸塼 ; USE statements
   335      !
   336  
   337      ! NAMELIST եϤ˴ؤ桼ƥƥ
   338      ! Utilities for NAMELIST file input
   339      !
   340      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   341  
   342      ! ե
   343      ! File I/O support
   344      !
   345      use dc_iounit, only: FileOpen
   346  
   347      ! ̷ѥ᥿
   348      ! Kind type parameter
   349      !
   350      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   351  
   352      ! ʸ
   353      ! Character handling
   354      !
   355      use dc_string, only: StoA
   356  
   357      ! å
   358      ! Message output
   359      !
   360      use dc_message, only: MessageNotify
   361  
   362      ! ʸ ; Declaration statements
   363      !
   364      implicit none
   365  
   366      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   367                                ! Unit number for NAMELIST file open
   368      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   369                                ! IOSTAT of NAMELIST read
   370  
   371      ! NAMELIST ѿ
   372      ! NAMELIST group name
   373      !
   374      namelist /check_prog_vars_nml/ &
   375        & VelMin, VelMax, TempMin, TempMax
   376            !
   377            ! ǥեͤˤĤƤϽ³ "check_prog_vars#CheckProgVarsInit"
   378            ! Υɤ򻲾ȤΤ.
   379            !
   380            ! Refer to source codes in the initialization procedure
   381            ! "check_prog_vars#CheckProgVarsInit" for the default values.
   382            !
   383  
   384      ! ¹ʸ ; Executable statement
   385      !
   386  
   387      if ( check_prog_vars_inited ) return
   388  !!$    call InitCheck
   389  
   390      ! ǥեͤ
   391      ! Default values settings
   392      !
   393      VelMin  = -300.0_DP
   394      VelMax  =  300.0_DP
   395      TempMin =   50.0_DP
   396      TempMax =  350.0_DP
   397  
   398      ! NAMELIST ɤ߹
   399      ! NAMELIST is input
   400      !
   401      if ( trim(namelist_filename) /= '' ) then
   402        call FileOpen( unit_nml, &          ! (out)
   403          & namelist_filename, mode = 'r' ) ! (in)
   404  
   405        rewind( unit_nml )
   406        read( unit_nml, &                ! (in)
   407          & nml = check_prog_vars_nml, &  ! (out)
   408          & iostat = iostat_nml )        ! (out)
   409        close( unit_nml )
   410  
   411        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   412      end if
   413  
   414  
   415      !  ; Print
   416      !
   417      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   418  
   419      call MessageNotify( 'M', module_name, '  VelMin  = %f', d = (/ VelMin  /) )
   420      call MessageNotify( 'M', module_name, '  VelMax  = %f', d = (/ VelMax  /) )
   421      call MessageNotify( 'M', module_name, '  TempMin = %f', d = (/ TempMin /) )
   422      call MessageNotify( 'M', module_name, '  TempMax = %f', d = (/ TempMax /) )
   423  
   424      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   425  
   426      check_prog_vars_inited = .true.
   427  
   428    end subroutine CheckProgVarsInit
   429  
   430    !--------------------------------------------------------------------------------------
   431  
   432  end module check_prog_vars
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:21 2012
FILE NAME: check_prog_vars.f90
PROGRAM NAME: check_prog_vars
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ͽѿͤγǧ
     2:            !
     3:            != Check values of prognostic variables
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: check_prog_vars.f90,v 1.4 2011-07-08 03:55:20 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module check_prog_vars
    13:              !
    14:              != ͽѿͤγǧ
    15:              !
    16:              != Check values of prognostic variables
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ͽѿͤγǧ
    21:              !
    22:              ! Check values of prognostic variables
    23:              !
    24:              !== Procedures List
    25:              !
    26:            !!$  ! SurfaceFlux       :: ɽ̥եåη׻
    27:            !!$  ! SurfaceFluxOutput :: ɽ̥եåν
    28:            !!$  ! ------------      :: ------------
    29:            !!$  ! SurfaceFlux       :: Calculate surface fluxes
    30:            !!$  ! SurfaceFluxOutput :: Output surface fluxes
    31:              !
    32:              !== NAMELIST
    33:              !
    34:              ! NAMELIST#check_prog_vars_nml
    35:              !
    36:            
    37:              ! ⥸塼 ; USE statements
    38:              !
    39:            
    40:              ! ̷ѥ᥿
    41:              ! Kind type parameter
    42:              !
    43:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    44:                &                 STRING     ! ʸ.       Strings. 
    45:            
    46:            
    47:              ! ʸ ; Declaration statements
    48:              !
    49:              implicit none
    50:              private
    51:            
    52:              ! ³
    53:              ! Public procedure
    54:              !
    55:              public :: CheckProgVars
    56:              public :: CheckProgVarsInit
    57:            
    58:              ! ѿ
    59:              ! Public variables
    60:              !
    61:            
    62:              ! ѿ
    63:              ! Private variables
    64:              !
    65:              logical, save :: check_prog_vars_inited = .false.
    66:                                          ! ե饰. 
    67:                                          ! Initialization flag
    68:            
    69:              real(DP), save:: TempMin
    70:                                        ! ٺǾ
    71:                                        ! Minimum value of temperature
    72:              real(DP), save:: TempMax
    73:                                        ! ٺ
    74:                                        ! Maximum value of temperature
    75:              real(DP), save:: VelMin
    76:                                        ! ®Ǿ
    77:                                        ! Minimum value of wind velocity
    78:              real(DP), save:: VelMax
    79:                                        ! ®
    80:                                        ! Maximum value of wind velocity
    81:            
    82:              character(*), parameter:: module_name = 'check_prog_vars'
    83:                                          ! ⥸塼̾. 
    84:                                          ! Module name
    85:              character(*), parameter:: version = &
    86:                & '$Name: dcpam5-20120921 $' // &
    87:                & '$Id: check_prog_vars.f90,v 1.4 2011-07-08 03:55:20 yot Exp $'
    88:                                          ! ⥸塼ΥС
    89:                                          ! Module version
    90:            
    91:              ! INTERFACE ʸ ; INTERFACE statements
    92:              !
    93:            !!$  interface SurfaceFlux
    94:            !!$    module procedure SurfaceFlux
    95:            !!$  end interface
    96:            !!$
    97:            !!$  interface SurfaceFluxOutput
    98:            !!$    module procedure SurfaceFluxOutput
    99:            !!$  end interface
   100:            
   101:            contains
   102:            
   103:              subroutine CheckProgVars( &
   104:                & xy_Ps, xyz_U, xyz_V, xyz_Temp, xyzf_QMix   & ! (in)
   105:                & )
   106:                !
   107:                ! ͽѿͤγǧ
   108:                !
   109:                ! Check values of prognostic variables
   110:                !
   111:            
   112:                ! ⥸塼 ; USE statements
   113:                !
   114:            
   115:                ! ʻ
   116:                ! Grid points settings
   117:                !
   118:                use gridset, only: imax, & ! ٳʻ. 
   119:                                           ! Number of grid points in longitude
   120:                  &                jmax, & ! ٳʻ. 
   121:                                           ! Number of grid points in latitude
   122:                  &                kmax    ! ľؿ. 
   123:                                           ! Number of vertical level
   124:            
   125:                ! ˴ؤ
   126:                ! Settings of array for atmospheric composition
   127:                !
   128:                use composition, only: ncmax, IndexH2OVap
   129:            
   130:                ! å
   131:                ! Message output
   132:                !
   133:                use dc_message, only: MessageNotify
   134:            
   135:                ! 
   136:                ! Time control
   137:                !
   138:                use timeset, only: &
   139:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   140:                  & TimesetClockStart, TimesetClockStop
   141:            
   142:                ! ǥХåѥ桼ƥƥ
   143:                ! Utilities for debug
   144:                !
   145:                use dc_trace, only: DbgMessage, BeginSub, EndSub
   146:            
   147:                ! ʸ ; Declaration statements
   148:                !
   149:                implicit none
   150:                real(DP), intent(in):: xy_Ps (0:imax-1, 1:jmax)
   151:                                          ! $ p_s (t-\Delta t) $ . ɽ̵. Surface pressure (Pa)
   152:                real(DP), intent(in):: xyz_U (0:imax-1, 1:jmax, 1:kmax)
   153:                                          ! $ u $ . ®. Eastward wind
   154:                real(DP), intent(in):: xyz_V (0:imax-1, 1:jmax, 1:kmax)
   155:                                          ! $ v $ . ®. Northward wind
   156:                real(DP), intent(in):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   157:                                          ! $ T $ .  (٥). 
   158:                                          ! Temperature (full level)
   159:                real(DP), intent(in):: xyzf_QMix(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   160:                                          ! $ q $ .     漾. Specific humidity
   161:            
   162:                ! ѿ
   163:                ! Work variables
   164:                !
   165:                integer:: i               ! ˲ DO 롼Ѻѿ
   166:                                          ! Work variables for DO loop in longitude
   167:                integer:: j               ! ˲ DO 롼Ѻѿ
   168:                                          ! Work variables for DO loop in latitude
   169:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   170:                                          ! Work variables for DO loop in vertical direction
   171:                integer:: n               ! ˲ DO 롼Ѻѿ
   172:                                          ! Work variables for DO loop in dimension of constituents
   173:            
   174:                real(DP) :: minval, maxval
   175:                integer  :: mini, minj, mink
   176:                integer  :: maxi, maxj, maxk
   177:            
   178:            
   179:                ! ¹ʸ ; Executable statement
   180:                !
   181:            
   182:                ! ǧ
   183:                ! Initialization check
   184:                !
   185:                if ( .not. check_prog_vars_inited ) then
   186:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   187:                end if
   188:            
   189:            
   190:                ! ׻ַ¬
   191:                ! Start measurement of computation time
   192:                !
   193:                call TimesetClockStart( module_name )
   194:            
   195:            
   196:            
   197:                i = 0
   198:                j = 1
   199:                k = 1
   200:                minval = xyz_U(i,j,k)
   201:                maxval = xyz_U(i,j,k)
   202:                mini   = i
   203:                minj   = j
   204:                mink   = k
   205:                maxi   = i
   206:                maxj   = j
   207:                maxk   = k
   208: +------>       do k = 1, kmax
   209: |+----->         do j = 1, jmax
   210: ||V---->           do i = 0, imax-1
   211: |||                  if ( xyz_U   (i,j,k) < minval ) then
   212: |||                    minval = xyz_U   (i,j,k)
   213: |||                    mini   = i
   214: |||                    minj   = j
   215: |||                    mink   = k
   216: |||                  end if
   217: |||                  if ( maxval < xyz_U   (i,j,k) ) then
   218: |||                    maxval = xyz_U   (i,j,k)
   219: |||                    maxi   = i
   220: |||                    maxj   = j
   221: |||                    maxk   = k
   222: |||                  end if
   223: ||V----            end do
   224: |+-----          end do
   225: +------        end do
   226:                if ( minval  < VelMin  ) then
   227:                  call MessageNotify( 'M', module_name, 'Minimum value : U(%d,%d,%d) = %f.', &
   228:                    & i = (/ mini, minj, mink /), d = (/ minval /) )
   229:                end if
   230:                if ( VelMax  < maxval  ) then
   231:                  call MessageNotify( 'M', module_name, 'Maximum value : U(%d,%d,%d) = %f.', &
   232:                    & i = (/ maxi, maxj, maxk /), d = (/ maxval /) )
   233:                end if
   234:            
   235:                i = 0
   236:                j = 1
   237:                k = 1
   238:                minval = xyz_V(i,j,k)
   239:                maxval = xyz_V(i,j,k)
   240:                mini   = i
   241:                minj   = j
   242:                mink   = k
   243:                maxi   = i
   244:                maxj   = j
   245:                maxk   = k
   246: +------>       do k = 1, kmax
   247: |+----->         do j = 1, jmax
   248: ||V---->           do i = 0, imax-1
   249: |||                  if ( xyz_V   (i,j,k) < minval ) then
   250: |||                    minval = xyz_V   (i,j,k)
   251: |||                    mini   = i
   252: |||                    minj   = j
   253: |||                    mink   = k
   254: |||                  end if
   255: |||                  if ( maxval < xyz_V   (i,j,k) ) then
   256: |||                    maxval = xyz_V   (i,j,k)
   257: |||                    maxi   = i
   258: |||                    maxj   = j
   259: |||                    maxk   = k
   260: |||                  end if
   261: ||V----            end do
   262: |+-----          end do
   263: +------        end do
   264:                if ( minval  < VelMin  ) then
   265:                  call MessageNotify( 'M', module_name, 'Minimum value : V(%d,%d,%d) = %f.', &
   266:                    & i = (/ mini, minj, mink /), d = (/ minval /) )
   267:                end if
   268:                if ( VelMax  < maxval  ) then
   269:                  call MessageNotify( 'M', module_name, 'Maximum value : V(%d,%d,%d) = %f.', &
   270:                    & i = (/ maxi, maxj, maxk /), d = (/ maxval /) )
   271:                end if
   272:            
   273:                i = 0
   274:                j = 1
   275:                k = 1
   276:                minval = xyz_Temp(i,j,k)
   277:                maxval = xyz_Temp(i,j,k)
   278:                mini   = i
   279:                minj   = j
   280:                mink   = k
   281:                maxi   = i
   282:                maxj   = j
   283:                maxk   = k
   284: +------>       do k = 1, kmax
   285: |+----->         do j = 1, jmax
   286: ||V---->           do i = 0, imax-1
   287: |||                  if ( xyz_Temp(i,j,k) < minval ) then
   288: |||                    minval = xyz_Temp(i,j,k)
   289: |||                    mini   = i
   290: |||                    minj   = j
   291: |||                    mink   = k
   292: |||                  end if
   293: |||                  if ( maxval < xyz_Temp(i,j,k) ) then
   294: |||                    maxval = xyz_Temp(i,j,k)
   295: |||                    maxi   = i
   296: |||                    maxj   = j
   297: |||                    maxk   = k
   298: |||                  end if
   299: ||V----            end do
   300: |+-----          end do
   301: +------        end do
   302:                if ( minval  < TempMin ) then
   303:                  call MessageNotify( 'M', module_name, 'Minimum value : Temp(%d,%d,%d) = %f.', &
   304:                    & i = (/ mini, minj, mink /), d = (/ minval /) )
   305:                end if
   306:                if ( TempMax < maxval  ) then
   307:                  call MessageNotify( 'M', module_name, 'Maximum value : Temp(%d,%d,%d) = %f.', &
   308:                    & i = (/ maxi, maxj, maxk /), d = (/ maxval /) )
   309:                end if
   310:            
   311:            
   312:                ! ҥȥǡ
   313:                ! History data output
   314:                !
   315:            
   316:                ! ׻ַ¬
   317:                ! Pause measurement of computation time
   318:                !
   319:                call TimesetClockStop( module_name )
   320:            
   321:              end subroutine CheckProgVars
   322:            
   323:              !-------------------------------------------------------------------
   324:            
   325:              subroutine CheckProgVarsInit
   326:                !
   327:                ! check_prog_vars ⥸塼νԤޤ. 
   328:                ! NAMELIST#check_prog_vars_nml ɤ߹ߤϤμ³ǹԤޤ. 
   329:                !
   330:                ! "check_prog_vars" module is initialized. 
   331:                ! "NAMELIST#check_prog_vars_nml" is loaded in this procedure. 
   332:                !
   333:            
   334:                ! ⥸塼 ; USE statements
   335:                !
   336:            
   337:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   338:                ! Utilities for NAMELIST file input
   339:                !
   340:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   341:            
   342:                ! ե
   343:                ! File I/O support
   344:                !
   345:                use dc_iounit, only: FileOpen
   346:            
   347:                ! ̷ѥ᥿
   348:                ! Kind type parameter
   349:                !
   350:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   351:            
   352:                ! ʸ
   353:                ! Character handling
   354:                !
   355:                use dc_string, only: StoA
   356:            
   357:                ! å
   358:                ! Message output
   359:                !
   360:                use dc_message, only: MessageNotify
   361:            
   362:                ! ʸ ; Declaration statements
   363:                !
   364:                implicit none
   365:            
   366:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   367:                                          ! Unit number for NAMELIST file open
   368:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   369:                                          ! IOSTAT of NAMELIST read
   370:            
   371:                ! NAMELIST ѿ
   372:                ! NAMELIST group name
   373:                !
   374:                namelist /check_prog_vars_nml/ &
   375:                  & VelMin, VelMax, TempMin, TempMax
   376:                      !
   377:                      ! ǥեͤˤĤƤϽ³ "check_prog_vars#CheckProgVarsInit" 
   378:                      ! Υɤ򻲾ȤΤ. 
   379:                      !
   380:                      ! Refer to source codes in the initialization procedure
   381:                      ! "check_prog_vars#CheckProgVarsInit" for the default values. 
   382:                      !
   383:            
   384:                ! ¹ʸ ; Executable statement
   385:                !
   386:            
   387:                if ( check_prog_vars_inited ) return
   388:            !!$    call InitCheck
   389:            
   390:                ! ǥեͤ
   391:                ! Default values settings
   392:                !
   393:                VelMin  = -300.0_DP
   394:                VelMax  =  300.0_DP
   395:                TempMin =   50.0_DP
   396:                TempMax =  350.0_DP
   397:            
   398:                ! NAMELIST ɤ߹
   399:                ! NAMELIST is input
   400:                !
   401:                if ( trim(namelist_filename) /= '' ) then
   402:                  call FileOpen( unit_nml, &          ! (out)
   403:                    & namelist_filename, mode = 'r' ) ! (in)
   404:            
   405:                  rewind( unit_nml )
   406:                  read( unit_nml, &                ! (in)
   407:                    & nml = check_prog_vars_nml, &  ! (out)
   408:                    & iostat = iostat_nml )        ! (out)
   409:                  close( unit_nml )
   410:            
   411:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   412:                end if
   413:            
   414:            
   415:                !  ; Print
   416:                !
   417:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   418:            
   419:                call MessageNotify( 'M', module_name, '  VelMin  = %f', d = (/ VelMin  /) )
   420:                call MessageNotify( 'M', module_name, '  VelMax  = %f', d = (/ VelMax  /) )
   421:                call MessageNotify( 'M', module_name, '  TempMin = %f', d = (/ TempMin /) )
   422:                call MessageNotify( 'M', module_name, '  TempMax = %f', d = (/ TempMax /) )
   423:            
   424:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   425:            
   426:                check_prog_vars_inited = .true.
   427:            
   428:              end subroutine CheckProgVarsInit
   429:            
   430:              !--------------------------------------------------------------------------------------
   431:            
   432:            end module check_prog_vars
