Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:18 2012
FILE NAME: i.intavr_operate.F90
PROGRAM NAME: intavr_operate
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   197  vec  (   4): Vectorized array expression.
   202  opt  (1800): Idiom detected (matrix multiply).
   231  vec  (   4): Vectorized array expression.
   231  vec  (  26): Macro operation Sum/InnerProd.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:18 2012
FILE NAME: i.intavr_operate.F90
PROGRAM NAME: intavr_operate
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ʬʿѤ
     2  !
     3  != Operation for integral and average
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6  ! Version::   $Id: intavr_operate.F90,v 1.3 2011-06-19 10:56:27 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module intavr_operate
    13    !
    14    != ʬʿѤ
    15    !
    16    != Operation for integral and average
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ʬѤɸŤߤθʬʿΤδؿ󶡤ޤ.
    21    ! {SPMODEL 饤֥}[http://www.gfd-dennou.org/library/spmodel]
    22    !  w_integral_module.f90 򻲹ͤ˺ޤ.
    23    !
    24    ! Functions for integral or average operation with weight for integration
    25    ! are provided
    26    ! This program is created referring to
    27    ! "w_integral_module.f90" in
    28    ! {SPMODEL library}[http://www.gfd-dennou.org/library/spmodel]
    29    !
    30    !== Procedures List
    31    !
    32    ! IntLonLat_xy           :: ٷʬ
    33  !!$  ! y_IntLon_xy, IntLon_x  :: ʬ
    34  !!$  ! ya_IntLon_xya          :: ʬ (¿)
    35  !!$  ! x_IntLat_xy, IntLat_y  :: ʬ
    36  !!$  ! xa_IntLat_xya          :: ʬ (¿)
    37  !!$  ! AvrLonLat_xy           :: ٷʿ
    38  !!$  ! y_AvrLon_xy, AvrLon_x  :: ʿ
    39  !!$  ! ya_AvrLon_xya          :: ʿ (¿)
    40  !!$  ! x_AvrLat_xy, AvrLat_y  :: ʿ
    41  !!$  ! xa_AvrLat_xya          :: ʿ (¿)
    42    ! ---------------------  :: ---------------------
    43    ! y_IntLon_xy, IntLon_x  :: Meridional integral
    44  !!$  ! ya_IntLon_xya          :: Meridional integral (for multi layer)
    45  !!$  ! x_IntLat_xy, IntLat_y  :: Zonal integral
    46  !!$  ! xa_IntLat_xya          :: Zonal integral (for multi layer)
    47  !!$  ! AvrLonLat_xy           :: Zonal and meridional average
    48  !!$  ! y_AvrLon_xy, AvrLon_x  :: Meridional average
    49  !!$  ! ya_AvrLon_xya          :: Meridional average (for multi layer)
    50  !!$  ! x_AvrLat_xy, AvrLat_y  :: Zonal average
    51  !!$  ! xa_AvrLat_xya          :: Zonal average (for multi layer)
    52    !
    53    !--
    54    !== NAMELIST
    55    !
    56    ! NAMELIST#intavr_operate_nml
    57    !++
    58  
    59    ! ⥸塼 ; USE statements
    60    !
    61  
    62    ! ɸǡ
    63    ! Axes data settings
    64    !
    65    use axesset, only: &
    66      & x_Lon_Weight, &
    67                                ! $ \Delta \lambda $ [rad.] .
    68                                ! ٺɸŤ.
    69                                ! Weight of longitude
    70      & y_Lat_Weight
    71                                ! $ \Delta \varphi $ [rad.] .
    72                                ! ٺɸŤ.
    73                                ! Weight of latitude
    74  
    75    ! ʻ
    76    ! Grid points settings
    77    !
    78    use gridset, only: imax, & ! ٳʻ.
    79                               ! Number of grid points in longitude
    80      &                jmax, & ! ٳʻ.
    81                               ! Number of grid points in latitude
    82      &                kmax    ! ľؿ.
    83                               ! Number of vertical level
    84  
    85    ! ̷ѥ᥿
    86    ! Kind type parameter
    87    !
    88    use dc_types, only: DP, &      ! ټ¿. Double precision.
    89      &                 STRING     ! ʸ.       Strings.
    90  
    91    ! å
    92    ! Message output
    93    !
    94    use dc_message, only: MessageNotify
    95  
    96    ! ʸ ; Declaration statements
    97    !
    98    implicit none
    99    private
   100  
   101    ! ³
   102    ! Public procedure
   103    !
   104    public:: IntLonLat_xy
   105  !!$  public:: y_IntLon_xy, ya_IntLon_xya, IntLon_x
   106  !!$  public:: x_IntLat_xy, xa_IntLat_xya, IntLat_y
   107  !!$  public:: IntLat_y
   108  !!$  public:: AvrLonLat_xy
   109  !!$  public:: y_AvrLon_xy, ya_AvrLon_xya, AvrLon_x
   110  !!$  public:: x_AvrLat_xy, xa_AvrLat_xya, AvrLat_y
   111  
   112    ! ѿ
   113    ! Public variables
   114    !
   115    logical, save, public:: intavr_operate_inited = .false.
   116                                ! ե饰.
   117                                ! Initialization flag
   118  
   119  
   120    ! ѿ
   121    ! Private variables
   122    !
   123  
   124    character(*), parameter:: module_name = 'intavr_operate'
   125                                ! ⥸塼̾.
   126                                ! Module name
   127    character(*), parameter:: version = &
   128      & '$Name: dcpam5-20120921 $' // &
   129      & '$Id: intavr_operate.F90,v 1.3 2011-06-19 10:56:27 yot Exp $'
   130                                ! ⥸塼ΥС
   131                                ! Module version
   132  
   133    ! INTERFACE ʸ ; INTERFACE statements
   134    !
   135  
   136  contains
   137  
   138    !-------------------------------------------------------------------
   139  
   140    function IntLonLat_xy( xy_Data )
   141      !
   142      ! 2 ٷٳʻǡΰʬ(1 ).
   143      !
   144      ! ºݤˤϳʻǡ x_Lon_Weight, y_Lat_Weight ݤ
   145      ! ¤׻Ƥ.
   146      !
   147      ! Global integration of 2-dimensional (latitude and longitude)
   148      ! grid data.
   149      !
   150      ! Practically, the sum total of grid data is calculated
   151      ! by multiplying in each grid "x_Lon_Weight" and "y_Lat_Weight".
   152      !
   153  
   154      real(DP), intent(in) :: xy_Data (0:imax-1, 1:jmax)
   155      real(DP)             :: IntLonLat_xy
   156  
   157      ! ¹ʸ ; Executable statement
   158      !
   159  
   160      ! Old one to be deleted
   161  !!$    IntLonLat_xy = IntLon_x( x_IntLat_xy( xy_Data ) )
   162  
   163      IntLonLat_xy = IntLat_y( y_IntLon_xy( xy_Data ) )
   164  
   165    end function IntLonLat_xy
   166  
   167    !-------------------------------------------------------------------
   168  
   169    function y_IntLon_xy( xy_Data )
   170      !
   171      ! 2 ٷٳʻǡηʬ(1 ).
   172      !
   173      ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   174      ! ¤׻Ƥ.
   175      !
   176      ! Zonal integration of 2-dimensional (latitude and longitude)
   177      ! grid data.
   178      !
   179      ! Practically, the sum total of grid data is calculated
   180      ! by multiplying in each grid "x_Lon_Weight".
   181      !
   182  
   183      real(DP), intent(in) :: xy_Data (0:imax-1, 1:jmax)
   184      real(DP)             :: y_IntLon_xy (1:jmax)
   185  
   186      ! ѿ
   187      ! Work variables
   188      !
   189      integer:: i               ! ˲ DO 롼Ѻѿ
   190                                ! Work variables for DO loop in longitudinal direction
   191      integer:: j               ! ˲ DO 롼Ѻѿ
   192                                ! Work variables for DO loop in latitudinal direction
   193  
   194      ! ¹ʸ ; Executable statement
   195      !
   196  
   197      y_IntLon_xy = 0.0_DP
   198      do j = 1, jmax
   199        do i = 0, imax - 1
   200          y_IntLon_xy(j) = y_IntLon_xy(j) + xy_Data (i,j) * x_Lon_Weight(i)
   201        end do
   202      end do
     .           call VDMXPA (xy_data(0,1), 1*imax, 1, x_lon_weight(0), 1,      
     .       1   y_intlon_xy(1), 1, jmax, imax)                                 
   203  
   204    end function y_IntLon_xy
   205  
   206  
   207    !-------------------------------------------------------------------
   208  
   209    function IntLat_y( y_Data )
   210      !
   211      ! 1 ٳʻǡΰʬ(1 ).
   212      !
   213      ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   214      ! ¤׻Ƥ.
   215      !
   216      ! Meridonal integration of 1-dimensional (latitude)
   217      ! grid data.
   218      !
   219      ! Practically, the sum total of grid data is calculated
   220      ! by multiplying in each grid "y_Lat_Weight".
   221      !
   222      real(DP), intent(in) :: y_Data (1:jmax)
   223      real(DP)             :: IntLat_y
   224  
   225      ! ѿ
   226      ! Work variables
   227      !
   228  
   229      ! ¹ʸ ; Executable statement
   230      !
   231      IntLat_y = sum( y_Data * y_Lat_Weight )
   232  
   233    end function IntLat_y
   234  
   235  
   236    !-------------------------------------------------------------------
   237  !!$
   238  !!$  function AvrLonLat_xy( xy_Data )
   239  !!$    !
   240  !!$    ! 2 ٷٳʻǡΰʿ(1 ).
   241  !!$    !
   242  !!$    ! Global mean of 2-dimensional (latitude and longitude)
   243  !!$    ! grid data.
   244  !!$    !
   245  !!$
   246  !!$    real(DP), intent(in):: xy_Data (0:imax-1, 1:jmax)
   247  !!$
   248  !!$
   249  !!$    ! Local variable
   250  !!$    !
   251  !!$    real(DP)              :: AvrLonLat_xy
   252  !!$
   253  !!$
   254  !!$    ! ¹ʸ ; Executable statement
   255  !!$    !
   256  !!$
   257  !!$    ! Old one to be deleted
   258  !!$!    AvrLonLat_xy = AvrLon_x( x_AvrLat_xy( xy_Data ) )
   259  !!$
   260  !!$    AvrLonLat_xy = AvrLat_y( y_AvrLon_xy( xy_Data ) )
   261  !!$
   262  !!$
   263  !!$  end function AvrLonLat_xy
   264  !!$
   265  !!$  !-------------------------------------------------------------------
   266  !!$
   267  !!$  function x_IntLat_xy( xy_Data )
   268  !!$    !
   269  !!$    ! 2 ٷٳʻǡΰʬ(1 ).
   270  !!$    !
   271  !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   272  !!$    ! ¤׻Ƥ.
   273  !!$    !
   274  !!$    ! Meridional integration of 2-dimensional (latitude and longitude)
   275  !!$    ! grid data.
   276  !!$    !
   277  !!$    ! Practically, the sum total of grid data is calculated
   278  !!$    ! by multiplying in each grid "y_Lat_Weight".
   279  !!$    !
   280  !!$    real(DP), intent(in):: xy_Data (0:imax-1, 1:jmax)
   281  !!$    real(DP):: x_IntLat_xy (0:imax-1)
   282  !!$
   283  !!$    ! ѿ
   284  !!$    ! Work variables
   285  !!$    !
   286  !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   287  !!$                              ! Work variables for DO loop in latitude
   288  !!$
   289  !!$    ! ¹ʸ ; Executable statement
   290  !!$    !
   291  !!$    x_IntLat_xy = 0.0_DP
   292  !!$    do j = 1, jmax
   293  !!$      x_IntLat_xy = x_IntLat_xy + xy_Data (:,j) * y_Lat_Weight(j)
   294  !!$    enddo
   295  !!$  end function x_IntLat_xy
   296  !!$
   297  !!$  !-------------------------------------------------------------------
   298  !!$
   299  !!$  function xa_IntLat_xya( xya_Data )
   300  !!$    !
   301  !!$    ! 3 ٷٳʻǡΰʬ(¿).
   302  !!$    !
   303  !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   304  !!$    ! ¤׻Ƥ.
   305  !!$    !
   306  !!$    ! Meridional integration of 3-dimensional (latitude and longitude)
   307  !!$    ! grid data. (for multi layer)
   308  !!$    !
   309  !!$    ! Practically, the sum total of grid data is calculated
   310  !!$    ! by multiplying in each grid "y_Lat_Weight".
   311  !!$    !
   312  !!$    real(DP), intent(in):: xya_Data (0:imax-1, 1:jmax, 1:kmax)
   313  !!$    real(DP):: xa_IntLat_xya (0:imax-1, 1:kmax)
   314  !!$
   315  !!$    ! ѿ
   316  !!$    ! Work variables
   317  !!$    !
   318  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   319  !!$                              ! Work variables for DO loop in vertical direction
   320  !!$
   321  !!$    ! ¹ʸ ; Executable statement
   322  !!$    !
   323  !!$    do k = 1, kmax
   324  !!$      xa_IntLat_xya(:,k) = x_IntLat_xy( xya_Data(:,:,k) )
   325  !!$    end do
   326  !!$  end function xa_IntLat_xya
   327  !!$
   328  !!$  !-------------------------------------------------------------------
   329  !!$
   330  !!$  function ya_IntLon_xya( xya_Data )
   331  !!$    !
   332  !!$    ! 3 ٷٳʻǡηʬ(¿).
   333  !!$    !
   334  !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   335  !!$    ! ¤׻Ƥ.
   336  !!$    !
   337  !!$    ! Zonal integration of 3-dimensional (latitude and longitude)
   338  !!$    ! grid data. (for multi layer)
   339  !!$    !
   340  !!$    ! Practically, the sum total of grid data is calculated
   341  !!$    ! by multiplying in each grid "x_Lon_Weight".
   342  !!$    !
   343  !!$    real(DP), intent(in):: xya_Data (0:imax-1, 1:jmax, 1:kmax)
   344  !!$    real(DP):: ya_IntLon_xya (1:jmax,1:kmax)
   345  !!$
   346  !!$    ! ѿ
   347  !!$    ! Work variables
   348  !!$    !
   349  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   350  !!$                              ! Work variables for DO loop in vertical direction
   351  !!$
   352  !!$    ! ¹ʸ ; Executable statement
   353  !!$    !
   354  !!$    do k = 1, kmax
   355  !!$      ya_IntLon_xya(:,k) = y_IntLon_xy( xya_Data(:,:,k) )
   356  !!$    end do
   357  !!$  end function ya_IntLon_xya
   358  !!$
   359  !!$  !-------------------------------------------------------------------
   360  !!$
   361  !!$  function IntLon_x( x_Data )
   362  !!$    !
   363  !!$    ! 1 ٳʻǡηʬ(1 ).
   364  !!$    !
   365  !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   366  !!$    ! ¤׻Ƥ.
   367  !!$    !
   368  !!$    ! Zonal integration of 1-dimensional (longitude)
   369  !!$    ! grid data.
   370  !!$    !
   371  !!$    ! Practically, the sum total of grid data is calculated
   372  !!$    ! by multiplying in each grid "x_Lon_Weight".
   373  !!$    !
   374  !!$    real(DP), intent(in):: x_Data (0:imax-1)
   375  !!$    real(DP):: IntLon_x
   376  !!$
   377  !!$    ! ѿ
   378  !!$    ! Work variables
   379  !!$    !
   380  !!$
   381  !!$    ! ¹ʸ ; Executable statement
   382  !!$    !
   383  !!$    IntLon_x = sum( x_Data * x_Lon_Weight )
   384  !!$  end function IntLon_x
   385  !!$
   386  !!$  !-------------------------------------------------------------------
   387  !!$
   388  !!$  function x_AvrLat_xy( xy_Data )
   389  !!$    !
   390  !!$    ! 2 ٷٳʻǡΰʿ(1 ).
   391  !!$    !
   392  !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   393  !!$    ! ¤׻, y_Lat_Weight ¤ǳ뤳Ȥ
   394  !!$    ! ʿѤƤ.
   395  !!$    !
   396  !!$    ! Meridional mean of 2-dimensional (latitude and longitude)
   397  !!$    ! grid data.
   398  !!$    !
   399  !!$    ! Practically, the mean grid data is calculated
   400  !!$    ! by multiplying in each grid "y_Lat_Weight"
   401  !!$    ! and deviding by the sum total of "y_Lat_Weight".
   402  !!$    !
   403  !!$    real(DP), intent(in):: xy_Data (0:imax-1, 1:jmax)
   404  !!$    real(DP):: x_AvrLat_xy (0:imax-1)
   405  !!$
   406  !!$    ! ѿ
   407  !!$    ! Work variables
   408  !!$    !
   409  !!$
   410  !!$    ! ¹ʸ ; Executable statement
   411  !!$    !
   412  !!$    x_AvrLat_xy = x_IntLat_xy ( xy_Data ) / sum( y_Lat_Weight )
   413  !!$  end function x_AvrLat_xy
   414  !!$
   415  !!$  !-------------------------------------------------------------------
   416  !!$
   417  !!$  function xa_AvrLat_xya( xya_Data )
   418  !!$    !
   419  !!$    ! 3 ٷٳʻǡΰʿ(¿).
   420  !!$    !
   421  !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   422  !!$    ! ¤׻, y_Lat_Weight ¤ǳ뤳Ȥ
   423  !!$    ! ʿѤƤ.
   424  !!$    !
   425  !!$    ! Meridional mean of 3-dimensional (latitude and longitude)
   426  !!$    ! grid data. (for multi layer)
   427  !!$    !
   428  !!$    ! Practically, the mean grid data is calculated
   429  !!$    ! by multiplying in each grid "y_Lat_Weight"
   430  !!$    ! and deviding by the sum total of "y_Lat_Weight".
   431  !!$    !
   432  !!$    real(DP), intent(in):: xya_Data (0:imax-1, 1:jmax, 1:kmax)
   433  !!$    real(DP):: xa_AvrLat_xya (0:imax-1, 1:kmax)
   434  !!$
   435  !!$    ! ѿ
   436  !!$    ! Work variables
   437  !!$    !
   438  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   439  !!$                              ! Work variables for DO loop in vertical direction
   440  !!$
   441  !!$    ! ¹ʸ ; Executable statement
   442  !!$    !
   443  !!$    do k = 1, kmax
   444  !!$      xa_AvrLat_xya(:,k) = x_AvrLat_xy( xya_Data(:,:,k) )
   445  !!$    end do
   446  !!$  end function xa_AvrLat_xya
   447  !!$
   448  !!$  !-------------------------------------------------------------------
   449  !!$
   450  !!$  function y_AvrLon_xy( xy_Data )
   451  !!$    !
   452  !!$    ! 2 ٷٳʻǡηʿ(1 ).
   453  !!$    !
   454  !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   455  !!$    ! ¤׻, x_Lon_Weight ¤ǳ뤳Ȥ
   456  !!$    ! ʿѤƤ.
   457  !!$    !
   458  !!$    ! Zonal mean of 2-dimensional (latitude and longitude)
   459  !!$    ! grid data.
   460  !!$    !
   461  !!$    ! Practically, the mean grid data is calculated
   462  !!$    ! by multiplying in each grid "x_Lon_Weight"
   463  !!$    ! and deviding by the sum total of "x_Lon_Weight".
   464  !!$    !
   465  !!$    real(DP), intent(in):: xy_Data (0:imax-1, 1:jmax)
   466  !!$    real(DP):: y_AvrLon_xy (1:jmax)
   467  !!$
   468  !!$    ! ѿ
   469  !!$    ! Work variables
   470  !!$    !
   471  !!$
   472  !!$    ! ¹ʸ ; Executable statement
   473  !!$    !
   474  !!$    y_AvrLon_xy = y_IntLon_xy( xy_Data ) / sum( x_Lon_Weight )
   475  !!$  end function y_AvrLon_xy
   476  !!$
   477  !!$  !-------------------------------------------------------------------
   478  !!$
   479  !!$  function ya_AvrLon_xya( xya_Data )
   480  !!$    !
   481  !!$    ! 3 ٷٳʻǡηʿ(¿).
   482  !!$    !
   483  !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   484  !!$    ! ¤׻, x_Lon_Weight ¤ǳ뤳Ȥ
   485  !!$    ! ʿѤƤ.
   486  !!$    !
   487  !!$    ! Zonal mean of 3-dimensional (latitude and longitude)
   488  !!$    ! grid data. (for multi layer)
   489  !!$    !
   490  !!$    ! Practically, the mean grid data is calculated
   491  !!$    ! by multiplying in each grid "x_Lon_Weight"
   492  !!$    ! and deviding by the sum total of "x_Lon_Weight".
   493  !!$    !
   494  !!$    real(DP), intent(in):: xya_Data (0:imax-1, 1:jmax, 1:kmax)
   495  !!$    real(DP):: ya_AvrLon_xya (1:jmax, 1:kmax)
   496  !!$
   497  !!$    ! ѿ
   498  !!$    ! Work variables
   499  !!$    !
   500  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   501  !!$                              ! Work variables for DO loop in vertical direction
   502  !!$
   503  !!$    ! ¹ʸ ; Executable statement
   504  !!$    !
   505  !!$    do k = 1, kmax
   506  !!$      ya_AvrLon_xya(:,k) = y_AvrLon_xy( xya_Data(:,:,k) )
   507  !!$    end do
   508  !!$  end function ya_AvrLon_xya
   509  !!$
   510  !!$#ifdef LIB_MPI
   511  !!$  !-------------------------------------------------------------------
   512  !!$
   513  !!$  function AvrLat_y( y_Data )
   514  !!$    !
   515  !!$    ! 1 ٳʻǡΰʿ(1 ).
   516  !!$    !
   517  !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   518  !!$    ! ¤׻, y_Lat_Weight ¤ǳ뤳Ȥ
   519  !!$    ! ʿѤƤ.
   520  !!$    !
   521  !!$    ! Meridonal mean of 1-dimensional (latitude)
   522  !!$    ! grid data.
   523  !!$    !
   524  !!$    ! Practically, the sum total of grid data is calculated
   525  !!$    ! by multiplying in each grid "y_Lat_Weight"
   526  !!$    ! and deviding by the sum total of "y_Lat_Weight".
   527  !!$    !
   528  !!$
   529  !!$    ! MPI
   530  !!$    !
   531  !!$    use mpi_wrapper, only: nprocs, myrank, &
   532  !!$      & MPIWrapperISend, &
   533  !!$      & MPIWrapperIRecv, &
   534  !!$      & MPIWrapperWait
   535  !!$
   536  !!$    ! ʻȿ
   537  !!$    ! Number of grid points and maximum truncated wavenumber settings
   538  !!$    !
   539  !!$    use gridset, only: a_jmax, jmax_max
   540  !!$
   541  !!$    real(DP), intent(in):: y_Data (1:jmax)
   542  !!$    real(DP):: AvrLat_y
   543  !!$
   544  !!$    ! ѿ
   545  !!$    ! Work variables
   546  !!$    !
   547  !!$
   548  !!$    ! ¹ʸ ; Executable statement
   549  !!$    !
   550  !!$
   551  !!$    real(DP), allocatable :: a_SendBuf (:)
   552  !!$    real(DP), allocatable :: aa_RecvBuf(:,:)
   553  !!$    integer , allocatable :: a_iReqSend(:)
   554  !!$    integer , allocatable :: a_iReqRecv(:)
   555  !!$
   556  !!$    real(DP)              :: SumWeight
   557  !!$
   558  !!$    integer               :: j
   559  !!$    integer               :: n
   560  !!$
   561  !!$    allocate( a_SendBuf (1:jmax_max) )
   562  !!$    allocate( aa_RecvBuf(1:jmax_max,0:nprocs-1) )
   563  !!$    allocate( a_iReqSend(0:nprocs-1) )
   564  !!$    allocate( a_iReqRecv(0:nprocs-1) )
   565  !!$
   566  !!$    do j = 1, jmax
   567  !!$      a_SendBuf(j) = y_Lat_Weight(j)
   568  !!$    end do
   569  !!$    do j = jmax+1, jmax_max
   570  !!$      a_SendBuf(j) = -1.0d0
   571  !!$    end do
   572  !!$
   573  !!$    do n = 0, nprocs-1
   574  !!$      if ( n == myrank ) then
   575  !!$        do j = 1, jmax
   576  !!$          aa_RecvBuf(:,n) = a_SendBuf
   577  !!$        end do
   578  !!$      else
   579  !!$        call MPIWrapperISend( n, jmax_max, a_SendBuf      , a_iReqSend(n) )
   580  !!$        call MPIWrapperIRecv( n, jmax_max, aa_RecvBuf(:,n), a_iReqRecv(n) )
   581  !!$      end if
   582  !!$    end do
   583  !!$    do n = 0, nprocs-1
   584  !!$      if ( n == myrank ) cycle
   585  !!$      call MPIWrapperWait( a_iReqSend(n) )
   586  !!$      call MPIWrapperWait( a_iReqRecv(n) )
   587  !!$    end do
   588  !!$
   589  !!$
   590  !!$    if ( nprocs == 1 ) then
   591  !!$      SumWeight = 0.0d0
   592  !!$      do n = 0, nprocs-1
   593  !!$        do j = 1, a_jmax(n)
   594  !!$          SumWeight = SumWeight + aa_RecvBuf(j,n)
   595  !!$        end do
   596  !!$      end do
   597  !!$    else
   598  !!$
   599  !!$      write( 6, * ) 'THIS WOULD BE WRONG.'
   600  !!$
   601  !!$      SumWeight = 0.0d0
   602  !!$      do n = nprocs-1, 0, -1
   603  !!$        do j = a_jmax(n), a_jmax(n) / 2 + 1, -1
   604  !!$          SumWeight = SumWeight + aa_RecvBuf(j,n)
   605  !!$        end do
   606  !!$      end do
   607  !!$      do n = 0, nprocs-1
   608  !!$        do j = 1, a_jmax(n) / 2
   609  !!$          SumWeight = SumWeight + aa_RecvBuf(j,n)
   610  !!$        end do
   611  !!$      end do
   612  !!$    end if
   613  !!$
   614  !!$    deallocate( a_SendBuf  )
   615  !!$    deallocate( aa_RecvBuf )
   616  !!$    deallocate( a_iReqSend )
   617  !!$    deallocate( a_iReqRecv )
   618  !!$
   619  !!$
   620  !!$    AvrLat_y = IntLat_y( y_Data ) / SumWeight
   621  !!$
   622  !!$  end function AvrLat_y
   623  !!$
   624  !!$#else
   625  !!$  !-------------------------------------------------------------------
   626  !!$
   627  !!$  function AvrLat_y( y_Data )
   628  !!$    !
   629  !!$    ! 1 ٳʻǡΰʿ(1 ).
   630  !!$    !
   631  !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   632  !!$    ! ¤׻, y_Lat_Weight ¤ǳ뤳Ȥ
   633  !!$    ! ʿѤƤ.
   634  !!$    !
   635  !!$    ! Meridonal mean of 1-dimensional (latitude)
   636  !!$    ! grid data.
   637  !!$    !
   638  !!$    ! Practically, the sum total of grid data is calculated
   639  !!$    ! by multiplying in each grid "y_Lat_Weight"
   640  !!$    ! and deviding by the sum total of "y_Lat_Weight".
   641  !!$    !
   642  !!$    real(DP), intent(in):: y_Data (1:jmax)
   643  !!$    real(DP):: AvrLat_y
   644  !!$
   645  !!$    ! ѿ
   646  !!$    ! Work variables
   647  !!$    !
   648  !!$
   649  !!$    ! ¹ʸ ; Executable statement
   650  !!$    !
   651  !!$
   652  !!$    AvrLat_y = IntLat_y( y_Data ) / sum( y_Lat_Weight )
   653  !!$
   654  !!$  end function AvrLat_y
   655  !!$
   656  !!$#endif
   657  !!$  !-------------------------------------------------------------------
   658  !!$
   659  !!$  function AvrLon_x( x_Data )
   660  !!$    !
   661  !!$    ! 1 ٳʻǡηʿ(1 ).
   662  !!$    !
   663  !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   664  !!$    ! ¤׻, x_Lon_Weight ¤ǳ뤳Ȥ
   665  !!$    ! ʿѤƤ.
   666  !!$    !
   667  !!$    ! Zonal mean of 1-dimensional (longitude)
   668  !!$    ! grid data.
   669  !!$    !
   670  !!$    ! Practically, the sum total of grid data is calculated
   671  !!$    ! by multiplying in each grid "x_Lon_Weight"
   672  !!$    ! and deviding by the sum total of "x_Lon_Weight".
   673  !!$    !
   674  !!$    real(DP), intent(in):: x_Data (0:imax-1)
   675  !!$    real(DP):: AvrLon_x
   676  !!$
   677  !!$    ! ѿ
   678  !!$    ! Work variables
   679  !!$    !
   680  !!$
   681  !!$    ! ¹ʸ ; Executable statement
   682  !!$    !
   683  !!$    AvrLon_x = IntLon_x( x_Data ) / sum( x_Lon_Weight )
   684  !!$  end function AvrLon_x
   685  !!$
   686  
   687    !--------------------------------------------------------------------------------------
   688  
   689    subroutine IntAvrOprInit
   690      !
   691      ! intavr_operate ⥸塼νԤޤ.
   692      ! NAMELIST#intavr_operate_nml ɤ߹ߤϤμ³ǹԤޤ.
   693      !
   694      ! "intavr_operate" module is initialized.
   695      ! "NAMELIST#intavr_operate_nml" is loaded in this procedure.
   696      !
   697  
   698      ! ⥸塼 ; USE statements
   699      !
   700  
   701      ! ʸ ; Declaration statements
   702      !
   703  
   704  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   705  !!$                              ! Unit number for NAMELIST file open
   706  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   707  !!$                              ! IOSTAT of NAMELIST read
   708  
   709      ! NAMELIST ѿ
   710      ! NAMELIST group name
   711      !
   712  !!$    namelist /intavr_operate_nml/
   713            !
   714            ! ǥեͤˤĤƤϽ³ "intavr_operate#IntAvrOprInit"
   715            ! Υɤ򻲾ȤΤ.
   716            !
   717            ! Refer to source codes in the initialization procedure
   718            ! "intavr_operate#IntAvrOprInit" for the default values.
   719            !
   720  
   721      ! ¹ʸ ; Executable statement
   722      !
   723  
   724      if ( intavr_operate_inited ) return
   725  
   726  
   727      ! ǥեͤ
   728      ! Default values settings
   729      !
   730  
   731  !!$    ! NAMELIST ɤ߹
   732  !!$    ! NAMELIST is input
   733  !!$    !
   734  !!$    if ( trim(namelist_filename) /= '' ) then
   735  !!$      call FileOpen( unit_nml, &          ! (out)
   736  !!$        & namelist_filename, mode = 'r' ) ! (in)
   737  !!$
   738  !!$      rewind( unit_nml )
   739  !!$      read( unit_nml, &           ! (in)
   740  !!$        & nml = intavr_operate_nml, &  ! (out)
   741  !!$        & iostat = iostat_nml )   ! (out)
   742  !!$      close( unit_nml )
   743  !!$
   744  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   745  !!$    end if
   746  
   747      !  ; Print
   748      !
   749      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   750      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   751      intavr_operate_inited = .true.
   752    end subroutine IntAvrOprInit
   753  
   754    !--------------------------------------------------------------------------------------
   755  
   756  end module intavr_operate
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:18 2012
FILE NAME: i.intavr_operate.F90
PROGRAM NAME: intavr_operate
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ʬʿѤ
     2:            !
     3:            != Operation for integral and average
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6:            ! Version::   $Id: intavr_operate.F90,v 1.3 2011-06-19 10:56:27 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module intavr_operate
    13:              !
    14:              != ʬʿѤ
    15:              !
    16:              != Operation for integral and average
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ʬѤɸŤߤθʬʿΤδؿ󶡤ޤ. 
    21:              ! {SPMODEL 饤֥}[http://www.gfd-dennou.org/library/spmodel]
    22:              !  w_integral_module.f90 򻲹ͤ˺ޤ. 
    23:              !
    24:              ! Functions for integral or average operation with weight for integration
    25:              ! are provided
    26:              ! This program is created referring to 
    27:              ! "w_integral_module.f90" in 
    28:              ! {SPMODEL library}[http://www.gfd-dennou.org/library/spmodel]
    29:              !
    30:              !== Procedures List
    31:              !
    32:              ! IntLonLat_xy           :: ٷʬ
    33:            !!$  ! y_IntLon_xy, IntLon_x  :: ʬ
    34:            !!$  ! ya_IntLon_xya          :: ʬ (¿)
    35:            !!$  ! x_IntLat_xy, IntLat_y  :: ʬ
    36:            !!$  ! xa_IntLat_xya          :: ʬ (¿)
    37:            !!$  ! AvrLonLat_xy           :: ٷʿ
    38:            !!$  ! y_AvrLon_xy, AvrLon_x  :: ʿ
    39:            !!$  ! ya_AvrLon_xya          :: ʿ (¿)
    40:            !!$  ! x_AvrLat_xy, AvrLat_y  :: ʿ
    41:            !!$  ! xa_AvrLat_xya          :: ʿ (¿)
    42:              ! ---------------------  :: ---------------------
    43:              ! y_IntLon_xy, IntLon_x  :: Meridional integral
    44:            !!$  ! ya_IntLon_xya          :: Meridional integral (for multi layer)
    45:            !!$  ! x_IntLat_xy, IntLat_y  :: Zonal integral
    46:            !!$  ! xa_IntLat_xya          :: Zonal integral (for multi layer)
    47:            !!$  ! AvrLonLat_xy           :: Zonal and meridional average
    48:            !!$  ! y_AvrLon_xy, AvrLon_x  :: Meridional average
    49:            !!$  ! ya_AvrLon_xya          :: Meridional average (for multi layer)
    50:            !!$  ! x_AvrLat_xy, AvrLat_y  :: Zonal average
    51:            !!$  ! xa_AvrLat_xya          :: Zonal average (for multi layer)
    52:              !
    53:              !--
    54:              !== NAMELIST
    55:              !
    56:              ! NAMELIST#intavr_operate_nml
    57:              !++
    58:            
    59:              ! ⥸塼 ; USE statements
    60:              !
    61:            
    62:              ! ɸǡ
    63:              ! Axes data settings
    64:              !
    65:              use axesset, only: &
    66:                & x_Lon_Weight, &
    67:                                          ! $ \Delta \lambda $ [rad.] . 
    68:                                          ! ٺɸŤ. 
    69:                                          ! Weight of longitude
    70:                & y_Lat_Weight
    71:                                          ! $ \Delta \varphi $ [rad.] . 
    72:                                          ! ٺɸŤ. 
    73:                                          ! Weight of latitude
    74:            
    75:              ! ʻ
    76:              ! Grid points settings
    77:              !
    78:              use gridset, only: imax, & ! ٳʻ. 
    79:                                         ! Number of grid points in longitude
    80:                &                jmax, & ! ٳʻ. 
    81:                                         ! Number of grid points in latitude
    82:                &                kmax    ! ľؿ. 
    83:                                         ! Number of vertical level
    84:            
    85:              ! ̷ѥ᥿
    86:              ! Kind type parameter
    87:              !
    88:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    89:                &                 STRING     ! ʸ.       Strings. 
    90:            
    91:              ! å
    92:              ! Message output
    93:              !
    94:              use dc_message, only: MessageNotify
    95:            
    96:              ! ʸ ; Declaration statements
    97:              !
    98:              implicit none
    99:              private
   100:            
   101:              ! ³
   102:              ! Public procedure
   103:              !
   104:              public:: IntLonLat_xy
   105:            !!$  public:: y_IntLon_xy, ya_IntLon_xya, IntLon_x
   106:            !!$  public:: x_IntLat_xy, xa_IntLat_xya, IntLat_y
   107:            !!$  public:: IntLat_y
   108:            !!$  public:: AvrLonLat_xy
   109:            !!$  public:: y_AvrLon_xy, ya_AvrLon_xya, AvrLon_x
   110:            !!$  public:: x_AvrLat_xy, xa_AvrLat_xya, AvrLat_y
   111:            
   112:              ! ѿ
   113:              ! Public variables
   114:              !
   115:              logical, save, public:: intavr_operate_inited = .false.
   116:                                          ! ե饰. 
   117:                                          ! Initialization flag
   118:            
   119:            
   120:              ! ѿ
   121:              ! Private variables
   122:              !
   123:            
   124:              character(*), parameter:: module_name = 'intavr_operate'
   125:                                          ! ⥸塼̾. 
   126:                                          ! Module name
   127:              character(*), parameter:: version = &
   128:                & '$Name: dcpam5-20120921 $' // &
   129:                & '$Id: intavr_operate.F90,v 1.3 2011-06-19 10:56:27 yot Exp $'
   130:                                          ! ⥸塼ΥС
   131:                                          ! Module version
   132:            
   133:              ! INTERFACE ʸ ; INTERFACE statements
   134:              !
   135:            
   136:            contains
   137:            
   138:              !-------------------------------------------------------------------
   139:            
   140:              function IntLonLat_xy( xy_Data )
   141:                !
   142:                ! 2 ٷٳʻǡΰʬ(1 ). 
   143:                !
   144:                ! ºݤˤϳʻǡ x_Lon_Weight, y_Lat_Weight ݤ
   145:                ! ¤׻Ƥ. 
   146:                !
   147:                ! Global integration of 2-dimensional (latitude and longitude)
   148:                ! grid data.
   149:                !
   150:                ! Practically, the sum total of grid data is calculated
   151:                ! by multiplying in each grid "x_Lon_Weight" and "y_Lat_Weight".
   152:                !
   153:            
   154:                real(DP), intent(in) :: xy_Data (0:imax-1, 1:jmax)
   155:                real(DP)             :: IntLonLat_xy
   156:            
   157:                ! ¹ʸ ; Executable statement
   158:                !
   159:            
   160:                ! Old one to be deleted
   161:            !!$    IntLonLat_xy = IntLon_x( x_IntLat_xy( xy_Data ) )
   162:            
   163:                IntLonLat_xy = IntLat_y( y_IntLon_xy( xy_Data ) )
   164:            
   165:              end function IntLonLat_xy
   166:            
   167:              !-------------------------------------------------------------------
   168:            
   169:              function y_IntLon_xy( xy_Data )
   170:                !
   171:                ! 2 ٷٳʻǡηʬ(1 ). 
   172:                !
   173:                ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   174:                ! ¤׻Ƥ. 
   175:                !
   176:                ! Zonal integration of 2-dimensional (latitude and longitude)
   177:                ! grid data.
   178:                !
   179:                ! Practically, the sum total of grid data is calculated
   180:                ! by multiplying in each grid "x_Lon_Weight".
   181:                !
   182:            
   183:                real(DP), intent(in) :: xy_Data (0:imax-1, 1:jmax)
   184:                real(DP)             :: y_IntLon_xy (1:jmax)
   185:            
   186:                ! ѿ
   187:                ! Work variables
   188:                !
   189:                integer:: i               ! ˲ DO 롼Ѻѿ
   190:                                          ! Work variables for DO loop in longitudinal direction
   191:                integer:: j               ! ˲ DO 롼Ѻѿ
   192:                                          ! Work variables for DO loop in latitudinal direction
   193:            
   194:                ! ¹ʸ ; Executable statement
   195:                !
   196:            
   197: V======        y_IntLon_xy = 0.0_DP
   198: V------>       do j = 1, jmax
   199: |+----->         do i = 0, imax - 1
   200: ||                 y_IntLon_xy(j) = y_IntLon_xy(j) + xy_Data (i,j) * x_Lon_Weight(i)
   201: |+-----          end do
   202: V------        end do
   203:            
   204:              end function y_IntLon_xy
   205:            
   206:            
   207:              !-------------------------------------------------------------------
   208:            
   209:              function IntLat_y( y_Data )
   210:                !
   211:                ! 1 ٳʻǡΰʬ(1 ). 
   212:                !
   213:                ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   214:                ! ¤׻Ƥ. 
   215:                !
   216:                ! Meridonal integration of 1-dimensional (latitude)
   217:                ! grid data.
   218:                !
   219:                ! Practically, the sum total of grid data is calculated
   220:                ! by multiplying in each grid "y_Lat_Weight".
   221:                !
   222:                real(DP), intent(in) :: y_Data (1:jmax)
   223:                real(DP)             :: IntLat_y
   224:            
   225:                ! ѿ
   226:                ! Work variables
   227:                !
   228:            
   229:                ! ¹ʸ ; Executable statement
   230:                !
   231: V======        IntLat_y = sum( y_Data * y_Lat_Weight )
   232:            
   233:              end function IntLat_y
   234:            
   235:            
   236:              !-------------------------------------------------------------------
   237:            !!$
   238:            !!$  function AvrLonLat_xy( xy_Data )
   239:            !!$    !
   240:            !!$    ! 2 ٷٳʻǡΰʿ(1 ). 
   241:            !!$    !
   242:            !!$    ! Global mean of 2-dimensional (latitude and longitude)
   243:            !!$    ! grid data.
   244:            !!$    !
   245:            !!$
   246:            !!$    real(DP), intent(in):: xy_Data (0:imax-1, 1:jmax)
   247:            !!$
   248:            !!$
   249:            !!$    ! Local variable
   250:            !!$    !
   251:            !!$    real(DP)              :: AvrLonLat_xy
   252:            !!$
   253:            !!$
   254:            !!$    ! ¹ʸ ; Executable statement
   255:            !!$    !
   256:            !!$
   257:            !!$    ! Old one to be deleted
   258:            !!$!    AvrLonLat_xy = AvrLon_x( x_AvrLat_xy( xy_Data ) )
   259:            !!$
   260:            !!$    AvrLonLat_xy = AvrLat_y( y_AvrLon_xy( xy_Data ) )
   261:            !!$
   262:            !!$
   263:            !!$  end function AvrLonLat_xy
   264:            !!$
   265:            !!$  !-------------------------------------------------------------------
   266:            !!$
   267:            !!$  function x_IntLat_xy( xy_Data )
   268:            !!$    !
   269:            !!$    ! 2 ٷٳʻǡΰʬ(1 ). 
   270:            !!$    !
   271:            !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   272:            !!$    ! ¤׻Ƥ. 
   273:            !!$    !
   274:            !!$    ! Meridional integration of 2-dimensional (latitude and longitude)
   275:            !!$    ! grid data.
   276:            !!$    !
   277:            !!$    ! Practically, the sum total of grid data is calculated
   278:            !!$    ! by multiplying in each grid "y_Lat_Weight".
   279:            !!$    !
   280:            !!$    real(DP), intent(in):: xy_Data (0:imax-1, 1:jmax)
   281:            !!$    real(DP):: x_IntLat_xy (0:imax-1)
   282:            !!$
   283:            !!$    ! ѿ
   284:            !!$    ! Work variables
   285:            !!$    !
   286:            !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   287:            !!$                              ! Work variables for DO loop in latitude
   288:            !!$
   289:            !!$    ! ¹ʸ ; Executable statement
   290:            !!$    !
   291:            !!$    x_IntLat_xy = 0.0_DP
   292:            !!$    do j = 1, jmax
   293:            !!$      x_IntLat_xy = x_IntLat_xy + xy_Data (:,j) * y_Lat_Weight(j)
   294:            !!$    enddo
   295:            !!$  end function x_IntLat_xy
   296:            !!$
   297:            !!$  !-------------------------------------------------------------------
   298:            !!$
   299:            !!$  function xa_IntLat_xya( xya_Data )
   300:            !!$    !
   301:            !!$    ! 3 ٷٳʻǡΰʬ(¿). 
   302:            !!$    !
   303:            !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   304:            !!$    ! ¤׻Ƥ. 
   305:            !!$    !
   306:            !!$    ! Meridional integration of 3-dimensional (latitude and longitude)
   307:            !!$    ! grid data. (for multi layer)
   308:            !!$    !
   309:            !!$    ! Practically, the sum total of grid data is calculated
   310:            !!$    ! by multiplying in each grid "y_Lat_Weight".
   311:            !!$    !
   312:            !!$    real(DP), intent(in):: xya_Data (0:imax-1, 1:jmax, 1:kmax)
   313:            !!$    real(DP):: xa_IntLat_xya (0:imax-1, 1:kmax)
   314:            !!$
   315:            !!$    ! ѿ
   316:            !!$    ! Work variables
   317:            !!$    !
   318:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   319:            !!$                              ! Work variables for DO loop in vertical direction
   320:            !!$
   321:            !!$    ! ¹ʸ ; Executable statement
   322:            !!$    !
   323:            !!$    do k = 1, kmax
   324:            !!$      xa_IntLat_xya(:,k) = x_IntLat_xy( xya_Data(:,:,k) )
   325:            !!$    end do
   326:            !!$  end function xa_IntLat_xya
   327:            !!$
   328:            !!$  !-------------------------------------------------------------------
   329:            !!$
   330:            !!$  function ya_IntLon_xya( xya_Data )
   331:            !!$    !
   332:            !!$    ! 3 ٷٳʻǡηʬ(¿). 
   333:            !!$    !
   334:            !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   335:            !!$    ! ¤׻Ƥ. 
   336:            !!$    !
   337:            !!$    ! Zonal integration of 3-dimensional (latitude and longitude)
   338:            !!$    ! grid data. (for multi layer)
   339:            !!$    !
   340:            !!$    ! Practically, the sum total of grid data is calculated
   341:            !!$    ! by multiplying in each grid "x_Lon_Weight".
   342:            !!$    !
   343:            !!$    real(DP), intent(in):: xya_Data (0:imax-1, 1:jmax, 1:kmax)
   344:            !!$    real(DP):: ya_IntLon_xya (1:jmax,1:kmax)
   345:            !!$
   346:            !!$    ! ѿ
   347:            !!$    ! Work variables
   348:            !!$    !
   349:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   350:            !!$                              ! Work variables for DO loop in vertical direction
   351:            !!$
   352:            !!$    ! ¹ʸ ; Executable statement
   353:            !!$    !
   354:            !!$    do k = 1, kmax
   355:            !!$      ya_IntLon_xya(:,k) = y_IntLon_xy( xya_Data(:,:,k) )
   356:            !!$    end do
   357:            !!$  end function ya_IntLon_xya
   358:            !!$
   359:            !!$  !-------------------------------------------------------------------
   360:            !!$
   361:            !!$  function IntLon_x( x_Data )
   362:            !!$    !
   363:            !!$    ! 1 ٳʻǡηʬ(1 ). 
   364:            !!$    !
   365:            !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   366:            !!$    ! ¤׻Ƥ. 
   367:            !!$    !
   368:            !!$    ! Zonal integration of 1-dimensional (longitude)
   369:            !!$    ! grid data.
   370:            !!$    !
   371:            !!$    ! Practically, the sum total of grid data is calculated
   372:            !!$    ! by multiplying in each grid "x_Lon_Weight".
   373:            !!$    !
   374:            !!$    real(DP), intent(in):: x_Data (0:imax-1)
   375:            !!$    real(DP):: IntLon_x
   376:            !!$
   377:            !!$    ! ѿ
   378:            !!$    ! Work variables
   379:            !!$    !
   380:            !!$
   381:            !!$    ! ¹ʸ ; Executable statement
   382:            !!$    !
   383:            !!$    IntLon_x = sum( x_Data * x_Lon_Weight )
   384:            !!$  end function IntLon_x
   385:            !!$
   386:            !!$  !-------------------------------------------------------------------
   387:            !!$
   388:            !!$  function x_AvrLat_xy( xy_Data )
   389:            !!$    !
   390:            !!$    ! 2 ٷٳʻǡΰʿ(1 ). 
   391:            !!$    !
   392:            !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   393:            !!$    ! ¤׻, y_Lat_Weight ¤ǳ뤳Ȥ
   394:            !!$    ! ʿѤƤ. 
   395:            !!$    !
   396:            !!$    ! Meridional mean of 2-dimensional (latitude and longitude)
   397:            !!$    ! grid data.
   398:            !!$    !
   399:            !!$    ! Practically, the mean grid data is calculated
   400:            !!$    ! by multiplying in each grid "y_Lat_Weight" 
   401:            !!$    ! and deviding by the sum total of "y_Lat_Weight".
   402:            !!$    !
   403:            !!$    real(DP), intent(in):: xy_Data (0:imax-1, 1:jmax)
   404:            !!$    real(DP):: x_AvrLat_xy (0:imax-1)
   405:            !!$
   406:            !!$    ! ѿ
   407:            !!$    ! Work variables
   408:            !!$    !
   409:            !!$
   410:            !!$    ! ¹ʸ ; Executable statement
   411:            !!$    !
   412:            !!$    x_AvrLat_xy = x_IntLat_xy ( xy_Data ) / sum( y_Lat_Weight )
   413:            !!$  end function x_AvrLat_xy
   414:            !!$
   415:            !!$  !-------------------------------------------------------------------
   416:            !!$
   417:            !!$  function xa_AvrLat_xya( xya_Data )
   418:            !!$    !
   419:            !!$    ! 3 ٷٳʻǡΰʿ(¿). 
   420:            !!$    !
   421:            !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   422:            !!$    ! ¤׻, y_Lat_Weight ¤ǳ뤳Ȥ
   423:            !!$    ! ʿѤƤ. 
   424:            !!$    !
   425:            !!$    ! Meridional mean of 3-dimensional (latitude and longitude)
   426:            !!$    ! grid data. (for multi layer)
   427:            !!$    !
   428:            !!$    ! Practically, the mean grid data is calculated
   429:            !!$    ! by multiplying in each grid "y_Lat_Weight" 
   430:            !!$    ! and deviding by the sum total of "y_Lat_Weight".
   431:            !!$    !
   432:            !!$    real(DP), intent(in):: xya_Data (0:imax-1, 1:jmax, 1:kmax)
   433:            !!$    real(DP):: xa_AvrLat_xya (0:imax-1, 1:kmax)
   434:            !!$
   435:            !!$    ! ѿ
   436:            !!$    ! Work variables
   437:            !!$    !
   438:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   439:            !!$                              ! Work variables for DO loop in vertical direction
   440:            !!$
   441:            !!$    ! ¹ʸ ; Executable statement
   442:            !!$    !
   443:            !!$    do k = 1, kmax
   444:            !!$      xa_AvrLat_xya(:,k) = x_AvrLat_xy( xya_Data(:,:,k) )
   445:            !!$    end do
   446:            !!$  end function xa_AvrLat_xya
   447:            !!$
   448:            !!$  !-------------------------------------------------------------------
   449:            !!$
   450:            !!$  function y_AvrLon_xy( xy_Data )
   451:            !!$    !
   452:            !!$    ! 2 ٷٳʻǡηʿ(1 ). 
   453:            !!$    !
   454:            !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   455:            !!$    ! ¤׻, x_Lon_Weight ¤ǳ뤳Ȥ
   456:            !!$    ! ʿѤƤ. 
   457:            !!$    !
   458:            !!$    ! Zonal mean of 2-dimensional (latitude and longitude)
   459:            !!$    ! grid data.
   460:            !!$    !
   461:            !!$    ! Practically, the mean grid data is calculated
   462:            !!$    ! by multiplying in each grid "x_Lon_Weight" 
   463:            !!$    ! and deviding by the sum total of "x_Lon_Weight".
   464:            !!$    !
   465:            !!$    real(DP), intent(in):: xy_Data (0:imax-1, 1:jmax)
   466:            !!$    real(DP):: y_AvrLon_xy (1:jmax)
   467:            !!$
   468:            !!$    ! ѿ
   469:            !!$    ! Work variables
   470:            !!$    !
   471:            !!$
   472:            !!$    ! ¹ʸ ; Executable statement
   473:            !!$    !
   474:            !!$    y_AvrLon_xy = y_IntLon_xy( xy_Data ) / sum( x_Lon_Weight )
   475:            !!$  end function y_AvrLon_xy
   476:            !!$
   477:            !!$  !-------------------------------------------------------------------
   478:            !!$
   479:            !!$  function ya_AvrLon_xya( xya_Data )
   480:            !!$    !
   481:            !!$    ! 3 ٷٳʻǡηʿ(¿). 
   482:            !!$    !
   483:            !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   484:            !!$    ! ¤׻, x_Lon_Weight ¤ǳ뤳Ȥ
   485:            !!$    ! ʿѤƤ. 
   486:            !!$    !
   487:            !!$    ! Zonal mean of 3-dimensional (latitude and longitude)
   488:            !!$    ! grid data. (for multi layer)
   489:            !!$    !
   490:            !!$    ! Practically, the mean grid data is calculated
   491:            !!$    ! by multiplying in each grid "x_Lon_Weight" 
   492:            !!$    ! and deviding by the sum total of "x_Lon_Weight".
   493:            !!$    !
   494:            !!$    real(DP), intent(in):: xya_Data (0:imax-1, 1:jmax, 1:kmax)
   495:            !!$    real(DP):: ya_AvrLon_xya (1:jmax, 1:kmax)
   496:            !!$
   497:            !!$    ! ѿ
   498:            !!$    ! Work variables
   499:            !!$    !
   500:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   501:            !!$                              ! Work variables for DO loop in vertical direction
   502:            !!$
   503:            !!$    ! ¹ʸ ; Executable statement
   504:            !!$    !
   505:            !!$    do k = 1, kmax
   506:            !!$      ya_AvrLon_xya(:,k) = y_AvrLon_xy( xya_Data(:,:,k) )
   507:            !!$    end do
   508:            !!$  end function ya_AvrLon_xya
   509:            !!$
   510:            !!$#ifdef LIB_MPI
   511:            !!$  !-------------------------------------------------------------------
   512:            !!$
   513:            !!$  function AvrLat_y( y_Data )
   514:            !!$    !
   515:            !!$    ! 1 ٳʻǡΰʿ(1 ). 
   516:            !!$    !
   517:            !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   518:            !!$    ! ¤׻, y_Lat_Weight ¤ǳ뤳Ȥ
   519:            !!$    ! ʿѤƤ. 
   520:            !!$    !
   521:            !!$    ! Meridonal mean of 1-dimensional (latitude)
   522:            !!$    ! grid data.
   523:            !!$    !
   524:            !!$    ! Practically, the sum total of grid data is calculated
   525:            !!$    ! by multiplying in each grid "y_Lat_Weight" 
   526:            !!$    ! and deviding by the sum total of "y_Lat_Weight".
   527:            !!$    !
   528:            !!$
   529:            !!$    ! MPI
   530:            !!$    !
   531:            !!$    use mpi_wrapper, only: nprocs, myrank, &
   532:            !!$      & MPIWrapperISend, &
   533:            !!$      & MPIWrapperIRecv, &
   534:            !!$      & MPIWrapperWait
   535:            !!$
   536:            !!$    ! ʻȿ
   537:            !!$    ! Number of grid points and maximum truncated wavenumber settings
   538:            !!$    !
   539:            !!$    use gridset, only: a_jmax, jmax_max
   540:            !!$
   541:            !!$    real(DP), intent(in):: y_Data (1:jmax)
   542:            !!$    real(DP):: AvrLat_y
   543:            !!$
   544:            !!$    ! ѿ
   545:            !!$    ! Work variables
   546:            !!$    !
   547:            !!$
   548:            !!$    ! ¹ʸ ; Executable statement
   549:            !!$    !
   550:            !!$
   551:            !!$    real(DP), allocatable :: a_SendBuf (:)
   552:            !!$    real(DP), allocatable :: aa_RecvBuf(:,:)
   553:            !!$    integer , allocatable :: a_iReqSend(:)
   554:            !!$    integer , allocatable :: a_iReqRecv(:)
   555:            !!$
   556:            !!$    real(DP)              :: SumWeight
   557:            !!$
   558:            !!$    integer               :: j
   559:            !!$    integer               :: n
   560:            !!$
   561:            !!$    allocate( a_SendBuf (1:jmax_max) )
   562:            !!$    allocate( aa_RecvBuf(1:jmax_max,0:nprocs-1) )
   563:            !!$    allocate( a_iReqSend(0:nprocs-1) )
   564:            !!$    allocate( a_iReqRecv(0:nprocs-1) )
   565:            !!$
   566:            !!$    do j = 1, jmax
   567:            !!$      a_SendBuf(j) = y_Lat_Weight(j)
   568:            !!$    end do
   569:            !!$    do j = jmax+1, jmax_max
   570:            !!$      a_SendBuf(j) = -1.0d0
   571:            !!$    end do
   572:            !!$
   573:            !!$    do n = 0, nprocs-1
   574:            !!$      if ( n == myrank ) then
   575:            !!$        do j = 1, jmax
   576:            !!$          aa_RecvBuf(:,n) = a_SendBuf
   577:            !!$        end do
   578:            !!$      else
   579:            !!$        call MPIWrapperISend( n, jmax_max, a_SendBuf      , a_iReqSend(n) )
   580:            !!$        call MPIWrapperIRecv( n, jmax_max, aa_RecvBuf(:,n), a_iReqRecv(n) )
   581:            !!$      end if
   582:            !!$    end do
   583:            !!$    do n = 0, nprocs-1
   584:            !!$      if ( n == myrank ) cycle
   585:            !!$      call MPIWrapperWait( a_iReqSend(n) )
   586:            !!$      call MPIWrapperWait( a_iReqRecv(n) )
   587:            !!$    end do
   588:            !!$
   589:            !!$
   590:            !!$    if ( nprocs == 1 ) then
   591:            !!$      SumWeight = 0.0d0
   592:            !!$      do n = 0, nprocs-1
   593:            !!$        do j = 1, a_jmax(n)
   594:            !!$          SumWeight = SumWeight + aa_RecvBuf(j,n)
   595:            !!$        end do
   596:            !!$      end do
   597:            !!$    else
   598:            !!$
   599:            !!$      write( 6, * ) 'THIS WOULD BE WRONG.'
   600:            !!$
   601:            !!$      SumWeight = 0.0d0
   602:            !!$      do n = nprocs-1, 0, -1
   603:            !!$        do j = a_jmax(n), a_jmax(n) / 2 + 1, -1
   604:            !!$          SumWeight = SumWeight + aa_RecvBuf(j,n)
   605:            !!$        end do
   606:            !!$      end do
   607:            !!$      do n = 0, nprocs-1
   608:            !!$        do j = 1, a_jmax(n) / 2
   609:            !!$          SumWeight = SumWeight + aa_RecvBuf(j,n)
   610:            !!$        end do
   611:            !!$      end do
   612:            !!$    end if
   613:            !!$
   614:            !!$    deallocate( a_SendBuf  )
   615:            !!$    deallocate( aa_RecvBuf )
   616:            !!$    deallocate( a_iReqSend )
   617:            !!$    deallocate( a_iReqRecv )
   618:            !!$
   619:            !!$
   620:            !!$    AvrLat_y = IntLat_y( y_Data ) / SumWeight
   621:            !!$
   622:            !!$  end function AvrLat_y
   623:            !!$
   624:            !!$#else
   625:            !!$  !-------------------------------------------------------------------
   626:            !!$
   627:            !!$  function AvrLat_y( y_Data )
   628:            !!$    !
   629:            !!$    ! 1 ٳʻǡΰʿ(1 ). 
   630:            !!$    !
   631:            !!$    ! ºݤˤϳʻǡ y_Lat_Weight ݤ
   632:            !!$    ! ¤׻, y_Lat_Weight ¤ǳ뤳Ȥ
   633:            !!$    ! ʿѤƤ. 
   634:            !!$    !
   635:            !!$    ! Meridonal mean of 1-dimensional (latitude)
   636:            !!$    ! grid data.
   637:            !!$    !
   638:            !!$    ! Practically, the sum total of grid data is calculated
   639:            !!$    ! by multiplying in each grid "y_Lat_Weight" 
   640:            !!$    ! and deviding by the sum total of "y_Lat_Weight".
   641:            !!$    !
   642:            !!$    real(DP), intent(in):: y_Data (1:jmax)
   643:            !!$    real(DP):: AvrLat_y
   644:            !!$
   645:            !!$    ! ѿ
   646:            !!$    ! Work variables
   647:            !!$    !
   648:            !!$
   649:            !!$    ! ¹ʸ ; Executable statement
   650:            !!$    !
   651:            !!$
   652:            !!$    AvrLat_y = IntLat_y( y_Data ) / sum( y_Lat_Weight )
   653:            !!$
   654:            !!$  end function AvrLat_y
   655:            !!$
   656:            !!$#endif
   657:            !!$  !-------------------------------------------------------------------
   658:            !!$
   659:            !!$  function AvrLon_x( x_Data )
   660:            !!$    !
   661:            !!$    ! 1 ٳʻǡηʿ(1 ). 
   662:            !!$    !
   663:            !!$    ! ºݤˤϳʻǡ x_Lon_Weight ݤ
   664:            !!$    ! ¤׻, x_Lon_Weight ¤ǳ뤳Ȥ
   665:            !!$    ! ʿѤƤ. 
   666:            !!$    !
   667:            !!$    ! Zonal mean of 1-dimensional (longitude)
   668:            !!$    ! grid data.
   669:            !!$    !
   670:            !!$    ! Practically, the sum total of grid data is calculated
   671:            !!$    ! by multiplying in each grid "x_Lon_Weight" 
   672:            !!$    ! and deviding by the sum total of "x_Lon_Weight".
   673:            !!$    !
   674:            !!$    real(DP), intent(in):: x_Data (0:imax-1)
   675:            !!$    real(DP):: AvrLon_x
   676:            !!$
   677:            !!$    ! ѿ
   678:            !!$    ! Work variables
   679:            !!$    !
   680:            !!$
   681:            !!$    ! ¹ʸ ; Executable statement
   682:            !!$    !
   683:            !!$    AvrLon_x = IntLon_x( x_Data ) / sum( x_Lon_Weight )
   684:            !!$  end function AvrLon_x
   685:            !!$
   686:            
   687:              !--------------------------------------------------------------------------------------
   688:            
   689:              subroutine IntAvrOprInit
   690:                !
   691:                ! intavr_operate ⥸塼νԤޤ. 
   692:                ! NAMELIST#intavr_operate_nml ɤ߹ߤϤμ³ǹԤޤ. 
   693:                !
   694:                ! "intavr_operate" module is initialized. 
   695:                ! "NAMELIST#intavr_operate_nml" is loaded in this procedure. 
   696:                !
   697:            
   698:                ! ⥸塼 ; USE statements
   699:                !
   700:            
   701:                ! ʸ ; Declaration statements
   702:                !
   703:            
   704:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   705:            !!$                              ! Unit number for NAMELIST file open
   706:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   707:            !!$                              ! IOSTAT of NAMELIST read
   708:            
   709:                ! NAMELIST ѿ
   710:                ! NAMELIST group name
   711:                !
   712:            !!$    namelist /intavr_operate_nml/
   713:                      !
   714:                      ! ǥեͤˤĤƤϽ³ "intavr_operate#IntAvrOprInit" 
   715:                      ! Υɤ򻲾ȤΤ. 
   716:                      !
   717:                      ! Refer to source codes in the initialization procedure
   718:                      ! "intavr_operate#IntAvrOprInit" for the default values. 
   719:                      !
   720:            
   721:                ! ¹ʸ ; Executable statement
   722:                !
   723:            
   724:                if ( intavr_operate_inited ) return
   725:            
   726:            
   727:                ! ǥեͤ
   728:                ! Default values settings
   729:                !
   730:            
   731:            !!$    ! NAMELIST ɤ߹
   732:            !!$    ! NAMELIST is input
   733:            !!$    !
   734:            !!$    if ( trim(namelist_filename) /= '' ) then
   735:            !!$      call FileOpen( unit_nml, &          ! (out)
   736:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   737:            !!$
   738:            !!$      rewind( unit_nml )
   739:            !!$      read( unit_nml, &           ! (in)
   740:            !!$        & nml = intavr_operate_nml, &  ! (out)
   741:            !!$        & iostat = iostat_nml )   ! (out)
   742:            !!$      close( unit_nml )
   743:            !!$
   744:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   745:            !!$    end if
   746:            
   747:                !  ; Print
   748:                !
   749:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   750:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   751:                intavr_operate_inited = .true.
   752:              end subroutine IntAvrOprInit
   753:            
   754:              !--------------------------------------------------------------------------------------
   755:            
   756:            end module intavr_operate
