Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:22 2012
FILE NAME: vertical_filter.f90
PROGRAM NAME: vertical_filter
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   243  vec  (   3): Unvectorized loop.
   243  vec  (  13): Overhead of loop division is too large.
   244  opt  (1592): Outer loop unrolled inside inner loop.
   244  vec  (   4): Vectorized array expression.
   244  vec  (   4): Vectorized array expression.
   247  vec  (   3): Unvectorized loop.
   247  vec  (  13): Overhead of loop division is too large.
   248  opt  (1036): Potential feedback - use directive if OK.
   248  opt  (1592): Outer loop unrolled inside inner loop.
   248  vec  (   4): Vectorized array expression.
   248  vec  (   4): Vectorized array expression.
   250  opt  (1772): Loop nest fused with following nest(s).
   250  opt  (1036): Potential feedback - use directive if OK.
   250  opt  (1592): Outer loop unrolled inside inner loop.
   250  vec  (   4): Vectorized array expression.
   250  vec  (   4): Vectorized array expression.
   254  opt  (1592): Outer loop unrolled inside inner loop.
   254  vec  (   4): Vectorized array expression.
   254  vec  (   4): Vectorized array expression.
   256  opt  (1772): Loop nest fused with following nest(s).
   256  opt  (1037): Feedback of array elements.
   256  opt  (1592): Outer loop unrolled inside inner loop.
   256  vec  (   4): Vectorized array expression.
   256  vec  (   4): Vectorized array expression.
   266  warn (  82): Name "i" is not used.
   266  warn (  82): Name "j" is not used.
   266  warn (  83): Dummy argument "xyz_ua" is not used.
   266  warn (  83): Dummy argument "xyz_va" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:22 2012
FILE NAME: vertical_filter.f90
PROGRAM NAME: vertical_filter
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ľե륿 (Ishiwatari et al., 2002)
     2  !
     3  != Vertical filter (Ishiwatari et al., 2002)
     4  !
     5  ! Authors::   Satoshi Noda, Yoshiyuki O. Takahashi
     6  ! Version::   $Id: vertical_filter.f90,v 1.2 2011-06-19 10:56:28 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2010. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module vertical_filter
    13    !
    14    != ľե륿 (Ishiwatari et al., 2002)
    15    !
    16    != Vertical filter (Ishiwatari et al., 2002)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ľ⡼ɤޤ뤿αľե륿 (Ishiwatari et al., 2002)
    21    ! ŬѤ뤿Υ⥸塼Ǥ.
    22    !
    23    ! ʤ
    24    ! \begin{align}
    25    !   T_{B,k} &\equiv \frac{T_{k+1/2} + T_{k-1/2}}{2} \\
    26    ! \end{align}
    27    ! ,
    28    ! \begin{align}
    29    !   \bar{T}_{k-1} &= T_{k-1} + F_T
    30    !     ( T_{B, k-1} - T_{k-1} )
    31    !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}, \\
    32    !   \bar{T}_{k} &= T_{k} + F_T
    33    !     ( T_{B, k} - T_{k} )
    34    !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}, \\
    35    !   \bar{T}_{k+1} &= T_{k+1} + F_T
    36    !     ( T_{B, k+1} - T_{k+1} )
    37    !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}
    38    ! \end{align}
    39    ! Ȥ򲼤ؤŬѤ뤳Ȥ $ \bar{T} $ ޤ.
    40    ! ź $ k $ ؤֹǤ.
    41    ! ľե륿ŬѤ줿ˤϾ ( $ \bar{\quad} $ )
    42    ! դƤޤ.
    43    !
    44    ! ľե륿η $F_T$  Create κݤꤷޤ.
    45    !
    46    !++
    47    !
    48    ! Vertical filter (Ishiwatari et al., 2002) for suppression of vertical mode
    49    ! is applied.
    50    !
    51    ! Concretely, $ \bar{A}^{t} $ is derived as follows.
    52    ! Reference Temperature is defined as
    53    ! \begin{align}
    54    !   T_{B,k} &\equiv \frac{T_{k+1/2} + T_{k-1/2}}{2}.
    55    ! \end{align}
    56    ! Operations as follows are applied from lower layer to higher layer.
    57    ! \begin{align}
    58    !   \bar{T}_{k-1} &= T_{k-1} + F_T
    59    !     ( T_{B, k-1} - T_{k-1} )
    60    !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}, \\
    61    !   \bar{T}_{k} &= T_{k} + F_T
    62    !     ( T_{B, k} - T_{k} )
    63    !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}, \\
    64    !   \bar{T}_{k+1} &= T_{k+1} + F_T
    65    !     ( T_{B, k+1} - T_{k+1} )
    66    !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}
    67    ! \end{align}
    68    ! where a suffix $ k $ is the number of layer.
    69    ! Over-bar ( $ \bar{\quad} $ ) represents the terms
    70    ! applied vertical filter.
    71    !
    72    ! Vertical filter coefficient $ F_T $ is specified by "Create".
    73    !
    74    !== Procedures List
    75    !
    76    ! VerticalFilter    :: ľե륿Ŭ
    77    ! ----------------  :: ---------------------
    78    ! VerticalFilter    :: Apply vertical filter
    79    !
    80    !== NAMELIST
    81    !
    82    ! NAMELIST#vertical_filter_nml
    83    !
    84    !== References
    85    !
    86    ! * Ishiwatari, M., Takehiro S., Nakajima, K. and Hayashi, Y. -Y. 2002:
    87    !   A Numerical Study on Appearance of the Runaway Greenhouse State of a
    88    !   Three-Dimensional Gray Atmosphere.
    89    !   <i>J. Atmos. Sci.</i>, <b>59</b>, 3223--3238.
    90    !
    91  
    92    ! ⥸塼 ; USE statements
    93    !
    94  
    95    ! ʻ
    96    ! Grid points settings
    97    !
    98    use gridset, only: imax, & ! ٳʻ.
    99                               ! Number of grid points in longitude
   100      &                jmax, & ! ٳʻ.
   101                               ! Number of grid points in latitude
   102      &                kmax    ! ľؿ.
   103                               ! Number of vertical level
   104  
   105    use composition, only: ncmax  ! ʬο
   106                                  ! Number of composition
   107  
   108    ! ̷ѥ᥿
   109    ! Kind type parameter
   110    !
   111    use dc_types, only: DP, &      ! ټ¿. Double precision.
   112      &                 STRING     ! ʸ.       Strings.
   113  
   114  
   115    ! å
   116    ! Message output
   117    !
   118    use dc_message, only: MessageNotify
   119  
   120    ! ʸ ; Declaration statements
   121    !
   122    implicit none
   123    private
   124  
   125    ! ³
   126    ! Public procedure
   127    !
   128    public:: VerticalFilter
   129  
   130    ! ѿ
   131    ! Public variables
   132    !
   133    logical, save, public:: vertical_filter_inited = .false.
   134                                ! ե饰.
   135                                ! Initialization flag
   136  
   137    ! ѿ
   138    ! Private variables
   139    !
   140    real(DP), save:: FilterParameter
   141                                ! ľե륿η.
   142                                ! Vertical filter coefficient
   143  !!$  integer, save:: IntStep     ! ľե륿ŬѤ륹ƥå״ֳ.
   144  !!$                              ! Step interval of vertical filter application
   145  !!$  integer, save:: CurStep     ! VerticalFilter ƤФ줿.
   146  !!$                              ! Number of times that "VerticalFilter" is called
   147  !!$  integer, save:: PrevStep    ! ľե륿ŬѤƥå׿.
   148  !!$                              ! Step number that is filtered previously
   149  
   150    character(*), parameter:: module_name = 'vertical_filter'
   151                                ! ⥸塼̾.
   152                                ! Module name
   153    character(*), parameter:: version = &
   154      & '$Name: dcpam5-20120921 $' // &
   155      & '$Id: vertical_filter.f90,v 1.2 2011-06-19 10:56:28 yot Exp $'
   156                                ! ⥸塼ΥС
   157                                ! Module version
   158  
   159  contains
   160  
   161    !--------------------------------------------------------------------------------------
   162  
   163    subroutine VerticalFilter( &
   164      & xyz_UA, xyz_VA, xyz_TempA, &
   165      & xyr_Press, xyr_Temp &
   166      & )
   167      !
   168      ! ͽѿ˱ľե륿ŬѤޤ.
   169      !
   170      ! Vertical filter is applied to predictional variables.
   171      !
   172  
   173      ! ⥸塼 ; USE statements
   174      !
   175  
   176      ! 
   177      ! Time control
   178      !
   179      use timeset, only: &
   180        & TimesetClockStart, TimesetClockStop
   181  
   182      ! ʸ ; Declaration statements
   183      !
   184      implicit none
   185  
   186      real(DP), intent(inout):: xyz_UA (0:imax-1, 1:jmax, 1:kmax)
   187                                ! $ u (t+\Delta t) $ .   ®. Eastward wind
   188      real(DP), intent(inout):: xyz_VA (0:imax-1, 1:jmax, 1:kmax)
   189                                ! $ v (t+\Delta t) $ .   ®. Northward wind
   190      real(DP), intent(inout):: xyz_TempA (0:imax-1, 1:jmax, 1:kmax)
   191                                ! $ T (t+\Delta t) $ .   . Temperature
   192  
   193      real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   194                                ! $ p_{1/2} (t+\Delta t) $ .   . Pressure
   195      real(DP), intent(in):: xyr_Temp (0:imax-1, 1:jmax, 0:kmax)
   196                                ! $ T_{1/2} (t+\Delta t) $ .   . Temperature
   197  
   198  
   199      ! ѿ
   200      ! Work variables
   201      !
   202      integer:: i               ! ˲ DO 롼Ѻѿ
   203                                ! Work variables for DO loop in longitude
   204      integer:: j               ! ˲ DO 롼Ѻѿ
   205                                ! Work variables for DO loop in latitude
   206      integer:: k               ! ľ˲ DO 롼Ѻѿ
   207                                ! Work variables for DO loop in vertical direction
   208      integer:: k1              ! ľ˲ DO 롼Ѻѿ
   209                                ! Work variables for DO loop in vertical direction
   210  
   211      real(DP):: Temp_ref(0:imax-1, 1:jmax, 1:kmax), &
   212        & Temp_corr(0:imax-1, 1:jmax)
   213  
   214      ! ¹ʸ ; Executable statement
   215      !
   216  
   217      ! ׻ַ¬
   218      ! Start measurement of computation time
   219      !
   220      call TimesetClockStart( module_name )
   221  
   222      ! 
   223      ! Initialization
   224      !
   225      if ( .not. vertical_filter_inited ) call VerticalFilterInit
   226  
   227  !!$    ! ƥåפΥå
   228  !!$    ! Check Step
   229  !!$    !
   230  !!$    CurStep = CurStep + 1
   231  !!$    if ( CurStep - PrevStep < IntStep ) return
   232  !!$    PrevStep = CurStep
   233  
   234      ! FilterParameter ͭΥå
   235      ! Check validity of "FilterParameter"
   236      !
   237      if ( FilterParameter == 0.0_DP ) return
   238  
   239      ! ľե륿Ŭ
   240      ! Apply vertical filter
   241      !
   242  
   243      do k=1,kmax
   244        Temp_ref(:,:,k)  = 0.5_DP * ( xyr_Temp(:,:,k-1) + xyr_Temp(:,:,k) )
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t202 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t204 = 1, imax                                           
     .                 temp_ref(t204-1,t202,k) = 5.00000000000000e-001*(xyr_temp
     .       1            (t204-1,t202,k-1)+xyr_temp(t204-1,t202,k))            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t202 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t204 = 1, imax                                           
     .                 temp_ref(t204-1,t202,k) = 5.00000000000000e-001*(xyr_temp
     .       1            (t204-1,t202,k-1)+xyr_temp(t204-1,t202,k))            
     .                 temp_ref(t204-1,t202+1,k) = 5.00000000000000e-001*(      
     .       1            xyr_temp(t204-1,t202+1,k-1)+xyr_temp(t204-1,t202+1,k))
     .                 temp_ref(t204-1,t202+2,k) = 5.00000000000000e-001*(      
     .       1            xyr_temp(t204-1,t202+2,k-1)+xyr_temp(t204-1,t202+2,k))
     .                 temp_ref(t204-1,t202+3,k) = 5.00000000000000e-001*(      
     .       1            xyr_temp(t204-1,t202+3,k-1)+xyr_temp(t204-1,t202+3,k))
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   245      end do
   246  
   247      do k=2,kmax-1
   248        Temp_corr = 0.0_DP
     .        if (temp_corr.DSC.U2 .gt. 0) then                                 
     .           J2 = and(temp_corr.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t212 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t214 = 1, temp_corr.DSC.U1 + 1                           
     .                 temp_corr(t214-1,t212) = 0.0000000000000000e+000         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t212 = J2 + 1, temp_corr.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t214 = 1, temp_corr.DSC.U1 + 1                           
     .                 temp_corr(t214-1,t212) = 0.0000000000000000e+000         
     .                 temp_corr(t214-1,t212+1) = 0.0000000000000000e+000       
     .                 temp_corr(t214-1,t212+2) = 0.0000000000000000e+000       
     .                 temp_corr(t214-1,t212+3) = 0.0000000000000000e+000       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   249        do k1=-1,1
   250          Temp_corr = Temp_corr + FilterParameter &
   251            & * ( Temp_ref(:,:,k+k1) - xyz_TempA(:,:,k+k1) ) &
   252            & * ( xyr_Press(:,:,k+k1-1) - xyr_Press(:,:,k+k1) )
   253        end do
     .        if (temp_corr.DSC.U2 .gt. 0) then                                 
     .           J3 = and(temp_corr.DSC.U2,1)                                   
     .  !CDIR    NODEP                                                          
     .           do t218 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t220 = 1, temp_corr.DSC.U1 + 1                           
     .                 temp_corr1 = temp_corr(t220-1,t218)                      
     .                 temp_corr1 = temp_corr1 + filterparameter*(temp_ref(t220-
     .       1            1,t218,k-1)-xyz_tempa(t220-1,t218,k-1))*(xyr_press(   
     .       2            t220-1,t218,k-2)-xyr_press(t220-1,t218,k-1))          
     .                 temp_corr1 = temp_corr1 + filterparameter*(temp_ref(t220-
     .       1            1,t218,k)-xyz_tempa(t220-1,t218,k))*(xyr_press(t220-1,
     .       2            t218,k-1)-xyr_press(t220-1,t218,k))                   
     .                 temp_corr(t220-1,t218) = temp_corr1 + filterparameter*(  
     .       1            temp_ref(t220-1,t218,k+1)-xyz_tempa(t220-1,t218,k+1))*
     .       2            (xyr_press(t220-1,t218,k)-xyr_press(t220-1,t218,k+1)) 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t218 = J3 + 1, temp_corr.DSC.U2, 2                          
     .  !CDIR       NODEP                                                       
     .              do t220 = 1, temp_corr.DSC.U1 + 1                           
     .                 temp_corr(t220-1,t218) = temp_corr(t220-1,t218) +        
     .       1            filterparameter*(temp_ref(t220-1,t218,k-1)-xyz_tempa( 
     .       2            t220-1,t218,k-1))*(xyr_press(t220-1,t218,k-2)-        
     .       3            xyr_press(t220-1,t218,k-1))                           
     .                 temp_corr(t220-1,t218+1) = temp_corr(t220-1,t218+1) +    
     .       1            filterparameter*(temp_ref(t220-1,t218+1,k-1)-xyz_tempa
     .       2            (t220-1,t218+1,k-1))*(xyr_press(t220-1,t218+1,k-2)-   
     .       3            xyr_press(t220-1,t218+1,k-1))                         
     .                 temp_corr(t220-1,t218) = temp_corr(t220-1,t218) +        
     .       1            filterparameter*(temp_ref(t220-1,t218,k)-xyz_tempa(   
     .       2            t220-1,t218,k))*(xyr_press(t220-1,t218,k-1)-xyr_press(
     .       3            t220-1,t218,k))                                       
     .                 temp_corr(t220-1,t218+1) = temp_corr(t220-1,t218+1) +    
     .       1            filterparameter*(temp_ref(t220-1,t218+1,k)-xyz_tempa( 
     .       2            t220-1,t218+1,k))*(xyr_press(t220-1,t218+1,k-1)-      
     .       3            xyr_press(t220-1,t218+1,k))                           
     .                 temp_corr(t220-1,t218) = temp_corr(t220-1,t218) +        
     .       1            filterparameter*(temp_ref(t220-1,t218,k+1)-xyz_tempa( 
     .       2            t220-1,t218,k+1))*(xyr_press(t220-1,t218,k)-xyr_press(
     .       3            t220-1,t218,k+1))                                     
     .                 temp_corr(t220-1,t218+1) = temp_corr(t220-1,t218+1) +    
     .       1            filterparameter*(temp_ref(t220-1,t218+1,k+1)-xyz_tempa
     .       2            (t220-1,t218+1,k+1))*(xyr_press(t220-1,t218+1,k)-     
     .       3            xyr_press(t220-1,t218+1,k+1))                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   254        Temp_corr = Temp_corr / ( xyr_Press(:,:,k-2) - xyr_Press(:,:,k+1) )
     .        if (temp_corr.DSC.U2 .gt. 0) then                                 
     .           J4 = and(temp_corr.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t234 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t236 = 1, temp_corr.DSC.U1 + 1                           
     .                 temp_corr(t236-1,t234) = temp_corr(t236-1,t234)/(        
     .       1            xyr_press(t236-1,t234,k-2)-xyr_press(t236-1,t234,k+1))
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t234 = J4 + 1, temp_corr.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t236 = 1, temp_corr.DSC.U1 + 1                           
     .                 temp_corr(t236-1,t234) = temp_corr(t236-1,t234)/(        
     .       1            xyr_press(t236-1,t234,k-2)-xyr_press(t236-1,t234,k+1))
     .                 temp_corr(t236-1,t234+1) = temp_corr(t236-1,t234+1)/(    
     .       1            xyr_press(t236-1,t234+1,k-2)-xyr_press(t236-1,t234+1,k
     .       2            +1))                                                  
     .                 temp_corr(t236-1,t234+2) = temp_corr(t236-1,t234+2)/(    
     .       1            xyr_press(t236-1,t234+2,k-2)-xyr_press(t236-1,t234+2,k
     .       2            +1))                                                  
     .                 temp_corr(t236-1,t234+3) = temp_corr(t236-1,t234+3)/(    
     .       1            xyr_press(t236-1,t234+3,k-2)-xyr_press(t236-1,t234+3,k
     .       2            +1))                                                  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   255        do k1=-1,1
   256          xyz_TempA(:,:,k+k1) = xyz_TempA(:,:,k+k1) &
   257            & + FilterParameter * ( Temp_ref(:,:,k+k1) - xyz_TempA(:,:,k+k1) ) - Temp_corr
   258        end do
     .        if (jmax .gt. 0) then                                             
     .           J5 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t246 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t248 = 1, imax                                           
     .                 xyz_tempa(t248-1,t246,k-1) = xyz_tempa(t248-1,t246,k-1)  
     .       1             + filterparameter*(temp_ref(t248-1,t246,k-1)-        
     .       2            xyz_tempa(t248-1,t246,k-1)) - temp_corr(t248-1,t246)  
     .                 xyz_tempa(t248-1,t246,k) = xyz_tempa(t248-1,t246,k) +    
     .       1            filterparameter*(temp_ref(t248-1,t246,k)-xyz_tempa(   
     .       2            t248-1,t246,k)) - temp_corr(t248-1,t246)              
     .                 xyz_tempa(t248-1,t246,k+1) = xyz_tempa(t248-1,t246,k+1)  
     .       1             + filterparameter*(temp_ref(t248-1,t246,k+1)-        
     .       2            xyz_tempa(t248-1,t246,k+1)) - temp_corr(t248-1,t246)  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t246 = J5 + 1, jmax, 2                                      
     .  !CDIR       NODEP                                                       
     .              do t248 = 1, imax                                           
     .                 xyz_tempa(t248-1,t246,k-1) = xyz_tempa(t248-1,t246,k-1)  
     .       1             + filterparameter*(temp_ref(t248-1,t246,k-1)-        
     .       2            xyz_tempa(t248-1,t246,k-1)) - temp_corr(t248-1,t246)  
     .                 xyz_tempa(t248-1,t246+1,k-1) = xyz_tempa(t248-1,t246+1,k-
     .       1            1) + filterparameter*(temp_ref(t248-1,t246+1,k-1)-    
     .       2            xyz_tempa(t248-1,t246+1,k-1)) - temp_corr(t248-1,t246+
     .       3            1)                                                    
     .                 xyz_tempa(t248-1,t246,k) = xyz_tempa(t248-1,t246,k) +    
     .       1            filterparameter*(temp_ref(t248-1,t246,k)-xyz_tempa(   
     .       2            t248-1,t246,k)) - temp_corr(t248-1,t246)              
     .                 xyz_tempa(t248-1,t246+1,k) = xyz_tempa(t248-1,t246+1,k)  
     .       1             + filterparameter*(temp_ref(t248-1,t246+1,k)-        
     .       2            xyz_tempa(t248-1,t246+1,k)) - temp_corr(t248-1,t246+1)
     .                 xyz_tempa(t248-1,t246,k+1) = xyz_tempa(t248-1,t246,k+1)  
     .       1             + filterparameter*(temp_ref(t248-1,t246,k+1)-        
     .       2            xyz_tempa(t248-1,t246,k+1)) - temp_corr(t248-1,t246)  
     .                 xyz_tempa(t248-1,t246+1,k+1) = xyz_tempa(t248-1,t246+1,k+
     .       1            1) + filterparameter*(temp_ref(t248-1,t246+1,k+1)-    
     .       2            xyz_tempa(t248-1,t246+1,k+1)) - temp_corr(t248-1,t246+
     .       3            1)                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   259      end do
   260  
   261      ! ׻ַ¬
   262      ! Pause measurement of computation time
   263      !
   264      call TimesetClockStop( module_name )
   265  
   266    end subroutine VerticalFilter
   267  
   268    !--------------------------------------------------------------------------------------
   269  
   270    subroutine VerticalFilterInit
   271      !
   272      ! vertical_filter ⥸塼νԤޤ.
   273      ! NAMELIST#vertical_filter_nml ɤ߹ߤϤμ³ǹԤޤ.
   274      !
   275      ! "vertical_filter" module is initialized.
   276      ! "NAMELIST#vertical_filter_nml" is loaded in this procedure.
   277      !
   278  
   279      ! ⥸塼 ; USE statements
   280      !
   281  
   282      ! NAMELIST եϤ˴ؤ桼ƥƥ
   283      ! Utilities for NAMELIST file input
   284      !
   285      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   286  
   287      ! ե
   288      ! File I/O support
   289      !
   290      use dc_iounit, only: FileOpen
   291  
   292      ! ̷ѥ᥿
   293      ! Kind type parameter
   294      !
   295      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   296  
   297      ! ʸ ; Declaration statements
   298      !
   299      implicit none
   300  
   301      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   302                                ! Unit number for NAMELIST file open
   303      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   304                                ! IOSTAT of NAMELIST read
   305  
   306      ! NAMELIST ѿ
   307      ! NAMELIST group name
   308      !
   309      namelist /vertical_filter_nml/ &
   310        & FilterParameter   !, IntStep
   311            !
   312            ! ǥեͤˤĤƤϽ³ "vertical_filter#VerticalFilterInit"
   313            ! Υɤ򻲾ȤΤ.
   314            !
   315            ! Refer to source codes in the initialization procedure
   316            ! "vertical_filter#VerticalFilterInit" for the default values.
   317            !
   318  
   319      ! ¹ʸ ; Executable statement
   320      !
   321  
   322      if ( vertical_filter_inited ) return
   323  
   324  
   325      ! ǥեͤ
   326      ! Default values settings
   327      !
   328      FilterParameter = 0.1_DP
   329  !!$    IntStep         = 1
   330  !!$    CurStep         = 0
   331  
   332      ! NAMELIST ɤ߹
   333      ! NAMELIST is input
   334      !
   335      if ( trim(namelist_filename) /= '' ) then
   336        call FileOpen( unit_nml, &          ! (out)
   337          & namelist_filename, mode = 'r' ) ! (in)
   338  
   339        rewind( unit_nml )
   340        read( unit_nml, &                ! (in)
   341          & nml = vertical_filter_nml, &  ! (out)
   342          & iostat = iostat_nml )        ! (out)
   343        close( unit_nml )
   344  
   345        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   346        if ( iostat_nml == 0 ) write( STDOUT, nml = vertical_filter_nml )
   347      end if
   348  
   349  !!$    ! IntStep Υå
   350  !!$    ! Check "IntStep"
   351  !!$    !
   352  !!$    if ( IntStep < 1 ) then
   353  !!$      call MessageNotify( 'E', module_name, &
   354  !!$        & 'IntStep=<%d> must be greater than 0', &
   355  !!$        & i = (/ IntStep /) )
   356  !!$    end if
   357  !!$
   358  !!$    ! PrevStep 
   359  !!$    ! Configure "PrevStep"
   360  !!$    !
   361  !!$    PrevStep = - IntStep
   362  
   363      !  ; Print
   364      !
   365      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   366      call MessageNotify( 'M', module_name, '  FilterParameter = %f', d = (/ FilterParameter /) )
   367  !!$    call MessageNotify( 'M', module_name, '  IntStep         = %d', i = (/ IntStep /) )
   368      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   369  
   370      vertical_filter_inited = .true.
   371  
   372    end subroutine VerticalFilterInit
   373  
   374    !--------------------------------------------------------------------------------------
   375  
   376  end module vertical_filter
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:22 2012
FILE NAME: vertical_filter.f90
PROGRAM NAME: vertical_filter
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ľե륿 (Ishiwatari et al., 2002)
     2:            !
     3:            != Vertical filter (Ishiwatari et al., 2002)
     4:            !
     5:            ! Authors::   Satoshi Noda, Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: vertical_filter.f90,v 1.2 2011-06-19 10:56:28 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2010. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module vertical_filter
    13:              !
    14:              != ľե륿 (Ishiwatari et al., 2002)
    15:              !
    16:              != Vertical filter (Ishiwatari et al., 2002)
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ľ⡼ɤޤ뤿αľե륿 (Ishiwatari et al., 2002)
    21:              ! ŬѤ뤿Υ⥸塼Ǥ.
    22:              !
    23:              ! ʤ
    24:              ! \begin{align}
    25:              !   T_{B,k} &\equiv \frac{T_{k+1/2} + T_{k-1/2}}{2} \\
    26:              ! \end{align}
    27:              ! , 
    28:              ! \begin{align}
    29:              !   \bar{T}_{k-1} &= T_{k-1} + F_T
    30:              !     ( T_{B, k-1} - T_{k-1} )
    31:              !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}, \\
    32:              !   \bar{T}_{k} &= T_{k} + F_T
    33:              !     ( T_{B, k} - T_{k} )
    34:              !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}, \\
    35:              !   \bar{T}_{k+1} &= T_{k+1} + F_T
    36:              !     ( T_{B, k+1} - T_{k+1} )
    37:              !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}
    38:              ! \end{align}
    39:              ! Ȥ򲼤ؤŬѤ뤳Ȥ $ \bar{T} $ ޤ. 
    40:              ! ź $ k $ ؤֹǤ.
    41:              ! ľե륿ŬѤ줿ˤϾ ( $ \bar{\quad} $ )
    42:              ! դƤޤ.
    43:              !
    44:              ! ľե륿η $F_T$  Create κݤꤷޤ.
    45:              !
    46:              !++
    47:              !
    48:              ! Vertical filter (Ishiwatari et al., 2002) for suppression of vertical mode 
    49:              ! is applied.
    50:              !
    51:              ! Concretely, $ \bar{A}^{t} $ is derived as follows.
    52:              ! Reference Temperature is defined as
    53:              ! \begin{align}
    54:              !   T_{B,k} &\equiv \frac{T_{k+1/2} + T_{k-1/2}}{2}.
    55:              ! \end{align}
    56:              ! Operations as follows are applied from lower layer to higher layer.
    57:              ! \begin{align}
    58:              !   \bar{T}_{k-1} &= T_{k-1} + F_T
    59:              !     ( T_{B, k-1} - T_{k-1} )
    60:              !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}, \\
    61:              !   \bar{T}_{k} &= T_{k} + F_T
    62:              !     ( T_{B, k} - T_{k} )
    63:              !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}, \\
    64:              !   \bar{T}_{k+1} &= T_{k+1} + F_T
    65:              !     ( T_{B, k+1} - T_{k+1} )
    66:              !     - \frac{ \Sigma_{k'=k-1}^{k+1} F_T (T_{B,k'} - T_{k'}) \delta p_{k'} }{\Sigma_{k'=k-1}^{k+1}  \delta p_{k'}}
    67:              ! \end{align}
    68:              ! where a suffix $ k $ is the number of layer.
    69:              ! Over-bar ( $ \bar{\quad} $ ) represents the terms
    70:              ! applied vertical filter.
    71:              !
    72:              ! Vertical filter coefficient $ F_T $ is specified by "Create".
    73:              !
    74:              !== Procedures List
    75:              ! 
    76:              ! VerticalFilter    :: ľե륿Ŭ
    77:              ! ----------------  :: ---------------------
    78:              ! VerticalFilter    :: Apply vertical filter
    79:              !
    80:              !== NAMELIST
    81:              !
    82:              ! NAMELIST#vertical_filter_nml
    83:              !
    84:              !== References
    85:              !
    86:              ! * Ishiwatari, M., Takehiro S., Nakajima, K. and Hayashi, Y. -Y. 2002: 
    87:              !   A Numerical Study on Appearance of the Runaway Greenhouse State of a
    88:              !   Three-Dimensional Gray Atmosphere.
    89:              !   <i>J. Atmos. Sci.</i>, <b>59</b>, 3223--3238.
    90:              !
    91:            
    92:              ! ⥸塼 ; USE statements
    93:              !
    94:            
    95:              ! ʻ
    96:              ! Grid points settings
    97:              !
    98:              use gridset, only: imax, & ! ٳʻ. 
    99:                                         ! Number of grid points in longitude
   100:                &                jmax, & ! ٳʻ. 
   101:                                         ! Number of grid points in latitude
   102:                &                kmax    ! ľؿ. 
   103:                                         ! Number of vertical level
   104:            
   105:              use composition, only: ncmax  ! ʬο
   106:                                            ! Number of composition
   107:            
   108:              ! ̷ѥ᥿
   109:              ! Kind type parameter
   110:              !
   111:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
   112:                &                 STRING     ! ʸ.       Strings. 
   113:            
   114:            
   115:              ! å
   116:              ! Message output
   117:              !
   118:              use dc_message, only: MessageNotify
   119:            
   120:              ! ʸ ; Declaration statements
   121:              !
   122:              implicit none
   123:              private
   124:            
   125:              ! ³
   126:              ! Public procedure
   127:              !
   128:              public:: VerticalFilter
   129:            
   130:              ! ѿ
   131:              ! Public variables
   132:              !
   133:              logical, save, public:: vertical_filter_inited = .false.
   134:                                          ! ե饰. 
   135:                                          ! Initialization flag
   136:            
   137:              ! ѿ
   138:              ! Private variables
   139:              !
   140:              real(DP), save:: FilterParameter
   141:                                          ! ľե륿η. 
   142:                                          ! Vertical filter coefficient
   143:            !!$  integer, save:: IntStep     ! ľե륿ŬѤ륹ƥå״ֳ. 
   144:            !!$                              ! Step interval of vertical filter application
   145:            !!$  integer, save:: CurStep     ! VerticalFilter ƤФ줿. 
   146:            !!$                              ! Number of times that "VerticalFilter" is called
   147:            !!$  integer, save:: PrevStep    ! ľե륿ŬѤƥå׿. 
   148:            !!$                              ! Step number that is filtered previously
   149:            
   150:              character(*), parameter:: module_name = 'vertical_filter'
   151:                                          ! ⥸塼̾. 
   152:                                          ! Module name
   153:              character(*), parameter:: version = &
   154:                & '$Name: dcpam5-20120921 $' // &
   155:                & '$Id: vertical_filter.f90,v 1.2 2011-06-19 10:56:28 yot Exp $'
   156:                                          ! ⥸塼ΥС
   157:                                          ! Module version
   158:            
   159:            contains
   160:            
   161:              !--------------------------------------------------------------------------------------
   162:            
   163:              subroutine VerticalFilter( &
   164:                & xyz_UA, xyz_VA, xyz_TempA, &
   165:                & xyr_Press, xyr_Temp &
   166:                & )
   167:                !
   168:                ! ͽѿ˱ľե륿ŬѤޤ. 
   169:                !
   170:                ! Vertical filter is applied to predictional variables.
   171:                !
   172:            
   173:                ! ⥸塼 ; USE statements
   174:                !
   175:            
   176:                ! 
   177:                ! Time control
   178:                !
   179:                use timeset, only: &
   180:                  & TimesetClockStart, TimesetClockStop
   181:            
   182:                ! ʸ ; Declaration statements
   183:                !
   184:                implicit none
   185:            
   186:                real(DP), intent(inout):: xyz_UA (0:imax-1, 1:jmax, 1:kmax)
   187:                                          ! $ u (t+\Delta t) $ .   ®. Eastward wind
   188:                real(DP), intent(inout):: xyz_VA (0:imax-1, 1:jmax, 1:kmax)
   189:                                          ! $ v (t+\Delta t) $ .   ®. Northward wind
   190:                real(DP), intent(inout):: xyz_TempA (0:imax-1, 1:jmax, 1:kmax)
   191:                                          ! $ T (t+\Delta t) $ .   . Temperature
   192:            
   193:                real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   194:                                          ! $ p_{1/2} (t+\Delta t) $ .   . Pressure
   195:                real(DP), intent(in):: xyr_Temp (0:imax-1, 1:jmax, 0:kmax)
   196:                                          ! $ T_{1/2} (t+\Delta t) $ .   . Temperature
   197:            
   198:            
   199:                ! ѿ
   200:                ! Work variables
   201:                !
   202:                integer:: i               ! ˲ DO 롼Ѻѿ
   203:                                          ! Work variables for DO loop in longitude
   204:                integer:: j               ! ˲ DO 롼Ѻѿ
   205:                                          ! Work variables for DO loop in latitude
   206:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   207:                                          ! Work variables for DO loop in vertical direction
   208:                integer:: k1              ! ľ˲ DO 롼Ѻѿ
   209:                                          ! Work variables for DO loop in vertical direction
   210:            
   211:                real(DP):: Temp_ref(0:imax-1, 1:jmax, 1:kmax), &
   212:                  & Temp_corr(0:imax-1, 1:jmax)
   213:            
   214:                ! ¹ʸ ; Executable statement
   215:                !
   216:            
   217:                ! ׻ַ¬
   218:                ! Start measurement of computation time
   219:                !
   220:                call TimesetClockStart( module_name )
   221:            
   222:                ! 
   223:                ! Initialization
   224:                !
   225:                if ( .not. vertical_filter_inited ) call VerticalFilterInit
   226:            
   227:            !!$    ! ƥåפΥå
   228:            !!$    ! Check Step
   229:            !!$    !
   230:            !!$    CurStep = CurStep + 1
   231:            !!$    if ( CurStep - PrevStep < IntStep ) return
   232:            !!$    PrevStep = CurStep
   233:            
   234:                ! FilterParameter ͭΥå
   235:                ! Check validity of "FilterParameter"
   236:                !
   237:                if ( FilterParameter == 0.0_DP ) return
   238:            
   239:                ! ľե륿Ŭ
   240:                ! Apply vertical filter
   241:                !
   242:            
   243: +------>       do k=1,kmax
   244: |+V====          Temp_ref(:,:,k)  = 0.5_DP * ( xyr_Temp(:,:,k-1) + xyr_Temp(:,:,k) )
   245: +------        end do
   246:            
   247: +------>       do k=2,kmax-1
   248: |+V====          Temp_corr = 0.0_DP
   249: |+----->         do k1=-1,1
   250: ||+V===            Temp_corr = Temp_corr + FilterParameter &
   251: ||                   & * ( Temp_ref(:,:,k+k1) - xyz_TempA(:,:,k+k1) ) &
   252: ||                   & * ( xyr_Press(:,:,k+k1-1) - xyr_Press(:,:,k+k1) )
   253: |+-----          end do
   254: |+V====          Temp_corr = Temp_corr / ( xyr_Press(:,:,k-2) - xyr_Press(:,:,k+1) )
   255: |+----->         do k1=-1,1
   256: ||+V===            xyz_TempA(:,:,k+k1) = xyz_TempA(:,:,k+k1) &
   257: ||                   & + FilterParameter * ( Temp_ref(:,:,k+k1) - xyz_TempA(:,:,k+k1) ) - Temp_corr
   258: |+-----          end do
   259: +------        end do
   260:            
   261:                ! ׻ַ¬
   262:                ! Pause measurement of computation time
   263:                !
   264:                call TimesetClockStop( module_name )
   265:            
   266:              end subroutine VerticalFilter
   267:            
   268:              !--------------------------------------------------------------------------------------
   269:            
   270:              subroutine VerticalFilterInit
   271:                !
   272:                ! vertical_filter ⥸塼νԤޤ. 
   273:                ! NAMELIST#vertical_filter_nml ɤ߹ߤϤμ³ǹԤޤ. 
   274:                !
   275:                ! "vertical_filter" module is initialized. 
   276:                ! "NAMELIST#vertical_filter_nml" is loaded in this procedure. 
   277:                !
   278:            
   279:                ! ⥸塼 ; USE statements
   280:                !
   281:            
   282:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   283:                ! Utilities for NAMELIST file input
   284:                !
   285:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   286:            
   287:                ! ե
   288:                ! File I/O support
   289:                !
   290:                use dc_iounit, only: FileOpen
   291:            
   292:                ! ̷ѥ᥿
   293:                ! Kind type parameter
   294:                !
   295:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   296:            
   297:                ! ʸ ; Declaration statements
   298:                !
   299:                implicit none
   300:            
   301:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   302:                                          ! Unit number for NAMELIST file open
   303:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   304:                                          ! IOSTAT of NAMELIST read
   305:            
   306:                ! NAMELIST ѿ
   307:                ! NAMELIST group name
   308:                !
   309:                namelist /vertical_filter_nml/ &
   310:                  & FilterParameter   !, IntStep
   311:                      !
   312:                      ! ǥեͤˤĤƤϽ³ "vertical_filter#VerticalFilterInit" 
   313:                      ! Υɤ򻲾ȤΤ. 
   314:                      !
   315:                      ! Refer to source codes in the initialization procedure
   316:                      ! "vertical_filter#VerticalFilterInit" for the default values. 
   317:                      !
   318:            
   319:                ! ¹ʸ ; Executable statement
   320:                !
   321:            
   322:                if ( vertical_filter_inited ) return
   323:            
   324:            
   325:                ! ǥեͤ
   326:                ! Default values settings
   327:                !
   328:                FilterParameter = 0.1_DP
   329:            !!$    IntStep         = 1
   330:            !!$    CurStep         = 0
   331:            
   332:                ! NAMELIST ɤ߹
   333:                ! NAMELIST is input
   334:                !
   335:                if ( trim(namelist_filename) /= '' ) then
   336:                  call FileOpen( unit_nml, &          ! (out)
   337:                    & namelist_filename, mode = 'r' ) ! (in)
   338:            
   339:                  rewind( unit_nml )
   340:                  read( unit_nml, &                ! (in)
   341:                    & nml = vertical_filter_nml, &  ! (out)
   342:                    & iostat = iostat_nml )        ! (out)
   343:                  close( unit_nml )
   344:            
   345:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   346:                  if ( iostat_nml == 0 ) write( STDOUT, nml = vertical_filter_nml )
   347:                end if
   348:            
   349:            !!$    ! IntStep Υå
   350:            !!$    ! Check "IntStep"
   351:            !!$    !
   352:            !!$    if ( IntStep < 1 ) then
   353:            !!$      call MessageNotify( 'E', module_name, &
   354:            !!$        & 'IntStep=<%d> must be greater than 0', &
   355:            !!$        & i = (/ IntStep /) )
   356:            !!$    end if
   357:            !!$
   358:            !!$    ! PrevStep 
   359:            !!$    ! Configure "PrevStep"
   360:            !!$    !
   361:            !!$    PrevStep = - IntStep
   362:            
   363:                !  ; Print
   364:                !
   365:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   366:                call MessageNotify( 'M', module_name, '  FilterParameter = %f', d = (/ FilterParameter /) )
   367:            !!$    call MessageNotify( 'M', module_name, '  IntStep         = %d', i = (/ IntStep /) )
   368:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   369:            
   370:                vertical_filter_inited = .true.
   371:            
   372:              end subroutine VerticalFilterInit
   373:            
   374:              !--------------------------------------------------------------------------------------
   375:            
   376:            end module vertical_filter
