Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:50 2012
FILE NAME: surface_properties.f90
PROGRAM NAME: surface_properties
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   521  opt  (1592): Outer loop unrolled inside inner loop.
   521  vec  (   4): Vectorized array expression.
   521  vec  (   4): Vectorized array expression.
   592  opt  (1592): Outer loop unrolled inside inner loop.
   592  vec  (   4): Vectorized array expression.
   592  vec  (   4): Vectorized array expression.
   661  vec  (   1): Vectorized loop.
   661  vec  (   1): Vectorized loop.
   669  opt  (1592): Outer loop unrolled inside inner loop.
   697  opt  (1592): Outer loop unrolled inside inner loop.
   697  vec  (   4): Vectorized array expression.
   697  vec  (   4): Vectorized array expression.
   788  opt  (1592): Outer loop unrolled inside inner loop.
   788  vec  (   4): Vectorized array expression.
   788  vec  (   4): Vectorized array expression.
  1090  opt  (1592): Outer loop unrolled inside inner loop.
  1090  vec  (   4): Vectorized array expression.
  1090  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:50 2012
FILE NAME: surface_properties.f90
PROGRAM NAME: surface_properties
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ɽ̥ǡ
     2  !
     3  != Setting planetary surface properties
     4  !
     5  ! Authors::   Yasuhiro Morikawa, Yukiko Yamada, Yoshiyuki O. Takahashi
     6  ! Version::   $Id: surface_properties.f90,v 1.14 2012-09-08 15:27:16 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module surface_properties
    13    !
    14    != ɽ
    15    !
    16    != Setting planetary surface properties
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ̲٤ɽ̤̽ꤷޤ.
    21    !
    22    ! Data about sea surface temperature (SST) or various values on surface
    23    ! are set.
    24    !
    25    !== Procedures List
    26    ! SetSurfaceProperties  :: ɽ
    27    !--
    28  !!$  ! GroundFileOpen   :: ɽ̥ǡեΥץ
    29  !!$  ! GroundFileOutput :: ɽ̥ǡեؤΥǡ
    30  !!$  ! GroundFileClose  :: ɽ̥ǡեΥ
    31    !++
    32    ! ------------     :: ------------
    33    ! SetSurfaceProperties  :: Setting surface properties
    34    !--
    35  !!$  ! GroundFileOpen   :: Open ground data file
    36  !!$  ! GroundFileOutput :: Data output to ground data file
    37  !!$  ! GroundFileClose  :: Close ground data file
    38    !++
    39    !
    40    !== NAMELIST
    41    !
    42    ! NAMELIST#surface_properties_nml
    43    !
    44  
    45    ! ⥸塼 ; USE statements
    46    !
    47  
    48    ! ̷ѥ᥿
    49    ! Kind type parameter
    50    !
    51    use dc_types, only: DP, &      ! ټ¿. Double precision.
    52      &                 STRING, &  ! ʸ.       Strings.
    53      &                 TOKEN      ! .   Keywords.
    54  
    55    ! å
    56    ! Message output
    57    !
    58    use dc_message, only: MessageNotify
    59  
    60    ! gtool5 ǡ
    61    ! Gtool5 data output
    62    !
    63    use gtool_history, only: GT_HISTORY
    64  
    65    ! ʻ
    66    ! Grid points settings
    67    !
    68    use gridset, only: imax, & ! ٳʻ.
    69                               ! Number of grid points in longitude
    70      &                jmax, & ! ٳʻ.
    71                               ! Number of grid points in latitude
    72      &                kmax    ! ľؿ.
    73                               ! Number of vertical level
    74  
    75    ! ʸ ; Declaration statements
    76    !
    77    implicit none
    78    private
    79  
    80    ! ³
    81    ! Public procedure
    82    !
    83    public:: SetSurfaceProperties
    84    public:: SurfacePropertiesInit
    85  
    86    ! ѿ
    87    ! Public variables
    88    !
    89    logical, save :: surface_properties_inited = .false.
    90                                ! ե饰.
    91                                ! Initialization flag
    92  
    93  !!$  logical, save, public:: ground_file_opened = .false.
    94  !!$                              ! ɽ̥ǡեΥץ˴ؤե饰.
    95  !!$                              ! Flag of ground data file open
    96  
    97    ! ѿ
    98    ! Private variables
    99    !
   100    logical          , save:: FlagSlabOcean
   101                                ! ֥ 󡿥.
   102                                ! flag for use of slab ocean on/off
   103  
   104    character(STRING), save:: SurfTempSetting
   105                                ! ɽ̲٤ˡ
   106                                ! Setting of surface temperature
   107    character(STRING), save:: SurfTempFile
   108                                ! ɽ̲٤Υե̾.
   109                                ! File name of surface temperature
   110    character(TOKEN) , save:: SurfTempName
   111                                ! ɽ̲٤ѿ̾.
   112                                ! Variable name of surface temperature
   113  
   114    character(STRING), save:: SeaIceSetting
   115                                ! ɹ̩٤ˡ
   116                                ! Setting of sea ice concentration
   117    character(STRING), save:: SeaIceFile
   118                                ! ɹ̩٤Υե̾.
   119                                ! File name of sea ice concentration
   120    character(TOKEN) , save:: SeaIceName
   121                                ! ɹ̩٤ѿ̾.
   122                                ! Variable name of sea ice concentration
   123  
   124    character(STRING), save:: AlbedoSetting
   125                                ! ɽ٥ɤˡ
   126                                ! Settingof surface albedo
   127    character(STRING), save:: AlbedoFile
   128                                ! ɽ٥ɤΥե̾.
   129                                ! File name of surface albedo
   130    character(TOKEN) , save:: AlbedoName
   131                                ! ɽ٥ɤѿ̾.
   132                                ! Variable name of surface albedo
   133  
   134    character(STRING), save:: HumidCoefSetting
   135                                ! ɽ٤ˡ
   136                                ! Setting of surface humidity coefficient
   137    character(STRING), save:: HumidCoefFile
   138                                ! ɽ٤Υե̾.
   139                                ! File name of surface humidity coefficient
   140    character(TOKEN) , save:: HumidCoefName
   141                                ! ɽ٤ѿ̾.
   142                                ! Variable name of surface humidity coefficient
   143  
   144    character(STRING), save:: RoughLengthSetting
   145                                ! ɽĹˡ
   146                                ! Setting of surface rough length
   147    character(STRING), save:: RoughLengthFile
   148                                ! ɽĹΥե̾.
   149                                ! File name of surface rough length
   150    character(TOKEN) , save:: RoughLengthName
   151                                ! ɽĹѿ̾.
   152                                ! Variable name of surface rough length
   153  
   154    character(STRING), save:: HeatCapacitySetting
   155                                ! ɽǮ̤ˡ
   156                                ! Setting of surface heat capacity
   157    character(STRING), save:: HeatCapacityFile
   158                                ! ɽǮ̤Υե̾.
   159                                ! File name of surface heat capacity
   160    character(TOKEN) , save:: HeatCapacityName
   161                                ! ɽǮ̤ѿ̾.
   162                                ! Variable name of surface heat capacity
   163  
   164    character(STRING), save:: TempFluxSetting
   165                                ! Ǯեåˡ
   166                                ! Setting of ground temperature flux
   167    character(STRING), save:: TempFluxFile
   168                                ! ǮեåΥե̾.
   169                                ! File name of ground temperature flux
   170    character(TOKEN) , save:: TempFluxName
   171                                ! Ǯեåѿ̾.
   172                                ! Variable name of ground temperature flux
   173  
   174    character(STRING), save:: SurfCondSetting
   175                                ! ɽ֤̾ˡ
   176                                ! Setting of surface condition
   177    character(STRING), save:: SurfCondFile
   178                                ! ɽ֤̾Υե̾.
   179                                ! File name of surface condition
   180    character(TOKEN) , save:: SurfCondName
   181                                ! ɽ֤̾ѿ̾.
   182                                ! Variable name of surface condition
   183  
   184    character(STRING), save:: SurfTypeSetting
   185                                ! ɽ̥ () ˡ
   186                                ! Setting of surface type (land use)
   187    character(STRING), save:: SurfTypeFile
   188                                ! ɽ̥ () Υե̾.
   189                                ! File name of surface type (land use)
   190    character(TOKEN) , save:: SurfTypeName
   191                                ! ɽ̥ () ѿ̾.
   192                                ! Variable name of surface type (land use)
   193  
   194    character(STRING), save:: SurfHeightSetting
   195                                ! ɽ̹٤ˡ
   196                                ! Setting of surface height
   197    character(STRING), save:: SurfHeightFile
   198                                ! ɽ̹٤Υե̾.
   199                                ! File name of surface height
   200    character(TOKEN) , save:: SurfHeightName
   201                                ! ɽ̹٤ѿ̾.
   202                                ! Variable name of surface height
   203  
   204    character(STRING), save:: SoilHeatCapSetting
   205                                ! ھǮ̤ˡ
   206                                ! Setting of heat conduction coefficient of soil
   207    character(STRING), save:: SoilHeatCapFile
   208                                ! ھǮ̤Υե̾.
   209                                ! File name of heat conduction coefficient of soil
   210    character(TOKEN) , save:: SoilHeatCapName
   211                                ! ھǮ̤ѿ̾.
   212                                ! Variable name of heat conduction coefficient of soil
   213  
   214    character(STRING), save:: SoilHeatDiffCoefSetting
   215                                ! ھǮƳΨˡ
   216                                ! Setting of heat conduction coefficient of soil
   217    character(STRING), save:: SoilHeatDiffCoefFile
   218                                ! ھǮƳΨΥե̾.
   219                                ! File name of heat conduction coefficient of soil
   220    character(TOKEN) , save:: SoilHeatDiffCoefName
   221                                ! ھǮƳΨѿ̾.
   222                                ! Variable name of heat conduction coefficient of soil
   223  
   224  
   225  
   226  !!$  character(STRING), save:: OutputFile
   227  !!$                              ! Ϥɽ̥ǡΥե̾
   228  !!$                              ! filename of output ground data
   229  !!$  real(DP), save:: IntValue
   230  !!$                              ! ɽ̥ǡνϴֳ.
   231  !!$                              ! Interval of ground data output
   232  !!$  character(TOKEN):: IntUnit
   233  !!$                              ! ɽ̥ǡνϴֳ֤ñ.
   234  !!$                              ! Unit for interval of ground data output
   235  !!$
   236  !!$  type(GT_HISTORY), save:: gthst_grd
   237  !!$                              ! ɽ̥ǡ gtool_history#GT_HISTORY ѿ
   238  !!$                              ! "gtool_history#GT_HISTORY" variable for ground data
   239  !!$
   240  !!$
   241  !!$  type(DC_DIFFTIME), save:: PrevOutputTime
   242  !!$                              ! νϻ.
   243  !!$                              ! Previous output time
   244  !!$
   245  !!$  type(DC_DIFFTIME), save:: IntTime
   246  !!$                              ! ꥹȥǡνϻ.
   247  !!$                              ! Time interval of restart data output
   248  
   249    character(*), parameter:: module_name = 'surface_properties'
   250                                ! ⥸塼̾.
   251                                ! Module name
   252    character(*), parameter:: version = &
   253      & '$Name: dcpam5-20120921 $' // &
   254      & '$Id: surface_properties.f90,v 1.14 2012-09-08 15:27:16 yot Exp $'
   255                                ! ⥸塼ΥС
   256                                ! Module version
   257  
   258  
   259  contains
   260  
   261    subroutine SetSurfaceProperties(                       &
   262      & xy_SurfMajCompIceB, xy_SoilMoistB, xy_SurfSnowB,   & ! (in)    optional
   263      & xy_SurfTemp, xy_SurfAlbedo, xy_SurfHumidCoef,      & ! (inout) optional
   264      & xy_SurfRoughLength, xy_SurfHeatCapacity,           & ! (inout) optional
   265      & xy_DeepSubSurfHeatFlux, xy_SurfCond, xy_SurfType,  & ! (inout) optional
   266      & xy_SurfHeight,                                     & ! (inout) optional
   267      & xy_SeaIceConc,                                     & ! (inout) optional
   268      & xy_SoilHeatCap, xy_SoilHeatDiffCoef                & ! (inout) optional
   269      & )
   270      !
   271      ! ɽꤷޤ.
   272      !
   273      ! Set surface properties.
   274      !
   275  
   276      ! ⥸塼 ; USE statements
   277      !
   278  
   279      ! ʸ
   280      ! Character handling
   281      !
   282      use dc_string, only: toChar
   283  
   284      ! gtool4 ǡ
   285      ! Gtool4 data input
   286      !
   287      use gtool_history, only: HistoryGet
   288  
   289      ! ǡɤ߹
   290      ! Reading time series
   291      !
   292      use read_time_series, only: SetValuesFromTimeSeriesWrapper
   293  
   294      ! 
   295      ! Time control
   296      !
   297      use timeset, only: &
   298        & TimeN, &              ! ƥå $ t $ λ.
   299                                ! Time of step $ t $.
   300        & EndTime, &            ! ׻λ.
   301                                ! End time of calculation
   302        & TimesetClockStart, TimesetClockStop
   303  
   304      ! ȳɹ
   305      ! Setting constants of snow and sea ice
   306      !
   307      use constants_snowseaice, only: SeaIceThreshold
   308  
   309      ! ɽ̥ǡ
   310      ! Prepare surface data
   311      !
   312      use surface_data, only: SetSurfData
   313  
   314      ! Matthews Υǡ˴Ťɽ̥٥
   315      ! set surface albedo based on data by Matthews
   316      !
   317      use albedo_Matthews, only: SetAlbedoMatthews
   318  
   319      ! Хĥǥ
   320      ! Bucket model
   321      !
   322      use Bucket_Model, only : BucketSetFlagOceanFromMatthews, BucketModHumidCoef
   323  
   324      ! ȳɹˤ륢٥Ѳ
   325      ! modification of surface albedo on the snow covered ground and on the sea ice
   326      !
   327      use modify_albedo_snowseaice, only: ModAlbedoDueToSnowSeaIce
   328  
   329      ! ٥, Ĺ, Φ̤ȳΤκΤ߹θ
   330      ! Set albedo and roughness length, only considering land-ocean contrast
   331      !
   332      use surface_properties_lo, only: &
   333        & SetAlbedoLO, SetRoughLenLO
   334  
   335      ! Matthews Υǡ˴Ť٤
   336      ! set roughness length on land surface based on data by Matthews
   337      !
   338      use roughlen_Matthews, only: SetRoughLenLandMatthews
   339  
   340  
   341      ! ʸ ; Declaration statements
   342      !
   343      real(DP), intent(in   ), optional:: xy_SurfMajCompIceB(0:imax-1, 1:jmax)
   344                                ! $ M_mcs (t-\Delta t) $ .
   345                                ! Surface major component ice amount (kg m-2)
   346      real(DP), intent(in   ), optional:: xy_SoilMoistB(0:imax-1, 1:jmax)
   347                                ! $ M_ws (t-\Delta t) $ . ھʬ (kg m-2)
   348                                ! Soil moisture (kg m-2)
   349      real(DP), intent(in   ), optional:: xy_SurfSnowB(0:imax-1, 1:jmax)
   350                                ! $ M_ss (t-\Delta t) $ .  (kg m-2)
   351                                ! Surface snow amount (kg m-2)
   352      real(DP), intent(inout), optional:: xy_SurfTemp (0:imax-1, 1:jmax)
   353                                ! ɽ̲.
   354                                ! Surface temperature
   355      real(DP), intent(inout), optional:: xy_SurfAlbedo (0:imax-1, 1:jmax)
   356                                ! ɽ٥.
   357                                ! Surface albedo
   358      real(DP), intent(inout), optional:: xy_SurfHumidCoef (0:imax-1, 1:jmax)
   359                                ! ɽ.
   360                                ! Surface humidity coefficient
   361      real(DP), intent(inout), optional:: xy_SurfRoughLength (0:imax-1, 1:jmax)
   362                                ! ɽĹ.
   363                                ! Surface rough length
   364      real(DP), intent(inout), optional:: xy_SurfHeatCapacity (0:imax-1, 1:jmax)
   365                                ! ɽǮ.
   366                                ! Surface heat capacity
   367      real(DP), intent(inout), optional:: xy_DeepSubSurfHeatFlux (0:imax-1, 1:jmax)
   368                                ! Ǯեå.
   369                                ! "Deep subsurface heat flux"
   370                                ! Heat flux at the bottom of surface/soil layer.
   371      integer , intent(inout), optional:: xy_SurfCond (0:imax-1, 1:jmax)
   372                                ! ɽ̾ (0: , 1: ).
   373                                ! Surface condition (0: fixed, 1: variable)
   374      integer , intent(inout), optional:: xy_SurfType (0:imax-1, 1:jmax)
   375                                ! ɽ̥ ()
   376                                ! Surface type (land use)
   377      real(DP), intent(inout), optional:: xy_SurfHeight (0:imax-1, 1:jmax)
   378                                ! $ z_s $ . ɽ̹.
   379                                ! Surface height.
   380      real(DP), intent(inout), optional:: xy_SeaIceConc(0:imax-1,1:jmax)
   381                                ! ɹ̩ (0 <= xy_SeaIceConc <= 1)
   382                                ! Sea ice concentration (0 <= xy_SeaIceConc <= 1)
   383      real(DP), intent(inout), optional:: xy_SoilHeatCap(0:imax-1,1:jmax)
   384                                ! ھǮ (J K-1 kg-1)
   385                                ! Specific heat of soil (J K-1 kg-1)
   386      real(DP), intent(inout), optional:: xy_SoilHeatDiffCoef(0:imax-1,1:jmax)
   387                                ! ھǮƳΨ (W m-1 K-1)
   388                                ! Heat conduction coefficient of soil (W m-1 K-1)
   389  
   390      ! ѿ
   391      ! Work variables
   392      !
   393      real(DP), allocatable, save:: xy_SurfTempSave (:,:)
   394                                ! ɽ̲٤¸ (K)
   395                                ! Saved values of surface temperature (K)
   396      real(DP), allocatable, save:: xy_SeaIceConcSave(:,:)
   397                                ! ɹ̩٤¸
   398                                ! Saved values of sea ice concentration
   399      real(DP), allocatable, save:: xy_SurfAlbedoSave(:,:)
   400                                ! ٥ɤ¸
   401                                ! Saved values of albedo
   402  
   403      logical      :: xy_BucketFlagOceanGrid(0:imax-1,1:jmax)
   404                                !
   405                                ! Flag for ocean grid point used in bucket model
   406  
   407      logical, save:: flag_first_SurfCond            = .true.
   408                                ! 򼨤ե饰.
   409                                ! Flag that indicates first loop
   410                                !
   411      logical, save:: flag_first_SurfType            = .true.
   412      logical, save:: flag_first_SeaIceConc          = .true.
   413      logical, save:: flag_first_SurfTemp            = .true.
   414      logical, save:: flag_first_SurfHeight          = .true.
   415      logical, save:: flag_first_SurfAlbedo          = .true.
   416      logical, save:: flag_first_SurfHumidCoef       = .true.
   417      logical, save:: flag_first_SurfRoughLength     = .true.
   418      logical, save:: flag_first_SurfHeatCapacity    = .true.
   419      logical, save:: flag_first_DeepSubSurfHeatFlux = .true.
   420      logical, save:: flag_first_SoilHeatCap         = .true.
   421      logical, save:: flag_first_SoilHeatDiffCoef    = .true.
   422  
   423      logical:: flag_mpi_init
   424  
   425      integer:: i               ! ˲ DO 롼Ѻѿ
   426                                ! Work variables for DO loop in longitude
   427      integer:: j               ! ˲ DO 롼Ѻѿ
   428                                ! Work variables for DO loop in latitude
   429  
   430  
   431      ! ¹ʸ ; Executable statement
   432      !
   433  
   434      ! ǧ
   435      ! Initialization check
   436      !
   437      if ( .not. surface_properties_inited ) then
   438        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   439      end if
   440  
   441  
   442      ! ׻ַ¬
   443      ! Start measurement of computation time
   444      !
   445      call TimesetClockStart( module_name )
   446  
   447  
   448      flag_mpi_init = .true.
   449  
   450  
   451      ! NOTICE:
   452      ! The surface condition has to be set, before other fields are set.
   453      !
   454      ! ɽ̾
   455      ! Surface condition
   456      !
   457      if ( present(xy_SurfCond) ) then
   458  
   459        if ( SurfCondSetting == 'file' ) then
   460          ! ǡե뤫
   461          ! Data is input from files
   462          !
   463          if ( flag_first_SurfCond ) then
   464            call HistoryGet( &
   465              & SurfCondFile, SurfCondName, &     ! (in)
   466              & xy_SurfCond, &                    ! (out)
   467              & flag_mpi_split = flag_mpi_init )  ! (in) optional
   468          end if
   469        else if ( SurfCondSetting == 'generate_internally' ) then
   470          ! ǡ (ǥե)  surface_data ⥸塼뤫
   471          ! Data (default values) is input from "surface_data" module
   472          !
   473          if ( flag_first_SurfCond ) then
   474            call SetSurfData( &
   475              & xy_SurfCond = xy_SurfCond &                   ! (out)
   476              & )
   477          end if
   478        else
   479          call MessageNotify( 'E', module_name, &
   480            & ' SurfCondSetting = %c is not appropriate.', &
   481            & c1 = trim(SurfCondSetting) )
   482        end if
   483  
   484        flag_first_SurfCond = .false.
   485  
   486      end if
   487  
   488  
   489      ! ɽ̥ ()
   490      ! Surface type (land use)
   491      !
   492      if ( present(xy_SurfType) ) then
   493  
   494        if ( SurfTypeSetting == 'file' ) then
   495          ! ǡե뤫
   496          ! Data is input from files
   497          !
   498          if ( flag_first_SurfType ) then
   499            call HistoryGet( &
   500              & SurfTypeFile, SurfTypeName, &     ! (in)
   501              & xy_SurfType, &                    ! (out)
   502              & flag_mpi_split = flag_mpi_init )  ! (in) optional
   503  !!$          do j = 1, jmax
   504  !!$            do i = 0, imax-1
   505  !!$              if ( xy_SurfType(i,j) >= 1 ) then
   506  !!$                xy_SurfCond(i,j) = 1
   507  !!$              else
   508  !!$                xy_SurfCond(i,j) = 0
   509  !!$              end if
   510  !!$            end do
   511  !!$          end do
   512  !!$          call MessageNotify( 'M', module_name, ' xy_SurfCond is overwritten.' )
   513          end if
   514        else if ( SurfTypeSetting == 'same_as_SurfCond' ) then
   515          if ( .not. present( xy_SurfCond ) ) then
   516            call MessageNotify( 'E', module_name, &
   517              & ' The xy_SurfCond has to be present, when SurfTypeSetting = %c.', &
   518              & c1 = trim(SurfTypeSetting) )
   519          end if
   520          if ( flag_first_SurfType ) then
   521            xy_SurfType = xy_SurfCond
     .        if (xy_surftype.DSC.U2 .gt. 0) then                               
     .           J1 = and(xy_surftype.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t767 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t769 = 1, xy_surftype.DSC.U1 + 2 - min0(1,               
     .       1         xy_surftype.DSC.U1 + 1)                                  
     .                 xy_surftype(t769-1,t767) = xy_surfcond(t769-1,t767)      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t767 = J1 + 1, xy_surftype.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t769 = 1, xy_surftype.DSC.U1 + 2 - min0(1,               
     .       1         xy_surftype.DSC.U1 + 1)                                  
     .                 xy_surftype(t769-1,t767) = xy_surfcond(t769-1,t767)      
     .                 xy_surftype(t769-1,t767+1) = xy_surfcond(t769-1,t767+1)  
     .                 xy_surftype(t769-1,t767+2) = xy_surfcond(t769-1,t767+2)  
     .                 xy_surftype(t769-1,t767+3) = xy_surfcond(t769-1,t767+3)  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10199                                                       
   522  !!$          do j = 1, jmax
   523  !!$            do i = 0, imax-1
   524  !!$              if ( xy_SurfType(i,j) >= 1 ) then
   525  !!$                xy_SurfCond(i,j) = 1
   526  !!$              else
   527  !!$                xy_SurfCond(i,j) = 0
   528  !!$              end if
   529  !!$            end do
   530  !!$          end do
   531  !!$          call MessageNotify( 'M', module_name, ' xy_SurfCond is overwritten.' )
   532          end if
   533        else
   534          call MessageNotify( 'E', module_name, &
   535            & ' SurfTypeSetting = %c is not appropriate.', &
   536            & c1 = trim(SurfTypeSetting) )
   537        end if
   538  
   539        flag_first_SurfType = .false.
   540  
   541      end if
   542  
   543  
   544      ! NOTICE:
   545      ! The sea ice distribution has to be set, before set surface temperature.
   546      !
   547      ! ɹ̩
   548      ! Sea ice concentration
   549      !
   550      if ( present(xy_SeaIceConc) ) then
   551  
   552        if ( flag_first_SeaIceConc ) then
   553          ! ¸ѿγ
   554          ! Allocate a variable for save
   555          !
   556          allocate( xy_SeaIceConcSave(0:imax-1, 1:jmax) )
   557        end if
   558        if ( SeaIceSetting == 'file' ) then
   559          ! ǡե뤫
   560          ! Data is input from files
   561          !
   562  
   563          ! This will be deleted near future (yot, 2010/10/11)
   564  !!$        if ( flag_first_SeaIceConc ) then
   565  !!$          call HistoryGet( &
   566  !!$            & SeaIceFile, SeaIceName,          & ! (in)
   567  !!$            & xy_SeaIceConcSave,               & ! (out)
   568  !!$            & flag_mpi_split = flag_mpi_init )   ! (in) optional
   569  !!$        end if
   570          call SetValuesFromTimeSeriesWrapper(    &
   571            & SeaIceFile, SeaIceName,             &
   572            & xy_SeaIceConcSave,                  &               ! (inout)
   573            & 'SIC'                               &
   574            & )
   575        else if ( SeaIceSetting == 'generate_internally' ) then
   576          ! ǡ (ǥե)  surface_data ⥸塼뤫
   577          ! Data (default values) is input from "surface_data" module
   578          !
   579          if ( flag_first_SeaIceConc ) then
   580            call SetSurfData( &
   581              & xy_SeaIceConc = xy_SeaIceConcSave &                   ! (out)
   582              & )
   583          end if
   584        else
   585          call MessageNotify( 'E', module_name, &
   586            & ' SeaIceSetting = %c is not appropriate.', &
   587            & c1 = trim(SeaIceSetting) )
   588        end if
   589        ! ɹ̩٤ ( xy_SurfCond == 0 ξΤ )
   590        ! Setting of sea ice concentration ( where xy_SurfCond == 0 only )
   591        !
   592        xy_SeaIceConc = xy_SeaIceConcSave
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t759 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t761 = 1, imax                                           
     .                 xy_seaiceconc(t761-1,t759) = xy_seaiceconcsave(          
     .       1            xy_seaiceconcsave.DSC.L1+t761-1,t759-1+               
     .       2            xy_seaiceconcsave.DSC.L2)                             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t759 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t761 = 1, imax                                           
     .                 xy_seaiceconc(t761-1,t759) = xy_seaiceconcsave(          
     .       1            xy_seaiceconcsave.DSC.L1+t761-1,t759-1+               
     .       2            xy_seaiceconcsave.DSC.L2)                             
     .                 xy_seaiceconc(t761-1,t759+1) = xy_seaiceconcsave(        
     .       1            xy_seaiceconcsave.DSC.L1+t761-1,t759+                 
     .       2            xy_seaiceconcsave.DSC.L2)                             
     .                 xy_seaiceconc(t761-1,t759+2) = xy_seaiceconcsave(        
     .       1            xy_seaiceconcsave.DSC.L1+t761-1,t759+1+               
     .       2            xy_seaiceconcsave.DSC.L2)                             
     .                 xy_seaiceconc(t761-1,t759+3) = xy_seaiceconcsave(        
     .       1            xy_seaiceconcsave.DSC.L1+t761-1,t759+2+               
     .       2            xy_seaiceconcsave.DSC.L2)                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   593  
   594        flag_first_SeaIceConc = .false.
   595  
   596      end if
   597  
   598  
   599      ! NOTICE:
   600      ! Before set surface temperature, sea ice distribution has to be set.
   601      !
   602      ! ɽ̲
   603      ! surface temperature
   604      !
   605      if ( present(xy_SurfTemp) ) then
   606  
   607        if ( flag_first_SurfTemp ) then
   608          ! ¸ѿγ
   609          ! Allocate a variable for save
   610          !
   611          allocate( xy_SurfTempSave  (0:imax-1, 1:jmax) )
   612        end if
   613        if ( SurfTempSetting == 'file' ) then
   614          ! ǡե뤫
   615          ! Data is input from files
   616          !
   617  
   618          ! This will be deleted near future (yot, 2010/10/11)
   619  !!$        if ( flag_first_SurfTemp ) then
   620  !!$          call HistoryGet( &
   621  !!$            & SurfTempFile, SurfTempName, &    ! (in)
   622  !!$            & xy_SurfTempSave, &               ! (out)
   623  !!$            & flag_mpi_split = flag_mpi_init ) ! (in) optional
   624  !!$        end if
   625          call SetValuesFromTimeSeriesWrapper(    &
   626            & SurfTempFile, SurfTempName,         &
   627            & xy_SurfTempSave,                    &               ! (inout)
   628            & 'SST'                               &
   629            & )
   630        else if ( SurfTempSetting == 'generate_internally' ) then
   631          ! ǡ (ǥե)  surface_data ⥸塼뤫
   632          ! Data (default values) is input from "surface_data" module
   633          !
   634          if ( flag_first_SurfTemp ) then
   635            call SetSurfData( &
   636              & xy_SurfTemp = xy_SurfTempSave & ! (out) optional
   637              & )
   638          end if
   639        else
   640          call MessageNotify( 'E', module_name, &
   641            & ' SurfTempSetting = %c is not appropriate.', &
   642            & c1 = trim(SurfTempSetting) )
   643        end if
   644        ! ɽ̲٤ SST ֤ ( xy_SurfCond <=0 ξΤ )
   645        ! Surface temperature is replaced with SST ( only xy_SurfCond <=0 )
   646        !
   647        if ( present(xy_SurfTemp) ) then
   648  
   649          if ( .not. present( xy_SurfCond ) ) then
   650            call MessageNotify( 'E', module_name, &
   651              & ' xy_SurfCond has to be present to set xy_SurfTemp.' )
   652          end if
   653          if ( .not. present( xy_SeaIceConc ) ) then
   654            call MessageNotify( 'E', module_name, &
   655              & ' xy_SeaIceConc has to be present to set xy_SurfTemp.' )
   656          end if
   657  
   658          if ( .not. FlagSlabOcean ) then
   659  
   660            do j = 1, jmax
   661              do i = 0, imax-1
   662                if ( ( xy_SurfCond(i,j)     <= 0               ) .and. &
   663                  &  ( xy_SurfTempSave(i,j) >  0.0_DP          ) .and. &
   664                  &  ( xy_SeaIceConc(i,j)   <  SeaIceThreshold ) ) then
   665  
   666                  xy_SurfTemp(i,j) = xy_SurfTempSave(i,j)
   667  
   668                end if
   669              end do
   670            end do
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,1)                                               
     .           do j = 1, J3                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xy_surfcond(i-1,j).le.0 .and. xy_surftempsave(i-1,j) 
     .       1            .gt.0.0000000000000000e+000 .and. xy_seaiceconc(i-1,j)
     .       2            .lt.seaicethreshold) then                             
     .                    xy_surftemp(i-1,j) = xy_surftempsave(i-1,j)           
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J3 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xy_surfcond(i-1,j).le.0 .and. xy_surftempsave(i-1,j) 
     .       1            .gt.0.0000000000000000e+000 .and. xy_seaiceconc(i-1,j)
     .       2            .lt.seaicethreshold) then                             
     .                    xy_surftemp(i-1,j) = xy_surftempsave(i-1,j)           
     .                 endif                                                    
     .                 if (xy_surfcond(i-1,j+1).le.0 .and. xy_surftempsave(i-1,j
     .       1            +1).gt.0.0000000000000000e+000 .and. xy_seaiceconc(i-1
     .       2            ,j+1).lt.seaicethreshold) then                        
     .                    xy_surftemp(i-1,j+1) = xy_surftempsave(i-1,j+1)       
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   671          end if
   672  
   673        end if
   674  
   675  
   676        flag_first_SurfTemp = .false.
   677      end if
   678  
   679  
   680      ! Ϸ
   681      ! Topography
   682      !
   683      if ( present(xy_SurfHeight) ) then
   684  
   685        if ( SurfHeightSetting == 'file' ) then
   686          ! ǡե뤫
   687          ! Data is input from files
   688          !
   689          if ( flag_first_SurfHeight ) then
   690            call HistoryGet( &
   691              & SurfHeightFile, SurfHeightName, &  ! (in)
   692              & xy_SurfHeight, &                   ! (out)
   693              & flag_mpi_split = flag_mpi_init )   ! (in) optional
   694          end if
   695        else if ( SurfHeightSetting == 'generate_internally' ) then
   696          if ( flag_first_SurfHeight ) then
   697            xy_SurfHeight = 0.0_DP
     .        if (xy_surfheight.DSC.U2 .gt. 0) then                             
     .           J4 = and(xy_surfheight.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t753 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t755 = 1, xy_surfheight.DSC.U1 + 2 - min0(1,             
     .       1         xy_surfheight.DSC.U1 + 1)                                
     .                 xy_surfheight(t755-1,t753) = 0.0000000000000000e+000     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t753 = J4 + 1, xy_surfheight.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t755 = 1, xy_surfheight.DSC.U1 + 2 - min0(1,             
     .       1         xy_surfheight.DSC.U1 + 1)                                
     .                 xy_surfheight(t755-1,t753) = 0.0000000000000000e+000     
     .                 xy_surfheight(t755-1,t753+1) = 0.0000000000000000e+000   
     .                 xy_surfheight(t755-1,t753+2) = 0.0000000000000000e+000   
     .                 xy_surfheight(t755-1,t753+3) = 0.0000000000000000e+000   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10147                                                       
   698          end if
   699        else
   700          call MessageNotify( 'E', module_name, &
   701            & ' SurfHeightSetting = %c is not appropriate.', &
   702            & c1 = trim(SurfHeightSetting) )
   703        end if
   704  
   705        flag_first_SurfHeight = .false.
   706      end if
   707  
   708  
   709      ! NOTICE:
   710      ! The surface condition and sea ice concentration have to be set, before albedo
   711      ! is set.
   712      !
   713      ! ٥
   714      ! Albedo
   715      !
   716      if ( present(xy_SurfAlbedo) ) then
   717  
   718        if ( flag_first_SurfAlbedo ) then
   719          ! ¸ѿγ
   720          ! Allocate a variable for save
   721          !
   722          allocate( xy_SurfAlbedoSave(0:imax-1, 1:jmax) )
   723        end if
   724        if ( AlbedoSetting == 'file' ) then
   725          ! ǡե뤫
   726          ! Data is input from files
   727          !
   728          if ( flag_first_SurfAlbedo ) then
   729            call HistoryGet( &
   730              & AlbedoFile, AlbedoName, &        ! (in)
   731              & xy_SurfAlbedoSave,      &        ! (out)
   732              & flag_mpi_split = flag_mpi_init ) ! (in) optional
   733          end if
   734  
   735        else if ( AlbedoSetting == 'Matthews' ) then
   736          ! ٥ɤ Matthews ΥǡȤ
   737          ! Surface albedo is set based on Matthews' data
   738          !
   739          if ( .not. present( xy_SurfType ) ) then
   740            call MessageNotify( 'E', module_name, &
   741              & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   742          end if
   743          if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   744            &  ( SurfTypeSetting /= 'file'             )       ) then
   745            call MessageNotify( 'E', module_name, &
   746              & " SurfType has to be 'same_as_SurfCond' or 'file', when AlbedoSetting = %c.", &
   747              & c1 = trim(AlbedoSetting) )
   748          end if
   749          call SetAlbedoMatthews( &
   750            & xy_SurfType,      &
   751            & xy_SurfAlbedoSave &
   752            & )
   753        else if ( AlbedoSetting == 'LOContrast' ) then
   754          ! ٥ɤ, Φ̤ȳΤκΤ߹θ
   755          ! Set albedo, only considering land-ocean contrast
   756          !
   757          if ( .not. present( xy_SurfType ) ) then
   758            call MessageNotify( 'E', module_name, &
   759              & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   760          end if
   761          if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   762            &  ( SurfTypeSetting /= 'file'             )       ) then
   763            call MessageNotify( 'E', module_name, &
   764              & " SurfType has to be 'same_as_SurfCond' or 'file', when AlbedoSetting = %c.", &
   765              & c1 = trim(AlbedoSetting) )
   766          end if
   767          call SetAlbedoLO(      &
   768            & xy_SurfType,       &
   769            & xy_SurfAlbedoSave  &
   770            & )
   771        else if ( AlbedoSetting == 'generate_internally' ) then
   772          ! ǡ (ǥե)  surface_data ⥸塼뤫
   773          ! Data (default values) is input from "surface_data" module
   774          !
   775          if ( flag_first_SurfAlbedo ) then
   776            call SetSurfData( &
   777              & xy_SurfAlbedo = xy_SurfAlbedoSave  & ! (out)
   778              & )
   779          end if
   780        else
   781          call MessageNotify( 'E', module_name, &
   782            & ' AlbedoSetting = %c is not appropriate.', &
   783            & c1 = trim(AlbedoSetting) )
   784        end if
   785        ! ٥ɤ
   786        ! Setting of albedo
   787        !
   788        xy_SurfAlbedo = xy_SurfAlbedoSave
     .        if (jmax .gt. 0) then                                             
     .           J5 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t745 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t747 = 1, imax                                           
     .                 xy_surfalbedo(t747-1,t745) = xy_surfalbedosave(          
     .       1            xy_surfalbedosave.DSC.L1+t747-1,t745-1+               
     .       2            xy_surfalbedosave.DSC.L2)                             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t745 = J5 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t747 = 1, imax                                           
     .                 xy_surfalbedo(t747-1,t745) = xy_surfalbedosave(          
     .       1            xy_surfalbedosave.DSC.L1+t747-1,t745-1+               
     .       2            xy_surfalbedosave.DSC.L2)                             
     .                 xy_surfalbedo(t747-1,t745+1) = xy_surfalbedosave(        
     .       1            xy_surfalbedosave.DSC.L1+t747-1,t745+                 
     .       2            xy_surfalbedosave.DSC.L2)                             
     .                 xy_surfalbedo(t747-1,t745+2) = xy_surfalbedosave(        
     .       1            xy_surfalbedosave.DSC.L1+t747-1,t745+1+               
     .       2            xy_surfalbedosave.DSC.L2)                             
     .                 xy_surfalbedo(t747-1,t745+3) = xy_surfalbedosave(        
     .       1            xy_surfalbedosave.DSC.L1+t747-1,t745+2+               
     .       2            xy_surfalbedosave.DSC.L2)                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   789  
   790  
   791        if ( present( xy_SurfType ) ) then
   792          ! ȳɹˤ륢٥Ѳ
   793          ! modification of surface albedo on the snow covered ground and on the sea ice
   794          !
   795  
   796          if ( .not. present( xy_SurfMajCompIceB ) ) then
   797            call MessageNotify( 'E', module_name, &
   798              & ' xy_SurfMajCompIceB has to be present to set xy_SurfAlbedo.' )
   799          end if
   800          if ( .not. present( xy_SurfSnowB ) ) then
   801            call MessageNotify( 'E', module_name, &
   802              & ' xy_SurfSnowB has to be present to set xy_SurfAlbedo.' )
   803          end if
   804          if ( .not. present( xy_SeaIceConc ) ) then
   805            call MessageNotify( 'E', module_name, &
   806              & ' xy_SeaIceConc has to be present to set xy_SurfAlbedo.' )
   807          end if
   808  
   809          if ( .not. present( xy_SurfType ) ) then
   810            call MessageNotify( 'E', module_name, &
   811              & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   812          end if
   813          if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   814            &  ( SurfTypeSetting /= 'file'             )       ) then
   815            call MessageNotify( 'E', module_name, &
   816              & " SurfType has to be 'same_as_SurfCond' or 'file'." )
   817          end if
   818  
   819          call ModAlbedoDueToSnowSeaIce(                        &
   820            & xy_SurfType,                                      &
   821            & xy_SurfMajCompIceB, xy_SurfSnowB, xy_SeaIceConc,  & ! (in   ) optional
   822            & xy_SurfAlbedo                                     & ! (inout)
   823            & )
   824        else
   825          call MessageNotify( 'E', module_name, &
   826            & ' xy_SurfType has to be present to modify albedo due to snow and sea ice.' )
   827        end if
   828  
   829        flag_first_SurfAlbedo = .false.
   830      end if
   831  
   832  
   833      ! NOTICE:
   834      ! The surface condition has to be set, before humidity coefficient is set.
   835      !
   836      ! ɽ̼
   837      ! Surface humidity coefficient
   838      !
   839      if ( present(xy_SurfHumidCoef) ) then
   840  
   841        if ( HumidCoefSetting == 'file' ) then
   842          ! ǡե뤫
   843          ! Data is input from files
   844          !
   845          if ( flag_first_SurfHumidCoef ) then
   846            call HistoryGet( &
   847              & HumidcoefFile, HumidcoefName, &  ! (in)
   848              & xy_SurfHumidcoef, &              ! (out)
   849              & flag_mpi_split = flag_mpi_init ) ! (in) optional
   850          end if
   851        else if ( HumidCoefSetting == 'generate_internally' ) then
   852          ! ǡ (ǥե)  surface_data ⥸塼뤫
   853          ! Data (default values) is input from "surface_data" module
   854          !
   855          if ( flag_first_SurfHumidCoef ) then
   856            call SetSurfData( &
   857              & xy_SurfHumidCoef = xy_SurfHumidCoef  & ! (out)
   858              & )
   859          end if
   860        else
   861          call MessageNotify( 'E', module_name, &
   862            & ' HumidCoefSetting = %c is not appropriate.', &
   863            & c1 = trim(HumidCoefSetting) )
   864        end if
   865  
   866        if ( &
   867          & ( present( xy_SurfType   ) ) .and. &
   868          & ( present( xy_SoilMoistB ) ) .and. &
   869          & ( present( xy_SurfSnowB  ) )       &
   870          & ) then
   871  
   872          ! Хĥǥ˴ؤɽ̼٤
   873          ! Setting of surface humidity coefficient
   874          !
   875          call BucketSetFlagOceanFromMatthews( &
   876            & xy_SurfType,                     & ! (in)
   877            & xy_BucketFlagOceanGrid           & ! (out)
   878            & )
   879          call BucketModHumidCoef(                                 &
   880            & xy_BucketFlagOceanGrid, xy_SoilMoistB, xy_SurfSnowB, & ! (in   )
   881            & xy_SurfHumidCoef                                     & ! (inout)
   882            & )
   883        else
   884          call MessageNotify( 'E', module_name, &
   885            & ' xy_SurfType, xy_SoilMoistB and Xy_SurfSnowB have to be present to modify humidity coefficient with bucket model.' )
   886        end if
   887  
   888        flag_first_SurfHumidCoef = .false.
   889      end if
   890  
   891  
   892      ! Ĺ
   893      ! Roughness length
   894      !
   895      if ( present(xy_SurfRoughLength) ) then
   896  
   897        if ( RoughLengthSetting == 'file' ) then
   898          ! ǡե뤫
   899          ! Data is input from files
   900          !
   901          if ( flag_first_SurfRoughLength ) then
   902            call HistoryGet( &
   903              & RoughLengthFile, RoughLengthName, & ! (in)
   904              & xy_SurfRoughLength, &               ! (out)
   905              & flag_mpi_split = flag_mpi_init )    ! (in) optional
   906          end if
   907        else if ( RoughLengthSetting == 'LOContrast' ) then
   908          ! Ĺ, Φ̤ȳΤκΤ߹θ
   909          ! Set roughness length, only considering land-ocean contrast
   910          !
   911          if ( .not. present( xy_SurfType ) ) then
   912            call MessageNotify( 'E', module_name, &
   913              & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   914          end if
   915          if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   916            &  ( SurfTypeSetting /= 'file'             )       ) then
   917            call MessageNotify( 'E', module_name, &
   918              & " SurfType has to be 'same_as_SurfCond' or 'file', when RoughLengthSetting = %c.", &
   919              & c1 = trim(RoughLengthSetting) )
   920          end if
   921          call SetRoughLenLO(    &
   922            & xy_SurfType,       &
   923            & xy_SurfRoughLength &
   924            & )
   925        else if ( RoughLengthSetting == 'Matthews' ) then
   926          ! Ĺ, Matthews Υǡ˴Ť
   927          ! Set roughness length based on Matthews dataset
   928          !
   929          if ( .not. present( xy_SurfType ) ) then
   930            call MessageNotify( 'E', module_name, &
   931              & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   932          end if
   933          if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   934            &  ( SurfTypeSetting /= 'file'             )       ) then
   935            call MessageNotify( 'E', module_name, &
   936              & " SurfType has to be 'same_as_SurfCond' or 'file', when RoughLengthSetting = %c.", &
   937              & c1 = trim(RoughLengthSetting) )
   938          end if
   939          call SetRoughLenLandMatthews( &
   940            & xy_SurfType,       &
   941            & xy_SurfRoughLength &
   942            & )
   943        else if ( RoughLengthSetting == 'generate_internally' ) then
   944          ! ǡ (ǥե)  surface_data ⥸塼뤫
   945          ! Data (default values) is input from "surface_data" module
   946          !
   947          if ( flag_first_SurfRoughLength ) then
   948            call SetSurfData( &
   949              & xy_SurfRoughLength = xy_SurfRoughLength &          ! (out)
   950              & )
   951          end if
   952        else
   953          call MessageNotify( 'E', module_name, &
   954            & ' RoughLengthSetting = %c is not appropriate.', &
   955            & c1 = trim(RoughLengthSetting) )
   956        end if
   957  
   958        flag_first_SurfRoughLength = .false.
   959      end if
   960  
   961  
   962      ! ɽǮ
   963      ! Surface heat capacity
   964      !
   965      if ( present(xy_SurfHeatCapacity) ) then
   966  
   967        if ( HeatCapacitySetting == 'file' ) then
   968          ! ǡե뤫
   969          ! Data is input from files
   970          !
   971          if ( flag_first_SurfHeatCapacity ) then
   972            call HistoryGet( &
   973              & HeatCapacityFile, HeatCapacityName, & ! (in)
   974              & xy_SurfHeatCapacity, &                ! (out)
   975              & flag_mpi_split = flag_mpi_init )      ! (in) optional
   976          end if
   977        else if ( HeatCapacitySetting == 'generate_internally' ) then
   978          ! ǡ (ǥե)  surface_data ⥸塼뤫
   979          ! Data (default values) is input from "surface_data" module
   980          !
   981          if ( flag_first_SurfHeatCapacity ) then
   982            call SetSurfData( &
   983              & xy_SurfHeatCapacity = xy_SurfHeatCapacity &          ! (out)
   984              & )
   985          end if
   986        else
   987          call MessageNotify( 'E', module_name, &
   988            & ' HeatCapacitySetting = %c is not appropriate.', &
   989            & c1 = trim(HeatCapacitySetting) )
   990        end if
   991  
   992        flag_first_SurfHeatCapacity = .false.
   993      end if
   994  
   995  
   996      ! Ǯեå
   997      ! Ground temperature flux
   998      !
   999      if ( present(xy_DeepSubSurfHeatFlux) ) then
  1000  
  1001        if ( TempFluxSetting == 'file' ) then
  1002          ! ǡե뤫
  1003          ! Data is input from files
  1004          !
  1005          if ( flag_first_DeepSubSurfHeatFlux ) then
  1006            call HistoryGet( &
  1007              & TempFluxFile, TempFluxName, &     ! (in)
  1008              & xy_DeepSubSurfHeatFlux, &              ! (out)
  1009              & flag_mpi_split = flag_mpi_init )  ! (in) optional
  1010          end if
  1011        else if ( TempFluxSetting == 'generate_internally' ) then
  1012          ! ǡ (ǥե)  surface_data ⥸塼뤫
  1013          ! Data (default values) is input from "surface_data" module
  1014          !
  1015          if ( flag_first_DeepSubSurfHeatFlux ) then
  1016            call SetSurfData( &
  1017              & xy_DeepSubSurfHeatFlux = xy_DeepSubSurfHeatFlux &          ! (out)
  1018              & )
  1019          end if
  1020        else
  1021          call MessageNotify( 'E', module_name, &
  1022            & ' TempFluxSetting = %c is not appropriate.', &
  1023            & c1 = trim(TempFluxSetting) )
  1024        end if
  1025  
  1026        flag_first_DeepSubSurfHeatFlux = .false.
  1027      end if
  1028  
  1029  
  1030      ! ھǮ (J K-1 kg-1)
  1031      ! Specific heat of soil (J K-1 kg-1)
  1032      !
  1033      if ( present(xy_SoilHeatCap) ) then
  1034  
  1035        if ( SoilHeatCapSetting == 'file' ) then
  1036          ! ǡե뤫
  1037          ! Data is input from files
  1038          !
  1039          if ( flag_first_SoilHeatCap ) then
  1040            call HistoryGet( &
  1041              & SoilHeatCapFile, SoilHeatCapName, &     ! (in)
  1042              & xy_SoilHeatCap, &              ! (out)
  1043              & flag_mpi_split = flag_mpi_init )  ! (in) optional
  1044          end if
  1045        else if ( SoilHeatCapSetting == 'generate_internally' ) then
  1046          ! ǡ (ǥե)  surface_data ⥸塼뤫
  1047          ! Data (default values) is input from "surface_data" module
  1048          !
  1049          if ( flag_first_SoilHeatCap ) then
  1050            call SetSurfData( &
  1051              & xy_SoilHeatCap = xy_SoilHeatCap &          ! (out)
  1052              & )
  1053          end if
  1054        else
  1055          call MessageNotify( 'E', module_name, &
  1056            & ' SoilHeatCapSetting = %c is not appropriate.', &
  1057            & c1 = trim(SoilHeatCapSetting) )
  1058        end if
  1059  
  1060        flag_first_SoilHeatCap = .false.
  1061      end if
  1062  
  1063  
  1064      ! ھǮƳΨ (W m-1 K-1)
  1065      ! Heat conduction coefficient of soil (W m-1 K-1)
  1066      !
  1067      if ( present(xy_SoilHeatDiffCoef) ) then
  1068  
  1069        if ( SoilHeatDiffCoefSetting == 'file' ) then
  1070          ! ǡե뤫
  1071          ! Data is input from files
  1072          !
  1073          if ( flag_first_SoilHeatDiffCoef ) then
  1074            call HistoryGet( &
  1075              & SoilHeatDiffCoefFile, SoilHeatDiffCoefName, &     ! (in)
  1076              & xy_SoilHeatDiffCoef, &              ! (out)
  1077              & flag_mpi_split = flag_mpi_init )  ! (in) optional
  1078          end if
  1079        else if ( SoilHeatDiffCoefSetting == 'file_thermal_inertia' ) then
  1080          ! ǡե뤫
  1081          ! Data is input from files
  1082          !
  1083          if ( flag_first_SoilHeatDiffCoef ) then
  1084            call HistoryGet( &
  1085              & SoilHeatDiffCoefFile, SoilHeatDiffCoefName, &     ! (in)
  1086              & xy_SoilHeatDiffCoef, &              ! (out)
  1087              & flag_mpi_split = flag_mpi_init )  ! (in) optional
  1088  
  1089            if ( present( xy_SoilHeatCap ) ) then
  1090              xy_SoilHeatDiffCoef = xy_SoilHeatDiffCoef**2 / xy_SoilHeatCap
     .        if (xy_soilheatdiffcoef.DSC.U2 .gt. 0) then                       
     .           J6 = and(xy_soilheatdiffcoef.DSC.U2,3)                         
     .  !CDIR    NODEP                                                          
     .           do t735 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t737 = 1, xy_soilheatdiffcoef.DSC.U1 + 2 - min0(1,       
     .       1         xy_soilheatdiffcoef.DSC.U1 + 1)                          
     .                 xy_soilheatdiffcoef(t737-1,t735) = xy_soilheatdiffcoef(  
     .       1            t737-1,t735)**2/xy_soilheatcap(t737-1,t735)           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t735 = J6 + 1, xy_soilheatdiffcoef.DSC.U2, 4                
     .  !CDIR       NODEP                                                       
     .              do t737 = 1, xy_soilheatdiffcoef.DSC.U1 + 2 - min0(1,       
     .       1         xy_soilheatdiffcoef.DSC.U1 + 1)                          
     .                 xy_soilheatdiffcoef(t737-1,t735) = xy_soilheatdiffcoef(  
     .       1            t737-1,t735)**2/xy_soilheatcap(t737-1,t735)           
     .                 xy_soilheatdiffcoef(t737-1,t735+1) = xy_soilheatdiffcoef(
     .       1            t737-1,t735+1)**2/xy_soilheatcap(t737-1,t735+1)       
     .                 xy_soilheatdiffcoef(t737-1,t735+2) = xy_soilheatdiffcoef(
     .       1            t737-1,t735+2)**2/xy_soilheatcap(t737-1,t735+2)       
     .                 xy_soilheatdiffcoef(t737-1,t735+3) = xy_soilheatdiffcoef(
     .       1            t737-1,t735+3)**2/xy_soilheatcap(t737-1,t735+3)       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10021                                                       
  1091            else
  1092              call MessageNotify( 'E', module_name, &
  1093                & ' xy_SoilHeatCap has to be present to calculate heat diffusion coefficient of soil from thermal inertia.' )
  1094            end if
  1095          end if
  1096        else if ( SoilHeatDiffCoefSetting == 'generate_internally' ) then
  1097          ! ǡ (ǥե)  surface_data ⥸塼뤫
  1098          ! Data (default values) is input from "surface_data" module
  1099          !
  1100          if ( flag_first_SoilHeatDiffCoef ) then
  1101            call SetSurfData( &
  1102              & xy_SoilHeatDiffCoef = xy_SoilHeatDiffCoef &          ! (out)
  1103              & )
  1104          end if
  1105        else
  1106          call MessageNotify( 'E', module_name, &
  1107            & ' SoilHeatDiffCoefSetting = %c is not appropriate.', &
  1108            & c1 = trim(TempFluxSetting) )
  1109        end if
  1110  
  1111        flag_first_SoilHeatDiffCoef = .false.
  1112      end if
  1113  
  1114  
  1115  
  1116      ! ׻ַ¬
  1117      ! Pause measurement of computation time
  1118      !
  1119      call TimesetClockStop( module_name )
  1120  
  1121  
  1122    end subroutine SetSurfaceProperties
  1123  
  1124    !--------------------------------------------------------------------------------------
  1125  
  1126  !!$  subroutine GroundFileOpen
  1127  !!$    !
  1128  !!$    ! ɽ̥ǡե򥪡ץ󤷤ޤ.
  1129  !!$    !
  1130  !!$    ! A ground data file is opened.
  1131  !!$    !
  1132  !!$
  1133  !!$    ! ⥸塼 ; USE statements
  1134  !!$    !
  1135  !!$
  1136  !!$    ! ϥեδܾ
  1137  !!$    ! Basic information for output files
  1138  !!$    !
  1139  !!$    use fileset, only: &
  1140  !!$      & FileTitle, &
  1141  !!$                              ! ϥǡեɽ.
  1142  !!$                              ! Title of output data files
  1143  !!$      & FileSource, &
  1144  !!$                              ! ǡեμ.
  1145  !!$                              ! Source of data file
  1146  !!$      & FileInstitution
  1147  !!$                              ! ǡեǽŪѹȿ/Ŀ.
  1148  !!$                              ! Institution or person that changes data files for the last time
  1149  !!$
  1150  !!$    ! ʪ
  1151  !!$    ! Physical constants settings
  1152  !!$    !
  1153  !!$    use constants, only: PI   ! $ \pi $ .
  1154  !!$                              ! ߼Ψ.  Circular constant
  1155  !!$
  1156  !!$    ! ɸǡ
  1157  !!$    ! Axes data settings
  1158  !!$    !
  1159  !!$    use axesset, only: &
  1160  !!$      & x_Lon, &
  1161  !!$                              ! $ \lambda $ [rad.] . . Longitude
  1162  !!$      & x_Lon_Weight, &
  1163  !!$                              ! $ \Delta \lambda $ [rad.] .
  1164  !!$                              ! ٺɸŤ.
  1165  !!$                              ! Weight of longitude
  1166  !!$      & y_Lat, &
  1167  !!$                              ! $ \varphi $ [rad.] . . Latitude
  1168  !!$      & y_Lat_Weight, &
  1169  !!$                              ! $ \Delta \varphi $ [rad.] .
  1170  !!$                              ! ٺɸŤ.
  1171  !!$                              ! Weight of latitude
  1172  !!$      & z_Sigma, &
  1173  !!$                              ! $ \sigma $ ٥ ().
  1174  !!$                              ! Full $ \sigma $ level
  1175  !!$      & r_Sigma, &
  1176  !!$                              ! $ \sigma $ ٥ (Ⱦ).
  1177  !!$                              ! Half $ \sigma $ level
  1178  !!$      & z_DelSigma
  1179  !!$                              ! $ \Delta \sigma $ ().
  1180  !!$                              ! $ \Delta \sigma $ (Full)
  1181  !!$
  1182  !!$    ! 
  1183  !!$    ! Time control
  1184  !!$    !
  1185  !!$    use timeset, only: &
  1186  !!$      & DelTime, &            ! $ \Delta t $ [s]
  1187  !!$      & StartTime, &          ! ׻ϻ.
  1188  !!$                              ! Start time of calculation
  1189  !!$      & StartDate, &          ! ׻.
  1190  !!$                              ! Start date of calculation
  1191  !!$      & StartDateValid        ! ׻ͭ.
  1192  !!$                              ! Validation of start date of calculation
  1193  !!$
  1194  !!$    ! gtool4 ǡ
  1195  !!$    ! Gtool4 data output
  1196  !!$    !
  1197  !!$    use gtool_history, only: HistoryCreate, HistoryAddVariable, &
  1198  !!$      & HistoryPut, HistoryAddAttr
  1199  !!$
  1200  !!$    ! ʸ
  1201  !!$    ! Character handling
  1202  !!$    !
  1203  !!$    use dc_string, only: StoA
  1204  !!$
  1205  !!$    ! դӻμ갷
  1206  !!$    ! Date and time handler
  1207  !!$    !
  1208  !!$    use dc_date, only: toChar, EvalByUnit
  1209  !!$
  1210  !!$    ! ʸ ; Declaration statements
  1211  !!$    !
  1212  !!$    implicit none
  1213  !!$
  1214  !!$    ! ѿ
  1215  !!$    ! Work variables
  1216  !!$    !
  1217  !!$    real(DP):: origin_time
  1218  !!$                              ! ׻ϻ.
  1219  !!$                              ! Start time of calculation
  1220  !!$
  1221  !!$    ! ¹ʸ ; Executable statement
  1222  !!$    !
  1223  !!$
  1224  !!$    ! 
  1225  !!$    ! Initialization
  1226  !!$    !
  1227  !!$    if ( .not. ground_file_io_inited ) call GroundFileInit
  1228  !!$    if ( ground_file_opened ) return
  1229  !!$
  1230  !!$    ! μ
  1231  !!$    ! Get time information
  1232  !!$    !
  1233  !!$    origin_time = EvalByUnit( StartTime, IntUnit )
  1234  !!$
  1235  !!$    ! ɽ̥ǡեΥץ
  1236  !!$    ! Open a ground data file
  1237  !!$    !
  1238  !!$    call HistoryCreate( &
  1239  !!$      &      file = OutputFile,   &
  1240  !!$      &     title = trim(FileTitle) // ' ground data', &          ! (in)
  1241  !!$      &    source = FileSource, institution = FileInstitution, &   ! (in)
  1242  !!$      &      dims = StoA( 'lon', 'lat', 'sig', 'sigm', 'time' ), & ! (in)
  1243  !!$      &  dimsizes = (/ imax, jmax, kmax, kmax + 1, 0 /), &         ! (in)
  1244  !!$      & longnames = StoA( 'longitude', 'latitude', &
  1245  !!$      &                   'sigma at layer midpoints', &
  1246  !!$      &                   'sigma at layer end-points (half level)', &
  1247  !!$      &                   'time' ), &                              ! (in)
  1248  !!$      &     units = StoA( 'degree_east', 'degree_north', &
  1249  !!$      &                   '1', '1', IntUnit ), &                   ! (in)
  1250  !!$      &    origin = real( origin_time ), &                         ! (in)
  1251  !!$      &  interval = real( IntValue ), &                            ! (in)
  1252  !!$      &   history = gthst_grd )                                    ! (out)
  1253  !!$
  1254  !!$    ! $ \Delta t $ ˴ؤɲ
  1255  !!$    ! Add information about $ \Delta t $
  1256  !!$    !
  1257  !!$    call HistoryAddVariable( &
  1258  !!$      & varname = 'deltime', &            ! (in)
  1259  !!$      & dims = StoA(''), &                ! (in)
  1260  !!$      & longname = 'delta time', &        ! (in)
  1261  !!$      & units = 's', xtype = 'float', &   ! (in)
  1262  !!$      & history = gthst_grd )             ! (inout)
  1263  !!$    call HistoryPut( &
  1264  !!$      & varname = 'deltime', &            ! (in)
  1265  !!$      & array = (/ DelTime /), &          ! (in)
  1266  !!$      & history = gthst_grd )             ! (inout)
  1267  !!$
  1268  !!$    ! ɸǡ
  1269  !!$    ! Axes data settings
  1270  !!$    !
  1271  !!$    call HistoryAddAttr( &
  1272  !!$      & varname = 'lon', attrname = 'standard_name', &   ! (in)
  1273  !!$      & value = 'longitude', &                           ! (in)
  1274  !!$      & history = gthst_grd )                            ! (inout)
  1275  !!$    call HistoryAddAttr( &
  1276  !!$      & varname = 'lat', attrname = 'standard_name', &   ! (in)
  1277  !!$      & value = 'latitude', &                            ! (in)
  1278  !!$      & history = gthst_grd )                            ! (inout)
  1279  !!$    call HistoryAddAttr( &
  1280  !!$      & varname = 'sig', attrname = 'standard_name', &   ! (in)
  1281  !!$      & value = 'atmosphere_sigma_coordinate', &         ! (in)
  1282  !!$      & history = gthst_grd )                            ! (inout)
  1283  !!$    call HistoryAddAttr( &
  1284  !!$      & varname = 'sigm', attrname = 'standard_name', &  ! (in)
  1285  !!$      & value = 'atmosphere_sigma_coordinate', &         ! (in)
  1286  !!$      & history = gthst_grd )                            ! (inout)
  1287  !!$    call HistoryAddAttr( &
  1288  !!$      & varname = 'time', attrname = 'standard_name', &  ! (in)
  1289  !!$      & value = 'time', &                                ! (in)
  1290  !!$      & history = gthst_grd )                            ! (inout)
  1291  !!$    call HistoryAddAttr( &
  1292  !!$      & varname = 'sig', attrname = 'positive', &        ! (in)
  1293  !!$      & value = 'down', &                                ! (in)
  1294  !!$      & history = gthst_grd )                            ! (inout)
  1295  !!$    call HistoryAddAttr( &
  1296  !!$      & varname = 'sigm', attrname = 'positive', &       ! (in)
  1297  !!$      & value = 'down', &                                ! (in)
  1298  !!$      & history = gthst_grd )                            ! (inout)
  1299  !!$
  1300  !!$    call HistoryPut( &
  1301  !!$      & varname = 'lon', &               ! (in)
  1302  !!$      & array = x_Lon / PI * 180.0_DP, & ! (in)
  1303  !!$      & history = gthst_grd )            ! (inout)
  1304  !!$    call HistoryPut( &
  1305  !!$      & varname = 'lat', &               ! (in)
  1306  !!$      & array = y_Lat / PI * 180.0_DP, & ! (in)
  1307  !!$      & history = gthst_grd )            ! (inout)
  1308  !!$    call HistoryPut( &
  1309  !!$      & varname = 'sig', &               ! (in)
  1310  !!$      & array = z_Sigma, &               ! (in)
  1311  !!$      & history = gthst_grd )            ! (inout)
  1312  !!$    call HistoryPut( &
  1313  !!$      & varname = 'sigm', &              ! (in)
  1314  !!$      & array = r_Sigma, &               ! (in)
  1315  !!$      & history = gthst_grd )            ! (inout)
  1316  !!$
  1317  !!$    ! ɸŤߤ
  1318  !!$    ! Axes weights settings
  1319  !!$    !
  1320  !!$    call HistoryAddVariable( &
  1321  !!$      & varname = 'lon_weight', &                           ! (in)
  1322  !!$      & dims = StoA('lon'), &                               ! (in)
  1323  !!$      & longname = 'weight for integration in longitude', & ! (in)
  1324  !!$      & units = 'radian', xtype = 'double', &               ! (in)
  1325  !!$      & history = gthst_grd )                               ! (inout)
  1326  !!$    call HistoryAddAttr( &
  1327  !!$      & varname = 'lon', attrname = 'gt_calc_weight', &     ! (in)
  1328  !!$      & value = 'lon_weight', &                             ! (in)
  1329  !!$      & history = gthst_grd )                               ! (inout)
  1330  !!$    call HistoryPut( &
  1331  !!$      & varname = 'lon_weight', array = x_Lon_Weight, &     ! (in)
  1332  !!$      & history = gthst_grd )                               ! (inout)
  1333  !!$
  1334  !!$    call HistoryAddVariable( &
  1335  !!$      & varname = 'lat_weight', &                           ! (in)
  1336  !!$      & dims = StoA('lat'), &                               ! (in)
  1337  !!$      & longname = 'weight for integration in latitude', &  ! (in)
  1338  !!$      & units = 'radian', xtype = 'double', &               ! (in)
  1339  !!$      & history = gthst_grd )                               ! (inout)
  1340  !!$    call HistoryAddAttr( &
  1341  !!$      & varname = 'lat', attrname = 'gt_calc_weight', &     ! (in)
  1342  !!$      & value = 'lat_weight', &                             ! (in)
  1343  !!$      & history = gthst_grd )                               ! (inout)
  1344  !!$    call HistoryPut( &
  1345  !!$      & varname = 'lat_weight', array = y_Lat_Weight, &     ! (in)
  1346  !!$      & history = gthst_grd )                               ! (inout)
  1347  !!$
  1348  !!$    call HistoryAddVariable( &
  1349  !!$      & varname = 'sig_weight', &                           ! (in)
  1350  !!$      & dims = StoA('sig'), &                               ! (in)
  1351  !!$      & longname = 'weight for integration in sigma', &     ! (in)
  1352  !!$      & units = '1', xtype = 'double', &                    ! (in)
  1353  !!$      & history = gthst_grd )                               ! (inout)
  1354  !!$    call HistoryAddAttr( &
  1355  !!$      & varname = 'sig', attrname = 'gt_calc_weight', &     ! (in)
  1356  !!$      & value = 'sig_weight', &                             ! (in)
  1357  !!$      & history = gthst_grd )                               ! (inout)
  1358  !!$    call HistoryPut( &
  1359  !!$      & varname = 'sig_weight', array = z_DelSigma, &       ! (in)
  1360  !!$      & history = gthst_grd )                               ! (inout)
  1361  !!$
  1362  !!$    ! ͽѿ
  1363  !!$    ! Predictional variables settings
  1364  !!$    !
  1365  !!$    call HistoryAddVariable( &
  1366  !!$      & varname = 'UB', &                                   ! (in)
  1367  !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1368  !!$      & longname = 'eastward wind (at t-\Delta t)', &       ! (in)
  1369  !!$      & units = 'm s-1', xtype = 'double', &                ! (in)
  1370  !!$      & history = gthst_grd )                               ! (inout)
  1371  !!$    call HistoryAddVariable( &
  1372  !!$      & varname = 'VB', &                                   ! (in)
  1373  !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1374  !!$      & longname = 'northward wind (at t-\Delta t)', &      ! (in)
  1375  !!$      & units = 'm s-1', xtype = 'double', &                ! (in)
  1376  !!$      & history = gthst_grd )                               ! (inout)
  1377  !!$    call HistoryAddVariable( &
  1378  !!$      & varname = 'TempB', &                                ! (in)
  1379  !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1380  !!$      & longname = 'temperature (at t-\Delta t)', &         ! (in)
  1381  !!$      & units = 'K', xtype = 'double', &                    ! (in)
  1382  !!$      & history = gthst_grd )                               ! (inout)
  1383  !!$    call HistoryAddVariable( &
  1384  !!$      & varname = 'QVapB', &                                ! (in)
  1385  !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1386  !!$      & longname = 'specific humidity (at t-\Delta t)', &   ! (in)
  1387  !!$      & units = 'kg kg-1', xtype = 'double', &              ! (in)
  1388  !!$      & history = gthst_grd )                               ! (inout)
  1389  !!$    call HistoryAddVariable( &
  1390  !!$      & varname = 'PsB', &                                  ! (in)
  1391  !!$      & dims = StoA('lon', 'lat', 'time'), &                ! (in)
  1392  !!$      & longname = 'surface pressure (at t-\Delta t)', &    ! (in)
  1393  !!$      & units = 'Pa', xtype = 'double', &                   ! (in)
  1394  !!$      & history = gthst_grd )                               ! (inout)
  1395  !!$
  1396  !!$    call HistoryAddVariable( &
  1397  !!$      & varname = 'UN', &                                   ! (in)
  1398  !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1399  !!$      & longname = 'eastward wind (at t)', &                ! (in)
  1400  !!$      & units = 'm s-1', xtype = 'double', &                ! (in)
  1401  !!$      & history = gthst_grd )                               ! (inout)
  1402  !!$    call HistoryAddVariable( &
  1403  !!$      & varname = 'VN', &                                   ! (in)
  1404  !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1405  !!$      & longname = 'northward wind (at t)', &               ! (in)
  1406  !!$      & units = 'm s-1', xtype = 'double', &                ! (in)
  1407  !!$      & history = gthst_grd )                               ! (inout)
  1408  !!$    call HistoryAddVariable( &
  1409  !!$      & varname = 'TempN', &                                ! (in)
  1410  !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1411  !!$      & longname = 'temperature (at t)', &                  ! (in)
  1412  !!$      & units = 'K', xtype = 'double', &                    ! (in)
  1413  !!$      & history = gthst_grd )                               ! (inout)
  1414  !!$    call HistoryAddVariable( &
  1415  !!$      & varname = 'QVapN', &                                ! (in)
  1416  !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1417  !!$      & longname = 'specific humidity (at t)', &            ! (in)
  1418  !!$      & units = 'kg kg-1', xtype = 'double', &              ! (in)
  1419  !!$      & history = gthst_grd )                               ! (inout)
  1420  !!$    call HistoryAddVariable( &
  1421  !!$      & varname = 'PsN', &                                  ! (in)
  1422  !!$      & dims = StoA('lon', 'lat', 'time'), &                ! (in)
  1423  !!$      & longname = 'surface pressure (at t)', &             ! (in)
  1424  !!$      & units = 'Pa', xtype = 'double', &                   ! (in)
  1425  !!$      & history = gthst_grd )                               ! (inout)
  1426  !!$
  1427  !!$    ground_file_opened = .true.
  1428  !!$  end subroutine GroundFileOpen
  1429  !!$
  1430  !!$  !-------------------------------------------------------------------
  1431  !!$
  1432  !!$  subroutine GroundFileOutput( &
  1433  !!$    & xyz_UB, xyz_VB, xyz_TempB, xyz_QVapB, xy_PsB, &   ! (in)
  1434  !!$    & xyz_UN, xyz_VN, xyz_TempN, xyz_QVapN, xy_PsN  &   ! (in)
  1435  !!$    & )
  1436  !!$    !
  1437  !!$    ! ɽ̥ǡνϤԤޤ.
  1438  !!$    !
  1439  !!$    ! Output ground data
  1440  !!$
  1441  !!$    ! ⥸塼 ; USE statements
  1442  !!$    !
  1443  !!$
  1444  !!$    ! gtool4 ǡ
  1445  !!$    ! Gtool4 data output
  1446  !!$    !
  1447  !!$    use gtool_history, only: HistoryPut
  1448  !!$
  1449  !!$    ! 
  1450  !!$    ! Time control
  1451  !!$    !
  1452  !!$    use timeset, only: TimeN  ! ƥå $ t $ λ.
  1453  !!$                              ! Time of step $ t $.
  1454  !!$
  1455  !!$    ! ʸ ; Declaration statements
  1456  !!$    !
  1457  !!$    implicit none
  1458  !!$    real(DP), intent(in):: xyz_UB  (0:imax-1, 1:jmax, 1:kmax)
  1459  !!$                              ! $ u (t-\Delta t) $ .   ®. Eastward wind
  1460  !!$    real(DP), intent(in):: xyz_VB  (0:imax-1, 1:jmax, 1:kmax)
  1461  !!$                              ! $ v (t-\Delta t) $ .   ®. Northward wind
  1462  !!$    real(DP), intent(in):: xyz_TempB  (0:imax-1, 1:jmax, 1:kmax)
  1463  !!$                              ! $ T (t-\Delta t) $ .   . Temperature
  1464  !!$    real(DP), intent(in):: xyz_QVapB  (0:imax-1, 1:jmax, 1:kmax)
  1465  !!$                              ! $ q (t-\Delta t) $ .   漾. Specific humidity
  1466  !!$    real(DP), intent(in):: xy_PsB (0:imax-1, 1:jmax)
  1467  !!$                              ! $ p_s (t-\Delta t) $ . ɽ̵. Surface pressure
  1468  !!$    real(DP), intent(in):: xyz_UN  (0:imax-1, 1:jmax, 1:kmax)
  1469  !!$                              ! $ u (t) $ .     ®. Eastward wind
  1470  !!$    real(DP), intent(in):: xyz_VN  (0:imax-1, 1:jmax, 1:kmax)
  1471  !!$                              ! $ v (t) $ .     ®. Northward wind
  1472  !!$    real(DP), intent(in):: xyz_TempN  (0:imax-1, 1:jmax, 1:kmax)
  1473  !!$                              ! $ T (t) $ .     . Temperature
  1474  !!$    real(DP), intent(in):: xyz_QVapN  (0:imax-1, 1:jmax, 1:kmax)
  1475  !!$                              ! $ q (t) $ .     漾. Specific humidity
  1476  !!$    real(DP), intent(in):: xy_PsN (0:imax-1, 1:jmax)
  1477  !!$                              ! $ p_s (t) $ .   ɽ̵. Surface pressure
  1478  !!$
  1479  !!$    ! ѿ
  1480  !!$    ! Work variables
  1481  !!$    !
  1482  !!$
  1483  !!$
  1484  !!$    ! ¹ʸ ; Executable statement
  1485  !!$    !
  1486  !!$
  1487  !!$    if ( .not. ground_file_opened ) call GroundFileOpen
  1488  !!$
  1489  !!$    ! ϥߥ󥰤Υå
  1490  !!$    ! Check output timing
  1491  !!$    !
  1492  !!$    if ( TimeN - PrevOutputTime < IntTime ) return
  1493  !!$    PrevOutputTime = TimeN
  1494  !!$
  1495  !!$    ! ǡ
  1496  !!$    ! Data output
  1497  !!$    !
  1498  !!$    call HistoryPut( &
  1499  !!$      & 'UB', xyz_UB, history = gthst_grd ) ! (in)
  1500  !!$    call HistoryPut( &
  1501  !!$      & 'VB', xyz_VB, history = gthst_grd ) ! (in)
  1502  !!$    call HistoryPut( &
  1503  !!$      & 'TempB', xyz_TempB, history = gthst_grd ) ! (in)
  1504  !!$    call HistoryPut( &
  1505  !!$      & 'QVapB', xyz_QVapB, history = gthst_grd ) ! (in)
  1506  !!$    call HistoryPut( &
  1507  !!$      & 'PsB', xy_PsB, history = gthst_grd ) ! (in)
  1508  !!$
  1509  !!$    call HistoryPut( &
  1510  !!$      & 'UN', xyz_UN, history = gthst_grd ) ! (in)
  1511  !!$    call HistoryPut( &
  1512  !!$      & 'VN', xyz_VN, history = gthst_grd ) ! (in)
  1513  !!$    call HistoryPut( &
  1514  !!$      & 'TempN', xyz_TempN, history = gthst_grd ) ! (in)
  1515  !!$    call HistoryPut( &
  1516  !!$      & 'QVapN', xyz_QVapN, history = gthst_grd ) ! (in)
  1517  !!$    call HistoryPut( &
  1518  !!$      & 'PsN', xy_PsN, history = gthst_grd ) ! (in)
  1519  !!$
  1520  !!$  end subroutine GroundFileOutput
  1521  !!$
  1522  !!$  !-------------------------------------------------------------------
  1523  !!$
  1524  !!$  subroutine GroundFileClose
  1525  !!$    !
  1526  !!$    ! ɽ̥ǡեϤνλԤޤ.
  1527  !!$    !
  1528  !!$    ! Terminate ground data files output.
  1529  !!$
  1530  !!$    ! ⥸塼 ; USE statements
  1531  !!$    !
  1532  !!$
  1533  !!$    ! gtool4 ǡ
  1534  !!$    ! Gtool4 data output
  1535  !!$    !
  1536  !!$    use gtool_history, only: HistoryClose
  1537  !!$
  1538  !!$    ! ʸ ; Declaration statements
  1539  !!$    !
  1540  !!$    implicit none
  1541  !!$
  1542  !!$    ! ѿ
  1543  !!$    ! Work variables
  1544  !!$    !
  1545  !!$
  1546  !!$    ! ¹ʸ ; Executable statement
  1547  !!$    !
  1548  !!$    if ( .not. ground_file_opened ) return
  1549  !!$
  1550  !!$    call HistoryClose( history = gthst_grd ) ! (inout)
  1551  !!$
  1552  !!$    ground_file_opened = .false.
  1553  !!$  end subroutine GroundFileClose
  1554  
  1555    !--------------------------------------------------------------------------------------
  1556  
  1557    subroutine SurfacePropertiesInit(   &
  1558      & ArgFlagSlabOcean, ArgFlagSnow   & ! (in)
  1559      & )
  1560      !
  1561      ! surface_properties ⥸塼νԤޤ.
  1562      ! NAMELIST#surface_properties_nml ɤ߹ߤϤμ³ǹԤޤ.
  1563      !
  1564      ! "surface_properties" module is initialized.
  1565      ! "NAMELIST#surface_properties_nml" is loaded in this procedure.
  1566      !
  1567  
  1568      ! ⥸塼 ; USE statements
  1569      !
  1570  
  1571      ! ̷ѥ᥿
  1572      ! Kind type parameter
  1573      !
  1574      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
  1575  
  1576      ! ե
  1577      ! File I/O support
  1578      !
  1579      use dc_iounit, only: FileOpen
  1580  
  1581      ! NAMELIST եϤ˴ؤ桼ƥƥ
  1582      ! Utilities for NAMELIST file input
  1583      !
  1584      use namelist_util, only: namelist_filename, NmlutilMsg
  1585  
  1586      ! 
  1587      ! Time control
  1588      !
  1589      use timeset, only: DelTime  ! $ \Delta t $ [s]
  1590  
  1591      ! Matthews Υǡ˴Ťɽ̥٥
  1592      ! set surface albedo based on data by Matthews
  1593      !
  1594      use albedo_Matthews, only : AlbedoMatthewsInit
  1595  
  1596      ! Хĥǥ
  1597      ! Bucket model
  1598      !
  1599      use Bucket_Model, only : BucketModelInit
  1600  
  1601      ! ȳɹˤ륢٥Ѳ
  1602      ! modification of surface albedo on the snow covered ground and on the sea ice
  1603      !
  1604      use modify_albedo_snowseaice, only : ModAlbedoSnowSeaIceInit
  1605  
  1606      ! ٥, Ĺ, Φ̤ȳΤκΤ߹θ
  1607      ! Set albedo and roughness length, only considering land-ocean contrast
  1608      !
  1609      use surface_properties_lo, only : SurfacePropertiesLOInit
  1610  
  1611      ! Matthews Υǡ˴Ť٤
  1612      ! set roughness length on land surface based on data by Matthews
  1613      !
  1614      use roughlen_Matthews, only : RoughLenMatthewsInit
  1615  
  1616      ! ʸ ; Declaration statements
  1617      !
  1618      logical, intent(in ) :: ArgFlagSlabOcean
  1619                                ! ֥ 󡿥.
  1620                                ! flag for use of slab ocean on/off
  1621      logical, intent(in ) :: ArgFlagSnow
  1622                                !
  1623                                ! flag for snow
  1624  
  1625      ! ѿ
  1626      ! Work variables
  1627      !
  1628      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
  1629                                ! Unit number for NAMELIST file open
  1630      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
  1631                                ! IOSTAT of NAMELIST read
  1632  
  1633      ! NAMELIST ѿ
  1634      ! NAMELIST group name
  1635      !
  1636      namelist /surface_properties_nml/ &
  1637        & SurfTempSetting,     &
  1638        & SurfTempFile,        &
  1639        & SurfTempName,        &
  1640        & SeaIceSetting,       &
  1641        & SeaIceFile,          &
  1642        & SeaIceName,          &
  1643        & AlbedoSetting,       &
  1644        & AlbedoFile,          &
  1645        & AlbedoName,          &
  1646        & HumidCoefSetting,    &
  1647        & HumidCoefFile,       &
  1648        & HumidCoefName,       &
  1649        & RoughLengthSetting,  &
  1650        & RoughLengthFile,     &
  1651        & RoughLengthName,     &
  1652        & HeatCapacitySetting, &
  1653        & HeatCapacityFile,    &
  1654        & HeatCapacityName,    &
  1655        & TempFluxSetting,     &
  1656        & TempFluxFile,        &
  1657        & TempFluxName,        &
  1658        & SurfCondSetting,     &
  1659        & SurfCondFile,        &
  1660        & SurfCondName,        &
  1661        & SurfTypeSetting,     &
  1662        & SurfTypeFile,        &
  1663        & SurfTypeName,        &
  1664        & SurfHeightSetting,   &
  1665        & SurfHeightFile,      &
  1666        & SurfHeightName,      &
  1667        & SoilHeatCapSetting,  &
  1668        & SoilHeatCapFile,     &
  1669        & SoilHeatCapName,     &
  1670        & SoilHeatDiffCoefSetting, &
  1671        & SoilHeatDiffCoefFile,    &
  1672        & SoilHeatDiffCoefName
  1673  
  1674            ! ǥեͤˤĤƤϽ³ "surface_properties#SurfacePropertiesInit"
  1675            ! Υɤ򻲾ȤΤ.
  1676            !
  1677            ! Refer to source codes in the initialization procedure
  1678            ! "surface_properties#SurfacePropertiesInit" for the default values.
  1679            !
  1680  
  1681  !!$      & OutputFile, &
  1682  !!$      & IntValue, IntUnit
  1683  
  1684  
  1685      ! ¹ʸ ; Executable statement
  1686      !
  1687  
  1688      if ( surface_properties_inited ) return
  1689  
  1690  
  1691      ! Set flag for slab ocean
  1692      FlagSlabOcean = ArgFlagSlabOcean
  1693  
  1694  
  1695      ! ǥեͤ
  1696      ! Default values settings
  1697      !
  1698      SurfTempSetting         = 'generate_internally'
  1699      SurfTempFile            = ''
  1700      SurfTempName            = ''
  1701      SeaIceSetting           = 'generate_internally'
  1702      SeaIceFile              = ''
  1703      SeaIceName              = ''
  1704      AlbedoSetting           = 'generate_internally'
  1705      AlbedoFile              = ''
  1706      AlbedoName              = ''
  1707      HumidCoefSetting        = 'generate_internally'
  1708      HumidCoefFile           = ''
  1709      HumidCoefName           = ''
  1710      RoughLengthSetting      = 'generate_internally'
  1711      RoughLengthFile         = ''
  1712      RoughLengthName         = ''
  1713      HeatCapacitySetting     = 'generate_internally'
  1714      HeatCapacityFile        = ''
  1715      HeatCapacityName        = ''
  1716      TempFluxSetting         = 'generate_internally'
  1717      TempFluxFile            = ''
  1718      TempFluxName            = ''
  1719      SurfCondSetting         = 'generate_internally'
  1720      SurfCondFile            = ''
  1721      SurfCondName            = ''
  1722      SurfTypeSetting         = 'same_as_SurfCond'
  1723      SurfTypeFile            = ''
  1724      SurfTypeName            = ''
  1725      SurfHeightSetting       = 'generate_internally'
  1726      SurfHeightFile          = ''
  1727      SurfHeightName          = ''
  1728      SoilHeatCapSetting      = 'generate_internally'
  1729      SoilHeatCapFile         = ''
  1730      SoilHeatCapName         = ''
  1731      SoilHeatDiffCoefSetting = 'generate_internally'
  1732      SoilHeatDiffCoefFile    = ''
  1733      SoilHeatDiffCoefName    = ''
  1734  
  1735  !!$    OutputFile = 'sst.nc'
  1736  !!$    IntValue   = 1.0_DP
  1737  !!$    IntUnit    = 'day'
  1738  
  1739      ! NAMELIST ɤ߹
  1740      ! NAMELIST is input
  1741      !
  1742      if ( trim(namelist_filename) /= '' ) then
  1743        call FileOpen( unit_nml, &          ! (out)
  1744          & namelist_filename, mode = 'r' ) ! (in)
  1745  
  1746        rewind( unit_nml )
  1747        read( unit_nml,                   &  ! (in)
  1748          & nml = surface_properties_nml, &  ! (out)
  1749          & iostat = iostat_nml           &  ! (out)
  1750          & )
  1751        close( unit_nml )
  1752  
  1753        call NmlutilMsg( iostat_nml, module_name ) ! (in)
  1754        if ( iostat_nml == 0 ) write( STDOUT, nml = surface_properties_nml )
  1755      end if
  1756  
  1757  !!$    ! ϻֳִ֤
  1758  !!$    ! Configure time interval of output
  1759  !!$    !
  1760  !!$    call DCDiffTimeCreate( PrevOutputTime, & ! (out)
  1761  !!$      & sec = 0.0_DP )                       ! (in)
  1762  !!$    call DCDiffTimeCreate( IntTime, & ! (out)
  1763  !!$      & IntValue, IntUnit )           ! (in)
  1764  
  1765  
  1766      ! A Value of "SurfTempSetting" is checked.
  1767      !
  1768      if ( ( SurfTempSetting == 'file' ) .and. ( FlagSlabOcean ) ) then
  1769        call MessageNotify( 'E', module_name, &
  1770          & "If FlagSlabOcean is .true., SurfTempSetting must not be 'file'." )
  1771      end if
  1772  
  1773  
  1774      ! Initialization of modules used in this module
  1775      !
  1776  
  1777      ! Matthews Υǡ˴Ťɽ̥٥
  1778      ! set surface albedo based on data by Matthews
  1779      !
  1780      call AlbedoMatthewsInit
  1781  
  1782      ! Хĥǥ
  1783      ! Bucket model
  1784      !
  1785      call BucketModelInit( &
  1786        & ArgFlagSnow       &
  1787        & )
  1788  
  1789      ! ȳɹˤ륢٥Ѳ
  1790      ! modification of surface albedo on the snow covered ground and on the sea ice
  1791      !
  1792      call ModAlbedoSnowSeaIceInit
  1793  
  1794      ! ٥, Ĺ, Φ̤ȳΤκΤ߹θ
  1795      ! Set albedo and roughness length, only considering land-ocean contrast
  1796      !
  1797      call SurfacePropertiesLOInit
  1798  
  1799      ! Matthews Υǡ˴Ť٤
  1800      ! set roughness length on land surface based on data by Matthews
  1801      !
  1802      call RoughLenMatthewsInit
  1803  
  1804  
  1805      !  ; Print
  1806      !
  1807      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
  1808      call MessageNotify( 'M', module_name, 'Input:: ' )
  1809      call MessageNotify( 'M', module_name, '  SurfTempSetting         = %c', c1 = trim(SurfTempSetting) )
  1810      call MessageNotify( 'M', module_name, '  SurfTempFile            = %c', c1 = trim(SurfTempFile) )
  1811      call MessageNotify( 'M', module_name, '  SurfTempName            = %c', c1 = trim(SurfTempName        ) )
  1812      call MessageNotify( 'M', module_name, '  SeaIceSetting           = %c', c1 = trim(SeaIceSetting) )
  1813      call MessageNotify( 'M', module_name, '  SeaIceFile              = %c', c1 = trim(SeaIceFile) )
  1814      call MessageNotify( 'M', module_name, '  SeaIceName              = %c', c1 = trim(SeaIceName        ) )
  1815      call MessageNotify( 'M', module_name, '  AlbedoSetting           = %c', c1 = trim(AlbedoSetting      ) )
  1816      call MessageNotify( 'M', module_name, '  AlbedoFile              = %c', c1 = trim(AlbedoFile      ) )
  1817      call MessageNotify( 'M', module_name, '  AlbedoName              = %c', c1 = trim(AlbedoName      ) )
  1818      call MessageNotify( 'M', module_name, '  HumidCoefSetting        = %c', c1 = trim(HumidCoefSetting ) )
  1819      call MessageNotify( 'M', module_name, '  HumidCoefFile           = %c', c1 = trim(HumidCoefFile  ) )
  1820      call MessageNotify( 'M', module_name, '  HumidCoefName           = %c', c1 = trim(HumidCoefName  ) )
  1821      call MessageNotify( 'M', module_name, '  RoughLengthSetting      = %c', c1 = trim(RoughLengthSetting ) )
  1822      call MessageNotify( 'M', module_name, '  RoughLengthFile         = %c', c1 = trim(RoughLengthFile ) )
  1823      call MessageNotify( 'M', module_name, '  RoughLengthName         = %c', c1 = trim(RoughLengthName ) )
  1824      call MessageNotify( 'M', module_name, '  HeatCapacitySetting     = %c', c1 = trim(HeatCapacitySetting) )
  1825      call MessageNotify( 'M', module_name, '  HeatCapacityFile        = %c', c1 = trim(HeatCapacityFile) )
  1826      call MessageNotify( 'M', module_name, '  HeatCapacityName        = %c', c1 = trim(HeatCapacityName) )
  1827      call MessageNotify( 'M', module_name, '  TempFluxSetting         = %c', c1 = trim(TempFluxSetting  ) )
  1828      call MessageNotify( 'M', module_name, '  TempFluxFile            = %c', c1 = trim(TempFluxFile  ) )
  1829      call MessageNotify( 'M', module_name, '  TempFluxName            = %c', c1 = trim(TempFluxName  ) )
  1830      call MessageNotify( 'M', module_name, '  SurfCondSetting         = %c', c1 = trim(SurfCondSetting   ) )
  1831      call MessageNotify( 'M', module_name, '  SurfCondFile            = %c', c1 = trim(SurfCondFile   ) )
  1832      call MessageNotify( 'M', module_name, '  SurfCondName            = %c', c1 = trim(SurfCondName   ) )
  1833      call MessageNotify( 'M', module_name, '  SurfTypeSetting         = %c', c1 = trim(SurfTypeSetting   ) )
  1834      call MessageNotify( 'M', module_name, '  SurfTypeFile            = %c', c1 = trim(SurfTypeFile   ) )
  1835      call MessageNotify( 'M', module_name, '  SurfTypeName            = %c', c1 = trim(SurfTypeName   ) )
  1836      call MessageNotify( 'M', module_name, '  SurfHeightSetting       = %c', c1 = trim(SurfHeightSetting   ) )
  1837      call MessageNotify( 'M', module_name, '  SurfHeightFile          = %c', c1 = trim(SurfHeightFile   ) )
  1838      call MessageNotify( 'M', module_name, '  SurfHeightName          = %c', c1 = trim(SurfHeightName   ) )
  1839      call MessageNotify( 'M', module_name, '  SoilHeatCapSetting      = %c', c1 = trim(SoilHeatCapSetting   ) )
  1840      call MessageNotify( 'M', module_name, '  SoilHeatCapFile         = %c', c1 = trim(SoilHeatCapFile   ) )
  1841      call MessageNotify( 'M', module_name, '  SoilHeatCapName         = %c', c1 = trim(SoilHeatCapName   ) )
  1842      call MessageNotify( 'M', module_name, '  SoilHeatDiffCoefSetting = %c', c1 = trim(SoilHeatDiffCoefSetting   ) )
  1843      call MessageNotify( 'M', module_name, '  SoilHeatDiffCoefFile    = %c', c1 = trim(SoilHeatDiffCoefFile   ) )
  1844      call MessageNotify( 'M', module_name, '  SoilHeatDiffCoefName    = %c', c1 = trim(SoilHeatDiffCoefName   ) )
  1845  
  1846  
  1847  !!$    call MessageNotify( 'M', module_name, 'Output:: ' )
  1848  !!$    call MessageNotify( 'M', module_name, '  OutputFile = %c', c1 = trim(OutputFile) )
  1849  !!$    call MessageNotify( 'M', module_name, '  IntTime    = %f [%c]', d = (/ IntValue /), c1 = trim(IntUnit) )
  1850      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
  1851  
  1852      surface_properties_inited = .true.
  1853  
  1854    end subroutine SurfacePropertiesInit
  1855  
  1856    !--------------------------------------------------------------------------------------
  1857  
  1858  end module surface_properties
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:50 2012
FILE NAME: surface_properties.f90
PROGRAM NAME: surface_properties
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ɽ̥ǡ
     2:            !
     3:            != Setting planetary surface properties
     4:            !
     5:            ! Authors::   Yasuhiro Morikawa, Yukiko Yamada, Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: surface_properties.f90,v 1.14 2012-09-08 15:27:16 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module surface_properties
    13:              !
    14:              != ɽ
    15:              !
    16:              != Setting planetary surface properties
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ̲٤ɽ̤̽ꤷޤ. 
    21:              !
    22:              ! Data about sea surface temperature (SST) or various values on surface
    23:              ! are set. 
    24:              !
    25:              !== Procedures List
    26:              ! SetSurfaceProperties  :: ɽ
    27:              !--
    28:            !!$  ! GroundFileOpen   :: ɽ̥ǡեΥץ
    29:            !!$  ! GroundFileOutput :: ɽ̥ǡեؤΥǡ
    30:            !!$  ! GroundFileClose  :: ɽ̥ǡեΥ
    31:              !++
    32:              ! ------------     :: ------------
    33:              ! SetSurfaceProperties  :: Setting surface properties
    34:              !--
    35:            !!$  ! GroundFileOpen   :: Open ground data file
    36:            !!$  ! GroundFileOutput :: Data output to ground data file
    37:            !!$  ! GroundFileClose  :: Close ground data file
    38:              !++
    39:              !
    40:              !== NAMELIST
    41:              !
    42:              ! NAMELIST#surface_properties_nml
    43:              !
    44:            
    45:              ! ⥸塼 ; USE statements
    46:              !
    47:            
    48:              ! ̷ѥ᥿
    49:              ! Kind type parameter
    50:              !
    51:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    52:                &                 STRING, &  ! ʸ.       Strings. 
    53:                &                 TOKEN      ! .   Keywords. 
    54:            
    55:              ! å
    56:              ! Message output
    57:              !
    58:              use dc_message, only: MessageNotify
    59:            
    60:              ! gtool5 ǡ
    61:              ! Gtool5 data output
    62:              !
    63:              use gtool_history, only: GT_HISTORY
    64:            
    65:              ! ʻ
    66:              ! Grid points settings
    67:              !
    68:              use gridset, only: imax, & ! ٳʻ. 
    69:                                         ! Number of grid points in longitude
    70:                &                jmax, & ! ٳʻ. 
    71:                                         ! Number of grid points in latitude
    72:                &                kmax    ! ľؿ. 
    73:                                         ! Number of vertical level
    74:            
    75:              ! ʸ ; Declaration statements
    76:              !
    77:              implicit none
    78:              private
    79:            
    80:              ! ³
    81:              ! Public procedure
    82:              !
    83:              public:: SetSurfaceProperties
    84:              public:: SurfacePropertiesInit
    85:            
    86:              ! ѿ
    87:              ! Public variables
    88:              !
    89:              logical, save :: surface_properties_inited = .false.
    90:                                          ! ե饰. 
    91:                                          ! Initialization flag
    92:            
    93:            !!$  logical, save, public:: ground_file_opened = .false.
    94:            !!$                              ! ɽ̥ǡեΥץ˴ؤե饰. 
    95:            !!$                              ! Flag of ground data file open
    96:            
    97:              ! ѿ
    98:              ! Private variables
    99:              !
   100:              logical          , save:: FlagSlabOcean
   101:                                          ! ֥ 󡿥.
   102:                                          ! flag for use of slab ocean on/off
   103:            
   104:              character(STRING), save:: SurfTempSetting
   105:                                          ! ɽ̲٤ˡ
   106:                                          ! Setting of surface temperature
   107:              character(STRING), save:: SurfTempFile
   108:                                          ! ɽ̲٤Υե̾. 
   109:                                          ! File name of surface temperature
   110:              character(TOKEN) , save:: SurfTempName
   111:                                          ! ɽ̲٤ѿ̾. 
   112:                                          ! Variable name of surface temperature
   113:            
   114:              character(STRING), save:: SeaIceSetting
   115:                                          ! ɹ̩٤ˡ
   116:                                          ! Setting of sea ice concentration
   117:              character(STRING), save:: SeaIceFile
   118:                                          ! ɹ̩٤Υե̾. 
   119:                                          ! File name of sea ice concentration
   120:              character(TOKEN) , save:: SeaIceName
   121:                                          ! ɹ̩٤ѿ̾. 
   122:                                          ! Variable name of sea ice concentration
   123:            
   124:              character(STRING), save:: AlbedoSetting
   125:                                          ! ɽ٥ɤˡ
   126:                                          ! Settingof surface albedo
   127:              character(STRING), save:: AlbedoFile
   128:                                          ! ɽ٥ɤΥե̾. 
   129:                                          ! File name of surface albedo
   130:              character(TOKEN) , save:: AlbedoName
   131:                                          ! ɽ٥ɤѿ̾. 
   132:                                          ! Variable name of surface albedo
   133:            
   134:              character(STRING), save:: HumidCoefSetting
   135:                                          ! ɽ٤ˡ
   136:                                          ! Setting of surface humidity coefficient
   137:              character(STRING), save:: HumidCoefFile
   138:                                          ! ɽ٤Υե̾. 
   139:                                          ! File name of surface humidity coefficient
   140:              character(TOKEN) , save:: HumidCoefName
   141:                                          ! ɽ٤ѿ̾. 
   142:                                          ! Variable name of surface humidity coefficient
   143:            
   144:              character(STRING), save:: RoughLengthSetting
   145:                                          ! ɽĹˡ
   146:                                          ! Setting of surface rough length
   147:              character(STRING), save:: RoughLengthFile
   148:                                          ! ɽĹΥե̾. 
   149:                                          ! File name of surface rough length
   150:              character(TOKEN) , save:: RoughLengthName
   151:                                          ! ɽĹѿ̾. 
   152:                                          ! Variable name of surface rough length
   153:            
   154:              character(STRING), save:: HeatCapacitySetting
   155:                                          ! ɽǮ̤ˡ
   156:                                          ! Setting of surface heat capacity
   157:              character(STRING), save:: HeatCapacityFile
   158:                                          ! ɽǮ̤Υե̾. 
   159:                                          ! File name of surface heat capacity
   160:              character(TOKEN) , save:: HeatCapacityName
   161:                                          ! ɽǮ̤ѿ̾. 
   162:                                          ! Variable name of surface heat capacity
   163:            
   164:              character(STRING), save:: TempFluxSetting
   165:                                          ! Ǯեåˡ
   166:                                          ! Setting of ground temperature flux
   167:              character(STRING), save:: TempFluxFile
   168:                                          ! ǮեåΥե̾. 
   169:                                          ! File name of ground temperature flux
   170:              character(TOKEN) , save:: TempFluxName
   171:                                          ! Ǯեåѿ̾. 
   172:                                          ! Variable name of ground temperature flux
   173:            
   174:              character(STRING), save:: SurfCondSetting
   175:                                          ! ɽ֤̾ˡ
   176:                                          ! Setting of surface condition
   177:              character(STRING), save:: SurfCondFile
   178:                                          ! ɽ֤̾Υե̾. 
   179:                                          ! File name of surface condition
   180:              character(TOKEN) , save:: SurfCondName
   181:                                          ! ɽ֤̾ѿ̾. 
   182:                                          ! Variable name of surface condition
   183:            
   184:              character(STRING), save:: SurfTypeSetting
   185:                                          ! ɽ̥ () ˡ
   186:                                          ! Setting of surface type (land use)
   187:              character(STRING), save:: SurfTypeFile
   188:                                          ! ɽ̥ () Υե̾. 
   189:                                          ! File name of surface type (land use)
   190:              character(TOKEN) , save:: SurfTypeName
   191:                                          ! ɽ̥ () ѿ̾. 
   192:                                          ! Variable name of surface type (land use)
   193:            
   194:              character(STRING), save:: SurfHeightSetting
   195:                                          ! ɽ̹٤ˡ
   196:                                          ! Setting of surface height
   197:              character(STRING), save:: SurfHeightFile
   198:                                          ! ɽ̹٤Υե̾. 
   199:                                          ! File name of surface height
   200:              character(TOKEN) , save:: SurfHeightName
   201:                                          ! ɽ̹٤ѿ̾. 
   202:                                          ! Variable name of surface height
   203:            
   204:              character(STRING), save:: SoilHeatCapSetting
   205:                                          ! ھǮ̤ˡ
   206:                                          ! Setting of heat conduction coefficient of soil
   207:              character(STRING), save:: SoilHeatCapFile
   208:                                          ! ھǮ̤Υե̾. 
   209:                                          ! File name of heat conduction coefficient of soil
   210:              character(TOKEN) , save:: SoilHeatCapName
   211:                                          ! ھǮ̤ѿ̾. 
   212:                                          ! Variable name of heat conduction coefficient of soil
   213:            
   214:              character(STRING), save:: SoilHeatDiffCoefSetting
   215:                                          ! ھǮƳΨˡ
   216:                                          ! Setting of heat conduction coefficient of soil
   217:              character(STRING), save:: SoilHeatDiffCoefFile
   218:                                          ! ھǮƳΨΥե̾. 
   219:                                          ! File name of heat conduction coefficient of soil
   220:              character(TOKEN) , save:: SoilHeatDiffCoefName
   221:                                          ! ھǮƳΨѿ̾. 
   222:                                          ! Variable name of heat conduction coefficient of soil
   223:            
   224:            
   225:            
   226:            !!$  character(STRING), save:: OutputFile
   227:            !!$                              ! Ϥɽ̥ǡΥե̾
   228:            !!$                              ! filename of output ground data
   229:            !!$  real(DP), save:: IntValue
   230:            !!$                              ! ɽ̥ǡνϴֳ. 
   231:            !!$                              ! Interval of ground data output
   232:            !!$  character(TOKEN):: IntUnit
   233:            !!$                              ! ɽ̥ǡνϴֳ֤ñ. 
   234:            !!$                              ! Unit for interval of ground data output
   235:            !!$
   236:            !!$  type(GT_HISTORY), save:: gthst_grd
   237:            !!$                              ! ɽ̥ǡ gtool_history#GT_HISTORY ѿ
   238:            !!$                              ! "gtool_history#GT_HISTORY" variable for ground data
   239:            !!$
   240:            !!$
   241:            !!$  type(DC_DIFFTIME), save:: PrevOutputTime
   242:            !!$                              ! νϻ. 
   243:            !!$                              ! Previous output time
   244:            !!$
   245:            !!$  type(DC_DIFFTIME), save:: IntTime
   246:            !!$                              ! ꥹȥǡνϻ. 
   247:            !!$                              ! Time interval of restart data output
   248:            
   249:              character(*), parameter:: module_name = 'surface_properties'
   250:                                          ! ⥸塼̾. 
   251:                                          ! Module name
   252:              character(*), parameter:: version = &
   253:                & '$Name: dcpam5-20120921 $' // &
   254:                & '$Id: surface_properties.f90,v 1.14 2012-09-08 15:27:16 yot Exp $'
   255:                                          ! ⥸塼ΥС
   256:                                          ! Module version
   257:            
   258:            
   259:            contains
   260:            
   261:              subroutine SetSurfaceProperties(                       &
   262:                & xy_SurfMajCompIceB, xy_SoilMoistB, xy_SurfSnowB,   & ! (in)    optional
   263:                & xy_SurfTemp, xy_SurfAlbedo, xy_SurfHumidCoef,      & ! (inout) optional
   264:                & xy_SurfRoughLength, xy_SurfHeatCapacity,           & ! (inout) optional
   265:                & xy_DeepSubSurfHeatFlux, xy_SurfCond, xy_SurfType,  & ! (inout) optional
   266:                & xy_SurfHeight,                                     & ! (inout) optional
   267:                & xy_SeaIceConc,                                     & ! (inout) optional
   268:                & xy_SoilHeatCap, xy_SoilHeatDiffCoef                & ! (inout) optional
   269:                & )
   270:                !
   271:                ! ɽꤷޤ. 
   272:                !
   273:                ! Set surface properties. 
   274:                !
   275:            
   276:                ! ⥸塼 ; USE statements
   277:                !
   278:            
   279:                ! ʸ
   280:                ! Character handling
   281:                !
   282:                use dc_string, only: toChar
   283:            
   284:                ! gtool4 ǡ
   285:                ! Gtool4 data input
   286:                !
   287:                use gtool_history, only: HistoryGet
   288:            
   289:                ! ǡɤ߹
   290:                ! Reading time series
   291:                !
   292:                use read_time_series, only: SetValuesFromTimeSeriesWrapper
   293:            
   294:                ! 
   295:                ! Time control
   296:                !
   297:                use timeset, only: &
   298:                  & TimeN, &              ! ƥå $ t $ λ.
   299:                                          ! Time of step $ t $.
   300:                  & EndTime, &            ! ׻λ.
   301:                                          ! End time of calculation
   302:                  & TimesetClockStart, TimesetClockStop
   303:            
   304:                ! ȳɹ
   305:                ! Setting constants of snow and sea ice
   306:                !
   307:                use constants_snowseaice, only: SeaIceThreshold
   308:            
   309:                ! ɽ̥ǡ
   310:                ! Prepare surface data
   311:                !
   312:                use surface_data, only: SetSurfData
   313:            
   314:                ! Matthews Υǡ˴Ťɽ̥٥
   315:                ! set surface albedo based on data by Matthews
   316:                !
   317:                use albedo_Matthews, only: SetAlbedoMatthews
   318:            
   319:                ! Хĥǥ
   320:                ! Bucket model
   321:                !
   322:                use Bucket_Model, only : BucketSetFlagOceanFromMatthews, BucketModHumidCoef
   323:            
   324:                ! ȳɹˤ륢٥Ѳ
   325:                ! modification of surface albedo on the snow covered ground and on the sea ice
   326:                !
   327:                use modify_albedo_snowseaice, only: ModAlbedoDueToSnowSeaIce
   328:            
   329:                ! ٥, Ĺ, Φ̤ȳΤκΤ߹θ
   330:                ! Set albedo and roughness length, only considering land-ocean contrast
   331:                !
   332:                use surface_properties_lo, only: &
   333:                  & SetAlbedoLO, SetRoughLenLO
   334:            
   335:                ! Matthews Υǡ˴Ť٤
   336:                ! set roughness length on land surface based on data by Matthews
   337:                !
   338:                use roughlen_Matthews, only: SetRoughLenLandMatthews
   339:            
   340:            
   341:                ! ʸ ; Declaration statements
   342:                !
   343:                real(DP), intent(in   ), optional:: xy_SurfMajCompIceB(0:imax-1, 1:jmax)
   344:                                          ! $ M_mcs (t-\Delta t) $ .
   345:                                          ! Surface major component ice amount (kg m-2)
   346:                real(DP), intent(in   ), optional:: xy_SoilMoistB(0:imax-1, 1:jmax)
   347:                                          ! $ M_ws (t-\Delta t) $ . ھʬ (kg m-2)
   348:                                          ! Soil moisture (kg m-2)
   349:                real(DP), intent(in   ), optional:: xy_SurfSnowB(0:imax-1, 1:jmax)
   350:                                          ! $ M_ss (t-\Delta t) $ .  (kg m-2)
   351:                                          ! Surface snow amount (kg m-2)
   352:                real(DP), intent(inout), optional:: xy_SurfTemp (0:imax-1, 1:jmax)
   353:                                          ! ɽ̲. 
   354:                                          ! Surface temperature
   355:                real(DP), intent(inout), optional:: xy_SurfAlbedo (0:imax-1, 1:jmax)
   356:                                          ! ɽ٥. 
   357:                                          ! Surface albedo
   358:                real(DP), intent(inout), optional:: xy_SurfHumidCoef (0:imax-1, 1:jmax)
   359:                                          ! ɽ. 
   360:                                          ! Surface humidity coefficient
   361:                real(DP), intent(inout), optional:: xy_SurfRoughLength (0:imax-1, 1:jmax)
   362:                                          ! ɽĹ. 
   363:                                          ! Surface rough length
   364:                real(DP), intent(inout), optional:: xy_SurfHeatCapacity (0:imax-1, 1:jmax)
   365:                                          ! ɽǮ. 
   366:                                          ! Surface heat capacity
   367:                real(DP), intent(inout), optional:: xy_DeepSubSurfHeatFlux (0:imax-1, 1:jmax)
   368:                                          ! Ǯեå. 
   369:                                          ! "Deep subsurface heat flux"
   370:                                          ! Heat flux at the bottom of surface/soil layer.
   371:                integer , intent(inout), optional:: xy_SurfCond (0:imax-1, 1:jmax)
   372:                                          ! ɽ̾ (0: , 1: ). 
   373:                                          ! Surface condition (0: fixed, 1: variable)
   374:                integer , intent(inout), optional:: xy_SurfType (0:imax-1, 1:jmax)
   375:                                          ! ɽ̥ ()
   376:                                          ! Surface type (land use)
   377:                real(DP), intent(inout), optional:: xy_SurfHeight (0:imax-1, 1:jmax)
   378:                                          ! $ z_s $ . ɽ̹. 
   379:                                          ! Surface height. 
   380:                real(DP), intent(inout), optional:: xy_SeaIceConc(0:imax-1,1:jmax)
   381:                                          ! ɹ̩ (0 <= xy_SeaIceConc <= 1)
   382:                                          ! Sea ice concentration (0 <= xy_SeaIceConc <= 1)
   383:                real(DP), intent(inout), optional:: xy_SoilHeatCap(0:imax-1,1:jmax)
   384:                                          ! ھǮ (J K-1 kg-1)
   385:                                          ! Specific heat of soil (J K-1 kg-1)
   386:                real(DP), intent(inout), optional:: xy_SoilHeatDiffCoef(0:imax-1,1:jmax)
   387:                                          ! ھǮƳΨ (W m-1 K-1)
   388:                                          ! Heat conduction coefficient of soil (W m-1 K-1)
   389:            
   390:                ! ѿ
   391:                ! Work variables
   392:                !
   393:                real(DP), allocatable, save:: xy_SurfTempSave (:,:)
   394:                                          ! ɽ̲٤¸ (K)
   395:                                          ! Saved values of surface temperature (K)
   396:                real(DP), allocatable, save:: xy_SeaIceConcSave(:,:)
   397:                                          ! ɹ̩٤¸
   398:                                          ! Saved values of sea ice concentration
   399:                real(DP), allocatable, save:: xy_SurfAlbedoSave(:,:)
   400:                                          ! ٥ɤ¸
   401:                                          ! Saved values of albedo
   402:            
   403:                logical      :: xy_BucketFlagOceanGrid(0:imax-1,1:jmax)
   404:                                          !
   405:                                          ! Flag for ocean grid point used in bucket model
   406:            
   407:                logical, save:: flag_first_SurfCond            = .true.
   408:                                          ! 򼨤ե饰. 
   409:                                          ! Flag that indicates first loop
   410:                                          !
   411:                logical, save:: flag_first_SurfType            = .true.
   412:                logical, save:: flag_first_SeaIceConc          = .true.
   413:                logical, save:: flag_first_SurfTemp            = .true.
   414:                logical, save:: flag_first_SurfHeight          = .true.
   415:                logical, save:: flag_first_SurfAlbedo          = .true.
   416:                logical, save:: flag_first_SurfHumidCoef       = .true.
   417:                logical, save:: flag_first_SurfRoughLength     = .true.
   418:                logical, save:: flag_first_SurfHeatCapacity    = .true.
   419:                logical, save:: flag_first_DeepSubSurfHeatFlux = .true.
   420:                logical, save:: flag_first_SoilHeatCap         = .true.
   421:                logical, save:: flag_first_SoilHeatDiffCoef    = .true.
   422:            
   423:                logical:: flag_mpi_init
   424:            
   425:                integer:: i               ! ˲ DO 롼Ѻѿ
   426:                                          ! Work variables for DO loop in longitude
   427:                integer:: j               ! ˲ DO 롼Ѻѿ
   428:                                          ! Work variables for DO loop in latitude
   429:            
   430:            
   431:                ! ¹ʸ ; Executable statement
   432:                !
   433:            
   434:                ! ǧ
   435:                ! Initialization check
   436:                !
   437:                if ( .not. surface_properties_inited ) then
   438:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   439:                end if
   440:            
   441:            
   442:                ! ׻ַ¬
   443:                ! Start measurement of computation time
   444:                !
   445:                call TimesetClockStart( module_name )
   446:            
   447:            
   448:                flag_mpi_init = .true.
   449:            
   450:            
   451:                ! NOTICE:
   452:                ! The surface condition has to be set, before other fields are set.
   453:                !
   454:                ! ɽ̾
   455:                ! Surface condition
   456:                !
   457:                if ( present(xy_SurfCond) ) then
   458:            
   459:                  if ( SurfCondSetting == 'file' ) then
   460:                    ! ǡե뤫
   461:                    ! Data is input from files
   462:                    !
   463:                    if ( flag_first_SurfCond ) then
   464:                      call HistoryGet( &
   465:                        & SurfCondFile, SurfCondName, &     ! (in)
   466:                        & xy_SurfCond, &                    ! (out)
   467:                        & flag_mpi_split = flag_mpi_init )  ! (in) optional
   468:                    end if
   469:                  else if ( SurfCondSetting == 'generate_internally' ) then
   470:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
   471:                    ! Data (default values) is input from "surface_data" module
   472:                    !
   473:                    if ( flag_first_SurfCond ) then
   474:                      call SetSurfData( &
   475:                        & xy_SurfCond = xy_SurfCond &                   ! (out)
   476:                        & )
   477:                    end if
   478:                  else
   479:                    call MessageNotify( 'E', module_name, &
   480:                      & ' SurfCondSetting = %c is not appropriate.', &
   481:                      & c1 = trim(SurfCondSetting) )
   482:                  end if
   483:            
   484:                  flag_first_SurfCond = .false.
   485:            
   486:                end if
   487:            
   488:            
   489:                ! ɽ̥ ()
   490:                ! Surface type (land use)
   491:                !
   492:                if ( present(xy_SurfType) ) then
   493:            
   494:                  if ( SurfTypeSetting == 'file' ) then
   495:                    ! ǡե뤫
   496:                    ! Data is input from files
   497:                    !
   498:                    if ( flag_first_SurfType ) then
   499:                      call HistoryGet( &
   500:                        & SurfTypeFile, SurfTypeName, &     ! (in)
   501:                        & xy_SurfType, &                    ! (out)
   502:                        & flag_mpi_split = flag_mpi_init )  ! (in) optional
   503:            !!$          do j = 1, jmax
   504:            !!$            do i = 0, imax-1
   505:            !!$              if ( xy_SurfType(i,j) >= 1 ) then
   506:            !!$                xy_SurfCond(i,j) = 1
   507:            !!$              else
   508:            !!$                xy_SurfCond(i,j) = 0
   509:            !!$              end if
   510:            !!$            end do
   511:            !!$          end do
   512:            !!$          call MessageNotify( 'M', module_name, ' xy_SurfCond is overwritten.' )
   513:                    end if
   514:                  else if ( SurfTypeSetting == 'same_as_SurfCond' ) then
   515:                    if ( .not. present( xy_SurfCond ) ) then
   516:                      call MessageNotify( 'E', module_name, &
   517:                        & ' The xy_SurfCond has to be present, when SurfTypeSetting = %c.', &
   518:                        & c1 = trim(SurfTypeSetting) )
   519:                    end if
   520:                    if ( flag_first_SurfType ) then
   521: +V=====              xy_SurfType = xy_SurfCond
   522:            !!$          do j = 1, jmax
   523:            !!$            do i = 0, imax-1
   524:            !!$              if ( xy_SurfType(i,j) >= 1 ) then
   525:            !!$                xy_SurfCond(i,j) = 1
   526:            !!$              else
   527:            !!$                xy_SurfCond(i,j) = 0
   528:            !!$              end if
   529:            !!$            end do
   530:            !!$          end do
   531:            !!$          call MessageNotify( 'M', module_name, ' xy_SurfCond is overwritten.' )
   532:                    end if
   533:                  else
   534:                    call MessageNotify( 'E', module_name, &
   535:                      & ' SurfTypeSetting = %c is not appropriate.', &
   536:                      & c1 = trim(SurfTypeSetting) )
   537:                  end if
   538:            
   539:                  flag_first_SurfType = .false.
   540:            
   541:                end if
   542:            
   543:            
   544:                ! NOTICE:
   545:                ! The sea ice distribution has to be set, before set surface temperature. 
   546:                !
   547:                ! ɹ̩
   548:                ! Sea ice concentration
   549:                !
   550:                if ( present(xy_SeaIceConc) ) then
   551:            
   552:                  if ( flag_first_SeaIceConc ) then
   553:                    ! ¸ѿγ
   554:                    ! Allocate a variable for save
   555:                    !
   556:                    allocate( xy_SeaIceConcSave(0:imax-1, 1:jmax) )
   557:                  end if
   558:                  if ( SeaIceSetting == 'file' ) then
   559:                    ! ǡե뤫
   560:                    ! Data is input from files
   561:                    !
   562:            
   563:                    ! This will be deleted near future (yot, 2010/10/11)
   564:            !!$        if ( flag_first_SeaIceConc ) then
   565:            !!$          call HistoryGet( &
   566:            !!$            & SeaIceFile, SeaIceName,          & ! (in)
   567:            !!$            & xy_SeaIceConcSave,               & ! (out)
   568:            !!$            & flag_mpi_split = flag_mpi_init )   ! (in) optional
   569:            !!$        end if
   570:                    call SetValuesFromTimeSeriesWrapper(    &
   571:                      & SeaIceFile, SeaIceName,             &
   572:                      & xy_SeaIceConcSave,                  &               ! (inout)
   573:                      & 'SIC'                               &
   574:                      & )
   575:                  else if ( SeaIceSetting == 'generate_internally' ) then
   576:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
   577:                    ! Data (default values) is input from "surface_data" module
   578:                    !
   579:                    if ( flag_first_SeaIceConc ) then
   580:                      call SetSurfData( &
   581:                        & xy_SeaIceConc = xy_SeaIceConcSave &                   ! (out)
   582:                        & )
   583:                    end if
   584:                  else
   585:                    call MessageNotify( 'E', module_name, &
   586:                      & ' SeaIceSetting = %c is not appropriate.', &
   587:                      & c1 = trim(SeaIceSetting) )
   588:                  end if
   589:                  ! ɹ̩٤ ( xy_SurfCond == 0 ξΤ )
   590:                  ! Setting of sea ice concentration ( where xy_SurfCond == 0 only )
   591:                  !
   592: +V=====          xy_SeaIceConc = xy_SeaIceConcSave
   593:            
   594:                  flag_first_SeaIceConc = .false.
   595:            
   596:                end if
   597:            
   598:            
   599:                ! NOTICE:
   600:                ! Before set surface temperature, sea ice distribution has to be set.
   601:                !
   602:                ! ɽ̲
   603:                ! surface temperature
   604:                !
   605:                if ( present(xy_SurfTemp) ) then
   606:            
   607:                  if ( flag_first_SurfTemp ) then
   608:                    ! ¸ѿγ
   609:                    ! Allocate a variable for save
   610:                    !
   611:                    allocate( xy_SurfTempSave  (0:imax-1, 1:jmax) )
   612:                  end if
   613:                  if ( SurfTempSetting == 'file' ) then
   614:                    ! ǡե뤫
   615:                    ! Data is input from files
   616:                    !
   617:            
   618:                    ! This will be deleted near future (yot, 2010/10/11)
   619:            !!$        if ( flag_first_SurfTemp ) then
   620:            !!$          call HistoryGet( &
   621:            !!$            & SurfTempFile, SurfTempName, &    ! (in)
   622:            !!$            & xy_SurfTempSave, &               ! (out)
   623:            !!$            & flag_mpi_split = flag_mpi_init ) ! (in) optional
   624:            !!$        end if
   625:                    call SetValuesFromTimeSeriesWrapper(    &
   626:                      & SurfTempFile, SurfTempName,         &
   627:                      & xy_SurfTempSave,                    &               ! (inout)
   628:                      & 'SST'                               &
   629:                      & )
   630:                  else if ( SurfTempSetting == 'generate_internally' ) then
   631:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
   632:                    ! Data (default values) is input from "surface_data" module
   633:                    !
   634:                    if ( flag_first_SurfTemp ) then
   635:                      call SetSurfData( &
   636:                        & xy_SurfTemp = xy_SurfTempSave & ! (out) optional
   637:                        & )
   638:                    end if
   639:                  else
   640:                    call MessageNotify( 'E', module_name, &
   641:                      & ' SurfTempSetting = %c is not appropriate.', &
   642:                      & c1 = trim(SurfTempSetting) )
   643:                  end if
   644:                  ! ɽ̲٤ SST ֤ ( xy_SurfCond <=0 ξΤ )
   645:                  ! Surface temperature is replaced with SST ( only xy_SurfCond <=0 )
   646:                  !
   647:                  if ( present(xy_SurfTemp) ) then
   648:            
   649:                    if ( .not. present( xy_SurfCond ) ) then
   650:                      call MessageNotify( 'E', module_name, &
   651:                        & ' xy_SurfCond has to be present to set xy_SurfTemp.' )
   652:                    end if
   653:                    if ( .not. present( xy_SeaIceConc ) ) then
   654:                      call MessageNotify( 'E', module_name, &
   655:                        & ' xy_SeaIceConc has to be present to set xy_SurfTemp.' )
   656:                    end if
   657:            
   658:                    if ( .not. FlagSlabOcean ) then
   659:            
   660: +------>             do j = 1, jmax
   661: |V----->               do i = 0, imax-1
   662: ||                       if ( ( xy_SurfCond(i,j)     <= 0               ) .and. &
   663: ||                         &  ( xy_SurfTempSave(i,j) >  0.0_DP          ) .and. &
   664: ||                         &  ( xy_SeaIceConc(i,j)   <  SeaIceThreshold ) ) then
   665: ||         
   666: ||                         xy_SurfTemp(i,j) = xy_SurfTempSave(i,j)
   667: ||         
   668: ||                       end if
   669: |V-----                end do
   670: +------              end do
   671:                    end if
   672:            
   673:                  end if
   674:            
   675:            
   676:                  flag_first_SurfTemp = .false.
   677:                end if
   678:            
   679:            
   680:                ! Ϸ
   681:                ! Topography
   682:                !
   683:                if ( present(xy_SurfHeight) ) then
   684:            
   685:                  if ( SurfHeightSetting == 'file' ) then
   686:                    ! ǡե뤫
   687:                    ! Data is input from files
   688:                    !
   689:                    if ( flag_first_SurfHeight ) then
   690:                      call HistoryGet( &
   691:                        & SurfHeightFile, SurfHeightName, &  ! (in)
   692:                        & xy_SurfHeight, &                   ! (out)
   693:                        & flag_mpi_split = flag_mpi_init )   ! (in) optional
   694:                    end if
   695:                  else if ( SurfHeightSetting == 'generate_internally' ) then
   696:                    if ( flag_first_SurfHeight ) then
   697: +V=====              xy_SurfHeight = 0.0_DP
   698:                    end if
   699:                  else
   700:                    call MessageNotify( 'E', module_name, &
   701:                      & ' SurfHeightSetting = %c is not appropriate.', &
   702:                      & c1 = trim(SurfHeightSetting) )
   703:                  end if
   704:            
   705:                  flag_first_SurfHeight = .false.
   706:                end if
   707:            
   708:            
   709:                ! NOTICE:
   710:                ! The surface condition and sea ice concentration have to be set, before albedo 
   711:                ! is set.
   712:                !
   713:                ! ٥
   714:                ! Albedo
   715:                !
   716:                if ( present(xy_SurfAlbedo) ) then
   717:            
   718:                  if ( flag_first_SurfAlbedo ) then
   719:                    ! ¸ѿγ
   720:                    ! Allocate a variable for save
   721:                    !
   722:                    allocate( xy_SurfAlbedoSave(0:imax-1, 1:jmax) )
   723:                  end if
   724:                  if ( AlbedoSetting == 'file' ) then
   725:                    ! ǡե뤫
   726:                    ! Data is input from files
   727:                    !
   728:                    if ( flag_first_SurfAlbedo ) then
   729:                      call HistoryGet( &
   730:                        & AlbedoFile, AlbedoName, &        ! (in)
   731:                        & xy_SurfAlbedoSave,      &        ! (out)
   732:                        & flag_mpi_split = flag_mpi_init ) ! (in) optional
   733:                    end if
   734:            
   735:                  else if ( AlbedoSetting == 'Matthews' ) then
   736:                    ! ٥ɤ Matthews ΥǡȤ
   737:                    ! Surface albedo is set based on Matthews' data
   738:                    !
   739:                    if ( .not. present( xy_SurfType ) ) then
   740:                      call MessageNotify( 'E', module_name, &
   741:                        & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   742:                    end if
   743:                    if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   744:                      &  ( SurfTypeSetting /= 'file'             )       ) then
   745:                      call MessageNotify( 'E', module_name, &
   746:                        & " SurfType has to be 'same_as_SurfCond' or 'file', when AlbedoSetting = %c.", &
   747:                        & c1 = trim(AlbedoSetting) )
   748:                    end if
   749:                    call SetAlbedoMatthews( &
   750:                      & xy_SurfType,      &
   751:                      & xy_SurfAlbedoSave &
   752:                      & )
   753:                  else if ( AlbedoSetting == 'LOContrast' ) then
   754:                    ! ٥ɤ, Φ̤ȳΤκΤ߹θ
   755:                    ! Set albedo, only considering land-ocean contrast
   756:                    !
   757:                    if ( .not. present( xy_SurfType ) ) then
   758:                      call MessageNotify( 'E', module_name, &
   759:                        & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   760:                    end if
   761:                    if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   762:                      &  ( SurfTypeSetting /= 'file'             )       ) then
   763:                      call MessageNotify( 'E', module_name, &
   764:                        & " SurfType has to be 'same_as_SurfCond' or 'file', when AlbedoSetting = %c.", &
   765:                        & c1 = trim(AlbedoSetting) )
   766:                    end if
   767:                    call SetAlbedoLO(      &
   768:                      & xy_SurfType,       &
   769:                      & xy_SurfAlbedoSave  &
   770:                      & )
   771:                  else if ( AlbedoSetting == 'generate_internally' ) then
   772:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
   773:                    ! Data (default values) is input from "surface_data" module
   774:                    ! 
   775:                    if ( flag_first_SurfAlbedo ) then
   776:                      call SetSurfData( &
   777:                        & xy_SurfAlbedo = xy_SurfAlbedoSave  & ! (out)
   778:                        & )
   779:                    end if
   780:                  else
   781:                    call MessageNotify( 'E', module_name, &
   782:                      & ' AlbedoSetting = %c is not appropriate.', &
   783:                      & c1 = trim(AlbedoSetting) )
   784:                  end if
   785:                  ! ٥ɤ
   786:                  ! Setting of albedo
   787:                  !
   788: +V=====          xy_SurfAlbedo = xy_SurfAlbedoSave
   789:            
   790:            
   791:                  if ( present( xy_SurfType ) ) then
   792:                    ! ȳɹˤ륢٥Ѳ
   793:                    ! modification of surface albedo on the snow covered ground and on the sea ice
   794:                    !
   795:            
   796:                    if ( .not. present( xy_SurfMajCompIceB ) ) then
   797:                      call MessageNotify( 'E', module_name, &
   798:                        & ' xy_SurfMajCompIceB has to be present to set xy_SurfAlbedo.' )
   799:                    end if
   800:                    if ( .not. present( xy_SurfSnowB ) ) then
   801:                      call MessageNotify( 'E', module_name, &
   802:                        & ' xy_SurfSnowB has to be present to set xy_SurfAlbedo.' )
   803:                    end if
   804:                    if ( .not. present( xy_SeaIceConc ) ) then
   805:                      call MessageNotify( 'E', module_name, &
   806:                        & ' xy_SeaIceConc has to be present to set xy_SurfAlbedo.' )
   807:                    end if
   808:            
   809:                    if ( .not. present( xy_SurfType ) ) then
   810:                      call MessageNotify( 'E', module_name, &
   811:                        & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   812:                    end if
   813:                    if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   814:                      &  ( SurfTypeSetting /= 'file'             )       ) then
   815:                      call MessageNotify( 'E', module_name, &
   816:                        & " SurfType has to be 'same_as_SurfCond' or 'file'." )
   817:                    end if
   818:            
   819:                    call ModAlbedoDueToSnowSeaIce(                        &
   820:                      & xy_SurfType,                                      &
   821:                      & xy_SurfMajCompIceB, xy_SurfSnowB, xy_SeaIceConc,  & ! (in   ) optional
   822:                      & xy_SurfAlbedo                                     & ! (inout)
   823:                      & )
   824:                  else
   825:                    call MessageNotify( 'E', module_name, &
   826:                      & ' xy_SurfType has to be present to modify albedo due to snow and sea ice.' )
   827:                  end if
   828:            
   829:                  flag_first_SurfAlbedo = .false.
   830:                end if
   831:            
   832:            
   833:                ! NOTICE:
   834:                ! The surface condition has to be set, before humidity coefficient is set.
   835:                !
   836:                ! ɽ̼
   837:                ! Surface humidity coefficient
   838:                !
   839:                if ( present(xy_SurfHumidCoef) ) then
   840:            
   841:                  if ( HumidCoefSetting == 'file' ) then
   842:                    ! ǡե뤫
   843:                    ! Data is input from files
   844:                    !
   845:                    if ( flag_first_SurfHumidCoef ) then
   846:                      call HistoryGet( &
   847:                        & HumidcoefFile, HumidcoefName, &  ! (in)
   848:                        & xy_SurfHumidcoef, &              ! (out)
   849:                        & flag_mpi_split = flag_mpi_init ) ! (in) optional
   850:                    end if
   851:                  else if ( HumidCoefSetting == 'generate_internally' ) then
   852:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
   853:                    ! Data (default values) is input from "surface_data" module
   854:                    !
   855:                    if ( flag_first_SurfHumidCoef ) then
   856:                      call SetSurfData( &
   857:                        & xy_SurfHumidCoef = xy_SurfHumidCoef  & ! (out)
   858:                        & )
   859:                    end if
   860:                  else
   861:                    call MessageNotify( 'E', module_name, &
   862:                      & ' HumidCoefSetting = %c is not appropriate.', &
   863:                      & c1 = trim(HumidCoefSetting) )
   864:                  end if
   865:            
   866:                  if ( &
   867:                    & ( present( xy_SurfType   ) ) .and. &
   868:                    & ( present( xy_SoilMoistB ) ) .and. &
   869:                    & ( present( xy_SurfSnowB  ) )       &
   870:                    & ) then
   871:            
   872:                    ! Хĥǥ˴ؤɽ̼٤
   873:                    ! Setting of surface humidity coefficient
   874:                    !
   875:                    call BucketSetFlagOceanFromMatthews( &
   876:                      & xy_SurfType,                     & ! (in)
   877:                      & xy_BucketFlagOceanGrid           & ! (out)
   878:                      & )
   879:                    call BucketModHumidCoef(                                 &
   880:                      & xy_BucketFlagOceanGrid, xy_SoilMoistB, xy_SurfSnowB, & ! (in   )
   881:                      & xy_SurfHumidCoef                                     & ! (inout)
   882:                      & )
   883:                  else
   884:                    call MessageNotify( 'E', module_name, &
   885:                      & ' xy_SurfType, xy_SoilMoistB and Xy_SurfSnowB have to be present to modify humidity coefficient with bucket model.' )
   886:                  end if
   887:            
   888:                  flag_first_SurfHumidCoef = .false.
   889:                end if
   890:            
   891:            
   892:                ! Ĺ
   893:                ! Roughness length
   894:                !
   895:                if ( present(xy_SurfRoughLength) ) then
   896:            
   897:                  if ( RoughLengthSetting == 'file' ) then
   898:                    ! ǡե뤫
   899:                    ! Data is input from files
   900:                    !
   901:                    if ( flag_first_SurfRoughLength ) then
   902:                      call HistoryGet( &
   903:                        & RoughLengthFile, RoughLengthName, & ! (in)
   904:                        & xy_SurfRoughLength, &               ! (out)
   905:                        & flag_mpi_split = flag_mpi_init )    ! (in) optional
   906:                    end if
   907:                  else if ( RoughLengthSetting == 'LOContrast' ) then
   908:                    ! Ĺ, Φ̤ȳΤκΤ߹θ
   909:                    ! Set roughness length, only considering land-ocean contrast
   910:                    !
   911:                    if ( .not. present( xy_SurfType ) ) then
   912:                      call MessageNotify( 'E', module_name, &
   913:                        & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   914:                    end if
   915:                    if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   916:                      &  ( SurfTypeSetting /= 'file'             )       ) then
   917:                      call MessageNotify( 'E', module_name, &
   918:                        & " SurfType has to be 'same_as_SurfCond' or 'file', when RoughLengthSetting = %c.", &
   919:                        & c1 = trim(RoughLengthSetting) )
   920:                    end if
   921:                    call SetRoughLenLO(    &
   922:                      & xy_SurfType,       &
   923:                      & xy_SurfRoughLength &
   924:                      & )
   925:                  else if ( RoughLengthSetting == 'Matthews' ) then
   926:                    ! Ĺ, Matthews Υǡ˴Ť
   927:                    ! Set roughness length based on Matthews dataset
   928:                    !
   929:                    if ( .not. present( xy_SurfType ) ) then
   930:                      call MessageNotify( 'E', module_name, &
   931:                        & ' xy_SurfType has to be present to set xy_SurfAlbedo.' )
   932:                    end if
   933:                    if ( ( SurfTypeSetting /= 'same_as_SurfCond' ) .and.   &
   934:                      &  ( SurfTypeSetting /= 'file'             )       ) then
   935:                      call MessageNotify( 'E', module_name, &
   936:                        & " SurfType has to be 'same_as_SurfCond' or 'file', when RoughLengthSetting = %c.", &
   937:                        & c1 = trim(RoughLengthSetting) )
   938:                    end if
   939:                    call SetRoughLenLandMatthews( &
   940:                      & xy_SurfType,       &
   941:                      & xy_SurfRoughLength &
   942:                      & )
   943:                  else if ( RoughLengthSetting == 'generate_internally' ) then
   944:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
   945:                    ! Data (default values) is input from "surface_data" module
   946:                    !
   947:                    if ( flag_first_SurfRoughLength ) then
   948:                      call SetSurfData( &
   949:                        & xy_SurfRoughLength = xy_SurfRoughLength &          ! (out)
   950:                        & )
   951:                    end if
   952:                  else
   953:                    call MessageNotify( 'E', module_name, &
   954:                      & ' RoughLengthSetting = %c is not appropriate.', &
   955:                      & c1 = trim(RoughLengthSetting) )
   956:                  end if
   957:            
   958:                  flag_first_SurfRoughLength = .false.
   959:                end if
   960:            
   961:            
   962:                ! ɽǮ
   963:                ! Surface heat capacity
   964:                !
   965:                if ( present(xy_SurfHeatCapacity) ) then
   966:            
   967:                  if ( HeatCapacitySetting == 'file' ) then
   968:                    ! ǡե뤫
   969:                    ! Data is input from files
   970:                    !
   971:                    if ( flag_first_SurfHeatCapacity ) then
   972:                      call HistoryGet( &
   973:                        & HeatCapacityFile, HeatCapacityName, & ! (in)
   974:                        & xy_SurfHeatCapacity, &                ! (out)
   975:                        & flag_mpi_split = flag_mpi_init )      ! (in) optional
   976:                    end if
   977:                  else if ( HeatCapacitySetting == 'generate_internally' ) then
   978:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
   979:                    ! Data (default values) is input from "surface_data" module
   980:                    !
   981:                    if ( flag_first_SurfHeatCapacity ) then
   982:                      call SetSurfData( &
   983:                        & xy_SurfHeatCapacity = xy_SurfHeatCapacity &          ! (out)
   984:                        & )
   985:                    end if
   986:                  else
   987:                    call MessageNotify( 'E', module_name, &
   988:                      & ' HeatCapacitySetting = %c is not appropriate.', &
   989:                      & c1 = trim(HeatCapacitySetting) )
   990:                  end if
   991:            
   992:                  flag_first_SurfHeatCapacity = .false.
   993:                end if
   994:            
   995:            
   996:                ! Ǯեå
   997:                ! Ground temperature flux
   998:                !
   999:                if ( present(xy_DeepSubSurfHeatFlux) ) then
  1000:            
  1001:                  if ( TempFluxSetting == 'file' ) then
  1002:                    ! ǡե뤫
  1003:                    ! Data is input from files
  1004:                    !
  1005:                    if ( flag_first_DeepSubSurfHeatFlux ) then
  1006:                      call HistoryGet( &
  1007:                        & TempFluxFile, TempFluxName, &     ! (in)
  1008:                        & xy_DeepSubSurfHeatFlux, &              ! (out)
  1009:                        & flag_mpi_split = flag_mpi_init )  ! (in) optional
  1010:                    end if
  1011:                  else if ( TempFluxSetting == 'generate_internally' ) then
  1012:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
  1013:                    ! Data (default values) is input from "surface_data" module
  1014:                    !
  1015:                    if ( flag_first_DeepSubSurfHeatFlux ) then
  1016:                      call SetSurfData( &
  1017:                        & xy_DeepSubSurfHeatFlux = xy_DeepSubSurfHeatFlux &          ! (out)
  1018:                        & )
  1019:                    end if
  1020:                  else
  1021:                    call MessageNotify( 'E', module_name, &
  1022:                      & ' TempFluxSetting = %c is not appropriate.', &
  1023:                      & c1 = trim(TempFluxSetting) )
  1024:                  end if
  1025:            
  1026:                  flag_first_DeepSubSurfHeatFlux = .false.
  1027:                end if
  1028:            
  1029:            
  1030:                ! ھǮ (J K-1 kg-1)
  1031:                ! Specific heat of soil (J K-1 kg-1)
  1032:                !
  1033:                if ( present(xy_SoilHeatCap) ) then
  1034:            
  1035:                  if ( SoilHeatCapSetting == 'file' ) then
  1036:                    ! ǡե뤫
  1037:                    ! Data is input from files
  1038:                    !
  1039:                    if ( flag_first_SoilHeatCap ) then
  1040:                      call HistoryGet( &
  1041:                        & SoilHeatCapFile, SoilHeatCapName, &     ! (in)
  1042:                        & xy_SoilHeatCap, &              ! (out)
  1043:                        & flag_mpi_split = flag_mpi_init )  ! (in) optional
  1044:                    end if
  1045:                  else if ( SoilHeatCapSetting == 'generate_internally' ) then
  1046:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
  1047:                    ! Data (default values) is input from "surface_data" module
  1048:                    !
  1049:                    if ( flag_first_SoilHeatCap ) then
  1050:                      call SetSurfData( &
  1051:                        & xy_SoilHeatCap = xy_SoilHeatCap &          ! (out)
  1052:                        & )
  1053:                    end if
  1054:                  else
  1055:                    call MessageNotify( 'E', module_name, &
  1056:                      & ' SoilHeatCapSetting = %c is not appropriate.', &
  1057:                      & c1 = trim(SoilHeatCapSetting) )
  1058:                  end if
  1059:            
  1060:                  flag_first_SoilHeatCap = .false.
  1061:                end if
  1062:            
  1063:            
  1064:                ! ھǮƳΨ (W m-1 K-1)
  1065:                ! Heat conduction coefficient of soil (W m-1 K-1)
  1066:                !
  1067:                if ( present(xy_SoilHeatDiffCoef) ) then
  1068:            
  1069:                  if ( SoilHeatDiffCoefSetting == 'file' ) then
  1070:                    ! ǡե뤫
  1071:                    ! Data is input from files
  1072:                    !
  1073:                    if ( flag_first_SoilHeatDiffCoef ) then
  1074:                      call HistoryGet( &
  1075:                        & SoilHeatDiffCoefFile, SoilHeatDiffCoefName, &     ! (in)
  1076:                        & xy_SoilHeatDiffCoef, &              ! (out)
  1077:                        & flag_mpi_split = flag_mpi_init )  ! (in) optional
  1078:                    end if
  1079:                  else if ( SoilHeatDiffCoefSetting == 'file_thermal_inertia' ) then
  1080:                    ! ǡե뤫
  1081:                    ! Data is input from files
  1082:                    !
  1083:                    if ( flag_first_SoilHeatDiffCoef ) then
  1084:                      call HistoryGet( &
  1085:                        & SoilHeatDiffCoefFile, SoilHeatDiffCoefName, &     ! (in)
  1086:                        & xy_SoilHeatDiffCoef, &              ! (out)
  1087:                        & flag_mpi_split = flag_mpi_init )  ! (in) optional
  1088:            
  1089:                      if ( present( xy_SoilHeatCap ) ) then
  1090: +V=====                xy_SoilHeatDiffCoef = xy_SoilHeatDiffCoef**2 / xy_SoilHeatCap
  1091:                      else
  1092:                        call MessageNotify( 'E', module_name, &
  1093:                          & ' xy_SoilHeatCap has to be present to calculate heat diffusion coefficient of soil from thermal inertia.' )
  1094:                      end if
  1095:                    end if
  1096:                  else if ( SoilHeatDiffCoefSetting == 'generate_internally' ) then
  1097:                    ! ǡ (ǥե)  surface_data ⥸塼뤫
  1098:                    ! Data (default values) is input from "surface_data" module
  1099:                    !
  1100:                    if ( flag_first_SoilHeatDiffCoef ) then
  1101:                      call SetSurfData( &
  1102:                        & xy_SoilHeatDiffCoef = xy_SoilHeatDiffCoef &          ! (out)
  1103:                        & )
  1104:                    end if
  1105:                  else
  1106:                    call MessageNotify( 'E', module_name, &
  1107:                      & ' SoilHeatDiffCoefSetting = %c is not appropriate.', &
  1108:                      & c1 = trim(TempFluxSetting) )
  1109:                  end if
  1110:            
  1111:                  flag_first_SoilHeatDiffCoef = .false.
  1112:                end if
  1113:            
  1114:            
  1115:            
  1116:                ! ׻ַ¬
  1117:                ! Pause measurement of computation time
  1118:                !
  1119:                call TimesetClockStop( module_name )
  1120:            
  1121:            
  1122:              end subroutine SetSurfaceProperties
  1123:            
  1124:              !--------------------------------------------------------------------------------------
  1125:            
  1126:            !!$  subroutine GroundFileOpen
  1127:            !!$    !
  1128:            !!$    ! ɽ̥ǡե򥪡ץ󤷤ޤ. 
  1129:            !!$    !
  1130:            !!$    ! A ground data file is opened. 
  1131:            !!$    !
  1132:            !!$
  1133:            !!$    ! ⥸塼 ; USE statements
  1134:            !!$    !
  1135:            !!$
  1136:            !!$    ! ϥեδܾ
  1137:            !!$    ! Basic information for output files
  1138:            !!$    ! 
  1139:            !!$    use fileset, only: &
  1140:            !!$      & FileTitle, &
  1141:            !!$                              ! ϥǡեɽ.
  1142:            !!$                              ! Title of output data files
  1143:            !!$      & FileSource, &
  1144:            !!$                              ! ǡեμ. 
  1145:            !!$                              ! Source of data file
  1146:            !!$      & FileInstitution
  1147:            !!$                              ! ǡեǽŪѹȿ/Ŀ. 
  1148:            !!$                              ! Institution or person that changes data files for the last time
  1149:            !!$
  1150:            !!$    ! ʪ
  1151:            !!$    ! Physical constants settings
  1152:            !!$    !
  1153:            !!$    use constants, only: PI   ! $ \pi $ .
  1154:            !!$                              ! ߼Ψ.  Circular constant
  1155:            !!$
  1156:            !!$    ! ɸǡ
  1157:            !!$    ! Axes data settings
  1158:            !!$    !
  1159:            !!$    use axesset, only: &
  1160:            !!$      & x_Lon, &
  1161:            !!$                              ! $ \lambda $ [rad.] . . Longitude
  1162:            !!$      & x_Lon_Weight, &
  1163:            !!$                              ! $ \Delta \lambda $ [rad.] . 
  1164:            !!$                              ! ٺɸŤ. 
  1165:            !!$                              ! Weight of longitude
  1166:            !!$      & y_Lat, &
  1167:            !!$                              ! $ \varphi $ [rad.] . . Latitude
  1168:            !!$      & y_Lat_Weight, &
  1169:            !!$                              ! $ \Delta \varphi $ [rad.] . 
  1170:            !!$                              ! ٺɸŤ. 
  1171:            !!$                              ! Weight of latitude
  1172:            !!$      & z_Sigma, &
  1173:            !!$                              ! $ \sigma $ ٥ (). 
  1174:            !!$                              ! Full $ \sigma $ level
  1175:            !!$      & r_Sigma, &
  1176:            !!$                              ! $ \sigma $ ٥ (Ⱦ). 
  1177:            !!$                              ! Half $ \sigma $ level
  1178:            !!$      & z_DelSigma
  1179:            !!$                              ! $ \Delta \sigma $ (). 
  1180:            !!$                              ! $ \Delta \sigma $ (Full)
  1181:            !!$
  1182:            !!$    ! 
  1183:            !!$    ! Time control
  1184:            !!$    !
  1185:            !!$    use timeset, only: &
  1186:            !!$      & DelTime, &            ! $ \Delta t $ [s]
  1187:            !!$      & StartTime, &          ! ׻ϻ. 
  1188:            !!$                              ! Start time of calculation
  1189:            !!$      & StartDate, &          ! ׻. 
  1190:            !!$                              ! Start date of calculation
  1191:            !!$      & StartDateValid        ! ׻ͭ. 
  1192:            !!$                              ! Validation of start date of calculation
  1193:            !!$
  1194:            !!$    ! gtool4 ǡ
  1195:            !!$    ! Gtool4 data output
  1196:            !!$    !
  1197:            !!$    use gtool_history, only: HistoryCreate, HistoryAddVariable, &
  1198:            !!$      & HistoryPut, HistoryAddAttr
  1199:            !!$
  1200:            !!$    ! ʸ
  1201:            !!$    ! Character handling
  1202:            !!$    !
  1203:            !!$    use dc_string, only: StoA
  1204:            !!$
  1205:            !!$    ! դӻμ갷
  1206:            !!$    ! Date and time handler
  1207:            !!$    !
  1208:            !!$    use dc_date, only: toChar, EvalByUnit
  1209:            !!$
  1210:            !!$    ! ʸ ; Declaration statements
  1211:            !!$    !
  1212:            !!$    implicit none
  1213:            !!$
  1214:            !!$    ! ѿ
  1215:            !!$    ! Work variables
  1216:            !!$    !
  1217:            !!$    real(DP):: origin_time
  1218:            !!$                              ! ׻ϻ. 
  1219:            !!$                              ! Start time of calculation
  1220:            !!$
  1221:            !!$    ! ¹ʸ ; Executable statement
  1222:            !!$    !
  1223:            !!$
  1224:            !!$    ! 
  1225:            !!$    ! Initialization
  1226:            !!$    !
  1227:            !!$    if ( .not. ground_file_io_inited ) call GroundFileInit
  1228:            !!$    if ( ground_file_opened ) return
  1229:            !!$
  1230:            !!$    ! μ
  1231:            !!$    ! Get time information
  1232:            !!$    !
  1233:            !!$    origin_time = EvalByUnit( StartTime, IntUnit )
  1234:            !!$
  1235:            !!$    ! ɽ̥ǡեΥץ
  1236:            !!$    ! Open a ground data file
  1237:            !!$    !
  1238:            !!$    call HistoryCreate( &
  1239:            !!$      &      file = OutputFile,   &
  1240:            !!$      &     title = trim(FileTitle) // ' ground data', &          ! (in)
  1241:            !!$      &    source = FileSource, institution = FileInstitution, &   ! (in)
  1242:            !!$      &      dims = StoA( 'lon', 'lat', 'sig', 'sigm', 'time' ), & ! (in)
  1243:            !!$      &  dimsizes = (/ imax, jmax, kmax, kmax + 1, 0 /), &         ! (in)
  1244:            !!$      & longnames = StoA( 'longitude', 'latitude', &
  1245:            !!$      &                   'sigma at layer midpoints', &
  1246:            !!$      &                   'sigma at layer end-points (half level)', &
  1247:            !!$      &                   'time' ), &                              ! (in)
  1248:            !!$      &     units = StoA( 'degree_east', 'degree_north', &
  1249:            !!$      &                   '1', '1', IntUnit ), &                   ! (in)
  1250:            !!$      &    origin = real( origin_time ), &                         ! (in)
  1251:            !!$      &  interval = real( IntValue ), &                            ! (in)
  1252:            !!$      &   history = gthst_grd )                                    ! (out)
  1253:            !!$
  1254:            !!$    ! $ \Delta t $ ˴ؤɲ
  1255:            !!$    ! Add information about $ \Delta t $
  1256:            !!$    !
  1257:            !!$    call HistoryAddVariable( &
  1258:            !!$      & varname = 'deltime', &            ! (in)
  1259:            !!$      & dims = StoA(''), &                ! (in)
  1260:            !!$      & longname = 'delta time', &        ! (in)
  1261:            !!$      & units = 's', xtype = 'float', &   ! (in)
  1262:            !!$      & history = gthst_grd )             ! (inout)
  1263:            !!$    call HistoryPut( &
  1264:            !!$      & varname = 'deltime', &            ! (in)
  1265:            !!$      & array = (/ DelTime /), &          ! (in)
  1266:            !!$      & history = gthst_grd )             ! (inout)
  1267:            !!$
  1268:            !!$    ! ɸǡ
  1269:            !!$    ! Axes data settings
  1270:            !!$    !
  1271:            !!$    call HistoryAddAttr( &
  1272:            !!$      & varname = 'lon', attrname = 'standard_name', &   ! (in)
  1273:            !!$      & value = 'longitude', &                           ! (in)
  1274:            !!$      & history = gthst_grd )                            ! (inout)
  1275:            !!$    call HistoryAddAttr( &
  1276:            !!$      & varname = 'lat', attrname = 'standard_name', &   ! (in)
  1277:            !!$      & value = 'latitude', &                            ! (in)
  1278:            !!$      & history = gthst_grd )                            ! (inout)
  1279:            !!$    call HistoryAddAttr( &
  1280:            !!$      & varname = 'sig', attrname = 'standard_name', &   ! (in)
  1281:            !!$      & value = 'atmosphere_sigma_coordinate', &         ! (in)
  1282:            !!$      & history = gthst_grd )                            ! (inout)
  1283:            !!$    call HistoryAddAttr( &
  1284:            !!$      & varname = 'sigm', attrname = 'standard_name', &  ! (in)
  1285:            !!$      & value = 'atmosphere_sigma_coordinate', &         ! (in)
  1286:            !!$      & history = gthst_grd )                            ! (inout)
  1287:            !!$    call HistoryAddAttr( &
  1288:            !!$      & varname = 'time', attrname = 'standard_name', &  ! (in)
  1289:            !!$      & value = 'time', &                                ! (in)
  1290:            !!$      & history = gthst_grd )                            ! (inout)
  1291:            !!$    call HistoryAddAttr( &
  1292:            !!$      & varname = 'sig', attrname = 'positive', &        ! (in)
  1293:            !!$      & value = 'down', &                                ! (in)
  1294:            !!$      & history = gthst_grd )                            ! (inout)
  1295:            !!$    call HistoryAddAttr( &
  1296:            !!$      & varname = 'sigm', attrname = 'positive', &       ! (in)
  1297:            !!$      & value = 'down', &                                ! (in)
  1298:            !!$      & history = gthst_grd )                            ! (inout)
  1299:            !!$
  1300:            !!$    call HistoryPut( &
  1301:            !!$      & varname = 'lon', &               ! (in)
  1302:            !!$      & array = x_Lon / PI * 180.0_DP, & ! (in)
  1303:            !!$      & history = gthst_grd )            ! (inout)
  1304:            !!$    call HistoryPut( &
  1305:            !!$      & varname = 'lat', &               ! (in)
  1306:            !!$      & array = y_Lat / PI * 180.0_DP, & ! (in)
  1307:            !!$      & history = gthst_grd )            ! (inout)
  1308:            !!$    call HistoryPut( &
  1309:            !!$      & varname = 'sig', &               ! (in)
  1310:            !!$      & array = z_Sigma, &               ! (in)
  1311:            !!$      & history = gthst_grd )            ! (inout)
  1312:            !!$    call HistoryPut( & 
  1313:            !!$      & varname = 'sigm', &              ! (in)
  1314:            !!$      & array = r_Sigma, &               ! (in)
  1315:            !!$      & history = gthst_grd )            ! (inout)
  1316:            !!$
  1317:            !!$    ! ɸŤߤ
  1318:            !!$    ! Axes weights settings
  1319:            !!$    !
  1320:            !!$    call HistoryAddVariable( &
  1321:            !!$      & varname = 'lon_weight', &                           ! (in)
  1322:            !!$      & dims = StoA('lon'), &                               ! (in)
  1323:            !!$      & longname = 'weight for integration in longitude', & ! (in)
  1324:            !!$      & units = 'radian', xtype = 'double', &               ! (in)
  1325:            !!$      & history = gthst_grd )                               ! (inout)
  1326:            !!$    call HistoryAddAttr( &
  1327:            !!$      & varname = 'lon', attrname = 'gt_calc_weight', &     ! (in)
  1328:            !!$      & value = 'lon_weight', &                             ! (in)
  1329:            !!$      & history = gthst_grd )                               ! (inout)
  1330:            !!$    call HistoryPut( &
  1331:            !!$      & varname = 'lon_weight', array = x_Lon_Weight, &     ! (in)
  1332:            !!$      & history = gthst_grd )                               ! (inout)
  1333:            !!$
  1334:            !!$    call HistoryAddVariable( &
  1335:            !!$      & varname = 'lat_weight', &                           ! (in)
  1336:            !!$      & dims = StoA('lat'), &                               ! (in)
  1337:            !!$      & longname = 'weight for integration in latitude', &  ! (in)
  1338:            !!$      & units = 'radian', xtype = 'double', &               ! (in)
  1339:            !!$      & history = gthst_grd )                               ! (inout)
  1340:            !!$    call HistoryAddAttr( &
  1341:            !!$      & varname = 'lat', attrname = 'gt_calc_weight', &     ! (in)
  1342:            !!$      & value = 'lat_weight', &                             ! (in)
  1343:            !!$      & history = gthst_grd )                               ! (inout)
  1344:            !!$    call HistoryPut( &
  1345:            !!$      & varname = 'lat_weight', array = y_Lat_Weight, &     ! (in)
  1346:            !!$      & history = gthst_grd )                               ! (inout)
  1347:            !!$
  1348:            !!$    call HistoryAddVariable( &
  1349:            !!$      & varname = 'sig_weight', &                           ! (in)
  1350:            !!$      & dims = StoA('sig'), &                               ! (in)
  1351:            !!$      & longname = 'weight for integration in sigma', &     ! (in)
  1352:            !!$      & units = '1', xtype = 'double', &                    ! (in)
  1353:            !!$      & history = gthst_grd )                               ! (inout)
  1354:            !!$    call HistoryAddAttr( &
  1355:            !!$      & varname = 'sig', attrname = 'gt_calc_weight', &     ! (in)
  1356:            !!$      & value = 'sig_weight', &                             ! (in)
  1357:            !!$      & history = gthst_grd )                               ! (inout)
  1358:            !!$    call HistoryPut( &
  1359:            !!$      & varname = 'sig_weight', array = z_DelSigma, &       ! (in)
  1360:            !!$      & history = gthst_grd )                               ! (inout)
  1361:            !!$
  1362:            !!$    ! ͽѿ
  1363:            !!$    ! Predictional variables settings
  1364:            !!$    !
  1365:            !!$    call HistoryAddVariable( &
  1366:            !!$      & varname = 'UB', &                                   ! (in)
  1367:            !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1368:            !!$      & longname = 'eastward wind (at t-\Delta t)', &       ! (in)
  1369:            !!$      & units = 'm s-1', xtype = 'double', &                ! (in)
  1370:            !!$      & history = gthst_grd )                               ! (inout)
  1371:            !!$    call HistoryAddVariable( &
  1372:            !!$      & varname = 'VB', &                                   ! (in)
  1373:            !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1374:            !!$      & longname = 'northward wind (at t-\Delta t)', &      ! (in)
  1375:            !!$      & units = 'm s-1', xtype = 'double', &                ! (in)
  1376:            !!$      & history = gthst_grd )                               ! (inout)
  1377:            !!$    call HistoryAddVariable( &
  1378:            !!$      & varname = 'TempB', &                                ! (in)
  1379:            !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1380:            !!$      & longname = 'temperature (at t-\Delta t)', &         ! (in)
  1381:            !!$      & units = 'K', xtype = 'double', &                    ! (in)
  1382:            !!$      & history = gthst_grd )                               ! (inout)
  1383:            !!$    call HistoryAddVariable( &
  1384:            !!$      & varname = 'QVapB', &                                ! (in)
  1385:            !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1386:            !!$      & longname = 'specific humidity (at t-\Delta t)', &   ! (in)
  1387:            !!$      & units = 'kg kg-1', xtype = 'double', &              ! (in)
  1388:            !!$      & history = gthst_grd )                               ! (inout)
  1389:            !!$    call HistoryAddVariable( &
  1390:            !!$      & varname = 'PsB', &                                  ! (in)
  1391:            !!$      & dims = StoA('lon', 'lat', 'time'), &                ! (in)
  1392:            !!$      & longname = 'surface pressure (at t-\Delta t)', &    ! (in)
  1393:            !!$      & units = 'Pa', xtype = 'double', &                   ! (in)
  1394:            !!$      & history = gthst_grd )                               ! (inout)
  1395:            !!$
  1396:            !!$    call HistoryAddVariable( &
  1397:            !!$      & varname = 'UN', &                                   ! (in)
  1398:            !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1399:            !!$      & longname = 'eastward wind (at t)', &                ! (in)
  1400:            !!$      & units = 'm s-1', xtype = 'double', &                ! (in)
  1401:            !!$      & history = gthst_grd )                               ! (inout)
  1402:            !!$    call HistoryAddVariable( &
  1403:            !!$      & varname = 'VN', &                                   ! (in)
  1404:            !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1405:            !!$      & longname = 'northward wind (at t)', &               ! (in)
  1406:            !!$      & units = 'm s-1', xtype = 'double', &                ! (in)
  1407:            !!$      & history = gthst_grd )                               ! (inout)
  1408:            !!$    call HistoryAddVariable( &
  1409:            !!$      & varname = 'TempN', &                                ! (in)
  1410:            !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1411:            !!$      & longname = 'temperature (at t)', &                  ! (in)
  1412:            !!$      & units = 'K', xtype = 'double', &                    ! (in)
  1413:            !!$      & history = gthst_grd )                               ! (inout)
  1414:            !!$    call HistoryAddVariable( &
  1415:            !!$      & varname = 'QVapN', &                                ! (in)
  1416:            !!$      & dims = StoA('lon', 'lat', 'sig', 'time'), &         ! (in)
  1417:            !!$      & longname = 'specific humidity (at t)', &            ! (in)
  1418:            !!$      & units = 'kg kg-1', xtype = 'double', &              ! (in)
  1419:            !!$      & history = gthst_grd )                               ! (inout)
  1420:            !!$    call HistoryAddVariable( &
  1421:            !!$      & varname = 'PsN', &                                  ! (in)
  1422:            !!$      & dims = StoA('lon', 'lat', 'time'), &                ! (in)
  1423:            !!$      & longname = 'surface pressure (at t)', &             ! (in)
  1424:            !!$      & units = 'Pa', xtype = 'double', &                   ! (in)
  1425:            !!$      & history = gthst_grd )                               ! (inout)
  1426:            !!$
  1427:            !!$    ground_file_opened = .true.
  1428:            !!$  end subroutine GroundFileOpen
  1429:            !!$
  1430:            !!$  !-------------------------------------------------------------------
  1431:            !!$
  1432:            !!$  subroutine GroundFileOutput( &
  1433:            !!$    & xyz_UB, xyz_VB, xyz_TempB, xyz_QVapB, xy_PsB, &   ! (in)
  1434:            !!$    & xyz_UN, xyz_VN, xyz_TempN, xyz_QVapN, xy_PsN  &   ! (in)
  1435:            !!$    & )
  1436:            !!$    !
  1437:            !!$    ! ɽ̥ǡνϤԤޤ. 
  1438:            !!$    !
  1439:            !!$    ! Output ground data
  1440:            !!$
  1441:            !!$    ! ⥸塼 ; USE statements
  1442:            !!$    !
  1443:            !!$
  1444:            !!$    ! gtool4 ǡ
  1445:            !!$    ! Gtool4 data output
  1446:            !!$    !
  1447:            !!$    use gtool_history, only: HistoryPut
  1448:            !!$
  1449:            !!$    ! 
  1450:            !!$    ! Time control
  1451:            !!$    !
  1452:            !!$    use timeset, only: TimeN  ! ƥå $ t $ λ. 
  1453:            !!$                              ! Time of step $ t $. 
  1454:            !!$
  1455:            !!$    ! ʸ ; Declaration statements
  1456:            !!$    !
  1457:            !!$    implicit none
  1458:            !!$    real(DP), intent(in):: xyz_UB  (0:imax-1, 1:jmax, 1:kmax)
  1459:            !!$                              ! $ u (t-\Delta t) $ .   ®. Eastward wind
  1460:            !!$    real(DP), intent(in):: xyz_VB  (0:imax-1, 1:jmax, 1:kmax)
  1461:            !!$                              ! $ v (t-\Delta t) $ .   ®. Northward wind
  1462:            !!$    real(DP), intent(in):: xyz_TempB  (0:imax-1, 1:jmax, 1:kmax)
  1463:            !!$                              ! $ T (t-\Delta t) $ .   . Temperature
  1464:            !!$    real(DP), intent(in):: xyz_QVapB  (0:imax-1, 1:jmax, 1:kmax)
  1465:            !!$                              ! $ q (t-\Delta t) $ .   漾. Specific humidity
  1466:            !!$    real(DP), intent(in):: xy_PsB (0:imax-1, 1:jmax)
  1467:            !!$                              ! $ p_s (t-\Delta t) $ . ɽ̵. Surface pressure
  1468:            !!$    real(DP), intent(in):: xyz_UN  (0:imax-1, 1:jmax, 1:kmax)
  1469:            !!$                              ! $ u (t) $ .     ®. Eastward wind
  1470:            !!$    real(DP), intent(in):: xyz_VN  (0:imax-1, 1:jmax, 1:kmax)
  1471:            !!$                              ! $ v (t) $ .     ®. Northward wind
  1472:            !!$    real(DP), intent(in):: xyz_TempN  (0:imax-1, 1:jmax, 1:kmax)
  1473:            !!$                              ! $ T (t) $ .     . Temperature
  1474:            !!$    real(DP), intent(in):: xyz_QVapN  (0:imax-1, 1:jmax, 1:kmax)
  1475:            !!$                              ! $ q (t) $ .     漾. Specific humidity
  1476:            !!$    real(DP), intent(in):: xy_PsN (0:imax-1, 1:jmax)
  1477:            !!$                              ! $ p_s (t) $ .   ɽ̵. Surface pressure
  1478:            !!$
  1479:            !!$    ! ѿ
  1480:            !!$    ! Work variables
  1481:            !!$    !
  1482:            !!$
  1483:            !!$
  1484:            !!$    ! ¹ʸ ; Executable statement
  1485:            !!$    !
  1486:            !!$
  1487:            !!$    if ( .not. ground_file_opened ) call GroundFileOpen
  1488:            !!$
  1489:            !!$    ! ϥߥ󥰤Υå
  1490:            !!$    ! Check output timing
  1491:            !!$    !
  1492:            !!$    if ( TimeN - PrevOutputTime < IntTime ) return
  1493:            !!$    PrevOutputTime = TimeN
  1494:            !!$
  1495:            !!$    ! ǡ
  1496:            !!$    ! Data output
  1497:            !!$    !
  1498:            !!$    call HistoryPut( &
  1499:            !!$      & 'UB', xyz_UB, history = gthst_grd ) ! (in)
  1500:            !!$    call HistoryPut( &
  1501:            !!$      & 'VB', xyz_VB, history = gthst_grd ) ! (in)
  1502:            !!$    call HistoryPut( &
  1503:            !!$      & 'TempB', xyz_TempB, history = gthst_grd ) ! (in)
  1504:            !!$    call HistoryPut( &
  1505:            !!$      & 'QVapB', xyz_QVapB, history = gthst_grd ) ! (in)
  1506:            !!$    call HistoryPut( &
  1507:            !!$      & 'PsB', xy_PsB, history = gthst_grd ) ! (in)
  1508:            !!$
  1509:            !!$    call HistoryPut( &
  1510:            !!$      & 'UN', xyz_UN, history = gthst_grd ) ! (in)
  1511:            !!$    call HistoryPut( &
  1512:            !!$      & 'VN', xyz_VN, history = gthst_grd ) ! (in)
  1513:            !!$    call HistoryPut( &
  1514:            !!$      & 'TempN', xyz_TempN, history = gthst_grd ) ! (in)
  1515:            !!$    call HistoryPut( &
  1516:            !!$      & 'QVapN', xyz_QVapN, history = gthst_grd ) ! (in)
  1517:            !!$    call HistoryPut( &
  1518:            !!$      & 'PsN', xy_PsN, history = gthst_grd ) ! (in)
  1519:            !!$
  1520:            !!$  end subroutine GroundFileOutput
  1521:            !!$
  1522:            !!$  !-------------------------------------------------------------------
  1523:            !!$
  1524:            !!$  subroutine GroundFileClose
  1525:            !!$    !
  1526:            !!$    ! ɽ̥ǡեϤνλԤޤ. 
  1527:            !!$    !
  1528:            !!$    ! Terminate ground data files output. 
  1529:            !!$
  1530:            !!$    ! ⥸塼 ; USE statements
  1531:            !!$    !
  1532:            !!$
  1533:            !!$    ! gtool4 ǡ
  1534:            !!$    ! Gtool4 data output
  1535:            !!$    !
  1536:            !!$    use gtool_history, only: HistoryClose
  1537:            !!$
  1538:            !!$    ! ʸ ; Declaration statements
  1539:            !!$    !
  1540:            !!$    implicit none
  1541:            !!$
  1542:            !!$    ! ѿ
  1543:            !!$    ! Work variables
  1544:            !!$    !
  1545:            !!$
  1546:            !!$    ! ¹ʸ ; Executable statement
  1547:            !!$    !
  1548:            !!$    if ( .not. ground_file_opened ) return
  1549:            !!$
  1550:            !!$    call HistoryClose( history = gthst_grd ) ! (inout)
  1551:            !!$
  1552:            !!$    ground_file_opened = .false.
  1553:            !!$  end subroutine GroundFileClose
  1554:            
  1555:              !--------------------------------------------------------------------------------------
  1556:            
  1557:              subroutine SurfacePropertiesInit(   &
  1558:                & ArgFlagSlabOcean, ArgFlagSnow   & ! (in)
  1559:                & )
  1560:                !
  1561:                ! surface_properties ⥸塼νԤޤ. 
  1562:                ! NAMELIST#surface_properties_nml ɤ߹ߤϤμ³ǹԤޤ. 
  1563:                !
  1564:                ! "surface_properties" module is initialized. 
  1565:                ! "NAMELIST#surface_properties_nml" is loaded in this procedure. 
  1566:                !
  1567:            
  1568:                ! ⥸塼 ; USE statements
  1569:                !
  1570:            
  1571:                ! ̷ѥ᥿
  1572:                ! Kind type parameter
  1573:                !
  1574:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
  1575:            
  1576:                ! ե
  1577:                ! File I/O support
  1578:                !
  1579:                use dc_iounit, only: FileOpen
  1580:            
  1581:                ! NAMELIST եϤ˴ؤ桼ƥƥ
  1582:                ! Utilities for NAMELIST file input
  1583:                !
  1584:                use namelist_util, only: namelist_filename, NmlutilMsg
  1585:            
  1586:                ! 
  1587:                ! Time control
  1588:                !
  1589:                use timeset, only: DelTime  ! $ \Delta t $ [s]
  1590:            
  1591:                ! Matthews Υǡ˴Ťɽ̥٥
  1592:                ! set surface albedo based on data by Matthews
  1593:                !
  1594:                use albedo_Matthews, only : AlbedoMatthewsInit
  1595:            
  1596:                ! Хĥǥ
  1597:                ! Bucket model
  1598:                !
  1599:                use Bucket_Model, only : BucketModelInit
  1600:            
  1601:                ! ȳɹˤ륢٥Ѳ
  1602:                ! modification of surface albedo on the snow covered ground and on the sea ice
  1603:                !
  1604:                use modify_albedo_snowseaice, only : ModAlbedoSnowSeaIceInit
  1605:            
  1606:                ! ٥, Ĺ, Φ̤ȳΤκΤ߹θ
  1607:                ! Set albedo and roughness length, only considering land-ocean contrast
  1608:                !
  1609:                use surface_properties_lo, only : SurfacePropertiesLOInit
  1610:            
  1611:                ! Matthews Υǡ˴Ť٤
  1612:                ! set roughness length on land surface based on data by Matthews
  1613:                !
  1614:                use roughlen_Matthews, only : RoughLenMatthewsInit
  1615:            
  1616:                ! ʸ ; Declaration statements
  1617:                !
  1618:                logical, intent(in ) :: ArgFlagSlabOcean
  1619:                                          ! ֥ 󡿥.
  1620:                                          ! flag for use of slab ocean on/off
  1621:                logical, intent(in ) :: ArgFlagSnow
  1622:                                          ! 
  1623:                                          ! flag for snow
  1624:            
  1625:                ! ѿ
  1626:                ! Work variables
  1627:                !
  1628:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
  1629:                                          ! Unit number for NAMELIST file open
  1630:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
  1631:                                          ! IOSTAT of NAMELIST read
  1632:            
  1633:                ! NAMELIST ѿ
  1634:                ! NAMELIST group name
  1635:                !
  1636:                namelist /surface_properties_nml/ &
  1637:                  & SurfTempSetting,     &
  1638:                  & SurfTempFile,        &
  1639:                  & SurfTempName,        &
  1640:                  & SeaIceSetting,       &
  1641:                  & SeaIceFile,          &
  1642:                  & SeaIceName,          &
  1643:                  & AlbedoSetting,       &
  1644:                  & AlbedoFile,          &
  1645:                  & AlbedoName,          &
  1646:                  & HumidCoefSetting,    &
  1647:                  & HumidCoefFile,       &
  1648:                  & HumidCoefName,       &
  1649:                  & RoughLengthSetting,  &
  1650:                  & RoughLengthFile,     &
  1651:                  & RoughLengthName,     &
  1652:                  & HeatCapacitySetting, &
  1653:                  & HeatCapacityFile,    &
  1654:                  & HeatCapacityName,    &
  1655:                  & TempFluxSetting,     &
  1656:                  & TempFluxFile,        &
  1657:                  & TempFluxName,        &
  1658:                  & SurfCondSetting,     &
  1659:                  & SurfCondFile,        &
  1660:                  & SurfCondName,        &
  1661:                  & SurfTypeSetting,     &
  1662:                  & SurfTypeFile,        &
  1663:                  & SurfTypeName,        &
  1664:                  & SurfHeightSetting,   &
  1665:                  & SurfHeightFile,      &
  1666:                  & SurfHeightName,      &
  1667:                  & SoilHeatCapSetting,  &
  1668:                  & SoilHeatCapFile,     &
  1669:                  & SoilHeatCapName,     &
  1670:                  & SoilHeatDiffCoefSetting, &
  1671:                  & SoilHeatDiffCoefFile,    &
  1672:                  & SoilHeatDiffCoefName
  1673:            
  1674:                      ! ǥեͤˤĤƤϽ³ "surface_properties#SurfacePropertiesInit" 
  1675:                      ! Υɤ򻲾ȤΤ. 
  1676:                      !
  1677:                      ! Refer to source codes in the initialization procedure
  1678:                      ! "surface_properties#SurfacePropertiesInit" for the default values. 
  1679:                      !
  1680:            
  1681:            !!$      & OutputFile, &
  1682:            !!$      & IntValue, IntUnit
  1683:            
  1684:            
  1685:                ! ¹ʸ ; Executable statement
  1686:                !
  1687:            
  1688:                if ( surface_properties_inited ) return
  1689:            
  1690:            
  1691:                ! Set flag for slab ocean
  1692:                FlagSlabOcean = ArgFlagSlabOcean
  1693:            
  1694:            
  1695:                ! ǥեͤ
  1696:                ! Default values settings
  1697:                !
  1698:                SurfTempSetting         = 'generate_internally'
  1699:                SurfTempFile            = ''
  1700:                SurfTempName            = ''
  1701:                SeaIceSetting           = 'generate_internally'
  1702:                SeaIceFile              = ''
  1703:                SeaIceName              = ''
  1704:                AlbedoSetting           = 'generate_internally'
  1705:                AlbedoFile              = ''
  1706:                AlbedoName              = ''
  1707:                HumidCoefSetting        = 'generate_internally'
  1708:                HumidCoefFile           = ''
  1709:                HumidCoefName           = ''
  1710:                RoughLengthSetting      = 'generate_internally'
  1711:                RoughLengthFile         = ''
  1712:                RoughLengthName         = ''
  1713:                HeatCapacitySetting     = 'generate_internally'
  1714:                HeatCapacityFile        = ''
  1715:                HeatCapacityName        = ''
  1716:                TempFluxSetting         = 'generate_internally'
  1717:                TempFluxFile            = ''
  1718:                TempFluxName            = ''
  1719:                SurfCondSetting         = 'generate_internally'
  1720:                SurfCondFile            = ''
  1721:                SurfCondName            = ''
  1722:                SurfTypeSetting         = 'same_as_SurfCond'
  1723:                SurfTypeFile            = ''
  1724:                SurfTypeName            = ''
  1725:                SurfHeightSetting       = 'generate_internally'
  1726:                SurfHeightFile          = ''
  1727:                SurfHeightName          = ''
  1728:                SoilHeatCapSetting      = 'generate_internally'
  1729:                SoilHeatCapFile         = ''
  1730:                SoilHeatCapName         = ''
  1731:                SoilHeatDiffCoefSetting = 'generate_internally'
  1732:                SoilHeatDiffCoefFile    = ''
  1733:                SoilHeatDiffCoefName    = ''
  1734:            
  1735:            !!$    OutputFile = 'sst.nc'
  1736:            !!$    IntValue   = 1.0_DP
  1737:            !!$    IntUnit    = 'day'
  1738:            
  1739:                ! NAMELIST ɤ߹
  1740:                ! NAMELIST is input
  1741:                !
  1742:                if ( trim(namelist_filename) /= '' ) then
  1743:                  call FileOpen( unit_nml, &          ! (out)
  1744:                    & namelist_filename, mode = 'r' ) ! (in)
  1745:            
  1746:                  rewind( unit_nml )
  1747:                  read( unit_nml,                   &  ! (in)
  1748:                    & nml = surface_properties_nml, &  ! (out)
  1749:                    & iostat = iostat_nml           &  ! (out)
  1750:                    & )
  1751:                  close( unit_nml )
  1752:            
  1753:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
  1754:                  if ( iostat_nml == 0 ) write( STDOUT, nml = surface_properties_nml )
  1755:                end if
  1756:            
  1757:            !!$    ! ϻֳִ֤
  1758:            !!$    ! Configure time interval of output 
  1759:            !!$    !
  1760:            !!$    call DCDiffTimeCreate( PrevOutputTime, & ! (out)
  1761:            !!$      & sec = 0.0_DP )                       ! (in)
  1762:            !!$    call DCDiffTimeCreate( IntTime, & ! (out)
  1763:            !!$      & IntValue, IntUnit )           ! (in)
  1764:            
  1765:            
  1766:                ! A Value of "SurfTempSetting" is checked.
  1767:                !
  1768:                if ( ( SurfTempSetting == 'file' ) .and. ( FlagSlabOcean ) ) then
  1769:                  call MessageNotify( 'E', module_name, &
  1770:                    & "If FlagSlabOcean is .true., SurfTempSetting must not be 'file'." )
  1771:                end if
  1772:            
  1773:            
  1774:                ! Initialization of modules used in this module
  1775:                !
  1776:            
  1777:                ! Matthews Υǡ˴Ťɽ̥٥
  1778:                ! set surface albedo based on data by Matthews
  1779:                !
  1780:                call AlbedoMatthewsInit
  1781:            
  1782:                ! Хĥǥ
  1783:                ! Bucket model
  1784:                !
  1785:                call BucketModelInit( &
  1786:                  & ArgFlagSnow       &
  1787:                  & )
  1788:            
  1789:                ! ȳɹˤ륢٥Ѳ
  1790:                ! modification of surface albedo on the snow covered ground and on the sea ice
  1791:                !
  1792:                call ModAlbedoSnowSeaIceInit
  1793:            
  1794:                ! ٥, Ĺ, Φ̤ȳΤκΤ߹θ
  1795:                ! Set albedo and roughness length, only considering land-ocean contrast
  1796:                !
  1797:                call SurfacePropertiesLOInit
  1798:            
  1799:                ! Matthews Υǡ˴Ť٤
  1800:                ! set roughness length on land surface based on data by Matthews
  1801:                !
  1802:                call RoughLenMatthewsInit
  1803:            
  1804:            
  1805:                !  ; Print
  1806:                !
  1807:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
  1808:                call MessageNotify( 'M', module_name, 'Input:: ' )
  1809:                call MessageNotify( 'M', module_name, '  SurfTempSetting         = %c', c1 = trim(SurfTempSetting) )
  1810:                call MessageNotify( 'M', module_name, '  SurfTempFile            = %c', c1 = trim(SurfTempFile) )
  1811:                call MessageNotify( 'M', module_name, '  SurfTempName            = %c', c1 = trim(SurfTempName        ) )
  1812:                call MessageNotify( 'M', module_name, '  SeaIceSetting           = %c', c1 = trim(SeaIceSetting) )
  1813:                call MessageNotify( 'M', module_name, '  SeaIceFile              = %c', c1 = trim(SeaIceFile) )
  1814:                call MessageNotify( 'M', module_name, '  SeaIceName              = %c', c1 = trim(SeaIceName        ) )
  1815:                call MessageNotify( 'M', module_name, '  AlbedoSetting           = %c', c1 = trim(AlbedoSetting      ) )
  1816:                call MessageNotify( 'M', module_name, '  AlbedoFile              = %c', c1 = trim(AlbedoFile      ) )
  1817:                call MessageNotify( 'M', module_name, '  AlbedoName              = %c', c1 = trim(AlbedoName      ) )
  1818:                call MessageNotify( 'M', module_name, '  HumidCoefSetting        = %c', c1 = trim(HumidCoefSetting ) )
  1819:                call MessageNotify( 'M', module_name, '  HumidCoefFile           = %c', c1 = trim(HumidCoefFile  ) )
  1820:                call MessageNotify( 'M', module_name, '  HumidCoefName           = %c', c1 = trim(HumidCoefName  ) )
  1821:                call MessageNotify( 'M', module_name, '  RoughLengthSetting      = %c', c1 = trim(RoughLengthSetting ) )
  1822:                call MessageNotify( 'M', module_name, '  RoughLengthFile         = %c', c1 = trim(RoughLengthFile ) )
  1823:                call MessageNotify( 'M', module_name, '  RoughLengthName         = %c', c1 = trim(RoughLengthName ) )
  1824:                call MessageNotify( 'M', module_name, '  HeatCapacitySetting     = %c', c1 = trim(HeatCapacitySetting) )
  1825:                call MessageNotify( 'M', module_name, '  HeatCapacityFile        = %c', c1 = trim(HeatCapacityFile) )
  1826:                call MessageNotify( 'M', module_name, '  HeatCapacityName        = %c', c1 = trim(HeatCapacityName) )
  1827:                call MessageNotify( 'M', module_name, '  TempFluxSetting         = %c', c1 = trim(TempFluxSetting  ) )
  1828:                call MessageNotify( 'M', module_name, '  TempFluxFile            = %c', c1 = trim(TempFluxFile  ) )
  1829:                call MessageNotify( 'M', module_name, '  TempFluxName            = %c', c1 = trim(TempFluxName  ) )
  1830:                call MessageNotify( 'M', module_name, '  SurfCondSetting         = %c', c1 = trim(SurfCondSetting   ) )
  1831:                call MessageNotify( 'M', module_name, '  SurfCondFile            = %c', c1 = trim(SurfCondFile   ) )
  1832:                call MessageNotify( 'M', module_name, '  SurfCondName            = %c', c1 = trim(SurfCondName   ) )
  1833:                call MessageNotify( 'M', module_name, '  SurfTypeSetting         = %c', c1 = trim(SurfTypeSetting   ) )
  1834:                call MessageNotify( 'M', module_name, '  SurfTypeFile            = %c', c1 = trim(SurfTypeFile   ) )
  1835:                call MessageNotify( 'M', module_name, '  SurfTypeName            = %c', c1 = trim(SurfTypeName   ) )
  1836:                call MessageNotify( 'M', module_name, '  SurfHeightSetting       = %c', c1 = trim(SurfHeightSetting   ) )
  1837:                call MessageNotify( 'M', module_name, '  SurfHeightFile          = %c', c1 = trim(SurfHeightFile   ) )
  1838:                call MessageNotify( 'M', module_name, '  SurfHeightName          = %c', c1 = trim(SurfHeightName   ) )
  1839:                call MessageNotify( 'M', module_name, '  SoilHeatCapSetting      = %c', c1 = trim(SoilHeatCapSetting   ) )
  1840:                call MessageNotify( 'M', module_name, '  SoilHeatCapFile         = %c', c1 = trim(SoilHeatCapFile   ) )
  1841:                call MessageNotify( 'M', module_name, '  SoilHeatCapName         = %c', c1 = trim(SoilHeatCapName   ) )
  1842:                call MessageNotify( 'M', module_name, '  SoilHeatDiffCoefSetting = %c', c1 = trim(SoilHeatDiffCoefSetting   ) )
  1843:                call MessageNotify( 'M', module_name, '  SoilHeatDiffCoefFile    = %c', c1 = trim(SoilHeatDiffCoefFile   ) )
  1844:                call MessageNotify( 'M', module_name, '  SoilHeatDiffCoefName    = %c', c1 = trim(SoilHeatDiffCoefName   ) )
  1845:            
  1846:            
  1847:            !!$    call MessageNotify( 'M', module_name, 'Output:: ' )
  1848:            !!$    call MessageNotify( 'M', module_name, '  OutputFile = %c', c1 = trim(OutputFile) )
  1849:            !!$    call MessageNotify( 'M', module_name, '  IntTime    = %f [%c]', d = (/ IntValue /), c1 = trim(IntUnit) )
  1850:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
  1851:            
  1852:                surface_properties_inited = .true.
  1853:            
  1854:              end subroutine SurfacePropertiesInit
  1855:            
  1856:              !--------------------------------------------------------------------------------------
  1857:            
  1858:            end module surface_properties
